<?php



function actual_expense_payment_method_select_box($name, $selected = null, $attributes = null) {
	
	if (!$attributes) $attributes = array();
	if (!isset($attributes['class'])) $attributes['class'] = '';
	$attributes['class'] .= " expense_pmet_selector";
	
	$options = array();

	if (Plugins::instance()->isActivePlugin('quickbooks')) {
		
		$p_methods = QuickbooksPaymentMethods::instance()->findAll(array("conditions" => "visible=1"));

		if (!$selected) {
			$default_selection = QuickbooksPaymentMethods::instance()->findOne(array("conditions" => "is_default=1"));
			if ($default_selection instanceof QuickbooksPaymentMethod) {
				$selected = $default_selection->getPaymentMethodId();
			}
		}

		foreach($p_methods as $p_method){
			$attr = null;
			if ($selected == $p_method->getPaymentMethodId()) $attr = array('selected' => 'selected');
			$options[] = option_tag($p_method->getName(), $p_method->getPaymentMethodId(), $attr);
		}
	} else {

		$options[] = option_tag(lang('none'), 0);
	}
	
	return select_box($name, $options, $attributes);
}




function actual_expense_payment_account_select_box($name, $selected = null, $attributes = null) {
	
	if (!$attributes) $attributes = array();
	if (!isset($attributes['class'])) $attributes['class'] = '';
	$attributes['class'] .= " expense_pacc_selector";
	
	$options = array();

	if (Plugins::instance()->isActivePlugin('quickbooks')) {
		
		$accounts = QuickbooksAccounts::instance()->findAll(array("conditions" => "visible=1 AND account_type_id IN (SELECT account_type_id FROM ".TABLE_PREFIX."quickbooks_account_types WHERE is_payment_account=1)"));
		
		if (!$selected) {
			$default_selection = QuickbooksAccounts::instance()->findOne(array("conditions" => "is_default=1"));
			if ($default_selection instanceof QuickbooksAccount) {
				$selected = $default_selection->getAccountId();
			}
		}

		foreach($accounts as $account){
			$attr = null;
			if ($selected == $account->getAccountId()) $attr = array('selected' => 'selected');
			$options[] = option_tag($account->getName(), $account->getAccountId(), $attr);
		}

	} else {

		$options[] = option_tag(lang('none'), 0);
	}
	
	return select_box($name, $options, $attributes);
}

