<?php 
	$genid = gen_id();
	$payment_receipt = $object;

	Env::useHelper('functions', 'actual_expense_payments');
?>

<div class="dataBlock"><?php 
	echo label_tag(lang('reimbursed'), $genid . 'paid', false, array('id' => $genid . 'paid_label_reimb'));
	echo label_tag(lang('paid'), $genid . 'paid', false, array('id' => $genid . 'paid_label_vendor', 'style' => 'display:none;'));

	echo yes_no_widget('payment_receipt[paid]', $genid."paid", $payment_receipt->getColumnValue('paid'), lang('paid'), lang('unpaid'));
?></div>

<div class="dataBlock" style="display:none;"><?php 
	echo label_tag(lang('payment method'), $genid . 'prFormPaymentMethod');

	echo actual_expense_payment_method_select_box('payment_receipt[payment_method]', $payment_receipt->getColumnValue('payment_method'), array('id' => $genid . 'payment_method', 'class' => 'paid-inputs'));
?>
	<span class="unpaid-message reimbursable desc" style="display:none;"><?php echo lang('pending employee reimbursement') ?></span>
	<span class="unpaid-message vendor desc" style="display:none;"><?php echo lang('pending vendor payment') ?></span>
</div>

<div class="dataBlock" style="display:none;"><?php 
	echo label_tag(lang('payment account'), $genid . 'prFormPaymentAccount');

	echo actual_expense_payment_account_select_box('payment_receipt[payment_account]', $payment_receipt->getColumnValue('payment_account'), array('id' => $genid . 'payment_account', 'class' => 'paid-inputs'));
?>
	<span class="unpaid-message desc" style="display:none;"><?php echo lang('payment pending') ?></span>
</div>

<div class="dataBlock paid-inputs"><?php 
	echo label_tag(lang('paid date'), $genid . 'payment_receipt_paid_date');

	echo pick_date_widget2('payment_receipt[paid_date]', $payment_receipt->getColumnValue('paid_date'), $genid, null, true, $genid."payment_receipt_paid_date");
?>
</div>

<script>

var this_tab_genid = '<?php echo $genid?>';

og.expenses2.show_hide_payment_fields = function(paid, exp_type) {
	
	if (paid == 1) {
		$('.paid-inputs').show();
		$('.unpaid-message').hide();
	} else {
		$('.paid-inputs').hide();
		$('.unpaid-message').show();

		if (exp_type == 'reimbursable') $('.unpaid-message.vendor').hide();
		else $('.unpaid-message.reimbursable').hide();
	}
}

$(function() {

	var main_tab_genid = $('.add-payment [name="genid"]').val();

	$("#" + main_tab_genid + 'expense_type').change(function() {
		if ($(this).val() == 'reimbursable') {
			$("#" + this_tab_genid + 'paid_label_reimb').show();
			$("#" + this_tab_genid + 'paid_label_vendor').hide();
		} else {
			$("#" + this_tab_genid + 'paid_label_reimb').hide();
			$("#" + this_tab_genid + 'paid_label_vendor').show();
		}

		$("#" + this_tab_genid + 'paidYes').change();

	}).change();

	$("#" + this_tab_genid + 'paidYes').change(function() {

		var paid = $("input[name='payment_receipt[paid]']:checked").val();
		var exp_type = $("#" + main_tab_genid + 'expense_type').val();

		og.expenses2.show_hide_payment_fields(paid, exp_type);

	}).change();

	$("#" + this_tab_genid + 'paidNo').change(function() {
		
		var paid = $("input[name='payment_receipt[paid]']:checked").val();
		var exp_type = $("#" + main_tab_genid + 'expense_type').val();

		og.expenses2.show_hide_payment_fields(paid, exp_type);

	}).change();
});

</script>