og.actual_expense_payments = {
    
    init: function() {
        
		if (!og.expenses2.payment_receipt_list_column_renderers) og.expenses2.payment_receipt_list_column_renderers = [];

		og.expenses2.payment_receipt_list_column_renderers.push(og.actual_expense_payments.payment_receipt_list_column_renderer);
    },

	payment_receipt_list_column_renderer: function(column) {

		switch (column) {
			case 'paid':
				return og.actual_expense_payments.render_paid_column;
				break;
			case 'payment_method':
				return og.actual_expense_payments.render_payment_method_column;
				break;
			case 'payment_account':
				return og.actual_expense_payments.render_payment_account_column;
				break;
		}

	},

	render_paid_column: function(value, p, r) {
		if (r.data.id == '__total_row__') return '';
		
		if (r.data.paid && r.data.paid == 1) {
			return '<span class="expense-row-status-executed">' + lang('paid') + '</span>';
		} else {
			return '<span class="expense-row-status-rejected">' + lang('unpaid') + '</span>';
		}
	},

	render_payment_method_column: function(value, p, r) {
		if (r.data.id == '__total_row__') return '';
		
		if (r.data.payment_method_name) {
			return r.data.payment_method_name;
		} else {
			return '';
		}
	},

	render_payment_account_column: function(value, p, r) {
		if (r.data.id == '__total_row__') return '';
		
		if (r.data.payment_account_name) {
			return r.data.payment_account_name;
		} else {
			return '';
		}
	}

}