<?php

  /**
  * BaseAdditionalMemberPermissionValue class
  *
  * @author Alvaro Torterola <alvaro.torterola@fengoffice.com>
  */
  abstract class BaseAdditionalMemberPermissionValue extends DataObject {
  
  	  
    // -------------------------------------------------------
    //  Access methods
    // -------------------------------------------------------
    
  	/**
  	 * Return value of 'permission_id' field
  	 *
  	 * @access public
  	 * @param void
  	 * @return string
  	 */
  	function getPermissionId() {
  		return $this->getColumnValue('permission_id');
  	} 
  	
  	/**
  	 * Set value of 'permission_id' field
  	 *
  	 * @access public
  	 * @param string $value
  	 * @return boolean
  	 */
  	function setPermissionId($value) {
  		return $this->setColumnValue('permission_id', $value);
  	} 
  
    /**
    * Return value of 'member_id' field
    *
    * @access public
    * @param void
    * @return string 
    */
    function getMemberId() {
      return $this->getColumnValue('member_id');
    } 
    
    /**
    * Set value of 'member_id' field
    *
    * @access public   
    * @param string $value
    * @return boolean
    */
    function setMemberId($value) {
      return $this->setColumnValue('member_id', $value);
    } 
    
    /**
    * Return value of 'permission_group_id' field
    *
    * @access public
    * @param void
    * @return string 
    */
    function getPermissionGroupId() {
      return $this->getColumnValue('permission_group_id');
    } 
    
    /**
    * Set value of 'permission_group_id' field
    *
    * @access public   
    * @param string $value
    * @return boolean
    */
    function setPermissionGroupId($value) {
      return $this->setColumnValue('permission_group_id', $value);
    } 
        
    /**
    * Return value of 'value' field
    *
    * @access public
    * @param void
    * @return string 
    */
    function getValue() {
      return $this->getColumnValue('value');
    }
    
    /**
    * Set value of 'value' field
    *
    * @access public   
    * @param string $value
    * @return boolean
    */
    function setValue($value) {
      return $this->setColumnValue('value', $value);
    }
    

    
    /**
    * Return manager instance
    *
    * @access protected
    * @param void
    * @return AdditionalMemberPermissionValues 
    */
    function manager() {
      if(!($this->manager instanceof AdditionalMemberPermissionValues)) $this->manager = AdditionalMemberPermissionValues::instance();
      return $this->manager;
    } // manager
  
  } // BaseAdditionalMemberPermissionValue 

?>