
if (!og.before_send_member_permissions) {
	og.before_send_member_permissions = [];
}
og.before_send_member_permissions.push(function(genid, post_vars) {
	
	var additional_perms = $('.' + genid + 'single-add-perm');
	for (var x=0; x<additional_perms.length; x++) {
		var inp = additional_perms[x];
		
		post_vars[$(inp).attr('name')] = ($(inp).attr('checked') == 'checked' ? 1 : 0);
	}
	
});

og.update_additional_member_permission_value = function(genid, member_id, perm_name, val) {
	
	if (!og.additional_member_permissions) og.additional_member_permissions = {};
	if (!og.additional_member_permissions[genid]) og.additional_member_permissions[genid] = {};
	if (!og.additional_member_permissions[genid][member_id]) og.additional_member_permissions[genid][member_id] = {}
	
	og.additional_member_permissions[genid][member_id][perm_name] = val;
}


og.eventManager.addListener('on load member permissions for user', function(data){
	var hfpg = document.getElementById(data.genid + 'hfPgId');
	var pg_id = hfpg ? hfpg.value : 0;
	
	og.openLink(og.getUrl('additional_member_permissions', 'render_addiotional_permission_inputs', {genid: data.genid, member_id:data.member_id}),{
		preventPanelLoad: true,
		callback: function(success, d) {
			$("#"+d.genid+"-"+d.dim_id+"-additional-member-permissions").html(d.html);
			og.additional_member_permissions_on_perm_popup_show(d.genid, pg_id, data.member_id);
		}
	});
	
});

// prepare additional permissions to submit, set them in a hidden input
og.eventManager.addListener('on send user permissions', function(data){
	if (og.additional_member_permissions && og.additional_member_permissions[data.genid]) {
		$("#" + data.genid + "hfAdditionalPermsSend").val(Ext.util.JSON.encode(og.additional_member_permissions[data.genid]));
	}
});

// request the current values and show the inputs, if already requested use the cached values
og.additional_member_permissions_on_perm_popup_show = function(genid, pg_id, member_id) {
	
	$(".additional-member-permissions").hide();
	
	if (!member_id) {
		var member_id = 0;
		var el = document.getElementById(genid + '_member_id');
		if (el) member_id = el.value;
	}
	
	og.openLink(og.getUrl('additional_member_permissions', 'get_additional_member_permission_values', {pg_id:pg_id, member_id:member_id}), {
		hideLoading: true,
		callback: function(success, data) {
			
			var perm_values = data.add_perm_values;
			if (og.additional_member_permissions && og.additional_member_permissions[genid] && og.additional_member_permissions[genid][member_id]) {
				perm_values = og.additional_member_permissions[genid][member_id];
			}
			
			if (perm_values) {
				for (x in perm_values) {
					if (typeof(x) == 'function') continue;
					
					var inp = document.getElementById(genid + 'additional_perm['+ x +']');
					if (inp && perm_values[x] == "1") {
						inp.setAttribute('checked', 'checked');
					}
					og.update_additional_member_permission_value(genid, member_id, x, perm_values[x]);
				}
			}
			
			
			$(".additional-member-permissions").slideDown();
			if (!data.can_manage_dim_members) {
				$(".additional-member-permissions").addClass('disabled');
				$(".additional-member-permissions input").attr('disabled', 'disabled');
				$(".additional-member-permissions").popover({
					content: '<div class="popover-hint">' + lang('additional permissions disabled hint 1') + '</div><div class="popover-hint">' + lang('additional permissions disabled hint 2') + '</div>',
					delay: { show: "100", hide: "200" },
					html: true,
			    	placement: 'left',
					trigger: 'hover'
				});
			} else {
				$(".additional-member-permissions").removeClass('disabled');
				$(".additional-member-permissions input").removeAttr('disabled');
			}
			
		}
	});
	
};



og.on_additional_member_perm_change = function(input, member_id, genid) {
	var input_name = $(input).attr('name');
	var perm_name = input_name.replace("additional_perm[", "").replace("]", "");
	
	var val = $(input).attr('checked') == 'checked';

	og.update_additional_member_permission_value(genid, member_id, perm_name, val);
}



if (!og.on_member_permissions_user_select) {
	og.on_member_permissions_user_select = [];
}
// add og.additional_member_permissions_on_perm_popup_show function to the onclick event of the user or group in member edition
og.on_member_permissions_user_select.push(og.additional_member_permissions_on_perm_popup_show);


if (!og.on_member_permissions_after_change) {
	og.on_member_permissions_after_change = [];
}
og.on_member_permissions_after_change.push(function(genid, pg_id) {
	
	var member_id = 0;
	var el = document.getElementById(genid + '_member_id');
	if (el) member_id = el.value;
	
	if (member_id == 0) {
		var params = {pg_id:pg_id};
		var additional_perms = $('.' + genid + 'single-add-perm');
		for (var x=0; x<additional_perms.length; x++) {
			var inp = additional_perms[x];
			
			params[$(inp).attr('name')] = ($(inp).attr('checked') == 'checked' ? 1 : 0);
		}
		
		// saves with member_id=0, after member is saved change 0 for member_id
		og.openLink(og.getUrl('additional_member_permissions', 'save_new_member_additional_permissions', params), {hideLoading: true});
	}
	
});


// apply the additional member permissions in children
og.eventManager.addListener('after apply permissions to submembers', function (data){
	var child_ids = data.subids;
	var member_id = data.member_id;
	var genid = data.genid;
	
	var perm_values = null;
	if (og.additional_member_permissions && og.additional_member_permissions[genid] && og.additional_member_permissions[genid][member_id]) {
		perm_values = og.additional_member_permissions[genid][member_id];
	}
	
	if (perm_values) {
		for (var i=0; i<child_ids.length; i++) {
			var child = child_ids[i];
			var new_perm_values = {};
			for (x in perm_values) {
				new_perm_values[x] = perm_values[x];
			}
			og.additional_member_permissions[genid][child] = new_perm_values;
		}
	}
});