<?php

/**
 * AdvancedBilling controller
 *
 * @version 1.0
 * @author Alex Zonis <alex.zonis@fengoffice.com>
 */
class AdvancedBillingController extends ApplicationController {

	var $plugin_name = "advanced_billing";
	
	/**
	 * Construct the AdvancedBillingController
	 *
	 * @access public
	 * @param void
	 * @return AdvancedBillingController
	 */
	function __construct() {
		parent::__construct();
		prepare_company_website_controller($this, 'website');
		
	} // __construct

    function get_updated_contract_type_settings() {
        ajx_current("empty");
        $current_members = json_decode(array_var($_REQUEST, 'current_members', array()), true);
        $new_members = json_decode(array_var($_REQUEST, 'new_members', array()), true);

        $current_project_members = $this->get_project_member_from_array($current_members);
        $new_project_members= $this->get_project_member_from_array($new_members);
        $current_member_id = empty($current_project_members) ? 0 : array_shift(array_values($current_project_members));
        $new_member_id = empty($new_project_members) ? 0 : array_shift(array_values($new_project_members));
        // Check if the member has changed or if the member is empty
        if($current_member_id == $new_member_id || $new_member_id == 0) {
            return;
        }

        $project_member = Members::instance()->findById($new_member_id);
        // Check if the member is a project member
        if(!$project_member instanceof Member) {
            return;
        }

        $project_ot = ObjectTypes::findByName('project');
        $contract_type_cp = $project_ot instanceof ObjectType? CustomProperties::getCustomPropertyByCode($project_ot->getId(), 'contract_type') : null;
        $active_contract_type_cp = $contract_type_cp instanceof CustomProperty ? !$contract_type_cp->getIsDisabled() : false;
        // Check if the contract type cp is enabled
        if(!$active_contract_type_cp) {
            return;
        }

        $contract_type_cp_value = CustomPropertyValues::getCustomPropertyValue($project_member->getObjectId(), $contract_type_cp->getId());
        // Check if the member has a contract type cp value
        if(!$contract_type_cp_value instanceof CustomPropertyValue) {
            return;
        }
        $contract_type_val = $contract_type_cp_value->getValue();

        ajx_extra_data(array('contract_type_val' => $contract_type_val));

        
    }

    function get_project_member_from_array($members_array) {
        ajx_current("empty");
        $project_member_dim = Dimensions::findByCode('customer_project');
        if(!$project_member_dim instanceof Dimension) {
            return false;
        }
        $project_member_dim_id = $project_member_dim->getId();
        foreach ($members_array as $dim_id => $members) {
            if ($dim_id == $project_member_dim_id) {
                $members = array_filter($members, function($member) {
                    return $member != 0;
                });
                return $members;
            }
        }
    }
}
