<?php

function get_task_billable_and_parent_billable_and_fixed_fee_info($task, $task_data) {
    $is_billable = 1; 
    $parent_non_billable = false;
    $parent_is_fixed_fee = false;

    if(!$task->isNew() || array_var($task_data, 'copyId')){
        $is_billable = $task->getColumnValue('is_billable');
        if(array_var($task_data, 'parent_id') > 0) {
            $parent_task = ProjectTasks::instance()->findById(array_var($task_data, 'parent_id'));
            if ($parent_task instanceof ProjectTask) {
                $parent_is_billable = $parent_task->getColumnValue('is_billable');
                $parent_non_billable = $parent_is_billable == 0 && $is_billable == 0;
                Env::useHelper('additional_tasks_columns_functions', 'advanced_billing');
                $parent_task_id = $parent_task->getId();
                $parent_is_fixed_fee = has_parent_with_fixed_fee(null, $parent_task_id);
            }
        }
    } else {
        if(array_var($task_data, 'parent_id') > 0) {
            $parent_task = ProjectTasks::instance()->findById(array_var($task_data, 'parent_id'));
            if ($parent_task instanceof ProjectTask) {
                $is_billable = $parent_task->getColumnValue('is_billable');
                $parent_non_billable = $is_billable == 0;
                Env::useHelper('additional_tasks_columns_functions', 'advanced_billing');
                $parent_task_id = $parent_task->getId();
                $parent_is_fixed_fee = has_parent_with_fixed_fee(null, $parent_task_id);
                if($parent_is_fixed_fee){
                    $is_billable = 0;
                }
            }
        } else if (Plugins::instance()->isActivePlugin('hour_types')) {
            $selected_members = active_context();
            
            $labor_cat_ot_id = ObjectTypes::findByName('hour_type')->getId();
            foreach($selected_members as $member){
                if($member instanceof Member && $member->getObjectTypeId() == $labor_cat_ot_id){
                    $mcp_billable = MemberCustomProperties::instance()->findOne(array('conditions' => '`object_type_id`='.$labor_cat_ot_id.' AND `code`="is_billable"'));
                    if($mcp_billable instanceof MemberCustomProperty){
                        $member_id = $member->getId();
                        $mcp_billable_id = $mcp_billable->getId();
                        $billable_mcp_value = MemberCustomPropertyValues::instance()->findOne(array('conditions' => '`member_id`='.$member_id.' AND `custom_property_id`='.$mcp_billable_id));
                        if($billable_mcp_value instanceof MemberCustomPropertyValue){
                            $is_billable = $billable_mcp_value->getValue() == -1 ? 0 : 1;
                        }
                    }
                }
            }
        } else {
            $is_billable = 1;
        }
    }

    $result = array(
        'is_billable' => $is_billable,
        'parent_non_billable' => $parent_non_billable,
        'parent_is_fixed_fee' => $parent_is_fixed_fee
    );

    return $result;
}
