<?php

class ObjectBillings extends BaseObjectBillings {

    public function __construct() {
        parent::__construct();
        $this->object_type_name = 'object_billing';
    }

    /**
     *
     * Find all members that have $id at 'object_id_column'
     * Also accepts as optional parameter dimension_id
     * @return Member
     */
    static function findByRelObjectId($id) {
        $conditions = 	"`rel_object_id` = '$id' ";
        return self::instance()->findOne(array("conditions" => array($conditions) ));
    }

    /**
     * Return array of object columns
     *
     * @access public
     * @param void
     * @return array
     */
    function getReportsColumns() {
        $cols = array(
            'total_price' => DATA_TYPE_FLOAT,
            'total_cost' => DATA_TYPE_FLOAT,
            'billing_rate' => DATA_TYPE_FLOAT,
            'cost_rate' => DATA_TYPE_FLOAT,
            'adv_billing_id' => DATA_TYPE_INTEGER,
            'adv_cost_id' => DATA_TYPE_INTEGER,

            'profit_margin' => DATA_TYPE_INTEGER,//Estimated profit margin
            'profit_margin_percentage' => DATA_TYPE_INTEGER,//Estimated profit %
        );
        return array_keys($cols);
    } // getColumns
}
