<?php
    if (!isset($genid)) $genid = gen_id();
    if (Plugins::instance()->isActivePlugin('multiple_currencies')) {
        Env::useHelper('functions', 'multiple_currencies');
    }
    $can_see_billing_info = true;
    Hook::fire('get_can_see_billing_information', array('user'=>logged_user()), $can_see_billing_info);
    $can_see_cost_info = true;
    Hook::fire('get_can_see_cost_information', array('user'=>logged_user()), $can_see_cost_info);

    $task_form_financials_status=$task->getColumnValue('invoicing_status');

   	$task_form_financials_status_input="enabled";  // *** LC no asignada en ningún otro lado ni referenciada en ningún otro archivo
    if($task_form_financials_status=='invoiced')
    {
    	$task_form_financials_status_input="disabled";
    }

    Env::useHelper('task_view_functions', 'advanced_billing');
    $task_billable_and_parent_billable_and_fixed_fee_info = get_task_billable_and_parent_billable_and_fixed_fee_info($task, $task_data);

    $is_billable = $task_billable_and_parent_billable_and_fixed_fee_info['is_billable'];

    $has_parent_with_quoted_price = false;
    $has_fixed_fee_parent = false;
    $has_subtasks_with_est_price = false;
    
    if(Plugins::instance()->isActivePlugin('advanced_billing')) {
        Env::useHelper('additional_tasks_columns_functions', 'advanced_billing');
        $has_parent_with_quoted_price = has_parent_with_quoted_price($task, array_var($task_data, 'parent_id'));
        $has_fixed_fee_parent = has_parent_with_fixed_fee($task, array_var($task_data, 'parent_id'));
        $has_subtasks_with_est_price = has_subtasks_with_est_price($task, array_var($task_data, 'parent_id'));
    }

	$set_objects_non_billable_if_price_is_manual = false;
	$additional_change_manually_est_price = "";

	if (Plugins::instance()->isActivePlugin('income')) {
		Env::useHelper('functions', 'income');
		$set_objects_non_billable_if_price_is_manual = income_config_option('set_objects_non_billable_if_price_is_manual');
		if ($set_objects_non_billable_if_price_is_manual) {
			$additional_change_manually_est_price = "og.ask_if_set_linked_objects_non_billable('$genid');";
		}
	}

    $project_ot = ObjectTypes::findByName('project');
    $contract_type_cp = $project_ot instanceof ObjectType? CustomProperties::getCustomPropertyByCode($project_ot->getId(), 'contract_type') : null;
    $active_contract_type_cp = $contract_type_cp instanceof CustomProperty ? !$contract_type_cp->getIsDisabled() : false;
?>

<table>

<input type="hidden" name="task[parent_has_quoted_price]" value="<?php echo $has_parent_with_quoted_price; ?>" id="<?php echo $genid."parent_has_quoted_price"; ?>" />
<!-- Estimated cost Row -->
<tr style="display: none;">
    <td class="bold task-financials-tab__td--label" ><?php echo lang('estimated_cost')?>:</td>
    <td class="task-financials-tab__td">
        <?php 
        $is_calculated_estimated_cost = !$task->isNew() || array_var($task_data, 'copyId') ? $task->getColumnValue('is_calculated_estimated_cost') : 1;
        $is_manual_estimated_cost = $is_calculated_estimated_cost ? 0 : 1;
        echo radio_field('task[is_calculated_estimated_cost]', $is_calculated_estimated_cost, array('onchange' => 'og.toggleAndHide("' . $genid. 'estimated_cost_value")', 
            'value' => '1', 'style' => 'width:16px; padding: 0 5px;')) . lang('calculated'); 
            
        echo radio_field('task[is_calculated_estimated_cost]', $is_manual_estimated_cost, array('onchange' => 'og.toggleAndHide("' . $genid. 'estimated_cost_value")', 
            'value' => '0', 'style' => 'width:16px; padding: 0 5px;')) . lang('manually');
        ?>
    </td>
    <td class="task-financials-tab__td--input">
        <div id="<?php echo $genid ?>estimated_cost_value">
            <?php
            //$estimated_cost_value = $task->getColumnValue('estimated_cost');
            //echo currency_selector('task[task_currency_id]', null, array());
            echo text_field('task[estimated_cost_value]', 0, array('id' => $genid.'addEstimatedCostValue', 'class' => 'amount', 'onchange' => 'og.updateElementMoneyAmount("'.$genid.'addEstimatedCostValue",this.value);')) ?>
        </div>
    </td>
</tr>
<tr style="display: none;"><td colspan='3' class='task-financials-tab__td--description'><?php echo lang('Unless it is manually set, the Estimated cost is calculated based on the Estimated time for this task multiplied by the hourly cost (depending to whom the task is assigned to), plus the cost of all budgeted expenses linked to this task') ?></td></tr>

<!-- Executed Cost Row -->
    <!-- <tr style="<?php echo $can_see_cost_info ? '' : 'display: none;' ?>"> -->
    <tr style="display: none;">
    <td class="bold task-financials-tab__td--label"><?php echo lang('executed_cost')?>:</td>
    <td class="task-financials-tab__td">
        <?php 
        $is_calculated_exec_cost = !$task->isNew() || array_var($task_data, 'copyId') ? $task->getColumnValue('is_calculated_executed_cost') : 1;
        $is_manual_exec_cost = $is_calculated_exec_cost ? 0 : 1;
        echo radio_field('task[is_calculated_executed_cost]',  $is_calculated_exec_cost, array('onchange' => 'og.toggleAndHide("' . $genid. 'executed_cost_amount")', 
            'value' => '1', 'style' => 'width:16px; padding: 0 5px;')) . lang('calculated'); 
            
        echo radio_field('task[is_calculated_executed_cost]', $is_manual_exec_cost, array('onchange' => 'og.toggleAndHide("' . $genid. 'executed_cost_amount")', 
            'value' => '0', 'style' => 'width:16px; padding: 0 5px;')) . lang('manually');
        ?>
    </td>
    <td class="task-financials-tab__td--input">
        <div id="<?php echo $genid ?>executed_cost_amount">
            <?php
            //$executed_cost_value = $task->getColumnValue('executed_cost');
            //echo currency_selector('task[task_currency_id]', null, array());
            echo text_field('task[executed_cost_value]', 0, array('id' => $genid.'addExecutedCostValue', 'class' => 'amount','onchange' => 'og.updateElementMoneyAmount("'.$genid.'addExecutedCostValue",this.value);')) ?>
        </div>
    </td>
</tr>
<tr style="display: none;"><td colspan='3' class='task-financials-tab__td--description'><?php echo lang('Executed cost is calculated based on the Worked time (time entries) for this task multiplied by the hourly cost. It has to be assigned in order for the system to calculate it') ?></td></tr>

<!-- Estimated Price Row -->
<?php 
    $use_contract_type_setup = false;
    if(!$task->isNew() || array_var($task_data, 'copyId')) {
        $is_calculated_estimated_price = $task->getColumnValue('is_calculated_estimated_price');
    } else {
        $is_calculated_estimated_price = 1;
        // Check contract type of project
        if($active_contract_type_cp) {
            $project = active_context_member_by_object_type($project_ot->getId());
            if($project instanceof Member){
                $contract_type_cp_value = CustomPropertyValues::getCustomPropertyValue($project->getObjectId(), $contract_type_cp->getId());
                if($contract_type_cp_value instanceof CustomPropertyValue) {
                    $use_contract_type_setup = true;
                    $contract_type = $contract_type_cp_value->getValue();
                    $is_calculated_estimated_price = $contract_type == 'T&M' ? 1 : 0;
                    $contract_type_is_fixed_fee = in_array($contract_type, array('Fixed fee', 'Percent complete', 'FDEP')) ? 1 : 0;
                }
            }
        }

    }
    $is_manual_estimated_price = $is_calculated_estimated_price ? 0 : 1;
    if($has_parent_with_quoted_price || $has_fixed_fee_parent || !$is_billable) {
        $is_calculated_estimated_price = 0;
        $is_manual_estimated_price = 1;
        if($has_fixed_fee_parent) {
            $use_contract_type_setup = false;
        }
    }

    // Set estimated price radio buttons params for 'Yes'
    $estimated_yes_params = array( 
        'onchange' => 'og.toggleAndHide("' . $genid. 'estimated_price_value"); 
                       og.setNewLabel("estimated_price_label", "'.lang('estimated_price').':"); 
                       og.show_hide_fixed_fee("'.$genid.'");', 
        'id' => $genid.'is_calculated_estimated_price_yes',
        'value' => '1',
        'style' => 'width:16px; padding: 0 5px;', 
        ''.$task_form_financials_status_input.''=>$task_form_financials_status_input);

    // Set estimated price radio buttons params for 'No'
    $estimated_no_params = array(
        'onchange' => 'og.ask_for_confirmation_to_change_to_quoted_price();',
        'id' => $genid.'is_calculated_estimated_price_no',
        'value' => '0', 
        'style' => 'width:16px; padding: 0 5px;');

    $estimated_price_input_params = array(
        'id' => $genid.'addEstimatedPriceValue', 
        'class' => 'amount', 
        ''.$task_form_financials_status_input.''=>$task_form_financials_status_input,
        'onchange' => 'og.updateElementMoneyAmount("'.$genid.'addEstimatedPriceValue",this.value);'
    );

    $show_billable_warning = $is_billable ? false : true;

    if($has_parent_with_quoted_price || !$is_billable) {
        $estimated_yes_params['disabled'] = 'disabled';
        $estimated_no_params['disabled'] = 'disabled';
        $estimated_price_input_params['disabled'] = 'disabled';
        if($has_parent_with_quoted_price) {
            $show_billable_warning = false;
        }
    }
?>
<tr style="<?php echo $can_see_billing_info ? '' : 'display: none;' ?>">
    <p id="estimated_price_warning" style="<?php echo $has_parent_with_quoted_price ? '' : 'display: none;' ?>" class="task-financials__warning"><?php echo lang('the estimated price cannot be manually set if a fixed quoted price is set for the parent task.'); ?></p>
    <p id="non_billable_task_estimated_price_warning" style="<?php echo $show_billable_warning ? '' : 'display: none;' ?>" class="task-financials__warning"><?php echo lang('the task is non-billable: cannot update quoted price'); ?></p>
    <td id="estimated_price_label" class="bold task-financials-tab__td--label"><?php echo $is_manual_estimated_price ? lang('estimated_price_manual') : lang('estimated_price')?>:</td>
    <td class="task-financials-tab__td">
        <?php
            // Render estimated price radio buttons
            echo radio_field('task[is_calculated_estimated_price]', $is_calculated_estimated_price, $estimated_yes_params) . lang('calculated'); 
            
            echo radio_field('task[is_calculated_estimated_price]', $is_manual_estimated_price, $estimated_no_params) . lang('manually');
        ?>
    </td>
    <td class="task-financials-tab__td--input">
        <div id="<?php echo $genid ?>estimated_price_value">
            <?php
                // Render estimated price input
                echo text_field('task[estimated_price_value]', 0, $estimated_price_input_params);
            ?>
        </div>
    </td>
</tr>
<tr><td colspan='3' class='task-financials-tab__td--description'><?php echo lang('Unless it is manually set, the Estimated revenue is calculated based on the Estimated time for this task multiplied by the hourly rate (depending on the labor category set to this task), plus the price of all budgeted expenses linked to this task') ?></td></tr>

<!-- Is fixed fee task -->
<?php 
    $show_fixed_fee = !$task->isNew() && !$task->getColumnValue('is_calculated_estimated_price');
    if($use_contract_type_setup && $is_calculated_estimated_price == 0) {
        $show_fixed_fee = true;
    }
    if($has_parent_with_quoted_price || $has_fixed_fee_parent) {
        $show_fixed_fee = false;
    }
    if($use_contract_type_setup) {
        $is_fixed_fee = $contract_type_is_fixed_fee;
    } else {
        $is_fixed_fee = $task->isNew() ? 0 : $task->getColumnValue('is_fixed_fee');
    }
   
    $fixed_fee_array = array(
                            array(0, lang('T&M')), 
                            array(1, lang('fixed fee'))
                       );
?>
<tr id="<?php echo $genid ?>_fixed_fee_row" style="<?php echo $show_fixed_fee ? '' : 'display: none;' ?>">
    <td id="fixed_fee_label" class="bold task-financials-tab__td--label"><?php echo lang('earned value calculation method') ?>:</td>
    <td class="task-financials-tab__td">
        <?php
            echo simple_select_box('task[is_fixed_fee]', $fixed_fee_array, $is_fixed_fee, array('id' => $genid.'is_fixed_fee', 'onchange' => $additional_change_manually_est_price));
        ?>
    </td>
</tr>

<!-- Earned Value Row -->
    <!-- <tr style="<?php echo $can_see_billing_info ? '' : 'display: none;' ?>"> -->
    <tr style="display: none;">
    <td class="bold task-financials-tab__td--label"><?php echo lang('earned_value')?>:</td>
    <td class="task-financials-tab__td">
        <?php 
        $is_calculated_earned_value = !$task->isNew() || array_var($task_data, 'copyId') ? $task->getColumnValue('is_calculated_earned_value') : 1;
        $is_manual_earned_value = $is_calculated_earned_value ? 0 : 1;
        echo radio_field('task[is_calculated_earned_value]', $is_calculated_earned_value, array('onchange' => 'og.toggleAndHide("' . $genid. 'earned_value_amount")', 
            'value' => '1', 'style' => 'width:16px; padding: 0 5px;')) . lang('calculated'); 
            
        echo radio_field('task[is_calculated_earned_value]', $is_manual_earned_value, array('onchange' => 'og.toggleAndHide("' . $genid. 'earned_value_amount")', 
            'value' => '0', 'style' => 'width:16px; padding: 0 5px;')) . lang('manually');
        ?>
    </td>
    <td class="task-financials-tab__td--input">
        <div id="<?php echo $genid ?>earned_value_amount">
            <?php
            //$earned_value_amount = $task->getColumnValue('earned_value');
            //echo currency_selector('task[task_currency_id]', null, array());
            echo text_field('task[earned_value_amount]', 0, array('id' => $genid.'addEarnedValueAmount', 'class' => 'amount',''.$task_form_financials_status_input.''=>$task_form_financials_status_input,'onchange' => 'og.updateElementMoneyAmount("'.$genid.'addEarnedValueAmount",this.value);')) ?>
        </div>
    </td>
</tr>
<tr style="display: none;"><td colspan='3' class='task-financials-tab__td--description'><?php echo lang('Earned value is calculated based on the Worked time (time entries) for this task multiplied by the hourly rate, depending on the labor category assigned to this task') ?></td></tr>

</table>





<script>
    var genid = '<?php echo $genid ?>';
    var formatted_default_value = og.format_money_amount(0);
    var active_contract_type_cp = <?php echo $active_contract_type_cp ? 1 : 0 ?>;
    var is_new_task = <?php echo $task->isNew() ? 1 : 0 ?>;
    var has_subtasks_with_est_price = <?php echo $has_subtasks_with_est_price ? 1 : 0 ?>;
    // Show or Hide estimated cost input

    var is_calculated_estimated_cost = <?php echo $is_calculated_estimated_cost ? 1 : 0 ?>;
    var div_estimated_cost_value = Ext.getDom(genid + 'estimated_cost_value');
    if(is_calculated_estimated_cost){
        $("#" + genid + 'addEstimatedCostValue').val(formatted_default_value);
        div_estimated_cost_value.style.display = 'none';
    } else {
        // Set formatted estimated cost value
        var estimated_cost_value = <?php echo $task->getColumnValue('estimated_cost') ? $task->getColumnValue('estimated_cost') : 0 ?>;
        var formatted_est_cost_value = og.format_money_amount(estimated_cost_value);
        $("#" + genid + 'addEstimatedCostValue').val(formatted_est_cost_value);
        // Show estimated cost input
		div_estimated_cost_value.style.display = 'block';
    }
    
    // Show or Hide executed cost input
   /* COMMENT AND KEEP THIS CODE FOR FUTURE USE 
    var is_calculated_exec_cost = <?php echo $is_calculated_exec_cost ? 1 : 0 ?>;
    var div_executed_cost = Ext.getDom(genid + 'executed_cost_amount');
    if(is_calculated_exec_cost){
        $("#" + genid + 'addExecutedCostValue').val(formatted_default_value);
        div_executed_cost.style.display = 'none';
    } else {
        // Set formatted executed cost value
        var executed_cost_value = <?php echo $task->getColumnValue('executed_cost') ? $task->getColumnValue('executed_cost') : 0 ?>;
        var formatted_ex_cost_value = og.format_money_amount(executed_cost_value);
        $("#" + genid + 'addExecutedCostValue').val(formatted_ex_cost_value);
        // Show executed cost input
		div_executed_cost.style.display = 'block';
    } */
    
    // Show or Hide estimated price input
    var is_calculated_estimated_price = <?php echo $is_calculated_estimated_price ? 1 : 0; ?>;
    var div_estimated_price_value = Ext.getDom(genid + 'estimated_price_value');
    if(is_calculated_estimated_price){
        $("#" + genid + 'addEstimatedPriceValue').val(formatted_default_value);
        div_estimated_price_value.style.display = 'none';
    } else {
        // Set formatted estimated price value
        var estimated_price_value = <?php echo $task->getColumnValue('estimated_price') && $task->getColumnValue('is_billable') ? $task->getColumnValue('estimated_price') : 0 ?>;
        var formatted_est_price_value = og.format_money_amount(estimated_price_value);
        $("#" + genid + 'addEstimatedPriceValue').val(formatted_est_price_value);
        // Show estimated price input
		div_estimated_price_value.style.display = 'block';
    }
    
    // Show or Hide earned value input
    /* COMMENT AND KEEP THIS CODE FOR FUTURE USE
    var is_calculated_earned_value = <?php echo $is_calculated_earned_value ? 1 : 0; ?>;
    var div_earned_value = Ext.getDom(genid + 'earned_value_amount');
    if(is_calculated_earned_value){
        $("#" + genid + 'addEarnedValueAmount').val(formatted_default_value);
        div_earned_value.style.display = 'none';
    } else {
         // Set formatted earned value
        var earned_value_amount = <?php echo $task->getColumnValue('earned_value') ? $task->getColumnValue('earned_value') : 0 ?>;
        var formatted_earned_value_amount = og.format_money_amount(earned_value_amount);
        $("#" + genid + 'addEarnedValueAmount').val(formatted_earned_value_amount);
        // Show earned value input
		div_earned_value.style.display = 'block';
    } */

    og.setNewLabel = function(id, text) {
        var label = Ext.getDom(id);
        label.innerHTML = text;
    }


	og.ask_if_set_linked_objects_non_billable = function(form_genid) { 
		var is_fixed_fee = $("#" + form_genid + "is_fixed_fee").val();
        if(is_fixed_fee == 0) return;
        
		var question = lang('If you set a fixed price for this task, all billable time entries and/or expenses linked to this task will be changed to non-billable. Do you want to proceed?');
		var html = '<div style="padding: 10px;">'+ 
			'<div id="'+genid+'_question">'+ question +'</div>'+
			'<div class="clear"></div></div>';

		og.ExtendedDialog.show({
			YESNO: true,
			html: html,
			height: 200,
			width: 400,
			title: lang('confirm set non billable'),
			okBtnCls: 'submit-btn-blue',
			cancelBtnCls: 'cancel-btn-g',
			iconCls: ' ',
			cls: 'ext-modal-object-list no-border',
			ok_fn: function() {
				og.ExtendedDialog.hide();
			},
			cancel_fn: function() {
				// rollback the radio button
                $("#" + form_genid + "is_fixed_fee").val(0);
				og.ExtendedDialog.hide();
			},
		});
	}

    og.udpate_estimated_price_and_fixed_fee_selector_using_project = function(current_members, new_members) {
        var parent_is_fixed_fee = $('#<?php echo $genid ?>parent_is_fixed_fee').val();
		if(parent_is_fixed_fee == 1){ 
			return;
		}
        if(active_contract_type_cp && is_new_task) {
            var request_params = {
                'current_members': current_members,
                'new_members': new_members
            };
            og.openLink(og.getUrl('advanced_billing', 'get_updated_contract_type_settings', request_params), {
                callback: function(success, data) {
                    if(data.contract_type_val) {
                        var fixed_fee_row = $('#' + genid + '_fixed_fee_row');
                        if(data.contract_type_val == 'T&M') {
                            $("#" + genid + "is_calculated_estimated_price_no").removeAttr('checked');
                            $("#" + genid + "is_calculated_estimated_price_yes").attr('checked', 'checked');
                            $("#" + genid + "estimated_price_value").hide();
                            og.show_hide_fixed_fee(genid);
                        } else if(data.contract_type_val == 'T&M (Not to exceed)') {
                            $("#" + genid + "is_calculated_estimated_price_yes").removeAttr('checked');
                            $("#" + genid + "is_calculated_estimated_price_no").attr('checked', 'checked');
                            $("#" + genid + "estimated_price_value").show();
                            fixed_fee_row.show();
                            $('#' + genid + 'is_fixed_fee option:eq(0)').attr('selected', 'selected');
                            $('#' + genid + 'is_fixed_fee option:eq(1)').removeAttr('selected');
                        } else if(data.contract_type_val == 'Fixed fee' || data.contract_type_val == 'Percent complete' || data.contract_type_val == 'FDEP') {
                            $("#" + genid + "is_calculated_estimated_price_yes").removeAttr('checked');
                            $("#" + genid + "is_calculated_estimated_price_no").attr('checked', 'checked');
                            $("#" + genid + "estimated_price_value").show();
                            fixed_fee_row.show();
                            $('#' + genid + 'is_fixed_fee option:eq(0)').removeAttr('selected');
                            $('#' + genid + 'is_fixed_fee option:eq(1)').attr('selected', 'selected');
                        }
                    }
                }
            });
        }
    }

    og.show_hide_fixed_fee = function(gen_id) {

        var parent_is_fixed_fee = $('#<?php echo $genid ?>parent_is_fixed_fee').val();
        var parent_has_quoted_price = $('#<?php echo $genid ?>parent_has_quoted_price').val();

        var fixed_fee_row = $('#' + gen_id + '_fixed_fee_row');
        var is_calculated_estimated_price = $('#' + gen_id + 'is_calculated_estimated_price_yes').is(':checked');
        if (!is_calculated_estimated_price) {
            if (parent_is_fixed_fee || parent_has_quoted_price) {
              return;
            }
            fixed_fee_row.show();
        } else {
            fixed_fee_row.hide();
            $('#' + gen_id + 'is_fixed_fee option:eq(0)').attr('selected', 'selected');
            $('#' + gen_id + 'is_fixed_fee option:eq(1)').removeAttr('selected');

        } 
    }

    og.udpate_estimated_price_and_fixed_fee_selector_using_task = function(parent_task_id) {
        og.openLink(og.getUrl('billing_definition', 'has_quoted_price_in_parent_hierarchy', {parent_task_id: parent_task_id}), {
            callback: function(success, data) {
                var has_quoted_price_parent = data.has_quoted_price_parent;
                var fixed_fee_row = $('#' + genid + '_fixed_fee_row');
                if(has_quoted_price_parent) {
                    $("#" + genid + "is_calculated_estimated_price_yes").removeAttr('checked');
                    $("#" + genid + "is_calculated_estimated_price_yes").attr('disabled', 'disabled');
                    $("#" + genid + "is_calculated_estimated_price_no").attr('checked', 'checked');
                    $("#" + genid + "is_calculated_estimated_price_no").attr('disabled', 'disabled');
                    $("#" + genid + "estimated_price_value").show();
                    $("#" + genid + "addEstimatedPriceValue").val(0);
                    $("#" + genid + "parent_has_quoted_price").val(1);
                    fixed_fee_row.hide();
                    $("#estimated_price_warning").show();
                    alert(lang('This task has a parent with a quoted price. Estimated price will be set to zero.'));
                } else {
                    $("#" + genid + "parent_has_quoted_price").val(0);
                }
            }
        });
    }

    og.udpate_restrictions_when_the_task_is_removed = function() {
        $("#" + genid + "is_calculated_estimated_price_no").removeAttr('disabled');
        $("#" + genid + "is_calculated_estimated_price_yes").removeAttr('disabled');
        $("#estimated_price_warning").hide();
        $("#" + genid + "parent_has_quoted_price").val(0);
        $("#" + genid + "parent_is_fixed_fee").val(0);
        og.show_hide_fixed_fee(genid);
    }

    og.ask_for_confirmation_to_change_to_quoted_price = function() { 
        if((has_subtasks_with_est_price && confirm(lang("You are about to set a quoted estimated price. Moving forward it will set estimated price of all sub-tasks to zero. This can't be un-done. Do you want to proceed?")) || !has_subtasks_with_est_price)) {
            og.toggleAndHide(genid + "estimated_price_value");
            og.setNewLabel("estimated_price_label", lang('estimated_price_manual')+":");
            og.show_hide_fixed_fee(genid);
        } else {
            $("#" + genid + "is_calculated_estimated_price_no").removeAttr('checked');
            $("#" + genid + "is_calculated_estimated_price_yes").attr('checked', 'checked');
        }
    }

    og.setQuotedPriceAndDisable = function() {
        // Set to quoted price and disable radio buttons
        $("#" + genid + "is_calculated_estimated_price_yes").removeAttr('checked');
        $("#" + genid + "is_calculated_estimated_price_yes").attr('disabled', 'disabled');
        $("#" + genid + "is_calculated_estimated_price_no").attr('checked', 'checked');
        $("#" + genid + "is_calculated_estimated_price_no").attr('disabled', 'disabled');
        $("#" + genid + "estimated_price_value").show();
        // Set quoted price to 0 and disable value input
        $("#" + genid + "addEstimatedPriceValue").attr('disabled', 'disabled');
        $("#" + genid + "addEstimatedPriceValue").val(0);
        $("#non_billable_task_estimated_price_warning").show();
    }

    og.enableQuotedPrice = function() {
        $("#non_billable_task_estimated_price_warning").hide();
       
        // Check if parent is fixed fee or has quoted price
        var parent_is_fixed_fee = $('#<?php echo $genid ?>parent_is_fixed_fee').val();
        var parent_has_quoted_price = $('#<?php echo $genid ?>parent_has_quoted_price').val();
        if(parent_is_fixed_fee || parent_has_quoted_price) {
            return;
        }

        // enable radio buttons and value input
        $("#" + genid + "is_calculated_estimated_price_yes").removeAttr('disabled');
        $("#" + genid + "is_calculated_estimated_price_no").removeAttr('disabled');
        $("#" + genid + "addEstimatedPriceValue").removeAttr('disabled');
    }
    
</script>
