<?php  

Env::useHelper('task_view_functions', 'advanced_billing');
$task_billable_and_parent_billable_and_fixed_fee_info = get_task_billable_and_parent_billable_and_fixed_fee_info($task, $task_data);

$is_billable = $task_billable_and_parent_billable_and_fixed_fee_info['is_billable']; 
$parent_non_billable = $task_billable_and_parent_billable_and_fixed_fee_info['parent_non_billable'];
$parent_is_fixed_fee = $task_billable_and_parent_billable_and_fixed_fee_info['parent_is_fixed_fee'];

$allow_manual_billable = config_option('use_is_billable_value_in_tasks');
$attributes = array('onchange' => 'og.onBillableValueChange();');
$parent_billable_value = $parent_non_billable ? 0 : 1;
$parent_is_fixed_fee_value = $parent_is_fixed_fee ? 1 : 0;

if($parent_non_billable || $parent_is_fixed_fee || !$allow_manual_billable){
	$attributes['disabled'] = 'disabled';
}
?>
<div class="dataBlock" style="display: inline;">
	<input type="hidden" name="task[parent_is_billable]" value="<?php echo $parent_billable_value; ?>" id="<?php echo $genid."parent_is_billable"; ?>" />
	<input type="hidden" name="task[parent_is_fixed_fee]" value="<?php echo $parent_is_fixed_fee_value; ?>" id="<?php echo $genid."parent_is_fixed_fee"; ?>" />
	<label><?php echo lang('billable')?></label>
	<?php echo yes_no_widget('task[is_billable]', $genid."is_billable", $is_billable, lang('yes'), lang('no'), null, $attributes); ?>
	<span id="parent_non_billable_warning" style="<?php echo $parent_non_billable ? '' : 'display: none;' ?>" class="parent_non_billable_warning"><?php echo lang('the parent task in non-billable.'); ?></span>
	<span id="parent_fixed_fee_warning" style="<?php echo !$parent_non_billable && $parent_is_fixed_fee ? '' : 'display: none;' ?>" class="parent_non_billable_warning"><?php echo lang('the parent task is fixed fee.'); ?></span>
</div>

<script>
	var genid = '<?php echo $genid ?>';
	var advanced_billing_active = <?php echo Plugins::instance()->isActivePlugin('advanced_billing') ? '1' : '0'; ?>;
	var allow_manual_billable = <?php echo $allow_manual_billable ? '1' : '0'; ?>;
	var show_financials_tab = false;
	if(advanced_billing_active) {
		show_financials_tab = <?php echo config_option('show_financial_tab_in_task_form') ? '1' : '0'; ?>;
	}

	og.updateBillableUsingParentTask = function(parent_task_id, genid) {
		og.openLink(og.getUrl('billing_definition', 'get_billable_value_of_parent_task', {parent_task_id: parent_task_id}), {
			callback: function(success, data) {
				var has_fixed_fee_parent = data.has_fixed_fee_parent;
				if(has_fixed_fee_parent) {
					// Set input parent_is_fixed_fee to 1
					$('#'+genid+'parent_is_fixed_fee').val('1');
					// Set the billable to 'No'
					$('#'+genid+'is_billableYes').removeAttr('checked');
					$('#'+genid+'is_billableNo').attr('checked', 'checked');
					og.disableBillableSelector();
					// Show warning
					$('#parent_fixed_fee_warning').show();
					og.onBillableValueChange();
					return;
				}

                var parent_is_billable = data.parent_is_billable;
                if(parent_is_billable) {
					// Set input parent_is_billable to 1
					$('#'+genid+'parent_is_billable').val('1');
					// Set the billable to 'Yes'
					$('#'+genid+'is_billableNo').removeAttr('checked');
					$('#'+genid+'is_billableYes').attr('checked', 'checked');
					og.enableBillableSelector();
					// Hide warning
					$('#parent_non_billable_warning').hide();
					$('#parent_fixed_fee_warning').hide();
					og.onBillableValueChange();
                } else {
					// Set input parent_is_billable to 0 and parent_is_fixed_fee to 1
					$('#'+genid+'parent_is_billable').val('0');
					$('#'+genid+'parent_is_fixed_fee').val('1');
					// Set the billable to 'No'
					$('#'+genid+'is_billableYes').removeAttr('checked');
					$('#'+genid+'is_billableNo').attr('checked', 'checked');
					og.disableBillableSelector();
					// Show warning
					$('#parent_non_billable_warning').show();
					og.onBillableValueChange();
					// Alert about the restriction
					alert(lang('The parent task in non-billable. You cannot set this task as billable.'));
				}
            }
		});
	}

	og.disableBillableSelector = function () {
		var genid = '<?php echo $genid ?>';
		$('#'+genid+'is_billableNo').attr('disabled', 'disabled');
		$('#'+genid+'is_billableYes').attr('disabled', 'disabled');
	}

	og.enableBillableSelector = function () {
		if (!allow_manual_billable) {
			return;
		}

		var genid = '<?php echo $genid ?>';
		$('#'+genid+'is_billableNo').removeAttr('disabled');
		$('#'+genid+'is_billableYes').removeAttr('disabled');
	}

	og.removeBillableSelectorConstraints = function (genid) {
		// Set input parent_is_billable to 1 and parent_is_fixed_fee to 0
		$('#'+genid+'parent_is_billable').val('1');
		$('#'+genid+'parent_is_fixed_fee').val('0');
		og.enableBillableSelector();
		// Hide warnings
		$('#parent_non_billable_warning').hide();
		$('#parent_fixed_fee_warning').hide();
	}

	og.onBillableValueChange = function() {
		if(!show_financials_tab) {
			return;
		}

		if($('#<?php echo $genid ?>is_billableYes').attr('checked') == 'checked') {
			og.enableQuotedPrice();
		} else {
			og.setQuotedPriceAndDisable();
		}
	}

</script>
