<?php
    if (!isset($genid)) $genid = gen_id();
    if (Plugins::instance()->isActivePlugin('multiple_currencies')) {
        Env::useHelper('functions', 'multiple_currencies');
    }
    $can_see_billing_info = true;
    Hook::fire('get_can_see_billing_information', array('user'=>logged_user()), $can_see_billing_info);
    $can_see_cost_info = true;
    Hook::fire('get_can_see_cost_information', array('user'=>logged_user()), $can_see_cost_info);
?>

<table>

<!-- Estimated cost Row -->
<tr style="display: none">
    <td class="bold task-financials-tab__td--label" ><?php echo lang('estimated_cost')?>:</td>
    <td class="task-financials-tab__td">
        <?php 
        $is_calculated_estimated_cost = !$task->isNew() || array_var($task_data, 'copyId') ? $task->getColumnValue('is_calculated_estimated_cost') : 1;
        $is_manual_estimated_cost = $is_calculated_estimated_cost ? 0 : 1;
        echo radio_field('task[is_calculated_estimated_cost]', $is_calculated_estimated_cost, array('onchange' => 'og.toggleAndHide("' . $genid. 'estimated_cost_value")', 
            'value' => '1', 'style' => 'width:16px; padding: 0 5px;')) . lang('calculated'); 
            
        echo radio_field('task[is_calculated_estimated_cost]', $is_manual_estimated_cost, array('onchange' => 'og.toggleAndHide("' . $genid. 'estimated_cost_value")', 
            'value' => '0', 'style' => 'width:16px; padding: 0 5px;')) . lang('manually');
        ?>
    </td>
    <td class="task-financials-tab__td--input">
        <div id="<?php echo $genid ?>estimated_cost_value">
            <?php
            echo text_field('task[estimated_cost]', 0, array('id' => $genid.'addEstimatedCostValue', 'class' => 'amount', 'onchange' => 'og.updateElementMoneyAmount("'.$genid.'addEstimatedCostValue",this.value);')) ?>
        </div>
    </td>
</tr>
<tr style="display: none"><td colspan='3' class='task-financials-tab__td--description'><?php echo lang('Estimated cost is calculated based on the Estimated time for this task multiplied by the hourly cost. It has to be assigned in order for the system to calculate it') ?></td></tr>


<!-- Estimated Price Row -->
<tr style="<?php echo $can_see_billing_info ? '' : 'display: none;' ?>">
    <td class="bold task-financials-tab__td--label"><?php echo lang('estimated_price')?>:</td>
    <td class="task-financials-tab__td">
        <?php 
        $is_calculated_estimated_price = !$task->isNew() || array_var($task_data, 'copyId') ? $task->getColumnValue('is_calculated_estimated_price') : 1;
        $is_manual_estimated_price = $is_calculated_estimated_price ? 0 : 1;
        echo radio_field('task[is_calculated_estimated_price]', $is_calculated_estimated_price, array('onchange' => 'og.toggleAndHide("' . $genid. 'estimated_price_value")', 
            'value' => '1', 'style' => 'width:16px; padding: 0 5px;')) . lang('calculated'); 
            
        echo radio_field('task[is_calculated_estimated_price]', $is_manual_estimated_price, array('onchange' => 'og.toggleAndHide("' . $genid. 'estimated_price_value")', 
            'value' => '0', 'style' => 'width:16px; padding: 0 5px;')) . lang('manually');
        ?>
    </td>
    <td class="task-financials-tab__td--input">
        <div id="<?php echo $genid ?>estimated_price_value">
            <?php
            echo text_field('task[estimated_price]', 0, array('id' => $genid.'addEstimatedPriceValue', 'class' => 'amount','onchange' => 'og.updateElementMoneyAmount("'.$genid.'addEstimatedPriceValue",this.value);')) ?>
        </div>
    </td>
</tr>
<tr><td colspan='3' class='task-financials-tab__td--description'><?php echo lang('Estimated revenue is calculated based on the Estimated time for this task multiplied by the hourly rate, depending on the labor category assigned to this task') ?></td></tr>

</table>





<script>
    var genid = '<?php echo $genid ?>';
    var formatted_default_value = og.format_money_amount(0);
    
    // Show or Hide estimated cost input
    var is_calculated_estimated_cost = <?php echo $is_calculated_estimated_cost ? 1 : 0 ?>;
    var div_estimated_cost_value = Ext.getDom(genid + 'estimated_cost_value');
    if(is_calculated_estimated_cost){
        $("#" + genid + 'addEstimatedCostValue').val(formatted_default_value);
        div_estimated_cost_value.style.display = 'none';
    } else {
        // Set formatted estimated cost value
        var estimated_cost_value = <?php echo $task->getColumnValue('estimated_cost') ? $task->getColumnValue('estimated_cost') : 0 ?>;
        var formatted_est_cost_value = og.format_money_amount(estimated_cost_value);
        $("#" + genid + 'addEstimatedCostValue').val(formatted_est_cost_value);
        // Show estimated cost input
		div_estimated_cost_value.style.display = 'block';
    }
    
    // Show or Hide estimated price input
    var is_calculated_estimated_price = <?php echo $is_calculated_estimated_price ? 1 : 0; ?>;
    var div_estimated_price_value = Ext.getDom(genid + 'estimated_price_value');
    if(is_calculated_estimated_price){
        $("#" + genid + 'addEstimatedPriceValue').val(formatted_default_value);
        div_estimated_price_value.style.display = 'none';
    } else {
        // Set formatted estimated price value
        var estimated_price_value = <?php echo $task->getColumnValue('estimated_price') ? $task->getColumnValue('estimated_price') : 0 ?>;
        var formatted_est_price_value = og.format_money_amount(estimated_price_value);
        $("#" + genid + 'addEstimatedPriceValue').val(formatted_est_price_value);
        // Show estimated price input
		div_estimated_price_value.style.display = 'block';
    }
    
</script>
