<?php
if (!isset($genid)) $genid = gen_id();
$rand = rand();

$timeslots_with_conflict = Timeslots::instance()->findAll(array("conditions" => "billing_category_status='conflict'"));
if (count($timeslots_with_conflict) > 0) {
?>
	<table id="<?php echo $genid ?>timeslots_with_conflict">
	<tr>
		<td colspan=2 class="TMConflictTsHeader">
			<?php echo lang('timeslots with billing category conflict') ?>
		</td>
		<td class="coViewTopRight">&nbsp;</td>
	</tr>
	<tr>
		<td colspan=2 class="coViewBody" style="background-color:white; border-left:1px solid #ddd;">
			<div id="<?php echo $genid ?>TMConflictTsContents" class="TMConflictTsContents">
				<table style="width:100%;">
				<tr>
					<td style="width:20px;"></td>
					<td style="width:20%;"><span class="bold"><?php echo lang('name') ?></span></td>
					<td style="width:15%;"><span class="bold"><?php echo lang('user') ?></span></td>
					<td style="width:70px;"><span class="bold"><?php echo lang('date') ?></span></td>
					<td style="width:60px;"><span class="bold"><?php echo lang('time') ?></span></td>
					<td><span class="bold"><?php echo lang('description') ?></span></td>
					<td style="width:350px;"><span class="bold"><?php echo lang('related to') ?></span></td>
					<td style="width:70px;"></td>
				</tr>
			<?php
			$i = 0;
			foreach ($timeslots_with_conflict as $ts) { /* @var $ts Timeslot */
				$i++;
				?>
				<tr class="<?php echo $i % 2 != 0 ? "alt" : ""?>">
				  <td>
				  	<a class="internalLink coViewAction ico-timeslot" href="javascript:og.render_modal_form('', {c:'time', a:'edit_timeslot', params: {id:<?php echo $ts->getId()?>}});"
					style="line-height:25px" title="<?php echo lang('edit')?>">&nbsp;</a>
					
				  </td><td>
					<a class="internalLink" href="javascript:og.render_modal_form('', {c:'time', a:'edit_timeslot', params: {id:<?php echo $ts->getId()?>}});"
					style="line-height:25px" title="<?php echo lang('edit')?>"><?php echo $ts->getObjectName() ?></a>
				 
				  </td><td>
					<?php
						$c = Contacts::instance()->findById($ts->getContactId());
						if ($c instanceof Contact) echo $c->getObjectName();
					?>
				  </td><td>
				    <?php
					    $tformat = 'M j';
					    $now = DateTimeValueLib::now();
					    if ($now->getYear() != $ts->getStartTime()->getYear()) $tformat = 'M j, Y';
					    echo format_time($ts->getStartTime(), $tformat);
				    ?>
				  </td><td>
				    <?php
				    	$info = $ts->getArrayInfo();
				    	$mins = $info['time'] / 60;
				    	$m = $mins % 60;
				    	$h = floor($mins / 60);
				    	echo str_pad($h, 2, '0', STR_PAD_LEFT) . ":" . str_pad($m, 2, '0', STR_PAD_LEFT);
				    ?>
				  </td><td>
				  	<?php echo $ts->getDescription(); ?>
				  </td><td>
					<div class='breadcrumb-container' style='max-width:300px; width:100%;' id="breadcrumb-container-<?php echo $rand."-".$ts->getId()?>">
						<script>
						
							var dim_mem_path = '<?php echo json_encode($ts->getMembersIdsToDisplayPath())?>';
							var mpath = null;
							if (dim_mem_path){
								mpath = Ext.util.JSON.decode(dim_mem_path);
							}
							var mem_path = "";			
							if (mpath){
								mem_path = og.getEmptyCrumbHtml(mpath, '.breadcrumb-container');
							}
							$("#breadcrumb-container-<?php echo $rand."-".$ts->getId() ?>").html(mem_path);
						
						</script>
					</div>
					
				  </td><td style="text-align:right;">
					<a class="internalLink coViewAction ico-edit" href="javascript:og.render_modal_form('', {c:'time', a:'edit_timeslot', params: {id:<?php echo $ts->getId()?>}});"
					style="line-height:25px" title="<?php echo lang('edit')?>">&nbsp;</a>
				  </td>
				</tr>
				<?php
			}
			?>
				</table>
			</div>
		</td>
		<td class="coViewRight"></td>
	</tr>
	<tr>
		<td class="coViewBottomLeft" style="max-width: 5px;"></td>
		<td class="coViewBottom">&nbsp;</td>
		<td class="coViewBottomRight"></td>
	</tr>
</table>
<?php 
	
}
