<?php

include_once dirname(__FILE__)."/../../../application/helpers/plugin_installer_functions.php";

function advanced_billing_get_additional_install_queries($db_connection, $table_prefix) {
	
	$queries = array();
	
	
    if (check_is_installed_plugin($db_connection, $table_prefix, 'advanced_reports')) {
        include_once dirname(__FILE__)."/../../advanced_reports/application/helpers/default_member_reports.php";

        $rep_fix = get_create_fixed_report_queries($table_prefix, 'timeslot','Billing rate and Cost rate');

        $queries = array_merge($queries, $rep_fix);
    }
	
	if (check_is_installed_plugin($db_connection, $table_prefix, 'advanced_core')) {
		
		include_once dirname(__FILE__)."/../../advanced_core/application/helpers/installer_functions.php";
		
		$prop_groups_queries = get_default_property_groups_queries($db_connection, $table_prefix);
		$queries = array_merge($queries, $prop_groups_queries);
		
	}

	if (check_is_installed_plugin($db_connection, $table_prefix, 'hour_types')) {

		$sql = "SELECT count(id) as total FROM ".$table_prefix."member_custom_properties WHERE code='is_billable'
				AND object_type_id=(SELECT id FROM ".$table_prefix."object_types WHERE name='hour_type')";
		
		$mysql_res = mysqli_query($db_connection, $sql);
		if ($mysql_res) {
			$rows = mysqli_fetch_assoc($mysql_res);
		
			if (count($rows) > 0 && $rows['total'] == 0) {
				$queries[] = "INSERT INTO `".$table_prefix."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
				SELECT mt.id, 'Billable', 'is_billable','boolean','','',1,0,0,0,5,1, 1, 0
				FROM ".$table_prefix."object_types mt WHERE mt.`type` IN ('dimension_group') AND name IN ('hour_type')
				ON DUPLICATE KEY UPDATE `code`=`code`;";
			}
		}

		if (check_is_installed_plugin($db_connection, $table_prefix, 'advanced_core')) {
			// Check if default property group exists
			$group_sql = "SELECT id FROM ".$table_prefix."property_groups WHERE code='default'
			AND object_type_id=(SELECT id FROM ".$table_prefix."object_types WHERE name='hour_type')";
			$group_mysql_res = mysqli_query($db_connection, $group_sql);
			if ($group_mysql_res) {
				$rows = mysqli_fetch_assoc($group_mysql_res);
				if (count($rows) > 0 && $rows[0]['id'] > 0) {
					$group_id = $rows[0]['id'];
				
					// Check if 'is_billable' custom property exists
					$mcp_sql = "SELECT id FROM ".$table_prefix."member_custom_properties WHERE code='is_billable'
					AND object_type_id=(SELECT id FROM ".$table_prefix."object_types WHERE name='hour_type')";
					$mcp_mysql_res = mysqli_query($db_connection, $mcp_sql);
					if ($mcp_mysql_res) {
						$rows = mysqli_fetch_assoc($mcp_mysql_res);
						if (count($rows) > 0 && $rows[0]['id'] > 0) {
							$property_id = $rows[0]['id'];
							$queries[] = "INSERT INTO `".$table_prefix."property_group_properties` (`group_id`, `property_id`, `order`, `is_inheritable`) VALUES
							('".$group_id."', '".$property_id."', 5, 0)
							ON DUPLICATE KEY UPDATE `property_id`=`property_id`;";
						}
					}
				}
			}
		}
	}


	return $queries;

}
?>
