-- <?php echo $table_prefix ?>
-- <?php echo $default_charset ?> DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci
-- <?php echo $default_collation ?> collate utf8_unicode_ci
-- <?php echo $engine ?> InnoDB
-- varchar cannot be larger than 256
-- blob/text cannot have default values
-- sql queries must finish with ;\n (line break inmediately after ;)

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>billing_definitions` (
  `id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(255) NOT NULL,
  `description` TEXT NULL,
  `user_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
  `rate_currency_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
  `hourly_rate` DECIMAL(20,3) NOT NULL DEFAULT 0,
  `cost_currency_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
  `hourly_cost` DECIMAL(20,3) NOT NULL DEFAULT 0,
  `enable_rate` tinyint(1) NOT NULL DEFAULT '1',
  `enable_cost` tinyint(1) NOT NULL DEFAULT '1',
  `created_by_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
  `created_on` datetime NOT NULL default '0000-00-00 00:00:00',
  `updated_by_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
  `updated_on` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  INDEX `user_id`(`user_id`)
) ENGINE = <?php echo $engine ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>billing_definition_members` (
  `definition_id` int(10) unsigned NOT NULL,
  `dimension_id` int(10) NOT NULL DEFAULT '0',
  `member_id` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`definition_id`,`dimension_id`,`member_id`)
) ENGINE = <?php echo $engine ?>;


ALTER TABLE `<?php echo $table_prefix ?>timeslots`
 ADD COLUMN `fixed_cost` DECIMAL(20,3) NOT NULL DEFAULT 0,
 ADD COLUMN `hourly_cost` DECIMAL(20,3) NOT NULL DEFAULT 0,
 ADD COLUMN `is_fixed_cost` BOOLEAN NOT NULL DEFAULT 0,
 ADD COLUMN `adv_billing_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
 ADD COLUMN `adv_cost_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
 ADD COLUMN `cost_currency_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
 ADD COLUMN `billing_category_status` VARCHAR(255) NOT NULL DEFAULT '';

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>object_billing` (
`object_id` INT(11) NOT NULL AUTO_INCREMENT,
`rel_object_id` INT(10) NULL DEFAULT NULL,
`contact_id` INT(10) NULL DEFAULT NULL,
`time` INT(10) NULL DEFAULT NULL,
`total_price` DECIMAL(20,3) NOT NULL DEFAULT '0.000',
`billing_rate` DECIMAL(20,3) NOT NULL DEFAULT '0.000',
`is_total_price` TINYINT(1) UNSIGNED NOT NULL DEFAULT '0',
`rate_currency_id` INT(10) UNSIGNED NOT NULL DEFAULT '0',
`invoicing_status` VARCHAR(50) CHARACTER SET 'utf8' NOT NULL DEFAULT 'pending',
`invoice_id` INT(10) UNSIGNED NOT NULL DEFAULT '0',
`total_cost` DECIMAL(20,3) NOT NULL DEFAULT '0.000',
`cost_rate` DECIMAL(20,3) NOT NULL DEFAULT '0.000',
`is_total_cost` TINYINT(1) NOT NULL DEFAULT '0',
`adv_billing_id` INT(10) UNSIGNED NOT NULL DEFAULT '0',
`adv_cost_id` INT(10) UNSIGNED NOT NULL DEFAULT '0',
`cost_currency_id` INT(10) UNSIGNED NOT NULL DEFAULT '0',
`billing_category_status` VARCHAR(255) CHARACTER SET 'utf8' NOT NULL DEFAULT '',
  PRIMARY KEY (`object_id`),
  KEY `rel_object_id` (`rel_object_id`),
  KEY `contact_id` (`contact_id`),
  KEY `adv_billing_id` (`adv_billing_id`),
  KEY `adv_cost_id` (`adv_cost_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>rate_schedules` (
  `object_id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`object_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

ALTER TABLE `<?php echo $table_prefix ?>project_tasks`
 ADD COLUMN `executed_cost` DECIMAL(20,3) NOT NULL DEFAULT 0,
 ADD COLUMN `earned_value` DECIMAL(20,3) NOT NULL DEFAULT 0,
 ADD COLUMN `estimated_cost` DECIMAL(20,3) NOT NULL DEFAULT 0,
 ADD COLUMN `estimated_price` DECIMAL(20,3) NOT NULL DEFAULT 0,
 ADD COLUMN `is_calculated_executed_cost` TINYINT(1) NOT NULL DEFAULT '1',
 ADD COLUMN `is_calculated_earned_value` TINYINT(1) NOT NULL DEFAULT '1',
 ADD COLUMN `is_calculated_estimated_cost` TINYINT(1) NOT NULL DEFAULT '1',
 ADD COLUMN `is_calculated_estimated_price` TINYINT(1) NOT NULL DEFAULT '1',
 ADD COLUMN `is_billable` TINYINT(1) NOT NULL DEFAULT '1',
 ADD COLUMN `invoicing_status` VARCHAR(50) NOT NULL default 'pending',
 ADD COLUMN `invoice_id` INT(10) NOT NULL default 0,
 ADD COLUMN `is_fixed_fee` TINYINT(1) NOT NULL DEFAULT '0',
 ADD COLUMN `earned_value_time_material` DECIMAL(20,3) NOT NULL DEFAULT 0,
 ADD COLUMN `earned_value_fixed_fee` DECIMAL(20,3) NOT NULL DEFAULT 0;
 
ALTER TABLE `<?php echo $table_prefix ?>template_tasks`
 ADD COLUMN `estimated_cost` DECIMAL(20,3) NOT NULL DEFAULT 0,
 ADD COLUMN `estimated_price` DECIMAL(20,3) NOT NULL DEFAULT 0,
 ADD COLUMN `is_calculated_estimated_cost` TINYINT(1) NOT NULL DEFAULT '1',
 ADD COLUMN `is_calculated_estimated_price` TINYINT(1) NOT NULL DEFAULT '1',
 ADD COLUMN `is_billable` TINYINT(1) NOT NULL DEFAULT '1';

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>member_totals` (
  `id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `member_id` INT(10) unsigned NOT NULL default 0,
  `estimated_labor_minutes` DECIMAL(50,3) NOT NULL default 0,
  `estimated_labor_billable_price` DECIMAL(50,3) NOT NULL default 0,
  `estimated_labor_non_billable_price` DECIMAL(50,3) NOT NULL default 0,
  `estimated_labor_total_price` DECIMAL(50,3) NOT NULL default 0,
  `estimated_labor_billable_cost` DECIMAL(50,3) NOT NULL default 0,
  `estimated_labor_non_billable_cost` DECIMAL(50,3) NOT NULL default 0,
  `estimated_labor_total_cost` DECIMAL(50,3) NOT NULL default 0,
  `executed_labor_minutes` DECIMAL(50,3) NOT NULL default 0,
  `executed_labor_billable_minutes` DECIMAL(50,3) NOT NULL default 0,
  `executed_labor_non_billable_minutes` DECIMAL(50,3) NOT NULL default 0,
  `executed_labor_billable_price` DECIMAL(50,3) NOT NULL default 0,
  `executed_labor_non_billable_price` DECIMAL(50,3) NOT NULL default 0,
  `executed_labor_total_price` DECIMAL(50,3) NOT NULL default 0,
  `executed_labor_billable_cost` DECIMAL(50,3) NOT NULL default 0,
  `executed_labor_non_billable_cost` DECIMAL(50,3) NOT NULL default 0,
  `executed_labor_total_cost` DECIMAL(50,3) NOT NULL default 0,
  `estimated_expense_billable_price` DECIMAL(50,3) NOT NULL default 0,
  `estimated_expense_non_billable_price` DECIMAL(50,3) NOT NULL default 0,
  `estimated_expense_total_price` DECIMAL(50,3) NOT NULL default 0,
  `estimated_expense_billable_cost` DECIMAL(50,3) NOT NULL default 0,
  `estimated_expense_non_billable_cost` DECIMAL(50,3) NOT NULL default 0,
  `estimated_expense_total_cost` DECIMAL(50,3) NOT NULL default 0,
  `executed_expense_billable_price` DECIMAL(50,3) NOT NULL default 0,
  `executed_expense_non_billable_price` DECIMAL(50,3) NOT NULL default 0,
  `executed_expense_total_price` DECIMAL(50,3) NOT NULL default 0,
  `executed_expense_billable_cost` DECIMAL(50,3) NOT NULL default 0,
  `executed_expense_non_billable_cost` DECIMAL(50,3) NOT NULL default 0,
  `executed_expense_total_cost` DECIMAL(50,3) NOT NULL default 0,
  `estimated_overall_billable_price` DECIMAL(50,3) NOT NULL default 0,
  `estimated_overall_non_billable_price` DECIMAL(50,3) NOT NULL default 0,
  `estimated_overall_total_price` DECIMAL(50,3) NOT NULL default 0,
  `estimated_overall_billable_cost` DECIMAL(50,3) NOT NULL default 0,
  `estimated_overall_non_billable_cost` DECIMAL(50,3) NOT NULL default 0,
  `estimated_overall_total_cost` DECIMAL(50,3) NOT NULL default 0,
  `executed_overall_billable_price` DECIMAL(50,3) NOT NULL default 0,
  `executed_overall_non_billable_price` DECIMAL(50,3) NOT NULL default 0,
  `executed_overall_total_price` DECIMAL(50,3) NOT NULL default 0,
  `executed_overall_billable_cost` DECIMAL(50,3) NOT NULL default 0,
  `executed_overall_non_billable_cost` DECIMAL(50,3) NOT NULL default 0,
  `executed_overall_total_cost` DECIMAL(50,3) NOT NULL default 0,
  `invoiced_total` DECIMAL(50,3) NOT NULL default 0,
  `invoiced_subtotal` DECIMAL(50,3) NOT NULL default 0,
  `invoiced_paid_amount` DECIMAL(50,3) NOT NULL default 0,
  `invoiced_due_amount` DECIMAL(50,3) NOT NULL default 0,
  `percent_completed` INT(10) UNSIGNED NOT NULL default 0,
  PRIMARY KEY  (`id`),
  INDEX `member_id`(`member_id`)
  ) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;