<?php
	class CObjTemplateObjectVariableValue extends BaseCObjTemplateObjectVariableValue {
		
		function getParsedData(CObjTemplate $template) {
			$data = array(
				'template_id' => $this->getTemplateId(),
				'object_id' => $this->getObjectId(),
				'property' => $this->getProperty(),
				'parameter_id' => $this->getParameterId(),
				'value' => $this->getValue(),
			);

			$property = $this->getProperty();
			$object_type = $template->getObjectType();
			
			if ($object_type->getName() == 'expense' && str_starts_with($property, 'line-')) {

				$exploded = explode('-', $property);
				$line_col = end($exploded);
				$col_type = ExpenseItems::instance()->getColumnType($line_col);
				
			} else {
				
				$manager = $template->getObjectTypeManager();
				$col_type = $manager->getColumnType($property);
			}

			if ($col_type == DATA_TYPE_DATE || $col_type == DATA_TYPE_DATETIME) {

				$string_val = $this->getValue();
				$param_pos = strpos($string_val, '}');
				$param = substr($string_val, 1, $param_pos - 1);
				$operation = substr($string_val, $param_pos + 1, 1);
				$amount_unit = substr($string_val, $param_pos + 2);
				$amount = substr($amount_unit, 0, strlen($amount_unit) - 1);
				$unit = substr($amount_unit, strlen($amount_unit) - 1, 1);

				$data['param'] = $param;
				$data['operation'] = $operation;
				$data['amount'] = $amount;
				$data['unit'] = $unit;

			}

			return $data;
		}
		
	}
	 
