<?php 
	require_javascript("og/modules/addTemplate.js");
	$genid = gen_id();
	
	$object_type = $template->getObjectType();
	$ot_name = $object_type->getObjectTypeName();
	$custom_ot_name = $object_type->getPluralObjectTypeName();

	$properties_for_variables = $template->getPropertiesForVariables();

	$current_variables = $template->getVariablesData();

	// on submit functions
	if (array_var($_REQUEST, 'modal')) {
		$on_submit = "og.submit_modal_form('".$genid."submit-edit-form'); return false;";
	} else {
		$on_submit = "return true;";
	}
	$on_submit = "og.cobj_templates.replace_parameter_names();" . $on_submit;

?>
<form class="add-member-template" id="<?php echo $genid ?>submit-edit-form" onsubmit="<?php echo $on_submit?>" action="<?php echo $template->isNew() ? get_url('c_obj_template', 'add') : get_url('c_obj_template', 'edit', array('id' => $template->getId())) ?>" method="post" enctype="multipart/form-data" >
<div class="member-template">
<div class="coInputHeader">

  <div class="coInputHeaderUpperRow">
	<div class="coInputTitle">
		<?php echo $template->isNew() ? lang('new x type template', $custom_ot_name) : lang('edit x type template', $custom_ot_name) ?>
	</div>
  </div>

  <div>
	<div class="coInputName">
		<?php echo text_field('template[name]', $template->getName(), array('id' => $genid . 'templateName', 'class' => 'title', 'placeholder' => lang('type name here'))) ?>
	</div>
		
	<div class="coInputButtons">
		<?php echo submit_button($template->isNew() ? lang('add new x type template', $custom_ot_name) : lang('save changes'),'s', array('style'=>'margin-top:0px;margin-left:10px')) ?>
	</div>
	<div class="clear"></div>
  </div>
</div>


<div class="coInputMainBlock adminMainBlock">
	
	<input type="hidden" name="template[object_type_id]" value="<?php echo $object_type->getId()?>" />
	
	<div id="<?php echo $genid?>tabs" class="edit-form-tabs">
	
		<ul id="<?php echo $genid?>tab_titles">
		
			<li><a href="#<?php echo $genid?>add_template_details"><?php echo $custom_ot_name ?></a></li>
			<li><a href="#<?php echo $genid?>add_template_description"><?php echo lang('description') ?></a></li>
			<li><a href="#<?php echo $genid?>add_template_parameters"><?php echo lang('parameters') ?></a></li>

		</ul>
	
		<div id="<?php echo $genid ?>add_template_details" class="form-tab">

			<div id="<?php echo $genid ?>template_objects" class="template-objects"></div>

			<div class="add-template-obj-link">
				<a href="#" id="<?php echo $genid . "add_template_object_link"?>" class="internalLink ico-add bg-ico"><?php echo lang("add new x",$ot_name); ?></a>
			</div>
			
		</div>

		<div id="<?php echo $genid ?>add_template_description" class="form-tab">
		<?php echo textarea_field("template[description]", $template->getDescription(), array("class" => "large", "rows" => 12, "cols" => 120, "placeholder" => lang("type here to add a description to the template"))) ?>
		</div>

		<div id="<?php echo $genid ?>add_template_parameters" class="form-tab">

			<div id="<?php echo $genid ?>template_parameters" class="template-parameters"></div>

			<div class="add-template-obj-link">
				<a href="#" id="<?php echo $genid . "add_template_parameter_link"?>" class="internalLink ico-add bg-ico"><?php echo lang('add a parameter to this template') ?></a>
			</div>
		</div>
		
		<div class="clear"></div>
	</div>
	
</div>

</div>
</form>

<div style="display:none" id="<?php echo $genid?>object_line_container_generic">
	<div id="<?php echo $genid ?>template_object_{idx}" class="line-container">

		<div class="template-object">
			<input type="hidden" value="" class="template-object-data-input" name="template[objects][{idx}]"/>
			<div class="template-obj-name"></div>
			<div class="template-obj-actions">
				<a href="#" class="vars-template-object toggle_collapsed bg-ico"><?php echo lang("variables"); ?></a>
				<a href="#" class="edit-template-object internalLink ico-edit action-ico board-ico"><?php echo lang("edit"); ?></a>
				<a href="#" class="delete-template-object internalLink ico-delete action-ico board-ico"><?php echo lang("delete"); ?></a>
			</div>
		</div>

		<div class="template-object-vars-container" style="display:none;">
			<div><?php echo lang('variables') ?></div>
			<div class="template-object-vars"></div>
			
			<a href="#" class="add-template-variable-link internalLink ico-add bg-ico"><?php echo lang('add a new variable to this object') ?></a>
			
		</div>
	</div>
</div>

<div style="display:none" id="<?php echo $genid?>parameter_container_generic">
	<div id="<?php echo $genid ?>template_parameter_{idx}" class="parameter-container">

		<div class="template-parameter">
			<input type="hidden" value="" class="template-parameter-name-input" name="template[parameters][{idx}][name]"/>
			<input type="hidden" value="" class="template-parameter-type-input" name="template[parameters][{idx}][type]"/>
			<div class="template-parameter-name"></div>
			<div class="template-parameter-actions">
				<a href="#" class="edit-template-parameter internalLink ico-edit action-ico board-ico"><?php echo lang("edit"); ?></a>
				<a href="#" class="delete-template-parameter internalLink ico-delete action-ico board-ico"><?php echo lang("delete"); ?></a>
			</div>
		</div>

	</div>
</div>

<div style="display:none" id="<?php echo $genid?>var_selector_container_generic">
	<div id="<?php echo $genid ?>template_var_{obj_idx}_{var_idx}" class="variable-container">

		<div class="template-variable">
			<div class="template-variable-contents">
				<select class="property-selector" name="template[variables][{obj_idx}][{var_idx}][property]" id="template_variable_{obj_idx}_{var_idx}_property">
					<option></option>
					<?php foreach ($properties_for_variables as $p) {
						?><option value="<?php echo $p['property'] ?>"><?php echo $p['text'] ?></option><?php
					} ?>
				</select>
				&nbsp; = &nbsp;
				<div class="variable-definition">
				</div>
			</div>
			<div class="template-variable-actions">
				<a href="#" class="delete-template-variable internalLink ico-delete bg-ico"><?php //echo lang("delete"); ?></a>
			</div>
		</div>

	</div>
</div>

<style>

</style>

<script>
var genid = '<?php echo $genid?>';

if (!og.cobj_templates) og.cobj_templates = {};
og.cobj_templates.genid = genid;
og.cobj_templates.add_url = "<?php echo $template->getTemplateObjectAddUrl() ?>";
og.cobj_templates.ot_name = "<?php echo $object_type->getName() ?>";

og.cobj_templates.last_object_index = 1; // increment index by each current object
og.cobj_templates.last_parameter_index = 0;
og.cobj_templates.last_variable_index = {};

og.templateParameters = [];
og.cobj_templates.var_values = {};

og.cobj_templates.properties_for_variables = {};
<?php
foreach ($properties_for_variables as $p) {
	$col_text = escape_single_quotes($p['text']);
?>
	og.cobj_templates.properties_for_variables['<?php echo $p['property'] ?>'] = {
		property: '<?php echo $p['property'] ?>',
		type: '<?php echo $p['type'] ?>',
		text: '<?php echo $col_text ?>',
	};
<?php
}

if ($object_type->getName() == 'expense') {
	$product_types = ProductTypes::getAllProductTypesData();
	$product_types_by_id = array();
	foreach ($product_types as $p) {
		$product_types_by_id[$p['id']] = $p;
	}
?>
	og.cobj_templates.product_types = Ext.util.JSON.decode('<?php echo(json_encode($product_types_by_id))?>');
<?php 
}
?>



// listener for the add new object click
$("#" + genid + "add_template_object_link").click(function(){
	var url = og.cobj_templates.add_url.replace(/obj_index/, og.cobj_templates.last_object_index);
	url = url.replace(/obj_data/, "''");
	
	eval(url);
});

// add new parameter listener
$("#" + genid + "add_template_parameter_link").click(function(){
	og.cobj_templates.add_new_template_parameter();
});


$(function() {
	$("#<?php echo $genid?>tabs").tabs();


<?php
	// add existing objects when editing template
	if (isset($template_objects_data) && is_array($template_objects_data)) {
		foreach ($template_objects_data as $data) {
			// build object for js function
			$js_data = array('object_data' => $data);
?>
			// set js variable
			var obj_data = Ext.util.JSON.decode('<?php echo escape_single_quotes(json_encode($js_data)) ?>');
			// call function to render the object in the form
			og.cobj_templates.update_template_object_in_form(obj_data);
<?php
		}
	}
?>


<?php
	// add existing parameters when editing template
	if (isset($template_parameters_data) && is_array($template_parameters_data)) {
		foreach ($template_parameters_data as $data) {
?>
			var param_id = <?php echo $data['parameter_id'] ?>;
			var param_name = '<?php echo $data['name'] ?>';
			var param_type = '<?php echo $data['type'] ?>';

			// call function to render the parameter in the form
			og.cobj_templates.update_template_parameter_in_form(param_id, param_name, param_type);

			var last_id = parseInt(param_id);
			if (og.cobj_templates.last_parameter_index < last_id) {
				og.cobj_templates.last_parameter_index = last_id;
			}
<?php
		}
	}
?>
});

<?php
	// add existing object variables when editing template
	if (isset($current_variables) && is_array($current_variables)) {
		foreach ($current_variables as $data) {
	?>
			var var_data = Ext.util.JSON.decode('<?php echo escape_single_quotes(json_encode($data)) ?>');

			// call function to render the object variable in the form
			og.cobj_templates.add_new_template_variable(var_data.object_id, var_data);

	<?php
		}
	}
?>
</script>
<div></div>
