<?php

$dim_ids = array();
$ot_ids = array();
$by_dim_and_ot = array();

foreach ($hide_sel_options as $opt) {/* @var $opt DimensionContentObjectOption */
	
	if (!isset($by_dim_and_ot[$opt->getDimensionId()])) $by_dim_and_ot[$opt->getDimensionId()] = array();
	if (!isset($by_dim_and_ot[$opt->getDimensionId()][$opt->getContentObjectTypeId()])) {
		$by_dim_and_ot[$opt->getDimensionId()][$opt->getContentObjectTypeId()] = array();
	}
	
	$by_dim_and_ot[$opt->getDimensionId()][$opt->getContentObjectTypeId()] = $opt->getValue();
	
	$dim_ids[] = $opt->getDimensionId();
	$ot_ids[] = $opt->getContentObjectTypeId();
}

$dim_ids = array_unique($dim_ids);
$ot_ids = array_unique($ot_ids);

?>
<div class="section">
	<h1><?php echo lang('show or hide dimension selector options') ?></h1>
	<div class="description desc"><?php echo lang('show or hide dimension selector options desc')?></div>
	<table class="bordered">
		<tr><th></th><?php
			foreach ($dimensions_by_id as $dim_id => $dimension) {
				$onclick = "og.on_show_hide_dim_selector_change_all_ots('$genid','$dim_id');";
				echo '<th><a href="#" onclick="'.$onclick.'">'. $dimension->getName() .'</a></th>';
			}
		?></tr>
<?php
		$is_alt = true;
		foreach ($ot_ids as $ot_id) {
			$ot = ObjectTypes::instance()->findById($ot_id);
			if (in_array($ot->getName(), array('template_milestone', 'template_task', 'file revision'))) continue
		
		?><tr class="<?php echo ($is_alt ? "altRow" : "")?>"><td><?php echo lang($ot->getName())?></td><?php
			foreach ($dimensions_by_id as $dim_id => $dimension) {
				$by_ot = array_var($by_dim_and_ot, $dim_id, array());
				$is_hidden = array_var($by_ot, $ot_id) > 0;
				
				echo '<td class="center">';
				
				echo checkbox_field("show_dim_selector_checkbox[$dim_id][$ot_id]", !$is_hidden, 
						array('onchange' => "og.on_show_hide_dim_selector_change('$genid', '$dim_id','$ot_id', this)",
							'id' => $genid.'show_dim_selector_checkbox_'.$dim_id.'_'.$ot_id));
				
				echo input_field("show_dim_selector[$dim_id][$ot_id]", (!$is_hidden ? "true" : "false"), 
						array('id' => $genid.'show_dim_selector_'.$dim_id.'_'.$ot_id, 'type' => 'hidden'));
				
				echo '</td>';
			}
			$is_alt = !$is_alt;
		?></tr><?php 
		}
?>
	</table>
</div>
