
<?php
	Env::useHelper("member_history", "advanced_core");
	
	if ($member instanceof Member && !$member->isNew()) {
		
		$last_date = null;
		$history_logs_info = MemberHistories::instance()->getMemberHistory($member->getId(), $start, $limit);
		
		$history_logs = array_var($history_logs_info, 'logs');
		$total_logs = array_var($history_logs_info, 'total_count');
		$page = array_var($history_logs_info, 'page');
		$total_pages = floor($total_logs / $limit);
		if ($total_logs % $limit > 0) $total_pages++;
		
		if (!isset($genid)) $genid = gen_id();
		
		if ($history_logs) {
		?>
		<div class="member-history-container" id="<?php echo $genid ?>member-history-container">
		<table class="member-history"><?php
		
		
		?><tr class="header"><th><?php echo lang('date')?></th><th><?php echo lang('user')?></th><th><?php echo lang('action')?></th></tr><?php
		
		
			$is_alt = false;
			
			foreach ($history_logs as $log) { /* @var $log MemberHistory */
				
				$new_tr = false;
				if (is_null($last_date) || $last_date->getTimestamp() != $log->getCreatedOn()->getTimestamp()) {
					$new_tr = true;
					$last_date = $log->getCreatedOn();
				}
				
				if ($new_tr) { 
					// close previous row
					if (!is_null($last_date)) {
						?></td></tr><?php
					}
					
					$user = Contacts::instance()->findById($log->getCreatedById());
					if (!$user) {
						$user_name = "";
						$tz_offset = logged_user()->getUserTimezoneHoursOffset();
					} else {
						$user_name = $user->getObjectName();
						$tz_offset = $user->getUserTimezoneHoursOffset();
					}
					$dateCreated = format_datetime($log->getCreatedOn(), null, $tz_offset);
					
					// put user and date in first record of the row
					?><tr class="<?php echo $is_alt ? "alt-row" : ""; ?>">
						<td class="date-td"><div class="date-div"><?php
							echo $dateCreated;
							
						?></div></td>
						<td class="user-td"><div class="user-div"><?php
							echo $user_name
						
					?></div></td><td class="log-td"><?php
					
					$is_alt = !$is_alt;
				}
				
				$log_html = get_member_history_log_single_html($log, $member);
				if ($log_html != "") {
					?><div class="log-div">
						<?php echo $log_html ?>
					</div><?php
				}
			}
			
			if (count($history_logs) > 0) {
				// close last row
				?></td></tr><?php
			}
	
			?></table><?php
			
			render_view_member_history_pagination($member->getId(), $page, $total_pages, $genid, $limit);
			
			?></div><?php 
		}
	}
?>


<script>
$(function() {
	og.eventManager.fireEvent('replace all empty breadcrumb', null);
	
// hide tab if member has no history
<?php if ( !$history_logs ) { ?>
	$("#<?php echo $genid ?>member_history_tab").hide();
	$("#<?php echo $genid ?>member_history_tab").parent().hide();
<?php } ?>
});
</script>