<?php   
  if (!isset($genid)) {
  	$genid = gen_id();
  }
  
  if (!isset($save_js_function)) {
  	$save_js_function = "og.saveObjectPrintOptions('$genid');";
  }
  
  $type_name = strtolower($object_type->getPluralObjectTypeName());
  
  $is_subtype = false;
  if (isset($subtype) && $subtype instanceof ObjectSubtype) {
  	$is_subtype = true;
  	$type_name = htmlentities(strtolower($subtype->getName()));
  }
  
?>

<div class="custom-properties-admin object-type <?php echo $object_type->getName() ?>">

<div class="coInputHeader">
<table><tr><td>
  <div class="coInputHeaderUpperRow">
	<div class="coInputTitle">
		<?php echo lang('print options for', $type_name); ?>
	</div>
	<div class="desc">
		<?php echo lang('print options reorder help') ?>
	</div>
  </div>
</td><td style="min-width:160px;">
  <div class="coInputHeaderUpperRow">
  	<div class="coInputButtons">
  		<?php echo submit_button(lang('save changes'), null, array('onclick' => $save_js_function, 'style' => 'margin-top:0; margin-left:20px;')) ?>
  	</div>
  </div>
</td></tr></table>
</div>

<div class="coInputMainBlock adminMainBlock">
	<input type="hidden" id="<?php echo $genid?>_ot_id" name="object_type_id" value="<?php echo $object_type->getId() ?>"/>
	<?php
		if ($is_subtype) { ?>
			<input type="hidden" id="<?php echo $genid?>_sub_ot_id" name="object_subtype_id" value="<?php echo $subtype->getId() ?>"/>
	<?php
			tpl_assign('subtype', $subtype);
		} 
	
		tpl_assign('genid', $genid);
		tpl_assign('object_type', $object_type);
		tpl_assign('type_name', $type_name);
		tpl_assign('object_print_options', $object_print_options);
		tpl_display(get_template_path('object_type_print_options', 'object_print_options'));
	?>
	
	<?php
	if (!$is_subtype) {
		tpl_display(get_template_path('print_options_subtypes_list', 'object_print_options'));
	} 
	?>
	
	<?php echo submit_button(lang('save changes'), null, array('onclick' => $save_js_function)) ?>
</div>

</div>

