<?php
Hook::register("custom_properties_in_templates");


function custom_properties_in_templates_after_template_object_param_instantiation($parameters, &$return) {
    // array('template_id' => $object->getTemplateId(), 'original' => $object, 'copy' => $copy, 'parameter_values' => $parameterValues)
    $template_id = array_var($parameters, 'template_id');
    $template_object = array_var($parameters, 'original');
    $task_created = array_var($parameters, 'copy'); /*var $task_created TemplateTask */
    $parameter_values = array_var($parameters, 'parameter_values');

    $objProp = TemplateObjectProperties::getPropertiesByTemplateObject($template_id, $template_object->getId());
    
    Env::useHelper('functions', 'advanced_core');
    
    foreach($objProp as $property) {
        $propName = $property->getProperty();
        $value = $property->getValue();
        
        if (substr($propName, 0, 3) == "cp_") {
            add_template_custom_property_to_template_task($template_object, $task_created, $propName, $value, $parameter_values);            
        }
    }
	$return = null;
}

/**
 * This function adds the custom properties as possible variables in a task template.
 * 
 * @param array $parameters Currently not used, but necessary for hook implementation
 * @param array $templateObjectProperties
 */
function custom_properties_in_templates_add_custom_properties_as_template_properties($parameters, &$templateObjectProperties) {
    //Get all the custom_properties in tasks...
    $custom_properties = CustomProperties::getAllCustomPropertiesByObjectType(ProjectTasks::instance()->getObjectTypeId());
    foreach ($custom_properties as $cp) { /* @var $cp CustomProperty */
        
		// only support text, numeric, date and user cps
		$allowed_cp_types = array('datetime','date','numeric','text','user');

		if (in_array($cp->getType(), $allowed_cp_types)) {
			$template_property_type = '';
			switch ($cp->getType()) {
				case 'date':
				case 'datetime':
					$template_property_type = DATA_TYPE_DATETIME;
					break;
				case 'text':
					$template_property_type = DATA_TYPE_STRING;
					break;
				case 'numeric':
					$template_property_type = DATA_TYPE_INTEGER;
					break;
				case 'user':
					$template_property_type = 'USER';
					break;
								
			}
 			//the 'cp_' prefix is added to the name of the Custom property
			$templateObjectProperties[] = array('id' => 'cp_'.$cp->getId(), 'name' => $cp->getName(), 'type' => $template_property_type);
		}
    }    
}
