<?php
Hook::register('dimension_options');

function dimension_options_render_administration_icons($ignored, &$links) {
	if (can_manage_dimensions(logged_user())) {
		$links[] = array(
				'ico' => 'ico-large-config2',
				'url' => get_url('dimension_options', 'dimension_options'),
				'name' => lang('dimension options'),
				'extra' => '',
		);
	}
}


function dimension_options_allowed_dimensions_in_member_selector($params, &$allowed_dimensions) {
	$ot_id = array_var($params, 'ot');
	$options = array_var($params, 'options');
	$dimensions = array();
	
	if (array_var($options, 'dont_exclude_hidden_selectors')) {
		return;
	}
	
	foreach ($allowed_dimensions as $dimension) {
		
		if (is_numeric($dimension)) $dim_id = $dimension;
		else if (is_array($dimension) && isset($dimension['dimension_id'])) $dim_id = $dimension['dimension_id'];
		else if (is_array($dimension) && isset($dimension['id'])) $dim_id = $dimension['id'];
		else if ($dimension instanceof Dimension) $dim_id = $dimension->getId();
		else continue;
		
		$hidden_dim = (int)DimensionContentObjectOptions::getOptionValue($dim_id, $ot_id, 'hide_member_selector_in_forms');
		if (!$hidden_dim) {
			$dimensions[] = $dimension;
		}
	}
	
	$allowed_dimensions = $dimensions;
}

function dimension_options_hidden_breadcrumbs($params, &$ret) {
	$dim_id = array_var($params, 'dim_id');
	$ot_id = array_var($params, 'ot_id');
	
	$is_hidden = DimensionContentObjectOptions::getOptionValue($dim_id, $ot_id, 'hide_member_selector_in_forms');
	if ($is_hidden) {
		// if selector is hidden, then check if it autoclassifies in this dimension by another member type
		$is_autoclassified = false;
		$assocs = DimensionMemberAssociations::instance()->findAll(array("conditions" => "associated_dimension_id='$dim_id'"));
		foreach ($assocs as $a) {
			if ($a instanceof DimensionMemberAssociation) {
				$is_autoclassified = DimensionAssociationsConfigs::getConfigValue($a->getId(), 'autoclassify_in_property_member');
				if ($is_autoclassified) break;
			}
		}
		
		// only hide it if not is autoclassfied by other member
		if (!$is_autoclassified) {
			$ret = array('hidden' => true);
		}
	}
}

function dimension_options_more_autoclassify_in_related_checks($params, &$classify_it) {
	$dim_id = array_var($params, 'dim_id');
	$ot_id = array_var($params, 'ot_id');
	
	$is_hidden = DimensionContentObjectOptions::getOptionValue($dim_id, $ot_id, 'hide_member_selector_in_forms');
	if ($is_hidden) {
		$classify_it = true;
	}
}