<?php

Hook::register('time_weekly_view');

function time_weekly_view_object_definition($type, &$ret) {
	if ($type == 'Timeslot') {
		$ret['ignore_time_start'] = DATA_TYPE_BOOLEAN;
	}
}

function time_weekly_view_timeslot_list_additional_actions($params, &$actions) {
	$actions[] = array(
		'url' => '#',
 		'onclick' => "og.time_weekly_view.switch_interface('".array_var($params, 'panel_id')."', 'list');",
 		'cls' => 'ico-calendar-week',
 		'text' => lang('weekly view'),
	);
}

function time_weekly_view_autoload_stylesheets($args, &$css) {
	$css[] = ROOT_URL . "/" . get_stylesheet_url('time_weekly.css', 'advanced_core');
}


function time_weekly_view_additional_time_panel_view($params, &$output) { 
	Env::useHelper('time_weekly_functions', 'advanced_core');
	Env::useHelper('time_weekly_view_functions', 'advanced_core');
	tpl_assign('panel_id', array_var($params, 'panel_id'));
	$genid = array_var($params, 'genid');
	tpl_assign('genid', $genid);

	$current_filters = array_var($params, 'current_filters');
	$time_filters = json_decode(user_config_option('current_time_module_filters'), true);
	$current_filters['weekly_user_id'] = $time_filters['user_filter'] == 0 ? logged_user()->getId() : $time_filters['user_filter'];
	$this_week_dates = get_date_range_for_this_week($current_filters);
	tpl_assign('current_filters', $current_filters);

	$weekly_data = get_weekly_time_data($current_filters);
	tpl_assign('weekly_data', $weekly_data);

	$weekly_html = build_html_for_weekly_view($weekly_data, $genid);
	tpl_assign('weekly_html', $weekly_html);

	$additional_html = tpl_fetch(get_template_path('weekly_view', 'time_weekly_view', 'advanced_core'));

	$output = array(
		'html' => $additional_html,
		'hide_list_view' => user_config_option('time_list_view') == 'weekly',
	);

}
