-- <?php echo $table_prefix ?> 
-- <?php echo $default_charset ?> DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci
-- <?php echo $default_collation ?> collate utf8_unicode_ci
-- <?php echo $engine ?> InnoDB
-- varchar cannot be larger than 256
-- blob/text cannot have default values
-- sql queries must finish with ;\n (line break inmediately after ;)

ALTER TABLE `<?php echo $table_prefix ?>custom_properties`
ADD COLUMN `total_operation` varchar(50) <?php echo $default_collation ?> NOT NULL DEFAULT '';

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>object_print_options` (
  `object_type_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
  `object_subtype_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
  `option_type` VARCHAR(255) NOT NULL DEFAULT '',
  `property` VARCHAR(255) NOT NULL DEFAULT '',
  `html_content` TEXT NULL,
  `position` VARCHAR(50) NOT NULL DEFAULT 'left',
  `order` int(10) unsigned NOT NULL DEFAULT 0,
  PRIMARY KEY (`object_type_id`, `object_subtype_id`, `option_type`, `property`)
) ENGINE = <?php echo $engine ?>;


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>object_subtype_task_templates` (
  `object_type_id` INTEGER UNSIGNED NOT NULL,
  `object_subtype_id` INTEGER UNSIGNED NOT NULL,
  `task_template_id` INTEGER UNSIGNED NOT NULL,
  PRIMARY KEY (`object_type_id`, `object_subtype_id`, `task_template_id`)
) ENGINE = <?php echo $engine ?>;


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>dimension_content_object_options` (
  `dimension_id` int(11) NOT NULL DEFAULT 0,
  `content_object_type_id` int(11) NOT NULL DEFAULT 0,
  `option` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `value` text COLLATE utf8_unicode_ci,
  PRIMARY KEY (`dimension_id`,`content_object_type_id`,`option`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>member_history` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `type` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
  `property` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
  `action` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
  `value` text COLLATE utf8_unicode_ci NOT NULL,
  `created_by_id` int(11) NOT NULL,
  `created_on` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `member_id_created_on` (`member_id`,`created_on`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>property_groups` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `object_type_id` int(10) NOT NULL DEFAULT 0,
  `name` varchar(255) <?php echo $default_collation ?> NOT NULL DEFAULT '',
  `order` int(10) NOT NULL DEFAULT 0,
  `code` varchar(255) <?php echo $default_collation ?> NOT NULL DEFAULT '',
  `is_system` tinyint(1) NOT NULL DEFAULT 0,
  `alignment` varchar(255) <?php echo $default_collation ?> NOT NULL DEFAULT 'left',
  PRIMARY KEY (`id`),
  KEY `object_type_id_order` (`object_type_id`,`order`),
  KEY `object_type_id_name` (`object_type_id`,`name`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>property_group_properties` (
  `group_id` int(10) NOT NULL DEFAULT 0,
  `property_id` varchar(255) <?php echo $default_collation ?> NOT NULL DEFAULT '',
  `order` int(10) NOT NULL DEFAULT 0,
  `is_inheritable` TINYINT(1) NOT NULL DEFAULT 0,
  PRIMARY KEY (`group_id`,`property_id`),
  KEY `group_id_order` (`group_id`,`order`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>api_searchable_properties` (
  `object_type_id` int(10) unsigned NOT NULL,
  `object_subtype_id` int(10) unsigned NOT NULL,
  `property` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`object_type_id`,`object_subtype_id`,`property`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

ALTER TABLE `<?php echo $table_prefix ?>report_conditions` ADD `group_id` int(10) NOT NULL;


ALTER TABLE `<?php echo $table_prefix ?>system_permissions`
 ADD COLUMN `can_add_timeslots_in_time_tab` TINYINT(1) UNSIGNED NOT NULL DEFAULT 0;

UPDATE `<?php echo $table_prefix ?>system_permissions` SET `can_add_timeslots_in_time_tab`=1 WHERE `permission_group_id` IN (
	SELECT id FROM `<?php echo $table_prefix ?>permission_groups` WHERE `type`='roles' AND `name` IN ('Super Administrator','Administrator','Manager','Executive','Internal Collaborator')
);
UPDATE `<?php echo $table_prefix ?>system_permissions` SET `can_add_timeslots_in_time_tab`=1 WHERE `permission_group_id` IN (
	SELECT permission_group_id FROM `<?php echo $table_prefix ?>contacts` WHERE `user_type` IN (
		SELECT id FROM `<?php echo $table_prefix ?>permission_groups` WHERE `type`='roles' AND `name` IN ('Super Administrator','Administrator','Manager','Executive','Internal Collaborator')
	)
);

ALTER TABLE `<?php echo $table_prefix ?>max_system_permissions`
 ADD COLUMN `can_add_timeslots_in_time_tab` TINYINT(1) UNSIGNED NOT NULL DEFAULT 0;

UPDATE `<?php echo $table_prefix ?>max_system_permissions` SET `can_add_timeslots_in_time_tab`=1 WHERE `permission_group_id` IN (
	SELECT id FROM `<?php echo $table_prefix ?>permission_groups` WHERE `type`='roles' AND `name` IN ('Super Administrator','Administrator','Manager','Executive','Internal Collaborator')
);

ALTER TABLE `<?php echo $table_prefix ?>timeslots`
 ADD COLUMN `ignore_time_start` TINYINT(1) UNSIGNED NOT NULL DEFAULT 0;


-- GENERIC CONTENT OBJECT TEMPLATES

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>cobj_templates` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `description` text,
  `object_type_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `name` (`name`),
  KEY `object_type_id` (`object_type_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>cobj_template_objects` (
  `template_id` int(11) NOT NULL,
  `object_id` int(11) NOT NULL,
  PRIMARY KEY (`template_id`,`object_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>cobj_template_parameters` (
  `template_id` int(11) NOT NULL,
  `parameter_id` int(11) NOT NULL,
  `name` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `type` varchar(255) DEFAULT NULL,
  `required` tinyint(3) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`template_id`,`parameter_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>cobj_template_object_properties` (
  `template_id` int(11) NOT NULL,
  `object_id` int(11) NOT NULL,
  `property` varchar(255) NOT NULL,
  `property_type` varchar(255) DEFAULT NULL,
  `property_value` text,
  PRIMARY KEY (`template_id`,`object_id`,`property`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>cobj_template_object_lines` (
  `template_id` int(11) NOT NULL,
  `object_id` int(11) NOT NULL,
  `line_id` int(11) NOT NULL,
  PRIMARY KEY (`template_id`,`object_id`,`line_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>cobj_template_object_line_values` (
  `template_id` int(11) NOT NULL,
  `object_id` int(11) NOT NULL,
  `line_id` int(11) NOT NULL,
  `line_property` varchar(255) NOT NULL,
  `line_property_value` text,
  PRIMARY KEY (`template_id`,`object_id`,`line_id`,`line_property`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>cobj_template_object_variable_values` (
  `template_id` int(11) NOT NULL,
  `object_id` int(11) NOT NULL,
  `property` varchar(255) NOT NULL,
  `parameter_id` int(11) NOT NULL,
  `value` text,
  PRIMARY KEY (`template_id`,`object_id`,`property`),
  KEY `parameter_id` (`parameter_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

-- END GENERIC CONTENT OBJECT TEMPLATES
