og.advanced_core = {
	
	init: function() {
		if (!og.additional_on_cp_submit_fn) {
			og.additional_on_cp_submit_fn = [];
		}
		og.additional_on_cp_submit_fn.push(og.advanced_core.on_cp_submit_additional_fields);
		
		
		if (!og.after_add_custom_property_row) {
			og.after_add_custom_property_row = [];
		}
		og.after_add_custom_property_row.push(og.advanced_core.after_add_cp_row_additional_fields);

		// allow to use groups in member lists 
		og.member_list_grouping = {
			controller: 'member_grouped_listing',
		  	action: 'listing_grouped'
		}
		
		if (!og.reload_selectors_modify_filter_options_functions) og.reload_selectors_modify_filter_options_functions = [];
		og.reload_selectors_modify_filter_options_functions.push(og.advanced_core.reload_selectors_modify_filter_options);
		
		if (!og.after_member_tree_initial_load_functions) og.after_member_tree_initial_load_functions = [];
		og.after_member_tree_initial_load_functions.push(og.advanced_core.after_member_tree_load_functions);
		
		
		if (!og.member_list_listeners) og.member_list_listeners = {};
		if (!og.member_list_listeners.widthchange) og.member_list_listeners.widthchange = [];
		if (!og.member_list_listeners.columnmoved) og.member_list_listeners.columnmoved = [];
		og.member_list_listeners.widthchange.push(og.advanced_core.on_member_list_widthchange);
		og.member_list_listeners.columnmoved.push(og.advanced_core.on_member_list_columnmove);
		
		// to add custom properties to tasks list order by combo
		if (!og.additional_tasks_list_order_by_fn) og.additional_tasks_list_order_by_fn = [];
		og.additional_tasks_list_order_by_fn.push(og.advanced_core.add_cps_to_tasks_order_by);


		// if there are templates defined then add them to the corresponding listing toolbar
		og.cobj_templates.replace_listing_new_actions();

		// used in generic content object templates
		og.eventManager.addListener('update_template_object_in_form', function(data){
			og.cobj_templates.update_template_object_in_form(data);
		});

		// triggered when we need the user to fill a template parameters form
		og.eventManager.addListener('instantiate_cobj_template_parameters', function(data){
			og.render_modal_form('', {c:'c_obj_template', a:'instantiate_parameters', params: {id: data.template_id}});
		});
	},
	
	add_cps_to_tasks_order_by: function(ordercombo_data) {
		if (og.custom_properties_by_type['task'] && og.custom_properties_by_type['task'].length > 0) {
			for (var i=0; i<og.custom_properties_by_type['task'].length; i++) {
				var cp = og.custom_properties_by_type['task'][i];
				if (cp) {
					ordercombo_data.push(['cp_'+cp.id, cp.name]);
				}
			}
		}
		return ordercombo_data;
	},
	
	on_cp_submit_additional_fields: function(prop, pre_id) {

		prop.property_group = $(pre_id + " #property_group").val();
		
		prop.total_operation = $(pre_id + " #numeric_options #total_operation").val();

		prop.is_inheritable = $(pre_id + " #is_inheritable").attr('checked') == 'checked' ? 1 : 0;
		
		return prop;
	},
	
	after_add_cp_row_additional_fields: function(property, pre_id) {

		$(pre_id + " #numeric_options #total_operation").val(property.total_operation);
		
		$(pre_id + " #property_group").val(property.property_group);
		
	},
	
	after_member_tree_load_functions: function(params) {
		var add_params = params.add_params;
		var data = params.data;
		
		// select the filtered nodes only if the list was really filtered
		if (add_params && add_params.select_filtered_nodes && data.list_was_filtered_by && add_params.node_clicked) {
			if (data.list_was_filtered_by.indexOf(add_params.node_clicked) != -1) {
				for (var i=0; i<data.dimension_members.length; i++) {
					member_selector.add_relation(data.dimension_id, add_params.genid, data.dimension_members[i].id, add_params.show_sel_mem_actions);
				}
			}
		}
	},
	
	reload_selectors_modify_filter_options: function(params, options) {
		var dimension_id = params.dimension_id;
		var dimensions_to_reload_ots = params.dimensions_to_reload_ots;
		var tree = params.tree;
		var genid = params.genid;
		
		// select all filtered members if dimension association is configured to do so
		var sel_filtered_nodes = false;
		var can_remove_autoselected = true;
		if (og.dimension_member_associations[dimension_id]) {
			
			var mem_type = dimensions_to_reload_ots[i];
			if (og.dimension_member_associations[dimension_id][mem_type]) {
				
				for (var k=0; k < og.dimension_member_associations[dimension_id][mem_type].length; k++) {
					var assoc_obj = og.dimension_member_associations[dimension_id][mem_type][k];
					
					if (assoc_obj.assoc_dimension_id == tree.dimensionId) {
						sel_filtered_nodes = parseInt(assoc_obj.config.autoclassify_in_property_member) > 0;
						can_remove_autoselected = parseInt(assoc_obj.config.allow_remove_from_property_member) > 0;
					}
				}
			}
		}
		
		options.select_filtered_nodes = sel_filtered_nodes;
		options.genid = genid;
		options.show_sel_mem_actions = can_remove_autoselected;
		
	},
	
	on_member_list_columnmove: function(manager, oldindex, newindex) {
		if (manager) {
			og.draw_member_list_show_more_links_and_totals(manager);
			
			if (manager.store.reader.jsonData.totals) {
				manager.addTotalsRow(manager.store.reader.jsonData, true);
			}
		}
	},

	on_member_list_widthchange: function(manager, colindex, newwidth) {
		if (manager) {
			og.draw_member_list_show_more_links_and_totals(manager);
		}
	},
	
	copy_member: function(original_member_id) {
		og.openLink(og.getUrl('advanced_member', 'copy_member', {id: original_member_id}), {
			callback: function(success, data) {
				if (success && data.member_id) {
					og.render_modal_form('', {c:'member', a:'edit', params: {id: data.member_id}});
				}
			}
		});
	}
}

og.cobj_templates = {

	replace_listing_new_actions() {

		og.openLink(og.getUrl('c_obj_template', 'get_templates'), {
			silent: true,
			callback: function(success, data) {
				if (success) {


					for (ot_id in data.templates) {
						if (!isNaN(ot_id)) {

							var ot_templates = data.templates[ot_id];
							var template_menu_items = [];

							for (var i=0; i<ot_templates.length; i++) {
								
								var template = ot_templates[i];
	
								var new_template_action = {
									text: template.name,
									iconCls: 'ico-template',
									handler: function() {
										og.openLink(og.getUrl('c_obj_template', 'instantiate', {id: this.id}));
									},
									scope: template
								};

								template_menu_items.push(new_template_action);
							}

							var new_action = new Ext.Action({
								id: 'new_button_' + template.ot_name,
								text: lang('add new ' + template.ot_name),
								tooltip: lang('add new ' + template.ot_name),
								iconCls: 'ico-new new_button',
								handler: function() {
									og.render_modal_form('', {c: template.ot_name, a:'add', params: {req_channel: template.ot_name + ' list - toolbar add'}});
								}
							});

							var menu_items = [new_action, '-'];
							menu_items = menu_items.concat(template_menu_items);

							if (!og.replace_list_new_action) og.replace_list_new_action = {};

							og.replace_list_new_action[template.ot_name] = new Ext.Button({
								iconCls: 'ico-new',
								text: lang('new'),
								id: 'new_menu_' + template.ot_name,
								menu: {
									cls:'scrollable-menu',
									items: menu_items
								}
							});

						}
					}

				}
			}
		});

	},


	update_template_object_in_form : function(data) {
		
		let object_data = data.object_data;
		let idx = object_data.idx;
		let name = object_data.name;

		// set the line's id
		let obj_container_id = og.cobj_templates.genid + 'template_object_' + idx;
		let container_id = og.cobj_templates.genid + 'template_objects';
		
		// get the "template html" for the object line to add in the form
		let line_html = $("#" + og.cobj_templates.genid + "object_line_container_generic").html();
		line_html = line_html.replace(/{idx}/g, idx);
		

		// append/update the new html for the object
		if ($("#" + obj_container_id).length == 0) {
			$("#" + container_id).append(line_html);
		} else {
			//$("#" + obj_container_id).replaceWith(line_html);
			// update name
			$("#" + obj_container_id + " .template-obj-name").html(name);
			// store all object properties
			let obj_properties = {properties: object_data};
			let json_data = Ext.util.JSON.encode(obj_properties);
			$("#" + obj_container_id + " .template-object-data-input").val(btoa(json_data));

			return;
		}
		// background class for the object
		if ($(".template-object").length % 2 == 0) {
			$("#" + obj_container_id).addClass('altRow');
		}

		// on edit icon click
		$("#" + obj_container_id + " .edit-template-object").click(function() {
			let encoded_data = $("#" + obj_container_id + " .template-object-data-input").val();
			let url = og.cobj_templates.add_url.replace(/obj_index/, idx);
			url = url.replace(/obj_data/, "'" + encoded_data + "'");
			eval(url);
		});

		// on delete icon click
		$("#" + obj_container_id + " .delete-template-object").click(function() {
			$("#" + obj_container_id).remove();
		});

		// on edit variables click (show/hide the variables section for the object)
		$("#" + obj_container_id + " .vars-template-object").click(function() {
			if ($("#" + obj_container_id + " .template-object-vars-container").is(":visible")) {
				$(this).addClass("toggle_collapsed").removeClass("toggle_expanded");
				$("#" + obj_container_id + " .template-object-vars-container").hide();
			} else {
				$(this).addClass("toggle_expanded").removeClass("toggle_collapsed");
				$("#" + obj_container_id + " .template-object-vars-container").show();
			}
		});

		// on add new variable
		$("#" + obj_container_id + " .add-template-variable-link").click(function() {
			og.cobj_templates.add_new_template_variable(idx);
		});
		

		// fill object name to show in form
		$("#" + obj_container_id + " .template-obj-name").html(name);

		// store all object properties
		let obj_properties = {properties: object_data};
		let json_data = Ext.util.JSON.encode(obj_properties);
		$("#" + obj_container_id + " .template-object-data-input").val(btoa(json_data));

		// set the next index to use
		var last_id = parseInt(idx);
		if (og.cobj_templates.last_object_index <= last_id) {
			og.cobj_templates.last_object_index = last_id + 1;
		}

	},
	
	// function to draw the html of a new or an edited parameter
	update_template_parameter_in_form : function(idx, name, type) {

		// parameter id
		let param_container_id = og.cobj_templates.genid + 'template_parameter_' + idx;
		let container_id = og.cobj_templates.genid + 'template_parameters';

		// get the previous parameter name
		var prev_param_name = $("#" + param_container_id + " .template-parameter-name-input").val();

		// get the "template html" for the parameter to add it to the form
		let line_html = $("#" + og.cobj_templates.genid + "parameter_container_generic").html();
		line_html = line_html.replace(/{idx}/g, idx);

		// append/update the new html for the parameter
		if ($("#" + param_container_id).length == 0) {
			$("#" + container_id).append(line_html);
		} else {
			$("#" + param_container_id).replaceWith(line_html);
		}
		// backgroupnd class
		if ($(".template-parameter").length % 2 == 0) {
			$("#" + param_container_id).addClass('altRow');
		}

		// local store for params
		og.templateParameters.push({
			id: idx,
			name: name,
			type: type
		});

		// on edit parameter click
		$("#" + param_container_id + " .edit-template-parameter").click(function() {
			
			var config = {
				ok_function: og.cobj_templates.update_template_parameter_in_form,
				prev_name: name,
				prev_type: type
			}
			og.promptAddParameter(null, 1, idx, config);

		});

		// on delete paramater click
		$("#" + param_container_id + " .delete-template-parameter").click(function() {
			var to_remove = -1;
			for(var j=0; j < og.templateParameters.length; j++){
				if(og.templateParameters[j].id == idx){
					to_remove = j;
					break;
				}
			}
			if (to_remove > -1) {
				og.templateParameters.splice(to_remove, 1);
			}
			$("#" + param_container_id).remove();
		});

		// set the text to show after parameter is added
		$("#" + param_container_id + " .template-parameter-name").html(name + ' (' + type + ')');

		// save the parameter values
		$("#" + param_container_id + " .template-parameter-name-input").val(name);
		$("#" + param_container_id + " .template-parameter-type-input").val(type);

		// if editing parameter then update the text variables that have use parameter to show the new name
		if (type.toUpperCase() == 'STRING' && prev_param_name) {
			$("#"+ og.cobj_templates.genid +"template_objects .string-var").each(function() {
				var text = $(this).val();
				while (text.indexOf('{'+prev_param_name+'}') >= 0) {
					text = text.replace('{'+prev_param_name+'}', '{'+name+'}');
				}
				$(this).val(text);
			});
		}

	},


	// function that adds a new parameter to the template form
	add_new_template_parameter : function() {

		og.cobj_templates.last_parameter_index++;

		var pos = og.cobj_templates.last_parameter_index;
		var config = {
			ok_function: og.cobj_templates.update_template_parameter_in_form
		}
		og.promptAddParameter(null, 0, pos, config);

	},


	// for text variables we want to show the parameter names in the content, but the controller must receive the parameter id
	// so we have to replace the names with the ids
	replace_parameter_names : function() {

		for (i=0; i<og.templateParameters.length; i++) {
			var parameter = og.templateParameters[i];
			if (parameter.type.toUpperCase() == 'STRING') {
				$("#"+ og.cobj_templates.genid +"template_objects .string-var").each(function() {
					
					var text = $(this).val();
					while (text.indexOf('{'+parameter.name+'}') >= 0) {
						text = text.replace('{'+parameter.name+'}', '{'+parameter.id+'}');
					}
					
					$(this).val(text);
				});
			}
		}
	},


	// function to draw the html of a new or an edited parameter
	update_template_variable_in_form : function(obj_idx, var_idx, data) {

		// parameter id
		let obj_container_id = og.cobj_templates.genid + 'template_object_' + obj_idx;
		let var_container_id = og.cobj_templates.genid + 'template_var_' + obj_idx + '_' + var_idx;

		// get the "template html" for the parameter to add it to the form
		let sel_html = $("#" + og.cobj_templates.genid + "var_selector_container_generic").html();
		sel_html = sel_html.replace(/{obj_idx}/g, obj_idx);
		sel_html = sel_html.replace(/{var_idx}/g, var_idx);

		// append/update the new html for the parameter
		$("#" + obj_container_id + " .template-object-vars").append(sel_html);
		
		// backgroupnd class
		if ($("#" + obj_container_id + " .template-object-vars").length % 2 == 0) {
			$("#" + obj_container_id + " .template-object-vars").addClass('altRow');
		}

		/************************************** 
		 * IMPORTANT
		 * If object type is 'Expense' Add line properties: quantity, unit cost, unit price, details, date
		 * FOR EACH PRODUCT TYPE DEFINED IN THE EXPENSE
		******************************************/
		if (og.cobj_templates.ot_name == 'expense') {
			// get current object lines
			var expense = Ext.util.JSON.decode(atob($("#" + obj_container_id + " .template-object-data-input").val()));
			if (expense && expense.properties && expense.properties.lines) {
				for (var i=0; i<expense.properties.lines.length; i++) {
					let line_id = i+1;
					var line = expense.properties.lines[i];
					
					var pt = og.cobj_templates.product_types[parseInt(line.product_type_id)];
					if (pt) {
						let name_start = pt.name + ' (' + lang('item') + ' ' + line_id + ')';
						line_vars = [
							{property: 'unit_cost', type: 'float', text: name_start + ' - ' + lang('unit_cost')},
							{property: 'unit_price', type: 'float', text: name_start + ' - ' + lang('unit_price')},
							{property: 'quantity', type: 'float', text: name_start + ' - ' + lang('quantity')},
							{property: 'date', type: 'date', text: name_start + ' - ' + lang('date')},
							{property: 'description', type: 'string', text: name_start + ' - ' + lang('description')},
						];
						for (var j=0; j<line_vars.length; j++) {
							var prop_selector_key = 'line-' + line_id + '-' + pt.id + '-' + line_vars[j].property;

							// add the template variables array
							og.cobj_templates.properties_for_variables[prop_selector_key] = line_vars[j];

							// append options to the selector
							$("#" + var_container_id + " .property-selector").append('<option value="'+prop_selector_key+'">' + line_vars[j].text + '</option>');
						}
					}
				}
			}
		}
		
		// on property change
		$("#"+ var_container_id +" .property-selector").change(function() {
		
			var container = $("#" + obj_container_id + " #"+ var_container_id +" .variable-definition");
			var property_sel = $(this).val();

			og.cobj_templates.on_variable_property_select(container, obj_idx, var_idx, property_sel);

		});

		if (data) {
			var container = $("#" + obj_container_id + " #"+ var_container_id +" .variable-definition");
			og.cobj_templates.on_variable_property_select(container, obj_idx, var_idx, data.property, data);
		}

		// on delete click
		$("#" + obj_container_id + " #"+ var_container_id +" .delete-template-variable").click(function() {
			$("#" + obj_container_id + " #"+ var_container_id).remove();
		});


	},


	on_variable_property_select : function(container, obj_idx, var_idx, property, data) {
		var property_obj = og.cobj_templates.properties_for_variables[property];
		if (!property_obj) {
			return;
		}
		var type = property_obj.type;

		if (type.toUpperCase() == 'STRING') {

			og.cobj_templates.draw_string_variable_input(container, obj_idx, var_idx, data);

		} else if (type.toUpperCase() == 'DATE' || type.toUpperCase() == 'DATETIME') {

			og.cobj_templates.draw_date_variable_input(container, obj_idx, var_idx, data);

		} else if (type.toUpperCase() == 'NUMERIC' || type.toUpperCase() == 'FLOAT' || type.toUpperCase() == 'INTEGER') {

			og.cobj_templates.draw_numeric_variable_input(container, obj_idx, var_idx, data);
		}
		
	},


	draw_string_variable_input : function(container, obj_idx, var_idx, data) {
		var value = data ? data.value : '';

		// replace parameter ids with parameter names
		if (value != '') {
			for (i=0; i<og.templateParameters.length; i++) {
				var parameter = og.templateParameters[i];
				if (parameter.type.toUpperCase() == 'STRING') {
					while (value.indexOf('{'+parameter.id+'}') >= 0) {
						value = value.replace('{'+parameter.id+'}', '{'+parameter.name+'}');
					}
				}
			}
		}

		// create input
		var html = '<textarea id="template_variable_'+obj_idx+'_'+var_idx+'" name="template[variables]['+obj_idx+']['+var_idx+'][value]" class="string-var">'+value+'</textarea>';
		html += '<a href="#" onclick="og.editStringTemplateObjectProperty(' + obj_idx + ',\'' + value + '\',\'template_variable_'+obj_idx+'_'+var_idx+'\')">[' + lang('open property editor') + ']</a>';

		// parameter type
		html += '<input type="hidden" name="template[variables]['+obj_idx+']['+var_idx+'][type]" value="STRING" />';

		// append inputs
		$(container).html(html);

		if (data) {
			$('#template_variable_'+obj_idx+'_'+var_idx+'_property').val(data.property);
		}
	},


	draw_date_variable_input : function(container, obj_idx, var_idx, data) {
		
		$(container).html('');
		
		selectParam = '<select name="template[variables]['+obj_idx+']['+var_idx+'][param]" id="template_variable_'+obj_idx+'_'+var_idx+'_param" '+
			'onchange="og.datePropertyTypeSelOnChange(this,\''+obj_idx+'\',\''+var_idx+'\');">';
		
		for(var j=0; j < og.templateParameters.length; j++){
			var item = og.templateParameters[j];
			if (item.type.toUpperCase() == 'DATE' || item.type.toUpperCase() == 'DATETIME') {
				selectParam += '<option value="'+ item['id'] +'">' + item['name'] + '</option>';
			}
		}
		selectParam += '<option value="object_creation">' + lang('date of creation') + '</option>';
		selectParam += '</select>';

		var type_input = '<input type="hidden" name="template[variables]['+obj_idx+']['+var_idx+'][type]" value="DATE" />';

		var html = type_input + selectParam + '&nbsp;'+
			'<select name="template[variables]['+obj_idx+']['+var_idx+'][operation]" id="template_variable_'+obj_idx+'_'+var_idx+'_operation">' +
				'<option>+</option>'+
				'<option>-</option>'+
			'</select>&nbsp;';

		var amount_html = '<input name="template[variables]['+obj_idx+']['+var_idx+'][amount]" id="template_variable_'+obj_idx+'_'+var_idx+'_amount" style="width:50px;" type="number" step="any" />';

		html += amount_html;

		html += '&nbsp;<select name="template[variables]['+obj_idx+']['+var_idx+'][unit]" id="template_variable_'+obj_idx+'_'+var_idx+'_unit">' + 
			'<option value="i">'+ lang('minutes') + '</option>'+
			'<option value="d" selected="selected">'+ lang('days') + '</option>' +
			'<option value="w">'+ lang('weeks') + '</option>'+
			'<option value="m">'+ lang('months') + '</option>'+
		'</select>';
		
		$(container).html(html);

		if (data) {
			if (data.param) {
				$('#template_variable_'+obj_idx+'_'+var_idx+'_param').val(data.param);
			}
			if (data.operation) {
				$('#template_variable_'+obj_idx+'_'+var_idx+'_operation').val(data.operation);
			}
			if (data.amount) {
				$('#template_variable_'+obj_idx+'_'+var_idx+'_amount').val(data.amount);
			}
			if (data.unit) {
				$('#template_variable_'+obj_idx+'_'+var_idx+'_unit').val(data.unit);
			}
			if (data.property) {
				$('#template_variable_'+obj_idx+'_'+var_idx+'_property').val(data.property);
			}
		}
		
	},



	draw_numeric_variable_input : function(container, obj_id, var_idx, data) {
	
		$(container).html('');
	
		var value = data ? data.value : '';
	
		var html = '<input type="hidden" name="template[variables]['+obj_id+']['+var_idx+'][type]" value="NUMERIC" />';
	
		if (value == '') {
			html += og.cobj_templates.get_numeric_formula_term_html(var_idx, obj_id, 0, '', '');
		} else {
	
			var terms = [];
			var term_ops = [];
			var splitted = value.split('|');
			var unit = '';
			for (var i=0; i<splitted.length; i++) {
				var part = splitted[i];
	
				if (part.indexOf('unit=') == 0) {
	
					unit = part.replace("unit=", "");
	
				} else {
	
					if (part == '+' || part == '-' || part == '*' || part == '/' || part == 'stop') {
						term_ops.push(part);
					} else {
						terms.push(part);
					}
				}
			}
	
			for (var i=0; i<terms.length; i++) {
				var term = terms[i];
				var term_op = term_ops[i];
				
				html += og.cobj_templates.get_numeric_formula_term_html(var_idx, obj_id, i, term, term_op);
			}
		}
	
		/*var propertySel = document.getElementById('objectProperties[' + obj_id + '][' + var_idx + ']');
		var prop = propertySel[propertySel.selectedIndex].value;
		if (prop == 'time_estimate') {
			if (!unit) unit = 'h';
	
			html += '&nbsp;' + lang('unit') + ': ';
			html += og.buildTimeUnitSelectorHtml(obj_id, prop, unit, 'propValueUnit');
		}*/
	
		$(container).html(html);
	
		if (data) {
			if (data.property) {
				$('#template_variable_'+obj_id+'_'+var_idx+'_property').val(data.property);
			}
		}
	
	},
	
	
	
	get_numeric_formula_term_html : function(var_idx, obj_id, term_index, term_value, next_operator) {
	
		var html = '<span id="formulaTerm_'+ var_idx +'_'+ obj_id +'_'+ term_index +'">';
	
		var param = '';
		var operator = '';
		var amount = '';
	
		if (term_value != '') {
			var op_start_pos = term_value.indexOf('}') + 1;
			var op_end_pos = op_start_pos + 1;
	
			param = term_value.substring(0, op_start_pos);
			operator = term_value.substring(op_start_pos, op_end_pos);
			amount = term_value.substring(op_end_pos);
		}
	
		// numeric variable selector
		var selectParam = '<select name="template[variables][' + obj_id + '][' + var_idx + '][num_formula]['+ term_index +'][param]" id="propValueParam[' + obj_id + '][' + var_idx + '][num_formula]['+ term_index +']"'
			+ ' onchange="og.cobj_templates.on_term_var_selector_change(this, \''+obj_id+'\', \''+var_idx+'\', \''+term_index+'\')">';
	
		// options for template variables
		for (var j=0; j < og.templateParameters.length; j++) {
			var item = og.templateParameters[j];
			if (item.type.toUpperCase() == "NUMERIC") {
				var param_selected = param == '{'+item['id']+'}' ? 'selected="selected"' : '';
				selectParam += '<option value="'+ item['id'] +'" '+ param_selected +'>' + item['name'] + '</option>';
			}
		}
	
		// option for fixed number
		param_selected = param == '{_fixed_num_}' ? 'selected="selected"' : '';
		selectParam += '<option value="_fixed_num_" '+ param_selected +'>' + lang('fixed num') + '</option>';
		selectParam += '</select>';
	
		html += '(' + selectParam + '&nbsp;';
	
		// operator
		html += '<select name="template[variables][' + obj_id + '][' + var_idx + '][num_formula]['+ term_index +'][operation]" id="propValueOperation[' + obj_id + '][' + var_idx + '][num_formula]['+ term_index +']"'
			+ (param == '{_fixed_num_}' ? 'style="display:none;"' : '') + '>' +
			'<option value="+" '+ (operator == "+" ? 'selected="selected"' : '') +'>+</option>' +
			'<option value="-" '+ (operator == "-" ? 'selected="selected"' : '') +'>-</option>' +
			'<option value="*" '+ (operator == "*" ? 'selected="selected"' : '') +'>*</option>' +
			'<option value="/" '+ (operator == "/" ? 'selected="selected"' : '') +'>/</option>' +
		'</select>&nbsp;';
	
		// numeric input
		html += '<input type="number" step="any" name="template[variables][' + obj_id + '][' + var_idx + '][num_formula]['+ term_index +'][amount]" id="propValueAmount[' + obj_id + '][' + var_idx + '][num_formula]['+ term_index +']" style="width:50px;" value="'+amount+'"/>';
	
		html += ')&nbsp;';
	
		// term operator "+", "-" or "stop"
		if (!next_operator) next_operator = "stop";
		html += '<select name="template[variables][' + obj_id + '][' + var_idx + '][num_formula]['+ term_index +'][term_operation]" ' +
			'id="propValueTermOperation[' + obj_id + '][' + var_idx + '][num_formula]['+ term_index +']" ' +
			'onchange="og.cobj_templates.on_term_operator_change(this, '+var_idx+', '+obj_id+', '+term_index+')">' +
	
			'<option value="+" '+ (next_operator == "+" ? 'selected="selected"' : '') +'>+</option>' +
			'<option value="-" '+ (next_operator == "-" ? 'selected="selected"' : '') +'>-</option>' +
			'<option value="*" '+ (next_operator == "*" ? 'selected="selected"' : '') +'>*</option>' +
			'<option value="/" '+ (next_operator == "/" ? 'selected="selected"' : '') +'>/</option>' +
			'<option value="stop" '+ (next_operator == "stop" ? 'selected="selected"' : '') +'>'+ lang('stop') +'</option>' +
		'</select>&nbsp;';
	
		html += '</span>';
	
		return html;
	},

	
	on_term_var_selector_change : function(input, obj_id, prop, term_index) {
		var term_oper_input = document.getElementById('propValueOperation[' + obj_id + '][' + prop + '][num_formula]['+ term_index +']');
		if (!term_oper_input) return;
	
		if ($(input).val() == '_fixed_num_') {
			$(term_oper_input).hide();
		} else {
			$(term_oper_input).show();
		}
	},
	
	
	/**
	* if selected value is + or - then draw next term (if not exists)
	* else remove all terms with index > term_index
	*/
	on_term_operator_change : function(selector, var_idx, obj_id, term_index) {
	
		if ($(selector).val() == 'stop') {
	
			og.cobj_templates.remove_next_terms(var_idx, obj_id, term_index + 1);
	
		} else {
	
			var next_term_index = term_index + 1;
			var next_term_id = 'formulaTerm_'+ var_idx +'_'+ obj_id +'_'+ next_term_index;
	
			if ($("#" + next_term_id).length == 0) {
				
				var next_term_html = og.cobj_templates.get_numeric_formula_term_html(var_idx, obj_id, next_term_index, '', '');
	
				var current_term_id = 'formulaTerm_'+ var_idx +'_'+ obj_id +'_'+ term_index;
				$("#" + current_term_id).after(next_term_html);
			}
	
		}
		
	},

	
	remove_next_terms : function(var_idx, obj_id, term_index) {
	
		var term_id = 'formulaTerm_'+ var_idx +'_'+ obj_id +'_'+ term_index;
		var element = document.getElementById(term_id);
		if (element) {
			element.remove();
			og.cobj_templates.remove_next_terms(var_idx, obj_id, term_index + 1);
		}
	
	},



	// function that adds a new parameter to the template form
	add_new_template_variable : function(obj_idx, data) {

		if (typeof og.cobj_templates.last_variable_index[obj_idx] == 'undefined') {
			og.cobj_templates.last_variable_index[obj_idx] = 0;
		}
		
		og.cobj_templates.last_variable_index[obj_idx] = og.cobj_templates.last_variable_index[obj_idx] + 1;

		var obj_var_idx = og.cobj_templates.last_variable_index[obj_idx];

		og.cobj_templates.update_template_variable_in_form(obj_idx, obj_var_idx, data);

	},

}


// add function to insert totals row to grid panels
Ext.grid.GridPanel.override({
	addTotalsRow: function (d, dont_scroll) {
		if (d.totals) {
			var scroll_state = this.view.getScrollState();

			// remove previous total row if exists
			var prev_total_row = this.store.getById('#__total_row__');
			if (prev_total_row) {
				this.store.remove(prev_total_row);
			}

			// create grid record and add it to the store
			d.totals.groupId = -1;
			var record = new Ext.data.Record(d.totals, "#__total_row__");
			this.store.add([record]);
			
			// add specific class for totals
			$("#"+this.id+" #__total_row__").closest('tr').addClass('list-totals-row');
			$("#"+this.id+" #__total_row__").closest('div.x-grid3-row').addClass('list-totals-row-container');

			var v = this.getView();
			if (v.forceFit) {
				var trb = $("#"+this.id+ " .x-panel-bbar").outerHeight() + $("#footer").outerHeight() + 1;
				$("#"+this.id+" .list-totals-row-container").css('position', 'fixed').css('bottom', trb+'px');
			}

			// if grouping then move totals row outside the groups
			if (v.enableGrouping) {
				// get new parent
				var new_parent = $("#"+this.id+" .list-totals-row-container").closest(".x-grid3-body");
				// remove totals container element
				var totals_row_container = $("#"+this.id+" .list-totals-row-container").detach();
				// append childs with group classes to avoid ext js generating errors when getting childs
				totals_row_container.append('<div class="x-grid-group-body" style="display:none;"></div><div class="x-grid-group-hd" style="display:none;">');
				// insert totals container in the new parent
				new_parent.append(totals_row_container);
			}
			
			var man_id = this.id;
			setTimeout(function() {
				// hide group for the totals row
				var rcount = $("#"+ man_id +" #__total_row__").closest(".x-grid-group").children(".x-grid-group-body").children().length;
				if (rcount <= 1) {
					$("#"+ man_id +" #__total_row__").closest(".x-grid-group").children(".x-grid-group-hd").hide();
				}
				
				// scroll list to top
				if (!dont_scroll) {
					Ext.getCmp(man_id).view.restoreScroll(scroll_state);
				}
			}, 1);
		}
	}
});

// add totals row after loading data in grids
og.eventManager.addListener('after grid panel load', function(data){
	var manager = data.man;
	var d = data.data;
	if (manager && d.totals) {
		manager.addTotalsRow(d);
	}
	
	if (og.member_list_grouping) {
		og.draw_member_list_show_more_links_and_totals(manager);
	}
	
});

og.printOptionsAddPropertyToSection = function(add_link, genid) {

	var select_html = $("#"+genid+"_property_selectbox_template").html().replace(genid+"_property_selector", genid+"_current_prop_sel");
	var div = document.createElement('div');
	div.innerHTML = '<div style="border-radius: 5px; background-color: #fff; padding: 10px; width: 400px;">'+
		'<div><label class="coInputTitle">'+lang('select property')+'</label></div>'+
		'<div id="'+genid+'_property">'+ select_html +'</div>'+
		'<div id="'+genid+'_buttons">'+
		'<button class="yes submit blue">'+lang('add property')+'</button><button class="no submit blue">'+lang('cancel')+'</button>'+
		'</div><div class="clear"></div></div>';

	var modal_params = {
		'escClose': false,
		'overlayClose': false,
		'closeHTML': '<a id="'+genid+'_close_link" class="modal-close" title="'+lang('close')+'"></a>',
		'onShow': function (dialog) {
			$("#"+genid+"_close_link").addClass("modal-close-img");
			$("#"+genid+"_buttons").css('text-align', 'right').css('margin', '10px 0');
			$("#"+genid+"_property").css('margin', '10px 0');
			
			$("#"+genid+"_buttons button.yes").css('margin-right', '10px').click(function() {
				
				var container = $(add_link).closest(".position").children(".position-values").first();
				var prop_id = $("#"+genid+"_current_prop_sel").val();
				var prop_name = $("#"+genid+'_current_prop_sel option[value="'+prop_id+'"]').html();

				// don't add it twice
				if ($("#"+genid+"_print_options #prop-"+prop_id).length == 0) {
					var html_to_add = '<div id="prop-'+prop_id+'" class="property">' + prop_name + '</div>';
					$(container).append(html_to_add);
				}
				
				$('.modal-close').click();
			});
			$("#"+genid+"_buttons button.no").css('margin-right', '10px').click(function(){
				$('.modal-close').click();
			});
	    }
	};
	setTimeout(function() {
		$.modal(div, modal_params);
	}, 100);
}


og.saveObjectPrintOptions = function(genid) {
	var options = [];
	var sections = ['top','left','right','bottom'];
	
	for (var i=0; i<sections.length; i++) {
		var section = sections[i]+"";
		var op_divs = $(".position-values."+section+" .property");
		
		for (var j=0; j<op_divs.length; j++) {
			var propid = $(op_divs[j]).attr('id').replace('prop-','');
			var op = {id:propid, position:section};
			options.push(op);
		}
	}

	var heditor = og.getCkEditorInstance(genid + '_header_editor');
	var feditor = og.getCkEditorInstance(genid + '_footer_editor');

	og.openLink(og.getUrl('object_print_options', 'save_print_options'), {
		post: {
			object_type_id: $("#"+genid+"_ot_id").val(),
			subtype_id: $("#"+genid+"_sub_ot_id").val(),
			header: heditor.getData(),
			footer: feditor.getData(),
			options: Ext.util.JSON.encode(options)
		}
	});
}





og.load_more_member_list_rows = function(dimension_id, object_type_id, group_id, row_index) {
	var man = Ext.getCmp('member-manager-'+dimension_id+'-'+object_type_id);
	
	var parameters = {};
	for (var k in man.store.lastOptions.params) {
		parameters[k] = man.store.lastOptions.params[k];
	}
	parameters.filter_by_group = group_id;
	
	
	var g_index = man.store.groups_info.groups_order.indexOf(group_id.toString());
	var view_groups = man.getView().getGroups();
	var g_elem = view_groups[g_index];
	var g_rows = g_elem.childNodes[1].childNodes;
	
	parameters.group_offset = g_rows.length;
	//parameters.group_limit = man.store.groups_info.max_per_group;
	
	og.openLink(og.getUrl('member_grouped_listing', 'listing_grouped'),{
		preventPanelLoad: true,
		post: parameters,
		callback: function(success, data){
			
			if (data.members && data.members.length > 0) {
				var records = [];
				for (var i=0; i<data.members.length; i++) {
					var mdata = data.members[i];
					var record = new Ext.data.Record(mdata);
					records.push(record);
				}
				records.reverse();
				man.store.insert(row_index, records);

				if (data.totals) {
					man.addTotalsRow(data, true);
				}
				
				og.draw_member_list_show_more_links_and_totals(man);
				
				og.eventManager.fireEvent('replace all empty breadcrumb', null);
			}
		}
	});
}

og.draw_member_list_show_more_links_and_totals = function(man) {
	if (!man || !man.store || !man.store.groups_info) return;
	
	var row_index = 0;
	var view_groups = man.getView().getGroups();
	var totals_row_found = false;
	var index = 0;
	var gcount = 0;
	var group_totals = {};
	
	for (i=0; i<view_groups.length; i++) {
		
		var g_elem = view_groups[i];
		if (!$(g_elem).attr('id') || $(g_elem).attr('id').indexOf('-undefined') > 0) continue;
		
		var g_rows = g_elem.childNodes[1].childNodes;
		row_index += g_rows.length;
		
		if ($(g_rows).children('.list-totals-row-container').length > 0) {
			totals_row_found = true;
			continue;
		}
		index = totals_row_found ? (i-1) : i;
		
		var gid = parseInt(man.store.groups_info.groups_order[index]);
		if (isNaN(gid)) gid=""; // none group
		
		var ginfo = man.store.groups_info.groups[gid];
		if (!ginfo) continue;
		
		gcount++;

		// add totals row - with show more link
		if (man.store.groups_info.group_totals && man.store.groups_info.group_totals[gid]) {
			var gtotals = man.store.groups_info.group_totals[gid];
			if (!g_rows.length) continue;
			
			// html row template
			var row_template_html = g_rows[0].innerHTML;
			
			$("#__group_total_row_"+gid).remove();
			
			// create new element
			var gtotal_div = document.createElement('div');
			$(gtotal_div).attr('id', "__group_total_row_"+gid);
			$(gtotal_div).addClass('x-grid3-row list-group-total-row');
			$(gtotal_div).html(row_template_html);
			
			// append element to the body
			$(g_elem).children(".x-grid-group-body").after(gtotal_div);
			
			// clean template contents
			$("#__group_total_row_"+gid+" .x-grid3-cell-inner").html('');

			// assign total values to each cell
			for (x in gtotals) {
				if (typeof(gtotals[x])=='function') continue;
				let elem = $("#__group_total_row_"+gid+" .x-grid3-td-"+x+" .x-grid3-cell-inner");
				if(elem.length == 0) {
					elem = $("#__group_total_row_"+gid+" .x-grid3-td-mem_type_col_"+x+" .x-grid3-cell-inner");
				}
				elem.html(gtotals[x]);
			}
			
			var name_text = gtotals.name;
			if (gtotals.total_rows > g_rows.length && g_rows.length>0) {
				name_text = lang('showing x of y', g_rows.length + ' ' + (og.objectTypes[man.object_type_id].c_name_plural).toLowerCase(), gtotals.total_rows);
				name_text += "<span class='show-more-link-container'>"
					+ "<a href='#' onclick='og.load_more_member_list_rows(\""+man.store.dimension_id+"\",\""+man.store.object_type_id+"\",\""+gid+"\",\""+row_index+"\");'>"
					+ ((ginfo.count - g_rows.length > og.config['files_per_page']) ? lang('show more') : lang('show all'))
					+ "</a></span>";
			}
			$("#__group_total_row_"+gid+" .x-grid3-td-name .x-grid3-cell-inner").html(name_text);
		}
		
	}
	
	// change bottom toolbar text
	var label = lang("showing x groups", gcount);
	if (man.store.groups_info.groups_order.length < og.config['files_per_page']) {
		label = lang("showing x groups of y", gcount, man.store.groups_info.groups_order.length);
	}
	man.getBottomToolbar().items.map.showing_x_groups.setText(label);
	
	// show/hide load more groups button
	if (gcount < man.store.groups_info.groups_order.length) {
		$("#"+man.id+" #load_more_groups_btn").show();
	} else {
		$("#"+man.id+" #load_more_groups_btn").hide();
	}
	
	// set toolbar groupby and sort hints
	og.set_member_list_gb_hint(man);
	og.set_member_list_sort_hint(man);
}

og.set_member_list_gb_hint = function(man) {
	
	var elem = man.getColumnModel().lookup[man.store.groupField];
	if (!elem) {
		elem = man.getColumnModel().lookup['mem_type_col_' + man.store.groupField];
	}
	if (!elem) return;
	
	var gb_criteria = elem.header;

	var gb_hint = $("#"+man.getTopToolbar().id+" #grouping_by_hint");
	if (!gb_hint || gb_hint.length==0) {
		man.getTopToolbar().add('->', {
			text: lang("grouped by", gb_criteria),
			id: "grouping_by_hint",
			xtype: "button"
		});
		
		og.member_list_toolbar_item_popover("#"+man.getTopToolbar().id+" #grouping_by_hint", lang('list toolbar group by help'));
		
	} else {
		$("#"+man.getTopToolbar().id+" #grouping_by_hint button.x-btn-text").html(lang("grouped by", gb_criteria));
	}
}

og.set_member_list_sort_hint = function(man) {
	
	var elem = man.getColumnModel().lookup[man.store.sortInfo.field];
	if (!elem) {
		elem = man.getColumnModel().lookup['mem_type_col_' + man.store.sortInfo.field];
	}
	if (!elem) return;
	
	var sort_criteria = elem.header;

	var gb_hint = $("#"+man.getTopToolbar().id+" #sort_by_hint");
	if (!gb_hint || gb_hint.length==0) {
		man.getTopToolbar().add('|', {
			text: lang("sorted by x", sort_criteria),
			id: "sort_by_hint",
			xtype: "button"
		});
		
		og.member_list_toolbar_item_popover("#"+man.getTopToolbar().id+" #sort_by_hint", lang('list toolbar sort by help'));
		
	} else {
		$("#"+man.getTopToolbar().id+" #sort_by_hint button.x-btn-text").html(lang("sorted by x", sort_criteria));
	}
}

og.member_list_toolbar_item_popover = function(selector, text) {
	$(selector).popover({
		content: '<div class="list-tbar-popover-hint">'+ text +'</div>',
		delay: { show: "100", hide: "200" },
		html: true,
		container: 'body',
    	placement: 'auto',
		trigger: 'hover'
	});
}


og.load_more_member_list_groups = function(man) {
	
	var parameters = {};
	for (var k in man.store.lastOptions.params) {
		parameters[k] = man.store.lastOptions.params[k];
	}
	
	var view_groups = man.getView().getGroups();
	var group_count = view_groups.length - 1;
	
	parameters.group_list_offset = group_count;
	
	og.openLink(og.getUrl('member_grouped_listing', 'listing_grouped'),{
		preventPanelLoad: true,
		post: parameters,
		callback: function(success, data){
			
			if (data.members && data.members.length > 0) {				
				var records = [];
				for (var i=0; i<data.members.length; i++) {
					var mdata = data.members[i];
					var record = new Ext.data.Record(mdata);
					records.push(record);
				}
				man.store.add(records);

				if (data.totals) {
					man.addTotalsRow(data, true);
				}
				
				og.draw_member_list_show_more_links_and_totals(man);

				og.eventManager.fireEvent('replace all empty breadcrumb', null);
				
			}
		}
	});
}






// show hide member selectors for object type
og.on_show_hide_dim_selector_change = function(genid, dim_id, ot_id, checkbox) {
	var is_checked = $(checkbox).attr('checked') == 'checked';
	$("#"+genid+"show_dim_selector_"+dim_id+"_"+ot_id).val(is_checked);
}

//show hide member selectors for all object types
og.on_show_hide_dim_selector_change_all_ots = function(genid, dim_id) {

	var first = true;
	for (var ot_id in og.objectTypes) {
		var ot = og.objectTypes[ot_id];
		if (ot.type == "dimension_object" || ot.type == "dimension_group") continue;

		var checkbox = $("#"+genid+"show_dim_selector_checkbox_"+dim_id+"_"+ot_id);
		if (checkbox) {
			if (first) {
				var was_checked = $(checkbox).attr('checked') == 'checked';
				first = false;
			}
			
			if (was_checked) {
				$(checkbox).removeAttr('checked');
			} else {
				$(checkbox).attr('checked', 'checked');
			}
			$("#"+genid+"show_dim_selector_"+dim_id+"_"+ot_id).val(!was_checked);
		}
	}
}


og.addAdvancedReminder = function(parent, context, type, duration, duration_type, for_subscribers, button, date_reminder, type_object=null) {
	var count = parent.getElementsByTagName("div").length;
	var div = document.createElement("div");
	var html = '<select name="reminder_type[' + context + '][' + count + ']">';
	for (var i=0; i < og.reminderTypes.length; i++) {
		html += '<option value="' + og.reminderTypes[i] + '"';
		if (og.reminderTypes[i] == type) {
			html += ' selected="selected"';
		}
		html += '>' + lang(og.reminderTypes[i]) + '</option>';
	}
	html += '</select>';
	
	var abs_duration = Math.abs(duration);
	var is_after = duration < 0;
	
	html += '<input type="number" name="reminder_duration['+ context +']['+ count +']" value="'+ abs_duration +'"/>'; 
	
	html += '<select name="reminder_duration_type[' + context + '][' + count + ']">';
	for (var i in og.reminderDurationTypes) {
		html += '<option value="' + i + '"';
		if (i == duration_type) {
			html += ' selected="selected"';
		}
		html += '>' + lang(og.reminderDurationTypes[i]) + '</option>';
	}
	html += '</select>';
	
	html += '<select name="reminder_before_after[' + context + '][' + count + ']">';
	html += '<option value="before" '+ (is_after ? '' : 'selected="selected"') +'>'+ lang('before') +'</option>';
	html += '<option value="after" '+ (is_after ? 'selected="selected"' : '') +'>'+ lang('after') +'</option>';
	html += '</select>';
	
	html += '<select name="reminder_context[' + context + '][' + count + ']" id="reminder_context[' + context + '][' + count + ']">';
	if (type_object == 'task') {
		if(date_reminder === null){
		  	date_reminder = "due_date";
		}
		html += '<option value="start_date" '+ (date_reminder != 'due_date' ? '' : 'selected="selected"') +'>'+ lang('start date') +'</option>';
		html += '<option value="due_date" '+ (date_reminder == 'due_date' ? 'selected="selected"' : '') +'>'+ lang('due date') +'</option>';
	} else {
		html += '<option value="' + context + '">'+ lang(context.replace('_',' ')) +'</option>';
	}
	html += '</select>';
	
	html += '<span style="margin-left:30px;position:relative;"><input class="checkbox" type="checkbox" name="reminder_subscribers[' + context + '][' + count + ']" ' + (for_subscribers ? 'checked="checked"' : "") + ' id="' + id + '" />&nbsp;' + lang("apply to subscribers") + '</span>';
	var id = Ext.id();
	html += '<a href="#" onclick="og.removeReminder(this.parentNode, \'' + context + '\');return false;" style="margin-left:30px;">';
	html += '<img title="' + lang("remove object reminder") + '" class="ico ico-delete" src="s.gif" style="vertical-align:middle;width:16px;height:20px;margin: 0 5px;position:relative;top:-2px;cursor:pointer" />';
	html += lang('remove');
	html += '</a>';
	div.innerHTML = html;
	parent.insertBefore(div, button);
};






og.member_history_change_page = function(member_id, page_number, genid, limit) {
	og.openLink(og.getUrl('member_history', 'member_history_list', {member_id: member_id, page: page_number, limit:limit}), {
		preventPanelLoad: true,
		callback: function(success, data) {
			$('#' + genid + 'member-history-container').parent().html(data.current.data);
		}
	});
}



og.time_weekly_view = { 

	current_interface: 'list',

	switch_interface: function (panel_id, interface = 'list') {

		og.time_weekly_view.current_interface = interface;
		
		if (og.time_weekly_view.current_interface == 'list') {
			og.time_weekly_view.current_interface = 'weekly';
			// Set weekly view to current week
			og.openLink(og.getUrl('time_weekly', 'set_user_preference_weekly_dates_to_current'));
		} else {
			og.time_weekly_view.current_interface = 'list';
		}

		var update_config_url = og.getUrl('account', 'update_user_preference', {name: 'time_list_view', value:og.time_weekly_view.current_interface}); 
		
		og.openLink(update_config_url, {
			hideLoading:true,
			callback: function(success, data) {
				var tp = Ext.getCmp("time-panel");
				if (tp) tp.reset();
			}
		});
	}
}
