//selector lista multiple de filtros a mostrar por custom porperties
og.custom_properties_filter = {
	object_type: '',
	cps: {},
	render_to_component_menu: '',
	render_to_component_cps: '',
	list_component_store: '',
	cp_container_id: 'container_cutom_prop_',
	custom_properties_filters: {},
	cp_types_supported: ["boolean","text","list"],
	
	init: function() {
		
		//Configuration
		this.object_type = 'contact';
		this.render_to_component_menu = 'obj_selector_filters';
		this.render_to_component_cps = 'object_selector_prop_filter';
		this.list_component_store = Ext.getCmp('obj_selector_grid').store;
		
		//Add custom_properties_filters to base params
		this.list_component_store.baseParams.custom_properties_filters = '';
		
		//get render to objects
		var container_cps = Ext.getCmp(this.render_to_component_cps);
		var $container_cps = $(container_cps.body.dom);
		
		var topToolbar = Ext.getCmp(this.render_to_component_menu).getTopToolbar();
		
		//get custom porperties for this object type
		var cp_array = og.custom_properties_by_type[this.object_type] ? og.custom_properties_by_type[this.object_type] : [];
		for (i=0; i<cp_array.length; i++) {
			//check if we support this cp type
			if(this.cp_types_supported.indexOf(cp_array[i].cp_type) != -1){
				//copy cps objects
				this.cps[cp_array[i].id] = jQuery.extend({}, cp_array[i]);
			}
		}
		
		//Add cp to the view menu
		var displayOptions = new Array();
		var supported_cps_count = 0;
		// count supported cps
		for (i=0; i<cp_array.length; i++) {
			if(this.cp_types_supported.indexOf(cp_array[i].cp_type) != -1){
				supported_cps_count++;
			}
		}
		var sup_cp_idx=0;
		for (i=0; i<cp_array.length; i++) {
			//check if we support this cp type
			if(this.cp_types_supported.indexOf(cp_array[i].cp_type) != -1){
				sup_cp_idx++;
				var cp_option = new Ext.menu.CheckItem ({
						cp_index: sup_cp_idx,
						checked:false, 
						stateful:true,
						stateId: "custom_properties_filter_view_cp_id"+cp_array[i].id,
			            stateEvents: ['click'],
			            getState: function() {
			                return {checked: this.checked}
			            },
			            applyState: function(state) {
			                this.checked = state.checked;
			            },
		   				hideOnClick:false,
		   				text: cp_array[i].name, 
		   				value: cp_array[i].id,
		   				custom_properties_filter: this,
		   				container_cps: $container_cps,
		   				listeners: {
		   				  checkchange: function(item, state){
		   					//if is checked
		   					if(state){
		   				    	this.custom_properties_filter.toggle_cp_filter(1,this.value, this.container_cps, true);
		   				    }else{
		   				    	this.custom_properties_filter.toggle_cp_filter(0,this.value, this.container_cps, true);
		   				    }
		   				  },
		   				  render: function(item){
			   					this.custom_properties_filter.toggle_cp_filter(item.checked,this.value, this.container_cps, false);
			   					// tell the selector that all cp filter have been rendered
			   					if (this.cp_index == supported_cps_count) {
			   						og.eventManager.fireEvent('object selector all cp filters rendered');
			   					}
			   			  }
		   				}
		   		});	   		
		   		displayOptions.push(cp_option);
			}
	   	}
		// if there are custom properties and none is supported => tell the selector that all cps are rendered.
		if (cp_array.length > 0 && supported_cps_count == 0) {
			og.eventManager.fireEvent('object selector all cp filters rendered');
		}
		
		/*displayOptions.push({
            text: 'Send mail',
            checked: false,
            value: "send-mail",
            stateful:true,
            stateId: "send-mail",
            stateEvents: ['click'],
            getState: function() {
                return {checked: this.checked}
            },
            applyState: function(state) {
                this.checked = state.checked;
            }
        });*/
	   	
	   	
	   	//Menu custom properties to reneder
	   	var action = new Ext.Action({
			text: lang('view'),
			id: "custom_properties_filter_menu_action_view",
			iconCls: 'ico-view_options',
			disabled: false,	
			listeners: {
 				  render: function(item){	   					
	   					item.menu.render();
	   			  }
 			},
			menu: {items: displayOptions}
		});
	   	
	   	//Add cp menu to the render_to_component toolbar		
	   	topToolbar.add(action);	   	
	},

	/**
	 * show or hide cp filter
	 * @param {Bool} show 
	 * @param {Number} cp_id
	 * @param {jquery object} $container_cps
	 * @param {Bool} reload_grid
	 */
	toggle_cp_filter: function(show, cp_id, $container_cps, reload_grid) {
		var cp = this.cps[cp_id];
		var cp_container_id = this.cp_container_id + cp.id;
						
		//do not draw it if already exists
		if($container_cps.find("#" + cp_container_id).length){
			if(show){
				$container_cps.find("#" + cp_container_id).show();
			}else{
				$container_cps.find("#" + cp_container_id).hide();
			}								
		}else{
			if(show){
				this.render_cp_filter(cp_id, $container_cps);				
			}
		}
		
		//Update request params, add or remove from params
		this.update_request_params(cp, show, reload_grid);
	},
	
	/**
	 * render cp filter
	 * @param {Number} cp_id
	 * @param {jquery object} $container_cps
	 */
	render_cp_filter: function(cp_id, $container_cps) {
		var cp = this.cps[cp_id];
		var cp_container_id = this.cp_container_id + cp.id;
				
		//do not draw it if already exists
		if($container_cps.find("#" + cp_container_id).length){
			return;			
		}
		
		switch(cp.cp_type) {
		    case "boolean":
		    	this.render_boolean_cp_filter(cp, cp_container_id, $container_cps);
		        break;
		    case "text":
		    	this.render_text_cp_filter(cp, cp_container_id, $container_cps);
		        break;
		    case "list":
		    	this.render_list_cp_filter(cp, cp_container_id, $container_cps);
		    	break;
	    }
	},
	
	/**
	 * render boolean cp filter
	 * @param {custom propertie obj} cp 
	 * @param {Number} cp_container_id
	 * @param {jquery object} $container_cps
	 */
	render_boolean_cp_filter: function(cp, cp_container_id, $container_cps) {
		//get template for the row
		var source = $("#boolean-custom-propertie-filter-template").html(); 
		//compile the template
		var template = Handlebars.compile(source);
		
		var def_value = "";
		if(cp.cp_default_value == 1){
			def_value = "checked";
		} 
		
		//template data
		var data = {			
			container_id : cp_container_id,
			cp : cp,
			default_value : def_value,
			on_cp_value_change_fn : "og.custom_properties_filter.on_cp_value_change_fn("+ cp.id +")"
		}
		
		//instantiate the template
		var html = template(data);
		
		//add html to the view
		$container_cps.append(html);		
	},
	
	/**
	 * render text cp filter
	 * @param {custom propertie obj} cp 
	 * @param {Number} cp_container_id
	 * @param {jquery object} $container_cps
	 */
	render_text_cp_filter: function(cp, cp_container_id, $container_cps) {
		//get template for the row
		var source = $("#text-custom-propertie-filter-template").html(); 
		//compile the template
		var template = Handlebars.compile(source);
		
		var def_value = "";
		if(cp.cp_default_value == 1){
			def_value = "checked";
		} 
		
		//template data
		var data = {			
			container_id : cp_container_id,
			cp : cp,
			default_value : def_value,
			onkeyup_cp_value_fn : "og.custom_properties_filter.text_filter_by_value(this,"+ cp.id +")"
		}
		
		//instantiate the template
		var html = template(data);
		
		//add html to the view
		$container_cps.append(html);		
	},
	
	/**
	 * render list cp filter
	 * @param {custom propertie obj} cp 
	 * @param {Number} cp_container_id
	 * @param {jquery object} $container_cps
	 */
	render_list_cp_filter: function(cp, cp_container_id, $container_cps) {
	
		//get template for the row
		var source = $("#list-custom-propertie-filter-template").html();
		//compile the template
		var template = Handlebars.compile(source);
		
		var def_value = "";
		if(cp.cp_default_value == 1){
			def_value = "checked";
		}
		var cp_values = cp.cp_values.split(',');

		//template data
		var data = {
			container_id : cp_container_id,
			cp : cp,
			cp_values: cp_values,
			default_value : def_value,
			on_cp_value_change_fn : "og.custom_properties_filter.on_cp_value_change_fn("+ cp.id +")"
		}
		
		//instantiate the template
		var html = template(data);
		
		//add html to the view
		$container_cps.append(html);		
	},
	/**
	 * update listing request
	 * @param {custom propertie obj} cp
	 * @param {bool} enabled
	 * @param {bool} reload_list
	 */
	update_request_params: function(cp, enabled, reload_list) {
		if(reload_list === undefined) { reload_list = false; }
		
		if(enabled){
			if (cp.cp_type == "list"){
				var values = this.get_cp_selected_values(cp.id, 1);				
				this.custom_properties_filters[cp.id] = {value : values};				
			}else{
				this.custom_properties_filters[cp.id] = {value : this.get_cp_selected_values(cp.id).value};
			}			
		}else{
			this.custom_properties_filters[cp.id] = undefined;
		}
		
		//update component store baseparams 
		this.list_component_store.baseParams.custom_properties_filters = Ext.util.JSON.encode(this.custom_properties_filters);
	
		//Reload the list
		if(reload_list){
			this.reload_target_list();
		}		
	},
	
	
	
	/**
	 * 
	 * @param {} 
	 */
	reload_target_list: function() {
		this.list_component_store.reload();
	},
	
	
	//VIEW INTERACTION FUNCTIONS
	/**
	 * 
	 * @param {} 
	 */
	get_cp_selected_values: function(cp_id, multiple=null) {
		var ret_obj = {};
		if (multiple){	
			var selected_values = []; 
			$.each($('.object_custom_properties_'+cp_id+':checkbox:checked'), function(index,item){				
				selected_values.push($(item).attr("data-id"));
			});
			return selected_values;
					
		}else{
			if($("#cps_object_custom_propertie_value_" + cp_id).length){
				//Get cp value
				if($("#cps_object_custom_propertie_value_" + cp_id).attr('type') == "checkbox"){
					
					ret_obj.value = $("#cps_object_custom_propertie_value_" + cp_id).is(':checked');
					
				}else{
					ret_obj.value = $("#cps_object_custom_propertie_value_" + cp_id).val();
				}			
			}		
		}
		
		return ret_obj;
	},
	
	/**
	 * 
	 * @param {} 
	 */
	on_cp_value_change_fn: function(cp_id) {
		var cp = this.cps[cp_id];
		this.update_request_params(cp,1,true);		
	},
	
	text_filter_by_value : function(input, cp_id) {
		var cp = this.cps[cp_id];
		
		var value = input.value;
		
		if (input.tout) clearTimeout(input.tout);
		input.tout = setTimeout(function(){
			if (value == input.last_value) {
				return;
			}
			input.last_value = value;
			
			og.custom_properties_filter.update_request_params(cp,1,true);
			
			setTimeout(function(){
				input.focus();
			}, 1000);
			
		}, 1000);
	}
	//END VIEW INTERACTION FUNCTIONS
}
