<?php 
$quota_id = $object->getColumnValue('quota_id');
$quota = Quotas::instance()->findById($quota_id);

$select_quota_by_id = false;
if (!$quota instanceof Quota) {// when creating payment from quota view
	$quota_id = get_id('quota_id');
	$quota = Quotas::instance()->findById($quota_id);
	if ($quota instanceof Quota) {
		$select_quota_by_id = true;
	}
}
$payment_dimensions = Dimensions::getAllowedDimensions(Payments::instance()->getObjectTypeId());
Hook::fire("allowed_dimensions_in_member_selector", array('ot' => Payments::instance()->getObjectTypeId()), $payment_dimensions);
?>

<div class="dataBlock"><?php
	echo label_tag(lang('quota'));
	?><span id="<?php echo $genid?>paymentQuotaName"><?php
		echo $quota instanceof Quota ? $quota->getName() : "";
	?></span>
	&nbsp;&nbsp;
	
	<input type="hidden" name="payment[quota_id]" value="<?php echo $payment->getColumnValue('quota_id')?>" id="<?php echo $genid?>paymentQuotaId"/>
	<a class="link-ico ico-edit underline" id="<?php echo $genid ?>quota_change_link" href="#" onclick="og.changeQuota(this, '<?php echo $genid?>');" style="font-size:13px;"><?php 
		echo $quota_id > 0 ? lang('change quota') : lang('select quota');
	?></a>
	&nbsp;
	<a class="link-ico ico-delete underline" id="<?php echo $genid ?>quota_remove_link" href="#" onclick="og.removePaymentQuota('<?php echo $genid?>', false);" 
		style="font-size:13px;<?php echo $quota_id > 0 ? "" : "display:none;" ?>"><?php 
		echo lang('remove');
	?></a>
	    			
</div>
<div class="clear"></div>

<script>
og.payment_dimension_ids = [];
<?php foreach ($payment_dimensions as $d) { ?>
	og.payment_dimension_ids.push(<?php echo $d['dimension_id']?>);
<?php } ?>

var genid = '<?php echo $genid ?>';

og.checkCanHaveQuota = function(genid) {
	if (og.after_selecting_payment_quota) return;
	
	var quota_id = $("#"+genid+"paymentQuotaId").val();
	if (quota_id) {
		var members = $("#"+genid+"members").val();
		og.openLink(og.getUrl('quota', 'check_quota_members', {id: quota_id, member_ids: members}), {
			callback: function(success, data) {
				if (!data.ok) {
					og.removePaymentQuota(genid, false);
				}
			}
		});
	} else {
		// try to autoselect quota
		var members = $("#"+genid+"members").val();
		og.openLink(og.getUrl('quota', 'get_quota_by_member_ids', {member_ids: members}), {
			callback: function(success, data) {
				if (data.quota) {
					$("#"+genid+"paymentQuotaId").val(data.quota.object_id);
					$("#"+genid+"paymentQuotaName").html(data.quota.name);
					$("#"+genid+"quota_change_link").html(lang("change quota"));
					$("#"+genid+"quota_remove_link").show();
				}
			}
		});
	}
}

og.removePaymentQuota = function(genid, remove_classification) {

	$("#"+genid+"paymentQuotaId").val("");
	$("#"+genid+"paymentQuotaName").html("");
	$("#"+genid+"quota_change_link").html(lang('select quota'));
	$("#"+genid+"quota_remove_link").hide();

	if (remove_classification) {
		$("#"+genid+"members").val("[]");
		member_selector.remove_all_selections(genid);
		$(".single_current_selected .empty-text").show();
	}
}

og.resetPaymentMembersByQuota = function(genid, quota_id) {
	og.openLink(og.getUrl('quota', 'get_quota_data', {id: quota_id}), {
		callback: function(success, data) {
			if (data && data.quota && data.quota.memPath) {
				
				var all_member_ids = Ext.util.JSON.decode($("#"+genid+"members").val());
				
				for (dim_id in data.quota.memPath) {
					var member_ids_by_ot = data.quota.memPath[dim_id];
					if (typeof(member_ids_by_ot) == 'function') continue;
					
					for (ot in member_ids_by_ot) {
						var member_ids = member_ids_by_ot[ot];
						if (typeof(member_ids) == 'function') continue;

						if (member_selector[genid] && member_selector[genid].properties[dim_id]) {
							for (var j=0; j<member_ids.length; j++) {
								var mem_id = member_ids[j];
								var d = dim_id;
								// add member to payment classification
								if ((!member_selector[genid].sel_context[dim_id] || member_selector[genid].sel_context[dim_id].length == 0) 
										&& member_selector[genid].properties[dim_id]) {

									member_selector.add_relation(d, genid, mem_id);
									
									all_member_ids.push(parseInt(mem_id));
									$("#"+genid+"members").val(Ext.util.JSON.encode(all_member_ids));

									$("#"+genid+"-member-chooser-panel-"+d+"-tree-current-selected .empty-text").hide();
								}
								
								if (!member_selector[genid].properties[d].isMultiple) break;
							}
						}
					}
				}
			}
			og.after_selecting_payment_quota = false;
		}
	});
}

og.changeQuota = function(before, genid) {
	
	var selected_members = [];
	if (member_selector[genid] && member_selector[genid].sel_context) {
		for (dim_id in member_selector[genid].sel_context) {
			if (og.payment_dimension_ids.indexOf(parseInt(dim_id)) != -1) {
				var mem_ids = member_selector[genid].sel_context[dim_id];
				for (var i=0; i<mem_ids.length; i++) {
					selected_members.push(mem_ids[i]);
				}
			}
		}
	}
	
	og.ObjectPicker.show(function (objs) {
		if (objs && objs.length > 0) {
			var obj = objs[0].data;
			if (obj.type != 'quota') {
				og.msg(lang("error"), lang("object type not supported"), 4, "err");
			} else {
				$("#"+genid+"paymentQuotaId").val(obj.object_id);
				$("#"+genid+"paymentQuotaName").html(obj.name);
				$(before).html(lang("change quota"));

				$("#"+genid+"quota_remove_link").show();

				og.after_selecting_payment_quota = true;
				
				og.resetPaymentMembersByQuota(genid, obj.object_id);
			}
		}
	}, before, {
		hideFilters: true,
		hideUploadButton: true,
		ignore_context: true,
		extra_member_ids: Ext.util.JSON.encode(selected_members),
		types: ['quota'],
		selected_type: 'quota'
	});
};


<?php if ($select_quota_by_id) { ?>
og.resetPaymentMembersByQuota(genid, <?php echo $quota_id ?>);
<?php } else { ?>
og.checkCanHaveQuota(genid);
<?php } ?>

</script>