<?php
if (isset($quota) && $quota instanceof Quota) {
	if (!isset($genid)) $genid = gen_id();
	
	if (!$quota->isTrashed()){
		if($quota->canEdit(logged_user())) {
			add_page_action(lang('edit'), "javascript:og.render_modal_form('', {c:'quota', a:'edit', params: {id:".$quota->getId()."}});", 'ico-edit', null, null, true);
			
			if (!$quota->isArchived()) {
				add_page_action(lang('archive'), "javascript:if(confirm(lang('confirm archive object'))) og.openLink('" . $quota->getArchiveUrl() ."');", 'ico-archive-obj');
			} else {
				add_page_action(lang('unarchive'), "javascript:if(confirm(lang('confirm unarchive object'))) og.openLink('" . $quota->getUnarchiveUrl() ."');", 'ico-unarchive-obj');
			}
		}
	}
	if ($quota->canDelete(logged_user())) {
		if ($quota->isTrashed()) {
			add_page_action(lang('restore from trash'), "javascript:if(confirm(lang('confirm restore objects'))) og.openLink('" . $quota->getUntrashUrl() ."');", 'ico-restore', null, null, true);
			add_page_action(lang('delete permanently'), "javascript:if(confirm(lang('confirm delete permanently'))) og.openLink('" . $quota->getDeletePermanentlyUrl() ."');", 'ico-delete', null, null, true);
		} else {
			add_page_action(lang('move to trash'), "javascript:if(confirm(lang('confirm move to trash'))) og.openLink('" . $quota->getTrashUrl() ."');", 'ico-trash', null, null, true);
		}
	}
?>

<div style="padding:7px">
<div class="quota">
<?php
	tpl_assign("object", $quota);
	tpl_assign("genid", $genid);

	$content = tpl_fetch(get_template_path('quota_details', 'quota', 'advanced_expenses'));
	
	tpl_assign("content", $content);
	tpl_assign('iconclass', 'ico-large-quota');
	
	$this->includeTemplate(get_template_path('view', 'co'));
?>
</div>
</div>
<?php } ?>
