<?php
	class MailImapFolderMember extends BaseMailImapFolderMember {
		
		
		function getEditUrl() {
			return null;
		}
		
		static function canAdd(Contact $user, $context, &$notAllowedMember = ''){
			return false;
		}
		
		/**
		 * Returns true if $user can access this message
		 *
		 * @param Contact $user
		 * @return boolean
		 */
		function canView(Contact $user) {
			$mail_account = MailAccounts::instance()->findById($this->getAccountId());
			if ($mail_account instanceof MailAccount) {
				$mac = MailAccountContacts::instance()->getByAccountAndContact($mail_account, $user);
				if ($mac instanceof MailAccountContact) {
					return true;
				}
			}
			return false;
		} // canView
	
		/**
		 * Check if specific user can edit this messages
		 *
		 * @access public
		 * @param Contact $user
		 * @return boolean
		 */
		function canEdit(Contact $user) {
			$mail_account = MailAccounts::instance()->findById($this->getAccountId());
			if ($mail_account instanceof MailAccount) {
				$mac = MailAccountContacts::instance()->getByAccountAndContact($mail_account, $user);
				if ($mac instanceof MailAccountContact && $mac->getCanEdit()) {
					return true;
				}
			}
			return false;
		} // canEdit
	
	
		/**
		 * Check if specific user can delete this messages
		 *
		 * @access public
		 * @param Contact $user
		 * @return boolean
		 */
		function canDelete(Contact $user) {
			$mail_account = MailAccounts::instance()->findById($this->getAccountId());
			if ($mail_account instanceof MailAccount) {
				$mac = MailAccountContacts::instance()->getByAccountAndContact($mail_account, $user);
				if ($mac instanceof MailAccountContact && $mac->getCanEdit()) {
					return true;
				}
			}
			return false;
		} // canDelete
	
		/**
		 * Check if specific user can comment this message
		 *
		 * @access public
		 * @param void
		 * @return boolean
		 */
		function canAddComment(Contact $user) {
			return false;
		} // canAddComment
	}