og.advanced_mail_imap_folders = {
	init: function() {
		if (!og.mail) og.mail = {};
		
		var did = null;
		for (var x in og.dimensionPanels) {
			if (og.dimensionPanels[x] && og.dimensionPanels[x].dimensionCode == "mail_imap_folders") {
				did = og.dimensionPanels[x].dimensionId;
				break;
			}
		}
		
		if (!isNaN(did)) {
			// add imap folder column to the list
			var has_col = false;
			if (og.mail.additional_mail_list_columns) {
				for (var i=0; i<og.mail.additional_mail_list_columns.length; i++) {
					if (og.mail.additional_mail_list_columns[i].id == 'imap_folder_member_column') has_col = true;
				}
			} else {
				og.mail.additional_mail_list_columns = [];
			}
			if (!has_col) {
				og.mail.additional_mail_list_columns.push({
					id: 'dim_' + did,
					header: lang('imap folder'),
					dataIndex: 'dim_' + did,
					sortable: true,
					renderer: og.renderDimCol
				});
			}
			// only show imap folder members in this dimension's breadcrumbs
			if (!og.dimensions_that_exclude_parents_in_breadcrumbs) og.dimensions_that_exclude_parents_in_breadcrumbs = [];
			og.dimensions_that_exclude_parents_in_breadcrumbs[did] = true;
			
			// after selecting an item in the account filter => clear imap folder dimension selectors
			if (!og.mail.after_filter_by_mail_account_fn) og.mail.after_filter_by_mail_account_fn = [];
			og.mail.after_filter_by_mail_account_fn.push(function(account_id) {
				og.contextManager.dimensionMembers[did] = [0];
				$("#dimension-panel-"+did+" .x-tree-selected").removeClass("x-tree-selected");
				var tree = Ext.getCmp("dimension-panel-"+did);
				if (tree) og.Breadcrumbs.refresh(tree.getRootNode());
				
				var man = Ext.getCmp('mails-manager');
				if (man) {
					if (!man.store.extraParams) man.store.extraParams = [];
					man.store.extraParams.dont_override_account_filter = 1;
				}
			});
		}
		
		
		og.eventManager.addListener('refresh_mail_list_account_filter', function (data) {
			var account_id = data.account_id;
			var account_name = data.account_name;
			
			var comp = Ext.getCmp('mails-manager').getTopToolbar().items.get('tb-item-byaccount');
			
			if (account_id != '') {
				for (var i=0; i<comp.menu.items.items.length; i++) {
					var mi = comp.menu.items.items[i];
					if (mi.text == account_name) {
						mi.checked = true;
						if (mi.el && mi.el.dom && mi.el.dom.parentNode) {
							Ext.fly(mi.el.dom.parentNode).addClass("x-menu-item-checked");
						}
					} else {
						mi.checked = false;
						if (mi.el && mi.el.dom && mi.el.dom.parentNode) {
							Ext.fly(mi.el.dom.parentNode).removeClass("x-menu-item-checked");
						}
					}
				}
			} else {
				for (var i=0; i<comp.menu.items.items.length; i++) {
					var mi = comp.menu.items.items[i];
					mi.checked = false;
					if (mi.el && mi.el.dom && mi.el.dom.parentNode) {
						Ext.fly(mi.el.dom.parentNode).removeClass("x-menu-item-checked");
					}
					account_name = lang('view by account');
				}
			}
			comp.setText(account_name);
			if (account_id != '') {
				comp.addClass('filter-selected');
			} else {
				comp.removeClass('filter-selected');
			}
			comp.menu.hide();
			Ext.getCmp('mails-manager').accountId = account_id.toString();
			
			og.openLink(og.getUrl('object', 'set_user_config_option_value', {config_option_name: 'mails account filter', config_option_value: account_id}), {preventPanelLoad: true, hideLoading: true});
			
		});

	}
}