<?php


	function file_access_report_print_group_csv($group_obj, $grouped_objects, $options, $skip_groups = array(), $level = 0, $prev = "", &$crumbJs = "") {
		$string = "";
		
		$margin_left = 2 * $level;
		$cls_suffix = $level > 2 ? "all" : $level;
		$next_level = $level + 1;
		
		$group_name = $group_obj['group']['name'];
		$string .= $group_name . "\n";
		
		$mem_index = $prev . $group_obj['group']['id'];
		
		// draw the table for the values
		if (isset($grouped_objects[$mem_index]) && count($grouped_objects[$mem_index]) > 0) {
			$string .= file_access_report_print_table_csv($grouped_objects[$mem_index], $margin_left, $options, $group_name, $crumbJs);
		}
		
		if (!is_array($group_obj['subgroups'])) return;
		
		$subgroups = order_groups_by_name($group_obj['subgroups']);
		foreach ($subgroups as $subgroup) {
			$string .= file_access_report_print_group_csv($subgroup, $grouped_objects, $options, array(), $next_level, $prev . $group_obj['group']['id'] . "_", $crumbJs);
		}
		
		return $string;
	}
	
	
	function file_access_report_print_table_csv($objects, $left, $options, $group_name, &$crumbJs = "") {
		$string = "";
		
		$string .= lang('date') . ';';
		$string .= lang('file') . ';';
		$string .= lang('related to') . ';';
		$string .= lang('action') . ';';
		$string .= lang('user') . ';';
		
		$alt_cls = "";
		$cols = 5;
		foreach ($objects as $t) {
			$string .= "\n";
			$string .= file_access_report_print_log_csv($t, 0, $cols, $options, $alt_cls, $crumbJs);
		}
		
		$string .= "\n\n";
		
		return $string;
	}
	
	
	function file_access_report_print_log_csv(ApplicationReadLog $log, $margin_left, $cols, $options, &$alt_cls='', &$crumbJs='') {
		$string = "";
		
		$string .= format_datetime($log->getCreatedOn()) .";";
		
		$document = Objects::findObject($log->getRelObjectId());
		$string .= ($document instanceof ContentDataObject ? $document->getObjectName() : lang('n/a')) . ";";
		
		// TODO: members
		$mem_str = "";
		$obj = $log->getObject();
		$mem_path = $obj->getMembersToDisplayPath();
		foreach ($mem_path as $dim_id => $members) {
			foreach ($members as $mem_id => $mem) {
				if (is_numeric($mem_id)) {
					$mem_str .= ($mem_str == "" ? "" : " - ") . $mem['name'];
				}
			}
		}
		$string .= "$mem_str;";
		
		$string .= lang($log->getAction()) .";";
		
		$person_name = isset($options['users'][$log->getCreatedById()]) ? $options['users'][$log->getCreatedById()]->getObjectName() : lang('n/a');
		$string .= clean($person_name) . ";";
		
		return $string;
		
	}
	
	
	function generate_file_access_report_csv_file($grouped_logs, $users, $filename) {
		
		$options = array_var($_SESSION, 'file_access_report_data', array());
		$options['users'] = $users;
		
		$string = "";
		$groups = order_groups_by_name($grouped_logs['groups']);
		foreach ($groups as $gid => $group_obj) {
			$string .= file_access_report_print_group_csv($group_obj, $grouped_logs['grouped_objects'], $options, array(), 0, "", $crumbJs);
		}
		
		file_put_contents(ROOT."/tmp/$filename", $string);
	}
	
	
