<?php
Hook::register("task_reports_previous_tasks_column");


/**
 * Add the 'Previous tasks' column to the report view
 */
function task_reports_previous_tasks_column_custom_reports_fixed_additional_columns_def($args, &$results) {
	$ot = array_var($args, 'object_type');
    $field = array_var($args, 'field');
    
	if ($ot instanceof ObjectType && $ot->getName()=='task' && $field == 'previous_tasks_list') {
        // Set column header name
        $results['columns']['names'][$field] = lang('previous tasks');
        // Set column order
		$results['columns']['order'][] = $field;


	}
}

/**
 * Add the 'Previous tasks' column to the add/edit custom report form for tasks
 */
function task_reports_previous_tasks_column_custom_reports_additional_columns($params, &$fields) {
	
	$ot = array_var($params, 'object_type');
	
	if ($ot->getName() == 'task') {
        $fields[] = array('id' => 'previous_tasks_list', 'name' => lang('previous tasks'), 'type' => 'text');
	}
}

/**
 * Add the 'Previous tasks' column values to the custom report result
 */
function task_reports_previous_tasks_column_custom_reports_override_column_format($parameters, &$value) {
	
	$field = array_var($parameters, 'field');
    $object = array_var($parameters, 'object');

	if ($object instanceof ProjectTask && $field == 'previous_tasks_list') {
        $value = '<div style="display: grid; grid-template-columns: 1fr 1fr; grid-gap: 2px; margin-bottom: 3px;">';
        $previous_tasks = ProjectTaskDependencies::getPreviousTasks($object->getId());
        foreach($previous_tasks as $p_task){
            $task_name = '<a href="'.$p_task->getObjectUrl().'">' . $p_task->getName() . '</a>';
            if($p_task->getCompletedById() == 0){
            $task_status = '<div style="padding: 1px 5px;margin-top: 3px; border-radius: 4px ; text-align: center; background-color: #F6D4D5 ; color: #F6464C ;">' . lang('pending') . '</div>';
            } else {
            $task_status = '<div style="padding: 1px 5px;margin-top: 3px; border-radius: 4px ; text-align: center; background-color: #73D073 ; color: #FFFFFF ;">' . lang('completed') . '</div>';
            }
            $value .= '<div>' . $task_name . '</div><div>' . $task_status . '</div>';
        }
        $value .= '</div>';
	}
}



