og.advanced_reports = {
	conditions_fields:[],
	init: function() {

		og.openLink(og.getUrl('advanced_reports', 'get_default_custom_reports'), {
			callback: function(success, data) {
				og.default_custom_reports = data.reports;
				if (!og.additional_member_list_actions) og.additional_member_list_actions = {};
				
				for (ot in og.default_custom_reports) {
					var print_action = new Ext.Action({
						text: lang('report and print'),
						iconCls: 'ico-print',
						ot: ot,
			            id: 'listing-print-action-'+ot,
						handler: function() {
							og.advanced_reports.execute_member_report(this.ot, this.dim_id, ot);
						}
					});
					
					og.additional_member_list_actions[ot] = [print_action];
				}
			}
		});
		

		if (!og.after_report_object_type_change_functions) og.after_report_object_type_change_functions=[];
		og.after_report_object_type_change_functions.push(og.advanced_reports.load_report_group_by_component);
		
		if (!og.additional_report_condition_renderers) og.additional_report_condition_renderers=[];
		og.additional_report_condition_renderers.push(og.advanced_reports.render_date_time_range_condition);
		og.additional_report_condition_renderers.push(og.advanced_reports.render_classification_condition);
		og.additional_report_condition_renderers.push(og.advanced_reports.render_dim_association_condition);
		og.additional_report_condition_renderers.push(og.advanced_reports.render_located_under_condition);
	},
	
	load_report_group_by_component: function(type, genid) {
		
		var rep_id_el = document.getElementById(genid + "report[report_object_type_id]");
		
		og.openLink(og.getUrl('advanced_reports', 'get_group_by_parameters_html', {object_type: type, genid:genid}), {
			preventPanelLoad: true,
			callback: function(success, data) {
				if (data && data.html) {
					$("#more_custom_report_parameters").html(data.html);
				}
			}
		});
	},
	
	render_located_under_condition: function(params) {
		var id = params.id;
		var type_and_name = params.type_and_name;
		var fieldType = params.fieldType;
		var selected_cond = params.selected;
		var conditions = params.conditions;
		var value = params.value;
		var div_id = params.div_id;
		
		if (fieldType == "located_under") {
			conditions += '<option value="in">'+lang('in')+'</option>';
			conditions += '<option value="not_in">'+lang('not in')+'</option>';
			conditions += '</select>';
			
			$("#" + div_id + " #tdConditions" + id).html(conditions);
			$("#" + div_id + " #tdConditions" + id).find('select').on('change',og.advanced_reports.hiddenInputType);
			
			$("#" + div_id + " #tdConditions" + id + ' .reportConditionDD').hide();
			$("#" + div_id + " #tdConditions" + id + ' label').hide();
			
			var dim_id = selected_cond.replace("located_under_", "");
			var genid = Ext.id();
			$("#" + div_id + " #tdValue" + id).html('<div style="margin-top:20px;" id="'+ genid + 'members_' + dim_id +'"></div><input type="hidden" name="conditions['+ id +'][field_name]" value="' + selected_cond + '">');
			
			var sel_mem_ids = '';
			if (value != '') {
				var decoded = Ext.util.JSON.decode(value);
				sel_mem_ids = decoded.join(',');
			}
			
			var hf_name = 'conditions['+ id +'][value]';
			og.quick_add_row_member_selector(dim_id, genid, hf_name, sel_mem_ids, false, '0');
		}
		
	},
	
	render_classification_condition: function(params) {
		var id = params.id;
		var type_and_name = params.type_and_name;
		var fieldType = params.fieldType;
		var selected_cond = params.selected;
		var conditions = params.conditions;
		var value = params.value;
		var div_id = params.div_id;
		
		if (fieldType == "classification") {
			conditions += '<option value="in">'+lang('classified in')+'</option>';
			conditions += '<option value="single_in">'+lang('classified in this single')+'</option>';
			conditions += '<option value="not_in">'+lang('not classified in')+'</option>';
			conditions += '<option value="not_in_single">'+lang('not classified in single')+'</option>';
			conditions += '<option value="unclassified">'+lang('not classified')+'</option>';
			conditions += '</select>';
			
			$("#" + div_id + " #tdConditions" + id).html(conditions);
			$("#" + div_id + " #tdConditions" + id).find('select').on('change',og.advanced_reports.hiddenInputType);
			
			var dim_id = selected_cond.replace("dim_", "");
			var genid = Ext.id();
			$("#" + div_id + " #tdValue" + id).html('<div style="margin-top:20px;" id="'+ genid + 'members_' + dim_id +'"></div><input type="hidden" name="conditions['+ id +'][field_name]" value="' + selected_cond + '">');
			
			var sel_mem_ids = '';
			if (value != '') {
				var decoded = Ext.util.JSON.decode(value);
				sel_mem_ids = decoded.join(',');
			}
			
			var hf_name = 'conditions['+ id +'][value]';
			var single_name = 'conditions['+ id +']';

			og.advanced_reports.conditions_fields.push([single_name,dim_id,genid,hf_name,sel_mem_ids]);
			og.quick_add_row_member_selector(dim_id, genid, hf_name, sel_mem_ids, true, '0');
		}
		
	},
	
	render_dim_association_condition: function(params) {
		var id = params.id;
		var type_and_name = params.type_and_name;
		var fieldType = params.fieldType;
		var selected_cond = params.selected;
		var conditions = params.conditions;
		var value = params.value;
		var div_id = params.div_id;
		
		if (fieldType == "dim_association") {
			conditions += '<option value="in">'+lang('classified in')+'</option>';
			conditions += '<option value="single_in">'+lang('classified in this single')+'</option>';
			conditions += '<option value="not_in">'+lang('not classified in')+'</option>';
			conditions += '<option value="not_in_single">'+lang('not classified in single')+'</option>';
			conditions += '<option value="unclassified">'+lang('not classified')+'</option>';
			conditions += '</select>';
			
			$("#" + div_id + " #tdConditions" + id).html(conditions);
			$("#" + div_id + " #tdConditions" + id).find('select').on('change',og.advanced_reports.hiddenInputType);
			
			var dim_id = null;
			var assoc_id = selected_cond.replace("dimassoc_", "");
			for (did in og.dimension_member_associations) {
				for (otid in og.dimension_member_associations[did]) {
					var assocs = og.dimension_member_associations[did][otid];
					for (var i=0; i<assocs.length; i++) {
						var a = assocs[i];
						if (a && a.id == assoc_id) {
							dim_id = did;
							break;
						}
					}
				}
			}
			
			if (dim_id) {
				var genid = Ext.id();
				$("#" + div_id + " #tdValue" + id).html('<div style="margin-top:20px;" id="'+ genid + 'members_' + dim_id +'"></div><input type="hidden" name="conditions['+ id +'][field_name]" value="' + selected_cond + '">');
				
				var sel_mem_ids = '';
				if (value != '') {
					var decoded = Ext.util.JSON.decode(value);
					sel_mem_ids = decoded.join(',');
				}
				
				var hf_name = 'conditions['+ id +'][value]';
				og.quick_add_row_member_selector(dim_id, genid, hf_name, sel_mem_ids, true, '0');
			}
		}
		
	},
	
	render_date_time_range_condition: function(params) {
		var id = params.id;
		var type_and_name = params.type_and_name;
		var fieldType = params.fieldType;
		var selected_cond = params.selected;
		var conditions = params.conditions;
		var value = params.value;
		if (fieldType == "date_range_time_range") {
			
			var dateRangeValueField = '<label for="containerConditions[' + id + '][value]">' + lang('value') + '</label>' + 
				'<span id="containerConditions[' + id + '][value][from]"></span>&nbsp;' + lang('and') +
				'&nbsp;<span id="containerConditions[' + id + '][value][to]"></span>&nbsp;' + 
				'&nbsp;<div style="display: inline-block;vertical-align: text-top;">' + lang('between') + '</div>' +
				'&nbsp;<span id="containerConditions[' + id + '][value][from_time]"></span>&nbsp;' + lang('and') +
				'&nbsp;<span id="containerConditions[' + id + '][value][to_time]"></span>' + type_and_name;
			
			if (value != '') {
				value = Ext.util.JSON.decode(value);
			} else {
				value = {from:'', to:'', from_time:'', to_time:''};
			}
			
			document.getElementById('tdValue' + id).innerHTML = dateRangeValueField;
			document.getElementById('tdValue' + id).style.width = '500px';
			
			conditions += '<option value="between">'+lang('between')+'</option>';
			conditions += '</select>';
			document.getElementById('tdConditions' + id).innerHTML = conditions;
			var date1Cond = new og.DateField({
				renderTo:'containerConditions[' + id + '][value][from]',
				name: 'conditions[' + id + '][value][from]',
				id: 'conditions[' + id + '][value][from]',
				value: Ext.util.Format.date(value.from, og.preferences['date_format'])
			});
			
			var date2Cond = new og.DateField({
				renderTo:'containerConditions[' + id + '][value][to]',
				name: 'conditions[' + id + '][value][to]',
				id: 'conditions[' + id + '][value][to]',
				value: Ext.util.Format.date(value.to, og.preferences['date_format'])
			});

			var time1Cond = new Ext.form.TimeField({
				renderTo:'containerConditions[' + id + '][value][from_time]',
				name: 'conditions[' + id + '][value][from_time]',
				id: 'conditions[' + id + '][value][from_time]',
				width: 85,
				emptyText: 'hh:mm',
				value: value.from_time
			});
			var time2Cond = new Ext.form.TimeField({
				renderTo:'containerConditions[' + id + '][value][to_time]',
				name: 'conditions[' + id + '][value][to_time]',
				id: 'conditions[' + id + '][value][to_time]',
				width: 85,
				emptyText: 'hh:mm',
				value: value.to_time
			});
			
			document.getElementById('conditions[' + id + '][value][from]').parentNode.style.display = 'inline-block';
			document.getElementById('conditions[' + id + '][value][to]').parentNode.style.display = 'inline-block';
			document.getElementById('conditions[' + id + '][value][from_time]').parentNode.style.display = 'inline-block';
			document.getElementById('conditions[' + id + '][value][to_time]').parentNode.style.display = 'inline-block';
			
		}
	},
	
	execute_member_report: function(ot_id, ot_dim, ot_ot) {
		
		var manager = Ext.getCmp('member-manager-' + ot_dim + '-' + ot_id);
		var params = {id: og.default_custom_reports[ot_id]};
		
		if (manager) {
			var cols = [];
			var colmodeldef = manager.colModel.config;
			for (var x=0; x<colmodeldef.length; x++) {
				var col = colmodeldef[x];
				if (!col.id || col.hidden || col.id=='icon' || col.id=='checker') continue;
				var colId = col.id.replace('mem_type_col_', '');
				cols.push(colId);
			}
			params.columns = cols;
			
			params.order = manager.store.sortInfo.field;
			params.order_dir = manager.store.sortInfo.direction;
			
			var gb = null;
			if (manager.store.lastOptions.params.groupBy) {
				 if (manager.store.lastOptions.params.groupBy.indexOf('dimassoc_') == 0) {
					 gb = manager.store.lastOptions.params.groupBy.replace('dimassoc_', 'a_');
				 } else if (manager.store.lastOptions.params.groupBy.indexOf('cp_') == 0) {
					 gb = manager.store.lastOptions.params.groupBy;
				 } else if (manager.store.lastOptions.params.groupBy.indexOf('mem_path') == 0) {
					 gb = 'pm_1';
				 }
			}
			if (gb) params.group_by = gb;
		}
		
		var active_tab = Ext.getCmp('tabs-panel').getActiveTab();
		if (active_tab) {
			params.go_to_tab = active_tab.id;
		}
		var url = og.getUrl('reporting', 'view_custom_report', params);
		og.openLink(url, {
			caller: 'reporting-panel',
			onSuccess: function() {
				var reporting_panel = Ext.getCmp('reporting-panel');
				if (reporting_panel) {
					reporting_panel.loaded = true; // prevent that defautl action overrides the content
					Ext.getCmp('tabs-panel').setActiveTab(reporting_panel);
				}
			}
		});
	},
	
	
	submit_csv_form : function(genid) {
		var form_id = 'form' + genid;
		var form = document.getElementById(form_id);

		var post_id = 'post' + genid;
		var post_el = document.getElementById(post_id);
		var post = Ext.util.JSON.decode(post_el.value);

		var params = {'exportCSV': true};
		for (x in post) {
			if (x != 'c' && x != 'a' && x != 'ajax' && x != 'report') {
				params[x] = post[x];

				var i = document.createElement("input");
				i.type= "hidden";
				i.value = post[x];
				i.name = x;
				form.appendChild(i);
			} else if (x == 'report') {
				for (y in post[x]) {
					params['report['+y+']'] = post[x][y];
				}
			}
		}

		og.openLink(form.action, {
			post: params,
			callback: function(success, data) {
				var $form = $("<form></form>");
				$form.attr("action", og.getUrl('advanced_reports', 'download_file'));
				$form.attr("method", "post");
				$form.append('<input type="text" name="file_name" value="'+data.filename+'" />');
				$form.append('<input type="text" name="file_type" value="application/csv" />');
				
				$form.appendTo('body').submit().remove();				
			}
		});
		return false;
	},

	export_fixed_report_excel(genid) {
        var form_id = 'form' + genid;
        var form = document.getElementById(form_id);
        
        form.action = form.action.replace(/_print/ig, '_excel');
        
        og.advanced_reports.submit_csv_form(genid);

        form.action = form.action.replace(/_excel/ig, '_print');
        
        return false;
    },

    export_fixed_report_pdf(genid, controller, action) {
        var params = og.get_report_parameters_of_form(genid);
        params['exportPDF'] = true;
        params['pdfPageLayout'] = $("#"+genid+"pdfPageLayout").val();
        params['pdfPageSize'] = $("#"+genid+"pdfPageSize").val();

        var report_id = $("#report_id_"+genid).val();
        og.openLink(og.getUrl(controller, action), {
            post: params,
            callback: function(success, data) {
                var $form = $("<form></form>");
                $form.attr("action", og.getUrl('reporting', 'download_file'));
                $form.attr("method", "post");
                $form.append('<input type="text" name="file_name" value="'+data.filename+'" />');
                $form.append('<input type="text" name="file_type" value="application/pdf" />');
                
                $form.appendTo('body').submit().remove();

                $("#pdf_options_close_link").click();
            }
        });
        return false;
    },

    export_permissions_report_pdf: function(genid) {
        return og.advanced_reports.export_fixed_report_pdf(genid, 'permissions_reports', 'permissions_report_print');
    },

    export_permissions_report__excel: function(genid) {
        return og.advanced_reports.export_fixed_report_excel(genid);
    }
}
/**
 * Show or hide the input of members on conditions section
 * @param {type} e
 * @returns {undefined}
 */
og.advanced_reports.hiddenInputType = function(e){
    if (typeof(e) === 'string'){
      var elementSelect = $(e);
    }else{
      var elementSelect = $(e.srcElement);
    }
  var value = elementSelect.val();
  if(value == 'unclassified'){
      elementSelect.parent().next().css('display','none');
      elementSelect.parent().next().next().css('display','none');
  }else{
      elementSelect.parent().next().css('display','table-cell');
      elementSelect.parent().next().next().css('display','table-cell');
  }

	var conditions = og.advanced_reports.conditions_fields;
	var name_control = $(this).attr('name');
	var is_multiple = true;

	if(typeof name_control == 'undefined'){
		name_control = e;
	}
	
	if(typeof name_control != 'undefined'){
		for(condition of conditions){
			var key_condition = condition[0];
			if(name_control.indexOf(key_condition) > -1){
				if(value == 'single_in' || value == 'not_in_single'){is_multiple=false;}
				else if(value != 'unclassified'){is_multiple=true;}
				break;
			}
		}

		if(value != 'unclassified' && typeof condition != 'undefined'){
			og.quick_add_row_member_selector(condition[1], condition[2], condition[3], condition[4], is_multiple, '0');
		}
	}
};

og.eventManager.addListener('edit report loaded', function(){
	og.advanced_reports.conditions_fields = [];
});

og.eventManager.addListener('end colum list', function(){
	og.advanced_reports.conditions_fields = [];
});

