<?php

$hour_types_dim = Dimensions::findByCode('hour_types_night');

$night_hours_def = DB::executeOne("SELECT * FROM ".TABLE_PREFIX."work_night_hours ORDER BY id DESC");

if (is_array($night_hours_def) && count($night_hours_def) > 0) {
	$start = DateTimeValueLib::now();
	$start->setHour($night_hours_def['start_hour']);
	$start->setMinute($night_hours_def['start_minute']);
	$start_time = $start->format(user_config_option('time_format_use_24') ? "G:i" : "g:i A");
	
	$end = DateTimeValueLib::now();
	$end->setHour($night_hours_def['end_hour']);
	$end->setMinute($night_hours_def['end_minute']);
	$end_time = $end->format(user_config_option('time_format_use_24') ? "G:i" : "g:i A");
	
	$hour_type_id = $night_hours_def['hour_type_id'];
}

?>

<div class="work-time-admin" id="work-night-hours-container" style="<?php echo config_option('use_night_hours') ? "" : "display:none;"?>">
	<div class="title"><?php echo lang('night hours') ?></div>
	<div class="options">
		<div class="option">
			<label><?php echo lang('start time')?>:</label>
			<div class="value"><?php echo pick_time_widget2('night_hours[start_time]', $start_time); ?></div>
		</div>
		<div class="option">
			<label><?php echo lang('end time')?>:</label>
			<div class="value"><?php echo pick_time_widget2('night_hours[end_time]', $end_time); ?></div>
		</div>
		<div class="option">
			<div class="value member-selector"><?php render_single_member_selector($hour_types_dim, null, array($hour_type_id), 
				array('label' => lang('hour type'), 'is_multiple' => false, 'width' => '300', 'hidden_field_name' => 'night_hours[hour_type_id]')) ?></div>
		</div>
		<div class="option">
			<label style="vertical-align:middle;"><?php echo lang('min night hours')?>:</label>
			<div class="value"><?php
				$config_opt = ConfigOptions::getByName('min_night_hours');
				$config_opt->render('night_hours[min_night_hours]');
			?></div>
		</div>
		<div class="option">
			<label style="vertical-align:middle;max-width:310px;"><?php echo lang('min percentage to mark night hours')?>:</label>
			<div class="value"><?php
				$input_attr = array("style" => "width:30px;", "onkeyup" => "event.target.value = event.target.value.replace(/[^0-9]/g, '')");
				echo text_field('night_hours[min_percentage_to_mark_night_hours]', config_option('min_percentage_to_mark_night_hours'), $input_attr);
			?> %</div>
		</div>
	</div>
</div>

<script>
	$("#yes_no_use_night_hoursYes").click(function(){
		$("#work-night-hours-container").show();
	});
	$("#yes_no_use_night_hoursNo").click(function(){
		$("#work-night-hours-container").hide();
	});
</script>
