<?php 

function advanced_services_update_1_2() {
	DB::execute("
		DELETE FROM ".TABLE_PREFIX."dimension_object_type_contents 
		WHERE dimension_id=(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='hour_types')
			AND dimension_object_type_id=(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='hour_type')
			AND content_object_type_id!=(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='timeslot');
	");
}

function advanced_services_update_2_3() {
	
	DB::execute("
		CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."work_night_hours` (
		  `id` int NOT NULL AUTO_INCREMENT,
		  `start_hour` int NOT NULL DEFAULT 0,
		  `start_minute` int NOT NULL DEFAULT 0,
		  `end_hour` int NOT NULL DEFAULT 0,
		  `end_minute` int NOT NULL DEFAULT 0,
		  `hour_type_id` int NOT NULL DEFAULT 0,
		  PRIMARY KEY (`id`)
		) ENGINE='InnoDB' DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
	");
	
	DB::execute("
		CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."work_shifts` (
		  `id` int(11) NOT NULL AUTO_INCREMENT,
		  `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
		  `description` text CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
		  PRIMARY KEY (`id`)
		) ENGINE='InnoDB' DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
	");
	
	DB::execute("
		CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."work_shift_days` (
		  `shift_id` int(11) NOT NULL DEFAULT 0,
		  `week_day` int(11) NOT NULL DEFAULT 0,
		  `start_hour` int(11) NOT NULL DEFAULT 0,
		  `start_minute` int(11) NOT NULL DEFAULT 0,
		  `end_hour` int(11) NOT NULL DEFAULT 0,
		  `end_minute` int(11) NOT NULL DEFAULT 0,
		  PRIMARY KEY (`shift_id`,`week_day`)
		) ENGINE='InnoDB' DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
	");
	
	DB::execute("
		CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."contact_shifts` (
		  `contact_id` int(11) NOT NULL,
		  `shift_id` int(11) NOT NULL,
		  PRIMARY KEY (`contact_id`,`shift_id`),
		  KEY `shift_id` (`shift_id`)
		) ENGINE='InnoDB' DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."config_categories` (`name`, `is_system`, `category_order`) VALUES
		('work_shifts_management', 0, 5);
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
		('work_shifts_management', 'use_night_hours', '0', 'BoolConfigHandler', '0', '0', NULL);
	");
}

function advanced_services_update_3_4() {
	$dim_id = Dimensions::findByCode('hour_types')->getId();
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
		('work_shifts_management', 'extra_hours_member', '0', 'MemberConfigHandler', '0', '0', NULL, '{\"dim_id\":$dim_id}'),
		('work_shifts_management', 'normal_hours_member', '0', 'MemberConfigHandler', '0', '0', NULL, '{\"dim_id\":$dim_id}'),
		('work_shifts_management', 'holiday_hours_member', '0', 'MemberConfigHandler', '0', '0', NULL, '{\"dim_id\":$dim_id}');
	");
}


function advanced_services_update_4_5() {
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`,`uses_order`) VALUES
		 ('station', '', '', 'dimension_group', 'station', (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='advanced_services'), 0)
		ON DUPLICATE KEY UPDATE id=id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_types` (`dimension_id`,`object_type_id`,`is_root`,`options`) VALUES 
		 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'station'), 1, '{\"defaultAjax\":{\"controller\":\"dashboard\", \"action\": \"main_dashboard\"}}')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
		 SELECT
		 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='customer_project'),
		 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='station'),
		 	`id`, 0, 1
		 FROM `".TABLE_PREFIX."object_types`
		 WHERE  `type` IN ('content_object', 'comment', 'located')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_hierarchies` (dimension_id, parent_object_type_id, child_object_type_id)
		VALUES 
		(
		  (SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'customer'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'station')
		 ),(
		  (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='customer_project'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'folder'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'station')
		 ),(
		  (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='customer_project'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'project'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'station')
		 ),(
		  (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='customer_project'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'customer_folder'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'station')
		 ),(
		  (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='customer_project'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'project_folder'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'station')
		);
	");
	
	if (Plugins::instance()->isActivePlugin('member_custom_properties')) {
		
		if (!check_member_custom_prop_exists(TABLE_PREFIX, 'color_special', 'station')) {
			DB::execute("
				INSERT INTO `".TABLE_PREFIX."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
				SELECT mt.id, 'Color', 'color_special','color','','','',0,0,0,30,1, 1, 0
				FROM ".TABLE_PREFIX."object_types mt WHERE mt.`type` IN ('dimension_object','dimension_group') AND name IN ('station')
				ON DUPLICATE KEY UPDATE `code`=`code`;
			");
		}
		
		if (!check_member_custom_prop_exists(TABLE_PREFIX, 'description_special', 'station')) {
			DB::execute("
				INSERT INTO `".TABLE_PREFIX."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
				SELECT mt.id, 'Description', 'description_special', 'memo','','','',0,0,0,31,1, 1, 0
				FROM ".TABLE_PREFIX."object_types mt WHERE mt.`type` IN ('dimension_object','dimension_group') AND name IN ('station')
				ON DUPLICATE KEY UPDATE `code`=`code`;
			");
		}
	}
	
}


function advanced_services_update_5_6() {
	$dim_id = Dimensions::findByCode('hour_types')->getId();
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
			('work_shifts_management', 'min_night_hours', '0', 'IntegerConfigHandler', '1', '0', NULL, '');
	");
}


function advanced_services_update_6_7() {

}


function advanced_services_update_7_8() {
	$dim_id = Dimensions::findByCode('hour_types')->getId();
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
			('work_shifts_management', 'min_percentage_to_mark_night_hours', '0', 'IntegerConfigHandler', '1', '0', NULL, ''),
			('work_shifts_management', 'break_hours_member', '0', 'MemberConfigHandler', '0', '0', NULL, '{\"dim_id\":$dim_id}'),
			('work_shifts_management', 'break_not_taken_hours_member', '0', 'MemberConfigHandler', '0', '0', NULL, '{\"dim_id\":$dim_id}'),
			('work_shifts_management', 'default_break_minutes', '30', 'IntegerConfigHandler', '0', '0', NULL, ''),
			('work_shifts_management', 'default_break_min_hours', '8', 'IntegerConfigHandler', '0', '0', NULL, ''),
			('work_shifts_management', 'default_break_every_x_hours', '4', 'IntegerConfigHandler', '0', '0', NULL, '');
	");

	$serv_dim_id = Dimensions::findByCode('service_types')->getId();
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
			('work_shifts_management', 'holiday_service_member', '0', 'MemberConfigHandler', '0', '0', NULL, '{\"dim_id\":$serv_dim_id}');
	");
	
	if (!check_column_exists(TABLE_PREFIX."work_shifts", "break_minutes")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."work_shifts`
				ADD `break_minutes` int(10) NOT NULL DEFAULT 0,
				ADD `break_min_hours` int(10) NOT NULL DEFAULT 0,
				ADD `break_every_x_hours` int(10) NOT NULL DEFAULT 0;
		");
	}
	
	if (!check_column_exists(TABLE_PREFIX."contact_shifts", "takes_break")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."contact_shifts` ADD `takes_break` tinyint(1) NOT NULL DEFAULT 1;
		");
	}
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_hierarchies` (dimension_id, parent_object_type_id, child_object_type_id)
		VALUES
		(
		  (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='service_types'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'service_type'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'service_type')
		),(
		  (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='hour_types'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'hour_type'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'hour_type')
		);
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."custom_properties` (`object_type_id`,`name`,`code`,`type`,`description`,`values`,`default_value`,`is_required`,`is_multiple_values`,`property_order`,`visible_by_default`,`show_in_lists`,`is_special`, `is_disabled`) VALUES
		 ((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='task'),'Add worked hours when complete','add_worked_hours_on_complete','boolean','','','',0,0,20,1,0,1,0),
		 ((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='task'),'Takes break','takes_break','boolean','','','1',0,0,20,1,0,1,0)
		ON DUPLICATE KEY UPDATE object_type_id=object_type_id;
	");
}


function advanced_services_update_8_9() {
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
		('general', 'dont allow unavailable users assign', 0, 'BoolConfigHandler', '0', '0', NULL);
	");
}


function advanced_services_update_9_10() {
	
}

function advanced_services_update_10_11() {
	DB::execute("
		UPDATE ".TABLE_PREFIX."config_options SET config_handler_class='TimeAmountConfigHandler' 
		WHERE name IN ('min_night_hours','default_break_min_hours','default_break_every_x_hours');
	");
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."work_shifts`
		CHANGE `break_min_hours` `break_min_minutes` int(10) NOT NULL DEFAULT '0' AFTER `break_minutes`,
		CHANGE `break_every_x_hours` `break_every_x_minutes` int(10) NOT NULL DEFAULT '0' AFTER `break_min_minutes`;
	");
	DB::execute("
		UPDATE `".TABLE_PREFIX."work_shifts` SET break_min_minutes=break_min_minutes*60;
	");
	DB::execute("
		UPDATE `".TABLE_PREFIX."work_shifts` SET break_every_x_minutes=break_every_x_minutes*60;
	");
}


function advanced_services_update_11_12() {
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."work_shift_days` ADD `is_day_off` tinyint(1) NOT NULL DEFAULT '0';
	");
	
	$dim_id = Dimensions::findByCode('hour_types')->getId();
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
			('work_shifts_management', 'day_off_hours_member', '0', 'MemberConfigHandler', '0', '0', NULL, '{\"dim_id\":$dim_id}');
	");
}

function advanced_services_update_12_13() {
	// add column for resource type users
	if (!check_column_exists(TABLE_PREFIX."contacts", "is_resource")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."contacts` ADD COLUMN `is_resource` BOOLEAN NOT NULL DEFAULT 0;
		");
	}
}


function advanced_services_update_13_14() {
	$ot = ObjectTypes::findByName('timeslot');
	
	// create workday custom property if not exists
	$cp = CustomProperties::getCustomPropertyByCode($ot->getId(), 'workday');
	if (!$cp instanceof CustomProperty) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."custom_properties` (`object_type_id`,`name`,`code`,`type`,`description`,`values`,`default_value`,`is_required`,`is_multiple_values`,`property_order`,`visible_by_default`,`show_in_lists`,`is_special`, `is_disabled`) VALUES 
			 ((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='timeslot'),'Workday','workday','date','','','',0,0,20,1,0,1,0)
			ON DUPLICATE KEY UPDATE object_type_id=object_type_id;
		");
		$cp = CustomProperties::getCustomPropertyByCode($ot->getId(), 'workday');
	}
	if (!$cp instanceof CustomProperty) {
		return;
	}
	
	// clean custom property values for workday cp
	DB::execute("DELETE FROM ".TABLE_PREFIX."custom_property_values WHERE custom_property_id=".$cp->getId());
	
	
	// fill custom property values for workday cp
	$sql = "
		INSERT INTO ".TABLE_PREFIX."custom_property_values (object_id, custom_property_id, `value`)
			SELECT ts.object_id, ".$cp->getId().", 
			IF (t.start_date > 0, 
				DATE(ADDDATE(t.start_date, INTERVAL o.timezone_value SECOND)), 
				IF (t.due_date > 0, 
					DATE(ADDDATE(t.due_date, INTERVAL o.timezone_value SECOND)), 
					DATE(ADDDATE(ts.start_time, INTERVAL tso.timezone_value SECOND))
				)
			) as cpvalue
			
			FROM ".TABLE_PREFIX."timeslots ts
			LEFT JOIN ".TABLE_PREFIX."objects tso ON tso.id = ts.object_id
			LEFT JOIN ".TABLE_PREFIX."project_tasks t ON ts.rel_object_id = t.object_id
			LEFT JOIN ".TABLE_PREFIX."objects o ON o.id = t.object_id
			LEFT JOIN ".TABLE_PREFIX."custom_property_values v ON ts.object_id = v.object_id AND v.custom_property_id=".$cp->getId()."
			WHERE v.value IS NULL
		ON DUPLICATE KEY UPDATE ".TABLE_PREFIX."custom_property_values.object_id=".TABLE_PREFIX."custom_property_values.object_id;
	";
	DB::execute($sql);
	
}


function advanced_services_update_14_15() {
	$dim_id = Dimensions::findByCode('service_types')->getId();
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
			('work_shifts_management', 'night_service_member', '0', 'MemberConfigHandler', '0', '0', NULL, '{\"dim_id\":$dim_id}');
	");
}


// New dimension configuration
function advanced_services_update_15_16() {
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimensions` (`code`,`name`,`is_root`,`is_manageable`,`allows_multiple_selection`,`defines_permissions`,`default_order`, `is_default`, `options`, `permission_query_method`) VALUES 
		('hour_types_night','Hour night types',1,1,0,0,17,0,'', 'not_mandatory' ),
		('hour_types_extra','Hour extra types',1,1,0,0,18,0,'', 'not_mandatory' ),
		('hour_types_break','Hour break types',1,1,0,0,19,0,'', 'not_mandatory' ),
		('hour_types_weapon','Hour weapon types',1,1,0,0,20,0,'', 'not_mandatory' );
	");
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."dimension_options (`dimension_id`, `name`, `value`)
			SELECT d.id, 'useLangs', '1' FROM `".TABLE_PREFIX."dimensions` d
			WHERE d.`code` IN ('service_types','hour_types','hour_types_night','hour_types_extra','hour_types_break','hour_types_weapon')
		ON DUPLICATE KEY UPDATE `value`=`value`;
	");
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."dimension_options (`dimension_id`, `name`, `value`)
			SELECT d.id, 'showInPaths', '1' FROM `".TABLE_PREFIX."dimensions` d
			WHERE d.`code` IN ('service_types','hour_types','hour_types_night','hour_types_extra','hour_types_break','hour_types_weapon')
		ON DUPLICATE KEY UPDATE `value`=`value`;
	");
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`,`uses_order`) VALUES
		 ('hour_type_night', '', '', 'dimension_group', 'hour_type_night', (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='advanced_services'), 0),
		 ('hour_type_extra', '', '', 'dimension_group', 'hour_type_extra', (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='advanced_services'), 0),
		 ('hour_type_break', '', '', 'dimension_group', 'hour_type_break', (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='advanced_services'), 0),
		 ('hour_type_weapon', '', '', 'dimension_group', 'hour_type_weapon', (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='advanced_services'), 0)
		ON DUPLICATE KEY UPDATE id=id;
	");
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_types` (`dimension_id`,`object_type_id`,`is_root`,`options`) VALUES 
		 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'hour_types_night'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'hour_type_night'), 1, '{\"defaultAjax\":{\"controller\":\"dashboard\", \"action\": \"main_dashboard\"}}'),
		 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'hour_types_extra'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'hour_type_extra'), 1, '{\"defaultAjax\":{\"controller\":\"dashboard\", \"action\": \"main_dashboard\"}}'),
		 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'hour_types_break'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'hour_type_break'), 1, '{\"defaultAjax\":{\"controller\":\"dashboard\", \"action\": \"main_dashboard\"}}'),
		 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'hour_types_weapon'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'hour_type_weapon'), 1, '{\"defaultAjax\":{\"controller\":\"dashboard\", \"action\": \"main_dashboard\"}}')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	DB::execute("
		UPDATE `".TABLE_PREFIX."dimension_object_type_contents` SET is_multiple=0
		WHERE `dimension_object_type_id` = (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'hour_type');
	");
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
		 SELECT
		 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='hour_types'),
		 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='hour_type'),
		 	`id`, 0, 0
		 FROM `".TABLE_PREFIX."object_types`
		 WHERE  `name` IN ('timeslot','task')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
		 SELECT
		 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='hour_types_night'),
		 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='hour_type_night'),
		 	`id`, 0, 0
		 FROM `".TABLE_PREFIX."object_types`
		 WHERE  `name` IN ('timeslot')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
		 SELECT
		 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='hour_types_extra'),
		 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='hour_type_extra'),
		 	`id`, 0, 0
		 FROM `".TABLE_PREFIX."object_types`
		 WHERE  `name` IN ('timeslot')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
		 SELECT
		 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='hour_types_break'),
		 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='hour_type_break'),
		 	`id`, 0, 0
		 FROM `".TABLE_PREFIX."object_types`
		 WHERE  `name` IN ('timeslot')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
		 SELECT
		 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='hour_types_weapon'),
		 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='hour_type_weapon'),
		 	`id`, 0, 0
		 FROM `".TABLE_PREFIX."object_types`
		 WHERE  `name` IN ('timeslot')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_hierarchies` (dimension_id, parent_object_type_id, child_object_type_id)
		VALUES 
		(
		  (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code = 'hour_types_night'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'hour_type_night'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'hour_type_night')
		 ),(
		  (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code = 'hour_types_extra'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'hour_type_extra'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'hour_type_extra')
		 ),(
		  (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code = 'hour_types_break'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'hour_type_break'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'hour_type_break')
		 ),(
		  (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code = 'hour_types_weapon'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'hour_type_weapon'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'hour_type_weapon')
		);
	");
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`) VALUES
		 ('listing preferences', 'lp_dim_hour_types_night_show_as_column', '1', 'BoolConfigHandler', 0, 0),
		 ('listing preferences', 'lp_dim_hour_types_extra_show_as_column', '1', 'BoolConfigHandler', 0, 0),
		 ('listing preferences', 'lp_dim_hour_types_break_show_as_column', '1', 'BoolConfigHandler', 0, 0),
		 ('listing preferences', 'lp_dim_hour_types_weapon_show_as_column', '1', 'BoolConfigHandler', 0, 0)
		ON DUPLICATE KEY UPDATE name=name;
	");
	DB::execute("
		UPDATE `".TABLE_PREFIX."config_options` SET options=CONCAT('{\"dim_id\":',(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='hour_types_extra'),'}')
		WHERE `name`='extra_hours_member';
	");
	DB::execute("
		UPDATE `".TABLE_PREFIX."config_options` SET options=CONCAT('{\"dim_id\":',(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='hour_types_extra'),'}')
		WHERE `name`='normal_hours_member';
	");
	DB::execute("
		UPDATE `".TABLE_PREFIX."config_options` SET options=CONCAT('{\"dim_id\":',(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='hour_types_break'),'}')
		WHERE `name`='break_hours_member';
	");
	DB::execute("
		UPDATE `".TABLE_PREFIX."config_options` SET options=CONCAT('{\"dim_id\":',(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='hour_types_break'),'}')
		WHERE `name`='break_not_taken_hours_member';
	");
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
		('work_shifts_management', 'common_hours_member', '0', 'MemberConfigHandler', '0', '0', NULL, CONCAT('{\"dim_id\":',(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='hour_types'),'}')),
		('work_shifts_management', 'day_hours_member', '0', 'MemberConfigHandler', '0', '0', NULL, CONCAT('{\"dim_id\":',(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='hour_types_night'),'}')),
		('work_shifts_management', 'with_weapon_hours_member', '0', 'MemberConfigHandler', '0', '0', NULL, CONCAT('{\"dim_id\":',(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='hour_types_weapon'),'}')),
		('work_shifts_management', 'no_weapon_hours_member', '0', 'MemberConfigHandler', '0', '0', NULL, CONCAT('{\"dim_id\":',(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='hour_types_weapon'),'}')),
		('work_shifts_management', 'with_weapon_service_member', '0', 'MemberConfigHandler', '0', '0', NULL, CONCAT('{\"dim_id\":',(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='service_types'),'}')),
		('work_shifts_management', 'worked_hour_type_members', '0', 'MemberConfigHandler', '0', '0', NULL, CONCAT('{\"dim_id\":',(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='hour_types'),', \"is_multiple\":1}')),
		('work_shifts_management', 'time_between_workdays', '6:0', 'TimeAmountConfigHandler', '0', '0', NULL, '');
	");


	if (Plugins::instance()->isActivePlugin('member_custom_properties')) {
	
		if (!check_member_custom_prop_exists(TABLE_PREFIX, 'color_special', 'hour_type_night')) {
			DB::execute("
				INSERT INTO `".TABLE_PREFIX."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
				SELECT mt.id, 'Color', 'color_special','color','','','',0,0,0,30,1, 1, 0
				FROM ".TABLE_PREFIX."object_types mt WHERE mt.`type` IN ('dimension_group') AND name IN ('hour_type_night','hour_type_extra','hour_type_break','hour_type_weapon')
				ON DUPLICATE KEY UPDATE `code`=`code`;
			");
		}
	
		if (!check_member_custom_prop_exists(TABLE_PREFIX, 'description_special', 'hour_type_night')) {
			DB::execute("
				INSERT INTO `".TABLE_PREFIX."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
				SELECT mt.id, 'Description', 'description_special', 'memo','','','',0,0,0,31,1, 1, 0
				FROM ".TABLE_PREFIX."object_types mt WHERE mt.`type` IN ('dimension_group') AND name IN ('hour_type_night','hour_type_extra','hour_type_break','hour_type_weapon')
				ON DUPLICATE KEY UPDATE `code`=`code`;
			");
		}
	}
}

function advanced_services_update_16_17() {
	// enable hour types dimension plugin
	DB::execute("
		UPDATE ".TABLE_PREFIX."plugins
		SET is_installed=1, is_activated=1
		WHERE name='hour_types';
	");
}

function advanced_services_update_17_18() {
	$root = ROOT;
	$root_exploded = @explode("/", $root);
	$install = end ($root_exploded);
	if (!in_array($install, array('fidelis', 'segor', 'sigma_seguridad'))) {
		DB::execute("
			UPDATE `".TABLE_PREFIX."custom_properties` 
			SET `is_disabled` = '1' 
			WHERE `code` = 'workday';
		");
	}
}

function advanced_services_update_18_19() {
	DB::execute("
	INSERT INTO `".TABLE_PREFIX."objects` (`object_type_id`, `name`, `created_on`, `created_by_id`, `updated_on`, `updated_by_id`, `trashed_by_id`, `archived_by_id`) VALUES
	((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report'), 'billing and cost by client report', NOW(), 0, NOW(), 0, 0, 0);
	");

	DB::execute("
	INSERT INTO `".TABLE_PREFIX."reports` (`object_id`, `description`, `report_object_type_id`, `is_order_by_asc`, `ignore_context`, `is_default`, `code`, `function_url`) VALUES
	((SELECT max(id) FROM ".TABLE_PREFIX."objects WHERE object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report')), 'billing and cost by client report description', (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='billing'), 1, 1, 1, 'billing_by_client_report', '?c=advanced_timeslot_reports&a=grouped_timeslots_p&preset=billing_and_cost_by_client');
	");

	DB::execute("
	INSERT INTO `".TABLE_PREFIX."objects` (`object_type_id`, `name`, `created_on`, `created_by_id`, `updated_on`, `updated_by_id`, `trashed_by_id`, `archived_by_id`) VALUES
	((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report'), 'worked time by person and hour type report', NOW(), 0, NOW(), 0, 0, 0);
	");

	DB::execute("
	INSERT INTO `".TABLE_PREFIX."reports` (`object_id`, `description`, `report_object_type_id`, `is_order_by_asc`, `ignore_context`, `is_default`, `code`, `function_url`) VALUES
	((SELECT max(id) FROM ".TABLE_PREFIX."objects WHERE object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report')), 'worked time by person and hour type report description', (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='billing'), 1, 1, 1, 'worked_time_report', '?c=advanced_timeslot_reports&a=grouped_timeslots_p&preset=worked_time_by_person_and_hour_type');
	");
}