<?php 



function calculate_number_using_template_formula($template_formula, $parameterValues, $property = '') {

	$terms = array();
	$term_ops = array();
	$time_unit = null;
	$allowed_term_separators = array("+","-","*","/","stop");
	
	// parse the variable defined formula
	$splitted = explode('|', $template_formula);
	foreach ($splitted as $part) {
		if (str_starts_with($part, 'unit=')) {
			$time_unit = str_replace('unit=', '', $part);
		} else {
			if (in_array($part, $allowed_term_separators)) {
				$term_ops[] = $part;
			} else {
				$terms[] = $part;
			}
		}
	}

	$formula = "";

	foreach ($terms as $k => $term) {

		// get the variable name
		$var_name = substr($term, 1, strpos($term, '}') - 1);
		$var_name = str_replace("'", "", $var_name);

		// get the fixed amount
		$fixed_amount = substr($term, strpos($term, '}')+2);
		if ($fixed_amount == '') $fixed_amount = 0;

		if ($var_name == '_fixed_num_') {

			$formula .= "($fixed_amount)";

		} else {
			
			// replace variable with entered value
			$var_value = array_var($parameterValues, $var_name, 0);
	
			// get the operator
			$term_op = substr($term, strpos($term, '}')+1, 1);
	
			// prevent division by zero inside terms
			if ($term_op == "/" && $fixed_amount == 0) {
				$fixed_amount = 1;
			}
	
			// build the formula part for this term
			$formula .= "($var_value $term_op $fixed_amount)";
		}

		// concatenate the operator
		if ($term_ops[$k] != 'stop') {
			$formula .= " ".$term_ops[$k]." ";
		} else {
			$formula .= ";";
		}

	}

	if (!str_ends_with($formula, ';')) $formula .= ";";

	$final_value = 0;
	// evaluate the formula
	eval('$final_value = '.$formula);

	if ($time_unit != null && $property == 'time_estimate') {
		// if estimated time is specified in an unit different than minutes then convert it to minutes
		$final_value = convert_time_amount_to_minutes($time_unit, $final_value);
	}

	return $final_value;
}