og.advanced_templates = {
	init : function() {
		if (!og.templates) og.templates = { datetypes: ['date'] };
		og.templates.datetypes.push('datetime');
		
		if (!og.templates.more_var_types) og.templates.more_var_types = [];
		og.templates.more_var_types.push('datetime');
		
		if (!og.templates.more_param_prompt_items) og.templates.more_param_prompt_items = [];
		og.templates.more_param_prompt_items.push({
	    	xtype: 'checkbox',
	    	fieldLabel: lang('required'),
	    	id: 'paramIsRequired',
	    	name: 'is_required'
	    });
		
		if (!og.templates.init_param_functions) og.templates.init_param_functions = {};
		og.templates.init_param_functions['paramIsRequired'] = function(is_edit, pos) {
			if (is_edit) {
				
			}
		}
		
		
		if (!og.templates.after_param_prompt_ok) og.templates.after_param_prompt_ok = [];
		og.templates.after_param_prompt_ok.push(function(pos) {
			var name_field_id = "paramName_" + pos;
			var req_span_id = "reqChar_" + pos;
			
			var is_req = Ext.getCmp('paramIsRequired').getValue();
			
			$("#"+name_field_id+" #"+req_span_id).remove();
			if (is_req) {
				$("#"+name_field_id).append('<span id="'+req_span_id+'" class="bold"> *</span>');
			}
			
			var hf_id = 'parameters_'+pos+'_is_required';
			var hf_input = '<input type="hidden" name="parameters['+pos+'][is_required]" id="'+hf_id+'" value="'+(is_req?'1':'0')+'">';
			
			$("#"+hf_id).remove();
			$("#"+name_field_id).closest(".og-add-template-object").append(hf_input);
		});


		og.override_template_numeric_property_selector = function(count, obj_id, value) {

			og.advanced_templates.render_numeric_property_selector(count, obj_id, value);

		}

		og.override_template_date_amount_input = function(obj_id, prop) {
			html = '';
			
			// selectbox with numeric variables
			selectNumParamType = '<select name="propValueNumType[' + obj_id + '][' + prop + ']" id="propValueNumType[' + obj_id + '][' + prop + ']" onchange="og.advanced_templates.date_prop_num_type_change(this,\''+obj_id+'\',\''+prop+'\');" >';
			selectNumParamType += '<option value="fixed">'+ lang('fixed num') +'</option>';
			for (var j=0; j < og.templateParameters.length; j++) {
				var item = og.templateParameters[j];
				if (item.type.toUpperCase() == "NUMERIC") {
					selectNumParamType += '<option value="'+ item['name'] +'">' + item['name'] + '</option>';
				}
			}
			selectNumParamType += '</select>&nbsp;';
			html += selectNumParamType;

			// default amount input
			html += '<input name="propValueAmount[' + obj_id + '][' + prop + ']" id="propValueAmount[' + obj_id + '][' + prop + ']" style="width:50px;" type="number" step="any" />';

			// operator input
			var operator = '+';
			html += '<select name="propValueNumOp[' + obj_id + '][' + prop + ']" id="propValueNumOp[' + obj_id + '][' + prop + ']">' +
				'<option value="+" '+ (operator == "+" ? 'selected="selected"' : '') +'>+</option>' +
				'<option value="-" '+ (operator == "-" ? 'selected="selected"' : '') +'>-</option>' +
				'<option value="*" '+ (operator == "*" ? 'selected="selected"' : '') +'>*</option>' +
				'<option value="/" '+ (operator == "/" ? 'selected="selected"' : '') +'>/</option>' +
			'</select>&nbsp;';

			// number to use with the variable and formula
			html += '<input name="propValueNumConst[' + obj_id + '][' + prop + ']" id="propValueNumConst[' + obj_id + '][' + prop + ']" style="width:50px;" type="number" step="any" />';

			return html;
		}

		og.override_template_date_amount_input_init = function (obj_id, prop, amount) {

			if (isNaN(amount)) {

				var pos_op = amount.indexOf('}') + 1;
				var variable = amount.substring(0, pos_op);
				var oper = amount.substring(pos_op, pos_op + 1);
				var const_num = amount.substring(pos_op + 1, amount.length);

				if (variable != 'fixed') {
					variable = amount.substring(1, pos_op - 1); // exclude brackets
				}

				var num_type_el = document.getElementById('propValueNumType[' + obj_id + '][' + prop.value + ']');
				for(i=0; i < num_type_el.length; i++){
					if (num_type_el.options[i].value == variable) num_type_el.selectedIndex = i;
				}

				var op_sel = document.getElementById('propValueNumOp[' + obj_id + '][' + prop.value + ']');
				for(i=0; i < op_sel.length; i++){
					if (op_sel.options[i].value == oper) op_sel.selectedIndex = i;
				}

				var const_input = document.getElementById('propValueNumConst[' + obj_id + '][' + prop.value + ']');
				if (const_input) const_input.value = const_num;

			} else {
				var amountInput = document.getElementById('propValueAmount[' + obj_id + '][' + prop.value + ']');
				amountInput.value = amount;
			}

			og.advanced_templates.date_prop_num_type_change(document.getElementById('propValueNumType[' + obj_id + '][' + prop.value + ']'), obj_id, prop.value);

		}

	},

	
	date_prop_num_type_change: function(input, obj_id, prop) {
		
		var amount_el = document.getElementById('propValueAmount[' + obj_id + '][' + prop + ']');
		var op_el = document.getElementById('propValueNumOp[' + obj_id + '][' + prop + ']');
		var const_el = document.getElementById('propValueNumConst[' + obj_id + '][' + prop + ']');

		if ($(input).val() == 'fixed') {
			if (amount_el) $(amount_el).show();
			if (op_el) $(op_el).hide();
			if (const_el) $(const_el).hide();
		} else {
			if (amount_el) $(amount_el).hide();
			if (op_el) $(op_el).show();
			if (const_el) $(const_el).show();
		}

	},

	render_numeric_property_selector: function(count, obj_id, value) {

		var numericPropTD = document.getElementById('numericPropTD[' + obj_id + '][' + count + ']');
		numericPropTD.innerHTML = '';

		var html = '=&nbsp;';
	
		if (value == '') {
			html += og.advanced_templates.get_numeric_formula_term_html(count, obj_id, 0, '', '');
		} else {

			var terms = [];
			var term_ops = [];
			var splitted = value.split('|');
			var unit = '';
			for (var i=0; i<splitted.length; i++) {
				var part = splitted[i];

				if (part.indexOf('unit=') == 0) {

					unit = part.replace("unit=", "");

				} else {

					if (part == '+' || part == '-' || part == '*' || part == '/' || part == 'stop') {
						term_ops.push(part);
					} else {
						terms.push(part);
					}
				}
			}

			for (var i=0; i<terms.length; i++) {
				var term = terms[i];
				var term_op = term_ops[i];
				
				html += og.advanced_templates.get_numeric_formula_term_html(count, obj_id, i, term, term_op);
			}
		}

		var propertySel = document.getElementById('objectProperties[' + obj_id + '][' + count + ']');
		var prop = propertySel[propertySel.selectedIndex].value;
		if (prop == 'time_estimate') {
			if (!unit) unit = 'h';

			html += '&nbsp;' + lang('unit') + ': ';
			html += og.buildTimeUnitSelectorHtml(obj_id, prop, unit, 'propValueUnit');
		}
		
		numericPropTD.innerHTML = html;

	},


	get_numeric_formula_term_html: function(count, obj_id, term_index, term_value, next_operator) {

		var html = '<span id="formulaTerm_'+ count +'_'+ obj_id +'_'+ term_index +'">';

		var propertySel = document.getElementById('objectProperties[' + obj_id + '][' + count + ']');
		var prop = propertySel[propertySel.selectedIndex].value;

		var param = '';
		var operator = '';
		var amount = '';

		if (term_value != '') {
			var op_start_pos = term_value.indexOf('}') + 1;
			var op_end_pos = op_start_pos + 1;

			param = term_value.substring(0, op_start_pos);
			operator = term_value.substring(op_start_pos, op_end_pos);
			amount = term_value.substring(op_end_pos);
		}

		// numeric variable selector
		var selectParam = '<select name="propValueParam[' + obj_id + '][' + prop + '][num_formula]['+ term_index +']" id="propValueParam[' + obj_id + '][' + prop + '][num_formula]['+ term_index +']"'
			+ ' onchange="og.advanced_templates.on_term_var_selector_change(this, \''+obj_id+'\', \''+prop+'\', \''+term_index+'\')">';
		
		// options for template variables
		for (var j=0; j < og.templateParameters.length; j++) {
			var item = og.templateParameters[j];
			if (item.type.toUpperCase() == "NUMERIC") {
				var param_selected = param == '{'+item['name']+'}' ? 'selected="selected"' : '';
				selectParam += '<option value="'+ item['name'] +'" '+ param_selected +'>' + item['name'] + '</option>';
			}
		}
		
		// option for fixed number
		param_selected = param == '{_fixed_num_}' ? 'selected="selected"' : '';
		selectParam += '<option value="_fixed_num_" '+ param_selected +'>' + lang('fixed num') + '</option>';
		
		selectParam += '</select>';

		html += '(<input type="hidden" name="propValues[' + obj_id + '][' + prop + '][num_formula]['+ term_index +']">' + 
			selectParam + '&nbsp;';

		// operator
		html += '<select name="propValueOperation[' + obj_id + '][' + prop + '][num_formula]['+ term_index +']" id="propValueOperation[' + obj_id + '][' + prop + '][num_formula]['+ term_index +']"'
			+ (param == '{_fixed_num_}' ? 'style="display:none;"' : '') + '>' +
			'<option value="+" '+ (operator == "+" ? 'selected="selected"' : '') +'>+</option>' +
			'<option value="-" '+ (operator == "-" ? 'selected="selected"' : '') +'>-</option>' +
			'<option value="*" '+ (operator == "*" ? 'selected="selected"' : '') +'>*</option>' +
			'<option value="/" '+ (operator == "/" ? 'selected="selected"' : '') +'>/</option>' +
		'</select>&nbsp;';

		// numeric input
		html += '<input type="number" step="any" name="propValueAmount[' + obj_id + '][' + prop + '][num_formula]['+ term_index +']" id="propValueAmount[' + obj_id + '][' + prop + '][num_formula]['+ term_index +']" style="width:50px;" value="'+amount+'"/>';
	
		html += ')&nbsp;';

		// term operator "+", "-" or "stop"
		if (!next_operator) next_operator = "stop";
		html += '<select name="propValueTermOperation[' + obj_id + '][' + prop + '][num_formula]['+ term_index +']" ' +
			'id="propValueTermOperation[' + obj_id + '][' + prop + '][num_formula]['+ term_index +']" ' +
			'onchange="og.advanced_templates.on_term_operator_change(this, '+count+', '+obj_id+', '+term_index+')">' +

			'<option value="+" '+ (next_operator == "+" ? 'selected="selected"' : '') +'>+</option>' +
			'<option value="-" '+ (next_operator == "-" ? 'selected="selected"' : '') +'>-</option>' +
			'<option value="*" '+ (next_operator == "*" ? 'selected="selected"' : '') +'>*</option>' +
			'<option value="/" '+ (next_operator == "/" ? 'selected="selected"' : '') +'>/</option>' +
			'<option value="stop" '+ (next_operator == "stop" ? 'selected="selected"' : '') +'>'+ lang('stop') +'</option>' +
		'</select>&nbsp;';

		html += '</span>';

		return html;
	},

	on_term_var_selector_change: function(input, obj_id, prop, term_index) {
		var term_oper_input = document.getElementById('propValueOperation[' + obj_id + '][' + prop + '][num_formula]['+ term_index +']');
		if (!term_oper_input) return;

		if ($(input).val() == '_fixed_num_') {
			$(term_oper_input).hide();
		} else {
			$(term_oper_input).show();
		}
	},


	/**
	 * if selected value is + or - then draw next term (if not exists)
	 * else remove all terms with index > term_index
	 */
	on_term_operator_change: function(selector, count, obj_id, term_index) {
		
		if ($(selector).val() == 'stop') {

			og.advanced_templates.remove_next_terms(count, obj_id, term_index + 1);

		} else {

			var next_term_index = term_index + 1;
			var next_term_id = 'formulaTerm_'+ count +'_'+ obj_id +'_'+ next_term_index;

			if ($("#" + next_term_id).length == 0) {
				
				var next_term_html = og.advanced_templates.get_numeric_formula_term_html(count, obj_id, next_term_index, '', '');

				var current_term_id = 'formulaTerm_'+ count +'_'+ obj_id +'_'+ term_index;
				$("#" + current_term_id).after(next_term_html);
			}

		}
	},

	remove_next_terms: function(count, obj_id, term_index) {

		var term_id = 'formulaTerm_'+ count +'_'+ obj_id +'_'+ term_index;
		var element = document.getElementById(term_id);
		if (element) {
			element.remove();
			og.advanced_templates.remove_next_terms(count, obj_id, term_index + 1);
		}

	}

	
}