<?php

/**
 * @version 1.0
 * @author Alvaro Torterola <alvaro.torterola@fengoffice.com>
 */

class AffinityReportsController extends ApplicationController {

	/**
	 * Construct the ReportingController
	 *
	 * @access public
	 * @param void
	 * @return ReportingController
	 */
	function __construct()
	{
		parent::__construct();
		prepare_company_website_controller($this, 'website');
		Env::useHelper('grouping');
        Env::useHelper('reporting');
		Env::useHelper('advanced_reports', 'advanced_reports');
	} // __construct


	
	function member_export_report_p(){
		$report_data = array();
		
		tpl_assign('report_data', $report_data);
	}
	

	function member_export_report($report_data = null, $csv = null) {
		
		if (!$report_data) {
			$report_data = array_var($_POST, 'report', array());
		}
		$_SESSION['member_export_report_data'] = $report_data;

		$column_names = array(

            'transaction_type'=>'Transaction Type',
            'hba_number'=>'HBA Number',
            'subscription_id'=>'Subscription ID (MSN)',
            'member_type'=>'Member Type',
            'contact_person_id'=>'Contact Person ID (PIN)',
            'contact_prefix'=>'Contact Prefix', // not necessary
            'contact_first_name'=>'Contact First Name',
            'contact_middle_name'=>'Contact Middle Name', // not necessary
            'contact_last_name'=>'Contact Last Name',
            'contact_suffix'=>'Contact Suffix', // not necessary
            'contact_title_code'=>'Contact Title Code',
            'contact_custom_title'=>'Contact Custom Title',
            'contact_primary_phone'=>'Contact Primary Phone', // not necessary
            'contact_primay_fax'=>'Contact Primary Fax', // not necessary
            'contact_email'=>'Contact Email', // not necessary
            'contact_addres_type'=>'Contact Address Type',
            'contact_country'=>'Contact Country',
            'contact_address_line'=>'Contact Address Line 1',
            'contact_address_line_2'=>'Contact Address Line 2', // not necessary
            'contact_city'=>'Contact City',
            'contact_state'=>'Contact State/Province',
            'contact_postal_code'=>'Contact Postal Code',
            'company_id'=>'Company ID',
            'company_name'=>'Company Name',
            'company_custom_sort'=>'Company Custom Sort', // not necessary
            'company_country'=>'Company Country',
            'company_address_line'=>'Company Address Line 1',
            'company_address_line_2'=>'Company Address Line 2', // not necessary
            'company_city'=>'Company City',
            'company_state'=>'Company State/Province',
            'company_postal_code'=>'Company Postal Code',
            'company_phone'=>'Company Phone', // not necessary
            'company_fax'=>'Company Fax', // not necessary
            'company_website'=>'Company Website', // not necessary
            'prymary_business_activity_code'=>'Primary Business Activity Code',
            'custom_primary_business_activity'=>'Custom Primary Business Activity',
            'secondary_business_activity_code'=>'Secondary Business Activity Code', // not necessary
            'tertiary_business_activity_code'=>'Tertiary Business Activity Code', // not necessary
            'company_number_employees'=>'Company Number of Employees',
            'dollar'=>'Dollar Volume Code', // not necessary
            'units_code'=>'Number of Units Code', // not necessary
            'spike_information_entered'=>'Spike Information Entered',
            'spike_hba_number'=>'Spike HBA Number',
            'spike_person_id'=>'Spike Person ID', // not necessary
            'spike_prefix'=>'Spike Prefix', // not necessary
            'spike_first_name'=>'Spike First Name',
            'spike_midddle_name'=>'Spike Middle Name', // not necessary
            'spike_last_name'=>'Spike Last Name',
            'spike_suffix'=>'Spike Suffix', // not necessary
            'spike_company_id'=>'Spike Company ID'
		);


		$rows = array();
		$filter = $this->generate_sql_filter($report_data);



		/* SQL FOR THE FUTURE
		$sql = "
		    SELECT o.id,c.contact_id,o.name,o.created_on,o.updated_on,m.id as member_id,cps.value FROM ".TABLE_PREFIX."objects as o
		    Left join ".TABLE_PREFIX."members as m on m.object_id = o.id
            Inner join ".TABLE_PREFIX."customers as c on c.object_id = o.id
            left join (
                Select cpv.object_id,cpv.`value` From ".TABLE_PREFIX."custom_properties as cp
                INNER JOIN ".TABLE_PREFIX."custom_property_values as cpv on cpv.custom_property_id = cp.id
                WHERE cp.object_type_id = ".$report_data['report_object_type_id']." AND cp.code = 'join_date'
            ) as cps on cps.object_id = c.object_id
            WHERE o.trashed_by_id = 0 and o.archived_by_id = 0
		".$filter;
        */

        $dateFormat = user_config_option('date_format');
        if (!empty($dateFormat)){
            $dateFormat = 'm/d/Y';
        }
        //$filter .= ' AND ';
        /*$join_date = array_var($report_data,'join_date');
        if ($join_date != 'mm/dd/yyyy' && $join_date != '') {
            $join_date = format_date(DateTimeValueLib::dateFromFormatAndString($dateFormat, $join_date), 'Y-m-d', 0);
            $join_condition = array_var($report_data, 'join_condition');
            $filter .= ' cps.value  ' . $join_condition . '"' . $join_date . '"';
        }else{
            $filter .= ' true ';
        }*/

        $sql = "
		    SELECT o.id,c.contact_id,o.name,o.created_on,o.updated_on,m.id as member_id,cps.value FROM ".TABLE_PREFIX."objects as o
		    Left join ".TABLE_PREFIX."members as m on m.object_id = o.id
            Inner join ".TABLE_PREFIX."customers as c on c.object_id = o.id
            left join (
                Select cpv.object_id,cpv.`value` From ".TABLE_PREFIX."custom_properties as cp
                INNER JOIN ".TABLE_PREFIX."custom_property_values as cpv on cpv.custom_property_id = cp.id
                WHERE cp.object_type_id = ".$report_data['report_object_type_id']." AND cp.code = 'join_date'
            ) as cps on cps.object_id = c.object_id
            WHERE o.trashed_by_id = 0 and o.archived_by_id = 0 
		".$filter;


		$final_customer_rows = array();

		$customers_rows = DB::executeAll ($sql);

        $cp_hba_number = CustomProperties::getCustomPropertyByCode($report_data['report_object_type_id'],'hba_number'); //hba_number
        $cp_contact_person_id = CustomProperties::getCustomPropertyByCode($report_data['report_object_type_id'],'person_id'); //contact_person_id
        $cp_subs_id = CustomProperties::getCustomPropertyByCode($report_data['report_object_type_id'],'subscription_id'); //subscription_id

        // CustomProperties::getCustomPropertyByCode($report_data['report_object_type_id'],'num_units'); // no es necesario

        $cp_primary_contact = CustomProperties::getCustomPropertyByCode($report_data['report_object_type_id'],'representative'); //company_number_employees

        $cp_number_employees = CustomProperties::getCustomPropertyByCode($report_data['report_object_type_id'],'num_employees'); //company_number_employees

        $cp_company_id = CustomProperties::getCustomPropertyByCode($report_data['report_object_type_id'],'company_id');

        $cp_spike_hba_number = CustomProperties::getCustomPropertyByCode($report_data['report_object_type_id'],'spike_hba_number'); //spike_hba_number
        $cp_spike_company_id = CustomProperties::getCustomPropertyByCode($report_data['report_object_type_id'],'spike_company_id'); //spike_company_id
        $cp_spike_contact = CustomProperties::getCustomPropertyByCode($report_data['report_object_type_id'],'spike_contact'); //spike_company_id


        $cp_join_date = CustomProperties::getCustomPropertyByCode($report_data['report_object_type_id'],'join_date'); //join_date

        $cp_member_type_code = CustomProperties::getCustomPropertyByCode($report_data['report_object_type_id'],'member_type_code'); //member_type

        $customer_types_object_type = ObjectTypes::findByName('customer_type');
//        $customer_stage_object_type = ObjectTypes::findByName('customer_stage');


        $cp_activity_code = MemberCustomProperties::getCustomPropertyByCode($customer_types_object_type->getId(),'activity_code');

        $customer_project_dimension = Dimensions::findByCode('customer_project');
        $customer_types_dimension = Dimensions::findByCode('customer_types');
    //    $customer_stages_dimension = Dimensions::findByCode('customer_stages');


        $dim_business_activitiy = DimensionMemberAssociations::getAssociationObject($customer_project_dimension->getId(),$report_data['report_object_type_id'],$customer_types_dimension->getId(),$customer_types_object_type->getID());

        if (!empty($customers_rows)){

        foreach ($customers_rows as $customer) {
            $row = array();
            $transaction_tpye = $this->get_transaction_type_code($customer['id'],$customer,$report_data['join_date']);
		    $row['transaction_type'] = $transaction_tpye;

            $cpv_hba_number = CustomPropertyValues::getCustomPropertyValue($customer['id'],$cp_hba_number->getId());
            if ($cpv_hba_number instanceof  CustomPropertyValue){
		        $row['hba_number'] = $cpv_hba_number->getValue();
            }

            $cpv_subs_id = CustomPropertyValues::getCustomPropertyValue($customer['id'],$cp_subs_id->getId());
            if ($cpv_subs_id instanceof  CustomPropertyValue){
                $row['subscription_id'] = $cpv_subs_id->getValue();
            }

            $cpv_member_type_code = CustomPropertyValues::getCustomPropertyValue($customer['id'],$cp_member_type_code->getId());
            if ($cpv_member_type_code instanceof  CustomPropertyValue){
                $row['member_type'] = $cpv_member_type_code->getValue();
            }

            $contact_id = null;
            $cpv_primary_contact = CustomPropertyValues::getCustomPropertyValue($customer['id'],$cp_primary_contact->getId());
            if ($cpv_primary_contact instanceof  CustomPropertyValue){
                $contact_id = $cpv_primary_contact->getValue();
            }

            $contact = null;
            $contact = Contacts::instance()->findById($contact_id);
            if($contact instanceof Contact){

                $cpv_contact_person_id = CustomPropertyValues::getCustomPropertyValue($customer['contact_id'],$cp_contact_person_id->getId());
                if ($cpv_contact_person_id instanceof CustomPropertyValue){
                    $row['contact_first_name'] = substr($cpv_contact_person_id->getValue(),0,20);
                }

                $row['contact_first_name'] = substr($contact->getFirstName(),0,20);
                $row['contact_last_name'] = substr($contact->getSurname(),0,20);
            }

            $row['contact_title_code'] = '-1'; //'contact_title_code'=>'Contact Title Code', // nose de donde sale -1 sin espesificar
            $row['contact_custom_title'] = ''; //'contact_custom_title'=>'Contact Custom Title', // tiene que decir algo si lo otro esta en -1

            $contact_address = null;
            if($contact instanceof Contact){
                //$contact_address = ContactAddresses::getAddressByTypeId($contact,1);
                $contact_addresses = ContactAddresses::instance()->getByContact($contact);
                if (!empty($contact_addresses)){
                    $contact_address = $contact_addresses[0];
                }
            }
            if ($contact_address instanceof ContactAddress){

                 //'contact_addres_type'=>'Contact Address Type' // no se todavia.
    /*
                    1 Business
                    2 Home
                    3 PO Box
    */
                $row['contact_addres_type'] = 1;
                if($contact_address->getCountry() == 'us'){
                    $row['contact_country'] = 'USA';
                }
                //$row['contact_country'] = $contact_address->getCountry();
                $row['contact_city'] = $contact_address->getCity();
                $row['contact_state'] = $contact_address->getState();
                $row['contact_postal_code'] = $contact_address->getZipCode();

                $row['contact_address_line'] = $contact_address->getStreet(); //Contact Address Line 1

            }

            $cpv_company_id= CustomPropertyValues::getCustomPropertyValue($customer['id'],$cp_company_id->getId());

            if($cpv_company_id instanceof CustomPropertyValue){
                $row['company_id'] = $cpv_company_id->getValue();
            }
            $company = Contacts::instance()->findById($customer['contact_id']);
            $company_address = null;
            if($company instanceof Contact){
                //$company_address = ContactAddresses::getAddressByTypeId($company,1);
                $company_addresses = ContactAddresses::instance()->getByContact($company);
                if (!empty($company_addresses)){
                    $company_address = $company_addresses[0];
                }
            }
            $row['company_name'] = $customer['name'];
            if ($company_address instanceof ContactAddress){

                if($company_address->getCountry() == 'us'){
                    $row['company_country'] = 'USA';
                    //$row['company_country'] = $company_address->getCountry();
                }
                $row['company_address_line'] = $company_address->getStreet();
                $row['company_city'] = $company_address->getCity();
                $row['company_state'] = $company_address->getState();
                $row['company_postal_code'] = $company_address->getZipCode();

            }

            $row['prymary_business_activity_code']; //'Primary Business Activity Code'
            $row['custom_primary_business_activity']; //'Custom Primary Business Activity'

            //DimensionMemberAssociations::getAssociatations($customer_types_dimension->getId());

            $cpv_number_employees= CustomPropertyValues::getCustomPropertyValue($customer['id'],$cp_number_employees->getId());
            if($cpv_number_employees instanceof CustomPropertyValue){
                $row['company_number_employees'] =$cpv_number_employees->getValue();
            }

            $cpv_number_employees= CustomPropertyValues::getCustomPropertyValue($customer['id'],$cp_number_employees->getId());
            if($cpv_number_employees instanceof CustomPropertyValue){
                $row['company_number_employees'] =$cpv_number_employees->getValue();
            }

            $cpv_spike_contact = CustomPropertyValues::getCustomPropertyValue($customer['id'],$cp_spike_contact->getId());
            if($cpv_spike_contact instanceof CustomPropertyValue){
                $id_contact_spike = $cpv_spike_contact->getValue();
                $spike = Contacts::instance()->findById($id_contact_spike);
                if ($spike instanceof Contact){
                    $row['spike_information_entered'] = 1; // 1 if has a spike and 0 if hasn't
                    $row['spike_first_name'] = substr($spike->getFirstName(),0,20);
                    $row['spike_last_name'] = substr($spike->getSurname(),0,20);

                    $cpv_spike_hba_number = CustomPropertyValues::getCustomPropertyValue($customer['id'],$cp_spike_hba_number->getId());
                    if($cpv_spike_hba_number instanceof CustomPropertyValue){
                        $row['spike_hba_number'] =$cpv_spike_hba_number->getValue();
                    }

                    $cpv_spike_company_id= CustomPropertyValues::getCustomPropertyValue($customer['id'],$cp_spike_company_id->getId());
                    if($cpv_spike_company_id instanceof CustomPropertyValue){
                        $row['spike_company_id'] = $cpv_spike_company_id->getValue();
                    }

                }else{
                    $row['spike_information_entered'] = 0; // 1 if has a spike and 0 if hasn't
                }
                $spike = null;
            }else{
                $row['spike_information_entered'] = 0; // 1 if has a spike and 0 if hasn't
            }
            $cpv_spike_contact = null;

            $members = MemberPropertyMembers::getAllPropertyMemberIds($dim_business_activitiy->getId(), $customer['member_id']);

            $explode_members = explode(',',$members);
            if (!empty($explode_members)){
                $first_member_id = $explode_members[0];
                $cpv_activity_code = MemberCustomPropertyValues::getMemberCustomPropertyValue($first_member_id,$cp_activity_code->getId());
                if ($cpv_activity_code instanceof MemberCustomPropertyValue){
                    $row['prymary_business_activity_code'] = $cpv_activity_code->getValue(); //'Primary Business Activity Code'
                    if ($cpv_activity_code->getValue() != ''){
                        $row['prymary_business_activity_code'] = 'Z';
                        $business_member = Members::findByObjectId($first_member_id);
                        if($business_member instanceof Member){
                            $row['custom_primary_business_activity'] = $business_member->getName(); //'Custom Primary Business Activity'
                        }else{
                            $row['custom_primary_business_activity'] = 'Other';
                        }
                    }
                }else{
                    $row['custom_primary_business_activity'] = 'Other';
                    if (!empty($first_member_id)){
                        $business_member = Members::instance()->findById($first_member_id);
                        $row['custom_primary_business_activity'] = $business_member->getName(); //'Custom Primary Business Activity'
                    }
                }
            }


            $final_customer_rows[] = $row;
		}
    }

        if ($csv) {
            return array(
                'headers' => $column_names,
                'data' => $final_customer_rows,
            );
        }

		tpl_assign('column_names', $column_names);
		tpl_assign('rows', $final_customer_rows);

		tpl_assign('title', lang('export members report'));

        tpl_assign('join_date', $report_data['join_date']);
        tpl_assign('start_date', $report_data['start_date']);
        tpl_assign('end_date', $report_data['end_date']);
		tpl_assign('post', $report_data);
		tpl_assign('allow_export', true);
		
		tpl_assign('template_name', 'member_export_report');
		tpl_assign('print_action_url', get_url('affinity_reports', 'member_export_report_print'));
		tpl_assign('excel_export_action', 'og.affinity_reports.submit_excel_form');
		tpl_assign('pdf_export_function', 'og.affinity_reports.export_contable_report_pdf');
		tpl_assign('report_template_path', get_template_path('member_export_report', 'affinity_reports'));
		
		$this->setTemplate(get_template_path('report_wrapper', 'affinity_reports', 'affinity_reports'));
	}

	function get_transaction_type_code($customer_id,$data,$join_date_validator){
        $dateFormat = user_config_option('date_format');

        $created_on = format_datetime(array_var($data,'created_on'),$dateFormat);
        $updated_on = format_datetime(array_var($data,'updated_on'),$dateFormat);
        $join_date = format_datetime(array_var($data,'value'),$dateFormat);
        $dateFormat = user_config_option('date_format');

        $join_date = format_date(DateTimeValueLib::dateFromFormatAndString($dateFormat, $join_date),DATE_MYSQL,0);
        if($join_date > $join_date_validator){ // New member
            //1 New Member
            return 1;
        }

        if (array_var($data,'created_on') != array_var($data,'updated_on')){
            /*
             2 Renewal
            3 Cancellation
            4 Contact Information Change
            5 New Contact
            6 Company Information Change
            7 New Spike
            8 Member Type Change
            13 New Company

             */
        }
	    return 1; // temporal
    }


	function generate_sql_filter($report_data){
        $dateFormat = user_config_option('date_format');
        if (!empty($dateFormat)){
            $dateFormat = 'm/d/Y';
        }
        $result = ' AND ';
	    $start_date = array_var($report_data,'start_date');
	    if ($start_date != 'mm/dd/yyyy' && $start_date != ''){
            $start_date = format_date(DateTimeValueLib::dateFromFormatAndString($dateFormat, $start_date),DATE_MYSQL,0);
           // $start_condition = array_var($report_data,'start_condition');
           // $result .= '( o.created_on '.$start_condition.' "'.$start_date.'" OR   o.updated_on '.$start_condition.' "'.$start_date.'" )';
           // $result .= '( cps.value '.$start_condition.' "'.$start_date.'" )';
            $result .= '( cps.value >= "'.$start_date.'" )';
        }else{
            $result .= ' true ';
        }
        $result .= ' AND ';
        $end_date = array_var($report_data,'end_date');
        if ($end_date != 'mm/dd/yyyy' && $end_date != ''){
            $end_date = format_date(DateTimeValueLib::dateFromFormatAndString($dateFormat, $end_date),DATE_MYSQL,0);
           // $end_condition = array_var($report_data,'end_condition');
           // $result .= '( o.created_on '.$end_condition.' "'.$end_date.'" OR  o.updated_on '.$end_condition.' "'.$end_date.'" )';
           // $result .= '( cps.value  '.$end_condition.' "'.$end_date.'" )';
            $result .= '( cps.value  <= "'.$end_date.'" )';
        }else{
            $result .= ' true ';
        }

	    return $result;
    }


	
	function member_export_report_print() {
		ajx_current("empty");
		
			$report_result = $this->member_export_report($_POST, true);
			
			$filename = str_replace(" ", "-", str_replace("/", "-", lang('export members report').".txt"));

        $headers_csv = '"' . implode('","', $report_result["headers"]) . '"' . "\n";
        $headers_csv = "";
        $rows_csv = '';
        foreach ($report_result["data"] as $row) {
				$first = true;
				foreach ($report_result["headers"] as $col_key => $col_name) {
					//$rows_csv .= ($first ? "" : "\t") . '"' . array_var($row, $col_key, ' ') . '"';
					$rows_csv .= ($first ? " " : "\t") . '' . array_var($row, $col_key, ' ') . '';
					$first = false;
				}
				$rows_csv .= "\n";
			}
			
			file_put_contents(ROOT."/tmp/$filename", $headers_csv . $rows_csv);
			

		ajx_extra_data(array('filename' => $filename));
	}

}
























