<?php
    class Absence extends BaseAbsence {
		
        protected $allow_timeslots = true;
        
        
		function getArrayInfo() {
			$info = array();
			
			$columns = $this->getColumns();
			foreach ($columns as $col) {
				$info[$col] = $this->getColumnValue($col);
				if ($info[$col] instanceof DateTimeValue) $info[$col] = format_date($info[$col], null, 0);
			}
			
			$general_info = $this->getObject()->getArrayInfo();
			$info = array_merge($info, $general_info);
			
			return $info;
		}
		
		/**
		 * Validate before save
		 *
		 * @access public
		 * @param array $errors
		 * @return null
		 */
		function validate($errors) {
		    if(!$this->validatePresenceOf('name')) {
		        $errors[] = lang('message title required');
		    }
		} // validate
		
		static function canAdd(Contact $user, $context, &$notAllowedMember = ''){
		    return can_add($user, $context, Absences::instance()->getObjectTypeId(), $notAllowedMember);
		}
		
		/**
		 * Returns true if $user can access this message
		 *
		 * @param Contact $user
		 * @return boolean
		 */
		function canView(Contact $user) {
			return can_read($user, $this->getMembers(), $this->getObjectTypeId());
		} // canView
	
		/**
		 * Check if specific user can edit this messages
		 *
		 * @access public
		 * @param Contact $user
		 * @return boolean
		 */
		function canEdit(Contact $user) {
			return can_write($user, $this->getMembers(), $this->getObjectTypeId());
		} // canEdit
	
	
		/**
		 * Check if specific user can delete this messages
		 *
		 * @access public
		 * @param Contact $user
		 * @return boolean
		 */
		function canDelete(Contact $user) {
			return can_delete($user, $this->getMembers(), $this->getObjectTypeId());
		} // canDelete
	
		/**
		 * Check if specific user can comment this message
		 *
		 * @access public
		 * @param void
		 * @return boolean
		 */
		function canAddComment(Contact $user) {
			return can_write($user, $this->getMembers(), $this->getObjectTypeId());
		} // canAddComment
		
		/**
		 * Return the user that last assigned the task
		 *
		 * @access public
		 * @param void
		 * @return Contact
		 */
		/*
		function getAssignedBy() {
		    return Contacts::instance()->findById($this->getAssignedById());
		} // getAssignedBy()
		*/
		
		/**
		 * Return owner user or company
		 *
		 * @access public
		 * @param void
		 * @return ApplicationDataObject
		 */
		/*
		function getAssignedTo() {
		    if($this->getContactId() > 0) {
		        return $this->getAssignedToContact();
		    } else {
		        return null;
		    } // if
		} // getAssignedTo
		
		function getAssignedToName() {
		    $user = $this->getAssignedToContact();
		    if ($user instanceof Contact) {
		        return $user->getObjectName();
		    } else {
		        return lang("anyone");
		    } // if
		} // getAssignedTo
		*/
		/**
		 * Return owner user
		 *
		 * @access public
		 * @param void
		 * @return Contact
		 */
		/*
		function getAssignedToContact() {
		    $ret = null;
		    if ($this->getContactId() > 0) {
		        $ret = Contacts::instance()->findById($this->getContactId());
		    }
		    return $ret;
		} // 
		*/
	}