<?php

Hook::register("calculated_billing_rates");


function calculated_billing_rates_render_additional_billing_config_options($null, &$draw_disabled_options) {
	$draw_disabled_options = false;

	echo tpl_fetch(get_template_path('administration', 'calculated_billing_rates', 'calculated_billing_rates'));
}


function calculated_billing_rates_sum_col_total_query($params, &$sum_col) {
	$list_type = array_var($params, 'list_type');
	$object_type = array_var($params, 'object_type');
	$col = array_var($params, 'col');
	
	if ($object_type->getName() == 'timeslot' && $col == 'fixed_billing') {
		$sum_col = "
			CASE 
				WHEN ((select `value` from ".TABLE_PREFIX."config_options where name='regular_rate_member_id') IN (select tsom.member_id from ".TABLE_PREFIX."object_members tsom where tsom.object_id=o.id)) 
					THEN (select `value` from ".TABLE_PREFIX."config_options where name='regular_rate_multiplier') * ".$sum_col."
				
				WHEN ((select `value` from ".TABLE_PREFIX."config_options where name='overtime_rate_member_id') IN (select tsom.member_id from ".TABLE_PREFIX."object_members tsom where tsom.object_id=o.id)) 
					THEN (select `value` from ".TABLE_PREFIX."config_options where name='overtime_rate_multiplier') * ".$sum_col."
				
				WHEN ((select `value` from ".TABLE_PREFIX."config_options where name='double_overtime_rate_member_id') IN (select tsom.member_id from ".TABLE_PREFIX."object_members tsom where tsom.object_id=o.id)) 
					THEN (select `value` from ".TABLE_PREFIX."config_options where name='double_overtime_rate_multiplier') * ".$sum_col."
				
				WHEN ((select `value` from ".TABLE_PREFIX."config_options where name='non_billable_rate_member_id') IN (select tsom.member_id from ".TABLE_PREFIX."object_members tsom where tsom.object_id=o.id)) 
					THEN (select `value` from ".TABLE_PREFIX."config_options where name='non_billable_rate_multiplier') * ".$sum_col."
				
				ELSE ".$sum_col."
			END ";
	}
}


function calculated_billing_rates_override_timeslot_column_fields_when_generating_invoice($params, &$object) {
	
	if ($object instanceof Timeslot) {
		foreach ($object->manager()->getColumns() as $field) {
			
			if ($field == 'fixed_billing' || $field == 'hourly_billing') {
					
				Env::useHelper('functions', 'calculated_billing_rates');
				$value = $object->getColumnValue($field);
				apply_rate_multiplier_to_field($object, $field, $value);
				
			}
		}
	}
	
}


function calculated_billing_rates_get_value_columns_to_body_report($params, &$value) {

	$field = array_var($params, 'field');
	$object = array_var($params, 'object');

	if ($object instanceof Timeslot) {
		if ($field == 'fixed_billing' || $field == 'hourly_billing') {
			
			Env::useHelper('functions', 'calculated_billing_rates');
			apply_rate_multiplier_to_field($object, $field, $value);
			
		}
	}
}


function calculated_billing_rates_timeslot_info_additional_data($object, &$info) {
	if (Plugins::instance()->isActivePlugin('advanced_billing') && $object instanceof Timeslot) {

		foreach ($info as $field => &$value) {
			if ($field == 'fixed_billing' || $field == 'hourly_billing') {
					
				Env::useHelper('functions', 'calculated_billing_rates');
				$field_modified = apply_rate_multiplier_to_field($object, $field, $value);
				
				if ($field_modified) {
					$c = Currencies::instance()->getCurrency($object->getRateCurrencyId());
					$c_symbol = $c instanceof Currency ? $c->getSymbol() : '';
					$value = format_money_amount($value, $c_symbol);
				}
			}
		}

	}
}