<?php
/**
 * Conditional Tasks controller
 *
 * @version 1.0
 * @author Alvaro Torterola <alvaro.torterola@fengoffice.com>
 */
class ConditionalTasksController extends ApplicationController {

	var $plugin_name = "conditional_tasks";
	
	function __construct() {
		parent::__construct();
		prepare_company_website_controller($this, 'website');
	}
	
	
	
	function add_conditional_action() {
		
		$columns = array_diff(ProjectTasks::instance()->getColumns(), ProjectTasks::instance()->getSystemColumns());
		$custom_properties = CustomProperties::getAllCustomPropertiesByObjectType(ProjectTasks::instance()->getObjectTypeId());
		
		foreach ($columns as $k => &$col) {
			if (str_starts_with($col, "repeat") || in_array($col, array('order', 'completed_on', 'started_on', 'is_template', 'assigned_on', 'assigned_by_id', 'type_content'))) {
				unset($columns[$k]);
			}
		}
		
		tpl_assign('genid', array_var($_REQUEST, 'genid'));
		tpl_assign('index', array_var($_REQUEST, 'index'));
		tpl_assign('action', array_var($_REQUEST, 'action'));
		tpl_assign('property', array_var($_REQUEST, 'property'));
		tpl_assign('columns', $columns);
		tpl_assign('custom_properties', $custom_properties);
		
	}
}