<?php
		
	
	function get_task_workflow_available_conditions() {
		$available_condition_fields = array(
				array('name' => '-- '.lang('select a property').' --', 'field' => '', 'type' => ''),
				array('name' => lang('completed'), 'field' => 'completed', 'type' => strtolower(DATA_TYPE_BOOLEAN)),
				//	array('name' => lang('percent completed'), 'field' => 'percent_completed', 'type' => strtolower(DATA_TYPE_INTEGER)),
		);
	
		$custom_properties = CustomProperties::getAllCustomPropertiesByObjectType(ProjectTasks::instance()->getObjectTypeId());
		foreach ($custom_properties as $cp) {/* @var $cp CustomProperty */
			$available_condition_fields[] = array('name' => $cp->getName(), 'field' => "cp_".$cp->getId(), 'type' => $cp->getType());
		}
	
		return $available_condition_fields;
	}

	function parse_task_workflow_conditions($raw_parameters) {
		// leer lo que vino del request, pasar completed=true a completed_by_id>0
		$parameters = array();
		
		$conditions_info = get_task_workflow_available_conditions();
		
		if (is_array($raw_parameters )) {
		  foreach ($raw_parameters as $group_id => $group_data) {
			$parsed_group = array();
			
			foreach ($group_data as $condition_data) {
				
				$type = null;
				foreach ($conditions_info as $cond_info) {
					if ($cond_info['field'] == $condition_data['field']) {
						$type = $cond_info['type'];
						break;
					}
				}
				
				if ($type != null) {
					if ($type == 'numeric' || $type == 'integer') {
						$comp = $condition_data['comp_n'];
						$value = $condition_data['value_nt'];
					} else if ($type == 'string' || $type == 'text') {
						$comp = $condition_data['comp_t'];
						$value = $condition_data['value_nt'];
					} else if ($type == 'boolean') {
						$comp = "=";
						$value = $condition_data['value_b'];
					}
					
					$field = $condition_data['field'];
					if ($condition_data['field'] == 'completed') {
						$field = 'completed_by_id';
						$comp = $value == "1" ? ">" : "=";
						$value = "0";
					}
					
					$parsed_group[] = array('group_id' => $group_id, 'field' => $field, 'comp' => $comp, 'value' => $value);
				}
				
			}
			if (count($parsed_group) > 0) {
				$parameters[] = $parsed_group;
			}
		  }
		}
		
		return $parameters;
	}
	
	function save_task_workflow_parameters($task, $parameters) {
		DB::execute("DELETE FROM ".TABLE_PREFIX."task_after_action_conditions WHERE task_id=".$task->getId());
		foreach ($parameters as $group) {
			
			foreach ($group as $condition) {
				$sql = "INSERT INTO ".TABLE_PREFIX."task_after_action_conditions (task_id, group_id, condition_field, condition_comparison, condition_value) VALUES
						(".$task->getId().", ".$condition['group_id'].", '".$condition['field']."', '".$condition['comp']."', '".$condition['value']."')
						ON DUPLICATE KEY UPDATE task_id=task_id;";
				DB::execute($sql);
			}
		}
	}
	
	
	
	
	function parse_task_workflow_actions($raw_parameters) {
		$parameters = array();
		
		if (is_array($raw_parameters)) {
		  foreach ($raw_parameters as $group_id => $group_data) {
			foreach ($group_data as $idx => $gdata) {
				if (!array_var($gdata, 'action')) continue;
				
				if ($gdata['action'] == 'instantiate') {
					
					$parsed_group = array('group_id' => $group_id, 'action' => $gdata['action'], 'action_data' => implode(',', array_var($gdata, 'tasks_to_instantiate')));
					
				} else if (str_starts_with($gdata['action'], 'change_assoc_dim')) {
					
					$assoc_data = array_var($gdata, $gdata['action']);
					foreach ($assoc_data as $k => &$v) $v = str_replace(array("[","]"), "", $v);
					
					$parsed_group = array('group_id' => $group_id, 'action' => 'change_assoc_dim', 'action_data' => json_encode($assoc_data));
					
				}
				
				$parameters[] = $parsed_group;
			}
		  }
		}
		
		return $parameters;
	}
	
	function save_task_workflow_actions($task, $parameters) {
		DB::execute("DELETE FROM ".TABLE_PREFIX."task_after_action_actions WHERE task_id=".$task->getId());
		
		foreach ($parameters as $action) {
			
			$sql = "INSERT INTO ".TABLE_PREFIX."task_after_action_actions (task_id, group_id, action, action_data) VALUES
					(".$task->getId().", '".$action['group_id']."', '".$action['action']."', '".$action['action_data']."')
					ON DUPLICATE KEY UPDATE task_id=task_id;";
			
			DB::execute($sql);
			
			if ($action['action'] == 'instantiate' && trim($action['action_data']) != "") {
				$update_sql = "UPDATE ".TABLE_PREFIX."template_tasks SET `session_id`=0 WHERE object_id IN (".$action['action_data'].")";
				DB::execute($update_sql);
			}
		}
	}
