<?php

/**
 * Members
 *
 * @author Alvaro Torterola <alvaro.torterola@fengoffice.com>
 */
class TaskAfterActionConditions extends BaseTaskAfterActionConditions {

	
	static function getConditionGroups($task) {
		
		if (!$task instanceof ContentDataObject) return array();
		
		$groups = array_flat(DB::executeAll("SELECT DISTINCT(group_id) as gid FROM ".self::instance()->getTableName()." WHERE task_id=".$task->getId()));
		foreach ($groups as $k => &$id) {
			if (!is_numeric($id)) unset($groups[$k]);
		}
		
		return $groups;
	}
	
	
	static function checkConditionsForGroup($task, $group_id) {

		$conditions = self::instance()->findAll(array("conditions" => "task_id=".$task->getId()." AND group_id=$group_id"));
		if (!is_array($conditions) || count($conditions) == 0) return false;
		
		$conditions_accomplished = true;
		foreach ($conditions as $condition) { /* @var $condition TaskAfterActionCondition */
			if (!$condition->checkConditionForTask($task)) {
				$conditions_accomplished = false;
				break;
			}
		}
		
		return $conditions_accomplished;
	}
}
