<?php
 
class CrpmApiController extends ApiController {
	
	/**
	 * Lists all projects in the system.
	 * If int customer id argument, filters projects by customer
	 * Returns 
	 * @param unknown_type $customerId
	 */
	public function list_projects($customerId = null){
		$result = array();
		if (is_int($customerId)){			
			$customer = Customers::instance()->findById($customerId);
			if ($customer) {
				$projects =  $customer->getProjects() ;
			}else {
				throw new Error("Customer: $customerId not found");
			}
		}else {

			$projects = Projects::instance()->findAll(array("conditions"=>"trashed_by_id = 0 AND archived_by_id = 0"));
		}
		foreach ( $projects as $project ){ /* @var $project Project */
			$result[] = $project->getArrayInfo(false);
		}
		return $this->response('json',$result);
	}
	
	
	public function list_customers() {
		$result = array();
		$customers = Customers::instance()->findAll(array("conditions"=>"trashed_by_id = 0 AND archived_by_id = 0"));
		foreach ($customers as $customer){
			$result[] = $customer->getArrayInfo();
		}
		return $this->response('json',$result);
		
	}
	
	public function get_project($id) {
		return $this->response('json',Projects::instance()->findById($id)->getArrayInfo());
	}
	
	public function get_client($id){
		return $this->response('json',Projects::instance()->findById($id)->getArrayInfo());		
	}
	
	
}