<?php


function generate_repetitive_tasks_instances() {

	$limit = 200;
	$days = config_option("days range to replicate tasks");
	if ($days > 0) {
		
		$admin = Contacts::instance()->findOne(array('conditions' => 'user_type > 0', 'order' => 'user_type'));
		CompanyWebsite::instance()->logUserIn($admin);
		
		_log("Generating repetitive task instances for next $days days...");
		
		$limit_date = DateTimeValueLib::now();
		$limit_date = $limit_date->add('w', -1);
		$limit_date_str = $limit_date->toMySQL();
		
		$conditions_start = "repeat_forever=1
			AND (start_date >= '$limit_date_str')
			AND completed_by_id=0 AND trashed_by_id=0 AND archived_by_id=0
			AND repeat_by = 'start_date' 
			AND if (original_task_id=0, 
			    true, 
			    start_date = (
					select max(t2.start_date) from ".TABLE_PREFIX."project_tasks t2 
					inner join ".TABLE_PREFIX."objects o2 on o2.id = t2.object_id 
					where t2.original_task_id = e.original_task_id and o2.trashed_by_id=0 AND o2.archived_by_id=0
				)
			) 
			AND start_date <= ADDDATE(NOW(), INTERVAL $days DAY)";
		
		
		$conditions_due = "repeat_forever=1
			AND (due_date >= '$limit_date_str')
			AND completed_by_id=0 AND trashed_by_id=0 AND archived_by_id=0
			AND repeat_by = 'due_date'
			AND if (original_task_id=0,
			    true,
			    due_date = (
					select max(t2.due_date) from ".TABLE_PREFIX."project_tasks t2 
					inner join ".TABLE_PREFIX."objects o2 on o2.id = t2.object_id 
					where t2.original_task_id=e.original_task_id and o2.trashed_by_id=0 AND o2.archived_by_id=0
				)
			)
			AND due_date <= ADDDATE(NOW(), INTERVAL $days DAY)";
		
		
		$tasks_start = ProjectTasks::instance()->findAll(array('conditions' => $conditions_start));
		$tasks_due = ProjectTasks::instance()->findAll(array('conditions' => $conditions_due));
		
		$tasks = array();
		foreach ($tasks_start as $t) $tasks[$t->getId()] = $t;
		foreach ($tasks_due as $t) $tasks[$t->getId()] = $t;
		
		$count = 0;
		/*
		$tasks = ProjectTasks::instance()->findAll(array(
			'conditions' => "repeat_forever=1 
				AND (start_date >= '$limit_date_str' OR due_date >= '$limit_date_str')
				AND completed_by_id=0 AND trashed_by_id=0 AND archived_by_id=0
				AND IF (repeat_by = 'start_date', 
						start_date <= ADDDATE(NOW(), INTERVAL $days DAY), 
						due_date <= ADDDATE(NOW(), INTERVAL $days DAY)
				)"
		));
		*/

		if (count($tasks) > 0) {
			Env::useHelper('functions', 'crpm');
			
			foreach ($tasks as $task) {

                try {
                    DB::beginWork();

                    $count += generate_first_repetitions_for_task($task);

                    DB::commit();
                } catch (Exception $e) {
                    DB::rollback();
                    _log("ERROR: Generating task repetitions for task: ".$task->getId()." message:".$e->getMessage());
                }
				
				if ($count > $limit) {
					break;
				}
			}
		}
		
		_log("Generated $count task repetitions");
	}
}