<?php
	chdir($argv[1]);
	define("CONSOLE_MODE", true);
	include "init.php";
	
	session_commit(); // we don't need sessions
	@set_time_limit(0); // don't limit execution of cron, if possible
	ini_set('memory_limit', '2048M');
		
	
	
	$user_id = array_var($argv, 2);
	$token = array_var($argv, 3);
	
	$ot_id = array_var($argv, 4);
	
	// log user in
	$user = Contacts::instance()->findById($user_id);
	if(!($user instanceof Contact) || !$user->isValidToken($token)) {
		throw new Exception("Cannot login with user $user_id and token '$token'");
	}
	CompanyWebsite::instance()->setLoggedUser($user, false, false, false);
	
	try {
		
		$project_ot = ObjectTypes::findByName('project')->getId();
		$client_ot = ObjectTypes::findByName('customer')->getId();
				
		$dim = Dimensions::findByCode('customer_project');
		$members = array();
				
		if($ot_id == $project_ot || $ot_id == $client_ot){				
			$extra_conditions = " AND object_type_id IN (". $ot_id .")";
			$members = $dim->getAllMembers(false, null, true, $extra_conditions);	

			DB::beginWork();
			Formulas::instance()->calculateMemberStatus($members);
			DB::commit();
		}
				
		
	} catch (Exception $e) {
		DB::rollback();
		Logger::log("Error updating status (2): ".$e->getMessage()."\n".$e->getTraceAsString());
	}
	
	