<?php

  /**
  * BaseProject class
  *
  * @author Diego Castiglioni <diego.castiglioni@fengoffice.com>
  */
  abstract class BaseProject extends DimensionObject {
  
  	// -------------------------------------------------------
    //  Access methods
    // -------------------------------------------------------
  
  	
    /**
    * Return value of 'object_id' field
    *
    * @access public
    * @param void
    * @return integer 
    */
    function getObjectId() {
      return $this->getColumnValue('object_id');
    } // getId()
    
    
    /**
    * Set value of 'id' field
    *
    * @access public   
    * @param integer $value
    * @return boolean
    */
    function setObjectId($value) {
      return $this->setColumnValue('object_id', $value);
    } // setId() 
    
    /**
    * Return value of 'description' field
    *
    * @access public
    * @param void
    * @return integer 
    */
    function getDescription() {
      return $this->getColumnValue('description');
    } // getDescription()
    
    
    /**
    * Set value of 'description' field
    *
    * @access public   
    * @param integer $value
    * @return boolean
    */
    function setDescription($value) {
      return $this->setColumnValue('description', $value);
    } // setDescription() 
        
    
    /**
    * Return value of 'status' field
    *
    * @access public
    * @param void
    * @return integer 
    */
    function getStatus() {
      return $this->getColumnValue('status');
    } // getStatus()
    
    
    /**
    * Set value of 'status' field
    *
    * @access public   
    * @param integer $value
    * @return boolean
    */
    function setStatus($value) {
      return $this->setColumnValue('status', $value);
    } // setStatus() 


        /**
    * Return value of 'comments' field
    *
    * @access public
    * @param void
    * @return integer 
    */
    function getComments($include_trashed = false) {
      return $this->getColumnValue('comments');
    } // getComments()
    
    
    /**
    * Set value of 'comments' field
    *
    * @access public   
    * @param integer $value
    * @return boolean
    */
    function setComments($value) {
      return $this->setColumnValue('comments', $value);
    } // setComments() 
        
    
    /**
    * Return value of 'customer_id' field
    *
    * @access public
    * @param void
    * @return integer 
    */
    function getCustomerId() {
      return $this->getColumnValue('customer_id');
    } // getCustomerId()
    
    
    /**
    * Set value of 'customer_id' field
    *
    * @access public   
    * @param integer $value
    * @return boolean
    */
    function setCustomerId($value) {
      return $this->setColumnValue('customer_id', $value);
    } // setCustomerId() 
    
    /**
     * Return value of 'type_content' field
     *
     * @access public
     * @param void
     * @return string
     */
    function getTypeContent() {
            return $this->getColumnValue('type_content');
    } // getTypeContent()

    /**
     * Set value of 'type_content' field
     *
     * @access public
     * @param string $value
     * @return boolean
     */
    function setTypeContent($value) {
            return $this->setColumnValue('type_content', $value);
    } // setTypeContent()

    /**
     * Return value of 'end_date' field
     *
     * @access public
     * @param void
     * @return integer
     */
    function getEndDate() {
    	return $this->getColumnValue('end_date');
    }
    
    
    /**
     * Set value of 'end_date' field
     *
     * @access public
     * @param integer $value
     * @return boolean
     */
    function setEndDate($value) {
    	return $this->setColumnValue('end_date', $value);
    }

    /**
     * Return value of 'start_date' field
     *
     * @access public
     * @param void
     * @return integer
     */
    function getStartDate() {
    	return $this->getColumnValue('start_date');
    }
    
    
    /**
     * Set value of 'start_date' field
     *
     * @access public
     * @param integer $value
     * @return boolean
     */
    function setStartDate($value) {
    	return $this->setColumnValue('start_date', $value);
    }
    
    /**
     * Return value of 'manager_id' field
     *
     * @access public
     * @param void
     * @return integer
     */
    function getManagerId() {
    	return $this->getColumnValue('manager_id');
    }
    
    
    /**
     * Set value of 'manager_id' field
     *
     * @access public
     * @param integer $value
     * @return boolean
     */
    function setManagerId($value) {
    	return $this->setColumnValue('manager_id', $value);
    }
    
    /**
    * Return manager instance
    *
    * @access protected
    * @param void
    * @return Projects 
    */
    function manager() {
      if(!($this->manager instanceof Projects)) $this->manager = Projects::instance();
      return $this->manager;
    } // manager
  
    
    /**
     * @author pepe
     */
    function getId(){
    	return $this->getColumnValue('object_id');
    	 
    }
    
    /**
     * Return value of 'automatic_status' field
     *
     * @access public
     * @param void
     * @return integer
     */
    function getAutomaticStatus() {
    	return $this->getColumnValue('automatic_status');
    } // getAutomaticStatus()
    
    
    /**
     * Set value of 'automatic_status' field
     *
     * @access public
     * @param integer $value
     * @return boolean
     */
    function setAutomaticStatus($value) {
    	return $this->setColumnValue('automatic_status', $value);
    } // setAutomaticStatus()
    
  } // BaseProject 

?>