<?php 
	$genid = gen_id();
	if (isset($project) && $project instanceof Project) {
		$object = $project ;
	} elseif (isset($customer) && $customer instanceof Customer) {
		$object = $customer;
	}
	/* @var $project Project */
	/* @var $customer Customer */
?>
<div class="widget-persons widget">

	<div class="widget-header" onclick="og.dashExpand('<?php echo $genid?>');">
		<?php echo (isset($widget_title)) ? $widget_title : lang("project people");?>
		<div class="dash-expander ico-dash-expanded" id="<?php echo $genid; ?>expander"></div>
	</div>
	
	<div class="widget-body" id="<?php echo $genid; ?>_widget_body">
	<?php if ( count($contacts) ): ?>
		<ul>
		<?php 
		$row_cls = "";
		foreach ($contacts as $person): /* @var $person Contact */ ?>
			<li<?php echo ($row_cls == "" ? "" : " class='$row_cls'")?>>
				<div class="contact-picture contact-picture-container">
					<a href="<?php echo $person->getCardUrl() ?>" class="person" onclick="og.core_dimensions.buildBeforeObjectViewAction(<?php echo $person->getId()?>);"><img src="<?php echo $person->getPictureUrl(); ?>" /></a>
				</div>
				
				<div class="contact-info">
					<a href="<?php echo $person->getCardUrl() ?>" class="person" onclick="og.core_dimensions.buildBeforeObjectViewAction(<?php echo $person->getId()?>);"><?php echo clean($person->getObjectName()) ?></a>
					<div class="email"><?php echo $person->getEmailAddress(); ?></div> 
				</div>
				
				<div class="x-clear"></div>
			</li>
		<?php endforeach; ?>
		</ul>	
	<?php else:?>
		<div class="empty">
			<?php echo lang("no data to show") ?>

		</div>
	<?php endif; ?>
		<?php if ($object->canEdit(logged_user())): ?>
		<div class="add-contact">
			<a class="show-contact-form" href="#"><?php echo lang('assign existing contact')?></a>
			<div class="contact-form" style="display:none">
				<?php echo simple_select_box('new_contact',$unassigned_contacts, null, array("class"=>"new_contact_id")) ; ?>
				<button class = "add-contact-button"><?php echo lang('add')?></button> 
			</div>
		</div>		
		<?php endif; ?>
	</div>
</div>
<script>

	$(function(){
		$(".show-contact-form").click(function(){
			$(".contact-form").slideDown();
		});

		$(".add-contact-button").click(function(){
			
			var contact_id = $(".new_contact_id option:selected").val();
			var target = '<?php echo (isset($project))?"project":"customer"?>';
			var targetId = <?php echo ( isset($project)) ?$project->getId():$customer->getId()?>;
			var url = og.makeAjaxUrl(og.getUrl('crpm','add_contact'));
			var contactDimensionId = <?php echo Dimensions::instance()->findByCode("feng_persons")->getId() ?>;
			
			$.ajax({
				data: {
					"target" : target,
					"target_id" : targetId,
					"new_contact": contact_id
				},	
				url: url,
				type: "POST",
				dataType: "json",
				success: function(data){
					if (!data.errorCode){
						var content = data.current.data ;
						if ( ! $(".widget-persons .widget-body ul").length) {
							$(".widget-persons .empty").remove();
							$(".widget-persons .widget-body").prepend($(document.createElement('ul')));
						}

						$(".widget-persons .widget-body ul").append(content);
							
								
						 
							
						og.eventManager.fireEvent('reload dimension tree', contactDimensionId);
					}else{
						og.err(data.errorMessage);
					}		  
				},
				failure: function () {
					og.err("error send request");
				}	  
			});
		});
	});
</script>
