<?php /* @var Project $project */
	$genid = gen_id(); 
?>

<div class="task-graph-widget widget">

	<div style="overflow: hidden;" class="widget-header" onclick="og.dashExpand('<?php echo $genid?>');">
		<?php echo lang('estimated time vs worked time'); ?>
		<div class="dash-expander ico-dash-expanded" id="<?php echo $genid; ?>expander"></div>
	</div>
	
	<div class="widget-body" id="<?php echo $genid; ?>_widget_body">
		<div class="report-chart-container">
<?php 

	$estimated = array();
	$worked = array();
	$chart_labels = array();
	
	if ($all_has_due_date) {
		// render line chart
		foreach ($hours as $ts => $values) {
			$estimated[] = $values['estimated'] > 0 ? round($values['estimated'] / 60, 2) : null;
			$worked[] = $values['worked'] > 0 ? round($values['worked'] / 60, 2) : null;
			$d = new DateTimeValue($ts);
			$chart_labels[] = $d->format(user_config_option('date_format'));
		}
	
		$chart_data = array(
			array('color' => '#BBBB00', 'values' => $estimated, 'text' => lang('estimated time'), 'text_size' => 13, 'width' => 5),
			array('color' => '#00AA00', 'values' => $worked, 'text' => lang('executed time'), 'text_size' => 13, 'width' => 5),
		);
		
		if (count($estimated) + count($worked) > 0) {
			$merged = array_merge($estimated, $worked);
			$max_y = count($merged) > 0 ? max($merged) : 0;
			
			$x_end = count($chart_labels)-1;
			if ($x_end <= 0) $x_end = 1;
			
			render_chart(array(
				'label_step' => 2,
				'genid' => $genid,
				'width' => '100%',
				'height' => '250px',
				'type' => 'line',
				'x_range' => array('start' => 0, 'end' => $x_end, 'step' => 1),
				'y_range' => array('start' => 0, 'end' => $max_y, 'step' => round($max_y / 10)),
				'x_labels' => $chart_labels,
				'data' => $chart_data
			));
		} else {
			echo "<p>".lang('no estimated or working time registered')."</p>";
		}
	} else {
		// render bar chart
		$estimated = array(round($hours['estimated'] / 60, 2));
		$worked = array(round($hours['worked'] / 60, 2));

		$chart_labels = array(''/*lang('estimated time') ." - ". lang('executed time')*/);
		
		$chart_data = array(
			array('color' => '#CCCC00', 'values' => $estimated, 'text' => lang('estimated time'), 'text_size' => 13, 'tooltip' => lang('estimated time').": #val# ".lang('hours'), 'alpha' => 0.8),
			array('color' => '#00AA00', 'values' => $worked, 'text' => lang('executed time'), 'text_size' => 13, 'tooltip' => lang('executed time').": #val# ".lang('hours'), 'alpha' => 0.8),
		);
		
		if (count($estimated) + count($worked) > 0) {
			$merged = array_merge($estimated, $worked);
			$max_y = count($merged) > 0 ? max($merged) : 0;
			
			$x_end = count($chart_labels)-1;
			if ($x_end <= 0) $x_end = 1;
			
			render_chart(array(
				'label_step' => 4,
				'genid' => $genid,
				'width' => '100%',
				'height' => '250px',
				'type' => 'bar',
				'y_range' => array('start' => 0, 'end' => $max_y, 'step' => round($max_y / 10)),
				'x_labels' => $chart_labels,
				'data' => $chart_data
			));
		} else {
			echo "<p>".lang('no estimated or working time registered')."</p>";
		}
	}
?>
		</div>
		
		<div class="warnings">
		<?php if (!$all_has_due_date) : ?>
			<p><?php echo lang('there are tasks without due date');?></p>
		<?php endif; ?>
		
		<?php if (!$all_completed_has_work) : ?>
			<p><?php echo lang('there are completed tasks with no worked time registered');?></p>
		<?php endif; ?>
		
		<?php if (!$all_has_estimated_time) : ?>
			<p><?php echo lang('there are tasks with no estimated time');?></p>
		<?php endif; ?>
		</div>
	</div>
</div>