<?php 
	require_javascript('multi_assignment.js', 'crpm');
	if (!isset($genid)) $genid = gen_id();
	$dim_selectors_for_subtasks = config_option('multi_assignment_dim_ids');
?>

<style>
.ma-dim .dimension-selector-container {
	margin: 0px;
	width: 200px;
}
</style>

<div style="margin-top: 10px; width:100%">
	<table id="<?php echo $genid ?>multi_assignment" style="width:100%;display: none;"><tr>
		<td style="width:200"><?php echo label_tag(lang('assign to')) ?></td>
		<td style="width:350"><?php echo label_tag(lang('title'))  ?></td>
		<td style="padding-left:20px;"><?php echo label_tag(lang('estimated time')) ?></td>
	</tr></table>
	
	<div style="margin-top:10px;">
		<a href="#" tabindex="998" class="link-ico ico-add" onclick="addMultiAssignment('<?php echo $genid?>','','','','');return false;"><?php echo lang('add multi assignment') ?></a>
	</div>
</div>

<script>
og.multi_assignment_dim_ids = Ext.util.JSON.decode('<?php echo json_encode($dim_selectors_for_subtasks) ?>');
</script>

<?php 
if (count($subtasks) > 0) {
	
?><script>
	
	MA_COUNT_LINE = 1;
<?php
	foreach ($subtasks as $subtask) { /* @var $subtask ProjectTask */
		
		//genid, post_contact, post_name, post_hours, post_minutes, subtask_id, member_ids_csv
		$contact_id = $subtask->getAssignedToContactId();
		$name = escape_character(clean(str_replace("\n", "", $subtask->getObjectName())));
		$hours = floor($subtask->getTimeEstimate() / 60);
		$minutes = $subtask->getTimeEstimate() % 60;
		$subtask_id = $subtask->getId();
		$desc = escape_character($subtask->getText());
		
		$members_array = array();
		$st_members = $subtask->getMembers();
		foreach ($st_members as $m) {
			if (in_array($m->getDimensionId(), $dim_selectors_for_subtasks)) {
				if (!isset($members_array[$m->getDimensionId()])) $members_array[$m->getDimensionId()] = array();
				$members_array[$m->getDimensionId()][] = $m->getId();
			}
		}
		$members_json = json_encode($members_array);
	?>
	
	var ckEditorCss = [
		'<?php echo get_javascript_url('ckeditor/contents.css').'?rev='.product_version_revision();?>', 
		'<?php echo get_stylesheet_url('og/ckeditor_override.css').'?rev='.product_version_revision();?>'
	];

	addMultiAssignment('<?php echo $genid?>', '<?php echo $contact_id?>', '<?php echo $name ?>', '<?php echo $hours?>', '<?php echo $minutes?>', <?php echo $subtask_id ?>, '<?php echo $members_json?>', `<?php echo $desc ?>`, ckEditorCss); 

	<?php 
	}
?>
</script><?php
}
?>