<?php /* @var Project $customer */
	$genid = gen_id();
	$row_cls = "";
	
	$no_objects_text = count($customers) > 0 ? '' : lang('you have no clients yet');
	$dim_id = get_customers_dimension()->getId();
	$cot = ObjectTypes::findByName('customer');
	$c_name = Members::getTypeNameToShowByObjectType($dim_id, $cot->getId(), null, true);
	$add_button_text = count($customers) > 0 ? lang('add new client',$c_name) : lang('add your first client',$c_name);
?>


<div class="customer-widget widget">

	<div class="widget-header" onclick="og.dashExpand('<?php echo $genid?>');">
		<div class="widget-title"><?php echo $c_name; ?></div>
		<div class="dash-expander ico-dash-expanded" id="<?php echo $genid; ?>expander"></div>
	</div>
	
	<div class="widget-body" id="<?php echo $genid; ?>_widget_body">
			<div class="customer-list">
			<?php foreach ($customers as $customer): /* @var $customer Customer */ 
					$member = Members::findOneByObjectId($customer->getId(), $dim_id);

					$draw_status = true;
					$status_id = 0; // unknown
					if (Plugins::instance()->isActivePlugin('member_custom_properties') && $member instanceof Member) {
						$cp_status = CustomProperties::instance()->findOne(array('conditions' => "code='status_special' AND object_type_id=".$customer->getObjectTypeId()));
						if ($cp_status instanceof CustomProperty && !$cp_status->getIsDisabled()) {
							$cpval = CustomPropertyValues::getCustomPropertyValue($member->getObjectId(), $cp_status->getId());
							if ($cpval instanceof CustomPropertyValue) {
								$status_id = $cpval->getValue();
							}
						} else {
							$draw_status = false;
						}
					} else {
						$status_id = $customer->getStatusId();
					}
					$status_text = $status_id >= 0 ? lang('project_field_status'.$status_id) : "";
			?>
				<div class="customer-row-container <?php echo $row_cls ?>" id="customer-<?php echo $customer->getId()?>">
					<?php if ($draw_status) { ?>
					<div class="project-status-color color-<?php echo $status_id ?> project-row-status-<?php echo $status_id ?>"
							title="<?php echo $status_text ?>"><?php echo $status_text;?>
					</div>
					<?php } ?>
					<div class="text-container">
						<a class="internalLink" href="javascript:void(0);" onclick="og.customers.onCustomerClick('<?php echo ($member instanceof Member ? $member->getId() : 0); ?>');">
							<?php echo clean($customer->getObjectName()) ?>
						</a><?php
						$p = null;
						if ($member instanceof Member) {
							$p = $member->getParentMember();
						}
						if ($p instanceof Member) {
							$crumb_members = array(
								$p->getId() => array('name' => $p->getName(), 'ot' => $p->getObjectTypeId(), 'c' => $p->getColor()),
							);
							$crumbOptions = json_encode(array($dim_id => $crumb_members));
							if($crumbOptions == ""){
								$crumbOptions = "{}";
							}
							$crumbJs = " og.getEmptyCrumbHtml($crumbOptions, '.text-container' ) ";
						?>
						<span class="breadcrumb"></span>
						<script>
							var crumbHtml = <?php echo $crumbJs?>;
							$("#customer-<?php echo $customer->getId()?> .breadcrumb").html(crumbHtml);
						</script>
						<?php } ?>
					</div>
				</div>
				<div class="x-clear"></div>
			<?php endforeach; ?>
			</div>
		
		<?php if ($total > 0) : ?>
		<div class="view-all-container">
			<a href="#" onclick="og.openLink(og.getUrl('member', 'init', {dim_id:'<?php echo $dim_id?>', type_id:'<?php echo $cot->getId()?>'}), {caller:'customers list'})"><?php echo lang("view all") ?></a>
		</div>
		<?php endif ;?>

		<?php if ($render_add) :?>
			<?php if (count($customers) > 0) : ?>
			<div class="separator"></div>
			<?php endif; ?>
			<?php if ($no_objects_text != '') : ?><div class="no-obj-widget-msg"><?php echo $no_objects_text ?></div><?php endif; ?>
			<button title="<?php echo $add_button_text ?>" class="add-client-button add-first-btn">
				<img src="public/assets/themes/default/images/16x16/add.png"/>&nbsp;<?php echo $add_button_text ?>
			</button>
			
			<div class="x-clear"></div>
		<?php endif;?>
		
	</div>
</div>

<script>
	var parent_id = '<?php echo $parent instanceof Member ? $parent->getId() : 0?>';
	$(function(){
		$(".add-client-button").click(function(){
			var url = og.getUrl('customer', 'add', {parent: parent_id});
			var container = $(this).closest(".widget-body") ;
			container.closest(".widget-body").addClass("loading");
			og.openLink(url); 
		});
		// og.eventManager.fireEvent('replace all empty breadcrumb', null);
	});
</script>