<?php /* @var Project $project */
	$genid = gen_id();
	$row_cls = "";
	$no_objects_text = count($projects) > 0 ? '' : lang('you have no projects yet');
	$dim_id = Dimensions::findByCode('customer_project')->getId();
	
	$status_dimension = Dimensions::findByCode("project_statuses");
	$status_ot = ObjectTypes::findByName("project_status");
	$use_project_status_dimension = $status_dimension instanceof Dimension && in_array($status_dimension->getId(), config_option('enabled_dimensions'));
	$pot = ObjectTypes::findByName('project');
	$c_name = Members::getTypeNameToShowByObjectType($dim_id, $pot->getId(), null, true);
	$add_button_text = count($projects) > 0 ? lang('add new project',$c_name) : lang('add your first project',$c_name);
	
?>

<div class="projects-widget widget">

	<div style="overflow: hidden;" class="widget-header" onclick="og.dashExpand('<?php echo $genid?>');">
		<div class="widget-title"><?php echo isset($widget_title) ? $widget_title : $c_name; ?></div>
		<div class="dash-expander ico-dash-expanded" id="<?php echo $genid; ?>expander"></div>
	</div>
	
	<div class="widget-body" id="<?php echo $genid; ?>_widget_body" >
	
		<div class="project-list">
		<?php foreach ($projects as $project): /* @var $project Project */
				$member = Members::findOneByObjectId($project->getId(), $dim_id);
		?>
			<div class="project-row-container <?php echo $row_cls;?>" id="project-<?php echo $project->getId()?>">
			<?php if ($use_project_status_dimension) {
			
					$project_status = get_associated_status_member_id($member, $status_dimension, $status_ot, false, 'project_'.$status_ot->getName());
					$project_status_mem = Members::instance()->findById($project_status);
						
					if ($project_status_mem instanceof Member) {
						echo '<span style="float:left; margin:3px 10px 0 0;" class="crpm-status member-path real-breadcrumb og-wsname-color-'. $project_status_mem->getColor() .'">' . clean($project_status_mem->getName()) . '</span>';
					}
				} else {
					$status_name = $project->getStatus() ? Localization::instance()->lang('project_field_status'.$project->getStatus()) : "";
					if ($status_name) {
			?>
				<div class="project-status-color color-<?php echo $project->getStatus()?> project-row-status-<?php echo $project->getStatus()?>" 
					title="<?php echo $status_name;?>"><?php echo $status_name;?>
				</div>
				<?php } ?>
			<?php } ?>
				<div class="text-container">
					<a class="internalLink" href="javascript:void(0);" onclick="og.projects.onProjectClick(<?php echo $project->getProjectMemberId()?>);"><?php 
						echo clean($project->getObjectName()); 
					?></a><?php
					$p = $member->getParentMember();
					if ($p instanceof Member) {
						$crumb_members = array(
							$p->getId() => array('name' => $p->getName(), 'ot' => $p->getObjectTypeId(), 'c' => $p->getColor()),
						);
						$crumbOptions = json_encode(array($dim_id => $crumb_members));
						if($crumbOptions == ""){
							$crumbOptions = "{}";
						}
						$crumbJs = " og.getEmptyCrumbHtml($crumbOptions, '.text-container' ) ";
					?>
					<span class="breadcrumb"></span>
					<script>
						var crumbHtml = <?php echo $crumbJs?>;
						$("#project-<?php echo $project->getId()?> .breadcrumb").html(crumbHtml);
					</script>
				<?php } ?>
				</div>
			</div>
			<div class="x-clear"></div>
		<?php endforeach;?>
		</div>
		
		<?php if ($total > 0) : ?>
		<div class="view-all-container">
			<a href="#" onclick="og.openLink(og.getUrl('member', 'init', {dim_id:'<?php echo $dim_id?>', type_id:'<?php echo $pot->getId()?>'}), {caller:'projects list'})"><?php echo lang("view all") ?></a>
		</div>
		<?php endif ;?>
				
		<?php if ($render_add) :?>
			<?php if (count($projects) > 0) : ?>
			<div class="separator"></div>
			<?php endif; ?>
			<?php if ($no_objects_text != '') : ?><div class="no-obj-widget-msg"><?php echo $no_objects_text ?></div><?php endif; ?>
			<button title="<?php echo $add_button_text ?>" class="add-project-button add-first-btn">
				<img src="public/assets/themes/default/images/16x16/add.png"/>&nbsp;<?php echo $add_button_text ?>
			</button>
			<div class="x-clear"></div>
		<?php endif;?>
		

	</div>
</div>


<script>
	var parent_id = '<?php echo ( isset($parent) && $parent instanceof Member ) ? $parent->getId() : 0?>';
	$(function(){
		$(".add-project-button").click(function(){
			var url = og.getUrl('project', 'add', {parent: parent_id});
			var container = $(this).closest(".widget-body") ;
			container.closest(".widget-body").addClass("loading");
			og.openLink(url); 
		});
		// og.eventManager.fireEvent('replace all empty breadcrumb', null);
	});
</script>