<?php
/**
 * Generado el 14/6/2012
 * 
 */
Hook::register ( "multi_assignment" );

function multi_assignment_autoload_javascripts($args, &$js) {
	$js[] = ROOT_URL . "/" . get_javascript_url('multi_assignment.js', 'crpm');
}

function multi_assignment_modify_allowed_users_to_assign($null, &$object) {
	if (config_option('multi_assignment') && Plugins::instance()->isActivePlugin('crpm')) {
		$groups = PermissionGroups::getNonRolePermissionGroups();
		$groups_array = array();
		foreach ($groups as $group) {
			$groups_array[] = array('id' => $group->getId(), 'name' => $group->getName());
		}
		$object['groups'] = $groups_array;
	}
}

function multi_assignment_after_object_save($object, &$ret) {
	if ($object instanceof ProjectTask) {
		if (array_var($_POST, 'subtasks_generated')) return;
		
		$task_data = array_var($_REQUEST, 'task');
		$assigned_to = array_var($task_data, 'assigned_to_contact_id');
		$exploded = explode("-", $assigned_to);
		if (array_var($exploded, 0) == 'group') {
			$_POST['subtasks_generated'] = 1;
			$obj_controller = new ObjectController();
			
			if (in_array($_REQUEST['a'], array('quick_add_task', 'quick_edit_task'))) {
				$object_member_ids = active_context_members(false);
				if (is_numeric(array_var($task_data, 'member_id'))) $object_members[] = array_var($task_data, 'member_id');
			} else {
				$object_member_ids = json_decode(array_var($_POST, 'members'));
			}
			if (count($object_member_ids) > 0) {
				$object_members = Members::instance()->findAll(array('conditions' => 'id in ('.implode($object_member_ids).')'));
			} else {
				$object_members = array();
			}
			
			$pg_id = array_var($exploded, 1);
			$pg = PermissionGroups::instance()->findById($pg_id);
			if (!$pg instanceof PermissionGroup) return;
			
			$users = $pg->getUsers();
			foreach ($users as $user) {
				if (!$user->canAdd($user, $object_members)) continue;
				$new_task = $object->cloneTask();
				$new_task->setAssignedToContactId($user->getId());
				$new_task->setParentId($object->getId());
				$new_task->save();
				$new_task->subscribeUser($user);
				$obj_controller->add_to_members($new_task, $object_member_ids);
			}
		}
	}
}


function multi_assignment_object_definition($type,&$ret){
    if ($type == 'ProjectTask') {
        $ret['multi_assignment'] = DATA_TYPE_BOOLEAN;
    }
}

function multi_assignment_draw_additional_task_html($genid, &$task){
	$html = '';
	
	if ($task instanceof ProjectTask && config_option('multi_assignment')) {
		require_javascript('multi_assignment.js', 'crpm');
		
		$subtasks = array();
		if (!$task->isNew()) {
			$subtasks = ProjectTasks::instance()->findAll(array(
				'conditions' => '`trashed_by_id`=0 AND `parent_id`=' . DB::escape($task->getId()),
				'order' => '`created_on`'
			));
		}
		
		tpl_assign('genid', $genid);
		tpl_assign('subtasks', $subtasks);
		
		$html = tpl_fetch(get_template_path('multi_assignment_section', 'task', 'crpm'));
	}
	
    echo $html;
}

function multi_assignment_save_subtasks($params, $subtasks){
	
	$task = array_var($params, 'task');
	$is_new = array_var($params, 'is_new');
	
	if (!$task instanceof ProjectTask) return;
    
    if($task->getAssignedToContactId() > 0){
        $_POST['subscribers']['user_'.$task->getAssignedToContactId()] = 'checked';
    }
	
    if(is_array($subtasks) && count($subtasks) > 0)
    {
    	$saved_subtasks = array();
    	$deleted_subtasks = 0;
    	$new_subtasks = 0;
    	
        foreach ($subtasks as $subtask)
        {
        	$s_task = null;
            $group_id = explode("-", $subtask['assigned_to_contact_id']);
            $contact_permision = array();
            if ($group_id[0] == "group") {
                $contact_permision = ContactPermissionGroups::instance()->findAll(array("condition" => "permission_group_id = " . $group_id[1]));
            }
            if (count($contact_permision) > 0) {
                foreach ($contact_permision as $c_permision) {
                    $notAllowedMember = '';
                    $contact = Contacts::instance()->findById($c_permision->getContactId());
                    if(ProjectTask::canAdd($contact, active_context(), $notAllowedMember)) {
                    	$s_task = save_subtask($task, $subtask, $c_permision->getContactId());
                        // Add assigned user to the subscibers list
                        $_POST['subscribers']['user_' . $c_permision->getContactId()] = 'checked';
                    }
                    
                }
            } else {
            	$s_task = save_subtask($task, $subtask);
                // Add assigned user to the subscibers list
                $_POST['subscribers']['user_' . $subtask['assigned_to_contact_id']] = 'checked';
            }
            
            if ($s_task instanceof ProjectTask) {
            	$saved_subtasks[] = $s_task;
            	if (array_var($subtask, 'id') == 0) {
            		$new_subtasks++;
            	}
            } else {
            	$deleted_subtasks++;
            }
        }
        
        if ($deleted_subtasks > 0 || ($new_subtasks > 0 && !$is_new)) {
        	evt_add("reload current panel");
        	
        } else if (count($saved_subtasks) > 0) {
        	$stdata = array();
        	foreach ($saved_subtasks as $s_task) {
        		$stdata[] = $s_task->getArrayInfo();
        	}
        	if (count($stdata) > 0) {
        		evt_add('update tasks in list', array('tasks' => $stdata));
        	}
        }
    
        $task->setColumnValue('multi_assignment', 1);
        $task->save();
    
	    $object_controller = new ObjectController();
	    $is_template = $task instanceof TemplateTask;
	    $notify_subscribers = user_config_option("can notify subscribers");
	    $object_controller->add_subscribers($task ,null, !$is_template, $notify_subscribers);
    }
}

function save_subtask($task, $subtask , $contact_id = ""){
	
    $assign_contact = $subtask['assigned_to_contact_id'];
    if($contact_id != ""){
        $assign_contact = $contact_id;
    }
    
    $totalMinutes = (array_var($subtask, 'time_estimate_hours',0) * 60) + (array_var($subtask, 'time_estimate_minutes',0));
    
    $s_task = null;
    if (array_var($subtask, 'id') > 0) {
    	$s_task = ProjectTasks::instance()->findById(array_var($subtask, 'id'));
    	
    	// if subtask has been deleted in the form, then send it to the trash can and return
    	if (array_var($subtask, 'deleted') && $s_task instanceof ProjectTask) {
    		$s_task->trash();
    		ApplicationLogs::createLog($s_task, ApplicationLogs::ACTION_TRASH);
    		
    		return;
    	}
    } else if (array_var($subtask, 'deleted')) {
    	// new line, marked as deleted
    	return;
    }
    
    if (is_null($s_task)) {
    	
    	$new_subtask = true;
    	
	    $prev_assigned = null;
		$prev_time_estimate = 0;
    	$s_task = new ProjectTask();
		
    	$s_task->setUseDueTime($task->getUseDueTime());
    	$s_task->setUseStartTime($task->getUseStartTime());
    	$s_task->setDueDate($task->getDueDate());
    	$s_task->setStartDate($task->getStartDate());
    	$s_task->setPriority($task->getPriority());
    	$s_task->setState($task->getState());
    	$s_task->setOrder($task->getOrder());
    	$s_task->setMilestoneId($task->getMilestoneId());
    	$s_task->setPercentCompleted($task->getPercentCompleted());
    	$s_task->setTypeContent($task->getTypeContent());
	    $s_task->setParentId($task->getId());
		Hook::fire('save_additional_subtask_info', array('parent_task'=>$task), $s_task); 
	    
    } else {
    	$new_subtask = false;
    	$prev_assigned = $s_task->getAssignedToContactId();
		$prev_time_estimate = $s_task->getTimeEstimate();
    }
	
	$subtask_text = config_option("wysiwyg_tasks") ? str_replace(array("\r", "\n", "\r\n"), array('', '', ''), $subtask['text']) : $subtask['text'];

    $s_task->setObjectName($subtask['name']);      
    $s_task->setAssignedToContactId($assign_contact);
    $s_task->setTimeEstimate($totalMinutes);
    $s_task->setText($subtask_text);
    $s_task->save();
    
    $s_task->subscribeUser(logged_user());
    
    $dims_to_override = isset($subtask['members']) ? array_keys($subtask['members']) : array();
    
    $object_controller = new ObjectController();
    $member_ids = $task->getMemberIds();
    Hook::fire('modify_subtasks_member_ids', array('task' => $task), $member_ids);
    
    if (count($dims_to_override) > 0) {
    	$new_member_ids = array();
	    foreach ($member_ids as $mid) {
	    	$m = Members::getMemberById($mid);
	    	if ($m && !in_array($m->getDimensionId(), $dims_to_override)) {
				$new_member_ids[] = $mid;
	    	}
	    }
	    foreach ($dims_to_override as $dim_id) {
	    	$new_mid = json_decode($subtask['members'][$dim_id]);
	    	if (count($new_mid) > 0 && is_numeric($new_mid[0]) && $new_mid[0] > 0) {
				$new_member_ids[] = $new_mid[0];
	    	}
	    }
	    $member_ids = $new_member_ids;
    }
    
    if (!$new_subtask) {

		$subtask_member_ids = $s_task->getMemberIds();
		sort($subtask_member_ids);
		// get parent task's member objects to get their dimension ids
		$parent_task_members = $task->getMembers();
		$task_parent_members_dimension_ids = array();
		foreach ($parent_task_members as $pm) {
			$task_parent_members_dimension_ids[] = $pm->getDimensionId();
		}

		// to inherit parent classification => exlcude the ignored dimensions for subtasks using the config option
		$ignored_dimension_ids = config_option('ignored_dimensions_for_subtasks');
		$task_parent_members_dimension_ids = array_diff($task_parent_members_dimension_ids, $ignored_dimension_ids);

    	// keep the old members of the subtask, only if there is no classification in that dimension at parent task
		// example: if we change parent's rate schedule, we want to replace it also in the subtasks
		$prev_member_ids = array();
    	$prev_subtask_members = $s_task->getMembers();
    	foreach ($prev_subtask_members as $m) {
    		if ($m && !in_array($m->getDimensionId(), $dims_to_override) && !in_array($m->getDimensionId(), $task_parent_members_dimension_ids)) {
				$prev_member_ids[] = $m->getId();
    		}
    	}

		// merge the parent task's members with the ones of the subtask to keep
		$member_ids = array_unique(array_merge($member_ids, $prev_member_ids));
		sort($member_ids);
    }


	$members_updated = $subtask_member_ids && $member_ids && $subtask_member_ids != $member_ids || !$subtask_member_ids && $member_ids || $subtask_member_ids && !$member_ids;

	if($members_updated) {
		// classify all subtasks in hierarchy
		if (count($member_ids) > 0) {
			$all_subtasks_in_hierarchy = $s_task->getAllSubTasks(false);
			foreach ($all_subtasks_in_hierarchy as $st) {
				$object_controller->add_to_members($st, $member_ids);
			}
		}
		
		// classify the subtask in the resulting member ids array
		$object_controller->add_to_members($s_task, $member_ids);
	}
    
    if ($new_subtask) {
	    
	    $object_controller->link_to_new_object($s_task);
	    $object_controller->add_custom_properties($s_task);
    	$object_controller->add_reminders($s_task);
    }

	// Recalculate the estimated and executed cost and price, if all conditions are met:
	// 1. The task is not new
	// 2. Members were not updated
	// 3. The time estimate OR the assigned user has changed
	if(!$new_subtask && !$members_updated && ($prev_time_estimate != $s_task->getTimeEstimate() || $prev_assigned != $s_task->getAssignedToContactId())) {
		Hook::fire('calculate_estimated_executed_financials', array(), $s_task);
	}
    
    $s_task->save(); // to force recalculate this task's billing, must be done after it is classified.
    
    $notify_subscribers = user_config_option("can notify subscribers");
    
    $log_action = $new_subtask ? ApplicationLogs::ACTION_ADD : ApplicationLogs::ACTION_EDIT;
    ApplicationLogs::createLog($s_task, $log_action, true, !$notify_subscribers);

    if($s_task->getAssignedToContactId() > 0 && $prev_assigned != $s_task->getAssignedToContactId()){
        $user = Contacts::instance()->findById($s_task->getAssignedToContactId());
        $s_task->subscribeUser($user);
        
        if (user_config_option('can notify from quick add')) {
        	Notifier::taskAssigned($s_task);
        }
    }
    
    return $s_task;
}

