<?php

include_once dirname(__FILE__)."/../../../application/helpers/plugin_installer_functions.php";



function crpm_get_additional_install_queries($db_connection, $table_prefix) {
	
	$queries = array();
	
	$is_installed_advanced_reports = check_is_installed_plugin($db_connection, $table_prefix, 'advanced_reports');
	if ($is_installed_advanced_reports) {
		include_once dirname(__FILE__)."/../../advanced_reports/application/helpers/default_member_reports.php";
		$cli_rep_q = get_default_member_report_queries($db_connection, $table_prefix, 'customer');
		$proj_rep_q = get_default_member_report_queries($db_connection, $table_prefix, 'project');
		
		$queries = array_merge($queries, $cli_rep_q);
		$queries = array_merge($queries, $proj_rep_q);
	}
	
	$is_installed_member_custom_properties = check_is_installed_plugin($db_connection, $table_prefix, 'member_custom_properties');
	if ($is_installed_member_custom_properties) {
		
		$queries[] = "
			INSERT INTO `". $table_prefix ."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
				SELECT mt.id, 'Color', 'color_special','color','','','',0,0,30,1, 1, 0
				FROM ". $table_prefix ."object_types mt WHERE mt.`type` IN ('dimension_object','dimension_group') AND name IN ('folder', 'customer_folder', 'project_folder')
			ON DUPLICATE KEY UPDATE `code`=`code`;
		";
		$queries[] = "
			INSERT INTO `". $table_prefix ."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
				SELECT mt.id, 'Description', 'description_special', 'memo','','','',0,0,31,1, 1, 0
				FROM ". $table_prefix ."object_types mt WHERE mt.`type` IN ('dimension_object','dimension_group') AND name IN ('folder', 'customer_folder', 'project_folder')
			ON DUPLICATE KEY UPDATE `code`=`code`;
		";
	}


	if (check_is_installed_plugin($db_connection, $table_prefix, 'advanced_core')) {
	
		include_once dirname(__FILE__)."/../../advanced_core/application/helpers/installer_functions.php";
	
		$prop_groups_queries = get_default_property_groups_queries($db_connection, $table_prefix);
		$queries = array_merge($queries, $prop_groups_queries);
	
	}
	
	return $queries;

}
?>