<?php

include_once dirname(__FILE__)."/../../../application/helpers/plugin_installer_functions.php";

function crpm_types_get_additional_install_queries($db_connection, $table_prefix) {
	
	$queries = array();
	
	$is_installed_mem_custom_props = check_is_installed_plugin($db_connection, $table_prefix, 'member_custom_properties');
	
	if ($is_installed_mem_custom_props) {
	
		$sql = "SELECT count(id) as total FROM ".$table_prefix."member_custom_properties WHERE code='color_special'
				AND object_type_id=(SELECT id FROM ".$table_prefix."object_types WHERE name='project_status')";
		
		$mysql_res = mysqli_query($db_connection, $sql);
		if ($mysql_res) {
			$rows = mysqli_fetch_assoc($mysql_res);
		
			if (count($rows) > 0 && $rows['total'] == 0) {
				$queries[] = "INSERT INTO `".$table_prefix."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
					SELECT mt.id, 'Color', 'color_special','color','','','',0,0,0,30,1, 1, 0
					FROM ".$table_prefix."object_types mt WHERE mt.`type` IN ('dimension_group') AND name IN ('project_status', 'customer_sector', 'customer_type', 'project_type', 'project_phase', 'job_phase', 'customer_stage', 'project_manager', 'account_executive', 'country', 'marketing_channel')
				ON DUPLICATE KEY UPDATE `code`=`code`;";
				
				$queries[] = "INSERT INTO `".$table_prefix."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
				  SELECT mt.id, 'Description', 'description_special', 'memo','','','',0,0,0,31,1, 1, 0
				  FROM ".$table_prefix."object_types mt WHERE mt.`type` IN ('dimension_group') AND name IN ('project_status', 'customer_sector', 'customer_type', 'project_type', 'project_phase', 'job_phase', 'customer_stage', 'project_manager', 'account_executive', 'country', 'marketing_channel')
				ON DUPLICATE KEY UPDATE `code`=`code`;";
			}
		}
		
		// disable status custom properties for projects
		$queries[] = "UPDATE ".$table_prefix."member_custom_properties SET is_disabled=1 
			WHERE `code` IN ('status_special','calculate the status automatically_special') 
				AND object_type_id=(SELECT id FROM ".$table_prefix."object_types WHERE name='project');";
		
		// add the acronym cp for project managers
		$queries[] = "INSERT INTO ".$table_prefix."member_custom_properties (object_type_id, name, code, `type`,`is_special`) VALUES
			((SELECT id FROM ".$table_prefix."object_types WHERE name='project_manager'), 'Acronym', 'acronym', 'text', 1)
			ON DUPLICATE KEY UPDATE `code`=`code`;";
		
		// set project managers name as acronym - name
		$queries[] = "INSERT INTO ".$table_prefix."dimension_object_type_options (dimension_id, object_type_id, `name`, `value`) VALUES
			(	(SELECT id FROM ".$table_prefix."dimensions WHERE code='project_managers'),
				(SELECT id FROM ".$table_prefix."object_types WHERE name='project_manager'),
				'text_to_show_in_trees',
				CONCAT('{\"properties\":[\"cp_',(SELECT id FROM ".$table_prefix."member_custom_properties WHERE `code`='acronym'),'\",\"name\"], \"separator\":\"-\"}')
			);";
		
	}
	
	if (check_is_installed_plugin($db_connection, $table_prefix, 'advanced_core')) {
		
		include_once dirname(__FILE__)."/../../advanced_core/application/helpers/installer_functions.php";
		
		$prop_groups_queries = get_default_property_groups_queries($db_connection, $table_prefix);
		$queries = array_merge($queries, $prop_groups_queries);
		
	}
	
	return $queries;

}
?>