<?php
Hook::register ( "einvoice" );

function einvoice_render_page_actions($invoice, &$ret) {
    if ($invoice instanceof IncomeInvoice && !$invoice->isTrashed()){
        
		$use_e_invoice = true;
		Hook::fire('check_if_invoice_uses_einvoice', array('invoice'=>$invoice), $use_e_invoice);
		if (!$use_e_invoice) return;


        if($invoice->getStatus() == 'pending'){
            $url_generate_einvoice = get_url('einvoice', 'generate_einvoice', array('id' => $invoice->getId()));
            $url_generate_einvoice = "og.openLink(\\'".$url_generate_einvoice."\\');";
            $confirm_text = lang('confirm generate einvoice');
            $js_fn = "javascript: og.ConfirmBox({genid:'".gen_id()."', text:'".$confirm_text."',accept_fn:'" .$url_generate_einvoice."'})";
            add_page_action(lang('generate einvoice'), $js_fn, 'ico-income', null, null, true);
            // add_page_action(lang('generate einvoice'), get_url('einvoice', 'generate_einvoice', array('id' => $invoice->getId())), 'ico-income', null, null, true);
        };

        if($invoice->getStatus() == 'printed' || $invoice->getStatus() == 'confirmed'){
            add_page_action(lang('get einvoice document'), get_url('einvoice', 'get_einvoice_document', array('id' => $invoice->getId())), 'ico-income', null, null, true);
            add_page_action(lang('print einvoice document'), get_url('einvoice', 'print_view', array('id' => $invoice->getId())), 'ico-print', "_blank", null, true);
        };
    }
}

function einvoice_object_definition($type, &$ret) {
    if ($type == 'IncomeInvoice') {
        $ret['einvoice_document_id'] = DATA_TYPE_INTEGER;
        $ret['einvoice_qr_file_id'] = DATA_TYPE_INTEGER;
        $ret['einvoice_destiny_currency_id'] = DATA_TYPE_INTEGER;
        $ret['einvoice_destiny_rate'] = DATA_TYPE_FLOAT;
    }
}


function einvoice_more_invoice_print_options($params, &$invoice_options) {

	$invoice = array_var($params, 'invoice');

	$qr_file = ProjectFiles::instance()->findById($invoice->getColumnValue('einvoice_qr_file_id'));
	if ($qr_file instanceof ProjectFile) {
		$file_content = FileRepository::getFileContent($qr_file->getLastRevision()->getRepositoryId());
		$invoice_options['qr_file_url'] = 'data:image/png;base64,'. base64_encode($file_content);
	}

}



function einvoice_render_additional_billing_config_options($null, &$draw_disabled_options) {
    echo tpl_fetch(get_template_path('administration', 'einvoice', 'einvoice'));
}
