<?php 
	$genid = gen_id();
	$object = $event_attendee;
	
	// on submit functions
	if (array_var($_REQUEST, 'modal')) {
		$on_submit = "og.submit_modal_form('".$genid."submit-edit-form'); return false;";
	} else {
		$on_submit = "return true;";
	}
	
	$categories = array();
	Hook::fire('object_edit_categories', $object, $categories);

	$main_cp_count = CustomProperties::countVisibleCustomPropertiesByObjectType($object->getObjectTypeId());
	$other_cp_count = CustomProperties::countHiddenCustomPropertiesByObjectType($object->getObjectTypeId());
?>
<form class="add-event-ticket" id="<?php echo $genid ?>submit-edit-form" onsubmit="<?php echo $on_submit?>" action="<?php echo $event_attendee->isNew() ? get_url('event_attendee', 'add') : $event_attendee->getEditUrl() ?>" method="post" enctype="multipart/form-data" >
<div class="form">
<div class="coInputHeader">

  <div class="coInputHeaderUpperRow">
	<div class="coInputTitle">
		<?php echo $object->getAddEditFormTitle(); ?>
	</div>
  </div>

  <div>
	<div class="coInputName">
		<?php //echo text_field('event_attendee[name]', $event_attendee->getName(), array('id' => $genid . 'formName', 'class' => 'title', 'placeholder' => lang('type name here'))) ?>
	</div>
		
	<div class="coInputButtons" style="float:right;">
		<?php echo submit_button($object->getSubmitButtonFormTitle(),'s', array('style'=>'margin-top:0px;margin-left:10px')) ?>
	</div>
	<div class="clear"></div>
  </div>
</div>


<div class="coInputMainBlock">
	
	<input id="<?php echo $genid?>genid" type="hidden" name="genid" value="<?php echo $genid ?>">
	<input id="<?php echo $genid?>event_ticket_id" type="hidden" name="event_attendee[event_ticket_id]" value="<?php echo $event_attendee->getEventTicketId() ?>">
	<input id="<?php echo $genid?>updated-on-hidden" type="hidden" name="updatedon" value="<?php echo !$event_attendee->isNew() ? $event_attendee->getUpdatedOn()->getTimestamp() : '' ?>">
	
	<div id="<?php echo $genid?>tabs" class="edit-form-tabs">
	
		<ul id="<?php echo $genid?>tab_titles">
		
			<li><a href="#<?php echo $genid?>add_form_details"><?php echo lang('details') ?></a></li>

			<li><a href="#<?php echo $genid?>add_form_classification"><?php echo lang('context') ?></a></li>
			
			<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
			<li><a href="#<?php echo $genid?>add_custom_properties_div"><?php echo lang('custom properties') ?></a></li>
			<?php } ?>
			
			<li><a href="#<?php echo $genid?>add_subscribers_div"><?php echo lang('object subscribers') ?></a></li>
			
			<?php if($object->isNew() || $object->canLinkObject(logged_user())) { ?>
			<li><a href="#<?php echo $genid?>add_linked_objects_div"><?php echo lang('linked objects') ?></a></li>
			<?php } ?>
			
			<?php foreach ($categories as $category) {
					if (array_var($category, 'hidden')) continue;
				?>
			<li><a href="#<?php echo $genid . $category['name'] ?>"><?php echo $category['name'] ?></a></li>
			<?php } ?>
		</ul>
	
		<div id="<?php echo $genid ?>add_form_details" class="editor-container form-tab">
		
			<div class="dataBlock" style="display:none;">
				<?php
					echo checkbox_field("event_attendee[new_contact]", false, array(
						"id" => $genid."new_or_exisiting_contact_chk",
						"onchange" => ""
					));
					echo label_tag(lang('create a new contact'));
				?>
			</div>
			<div class="clear"></div>
		
			<div class="dataBlock">
				<table><tr><td><?php 
					echo label_tag(lang('attendee'));
				?></td><td>
					<div id="<?php echo $genid?>contact_id_combo_container"></div>
					<div id="<?php echo $genid?>new_contact_id" style="display:none;"></div>
				</td></tr></table>
			</div>
			<div class="clear"></div>
			
			<?php $null = null; Hook::fire('before_render_main_custom_properties', array('object' => $object), $null);?>
			
			<div class="dataBlock main-custom-properties-div"><?php
				if ($main_cp_count) {
					echo render_object_custom_properties($object, false, null, 'visible_by_default');
				}
			?></div>
			<div class="clear"></div>
			
		</div>
		
		
		<div id="<?php echo $genid ?>add_form_classification" class="editor-container form-tab">
		
			<div id="<?php echo $genid ?>add_form_select_context_div">
				<?php
				$listeners = array('on_selection_change' => 'og.reload_subscribers("'.$genid.'",'.$object->manager()->getObjectTypeId().')');
				if ($object->isNew()) {
					render_member_selectors($object->manager()->getObjectTypeId(), $genid, null, array('select_current_context' => true, 'listeners' => $listeners, 'object' => $object), null, null, false);
				} else {
					render_member_selectors($object->manager()->getObjectTypeId(), $genid, $object->getMemberIds(), array('listeners' => $listeners, 'object' => $object), null, null, false);
				} 
				?>
			</div>
			<div class="clear"></div>
		</div>

		
		<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
		<div id="<?php echo $genid ?>add_custom_properties_div" class="form-tab other-custom-properties-div">
			<?php  echo render_object_custom_properties($object, false, null, 'other') ?>
			<?php  echo render_add_custom_properties($object); ?>
		</div>
		<?php } ?>
		
		<div id="<?php echo $genid ?>add_subscribers_div" class="form-tab">
			<div id="<?php echo $genid ?>add_subscribers_content">
				<?php echo render_add_subscribers($object, $genid); ?>
			</div>
		</div>
		
		<?php if($object->isNew() || $object->canLinkObject(logged_user())) { ?>
		<div id="<?php echo $genid ?>add_linked_objects_div" class="form-tab">
			<?php echo render_object_link_form($object) ?>
		</div>
		<?php } // if ?>
	
		<?php foreach ($categories as $category) { ?>
		<div id="<?php echo $genid . $category['name'] ?>" class="form-tab">
			<?php echo $category['content'] ?>
		</div>
		<?php } ?>

	
	<div class="clear"></div>
</div>
	<?php if (!array_var($_REQUEST, 'modal')) {
		echo submit_button($event_attendee->isNew() ? lang('add form') : lang('save changes'),'s', array('tabindex' => '20000')); 
	}?>
</div>
</form>

<script>
var genid = '<?php echo $genid?>';
$(function(){
	
	og.renderContactSelector({
		genid: genid,
		id: genid + 'event_attendee_contact_id',
		name: 'event_attendee[contact_id]',
		render_to: "contact_id_combo_container",
		listWidth: 380,
		width: 380,
        cp_type:'contact',
		selected: <?php echo ($object->getContactId() > 0 ? $object->getContactId() : '0')?>,
		selected_name: '<?php echo $object->getAttendeeName() ?>',
		empty_text: '<?php echo lang ('select contact').'...' ?>'
	});
	
	$("#<?php echo $genid?>tabs").tabs();
});
</script>