<?php 
	$genid = gen_id();
	$object = $event_ticket; /* @var $event_ticket EventTicket */
	
	Env::useHelper('functions', 'multiple_currencies');

	// on submit functions
	if (array_var($_REQUEST, 'modal')) {
		$on_submit = "og.submit_modal_form('".$genid."submit-edit-form'); return false;";
	} else {
		$on_submit = "return true;";
	}
	
	$all_ticket_types = EventTicketTypes::findAllByEventId($event->getId());
	$ticket_types_by_id = array();
	foreach ($all_ticket_types as $tt) {
		$ticket_types_by_id[$tt->getId()] = $tt->getArrayInfo();
	}
	
	$currency_id = null;
	$amount = 0;
	if ($event_ticket->isNew()) {
		$tt = EventTicketTypes::getEventTicketById($event_ticket->getTicketTypeId());
		if ($tt instanceof EventTicketType) {
			$currency_id = $tt->getCurrencyId();
			$amount = $tt->getAmount();
		}
	} else {
		$currency_id = $event_ticket->getCurrencyId();
		$amount = $event_ticket->getUnitPrice();
	}
	
	$categories = array();
	Hook::fire('object_edit_categories', $object, $categories);

	$main_cp_count = CustomProperties::countVisibleCustomPropertiesByObjectType($object->getObjectTypeId());
	$other_cp_count = CustomProperties::countHiddenCustomPropertiesByObjectType($object->getObjectTypeId());
?>
<form class="add-event-ticket" id="<?php echo $genid ?>submit-edit-form" onsubmit="<?php echo $on_submit?>" action="<?php echo $event_ticket->isNew() ? get_url('event_ticket', 'add') : $event_ticket->getEditUrl() ?>" method="post" enctype="multipart/form-data" >
<div class="form">
<div class="coInputHeader">

  <div class="coInputHeaderUpperRow">
	<div class="coInputTitle">
		<?php echo $object->getAddEditFormTitle(); ?>
	</div>
  </div>

  <div>
	<div class="coInputName">
		<?php //echo text_field('event_ticket[name]', $event_ticket->getName(), array('id' => $genid . 'formName', 'class' => 'title', 'placeholder' => lang('type name here'))) ?>
	</div>
		
	<div class="coInputButtons" style="float:right;">
		<?php echo submit_button($object->getSubmitButtonFormTitle(),'s', array('style'=>'margin-top:0px;margin-left:10px')) ?>
	</div>
	<div class="clear"></div>
  </div>
</div>


<div class="coInputMainBlock">
	
	<input id="<?php echo $genid?>genid" type="hidden" name="genid" value="<?php echo $genid ?>">
	<input id="<?php echo $genid?>updated-on-hidden" type="hidden" name="updatedon" value="<?php echo !$event_ticket->isNew() ? $event_ticket->getUpdatedOn()->getTimestamp() : '' ?>">
	
	<div id="<?php echo $genid?>tabs" class="edit-form-tabs">
	
		<ul id="<?php echo $genid?>tab_titles">
		
			<li><a href="#<?php echo $genid?>add_form_details"><?php echo lang('details') ?></a></li>

			<li><a href="#<?php echo $genid?>add_form_classification"><?php echo lang('context') ?></a></li>
			
			<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
			<li><a href="#<?php echo $genid?>add_custom_properties_div"><?php echo lang('custom properties') ?></a></li>
			<?php } ?>
			
			<li><a href="#<?php echo $genid?>add_subscribers_div"><?php echo lang('object subscribers') ?></a></li>
			
			<?php if($object->isNew() || $object->canLinkObject(logged_user())) { ?>
			<li><a href="#<?php echo $genid?>add_linked_objects_div"><?php echo lang('linked objects') ?></a></li>
			<?php } ?>
			
			<?php foreach ($categories as $category) {
					if (array_var($category, 'hidden')) continue;
				?>
			<li><a href="#<?php echo $genid . $category['name'] ?>"><?php echo $category['name'] ?></a></li>
			<?php } ?>
		</ul>
	
		<div id="<?php echo $genid ?>add_form_details" class="editor-container form-tab">
		
		
			<div class="dataBlock">
			<?php 
				echo label_tag(lang('ticket type'));
				$options = array(option_tag("", 0));
				foreach ($all_ticket_types as $tt) {
					$attr = $tt->getId() == $event_ticket->getTicketTypeId() ? array("selected"=>"selected") : null;
					$options[] = option_tag($tt->getName(), $tt->getId(), $attr);
				}
				echo select_box("event_ticket[ticket_type_id]", $options, array("onchange" => "og.event_tickets.on_tt_change(this, '".$genid."');"));
			?>
			</div>
			<div class="clear"></div>
		
		
			<div class="dataBlock">
				<table><tr><td><?php 
					echo label_tag(lang('requested by'));
				?></td><td>
					<div id="<?php echo $genid?>requested_by_id_combo_container"></div>
				</td></tr></table>
			</div>
			<div class="clear"></div>
		
		
			<div class="dataBlock">
			<?php 
				echo label_tag(lang('requested on'));
				echo pick_date_widget2("event_ticket[requested_on]", $event_ticket->getRequestedOn(), $genid);
			?>
			</div>
			<div class="clear"></div>
			
			
			<div class="dataBlock">
			<?php 
				echo label_tag(lang('price'));
				$currency = $event_ticket->isNew() ? null : $currency_id;
				echo currency_selector('event_ticket[currency_id]', $currency, array("id" => $genid."_currency_sel"));
				echo text_field('event_ticket[amount]', $amount, array("id" => $genid."_amount_sel", 'style' => 'width: 120px; text-align: right;'));
			?>
			</div>
			<div class="clear"></div>
		
		
			<div class="dataBlock">
			<?php 
				echo label_tag(lang('status'));
				echo render_event_ticket_status_selector("event_ticket[status]", $event_ticket->getStatus());
			?>
			</div>
			<div class="clear"></div>
		
	
			<?php $null = null; Hook::fire('before_render_main_custom_properties', array('object' => $object), $null);?>
			
			<div class="dataBlock main-custom-properties-div"><?php
				if ($main_cp_count) {
					echo render_object_custom_properties($object, false, null, 'visible_by_default');
				}
			?></div>
			<div class="clear"></div>
			
		</div>

		<div id="<?php echo $genid ?>add_form_classification" class="editor-container form-tab">
		
			<div id="<?php echo $genid ?>add_form_select_context_div">
				<?php
				$listeners = array('on_selection_change' => 'og.reload_subscribers("'.$genid.'",'.$object->manager()->getObjectTypeId().')');
				if ($event_ticket->isNew()) {
					render_member_selectors($event_ticket->manager()->getObjectTypeId(), $genid, null, array('select_current_context' => true, 'listeners' => $listeners, 'object' => $object), null, null, false);
				} else {
					render_member_selectors($event_ticket->manager()->getObjectTypeId(), $genid, $event_ticket->getMemberIds(), array('listeners' => $listeners, 'object' => $object), null, null, false);
				} 
				?>
			</div>
			<div class="clear"></div>
		</div>
		
		<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
		<div id="<?php echo $genid ?>add_custom_properties_div" class="form-tab other-custom-properties-div">
			<?php  echo render_object_custom_properties($object, false, null, 'other') ?>
			<?php  echo render_add_custom_properties($object); ?>
		</div>
		<?php } ?>
		
		<div id="<?php echo $genid ?>add_subscribers_div" class="form-tab">
			<div id="<?php echo $genid ?>add_subscribers_content">
				<?php echo render_add_subscribers($object, $genid); ?>
			</div>
		</div>
		
		<?php if($object->isNew() || $object->canLinkObject(logged_user())) { ?>
		<div id="<?php echo $genid ?>add_linked_objects_div" class="form-tab">
			<?php echo render_object_link_form($object) ?>
		</div>
		<?php } // if ?>
	
		<?php foreach ($categories as $category) { ?>
		<div id="<?php echo $genid . $category['name'] ?>" class="form-tab">
			<?php echo $category['content'] ?>
		</div>
		<?php } ?>

	
	<div class="clear"></div>
</div>
	<?php if (!array_var($_REQUEST, 'modal')) {
		echo submit_button($event_ticket->isNew() ? lang('add form') : lang('save changes'),'s', array('tabindex' => '20000')); 
	}?>
</div>
</form>

<script>
var genid = '<?php echo $genid?>';
$(function(){

	og.event_tickets.form_tt = Ext.util.JSON.decode('<?php echo json_encode($ticket_types_by_id)?>');

	og.event_tickets.on_tt_change = function(combo, genid) {
		var tt = $(combo).val();
		
		$("#"+genid+"_currency_sel").val(og.event_tickets.form_tt[tt].currency_id);
		$("#"+genid+"_amount_sel").val(og.event_tickets.form_tt[tt].amount);
	}

	og.event_tickets.delete_event_ticket = function(id) {
		if (confirm(lang('delete event ticket confirmation'))) {
			og.openLink(og.getUrl('event_ticket', 'delete', {id: id}));
		}
	}

	og.renderContactSelector({
		genid: genid,
		id: genid + 'event_ticket_requested_by_id',
		name: 'event_ticket[requested_by_id]',
		render_to: "requested_by_id_combo_container",
		listWidth: 380,
		width: 380,
		selected: <?php echo ($object->getRequestedById() > 0 ? $object->getRequestedById() : '0')?>,
		selected_name: '<?php echo $object->getRequestedByName() ?>',
		empty_text: '<?php echo lang ('select contact').'...' ?>',
        cp_type:'contact'
	});
	
	$("#<?php echo $genid?>tabs").tabs();
});
</script>