<?php
$genid = gen_id();


// the forms will be called using ajax
$tickets_on_submit = "return false;";
$attendees_on_submit = "return false;";

// form action urls
$tickets_form_action = get_url('event_ticket', 'submit_multiple_event_tickets');
$attendees_form_action = get_url('event_attendee', 'submit_multiple_attendees');


$dimension = Dimensions::findByCode('customer_project');
?>


<div class="coInputHeader"></div>

<div class="coInputMainBlock feng-bootstrap">


    <div class="row col-md-12">
        <form class="" id="<?php echo $genid ?>submit-tickets-form"
              onsubmit="<?php echo $tickets_on_submit ?>"
              action="<?php echo $tickets_form_action ?>" method="post" enctype="multipart/form-data">

            <input type="hidden" name="tickets[event_member_id]" value="<?php echo $event_member->getId() ?>">

            <div id="step1">

                <h2><?php echo lang('registration information') ?></h2>
                <div>
                    <div id="step1_error" class="alert alert-danger " style="display: none;">
                        <strong>Error!</strong> <span id="step1_error_message"></span>
                    </div>
                    <table class="table table-striped">
                        <thead>
                        <tr>
                            <th><?php echo lang('registration type') ?></th>
                            <th><?php echo lang('remaining') ?></th>
                            <th><?php echo lang('sale ends') ?></th>
                            <th><?php echo lang('price') ?></th>
                            <th><?php echo lang('quantity') ?></th>
                            <th><?php echo lang('comment') ?></th>
                        </tr>
                        </thead>
                        <tbody>
                        <?php
                        $is_free_registration = true;
                        foreach ($event_ticket_types as $tt) {
                            /* @var $tt EventTicketType */
                            $currency = Currencies::instance()->getCurrency($tt->getCurrencyId());
                            $c_sym = $currency instanceof Currency ? $currency->getSymbol() : '$';
                            ?>
                            <tr>
                                <td><?php echo $tt->getName() ?> <br><small><?php echo $tt->getDescription() ?></small></td>
                                <td><?php echo $tt->getTotalQuantity() - $tt->getSoldQuantity() ?></td>
                                <td><?php echo format_date($tt->getAvailableTo(), null, 0) ?></td>
                                <td><?php echo format_money_amount($tt->getAmount(), $c_sym) ?></td>
                                <td style="width: 96px;">
                                    <input type="number" class="form-control" required min="0"
                                           max="<?php echo $tt->getTotalQuantity(); ?> "
                                           data-ticket-value="<?php echo $tt->getAmount(); ?>" data-action="updateTotal"
                                           name="tickets[types][<?php echo $tt->getId(); ?>][quantity]" value="0">
                                    <div class="invalid-feedback"><?php echo lang('select 1 at least'); ?></div>
                                </td>
                                <td>
                                    <input type="text" class="form-control commentfield"  name="tickets[types][<?php echo $tt->getId(); ?>][comment]" is-required="<?php echo $tt->getInputRequired(); ?>">
                                </td>
                            </tr>

                            <?php
                            if ($tt->getAmount() > 0) $is_free_registration = false;
                        }
                        ?>
                        </tbody>
                    </table>
                </div>

				<?php if (!$is_free_registration) { ?>
                <h2><?php echo lang('payment method') ?></h2>
                <div class="row">
                    <div id="paymentMethod" class="col-md-4">
                        <?php
                        $customProp = CustomProperties::getCustomPropertyByCode(IncomeInvoices::instance()->getObjectTypeId(),'payment_method');
                        $config = array();
                        $config['name'] = 'tickets[payment_method]';
                        $config['label'] = $customProp->getName();
                        $config['is_bootstrap'] = true;
                        $html = render_custom_property_by_type($customProp, $config);
                        echo $html;
                        ?>
                    </div>
                    <div class="col-md-4">
                        <label for="total_event_payment"><?php echo lang('sold quantity') ?></label>
                        <input type="text" class="form-control" data-money-symbol="<?php echo $c_sym ?>"
                               id="total_event_payment" readonly value="<?php echo $c_sym ?>0">
                    </div>
                </div>
                <?php } ?>
                <button type="button" class="btn btn-primary pull-right mt-3"
                        onclick="og.event_tickets.goStep2('<?php echo $genid ?>')"><?php echo lang('next') ?></button>
            </div>

            <div id="step2" style="display: none;">
                <h2><?php echo lang('payment information') ?></h2>
                <div class="col-md-12">
                    <div id="step2_error" class="alert alert-danger " style="display: none;">
                        <strong>Error!</strong> <span id="step2_error_message"></span>
                    </div>
                    <div class="row row-padding-bottom">
                        <div class="col-md-12">
                            <label for="inputTransactionId"><?php echo lang('members') ?></label>
                            <?php render_single_member_selector($dimension, $genid, null, array(
                            		'hf_name' => 'event_company_selected', 'hide_label' => true, 'is_multiple' => false,'is_bootstrap'=>true,
                            		'listeners' => array(
                            				'on_selection_change' => "og.event_tickets.reDrawContactSelector();",
                            				'on_remove_relation' => "og.event_tickets.reDrawContactSelector();",
                            		)
                            )); ?>
                        </div>
                    </div>
                    <div class="row row-padding-bottom">
                        <div class="col-md-12">
                            <label for="inputTransactionId"><?php echo lang('contact') ?></label>
                            <div id="<?php echo $genid; ?>new_event_registration"></div>
                        </div>
                    </div>
                    
                    <?php if (!$is_free_registration) { ?>
                    <div class="row row-padding-bottom">
                            <div class="col-md-12" id="inputTransactionIdContainer">
                                    <?php
                                    $customProp = CustomProperties::getCustomPropertyByCode(IncomeInvoices::instance()->getObjectTypeId(),'external_transaction_id');
                                    $config = array();
                                    $config['name'] = 'tickets[external_transaction_id]';
                                    $config['label'] = $customProp->getName();
                                    $config['is_bootstrap'] = true;
                                    $html = render_custom_property_by_type($customProp, $config);
                                    echo $html;

                                    ?>
                            </div>
                    </div>
                    <div class="row row-padding-bottom">
                        <div class="col-md-12">
                            <?php
                                $customProp = CustomProperties::getCustomPropertyByCode(IncomeInvoices::instance()->getObjectTypeId(),'external_transaction_desc');
                                $config = array();
                                $config['name'] = 'tickets[external_transaction_desc]';
                                $config['label'] = $customProp->getName();
                                $config['is_bootstrap'] = true;
                                $html = render_custom_property_by_type($customProp, $config);
                                echo $html;
                            ?>
                        </div>
                    </div>
                    <?php } ?>
                </div>
                <button type="button" class="btn btn-primary mt-3"
                        onclick="og.event_tickets.goStep1()"><?php echo lang('back') ?></button>
                        
                <?php if (!$is_free_registration) { ?>
                
                <button type="button" class="btn btn-primary pull-right mt-3"
                        onclick="og.event_tickets.getAvailableBillTo();"><?php echo lang('next') ?></button>
                
                <?php } else { ?>
                
                <button type="button" class="btn btn-primary pull-right mt-3"
                        onclick="og.event_tickets.submit_multiple_event_tickets('<?php echo $genid ?>', true)"><?php echo lang('save_registration') ?></button>
                
                <?php } ?>
            </div>

            <div id="step3" style="display: none;">
                <div class="col-md-12">
                    <div id="step3_error" class="alert alert-danger " style="display: none;">
                        <strong>Error!</strong> <span id="step3_error_message"></span>
                    </div>
                    <div class="row">
                        <h2 for="billto"><?php echo lang('review billing information') ?></h2>
                    </div>
                    <div id="list_of_bill_to" class="row">

                    </div>

                </div>


                <button type="button" class="btn btn-primary mt-3"
                        onclick="og.event_tickets.goStep2()"><?php echo lang('back') ?></button>
                <button type="button" class="btn btn-primary pull-right mt-3"
                        onclick="og.event_tickets.submit_multiple_event_tickets('<?php echo $genid ?>')"><?php echo lang('save_registration') ?></button>
            </div>


        </form>
    </div>

    <div id="step4" class="col-md-12" style="display: none; max-height: 600px;overflow: auto;">
        <form class="add-event-ticket" id="<?php echo $genid ?>submit-attendees-form"
              onsubmit="<?php echo $attendees_on_submit ?>" style="min-width: 0px;"
              action="<?php echo $attendees_form_action ?>" method="post" enctype="multipart/form-data">

            <input type="hidden" name="attendees[event_member_id]" value="<?php echo $event_member->getId() ?>">
            <input type="hidden" name="attendees[customer_member_id]" id="attendees_customer_member_id" value="">


            <h2><?php echo lang('select attendees') ?></h2>

            <div id="attendee_form">

            </div>
            <button class="btn btn-primary pull-right mt-3"
                    onclick="og.event_tickets.submit_multiple_attendees('<?php echo $genid ?>')"><?php echo lang('register_attendees') ?></button>


        </form>
    </div>

</div>
<script type="text/javascript">
	og.event_tickets.customer_member_id = 0;
    og.event_tickets.member_id = '<?php echo $event_member->getId() ?>';
    og.event_tickets.event_ticket_available = '<?php echo $event_ticket_available ?>';


    var gen_new_event_ticket_registration = '<?php echo $genid; ?>';
    url_available_bill_to = '<?php echo get_url('invoice', 'get_available_bill_to_for_invoice');?>';
    contacts_billing_to_information = null;
    og.bootstrap_helper.renderContactCombo({
        genid: gen_new_event_ticket_registration,
        id: gen_new_event_ticket_registration + 'new_event_registration',
        name: 'tickets[requested_by][contact_id]',
        render_to: "new_event_registration",
        listWidth: 380,
        width: 380,
        selected: '',
        selected_name: '',
        cp_type:'contact',
        empty_text: lang('select contact'),
        filters: {is_user: 0,member_ids:og.event_tickets.member_id},
        memberId:og.event_tickets.member_id
    });
</script>
<script id="billto_row" type="text/x-handlebars-template">
    <div class="col-md-4">
        <h5>{{customer_name}}</h5>
        <div class="input-group input-group-sm mb-3">
            <div class="input-group-prepend">
                <span class="input-group-text" id="inputGroup-sizing-sm"><?php echo lang("address") ?></span>
            </div>
            <input type="text" class="form-control" aria-label="Small" id="customer_address_{{customer_id}}"
                   aria-describedby="inputGroup-sizing-sm" readonly value="{{customer_address}}">
        </div>

        <div class="input-group input-group-sm mb-3">
            <div class="input-group-prepend">
                <span class="input-group-text" id="inputGroup-sizing-sm"><?php echo lang("city") ?></span>
            </div>
            <input type="text" class="form-control" aria-label="Small" id="customer_city_{{customer_id}}"
                   aria-describedby="inputGroup-sizing-sm" readonly value="{{customer_city}}">
        </div>

        <div class="input-group input-group-sm mb-3">
            <div class="input-group-prepend">
                <span class="input-group-text" id="inputGroup-sizing-sm"><?php echo lang("state") ?></span>
            </div>
            <input type="text" class="form-control" aria-label="Small" id="customer_state_{{customer_id}}"
                   aria-describedby="inputGroup-sizing-sm" readonly value="{{customer_state}}">
        </div>

        <div class="input-group input-group-sm mb-3">
            <div class="input-group-prepend">
                <span class="input-group-text" id="inputGroup-sizing-sm"><?php echo lang("country") ?></span>
            </div>
            <input type="text" class="form-control" aria-label="Small" id="customer_country_{{customer_id}}"
                   aria-describedby="inputGroup-sizing-sm" readonly value="{{customer_country}}">
        </div>

        <div class="input-group input-group-sm mb-3">
            <div class="input-group-prepend">
                <span class="input-group-text" id="inputGroup-sizing-sm"><?php echo lang("zipcode") ?></span>
            </div>
            <input type="text" class="form-control" aria-label="Small" id="customer_zipcode_{{customer_id}}"
                   aria-describedby="inputGroup-sizing-sm" readonly value="{{customer_zipcode}}">
        </div>

        <div class="input-group input-group-sm mb-3">
            <div class="input-group-prepend">
                <span class="input-group-text" id="inputGroup-sizing-sm"><?php echo lang("email") ?></span>
            </div>
            <input type="text" class="form-control" aria-label="Small" id="customer_email_{{customer_id}}"
                   aria-describedby="inputGroup-sizing-sm" readonly value="{{customer_email}}">
        </div>

        <div class="input-group input-group-sm mb-3">
            <div class="input-group-prepend">
                <span class="input-group-text" id="inputGroup-sizing-sm"><?php echo lang("phone") ?></span>
            </div>
            <input type="text" class="form-control" aria-label="Small" id="customer_phone_{{customer_id}}"
                   aria-describedby="inputGroup-sizing-sm" readonly value="{{customer_phone}}">
        </div>

        <input type="radio" name="billto" value="{{customer_id}}">
    </div>
</script>
<script id="attendee_row" type="text/x-handlebars-template">
    {{#each ticket_type}}
    <h3 class="">{{ticket_name}}</h3>
    {{#each ticket}}
    <h4>Ticket #{{ticket_num}}</h4>
    <div class="col-md-12">


        <div class="row pb-3">
            {{!-- {{If this structure is changed you have to check the function submit_multiple_attendees}} --}}

            {{#each attendees}}
            <div class="row col-md-12 pt-3">

                <div id="{{ticket_num}}_{{count}}_new_attendee_registration" class="col-md-12 row"></div>
                <input type="hidden" name="attendees[{{ticket_num}}][{{count}}][event_ticket_id]" value="{{ticket_id}}">

            </div>

            <div class="dropdown-divider"></div>
            {{/each}}
            <div id="cp_container_{{ticket_num}}" class="col-md-12 row">

            </div>


        </div>

    </div>
    {{/each}}
    {{/each}}
</script>
