<?php 
	$genid = gen_id();
	$object = $event_ticket_type;
	/* @var $object EventTicketType */
	
	Env::useHelper('functions', 'multiple_currencies');
	
	$form_action = $object->isNew() ? 
		get_url('event_ticket_type', 'add', array('event_id' => $event->getId())) : 
		get_url('event_ticket_type', 'edit', array('id' => $object->getId()));

	// on submit functions
	if (array_var($_REQUEST, 'modal')) {
		$on_submit = "og.submit_modal_form('".$genid."submit-edit-form'); return false;";
	} else {
		$on_submit = "return true;";
	}
	
?>
<form class="add-form" id="<?php echo $genid ?>submit-edit-form" onsubmit="<?php echo $on_submit?>" action="<?php echo $form_action ?>" method="post" enctype="multipart/form-data" >
<div class="form">
<div class="coInputHeader">

  <div class="coInputHeaderUpperRow">
	<div class="coInputTitle">
		<?php echo lang("new event ticket type") ?>
	</div>
  </div>

  <div>
	<div class="coInputName">
		<?php echo text_field('event_ticket_type[name]', $object->getName(), array('id' => $genid . 'formName', 'class' => 'title', 'placeholder' => lang('type name here'))) ?>
	</div>
		
	<div class="coInputButtons">
		<?php echo submit_button($object->isNew() ? lang('add event ticket type') : lang('save changes'), 's', array('style'=>'margin-top:0px;margin-left:10px')) ?>
	</div>
	<div class="clear"></div>
  </div>
</div>


<div class="coInputMainBlock">
	
	<input id="<?php echo $genid?>genid" type="hidden" name="genid" value="<?php echo $genid ?>">
	
	<div id="<?php echo $genid?>tabs" class="edit-form-tabs">
	
		<ul id="<?php echo $genid?>tab_titles">
		
			<li><a href="#<?php echo $genid?>add_event_ticket_type_details"><?php echo lang('details') ?></a></li>

		</ul>
	
		<div id="<?php echo $genid ?>add_event_ticket_type_details" class="editor-container form-tab">
		
			<input type="hidden" name="event_ticket_type[event_id]" value="<?php echo $event->getId() ?>" />
		
			<div class="dataBlock">
			<?php 
				echo label_tag(lang('price'));
				$currency = $object->isNew() ? null : $object->getCurrencyId();
				echo currency_selector('event_ticket_type[currency_id]', $currency, array());
				echo text_field('event_ticket_type[amount]', $object->getAmount(), array('style' => 'width: 120px; text-align: right;'));
			?>
			</div>
		
			<div class="dataBlock">
				<?php echo label_tag(lang('available from')) ?>
    			<div style="float:left;"><?php 
    				echo pick_date_widget2('event_ticket_type[available_from]', $object->getAvailableFrom(), $genid, null, true, $genid.'available_from');
    			?></div>
			</div>
			
			<div class="dataBlock">
				<?php echo label_tag(lang('available to')) ?>
    			<div style="float:left;"><?php 
    				echo pick_date_widget2('event_ticket_type[available_to]', $object->getAvailableTo(), $genid, null, true, $genid.'available_to');
    			?></div>
			</div>	
			
			<div class="dataBlock">
				<?php echo label_tag(lang('quantity')) ?>
				<?php echo number_field('event_ticket_type[total_quantity]', $object->getTotalQuantity()) ?>
			</div>
			
			<div class="dataBlock">
				<?php echo label_tag(lang('attendees per ticket')) ?>
				<?php echo number_field('event_ticket_type[attendees_per_ticket]', $object->getAttendeesPerTicket()) ?>
			</div>
			
			<?php if (config_option('use_ticket_type_member_pricing')) { ?>
			<div class="dataBlock">
				<?php echo label_tag(lang('member pricing')) ?>
				<?php echo checkbox_field('event_ticket_type[member_pricing]', $object->getMemberPricing()) ?>
			</div>
			<?php } ?>
			
			<div class="dataBlock">
				<?php 
					echo label_tag(lang('description'));
					echo textarea_field('event_ticket_type[description]', $object->getDescription(), 
							array('style' => 'width: 500px; height: 100px;'));
				?>
				<br />
				<?php 
					echo label_tag(""); // for margin
					echo checkbox_field('event_ticket_type[show_description_in_website]', $object->getShowDescriptionInWebsite(), 
							array('id' => $genid.'_show_desc_in_web', 'style' => 'float: left; margin: 5px;'));
					echo label_tag(lang('show description in website'), $genid . '_show_desc_in_web', false, 
							array('style' => "display: inline"), "");
				?>
			</div>
			
		</div>

	
	<div class="clear"></div>
</div>
	<?php if (!array_var($_REQUEST, 'modal')) {
		echo submit_button($object->isNew() ? lang('add event ticket') : lang('save changes'),'s', array('tabindex' => '20000')); 
	}?>
</div>

</div>

</form>
<script>
var genid = '<?php echo $genid?>';
$(function(){
	$("#<?php echo $genid?>tabs").tabs();
});
</script>