<?php
	Env::useHelper('functions', 'multiple_currencies');
?>
<div style="display:none;" id="<?php echo $genid?>_currency_selector_template"><?php
	echo ((!empty($currencies = Currencies::getAllCurrencies())>1)?currency_selector('ticket_types[{i}][currency_id]', 0, array('id' => $genid."_currency_selector_{i}")):"");
?></div>

<?php
	if ($member instanceof Member) {
		Env::useHelper("functions", "event_tickets");
	}
?>

<div class="listing-admin">
	<div class="coInputMainBlock adminMainBlock">
		<table id="<?php echo $genid ?>ticket_types_table" class="ticket-types-table bordered">
			<tr class="header">
				<th><?php echo lang('name') ?></th>
				<th><?php echo lang('price') ?></th>
				<th><?php echo lang('quantity') ?></th>
				<th><?php echo lang('attendees per ticket') ?></th>
				<th><?php echo lang('available from') ?></th>
				<th><?php echo lang('available to') ?></th>
				<?php if (config_option('use_ticket_type_member_pricing')) { ?>
				<th><?php echo lang('member pricing') ?></th>
				<?php } ?>
				<th><?php echo lang('input required') ?></th>
				<th></th>
			</tr>
		</table>
		<input type="hidden" id="<?php echo $genid ?>del_ticket_types" name="del_ticket_types">

		<div style="margin-top: 10px;">
			<a href="#" class="link-ico ico-add" onclick="og.event_tickets.ticket_types.add_ticket_type({genid:'<?php echo $genid ?>'});"><?php echo lang('add event ticket type') ?></a>
		</div>
	</div>
</div>

<script>

og.event_tickets.ticket_types.line_count = 1;
og.event_tickets.use_member_pricing = <?php echo config_option('use_ticket_type_member_pricing') ? "1" : "0" ?>;

<?php if ($member->isNew()) { ?>



<?php } else { ?>

    <?php foreach ($ticket_types as $ticket_type) { /* @var $ticket_type EventTicketType */?>

    	og.event_tickets.ticket_types.add_ticket_type({
			genid: '<?php echo $genid ?>',
			id: '<?php echo $ticket_type->getId() ?>',
			name: '<?php echo escape_character($ticket_type->getName()) ?>',
			description: '<?php echo str_replace("\n", "%|%", escape_character($ticket_type->getDescription())) ?>',
			currency_id: '<?php echo $ticket_type->getCurrencyId() ?>',
			amount: '<?php echo $ticket_type->getAmount() ?>',
			total_quantity: '<?php echo $ticket_type->getTotalQuantity() ?>',
			attendees_per_ticket: '<?php echo $ticket_type->getAttendeesPerTicket() ?>',
			available_from: '<?php echo format_date($ticket_type->getAvailableFrom(), null, 0) ?>',
			available_to: '<?php echo format_date($ticket_type->getAvailableTo(), null, 0) ?>',
			member_pricing: '<?php echo ($ticket_type->getMemberPricing() ? "1" : "0") ?>',
			input_required: '<?php echo ($ticket_type->getInputRequired() ? "1" : "0") ?>'
		});
	<?php } ?>
<?php } ?>
</script>
