-- <?php echo $table_prefix ?> 
-- <?php echo $default_charset ?> DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci
-- <?php echo $default_collation ?> collate utf8_unicode_ci
-- <?php echo $engine ?> InnoDB
-- varchar cannot be larger than 256
-- blob/text cannot have default values
-- sql queries must finish with ;\n (line break inmediately after ;)


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>event_ticket_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `event_id` int(10) unsigned NOT NULL DEFAULT 0,
  `name` varchar(255) NOT NULL DEFAULT '',
  `description` TEXT NULL,
  `show_description_in_website` tinyint(1) unsigned NOT NULL DEFAULT 0,
  `currency_id` int(10) unsigned NOT NULL DEFAULT 0,
  `amount` decimal(20,3) NOT NULL DEFAULT '0.000',
  `available_from` datetime NOT NULL,
  `available_to` datetime NOT NULL,
  `total_quantity` int(10) unsigned NOT NULL DEFAULT 0,
  `sold_quantity` int(10) unsigned NOT NULL DEFAULT 0,
  `attendees_per_ticket` int(10) unsigned NOT NULL DEFAULT 0,
  `member_pricing` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY (`id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>event_tickets` (
  `object_id` int(11) NOT NULL AUTO_INCREMENT,
  `ticket_type_id` int(11) NOT NULL,
  `requested_by_id` int(11) NOT NULL,
  `requested_on` datetime NOT NULL,
  `currency_id` int(11) NOT NULL,
  `unit_price` decimal(20,3) NOT NULL,
  `invoice_id` int(11) NOT NULL,
  `status` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`object_id`),
  KEY `ticket_type_id` (`ticket_type_id`),
  KEY `requested_on` (`requested_on`),
  KEY `status` (`status`),
  KEY `invoice_id` (`invoice_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>event_attendees` (
    `object_id` int(11) NOT NULL DEFAULT 0,
    `contact_id` int(11) NOT NULL DEFAULT 0,
    `event_ticket_id` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`object_id`),
  KEY `contact_id` (`contact_id`),
  KEY `event_ticket_id` (`event_ticket_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;


ALTER TABLE `<?php echo $table_prefix ?>event_ticket_types`
ADD `input_required` tinyint(1) unsigned NOT NULL DEFAULT '0';

ALTER TABLE `<?php echo $table_prefix ?>event_tickets`
ADD `comment` varchar(255) COLLATE 'utf8_unicode_ci' NOT NULL;