<?php

Env::useHelper('functions', 'evx_widgets');
ini_set('memory_limit', '1G');
$active_members = array();
$context = active_context();
foreach ($context as $selection) {
	if ($selection instanceof Member) $active_members[] = $selection;
}

$result = collect_tasks_and_time_amounts_data_for_widget();

$amounts_by_day = $result['amounts_by_day'];
$show_billing_info = true;
Hook::fire('get_can_see_billing_information', array('user'=>logged_user()), $show_billing_info);
$number_of_tasks = $result['number_of_tasks'];
$tasks_without_billing_cat = $result['tasks_without_billing_cat'];
$tasks_without_estimated_time = $result['tasks_without_estimated_time'];
$tasks_without_due_date = $result['tasks_without_due_date'];
$total_amount_tasks_without_billing_cat = $result['total_amount_tasks_without_billing_cat'];
$total_amount_tasks_without_estimated_time = $result['total_amount_tasks_without_estimated_time'];
$total_amount_tasks_without_due_date = $result['total_amount_tasks_without_due_date'];
$manual_tasks_earned_value_total = $result['manual_tasks_earned_value_total'];
$include_subtitle =  array_var($result, 'include_subtitle', false);
$subtitle_date_start =  array_var($result, 'subtitle_date_start', null);

// fill gaps with empty values
$keys = array_keys($amounts_by_day);
$first_key = $keys[0];
$last_key = end($keys);
$last_dt_val = DateTimeValueLib::dateFromFormatAndString('Y-m-d', $last_key);
$date_iter = DateTimeValueLib::dateFromFormatAndString('Y-m-d', $first_key);

// sort the amounts by date again
ksort($amounts_by_day);

// accumulate the amounts
$last_estimated_amount = 0;
$last_executed_amount = 0;
foreach ($amounts_by_day as &$amounts) {
	
	$amounts['estimated'] += $last_estimated_amount;
	$amounts['executed'] += $last_executed_amount;
	
	$last_estimated_amount = $amounts['estimated'];
	$last_executed_amount = $amounts['executed'];	
}

// Add the amounts of tasks without billing category, estimated time or due date
$last_estimated_amount += $total_amount_tasks_without_billing_cat;
$last_estimated_amount += $total_amount_tasks_without_estimated_time;
$last_estimated_amount += $total_amount_tasks_without_due_date;

// Add the amounts of manual tasks to the executed amount
$last_executed_amount += $manual_tasks_earned_value_total;

// Set currency symbol
$default_currency = Currencies::getDefaultCurrencyInfo();
$currency_symbol = !empty($default_currency) ? $default_currency['symbol'] : config_option('currency_code', '$');

// Set widget title
$widget_title = lang("earned value on labor");
if($include_subtitle){
	$date_format = user_config_option('date_format');
	$subtitle_date_formatted = $subtitle_date_start->format($date_format);
	$widget_subtitle = lang('from') . ': ' . $subtitle_date_formatted;
}
if($number_of_tasks > 0 && $show_billing_info) {
	include 'template.php';
}
