<?php /* @var Project $project */
$genid = gen_id();
$row_cls = "";
$no_objects_text = count($projects) > 0 ? '' : lang('you have no projects yet');
$dim_id = Dimensions::findByCode('customer_project')->getId();

$status_dimension = Dimensions::findByCode("project_statuses");
$status_ot = ObjectTypes::findByName("project_status");
$use_project_status_dimension = $status_dimension instanceof Dimension && in_array($status_dimension->getId(), config_option('enabled_dimensions'));
$pot = ObjectTypes::findByName('project');
$c_name = Members::getTypeNameToShowByObjectType($dim_id, $pot->getId(), null, true);
$add_button_text = count($projects) > 0 ? lang('add new project', $c_name) : lang('add your first project', $c_name);

// @TODO: Remove this code, modify this widget to take the columns from config option(s)
$expected_completion_cp = CustomProperties::getCustomPropertyByCode($pot->getId(), 'expected_completion');
if (!$expected_completion_cp) $expected_completion_cp = CustomProperties::getCustomPropertyByName($pot->getId(), 'Expected Completion');
$description_cp = CustomProperties::getCustomPropertyByCode($pot->getId(), 'description_special');
$project_id_cp = CustomProperties::getCustomPropertyByCode($pot->getId(), 'project_id');
// --------

/* @var $this Widget */
// $widget_header_color = $this->getContactOptionValue('color');
$header_color_class = "color-" . (isset($subtype) ? $subtype->getColor() : "1");


// this hook is used to add additional html content to the dasboard before rendering this widget
$params = array('genid' => $genid);
$ignored = null;
Hook::fire('before_render_evx_projects_widget', $params, $ignored);
?>

<div class="evx-projects-widget widget">

	<div style="overflow: hidden;" class="widget-header <?php echo $header_color_class ?>">
		<div class="widget-title"><?php echo isset($widget_title) ? $widget_title : $c_name; ?></div>
		<div class="view-all-container">
			<a href="#" onclick="og.projects.load_projects_list_in_new_tab('<?php echo $dim_id ?>', '<?php echo $pot->getId() ?>', '<?php echo (isset($subtype) ? $subtype->getId() : "0") ?>');"><?php echo lang("view all") ?></a>
		</div>
		<div style="margin-left: 15px;" onclick="og.dashExpand('<?php echo $genid ?>');">
			<div class="dash-expander ico-dash-expanded" id="<?php echo $genid; ?>expander"></div>
		</div>
	</div>

	<div class="widget-body" id="<?php echo $genid; ?>_widget_body">

		<div class="evx-project-list">

			<table class="project-list-table">
				<tr>
					<th style="width: 10%;max-width:120px;"><?php echo lang('Project ID') ?></th>
					<th><?php echo lang('Name') ?></th>
					<th style="width: 40%;"><?php echo lang('Description') ?></th>
					<th style="width: 16%;" class="right"><?php echo lang('Expected Completion') ?></th>
				</tr>

				<?php foreach ($projects as $project) : /* @var $project Project */
					$member = Members::findOneByObjectId($project->getId(), $dim_id);

					$expected_completion_date = '';
					if ($expected_completion_cp instanceof CustomProperty) {
						$cp_val = CustomPropertyValues::getCustomPropertyValue($project->getId(), $expected_completion_cp->getId());
						if ($cp_val instanceof CustomPropertyValue && trim($cp_val->getValue()) != '') {
							$date_val = DateTimeValueLib::dateFromFormatAndString(DATE_MYSQL, trim($cp_val->getValue()));
							if ($date_val) $expected_completion_date = format_date($date_val, null, 0);
						}
					}

					$project_description = '';
					if ($description_cp instanceof CustomProperty) {
						$cp_val = CustomPropertyValues::getCustomPropertyValue($project->getId(), $description_cp->getId());
						if ($cp_val instanceof CustomPropertyValue) {
							$project_description = $cp_val->getValue();
						}
					}

					$project_id = '';
					if ($project_id_cp instanceof CustomProperty) {
						$cp_val = CustomPropertyValues::getCustomPropertyValue($project->getId(), $project_id_cp->getId());
						if ($cp_val instanceof CustomPropertyValue) {
							$project_id = $cp_val->getValue();
						}
				
						if ($use_project_status_dimension) {
							
							$project_status = get_associated_status_member_id($member, $status_dimension, $status_ot, false, 'project_'.$status_ot->getName());
							$project_status_mem = Members::instance()->findById($project_status);
						
							if ($project_status_mem instanceof Member) {
								$status_html = '<span class="crpm-status member-path real-breadcrumb og-wsname-color-'. $project_status_mem->getColor() .'">' . clean($project_status_mem->getName()) . '</span>';
							}
              
						} else {
              
							$status_name = $project->getStatus() ? Localization::instance()->lang('project_field_status'.$project->getStatus()) : "";
							if ($status_name) {
								$status_html = '<div class="project-status-color color-'. $project->getStatus().' project-row-status-'. $project->getStatus().'" title="'. $status_name.'">'. $status_name.'</div>';
							}

						}
					} else {
						$status_name = $project->getStatus() ? Localization::instance()->lang('project_field_status' . $project->getStatus()) : "";
						if ($status_name) {
							$status_html = '<div class="project-status-color color-' . $project->getStatus() . ' project-row-status-' . $project->getStatus() . '" title="' . $status_name . '">' . $status_name . '</div>';
						}
					}
				?>
					<tr>
						<td><?php echo $project_id ?></td>

						<td><a class="internalLink" href="javascript:void(0);" onclick="og.projects.onProjectClick(<?php echo $project->getProjectMemberId() ?>);"><?php
																																									echo clean($project->getObjectName());
																																									?></a></td>

						<td><?php echo clean($project_description); ?></td>

						<td class="right"><?php echo $expected_completion_date ?></td>

					</tr>
				<?php endforeach; ?>
			</table>



			<?php foreach ($projects as $project) : /* @var $project Project */
				break;
				$member = Members::findOneByObjectId($project->getId(), $dim_id);
			?>
				<div class="project-row-container <?php echo $row_cls; ?>" id="project-<?php echo $project->getId() ?>">
					<div class="text-container" style="float:left; min-width:200px;">
						<a class="internalLink" href="javascript:void(0);" onclick="og.projects.onProjectClick(<?php echo $project->getProjectMemberId() ?>);"><?php
																																								echo clean($project->getObjectName());
																																								?></a><?php
																																										$p = $member->getParentMember();
																																										if ($p instanceof Member) {
																																											$crumb_members = array(
																																												$p->getId() => array('name' => $p->getName(), 'ot' => $p->getObjectTypeId(), 'c' => $p->getColor()),
																																											);
																																											$crumbOptions = json_encode(array($dim_id => $crumb_members));
																																											if ($crumbOptions == "") {
																																												$crumbOptions = "{}";
																																											}
																																											$crumbJs = " og.getEmptyCrumbHtml($crumbOptions, '.text-container' ) ";
																																										?>
							<span class="breadcrumb"></span>
							<script>
								var crumbHtml = <?php echo $crumbJs ?>;
								$("#project-<?php echo $project->getId() ?> .breadcrumb").html(crumbHtml);
							</script>
						<?php } ?>

					</div>

				</div>
				<div class="x-clear"></div>
			<?php endforeach; ?>
		</div>

		<div class="x-clear"></div>

		<?php if ($total > 0) : ?>

		<?php endif; ?>


	</div>
</div>

<script>
	var parent_id = '<?php echo $parent instanceof Member ? $parent->getId() : 0 ?>';
	$(function() {
		$(".add-project-button").click(function() {
			var url = og.getUrl('project', 'add', {
				parent: parent_id
			});
			var container = $(this).closest(".widget-body");
			container.closest(".widget-body").addClass("loading");
			og.openLink(url);
		});

		// hide the link to switch to overview list
		$(".dashboard-container.view-container .dashActions").hide();

	});
</script>