<?php /* @var Project $project */
	$genid = gen_id();
	$row_cls = "";
	$no_objects_text = count($projects) > 0 ? '' : lang('you have no projects yet');
	$dim_id = Dimensions::findByCode('customer_project')->getId();
	
	$status_dimension = Dimensions::findByCode("project_statuses");
	$status_ot = ObjectTypes::findByName("project_status");
	$use_project_status_dimension = $status_dimension instanceof Dimension && in_array($status_dimension->getId(), config_option('enabled_dimensions'));
	$pot = ObjectTypes::findByName('project');
	$c_name = Members::getTypeNameToShowByObjectType($dim_id, $pot->getId(), null, true);
	$add_button_text = count($projects) > 0 ? lang('add new project',$c_name) : lang('add your first project',$c_name);
	
	/* @var $this Widget */
	$widget_header_color = $this->getContactOptionValue('color');
	
?>

<div class="evx-projects-widget widget">

	<div style="overflow: hidden;" class="widget-header color-<?php echo $widget_header_color?>" onclick="og.dashExpand('<?php echo $genid?>');">
		<div class="widget-title"><?php echo isset($widget_title) ? $widget_title : $c_name; ?></div>
		<div class="dash-expander ico-dash-expanded" id="<?php echo $genid; ?>expander"></div>
	</div>
	
	<div class="widget-body" id="<?php echo $genid; ?>_widget_body" >
		
		<div class="evx-project-list">
		<?php foreach ($projects as $project): /* @var $project Project */
				$member = Members::findOneByObjectId($project->getId(), $dim_id);
		?>
			<div class="project-row-container <?php echo $row_cls;?>" id="project-<?php echo $project->getId()?>">
				<div class="text-container" style="float:left; min-width:200px;">
					<a class="internalLink" href="javascript:void(0);" onclick="og.projects.onProjectClick(<?php echo $project->getProjectMemberId()?>);"><?php 
						echo clean($project->getObjectName()); 
					?></a><?php
					$p = $member->getParentMember();
					if ($p instanceof Member) {
						$crumb_members = array(
							$p->getId() => array('name' => $p->getName(), 'ot' => $p->getObjectTypeId(), 'c' => $p->getColor()),
						);
						$crumbOptions = json_encode(array($dim_id => $crumb_members));
						if($crumbOptions == ""){
							$crumbOptions = "{}";
						}
						$crumbJs = " og.getEmptyCrumbHtml($crumbOptions, '.text-container' ) ";
					?>
					<span class="breadcrumb"></span>
					<script>
						var crumbHtml = <?php echo $crumbJs?>;
						$("#project-<?php echo $project->getId()?> .breadcrumb").html(crumbHtml);
					</script>
				<?php } ?>
				
				</div>
				<div style="float:left; width:150px;" class="chart-container"><?php 
					$chart_options = array();
					if (isset($completed_task_summary[$project->getId()])){
						
						$chart_options['data'] = array(
								array(
										'text'=> '',//lang('overdue'),
										'color'=>"#AA0000",
										'value' => (int)$completed_task_summary[$project->getId()]['overdue']
								),array(
										'text'=> '',//lang('pending'),
										'color'=>"#CCCCBB",
										'value' => (int)$completed_task_summary[$project->getId()]['pending']
								),array(
										'text'=> '',//lang('today'),
										'color'=>"#CCCC00",
										'value' => (int)$completed_task_summary[$project->getId()]['today']
								),array(
										'text'=> '',//lang('completed'),
										'color'=>"#00AA00",
										'value' => (int)$completed_task_summary[$project->getId()]['completed']
								)
						);
					}
					$chart_options['width'] = "150px";
					$chart_options['height'] = "100px";
					$chart_options['alpha'] = 0.75;
					render_pie_chart($chart_options);
				?></div>
				
				<div style="float:left; width: auto;" class="statistics-widget">
					<table class="statistics">
						<tr><td><div class="ref late">&nbsp;</div></td><td><?php echo lang('overdue pl f')?></td><td class="right"><?php echo $completed_task_summary['overdue']?></td></tr>	
						<tr><td><div class="ref upcoming">&nbsp;</div></td><td><?php echo lang('upcoming pl f')?></td><td class="right"><?php echo $completed_task_summary['pending']?></td></tr>	
						<tr><td><div class="ref today">&nbsp;</div></td><td><?php echo lang('today')?></td><td class="right"><?php echo $completed_task_summary['today']?></td></tr>	
						<tr><td><div class="ref complete">&nbsp;</div></td><td><?php echo lang('completed pl f')?></td><td class="right"><?php echo $completed_task_summary['completed']?></td></tr>	
					</table>
				</div>
			</div>
			<div class="x-clear"></div>
		<?php endforeach;?>
		</div>
		
		<div class="x-clear"></div>
		
		<?php if ($total > 0) : ?>
		<div class="view-all-container">
			<a href="#" onclick="og.openLink(og.getUrl('member', 'init', {dim_id:'<?php echo $dim_id?>', type_id:'<?php echo $pot->getId()?>'}), {caller:'projects list'})"><?php echo lang("view all") ?></a>
		</div>
		<?php endif ;?>
		

	</div>
</div>

<script>
	var parent_id = '<?php echo $parent instanceof Member ? $parent->getId() : 0?>';
	$(function(){
		$(".add-project-button").click(function(){
			var url = og.getUrl('project', 'add', {parent: parent_id});
			var container = $(this).closest(".widget-body") ;
			container.closest(".widget-body").addClass("loading");
			og.openLink(url); 
		});
/*
		var w = $(".evx-projects-widget").outerWidth() - $(".widget-buttons-left").outerWidth() - 70;
		var h = $(".evx-projects-widget .widget-body").outerHeight() - $(".evx-projects-widget .widget-body .view-all-container").outerHeight() - 25;
		$(".evx-project-list").css("width", w + "px").css("height", h + "px");
		*/
	});
</script>