<?php

/**
 * ExpenseCategory controller
 *
 * @version 1.0
 * @author Alex Zonis <alex.zonis@fengoffice.com>
 */
class ExpenseCategoryController extends ApplicationController {

	var $plugin_name = "expense_categories";
	
	/**
	 * Construct the ExpenseCategoryController
	 *
	 * @access public
	 * @param void
	 * @return ExpenseCategoryController
	 */
	function __construct() {
		parent::__construct();
		prepare_company_website_controller($this, 'website');
	    Env::useHelper('functions', $this->plugin_name);
	} // __construct

    function get_expense_category_billable_for_expense_form(){
		$member_ids = (array) json_decode(array_var($_REQUEST, 'member_ids', '{}'));
		$current_member_ids = (array) json_decode(array_var($_REQUEST, 'current_member_ids', '{}'));
		$current_billable = array_var($_REQUEST, 'current_billable', 1);
		$result = array('has_value' => false);

        $exp_cat_dim_id = Dimensions::findByCode('expense_categories')->getId();
        $exp_cat_ot_id = ObjectTypes::findByName('expense_category')->getId();
        $expense_category_id = array_var($member_ids, $exp_cat_dim_id, array(0))[0];
        $current_exp_category_array = array_var($current_member_ids, $exp_cat_dim_id, array(0));
        $current_expense_category_id = count($current_exp_category_array) == 2 ? $current_exp_category_array[1] : $current_exp_category_array[0];
        if($expense_category_id > 0 && $expense_category_id != $current_expense_category_id){
            $member_cp = MemberCustomProperties::instance()->findOne(array('conditions' => '`object_type_id`='.$exp_cat_ot_id.' AND `code`="is_billable"'));
            if($member_cp instanceof MemberCustomProperty){
                $cp_id = $member_cp->getId();
                $exp_cat_cpv = MemberCustomPropertyValues::instance()->findOne(array('conditions' => '`member_id`='.$expense_category_id.' AND `custom_property_id`='.$cp_id));
                if($exp_cat_cpv instanceof MemberCustomPropertyValue){
                    $is_billable = $exp_cat_cpv->getValue() == '-1' ? 0 : 1;
                    $result = array('has_value' => true, 'is_billable' => $is_billable);
                } else {
                    // Default value is 1
                    $is_billable = 1;
                    $result = array('has_value' => true, 'is_billable' => $is_billable);
                }
            }
        }
		ajx_current("empty");
		ajx_extra_data($result);
	}
	

} // ExpenseCategoryController