<?php
	class PaymentHistory extends BasePaymentHistory {
		
		function getTypeAttributes() {
				
			return Payments::getTypeAttributes($this);
				
		}
		
		function getDescriptionWithAttributes() {
				
			return Payments::getDescriptionWithAttributes($this);
				
		}
		
		function getAttributesString($separator=", ", $type='html') {
		
			return Payments::getDescriptionWithAttributes($this, $separator, false, false, $type);
		
		}
		
		
		function getArrayInfo() {
			Env::useHelper('format');
			
			$data = array();
			$currency = Currencies::instance()->getCurrency($this->getCurrency());
			$status = ExpensesStatuses::instance()->getStatus($this->getStatusId());
			$status_name = "";
			if ($status) {
				$status_name = $status->getName() == "" ? lang($status->getCode()) : $status->getName();
			}
			
			$data['description'] = $this->getDescription();
			$data['date'] = format_date($this->getDate(), null, 0);
			$data['amount'] = format_money_amount($this->getAmount(), $currency->getSymbol());
			$data['status'] = $status_name;
			
			$user = Contacts::instance()->findById($this->getUserId());
			$log_date = format_datetime($this->getModificationDate());
			if ($this->getModificationLog() == 'add') {
				$lang = 'created by on';
			} else {
				$lang = 'modified by on';
			} 
			$mod_data = lang($lang, '#', clean($user->getObjectName()), $log_date);
			
			$data['modification_data'] = $mod_data;
			
			return $data;
		}
		
	}