<?php
	class PaymentType extends BasePaymentType {
		
		function getArrayInfo($include_attributtes = true) {
			
			$info = array(
				"id" => $this->getId(),
				"name" => $this->getName(),
			);
			
			if ($include_attributtes) {
				
				$attributes = $this->getAttributes();
				
				$info['attributes'] = array();
				foreach ($attributes as $attribute) {
					$info['attributes'][] = $attribute->getArrayInfo();
				}
			}
			
			return $info;
		}
		
		
		function getAttributes() {
			
			$attributes = PaymentTypeAttributes::instance()->findAll(array('conditions' => 'payment_type_id = '.$this->getId(), 'order' => '`order`'));
			
			return $attributes;
		}
		
		
		
		function delete() {
			
			$attributes = $this->getAttributes();
			foreach ($attributes as $attr) {
				$attr->delete();
			}
			
			return parent::delete();
		}
	}
	 
