<?php 
	$genid = gen_id();
	$object = $expense;
	
	// on submit functions
	if (array_var($_REQUEST, 'modal')) {
		$on_submit = "og.expenses.submit_expense_form('".$genid."submit-edit-form'); return false;";
	} else {
		$on_submit = "return true;";
	}
	
	$currencies_info = Currencies::getCurrenciesInfo();
	$status_info = ExpensesStatuses::instance()->getAllStatusInfo();
	$payment_types_info = PaymentTypes::getAllPaymentTypesInfo();
	
	$use_date_in_expense_level = config_option("use_date_in_expense_level");
	$default_payment_status = config_option("default_payment_status");
	
	$categories = array();
	Hook::fire('object_edit_categories', $object, $categories);

	$main_cp_count = CustomProperties::countVisibleCustomPropertiesByObjectType($object->getObjectTypeId());
	$other_cp_count = CustomProperties::countHiddenCustomPropertiesByObjectType($object->getObjectTypeId());
	
	$action_for_empty_amount_payments = config_option("action_for_empty_amounts");
	
	if (!isset($force_render_object_members)) $force_render_object_members = false;
	
	$form_action = $expense->isNew() ? get_url('expense', 'add') : $expense->getEditUrl();
	if (isset($override_form_action) && $override_form_action) {
		$form_action = $override_form_action;
	}
?>
<style>
.payments-table-container table.payments ::-webkit-input-placeholder { color:#777; }
.payments-table-container table.payments ::-moz-placeholder { color:#777; }
.payments-table-container table.payments :-ms-input-placeholder { color:#777; }
.payments-table-container table.payments input:-moz-placeholder { color:#777; }
</style>

<form class="add-expense" id="<?php echo $genid ?>submit-edit-form" onsubmit="<?php echo $on_submit?>" action="<?php echo $form_action ?>" method="post" enctype="multipart/form-data" >
<div class="expense">
<div class="coInputHeader">

  <div class="coInputHeaderUpperRow">
	<div class="coInputTitle">
		<?php echo $object->getAddEditFormTitle(); ?>
	</div>
  </div>

  <div>
	<div class="coInputName">
		<?php echo text_field('expense[name]', $expense->getName(), array('id' => $genid . 'expenseName', 'class' => 'title', 'placeholder' => lang('type name here'))) ?>
	</div>
		
	<div class="coInputButtons">
		<?php echo submit_button($object->getSubmitButtonFormTitle(),'s', array('style'=>'margin-top:0px;margin-left:10px')) ?>
	</div>
	<div class="clear"></div>
  </div>
</div>

<div class="coInputMainBlock">
	
	<input id="<?php echo $genid?>genid" type="hidden" name="genid" value="<?php echo $genid ?>">
	<input id="<?php echo $genid?>updated-on-hidden" type="hidden" name="updatedon" value="<?php echo !$expense->isNew() ? $expense->getUpdatedOn()->getTimestamp() : '' ?>">
	
	<?php if (isset($original_expense_id)) { ?>
	<input id="<?php echo $genid?>original_expense_id" type="hidden" name="expense[original_expense_id]" value="<?php echo $original_expense_id?>" />
	<?php } ?>
	
	<div id="<?php echo $genid?>tabs" class="edit-form-tabs">
	
		<ul id="<?php echo $genid?>tab_titles">
		
			<li><a href="#<?php echo $genid?>add_expense_details"><?php echo lang('details') ?></a></li>
			<li><a href="#<?php echo $genid?>add_expense_description"><?php echo lang('description') ?></a></li>
			
			<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
			<li><a href="#<?php echo $genid?>add_custom_properties_div"><?php echo lang('custom properties') ?></a></li>
			<?php } ?>
			
			<li><a href="#<?php echo $genid?>add_subscribers_div"><?php echo lang('object subscribers') ?></a></li>
			
			<?php if($object->isNew() || $object->canLinkObject(logged_user())) { ?>
			<li><a href="#<?php echo $genid?>add_linked_objects_div"><?php echo lang('linked objects') ?></a></li>
			<?php } ?>
			
			<?php foreach ($categories as $category) {
					if (array_var($category, 'hidden')) continue;
				?>
			<li><a href="#<?php echo $genid . $category['name'] ?>"><?php echo $category['name'] ?></a></li>
			<?php } ?>
		</ul>
	
		<div id="<?php echo $genid ?>add_expense_details" class="form-tab">
			<div id="<?php echo $genid ?>add_expense_select_context_div" class="dataBlock"> 
				<?php
				$listeners = array('on_selection_change' => 'og.reload_subscribers("'.$genid.'",'.$object->manager()->getObjectTypeId().')');
				if ($expense->isNew()) {
					render_member_selectors($expense->manager()->getObjectTypeId(), $genid, null, array('select_current_context' => true, 'listeners' => $listeners, 'object' => $object), null, null, false);
				} else {
					render_member_selectors($expense->manager()->getObjectTypeId(), $genid, $expense->getMemberIds(), array('listeners' => $listeners, 'object' => $object), null, null, false);
				} 
				?>
			</div>
			
			<?php if ($use_date_in_expense_level) { ?>
			<div class="clear"></div>
			<div class="dataBlock"><?php 
				echo label_tag(lang('date'), $genid . 'expenseFormDate', false);
				echo pick_date_widget2('expense[date]', $expense->getDate(), $genid);
			?></div>
			<?php } ?>
			
			<?php $null = null; Hook::fire('before_render_main_custom_properties', array('object' => $object), $null);?>
			
			<div class="main-custom-properties-div"><?php
				if ($main_cp_count) {
					echo render_object_custom_properties($object, false, null, 'visible_by_default');
				}
			?></div>
			
			<div class="clear"></div>
			
			<div class="payments-table-container dataBlock" style="width:100%; display:none;">
				<div class="commentsTitle"><?php echo lang('payments')?></div>
				
				<table class="payments" id="<?php echo $genid?>payments-table" style="width:100%;">
					<tr><?php
						// payment type attribute headers
						if (count($payment_types_info) > 0) {
						?><th><?php echo lang('type')?></th><?php
						} ?>
						
						<th style="width:<?php echo ($use_date_in_expense_level ? "320px;" : "180px")?>;"><?php echo lang('description')?></th>
						
						<?php if (!$use_date_in_expense_level) { ?>
						<th style="width:100px;"><?php echo lang('date')?></th>
						<?php } ?>
						
						<th class="right"><?php echo lang('amount')?></th>
						<th class="right"><?php echo lang('status')?></th>
						<th></th>
					</tr>
				
				</table>
				
				<div><a class="coViewAction ico-add" href="#" id="<?php echo $genid?>add-payment-button"><?php echo lang('add budgeted payment')?></a></div>
			</div>
			
			<div class="clear"></div>
		</div>
		
		<div id="<?php echo $genid ?>add_expense_description" class="editor-container form-tab">
			<div class="dataBlock"><?php 
				$content_text = $expense->getDescription();
				echo label_tag(lang('description'), $genid . 'expenseFormText', false);
				echo textarea_field('expense[description]', $content_text, array('id' => $genid . 'expenseFormText', 'tabindex' => '50', 'class' => 'long'));
				
			?></div>
		</div>	
		
		<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
		<div id="<?php echo $genid ?>add_custom_properties_div" class="form-tab other-custom-properties-div">
			<?php  echo render_object_custom_properties($object, false, null, 'other') ?>
			<?php  echo render_add_custom_properties($object); ?>
		</div>
		<?php } ?>
	
		<div id="<?php echo $genid ?>add_subscribers_div" class="form-tab">
			<div id="<?php echo $genid ?>add_subscribers_content"><?php
				$subscriber_ids = array();
				if (!$object->isNew()) {
					$subscriber_ids = $object->getSubscriberIds();
				} else {
					$subscriber_ids[] = logged_user()->getId();
				}
				echo render_add_subscribers($object, $genid);
				foreach ($subscriber_ids as $subid) {
					echo '<input type="hidden" name="subscribers[user_'.$subid.']" value="1"/>';
				} 
			?></div>
		</div>
	
		<?php if($object->isNew() || $object->canLinkObject(logged_user())) { ?>
		<div id="<?php echo $genid ?>add_linked_objects_div" class="form-tab">
			<?php echo render_object_link_form($object) ?>
		</div>
		<?php } // if ?>
		
		<?php foreach ($categories as $category) { ?>
		<div id="<?php echo $genid . $category['name'] ?>" class="form-tab">
			<?php echo $category['content'] ?>
		</div>
		<?php } ?>

	</div>
	<?php if (!array_var($_REQUEST, 'modal')) {
		echo submit_button($expense->isNew() ? lang('add expense') : lang('save changes'),'s', array('tabindex' => '20000')); 
	}?>
	<div class="clear"></div>
</div>
<div class="clear"></div>
</div>
</form>

<script>
var genid = '<?php echo $genid?>';
og.expenses.currencies = Ext.util.JSON.decode('<?php echo(json_encode($currencies_info))?>');
og.expenses.statuses = Ext.util.JSON.decode('<?php echo(json_encode($status_info))?>');
og.expenses.payment_types = Ext.util.JSON.decode('<?php echo(json_encode($payment_types_info))?>');
og.expenses.use_date_in_expense_level = <?php echo ($use_date_in_expense_level ? '1' : '0')?>;
og.expenses.default_payment_status = '<?php echo $default_payment_status?>';
og.expenses.action_for_empty_amount_payments = '<?php echo $action_for_empty_amount_payments?>';

$(function(){
	$("#"+genid+"add-payment-button").click(function(){
		og.expenses.addPaymentTableRow(genid + 'payments-table', {num: <?php echo ($max_pnum + 1); ?>}, genid);
		return false;
	});

<?php 
	if (false) {
	  if (isset($payments) && is_array($payments) && count($payments) > 0) {
		foreach ($payments as $p) { ?>
			payment = {
				type_id:'<?php echo $p->getTypeId()?>', 
				num:'<?php echo $p->getPaymentNum()?>', 
				desc:'<?php echo escape_character($p->getDescription())?>', 
				date:'<?php echo format_date($p->getDate(), null, 0)?>', 
				status:'<?php echo $p->getStatusId()?>', 
				currency:'<?php echo $p->getCurrency()?>', 
				amount:'<?php echo number_format($p->getAmount(), 2)?>',
				attributes: {}
			};
			<?php 
			$pattributes = array_var($payment_attributes, $p->getPaymentNum());
			if (is_array($pattributes) && count($pattributes) > 0) {
				foreach ($pattributes as $attr) {
					$attr_value = $attr->getValue();
					$attr_def = PaymentTypeAttributes::instance()->findOne(array('conditions' => "payment_type_id='".$attr->getTypeId()."' AND attribute_id='".$attr->getAttributeId()."'"));
					if (!$attr_def instanceof PaymentTypeAttribute) continue;
					if ($attr_def->getType() == 'date') {
						$date = DateTimeValueLib::dateFromFormatAndString(DATE_MYSQL, $attr_value);
						$attr_value = format_date($date, null, 0);
					}
					if ($attr_def->getType() == 'user' || $attr_def->getType() == 'contact') {
						$c = Contacts::instance()->findById($attr_value);
						$cname = $c instanceof Contact ? $c->getObjectName() : "";
						$attr_value = $cname == "" ? "" : $c->getId()."|".escape_character($cname);
					}
			?>
					payment.attributes[<?php echo $attr->getAttributeId()?>] = '<?php echo $attr_value?>';
			<?php }
			}
			?>
			og.expenses.addPaymentTableRow(genid + 'payments-table', payment, genid);<?php 
		} ?>
<?php } else { ?>
			og.expenses.addPaymentTableRow(genid + 'payments-table', null, genid);
<?php } ?>
<?php 
	} ?>
	$("#<?php echo $genid?>tabs").tabs();
});
</script>