<?php 
	$genid = gen_id();
	$object = $payment;
	
	// on submit functions
	if (array_var($_REQUEST, 'modal')) {
		$on_submit = "og.expenses.submit_payment_form('".$genid."submit-edit-form'); return false;";
	} else {
		$on_submit = "return true;";
	}
	
	$currencies_info = Currencies::getCurrenciesInfo();
	$status_info = ExpensesStatuses::instance()->getAllStatusInfo();
	$payment_types_info = PaymentTypes::getAllPaymentTypesInfo();
	
	$default_payment_status = config_option("default_payment_status");
	
	$categories = array();
	Hook::fire('object_edit_categories', $object, $categories);

	$main_cp_count = CustomProperties::countVisibleCustomPropertiesByObjectType($object->getObjectTypeId());
	$other_cp_count = CustomProperties::countHiddenCustomPropertiesByObjectType($object->getObjectTypeId());
	
	$action_for_empty_amount_payments = config_option("action_for_empty_amounts");
	
	if (!$expense instanceof Expense) {
		$expense = new Expense();
	}
	
?>
<form class="add-payment" id="<?php echo $genid ?>submit-edit-form" onsubmit="<?php echo $on_submit?>" action="<?php echo $payment->isNew() ? get_url('payment', 'add') : $payment->getEditUrl() ?>" method="post" enctype="multipart/form-data" >
<div class="payment">
<div class="coInputHeader">

  <div class="coInputHeaderUpperRow">
	<div class="coInputTitle">
		<?php echo $object->getAddEditFormTitle(); ?>
	</div>
  </div>

  <div>
      
	<div class="coInputName">
		<?php echo text_field('payment[name]', $payment->getName(), array('id' => $genid . 'paymentName', 'class' => 'title', 'placeholder' => lang('type name here'))) ?>
	</div>	
	<div class="coInputButtons" style="float: right;">
		<?php echo submit_button($object->getSubmitButtonFormTitle(),'s', array('style'=>'margin-top:0px;margin-left:10px;')) ?>
	</div>
	<div class="clear"></div>
  </div>
</div>

<div class="coInputMainBlock">
	
	<input id="<?php echo $genid?>genid" type="hidden" name="genid" value="<?php echo $genid ?>">
	<input id="<?php echo $genid?>updated-on-hidden" type="hidden" name="updatedon" value="<?php echo !$payment->isNew() ? $payment->getUpdatedOn()->getTimestamp() : '' ?>">
	
	<input id="<?php echo $genid?>expense-id" type="hidden" name="payment[expense_id]" value="<?php echo $expense->getId() ?>">
	
	<div id="<?php echo $genid?>tabs" class="edit-form-tabs">
	
		<ul id="<?php echo $genid?>tab_titles">
		
			<li><a href="#<?php echo $genid?>add_payment_details"><?php echo lang('details') ?></a></li>
			
			<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
			<li><a href="#<?php echo $genid?>add_custom_properties_div"><?php echo lang('custom properties') ?></a></li>
			<?php } ?>
			
			<li><a href="#<?php echo $genid?>add_subscribers_div"><?php echo lang('object subscribers') ?></a></li>
			
			<?php if($object->isNew() || $object->canLinkObject(logged_user())) { ?>
			<li><a href="#<?php echo $genid?>add_linked_objects_div"><?php echo lang('linked objects') ?></a></li>
			<?php } ?>
			
			<?php if(!$object->isNew()) { ?>
			<li><a href="#<?php echo $genid?>view_payment_history_div"><?php echo lang('payment history') ?></a></li>
			<?php } ?>
			
			<?php foreach ($categories as $category) {
					if (array_var($category, 'hidden')) continue;
				?>
			<li><a href="#<?php echo $genid . $category['name'] ?>"><?php echo $category['name'] ?></a></li>
			<?php } ?>
		</ul>
	
		<div id="<?php echo $genid ?>add_payment_details" class="form-tab">
		
			<?php $null = null; Hook::fire('before_render_member_selectors', array('object' => $object, 'genid' => $genid), $null);?>
		
			<div id="<?php echo $genid ?>add_payment_select_context_div" class="dataBlock"> 
				<?php
				$listeners = array(
					'on_selection_change' => 'og.reload_subscribers("'.$genid.'",'.$object->manager()->getObjectTypeId().');'
						. 'og.checkCanHaveExpense("'.$genid.'");'
				);
				Hook::fire('modify_member_selector_listeners', array('genid' => $genid, 'object' => $object), $listeners);
				
				$skipped_dimensions = array();
				Hook::fire('add_member_selector_skipped_dimensions', array('genid' => $genid, 'object' => $object), $skipped_dimensions);
				
				if ($payment->isNew()) {
					render_member_selectors($payment->manager()->getObjectTypeId(), $genid, null, array('select_current_context' => true, 'listeners' => $listeners, 'object' => $object), $skipped_dimensions, null, false);
				} else {
					render_member_selectors($payment->manager()->getObjectTypeId(), $genid, $payment->getMemberIds(), array('listeners' => $listeners, 'object' => $object), $skipped_dimensions, null, false);
				} 
				?>
			</div>
			<div class="clear"></div>
			
			<?php $null = null; Hook::fire('after_render_member_selectors', array('object' => $object, 'genid' => $genid), $null);?>
			
			<?php 
				$using_expenses = true; 
				Hook::fire('payments_use_expenses', array('object' => $object, 'genid' => $genid), $using_expenses);
				if ($using_expenses) {
			?>
			<div class="dataBlock"><?php
				echo label_tag(lang('expense'));
				?><span id="<?php echo $genid?>paymentExpenseName"><?php
					echo $expense->getName();
				?></span>
				&nbsp;&nbsp;
				
				<input type="hidden" name="payment[expense_id]" value="<?php echo $payment->getExpenseId()?>" id="<?php echo $genid?>paymentExpenseId"/>
				<a class="link-ico ico-edit underline" id="<?php echo $genid ?>exp_change_link" href="#" onclick="og.changeExpense(this);" style="font-size:13px;"><?php 
					echo $payment->getExpenseId() > 0 ? lang('change expense') : lang('select expense');
				?></a>
				&nbsp;
				<a class="link-ico ico-delete underline" id="<?php echo $genid ?>exp_remove_link" href="#" onclick="og.removePaymentExpense('<?php echo $genid?>', true);" 
					style="font-size:13px;<?php echo $payment->getExpenseId() > 0 ? "" : "display:none;" ?>"><?php 
					echo lang('remove');
				?></a>
				    			
			</div>
			<div class="clear"></div>
			<?php } ?>
			
			<div class="dataBlock"><?php
				echo label_tag(lang('payment amount'), null, true);
				$currency = $payment->isNew() ? null : $payment->getCurrency();
				echo currency_select_box('payment[currency]', $currency);
				echo text_field('payment[amount]', $payment->getAmount(), array('class' => 'amount'));
			?></div>
			<div class="clear"></div>
			
			<?php 
				$remove_date_from_payments = false;
				Hook::fire("remove_date_from_payments", $payment, $remove_date_from_payments);
				if (!$remove_date_from_payments) {
			?>
			
			<div class="dataBlock"><?php 
				echo label_tag(lang('date'));
				echo pick_date_widget2('payment[date]', $payment->getDate(), $genid);
			?></div>
			<div class="clear"></div>
			
			<?php
				}
			?>
			
			<div class="dataBlock"><?php 
				echo label_tag(lang('status'));
				$sel_status_id = $payment->isNew() ? config_option('default_payment_status') : $payment->getStatusId();
				
				$all_staus_info = ExpensesStatuses::instance()->getAllStatusInfo();
				$options = array();
				foreach ($all_staus_info as $st) {
					if ($st['only_for_expenses']) continue;
					$attr = array();
					if ($sel_status_id == $st['id']) $attr['selected'] = 'selected';
					$options[] = option_tag($st['name'], $st['id'], $attr);
				}
				
				echo select_box('payment[status_id]', $options);
			?></div>
			<div class="clear"></div>
			
			<?php $null = null; Hook::fire('before_render_main_custom_properties', array('object' => $object, 'genid' => $genid), $null);?>
			
			<div class="main-custom-properties-div"><?php
				if ($main_cp_count) {
					echo render_object_custom_properties($object, false, null, 'visible_by_default');
				}
			?></div>
			
			<div class="clear"></div>
		</div>
		
		<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
		<div id="<?php echo $genid ?>add_custom_properties_div" class="form-tab other-custom-properties-div">
			<?php  echo render_object_custom_properties($object, false, null, 'other') ?>
			<?php  echo render_add_custom_properties($object); ?>
		</div>
		<?php } ?>
	
		<div id="<?php echo $genid ?>add_subscribers_div" class="form-tab">
			<div id="<?php echo $genid ?>add_subscribers_content"><?php
				$subscribers = $payment->isNew() ? $expense->getSubscribers() : $payment->getSubscribers();
				$subscriber_members = $payment->isNew() ? $expense->getMembers() : $payment->getMembers();
				
				echo render_add_subscribers($object, $genid, $subscribers, $subscriber_members);
				
				foreach ($subscriber_ids as $subid) {
					echo '<input type="hidden" name="subscribers[user_'.$subid.']" value="1"/>';
				} 
			?></div>
		</div>
	
		<?php if($object->isNew() || $object->canLinkObject(logged_user())) { ?>
		<div id="<?php echo $genid ?>add_linked_objects_div" class="form-tab">
			<?php echo render_object_link_form($object) ?>
		</div>
		<?php } // if ?>
		
		
		<?php if (!$object->isNew()) { ?>
		<div id="<?php echo $genid ?>view_payment_history_div" class="form-tab">
			<?php
				$history = PaymentHistories::instance()->getFormattedHistory($object->getObjectId(), null, null);
				
				tpl_assign('history', $history['data']);
				tpl_display(get_template_path('payment_history', 'expense', 'expenses'));
			?>
		</div>
		<?php } ?>
		
		
		<?php foreach ($categories as $category) { ?>
		<div id="<?php echo $genid . $category['name'] ?>" class="form-tab">
			<?php echo $category['content'] ?>
		</div>
		<?php } ?>

	</div>
	<?php if (!array_var($_REQUEST, 'modal')) {
		echo submit_button($payment->isNew() ? lang('add payment') : lang('save changes'),'s', array('tabindex' => '20000')); 
	}?>
	<div class="clear"></div>
</div>
<div class="clear"></div>
</div>
</form>

<script>
var genid = '<?php echo $genid?>';
og.expenses.action_for_empty_amount_payments = '<?php echo $action_for_empty_amount_payments?>';

$(function(){
	$("#<?php echo $genid?>tabs").tabs();
});

og.after_selecting_payment_expense = false;


og.changeExpense = function(before) {
	og.ObjectPicker.show(function (objs) {
		if (objs && objs.length > 0) {
			var obj = objs[0].data;
			if (obj.type != 'expense') {
				og.msg(lang("error"), lang("object type not supported"), 4, "err");
			} else {
				$("#"+genid+"paymentExpenseId").val(obj.object_id);
				$("#"+genid+"paymentExpenseName").html(obj.name);
				$(before).html(lang("change expense"));

				$("#"+genid+"exp_remove_link").show();

				og.after_selecting_payment_expense = true;
				
				og.resetPaymentMembersByExpense(genid, obj.object_id);
			}
		}
	}, before, {
		hideFilters: true,
		hideUploadButton: true,
		ignore_context: true,
		extra_member_ids: $("#<?php echo $genid?>members").val(),
		types: ['expense'],
		selected_type: 'expense'
	});
};

</script>