
if (!og.expenses.payment_list_grid_config) og.expenses.payment_list_grid_config = {};

og.expenses.payment_list_grid_config.tbar_items = [];
<?php 

$new_buttons = array(array(
		'id' => 'new_payment_btn',
		'name' => lang('add new payment'),
		'icon' => 'ico-new',
		'action' => 'og.render_modal_form(\'\', {c:\'payment\', a:\'add\', params: {expense_id:0}})',
));

if (Plugins::instance()->isActivePlugin("object_subtypes")) {
	$subtypes = ObjectSubtypes::instance()->findAll(array("conditions" => array("object_type_id = ?",Payments::instance()->getObjectTypeId())));
	foreach ($subtypes as $subtype) {
		$new_buttons[] = array(
				'id' => $subtype->getName() . '_btn',
				'name' => lang('add'). " " .$subtype->getName(),
				'icon' => 'ico-new',
				'member_id' => $subtype->getMemberId(),
				'action' => 'og.render_modal_form(\'\', {c:\'payment\', a:\'add\', params: {expense_id:0, object_subtype_id:'.$subtype->getId().'}})',
		);
	}
}

// dont show the new payment button until the expense selector is implemented in add/edit payment form.
//$new_buttons = array();

if (count($new_buttons) == 1) { ?>
	og.expenses.payment_list_grid_config.tbar_items.push(
		new Ext.Action({
			id: '<?php echo $new_buttons[0]['id']?>',
			text: '<?php echo $new_buttons[0]['name']?>',
	        iconCls: '<?php echo $new_buttons[0]['icon']?>',
	        handler: function() {
	        	<?php echo $new_buttons[0]['action']?>
			}
		})
	);
<?php 
} else { ?>
	var menu_items = [];
<?php 
	foreach ($new_buttons as $nb) { ?>
		menu_items.push(
			new Ext.Action({
				id: '<?php echo $nb['id']?>',
				text: '<?php echo $nb['name']?>',
		        iconCls: '<?php echo $nb['icon']?>',
		        member_id: '<?php echo array_var($nb, 'member_id', '0')?>',
		        handler: function() {
		        	<?php echo $nb['action']?>
				}
			})
		);
<?php 
	} ?>
	if (menu_items.length > 0) {
		var dd_menu = new Ext.Button({
			iconCls: 'ico-new',
			text: lang('new'),
			id: 'pgrid_new_payment_btn',
			menu: {
				cls:'scrollable-menu',
				items: menu_items
			}
		});
		
		og.expenses.payment_list_grid_config.tbar_items.push(dd_menu);
	}
<?php 
}
?>


var trash_action = new Ext.Action({
	text: lang('move to trash'),
    tooltip: lang('move selected objects to trash'),
    iconCls: 'ico-trash',
	disabled: true,
	handler: function() {
		if (confirm(lang('confirm move to trash'))) {
			var man = Ext.getCmp('payment-manager');
			man.load({
				action: 'delete',
				ids: man.getSelectedIds()
			});
			man.getSelectionModel().clearSelections();
		}
	},
	selection_dependant: true,
	is_multiple: true
});

var archive_action = new Ext.Action({
	text: lang('archive'),
    tooltip: lang('archive selected object'),
    iconCls: 'ico-archive-obj',
	disabled: true,
	handler: function() {
		if (confirm(lang('confirm archive selected objects'))) {
			var man = Ext.getCmp('payment-manager');
			man.load({
				action: 'archive',
				ids: man.getSelectedIds()
			});
			man.getSelectionModel().clearSelections();
		}
	},
	selection_dependant: true,
	is_multiple: true
});

var edit_action = new Ext.Action({
	text: lang('edit'),
    tooltip: lang('edit selected object'),
    iconCls: 'ico-edit',
	disabled: true,
	handler: function() {
		var man = Ext.getCmp('payment-manager');
		og.render_modal_form('', {c:'payment', a:'edit', params: {id:man.getFirstSelectedId()}});
	},
	selection_dependant: true,
	is_multiple: false
});

og.expenses.payment_list_grid_config.tbar_items.push(edit_action);
og.expenses.payment_list_grid_config.tbar_items.push(archive_action);
og.expenses.payment_list_grid_config.tbar_items.push(trash_action);



var status_options = [[0, '-- ' + lang('All') + ' --']];
if (og.expenses.all_status) {
	for (x=0; x < og.expenses.all_status.length; x++) {
		var st = og.expenses.all_status[x];
		if (st.only_for_expenses) continue;
		
		status_options.push([st.id, st.name]);
	}
}

og.expenses.payment_list_grid_config.filters = {
	status_filter: {type:'list', label: '&nbsp;'+lang('status')+': ', options: status_options, initial_val:0, secondToolbar: true},
	from_filter: {type:'date', label: '&nbsp;'+lang('from date')+': ', secondToolbar: true},
	to_filter: {type:'date', label: '&nbsp;'+lang('to date')+': ', secondToolbar: true}
};
if (typeof(og.build_text_filter_toolbar_item) == 'function') {
	text_filter_input = og.build_text_filter_toolbar_item('payment-manager');
	text_filter_input.secondToolbar = true;
	
	og.expenses.payment_list_grid_config.filters.text_filter = text_filter_input;
}

