<?php
Env::useHelper('format');
if (isset($payment) && $payment instanceof Payment) {
	if (!$payment->isTrashed()){
		if($payment->canEdit(logged_user())) {
			add_page_action(lang('edit'), "javascript:og.render_modal_form('', {c:'payment', a:'edit', params: {id:".$payment->getId()."}});", 'ico-edit', null, null, true);
			if (!$payment->isArchived())
				add_page_action(lang('archive'), "javascript:if(confirm(lang('confirm archive object'))) og.openLink('" . $payment->getArchiveUrl() ."');", 'ico-archive-obj');
			else
				add_page_action(lang('unarchive'), "javascript:if(confirm(lang('confirm unarchive object'))) og.openLink('" . $payment->getUnarchiveUrl() ."');", 'ico-unarchive-obj');
		}
	}
	if ($payment->canDelete(logged_user())) {
		if ($payment->isTrashed()) {
			add_page_action(lang('restore from trash'), "javascript:if(confirm(lang('confirm restore objects'))) og.openLink('" . $payment->getUntrashUrl() ."');", 'ico-restore', null, null, true);
			add_page_action(lang('delete permanently'), "javascript:if(confirm(lang('confirm delete permanently'))) og.openLink('" . $payment->getDeletePermanentlyUrl() ."');", 'ico-delete', null, null, true);
		} else {
			add_page_action(lang('move to trash'), "javascript:if(confirm(lang('confirm move to trash'))) og.openLink('" . $payment->getTrashUrl() ."');", 'ico-trash', null, null, true);
		}
	}
	if (!isset($genid)) $genid = gen_id();
?>

<div style="padding:7px">
<div class="payment">
<?php
	$status = ExpensesStatuses::instance()->getStatus($payment->getStatusId());
	
	$content = '';
	
	$st_html = '<span class="expense-row-status-'.($status instanceof ExpensesStatus ? $status->getCode() : '').'">'.($status instanceof ExpensesStatus ? lang($status->getCode()) : '').'</span>';
	$content .= '<div><span class="bold ">'.lang('status').': </span>'.$st_html.'</div>';
	
	$remove_date_from_payments = false;
	Hook::fire("remove_date_from_payments", $payment, $remove_date_from_payments);
	if ($payment->getDate() && !$remove_date_from_payments) {
		$content .= '<div><span class="bold">'.lang('date').': </span>'.format_date($payment->getDate(), null, 0).'</div>';
	}
	
	$currency = Currencies::instance()->getCurrency($payment->getCurrency());
	$c_symbol = $currency instanceof Currency ? $currency->getSymbol() : "$";
	$content .= '<div><span class="bold ">'.lang('payment amount').': </span>'.format_money_amount($payment->getAmount(), $c_symbol).'</div>';
	
	$content .= '<div><span class="bold">'.lang('description').': </span>'.$payment->getDescription().'</div>';
	
	Hook::fire('additional_view_payment_data', $payment, $content);
	
	$content .= '<br /><div id="'. $genid .'payment_history_container"></div>';
	
	tpl_assign("content", $content);
	tpl_assign("object", $payment);
	tpl_assign('iconclass', $payment->isTrashed()? 'ico-large-payment-trashed' : ($payment->isArchived() ? 'ico-large-payment-archived' : 'ico-large-payment'));
	
	$this->includeTemplate(get_template_path('view', 'co'));
?>
</div>
</div>
<script>
og.openLink(og.getUrl('payment', 'show_payment_history', {id:<?php echo $payment->getObjectId() ?>}), {
	callback: function(success, data) {
		if (data && data.html) {
			$("#<?php echo $genid ?>payment_history_container").html(data.html);
		}
	}
});
</script>
<?php } ?>
