<?php
	$genid = gen_id();
	$on_submit = "og.submit_modal_form('".$genid."submit-edit-form'); return false;";
	$form_action = $object->isNew() ? get_url('payment_types', 'add') : get_url('payment_types', 'edit', array('id' => $object->getId()));
	
	$attribute_types = PaymentTypeAttributes::getAllAttributeTypes();
?>

<script>
	var genid = '<?php echo $genid?>';
	og.pt_attribute_count = 0;
</script>

<form onsubmit="<?php echo $on_submit?>" class="add-payment-type" id="<?php echo $genid ?>submit-edit-form" action="<?php echo $form_action ?>" method="post" enctype="multipart/form-data">
<div class="payment-type">

<div class="coInputHeader">

  <div class="coInputHeaderUpperRow">
	<div class="coInputTitle">
		<?php echo $object->isNew() ? lang('new payment type') : lang('edit payment type') ?>
	</div>
  </div>

  <div>
	<div class="coInputName">
	<?php echo text_field('payment_type[name]', $object->getName(), array('id' => $genid . 'payment_typeFormTitle', 'class' => 'title', 'placeholder' => lang('type name here'))) ?>
	</div>
		
	<div class="coInputButtons">
		<?php echo submit_button($object->isNew() ? lang('add payment type') : lang('save changes'),'s',array('style'=>'margin-top:0px;margin-left:10px')) ?>
	</div>
	<div class="clear"></div>
  </div>
</div>

<div class="coInputMainBlock adminMainBlock">
	
	<div id="<?php echo $genid?>tabs" class="edit-form-tabs">
	
		<ul id="<?php echo $genid?>tab_titles">
		
			<li><a href="#<?php echo $genid?>add_payment_type_attributes"><?php echo lang('attributes') ?></a></li>
			
		</ul>

		
		<div id="<?php echo $genid ?>add_payment_type_attributes" class="form-tab">
		
			<table style="width:100%;" id="<?php echo $genid?>pt-attributes-table" class="pt-attributes-table bordered">
			
				<tr class="header texture-n-1">
					<th style="width:10px;padding:0px;"></th><th><?php echo lang('name')?></th><th><?php echo lang('type')?><th><?php echo lang('required')?></th><th></th>
				</tr>
				
				<tbody id="<?php echo $genid?>_template_attr_row" style="display:none;">
					<tr>
					<td class="ddhandle"></td>
					<td>
						<input type="hidden" value="-1" name="payment_type[attributes][{i}][id]" id="attribute_id"/>
						<input type="hidden" value="" name="payment_type[attributes][{i}][deleted]" id="deleted"/>
						<input type="text" value="" name="payment_type[attributes][{i}][name]" id="name" class="long"/>
						<div class="desc" id="deleted_message" style="display:none;"><?php echo lang('payment type attribute deleted')?></div>
					</td>
					<td style="width:100px;vertical-align: top;">
						<select name="payment_type[attributes][{i}][type]" id="type" onchange="og.payment_types.onAttributeTypeChange(this);">
						<?php foreach ($attribute_types as $at) { ?>
							<option value="<?php echo $at?>"><?php echo lang($at)?></option>
						<?php } ?>
						</select>
					</td>
					<td style="width:70px; text-align:center;">
						<input type="checkbox" name="payment_type[attributes][{i}][is_required]" id="is_required"/>
					</td>
					<td class="actions" style="vertical-align: top;">
						<a class="link-ico ico-delete" id="delete_action" href="#" onclick="og.payment_types.deletePaymentTypeAttribute(this)" title="<?php echo lang('delete')?>"></a>
						<a id="undo_delete_action" href="#" onclick="og.payment_types.undoDeletePaymentTypeAttribute(this)" title="<?php echo lang('enable')?>" style="display:none;"><?php echo lang('enable')?></a>
					</td>
					</tr>
					<tr id="list_values_row" style="display:none;">
						<td></td>
						<td colspan="4"><input id="list_values" type="text" name="payment_type[attributes][{i}][list_values]" value="" placeholder="<?php echo lang('list values comma separated')?>" style="width:99%;"/></td>
					</tr>
				</tbody>
				
			</table>
			
			<div class="actions">
				<a href="#" class="link-ico ico-add" onclick="og.payment_types.addPaymentAttributeRow('<?php echo $genid?>'); return false;"><?php echo lang('add new attribute')?></a>
			</div>
			
		</div>
		
	</div>
	
	<?php if (!array_var($_REQUEST, 'modal')) {
		echo submit_button($object->isNew() ? lang('add payment type') : lang('save changes'),'s', array('style'=>'margin-top:0px')); 
	}?>
</div>
</div>
</form>
<script>
$(function() {
	$("#<?php echo $genid?>tabs").tabs();

<?php 
	if (count($attributes) == 0) { // add one empty row
	
		?>og.payment_types.addPaymentAttributeRow('<?php echo $genid?>');<?php
		
	} else {
		foreach ($attributes as $attr) { /* @var $attr PaymentTypeAttribute */ ?>
		var prop = {
			attribute_id: '<?php echo $attr->getAttributeId()?>',
			name: '<?php echo escape_character($attr->getName())?>',
			type: '<?php echo $attr->getType()?>',
			is_required: '<?php echo $attr->getIsRequired() ? '1' : '0'?>',
			list_values: '<?php echo escape_character($attr->getListValues())?>'
		};
		og.payment_types.addPaymentAttributeRow('<?php echo $genid?>', prop);
	<?php }
	} ?>

	$( "#<?php echo $genid?>pt-attributes-table").sortable({
		//items: "> tr",
		handle: ".ddhandle",
		cursor: "move",
		cancel: "tr.header"
	});
});
</script>