<?php
Hook::register('payment');

function payment_override_report_grouping_external_column_info($parameters, &$result) {
	$object_type = array_var($parameters, 'object_type');
	$column = array_var($parameters, 'column');
	
	if ($object_type->getName() == 'payment' && $column == 'status_id') {
		$result = array('table' => 'expenses_status', 'name_col' => 'code', 'link_col' => 'id');
	}
}

function payment_override_custom_report_group_name($parameters, &$group) {
	$object_type = array_var($parameters, 'ot');
	$gb = array_var($parameters, 'gb');
	
	if ($object_type->getName() == 'payment' && $gb['type'] == 'fixed_property' && $gb['id'] == 'status_id') {
		$group['name'] = lang($group['name']);
	}
}

function payment_custom_reports_override_column_format($parameters, &$value) {
        $report = array_var($parameters, 'report');
	$manager = array_var($parameters, 'manager');
	$field = array_var($parameters, 'field');
	$object = array_var($parameters, 'object');
	
	if ($manager instanceof Payments) {
             if ($report->getColumnValue('show_currency')) {
		if ($field == 'amount' || $field == 'budgeted') {
			$currency = Currencies::instance()->getCurrency($object->getCurrency());
			$csymbol = null;
			if ($currency instanceof Currency) {
				$csymbol = $currency->getSymbol();
			}
			$value = format_money_amount($object->getAmount(), $csymbol);
		}
             }
	}
}

function payment_custom_reports_get_external_column_value($parameters, &$value) {
	$external_id = array_var($parameters, 'external_id');
	$manager = array_var($parameters, 'manager');
	$field = array_var($parameters, 'field');
	$object = array_var($parameters, 'object');
	
	if ($manager instanceof Payments) {
		
		if ($field == 'status_id') {
			
			$st = ExpensesStatuses::instance()->findById($external_id);
			if ($st instanceof ExpensesStatus) {
				if (trim($st->getCode()) != '') {
					$value = clean(lang($st->getCode()));
				} else {
					$value = clean($st->getName());
				}
			} else {
				$value = "";
			}
			
		} else if ($field == 'currency') {
			$currency = Currencies::instance()->getCurrency($external_id);
			if ($currency instanceof Currency) {
				$value = $currency->getName();
			} else {
				$value = "";
			}
			
		} else if ($field == 'expense_id') {
			
			$exp = Expenses::instance()->findById($external_id);
			if ($exp instanceof Expense) {
				$value = clean($exp->getObjectName());
			} else {
				$value = "";
			}
		}
	}
}

function payment_custom_reports_get_possible_external_column_values($parameters, &$values) {
	$ot_id = array_var($parameters, 'ot_id');
	$field = array_var($parameters, 'field');
	$ot = ObjectTypes::instance()->findById($ot_id);

	if ($ot->getName() == 'payment') {
		
		if ($field == 'status_id') {
			
			$all_status = ExpensesStatuses::instance()->getAllStatusInfo();
			foreach ($all_status as $status) {
				if (!$status['only_for_expenses']) {
					$values[] = array('id' => $status['id'], 'name' => $status['name']);
				}
			}
			
		} else if ($field == 'currency') {
			
			$currencies = Currencies::instance()->getAllCurrencies();
			foreach ($currencies as $currency) {
				$values[] = array('id' => $currency->getId(), 'name' => $currency->getSymbol());
			}
			
		} else if ($field == 'expense_id') {
			
			// VER COMO PONER LOS GASTOS
		}
	}
}





function payment_add_report_more_options($params, &$more_options_html_array) {
	$report = array_var($params, 'report');
	$genid = array_var($params, 'genid');

	if ($report instanceof Report) {
		$ot = ObjectTypes::instance()->findById($report->getReportObjectTypeId());

		if ($ot->getName() == 'payment') {
				
			$more_options_html_array['show_currency'] = '
				<div class="report-option">
	                <label for="'.$genid.'show_currency">'. lang('show currency') .':</label>
	                <input id="'.$genid.'show_currency" type="checkbox" class="checkbox" name="report[show_currency]"
	                       '. ($report->getColumnValue('show_currency') ? 'checked="checked"' : '0') .'/>
	            </div>
			';
			
		}
	}

}

