-- <?php echo $table_prefix ?> fo_
-- <?php echo $default_charset ?> DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci
-- <?php echo $default_collation ?> collate utf8_unicode_ci
-- <?php echo $engine ?> InnoDB
-- varchar cannot be larger than 256
-- blob/text cannot have default values
-- sql queries must finish with ;\n (line break inmediately after ;)

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>expenses` (
  `object_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `description` TEXT NULL,
  `status` INTEGER UNSIGNED NOT NULL,
  `date` datetime NOT NULL,
  PRIMARY KEY (`object_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS`<?php echo $table_prefix ?>payments` (
  `object_id` int(10) unsigned NOT NULL,
  `expense_id` int(10) unsigned NOT NULL,
  `payment_num` int(10) unsigned NOT NULL,
  `status_id` int(10) unsigned NOT NULL DEFAULT '0',
  `date` datetime NOT NULL,
  `description` text COLLATE utf8_unicode_ci NOT NULL,
  `currency` int(10) unsigned NOT NULL,
  `amount` decimal(20,3) NOT NULL DEFAULT 0,
  `type_id` int(10) unsigned NOT NULL default 0,
  PRIMARY KEY (`object_id`),
  KEY `expense_id` (`expense_id`,`payment_num`),
  KEY `status_id` (`status_id`,`expense_id`,`payment_num`),
  KEY `date` (`date`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>payment_history` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `expense_id` int(10) unsigned NOT NULL,
  `payment_num` varchar(45) <?php echo $default_collation ?> NOT NULL,
  `date` datetime NOT NULL,
  `description` text <?php echo $default_collation ?> NOT NULL,
  `currency` int(10) unsigned NOT NULL,
  `amount` decimal(20,3) NOT NULL DEFAULT 0,
  `type_id` int(10) unsigned NOT NULL default 0,
  `user_id` int(10) unsigned NOT NULL,
  `modification_date` datetime NOT NULL,
  `status_id` int(10) unsigned NOT NULL,
  `status_name` varchar(128) <?php echo $default_collation ?> NOT NULL,
  `modification_log` text <?php echo $default_collation ?> NOT NULL,
  `payment_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  KEY `expense` (`expense_id`),
  KEY `amount` (`amount`),
  KEY `payment_id` (`payment_id`),
  KEY `date` (`date`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>expenses_history` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `object_id` int(10) unsigned NOT NULL,
  `description` text <?php echo $default_collation ?> NOT NULL,
  `user_id` int(10) unsigned NOT NULL,
  `modification_date` datetime NOT NULL,
  `status_id` int(10) unsigned NOT NULL,
  `date` datetime NOT NULL,
  `status_name` varchar(128) <?php echo $default_collation ?> NOT NULL,
  `modification_log` text <?php echo $default_collation ?> NOT NULL,
  PRIMARY KEY (`id`),
  KEY `expense` (`object_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>currencies` (
  `id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `symbol` VARCHAR(5) NOT NULL,
  `name` VARCHAR(128) NOT NULL,
  `short_name` VARCHAR(50) NOT NULL,
  `is_default` BOOLEAN NOT NULL,
    `external_id` INTEGER UNSIGNED NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>expenses_status` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `order` int(10) unsigned NOT NULL,
  `code` varchar(128) NOT NULL,
  `name` varchar(128) NOT NULL,
  `description` TEXT NULL,
  `editable` tinyint(1) NOT NULL,
  `created_on` datetime NOT NULL,
  `created_by_id` int(10) unsigned NOT NULL,
  `enabled` tinyint(1) NOT NULL,
  `is_final` tinyint(1) NOT NULL,
  `is_temporal` tinyint(1) NOT NULL,
  `only_for_expenses` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `order` (`order`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;



CREATE TABLE IF NOT EXISTS`<?php echo $table_prefix ?>payment_types` (
  `id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(255) NOT NULL,
  `created_by_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
  `created_on` datetime NOT NULL default '0000-00-00 00:00:00',
  `updated_by_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
  `updated_on` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY (`id`)
) ENGINE = <?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS`<?php echo $table_prefix ?>payment_type_attributes` (
  `payment_type_id` INTEGER UNSIGNED NOT NULL,
  `attribute_id` INTEGER UNSIGNED NOT NULL,
  `name` VARCHAR(255) NOT NULL,
  `type` VARCHAR(50) NOT NULL,
  `order` INTEGER UNSIGNED NOT NULL DEFAULT 0,
  `list_values` text COLLATE utf8_unicode_ci NOT NULL,
  `is_required` tinyint(1) NOT NULL,
  PRIMARY KEY (`payment_type_id`, `attribute_id`)
) ENGINE = <?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS`<?php echo $table_prefix ?>payment_attribute_values` (
  `expense_id` INTEGER UNSIGNED NOT NULL,
  `payment_num` INTEGER UNSIGNED NOT NULL,
  `type_id` int(10) unsigned NOT NULL,
  `attribute_id` INTEGER UNSIGNED NOT NULL,
  `value` TEXT NULL,
  PRIMARY KEY (`expense_id`, `payment_num`, `type_id`, `attribute_id`)
) ENGINE = <?php echo $engine ?> <?php echo $default_charset ?>;


ALTER TABLE `<?php echo $table_prefix ?>system_permissions` 
ADD COLUMN `can_edit_executed_payments` TINYINT(1) UNSIGNED NOT NULL DEFAULT 0;


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>expense_totals` (
  `expense_id` int(11) NOT NULL DEFAULT '0',
  `status_id` int(11) NOT NULL DEFAULT '0',
  `currency_id` int(11) NOT NULL DEFAULT '0',
  `amount` decimal(20,3) NOT NULL DEFAULT '0.000',
  PRIMARY KEY (`expense_id`,`status_id`,`currency_id`),
  KEY `currency_id_amount` (`currency_id`,`amount`)
) ENGINE = <?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>payment_totals` (
  `payment_id` int(11) NOT NULL DEFAULT '0',
  `status_id` int(11) NOT NULL DEFAULT '0',
  `currency_id` int(11) NOT NULL DEFAULT '0',
  `amount` decimal(20,3) NOT NULL DEFAULT '0.000',
  PRIMARY KEY (`payment_id`,`status_id`,`currency_id`),
  KEY `currency_id_amount` (`currency_id`,`amount`)
) ENGINE = <?php echo $engine ?> <?php echo $default_charset ?>;
