<?php 

class PaymentReceipts extends BasePaymentReceipts {
	function __construct() {
		parent::__construct();
		$this->object_type_name = 'payment_receipt';
	}
	

	function getColumnsToAggregateInTotals() {
		$parent_cols = parent::getColumnsToAggregateInTotals();
		$cols = array(
				'amount' => array('operation' => 'sum', 'format' => 'money', 'currency_id_col' => 'currency_id', 'group_by' => 'currency_id'),
				'total_price' => array('operation' => 'sum', 'format' => 'money', 'currency_id_col' => 'currency_id', 'group_by' => 'currency_id'),
				'total_cost_without_taxes' => array('operation' => 'sum', 'format' => 'money', 'currency_id_col' => 'currency_id', 'group_by' => 'currency_id'),
		);
	
		return array_merge($parent_cols, $cols);
	}


	function getExternalColumnValue($field, $id, $manager=null, $object=null) {
		$value = '';
		if ($field == 'task_id') {
			$task = ProjectTasks::instance()->findById($id);
			if ($task) $value = clean($task->getName());
		}
		return $value;
	}

	static function getActualExpensesByTask($task_id) {
		$expenses = null;

		if ($task_id > 0) {
			$expenses = self::instance()->findAll(array("conditions" => array("task_id = ? and trashed_by_id=0", $task_id)));
		}

		return $expenses;
	}
	
}