<?php
	class ProductType extends BaseProductType {
		
		
		function getUser() {
			return Contacts::instance()->findById($this->getUserId());
		}
		
		function getUserName() {
			$user = $this->getUser();
			if ($user instanceof Contact) {
				return $user->getObjectName();
			}
			
			return lang('all');
		}
		
		
		function getUpdatedByDisplayName() {
			$updated_by = Contacts::instance()->findById($this->getUpdatedById());
			return $updated_by instanceof Contact ? $updated_by->getObjectName() : lang('n/a');
		}
		
		function getCreatedByDisplayName() {
			$updated_by = Contacts::instance()->findById($this->getCreatedById());
			return $updated_by instanceof Contact ? $updated_by->getObjectName() : lang('n/a');
		}
		
		
		
		function getArrayInfo() {
			
			$pt_members = ProductTypeMembers::getByProductType($this->getId());
			$mem_ids = array();
			foreach ($pt_members as $pt_member) {
				$mem_ids[] = $pt_member->getMemberId();
			}
			$mem_ids = array_filter($mem_ids);
			
			$members = array();
			if (count($mem_ids) > 0) {
				$members = Members::instance()->findAll(array("conditions" => "id IN (".implode(',', $mem_ids).")"));
			}
			$members_data = array();
			foreach ($members as $m) {
				$members_data[$m->getDimensionId()] = $m->getId();
			}
			
			return array(
				"id" => $this->getId(),
				"name" => escape_character(str_replace("'","`",$this->getName()), '"'),
				'user_id' => $this->getUserId(),
				'rate_currency_id' => $this->getRateCurrencyId(),
				'cost_currency_id' => $this->getCostCurrencyId(),
				'hourly_rate' => $this->getHourlyRate(),
				'hourly_cost' => $this->getHourlyCost(),
				'price_multiplier' => $this->getPriceMultiplier(),
				'uses_price_multiplier' => $this->getUsesPriceMultiplier(),
				"date" => $this->getUpdatedOn() instanceof DateTimeValue ? ($this->getUpdatedOn()->isToday() ? format_time($this->getUpdatedOn()) : format_datetime($this->getUpdatedOn())) : '',
				"is_today" => $this->getUpdatedOn() instanceof DateTimeValue ? $this->getUpdatedOn()->isToday() : 0,
				"updaterId" => $this->getUpdatedById() ? $this->getUpdatedById() : $this->getCreatedById(),
				"updaterName" => $this->getUpdatedById() ? $this->getUpdatedByDisplayName() : $this->getCreatedByDisplayName(),
				"members" => $members_data,
			);
		}
	}
	 
