<?php 
	$genid = gen_id();

	// with this hook we can use this form to send data to other controllers overriding the form's action attribute
	Hook::fire("override_object_data", array('request' => $_REQUEST), $expense);
	if (!isset($expense_items) && isset($expense->items)) {
		$expense_items = $expense->items;
	}

	$object = $expense;
	
	// on submit functions
	if (array_var($_REQUEST, 'modal')) {
		$on_submit = "og.expenses2.submit_expense_form('".$genid."submit-edit-form'); return false;";
	} else {
		$on_submit = "return true;";
	}
	$show_billing_info = true;
	Hook::fire('get_can_see_billing_information', array('user'=>logged_user()), $show_billing_info);
	$show_cost_info = true;
    Hook::fire('get_can_see_cost_information', array('user'=>logged_user()), $show_cost_info);

	$info_to_skip = array();
	Hook::fire('exclude_budgeted_expense_info', array(), $info_to_skip);

	$all_currencies = Currencies::getCurrenciesInfo();
	//$currencies_info = Currencies::getCurrenciesInfo();
	$status_info = ExpensesStatuses::instance()->getAllStatusInfo();
	
	$use_date_in_expense_level = config_option("use_date_in_expense_level");
	
	$product_types = ProductTypes::getAllProductTypesData();
	
	$active_context = active_context();
	$active_context_members_and_associated = $active_context;
	$assoc_member_ids = array();
	foreach ($active_context as $selection) {
		if ($selection instanceof Member) {
			$more_assoc_ids = MemberPropertyMembers::getAllAssociatedMemberIds($selection->getId(),true);
			$assoc_member_ids = array_merge($assoc_member_ids, array_flat($more_assoc_ids));
		}
	}
	$assoc_member_ids = array_filter(array_unique($assoc_member_ids));
	if (count($assoc_member_ids) > 0) {
		$assoc_members = Members::instance()->findAll(array("conditions" => "id IN (".implode(',', $assoc_member_ids).")"));
		$active_context_members_and_associated = array_merge($active_context_members_and_associated, $assoc_members);
	}
	
	$members_to_filter = $expense->isNew() ? $active_context_members_and_associated : $expense->getMembers();
	$filtered_product_types = ProductTypes::getFilteredProductTypesData($members_to_filter);
	
	$categories = array();
	Hook::fire('object_edit_categories', $object, $categories);

	$main_cp_count = CustomProperties::countVisibleCustomPropertiesByObjectType($object->getObjectTypeId());
	$other_cp_count = CustomProperties::countHiddenCustomPropertiesByObjectType($object->getObjectTypeId());
	
	$action_for_empty_amount_expense_items = config_option("action_for_empty_amounts");
	
	if (!isset($force_render_object_members)) $force_render_object_members = false;
	
	$form_action = $expense->isNew() ? get_url('expense', 'add') : $expense->getEditUrl();
	if (isset($override_form_action) && $override_form_action) {
		$form_action = $override_form_action;
	}

	// with this hook we can use this form to send data to other controllers overriding the form's action attribute
	Hook::fire("override_form_action", array('object' => $object, 'request' => $_REQUEST), $form_action);
	
	$amount_decimals = config_option('product_type_decimals');
?>

<form class="add-expense" id="<?php echo $genid ?>submit-edit-form" onsubmit="<?php echo $on_submit?>" action="<?php echo $form_action ?>" method="post" enctype="multipart/form-data" >
<div class="expense">
<div class="coInputHeader">

  <div class="coInputHeaderUpperRow">
	<div class="coInputTitle">
		<?php echo $object->getAddEditFormTitle(); ?>
	</div>
  </div>

  <div>
	<div class="coInputName">
		<?php echo text_field('expense[name]', $expense->getName(), array('id' => $genid . 'expenseName', 'class' => 'title', 'placeholder' => lang('type name here'))) ?>
	</div>
		
	<div class="coInputButtons">
		<?php echo submit_button($object->getSubmitButtonFormTitle(),'s', array('style'=>'margin-top:0px;margin-left:10px')) ?>
	</div>
	<div class="clear"></div>
  </div>
</div>

<div class="coInputMainBlock">
	
	<input id="<?php echo $genid?>genid" type="hidden" name="genid" value="<?php echo $genid ?>">
	<input id="<?php echo $genid?>updated-on-hidden" type="hidden" name="updatedon" value="<?php echo !$expense->isNew() ? $expense->getUpdatedOn()->getTimestamp() : '' ?>">
	<input id="<?php echo $genid?>object_type_id" type="hidden" name="object_type_id" value="<?php echo $expense->getObjectTypeId() ?>">
	
	<input type="hidden" name="req_channel" value="<?php echo array_var($_REQUEST, 'req_channel', 'modal form') ?>" />
	
	<?php if (isset($original_expense_id)) { ?>
	<input id="<?php echo $genid?>original_expense_id" type="hidden" name="expense[original_expense_id]" value="<?php echo $original_expense_id?>" />
	<?php } ?>
	
	<div id="<?php echo $genid?>tabs" class="edit-form-tabs">
	
		<ul id="<?php echo $genid?>tab_titles">
		
			<li><a href="#<?php echo $genid?>add_expense_details"><?php echo lang('details') ?></a></li>
			
			<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
			<li><a href="#<?php echo $genid?>add_custom_properties_div"><?php echo lang('custom properties') ?></a></li>
			<?php } ?>
			
			<li><a href="#<?php echo $genid?>add_subscribers_div"><?php echo lang('object subscribers') ?></a></li>
			
			<?php if($object->isNew() || $object->canLinkObject(logged_user())) { ?>
			<li><a href="#<?php echo $genid?>add_linked_objects_div"><?php echo lang('linked objects') ?></a></li>
			<?php } ?>
			
			<?php foreach ($categories as $category) {
					if (array_var($category, 'hidden')) continue;
				?>
			<li><a href="#<?php echo $genid . $category['name'] ?>"><?php echo $category['name'] ?></a></li>
			<?php } ?>
		</ul>
	
		<div id="<?php echo $genid ?>add_expense_details" class="form-tab">
			<div id="<?php echo $genid ?>add_expense_select_context_div" class="dataBlock"> 
				<?php
				$listeners = array(
					'on_selection_change' => 'og.product_types.reload_product_type_selectors("'.$genid.'"); og.reload_subscribers("'.$genid.'",'.$object->manager()->getObjectTypeId().');',
					'on_remove_relation' => 'og.product_types.reload_product_type_selectors("'.$genid.'");',
				);

				Hook::fire('modify_member_selector_listeners', array('genid' => $genid, 'object' => $object, 'info_to_skip' => $info_to_skip), $listeners);
				
				if ($expense->isNew()) {
					$select_current_context = !array_var($_REQUEST, 'is_template');
					render_member_selectors($expense->manager()->getObjectTypeId(), $genid, $pre_selected_members, array('select_current_context' => $select_current_context, 'listeners' => $listeners, 'object' => $object), null, null, false);
				} else {
					render_member_selectors($expense->manager()->getObjectTypeId(), $genid, $expense->getMemberIds(), array('listeners' => $listeners, 'object' => $object), null, null, false);
				} 
				?>
			</div>
			
			<?php if ($use_date_in_expense_level) { ?>
			<div class="clear"></div>
			<div class="dataBlock"><?php 
				echo label_tag(lang('date'), $genid . 'expenseFormDate', false);
				echo pick_date_widget2('expense[date]', $expense->getDate(), $genid);
			?></div>
			<?php } ?>
			
			<div class="clear"></div>
			<div class="dataBlock"><?php 
				$content_text = $expense->getDescription();
				echo label_tag(lang('description'), $genid . 'expenseFormText', false);
				echo textarea_field('expense[description]', $content_text, array('id' => $genid . 'expenseFormText', 'class' => 'long'));
				
			?></div>
			
			<div class="clear"></div>
			<div class="dataBlock" style="display:none;"><?php 
				echo label_tag(lang('status'), $genid . 'expenseFormStatus', false);
				echo expense_status_select_box('expense[status_id]', $expense->getStatusId(), array('id' => $genid . 'expenseFormStatus'));
				
			?></div>
			<?php if(!in_array('billable', $info_to_skip)){ ?>
			<div class="clear"></div>
			<div class="dataBlock"><?php 
			
				$is_billable = $expense->getIsBillable();
				if($expense->isNew()) {
					Hook::fire('get_billable_using_expense_cat', array('members' => $active_context_members_and_associated), $is_billable); 
				}

				echo label_tag(lang('billable'), $genid . 'expenseFormIsBillable', false);
				echo checkbox_field('expense[is_billable]', $is_billable, array('id' => $genid . 'expenseFormIsBillable', 'onclick' => 'og.expenses2.update_bud_exp_price_inputs_after_billable_change("'.$genid.'")'));
				
			?></div>

			<?php } ?>


			<div class="clear"></div>
			<div id="<?php echo $genid ?>add_expense_task_div" class="dataBlock">
				<?php 
					$task = $expense->getTask();
				?>
				<?php echo label_tag(lang('task')); ?>
				<div id="<?php echo $genid?>task_name_container" style="max-width: 600px;<?php echo ($task ? 'display:inline-block;' : 'display:none;') ?>">
					<input id="<?php echo $genid?>task_id" type="hidden" name="expense[task_id]" value="<?php echo $expense->getTaskId() ?>" />
					<div id="<?php echo $genid?>task_name" class="link-ico ico-task" style="display: inline-block;margin-right:10px;"><?php echo $task ? $task->getName() : '' ?> </div>
					<a id="<?php echo $genid?>remove_task" href="#" onclick="og.expenses2.remove_task('<?php echo $genid?>')" class="link-ico ico-delete"><?php echo lang('remove')?> </a> 
				</div>
				<a id="<?php echo $genid ?>select_task" style="<?php echo ($task ? 'display:none;' : '') ?>"  href="#" class="link-ico ico-add" onclick="og.expenses2.select_task('<?php echo $genid?>')"><?php echo lang('add task') ?></a> 
			</div>

			<div class="clear"></div>

			<?php if (Plugins::instance()->isActivePlugin('multiple_currencies') && count($all_currencies) > 1) {
				Env::useHelper('functions', 'multiple_currencies');
				?>
				<div class="clear"></div>
				<div class="dataBlock">
					<?php
						echo label_tag(lang('currency'), $genid . 'expenseCurrencyIdLabel');
						echo currency_selector('expense[currency_id]', $expense->getCurrencyId(), array('id' => $genid . 'expenseCurrencyId'));
					?>
				</div>
			<?php
			} else {
				$curr_id = $all_currencies[0]['id'];
				?>
				<input type="hidden" id="<?php echo $genid ?>expenseCurrencyId" name="expense[currency_id]" value="<?php echo $curr_id ?>" />
			<?php } ?>
			
			<?php $null = null; Hook::fire('before_render_main_custom_properties', array('object' => $object), $null);?>
			
			<div class="main-custom-properties-div"><?php
				if ($main_cp_count) {
					echo render_object_custom_properties($object, false, null, 'visible_by_default');
				}
			?></div>
			
			<div class="clear"></div>
			
			<div class="expense-items-table-container dataBlock" style="width:100%;">
				<div class="commentsTitle"><?php echo lang('items')?></div>
				
				<table class="expense-items" id="<?php echo $genid?>expense-items-table" style="width:100%;">
					<tr>
						<th class=""><?php echo lang('product type')?></th>
						<th class=""><?php echo lang('quantity')?></th>
						
						<th style="width:<?php echo ($use_date_in_expense_level ? "240px;" : "180px")?>;"><?php echo lang('details')?></th>
						
						<?php if (!$use_date_in_expense_level) { ?>
							<th style="width:100px;"><?php echo lang('expected date')?></th>
						<?php } ?>

						<th class="right"><?php echo $show_cost_info ? lang('unit_cost') : '' ?></th>
						<th class="right"><?php echo $show_cost_info ? lang('total_cost') : '' ?></th>

						<?php if(!in_array('unit_price', $info_to_skip)){ ?>
							<th class="right"><?php echo $show_billing_info ? lang('unit_price') : '' ?></th>
						<?php } ?>
						<?php if(!in_array('total_price', $info_to_skip)){ ?>
							<th class="right"><?php echo $show_billing_info ? lang('total_price') : '' ?></th>
						<?php } ?>

						<th></th>
					</tr>
				
					<input type="hidden" id="deleted_item_ids" name="expense[deleted_item_ids]" value="[]" />
				</table>
				
				<div><a class="coViewAction ico-add" href="#" id="<?php echo $genid?>add-expense-item-button"><?php echo lang('add item')?></a></div>
			</div>
			
			<div class="clear"></div>
		</div>
		
		<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
		<div id="<?php echo $genid ?>add_custom_properties_div" class="form-tab other-custom-properties-div">
			<?php  echo render_object_custom_properties($object, false, null, 'other') ?>
			<?php  echo render_add_custom_properties($object); ?>
		</div>
		<?php } ?>
	
		<div id="<?php echo $genid ?>add_subscribers_div" class="form-tab">
			<div id="<?php echo $genid ?>add_subscribers_content"><?php
				$subscriber_ids = array();
				if (!$object->isNew()) {
					$subscriber_ids = $object->getSubscriberIds();
				} else {
					$subscriber_ids[] = logged_user()->getId();
				}
				echo render_add_subscribers($object, $genid);
				foreach ($subscriber_ids as $subid) {
					echo '<input type="hidden" name="subscribers[user_'.$subid.']" value="1"/>';
				} 
			?></div>
		</div>
	
		<?php if($object->isNew() || $object->canLinkObject(logged_user())) { ?>
		<div id="<?php echo $genid ?>add_linked_objects_div" class="form-tab">
			<?php echo render_object_link_form($object) ?>
		</div>
		<?php } // if ?>
		
		<?php foreach ($categories as $category) { ?>
		<div id="<?php echo $genid . $category['name'] ?>" class="form-tab">
			<?php echo $category['content'] ?>
		</div>
		<?php } ?>

	</div>
	<?php if (!array_var($_REQUEST, 'modal')) {
		echo submit_button($expense->isNew() ? lang('add expense') : lang('save changes'),'s', array('tabindex' => '20000')); 
	}?>
	<div class="clear"></div>
</div>
<div class="clear"></div>
</div>
</form>

<script>
var genid = '<?php echo $genid?>';
var is_new_expense = <?php echo $expense->isNew() ? '1' : '0'?>;
og.expenses2.currencies = Ext.util.JSON.decode('<?php echo(json_encode($all_currencies))?>');
og.expenses2.statuses = Ext.util.JSON.decode('<?php echo(json_encode($status_info))?>');
og.expenses2.use_date_in_expense_level = <?php echo ($use_date_in_expense_level ? '1' : '0')?>;
og.expenses2.config_for_empty_amount_expense_items = '<?php echo $action_for_empty_amount_expense_items?>';
og.expenses2.action_for_empty_amount_expense_items = '<?php echo $action_for_empty_amount_expense_items?>';

og.expenses2.product_types = Ext.util.JSON.decode('<?php echo(json_encode($product_types))?>');
og.expenses2.filtered_product_types = Ext.util.JSON.decode('<?php echo(json_encode($filtered_product_types))?>');

og.expenses2.amount_decimals = <?php echo $amount_decimals; ?>;

if (!is_new_expense) {
	var current_dimension_members_json = Ext.util.JSON.encode(member_selector[genid].sel_context);
} else {
	var current_dimension_members_json = og.contextManager.plainContext();
}

$(function(){
	$("#"+genid+"add-expense-item-button").click(function(){
		var params ={
			num: '<?php echo ($max_pnum + 1); ?>',
			show_billing_info : '<?php echo $show_billing_info ?>',
			show_cost_info: '<?php echo $show_cost_info ?>',
		};
		og.expenses2.addExpenseItemTableRow(genid + 'expense-items-table', params, genid);
		return false;
	});

<?php 
	  if (isset($expense_items) && is_array($expense_items) && count($expense_items) > 0) {
	  	$i=0;
		foreach ($expense_items as $p) { /* @var $p ExpenseItem */
			$i++;
			$curr_sym = '';
		?>
			var item = {
				id:'<?php echo $p->getId() ?>', 
				num:'<?php echo $i ?>', 
				name:'<?php echo escape_character($p->getName())?>', 
				desc:'<?php echo escape_character($p->getDescription())?>', 
				date:'<?php echo format_date($p->getDate(), null, 0)?>', 
				product_type_id:'<?php echo $p->getProductTypeId()?>',
				quantity:'<?php echo $p->getQuantity()?>',
				currency:'<?php echo $p->getCurrencyId()?>', 
				unit_cost:'<?php echo format_money_amount($p->getUnitCost(), $curr_sym, $amount_decimals)?>',
				total_cost:'<?php echo format_money_amount($p->getTotalCost(), $curr_sym, $amount_decimals)?>',
				price_multiplier:'<?php echo format_money_amount($p->getPriceMultiplier(), $curr_sym, $amount_decimals)?>',
				unit_price:'<?php echo format_money_amount($p->getUnitPrice(), $curr_sym, $amount_decimals)?>',
				total_price:'<?php echo format_money_amount($p->getTotalPrice(), $curr_sym, $amount_decimals)?>',
				show_billing_info : '<?php echo $show_billing_info ?>',
				show_cost_info: '<?php echo $show_cost_info ?>',
			};
			og.expenses2.addExpenseItemTableRow(genid + 'expense-items-table', item, genid);<?php 
		} ?>
<?php } else { ?>
			var params ={
				show_billing_info : '<?php echo $show_billing_info ?>',
				show_cost_info: '<?php echo $show_cost_info ?>',
			};
			og.expenses2.addExpenseItemTableRow(genid + 'expense-items-table', params, genid);
<?php } ?>

<?php if (array_var($_REQUEST, 'new_item')) { ?>
	var params = {
		show_billing_info : '<?php echo $show_billing_info ?>',
		show_cost_info: '<?php echo $show_cost_info ?>',
	};
	og.expenses2.addExpenseItemTableRow(genid + 'expense-items-table', params, genid);
<?php } ?>

<?php 
	$is_calculated_estimated_price = $task instanceof ProjectTask ? $task->getColumnValue('is_calculated_estimated_price') : true;
	$is_fixed_fee = $task instanceof ProjectTask ? $task->getColumnValue('is_fixed_fee') : false;
	$task_non_billable = $task instanceof ProjectTask ? $task->getColumnValue('is_billable') == 0 : false;
	if ((!$is_calculated_estimated_price && $is_fixed_fee) || $task_non_billable) { ?>
		og.expenses2.set_non_billable_and_disable(genid);
<?php } ?>


	$("#<?php echo $genid?>tabs").tabs();
});

og.update_budgeted_expense_billable = function(genid) { 
	// avoid updating billable if the task is fixed fee or non-billable
	if($("#" + genid + "expenseFormIsBillable").attr('disabled')) return;

	var dimension_members_json = Ext.util.JSON.encode(member_selector[genid].sel_context);

	var current_billable = $('#' + genid + 'expenseFormIsBillable').attr('checked') == 'checked' ? 1 : 0;
	var member_params = {member_ids: dimension_members_json, current_member_ids: current_dimension_members_json, current_billable: current_billable};
	og.openLink(og.getUrl('expense_category','get_expense_category_billable_for_expense_form', member_params), { 
		callback: function(success, data) {
			if(data.has_value){
				if(data.is_billable){
					if(current_billable != data.is_billable){
						if(confirm(lang('You are changing from a non-billable expense category to a billable one. This will set the \'Billable\' property for this expense to \'Yes\''))){
							$('#'+genid+'expenseFormIsBillable').attr('checked','checked');
						}
					}
				} else {
					if(current_billable != data.is_billable){
						if(confirm(lang('You are changing from a billable expense category to a non-billable one. This will set the \'Billable\' property for this expense to \'No\''))){
							$('#'+genid+'expenseFormIsBillable').removeAttr('checked');
						}
					}
				}
			}
		}
	});

	current_dimension_members_json = dimension_members_json;
}

</script>