<script>

var item_columns = [];
<?php 
$show_billing_info = true;
Hook::fire('get_can_see_billing_information', array('user'=>logged_user()), $show_billing_info);
$show_cost_info = true;
Hook::fire('get_can_see_cost_information', array('user'=>logged_user()), $show_cost_info);

// columns to show in item grid
$item_columns = PaymentReceipts::instance()->getColumns();

$amount_cols = array('amount', 'unit_cost', 'unit_price', 'total_cost', 'total_price');
$boolean_cols = array('is_billable');

$item_sys_columns = Expenses::instance()->getSystemColumns();
$item_columns = array_diff($item_columns, $item_sys_columns);

// Get columns that should be excluded
$excluded_columns = array('currency_id', 'status_id', 'date', 'task_id', 'document_id', 'price_multiplier', 'total_cost_without_taxes');
if(!$show_billing_info){
	array_push($excluded_columns, 'unit_price', 'total_price');
}
if(!$show_cost_info){
	array_push($excluded_columns, 'unit_cost', 'total_cost');
}
$item_columns = array_diff($item_columns, $excluded_columns);

foreach ($item_columns as $pc) {
	$header = Localization::instance()->lang("field PaymentReceipts $pc");
	if (is_null($header)) {
		$header = Localization::instance()->lang("field Objects $pc");
	}
	if (is_null($header)) {
		$header = lang($pc);
	}
?>
	var col_def = {
		name: '<?php echo $pc ?>',
		header: '<?php echo $header ?>',
		sortable: true
	};

<?php if (in_array($pc, $amount_cols)) { ?>
		col_def.align = 'right';
		col_def.renderer = 'string';
<?php } ?>
<?php if (in_array($pc, $boolean_cols)) { ?>
		col_def.renderer = og.gridBooleanColumnRenderer;
<?php } ?>


	if (col_def.name == 'paid_by_id') {
		col_def.renderer = og.expenses2.renderContactName;
	}
	if (col_def.name == 'product_type_id') {
		col_def.renderer = og.expenses2.renderProductTypeColumn;
	}
	if (col_def.name == 'task_id') {
		col_def.renderer = og.expenses2.renderTaskLink;
	}
	if (col_def.name == 'invoice_id') {
		col_def.renderer = og.expenses2.renderInvoiceLink;
	}
	if (col_def.name == 'invoicing_status') {
		col_def.renderer = og.expenses2.renderInvoicingStatus;
	}
	if (col_def.name == 'expense_id') {
		col_def.renderer = og.expenses2.renderExpenseNameColumn;
	}
	if (col_def.name == 'payment_term_id') {
		col_def.renderer = og.expenses2.renderPaymentTerm;
	}

	item_columns.push(col_def);
<?php 
}
?>

item_columns.push({
	name: 'type',
	is_system: true
});
item_columns.push({
	name: 'add_cls',
	is_system: true
});
item_columns.push({
	name: 'paid_by_name',
	is_system: true
});
item_columns.push({
	name: 'product_type_name',
	is_system: true
});
item_columns.push({
	name: 'payment_term_name',
	is_system: true
});
item_columns.push({
	name: 'task_name',
	is_system: true
});
item_columns.push({
	name: 'expense_name',
	is_system: true
});

</script>