

if (!og.expenses2.payment_receipt_list_grid_config) og.expenses2.payment_receipt_list_grid_config = {};

og.expenses2.payment_receipt_list_grid_config.columns = [];
<?php 
// columns to show in payment grid
$payment_columns = PaymentReceipts::instance()->getColumns();

$payment_sys_columns = PaymentReceipts::instance()->getSystemColumns();
$payment_columns = array_diff($payment_columns, $payment_sys_columns);

$excluded_columns = array('currency_id', 'product_type_id');

$can_see_cost_info = true;
Hook::fire('get_can_see_cost_information', array('user'=>logged_user()), $can_see_cost_info);
if(!$can_see_cost_info){
	array_push($excluded_columns, 'document_id', 'amount', 'unit_cost', 'total_cost_without_taxes');
}

$can_see_billing_info = true;
Hook::fire('get_can_see_billing_information', array('user'=>logged_user()), $can_see_billing_info);
if(!$can_see_billing_info){
	array_push($excluded_columns, 'unit_price', 'total_price');
}

$info_to_skip = array();
Hook::fire('exclude_budgeted_expense_info', array(), $info_to_skip);
$excluded_columns = array_merge($excluded_columns, $info_to_skip);

$payment_columns = array_diff($payment_columns, $excluded_columns);

$amount_cols = array('amount', 'unit_cost', 'unit_price', 'total_price', 'total_cost_without_taxes');
$boolean_cols = array('is_billable');

$prod_type_cols = array('product_type_name');

// tax columns
$tax_headers = array();
$tax_columns = array();
$taxes = ActualExpenseTaxes::getAvailableTaxes();
foreach ($taxes as $tax) {
	$tax_headers['tax_'.$tax->getId()] = $tax->getName();
	$tax_columns[] = 'tax_'.$tax->getId();
}
$payment_columns = array_merge($payment_columns, $tax_columns, $prod_type_cols);
$amount_cols = array_merge($amount_cols, $tax_columns);

Hook::fire('before_generate_payment_columns', array(), $payment_columns);
foreach ($payment_columns as $pc) {
	$header = Localization::instance()->lang("field PaymentReceipts $pc");
	if (is_null($header)) {
		$header = Localization::instance()->lang("field Objects $pc");
	}
	if (str_starts_with($pc, 'tax_')) {
		$header = array_var($tax_headers, $pc);
	}
	if (is_null($header)) {
		$header = lang($pc);
	}

?>
	var col_def = {
		name: '<?php echo $pc ?>',
		header: '<?php echo $header ?>',
		sortable: true
	};

<?php if (in_array($pc, $amount_cols)) { ?>
		col_def.align = 'right';
		col_def.renderer = 'string';
<?php } ?>
<?php if (in_array($pc, $boolean_cols)) { ?>
		col_def.renderer = og.gridBooleanColumnRenderer;
<?php } ?>

 if (col_def.name == 'product_type_name') {
	col_def.align = 'left';
		col_def.renderer = og.expenses2.renderProductTypeColumn;
	}

/*
	if (col_def.name == 'status_id') {
		col_def.renderer = og.expenses2.renderExpenseItemGridStatus;
	}
*/

	if (col_def.name == 'paid_by_id') {
		col_def.renderer = og.expenses2.renderContactName;
	}
	
	if (col_def.name == 'task_id') {
		col_def.renderer = og.expenses2.renderTaskLink;
	}
	
	if (col_def.name == 'invoice_id') {
		col_def.renderer = og.expenses2.renderInvoiceLink;
	}
	if (col_def.name == 'invoicing_status') {
		col_def.renderer = og.expenses2.renderInvoicingStatus;
	}

	if (col_def.name == 'expense_id') {
		col_def.width = 200;
		col_def.renderer = og.expenses2.renderExpenseNameColumn;
	} else {
		col_def.width = 100;
	}

	if (col_def.name == 'payment_term_id') {
		col_def.renderer = og.expenses2.renderPaymentTerm;
	}

	if (col_def.name == 'document_id') {
		col_def.renderer = og.expenses2.renderExpenseDocumentLink;
	}

	if (!og.expenses2.payment_receipt_list_column_renderers) og.expenses2.payment_receipt_list_column_renderers = [];
	for (x = 0; x < og.expenses2.payment_receipt_list_column_renderers.length; x++) {
		var override_fn = og.expenses2.payment_receipt_list_column_renderers[x];
		if (typeof(override_fn) == 'function') {
			var col_renderer = override_fn.call(null, '<?php echo $pc ?>');
			if (col_renderer) {
				col_def.renderer = col_renderer;
			}
		}
	}

	og.expenses2.payment_receipt_list_grid_config.columns.push(col_def);
<?php 
}
?>
og.expenses2.payment_receipt_list_grid_config.columns.push({
	name: 'actions',
	is_right_column: true,
	//fixed: true,
	width: 150,
	//renderer: og.clean
});
/*
og.expenses2.payment_receipt_list_grid_config.columns.push({
	name: 'actions',
	renderer: og.expenses2.renderPaymentGridActions
});*/


/*
og.expenses2.payment_receipt_list_grid_config.columns.push({
	name: 'status',
	is_system: true
});
*/

og.expenses2.payment_receipt_list_grid_config.columns.push({
	name: 'expense_name',
	is_system: true
});
/*
og.expenses2.payment_receipt_list_grid_config.columns.push({
	name: 'status_code',
	is_system: true
});
*/

og.expenses2.payment_receipt_list_grid_config.columns.push({
	name: 'type',
	is_system: true
});
og.expenses2.payment_receipt_list_grid_config.columns.push({
	name: 'add_cls',
	is_system: true
});
og.expenses2.payment_receipt_list_grid_config.columns.push({
	name: 'paid_by_name',
	is_system: true
});
og.expenses2.payment_receipt_list_grid_config.columns.push({
	name: 'payment_term_name',
	is_system: true
});
og.expenses2.payment_receipt_list_grid_config.columns.push({
	name: 'task_name',
	is_system: true
});