<?php
Env::useHelper('format');
$info_to_skip = array();
Hook::fire('exclude_budgeted_expense_info', array(), $info_to_skip);
if (isset($payment_receipt) && $payment_receipt instanceof PaymentReceipt) {
	$req_channel_param = "&req_channel=".urlencode('actual expense view - ');
	$genid = gen_id();
	if (!$payment_receipt->isTrashed()){
		if($payment_receipt->canEdit(logged_user())) {
			add_page_action(lang('edit'), "javascript:og.render_modal_form('', {c:'payment_receipt', a:'edit', params: {id:".$payment_receipt->getId().", req_channel:'actual expense view - edit'}});", 'ico-edit', null, null, true);
			if (!$payment_receipt->isArchived())
				add_page_action(lang('archive'), "javascript:if(confirm(lang('confirm archive object'))) og.openLink('" . $payment_receipt->getArchiveUrl().$req_channel_param.'archive' ."');", 'ico-archive-obj');
			else
				add_page_action(lang('unarchive'), "javascript:if(confirm(lang('confirm unarchive object'))) og.openLink('" . $payment_receipt->getUnarchiveUrl().$req_channel_param.'unarchive' ."');", 'ico-unarchive-obj');
		} // if
	}
	if ($payment_receipt->canDelete(logged_user())) {
		if ($payment_receipt->isTrashed()) {
			add_page_action(lang('restore from trash'), "javascript:if(confirm(lang('confirm restore objects'))) og.openLink('" . $payment_receipt->getUntrashUrl().$req_channel_param.'untrash' ."');", 'ico-restore', null, null, true);
			add_page_action(lang('delete permanently'), "javascript:if(confirm(lang('confirm delete permanently'))) og.openLink('" . $payment_receipt->getDeletePermanentlyUrl().$req_channel_param.'delete' ."');", 'ico-delete', null, null, true);
		} else {
			if(!(Plugins::instance()->isActivePlugin('income') && $payment_receipt->getColumnValue('invoicing_status') == 'invoiced')){ 
				add_page_action(lang('move to trash'), "javascript:if(confirm(lang('confirm move to trash'))) og.openLink('" . $payment_receipt->getTrashUrl().$req_channel_param.'trash' ."');", 'ico-trash', null, null, true);
			}
		}
	}
?>

<div style="padding:7px">
<div class="payment receipt">
<?php
	
	$content = '';
	
	//$status = ExpensesStatuses::instance()->getStatus($payment_receipt->getStatusId());
	//$st_html = '<span class="expense-row-status-'.($status instanceof ExpensesStatus ? $status->getCode() : '').'">'.($status instanceof ExpensesStatus ? lang($status->getCode()) : '').'</span>';
	//$content .= '<div class="expense-property"><span class="bold ">'.lang('status').': </span>'.$st_html.'</div>';
	
	$expense = Expenses::instance()->findById($payment_receipt->getExpenseId());
	if ($expense instanceof Expense) {
		$content .= '<div class="expense-property"><span class="bold ">'.lang('expense').': </span>'.
			'<a href="#" class="underline" onclick="og.openLink(og.getUrl(\'expense\',\'view\',{id:'.$expense->getId().'}))">'.$expense->getObjectName().'</a></div>';
	}

	if (trim($payment_receipt->getPaidById()) != 0) {
		$content .= '<div class="expense-property"><span class="bold">'.lang('employee').': </span>'.Contacts::instance()->findById($payment_receipt->getPaidById())->getObjectName().'</div>';
	}
	
	$content .= '<div class="expense-property"><span class="bold ">'.lang('date').': </span>'.format_date($payment_receipt->getDate(), null, 0).'</div>';
	
	if(!in_array('billable', $info_to_skip)){
		$content .= '<div class="expense-property"><span class="bold ">'.lang('billable').': </span>'.($payment_receipt->getIsBillable() ? lang('yes') : lang('no')).'</div>';
	}
	
	$c_symbol = '$';
	$currency = Currencies::instance()->findById($payment_receipt->getCurrencyId());
	if ($currency instanceof Currency) {
		$c_symbol = $currency->getSymbol();
	}
	$can_see_cost_info = true;
	Hook::fire('get_can_see_cost_information', array('user'=>logged_user()), $can_see_cost_info);

	if($can_see_cost_info){
		$content .= '<div class="expense-property"><span class="bold ">'.lang('quantity').': </span>'.$payment_receipt->getQuantity().'</div>';
		$content .= '<div class="expense-property"><span class="bold ">'.lang('unit_cost').': </span>'.format_money_amount($payment_receipt->getUnitCost(), $c_symbol, config_option('product_type_decimals')).'</div>';
		$taxes = ActualExpenseTaxes::getAvailableTaxes();
		foreach ($taxes as $tax) {
			$tax_val = ActualExpenseTaxValues::getByObjectAndTaxId($payment_receipt->getId(), $tax->getId());
			if ($tax_val && $tax_val->getValue() > 0) {
				$content .= '<div class="expense-property"><span class="bold ">'.$tax->getName().': </span>'.format_money_amount($tax_val->getValue(), $c_symbol, config_option('product_type_decimals')).'</div>';
			}
		}
		$content .= '<div class="expense-property"><span class="bold ">'.lang('total_cost').': </span>'.format_money_amount($payment_receipt->getAmount(), $c_symbol, config_option('product_type_decimals')).'</div>';
	}
	
	$can_see_billing_info = true;
	Hook::fire('get_can_see_billing_information', array('user'=>logged_user()), $can_see_billing_info);
	if($can_see_billing_info){
		if(!in_array('unit_price', $info_to_skip)){
			$content .= '<div class="expense-property"><span class="bold ">'.lang('unit_price').': </span>'.format_money_amount($payment_receipt->getUnitPrice(), $c_symbol, config_option('product_type_decimals')).'</div>';
		}
		if(!in_array('total_price', $info_to_skip)){
			$content .= '<div class="expense-property"><span class="bold ">'.lang('total_price').': </span>'.format_money_amount($payment_receipt->getTotalPrice(), $c_symbol, config_option('product_type_decimals')).'</div>';
		}
		
		$inv_status = $payment_receipt->getColumnValue('invoicing_status');
		if (Plugins::instance()->isActivePlugin('income') && $inv_status) {
			$content .= '<div class="expense-property"><span class="bold ">'.lang('invoicing_status').': </span><span class="invoicing-status-'.$inv_status.'">'.lang('invoicing_status '.$inv_status).'</span></div>';
			if ($inv_status == 'invoiced') {
				$invoice = IncomeInvoices::instance()->findById($payment_receipt->getColumnValue('invoice_id'));
				if ($invoice) {
					$content .= '<div class="expense-property"><span class="bold ">'.lang('invoice').': </span>'.
						'<a href="#" class="underline" onclick="og.openLink(og.getUrl(\'invoice\',\'view\',{id:'.$invoice->getId().'}))">'.clean($invoice->getName()).'</a></div>';
				}
			}
		}
	}
	
	if (trim($payment_receipt->getDescription()) != "" && $can_see_cost_info) {
		$content .= '<div class="expense-property"><span class="bold">'.lang('description').': </span>'.$payment_receipt->getDescription().'</div>';
	}

	$task = $payment_receipt->getTask();
	if ($task) {
		$content .= '<div class="expense-property"><span class="bold">'.lang('task').': </span>'
		.'<a class="underline" href="#" onclick="og.openLink(og.getUrl(\'task\', \'view\', {id: '.$task->getId().'})); return false;" >'.clean($task->getName()).'</a>'
		.'</div>';
	}
	
	if (trim($payment_receipt->getDocumentId()) != "" && $can_see_cost_info) {
		$preview_url = get_url('files', 'get_public_file', array('id' => $payment_receipt->getDocumentId()));
		
		try {
			$file_attributes = FileRepository::getFileAttributes($payment_receipt->getDocumentId());
		} catch (FileNotInRepositoryError $e) {
			$file_attributes = null;
		}
		if (!is_null($file_attributes)) {
			$content .= '<div class="expense-property"><div class="bold">'.lang('receipt image').': </div>';
			
			if ($file_attributes['type'] == 'application/pdf') {
				$content .= '<iframe src="'.$preview_url.'" style="width:100%; min-height:350px; max-width: 100%; border:0px none;"></iframe>';
			} else {
				$content .= '<a href="'.$preview_url.'" target="_blank">';
				$content .= '<img alt="" src="'.$preview_url.'" style="max-width: 100%;"/>';
				$content .= '</a></div>';
			}
		}			
	}
		
	$content .= '<div class="clear"></div>';
	
	tpl_assign("content", $content);
	tpl_assign("object", $payment_receipt);
	tpl_assign('iconclass', $payment_receipt->isTrashed()? 'ico-large-payment-receipt-trashed' : ($payment_receipt->isArchived() ? 'ico-large-payment-receipt-archived' : 'ico-large-payment-receipt'));
	
	$this->includeTemplate(get_template_path('view', 'co'));
	
?>
</div>
</div>

<?php } //if isset ?>