INSERT INTO `<?php echo $table_prefix ?>object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`) VALUES
('expense', 'Expenses', 'expenses', 'content_object', 'expense', (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='expenses2')),
('expense_item', 'ExpenseItems', 'expense_items', 'content_object', 'expense_item', (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='expenses2')),
('payment_receipt', 'PaymentReceipts', 'payment_receipts', 'content_object', 'payment_receipt', (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='expenses2'))
ON DUPLICATE KEY UPDATE id=id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
SELECT dimension_id, dimension_object_type_id, (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='expense'), 0, 1
FROM `<?php echo $table_prefix ?>dimension_object_type_contents` x
WHERE x.`content_object_type_id` = (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>dimension_object_type_contents.dimension_id=<?php echo $table_prefix ?>dimension_object_type_contents.dimension_id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
SELECT dimension_id, dimension_object_type_id, (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='expense_item'), 0, 1
FROM `<?php echo $table_prefix ?>dimension_object_type_contents` x
WHERE x.`content_object_type_id` = (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>dimension_object_type_contents.dimension_id=<?php echo $table_prefix ?>dimension_object_type_contents.dimension_id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
SELECT dimension_id, dimension_object_type_id, (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='payment_receipt'), 0, 0
FROM `<?php echo $table_prefix ?>dimension_object_type_contents` x
WHERE x.`content_object_type_id` = (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>dimension_object_type_contents.dimension_id=<?php echo $table_prefix ?>dimension_object_type_contents.dimension_id;

DELETE FROM `<?php echo $table_prefix ?>dimension_object_type_contents` WHERE `dimension_id`=0 OR dimension_id IS NULL;

INSERT INTO `<?php echo $table_prefix ?>tab_panels` (`id`,`title`,`icon_cls`,`refresh_on_context_change`,`default_controller`,`default_action`,`initial_controller`,`initial_action`,`enabled`,`type`,`ordering`,`plugin_id`,`object_type_id`) VALUES
('expenses-panel', 'all_expenses', 'ico-expenses', 1, 'expense', 'init', '', '', 1, 'system', 6, (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='expenses2'), (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='expense'))
ON DUPLICATE KEY UPDATE id=id;

INSERT INTO `<?php echo $table_prefix ?>tab_panel_permissions` (`permission_group_id`, `tab_panel_id`)
SELECT `c`.`permission_group_id`, 'expenses-panel'
FROM `<?php echo $table_prefix ?>contacts` `c` WHERE `c`.`user_type` IN (
SELECT `id` FROM `<?php echo $table_prefix ?>permission_groups` WHERE `type`='roles' AND `name` IN ('Super Administrator','Administrator','Manager','Executive')
)
ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;


INSERT INTO `<?php echo $table_prefix ?>expenses_status` (`order`, `code`, `name`, `description`, `editable`, `created_on`, `created_by_id`, `enabled`, `is_final`, `only_for_expenses`) VALUES
(1, 'budgeted', '', '', 0, NOW(), (SELECT object_id FROM <?php echo $table_prefix ?>contacts WHERE user_type=(SELECT id FROM <?php echo $table_prefix ?>permission_groups WHERE `type`='roles' AND name='Super Administrator') limit 1), 1, 0, 0),
(10, 'part_approved', '', '', 0, NOW(), (SELECT object_id FROM <?php echo $table_prefix ?>contacts WHERE user_type=(SELECT id FROM <?php echo $table_prefix ?>permission_groups WHERE `type`='roles' AND name='Super Administrator') limit 1), 1, 0, 1),
(20, 'approved', '', '', 0, NOW(), (SELECT object_id FROM <?php echo $table_prefix ?>contacts WHERE user_type=(SELECT id FROM <?php echo $table_prefix ?>permission_groups WHERE `type`='roles' AND name='Super Administrator') limit 1), 1, 0, 0),
(30, 'part_executed', '', '', 0, NOW(), (SELECT object_id FROM <?php echo $table_prefix ?>contacts WHERE user_type=(SELECT id FROM <?php echo $table_prefix ?>permission_groups WHERE `type`='roles' AND name='Super Administrator') limit 1), 1, 0, 1),
(40, 'executed', '', '', 0, NOW(), (SELECT object_id FROM <?php echo $table_prefix ?>contacts WHERE user_type=(SELECT id FROM <?php echo $table_prefix ?>permission_groups WHERE `type`='roles' AND name='Super Administrator') limit 1), 1, 1, 0);

INSERT INTO <?php echo $table_prefix ?>max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 1, 1
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('expense', 'expense_item', 'payment_receipt')
AND p.`name` IN ('Super Administrator','Administrator','Manager','Executive');

INSERT INTO <?php echo $table_prefix ?>max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 0, 0
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('expense', 'expense_item', 'payment_receipt')
AND p.`name` IN ('Collaborator Customer','Internal Collaborator','External Collaborator','Guest Customer');

INSERT INTO <?php echo $table_prefix ?>role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 1, 1
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('expense', 'expense_item', 'payment_receipt')
AND p.`name` IN ('Super Administrator','Administrator','Manager');

INSERT INTO <?php echo $table_prefix ?>role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 0, 1
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('expense', 'expense_item', 'payment_receipt')
AND p.`name` IN ('Executive');


-- add permissions to users where the users already have permissions (copy permissions from tasks)

INSERT INTO <?php echo $table_prefix ?>contact_member_permissions (permission_group_id, member_id, object_type_id, can_delete, can_write)
SELECT cmp.permission_group_id, cmp.member_id, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='expense'), cmp.can_delete, cmp.can_write
FROM <?php echo $table_prefix ?>contact_member_permissions cmp
WHERE cmp.object_type_id = (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>contact_member_permissions.member_id=<?php echo $table_prefix ?>contact_member_permissions.member_id;

INSERT INTO <?php echo $table_prefix ?>contact_member_permissions (permission_group_id, member_id, object_type_id, can_delete, can_write)
SELECT cmp.permission_group_id, cmp.member_id, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='expense_item'), cmp.can_delete, cmp.can_write
FROM <?php echo $table_prefix ?>contact_member_permissions cmp
WHERE cmp.object_type_id = (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>contact_member_permissions.member_id=<?php echo $table_prefix ?>contact_member_permissions.member_id;

INSERT INTO <?php echo $table_prefix ?>contact_member_permissions (permission_group_id, member_id, object_type_id, can_delete, can_write)
SELECT cmp.permission_group_id, cmp.member_id, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='payment_receipt'), cmp.can_delete, cmp.can_write
FROM <?php echo $table_prefix ?>contact_member_permissions cmp
WHERE cmp.object_type_id = (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>contact_member_permissions.member_id=<?php echo $table_prefix ?>contact_member_permissions.member_id;



INSERT INTO <?php echo $table_prefix ?>tab_panel_permissions (permission_group_id, tab_panel_id)
SELECT pg.id, 'expenses-panel' FROM <?php echo $table_prefix ?>permission_groups pg WHERE pg.type='roles' AND pg.name IN ('Super Administrator','Administrator','Manager','Executive')
ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;


INSERT INTO `<?php echo $table_prefix ?>dimension_content_object_options` (`dimension_id`,`content_object_type_id`,`option`,`value`)
SELECT d.id, ot.id, 'hide_member_selector_in_forms', '0'
FROM <?php echo $table_prefix ?>dimensions d LEFT JOIN <?php echo $table_prefix ?>object_types ot ON true
WHERE ot.name IN ('expense','expense_item','payment_receipt')
ON DUPLICATE KEY UPDATE `value`=`value`;

INSERT INTO `<?php echo $table_prefix ?>config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
('expenses', 'use_date_in_expense_level', '0', 'BoolConfigHandler', 0, 1, ''),
('expenses', 'action_for_empty_amounts', 'ask_user', 'SavePromptConfigHandler', 0, 20, ''),
('expenses', 'allow_negative_amounts', '0', 'BoolConfigHandler', 0, 30, ''),
('expenses', 'copy_exp_classiffication_to_expense_items', '1', 'BoolConfigHandler', 0, 40, ''),
('expenses', 'product_type_decimals', '2', 'IntegerConfigHandler', 0, 50, ''),
('expenses', 'use_taxes_in_actual_expenses', '0', 'BoolConfigHandler', 0, 60, ''),
('expenses', 'disable_expenses_subtab', '0', 'BoolConfigHandler', 0, 70, ''),
('expenses', 'disable_actual_expenses_subtab', '0', 'BoolConfigHandler', 0, 80, ''),
('expenses', 'use_rentals_cons_expense', '0', 'BoolConfigHandler', 0, 90, ''),
('expenses', 'use_field_lab_test_expense', '0', 'BoolConfigHandler', 0, 100, ''),
('expenses', 'actual_expense_type_mandatory', '0', 'BoolConfigHandler', 0, 110, '')
ON DUPLICATE KEY UPDATE `category_name`=`category_name`;

INSERT INTO `<?php echo $table_prefix ?>config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
('expenses', 'set_paid_by_contacts_users','users','MultipleListConfigHandler',0,90,'','contacts,users')
ON DUPLICATE KEY UPDATE `category_name`=`category_name`;

-- PRODUCT TYPES
INSERT INTO `<?php echo $table_prefix ?>config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
('system', 'product_type_dimensions', '', 'AllDimensionsConfigHandler', 1, 0, ''),
('system', 'product_type_filter_up_dimensions', (SELECT GROUP_CONCAT(id) FROM <?php echo $table_prefix ?>dimensions WHERE code IN ('customer_project','customers')), 'AllDimensionsConfigHandler', 1, 0, '')
ON DUPLICATE KEY UPDATE `category_name`=`category_name`;

-- UNICITY OF MEMBER SELECTORS FOR EXPENSES
UPDATE <?php echo $table_prefix ?>dimension_object_type_contents
SET is_multiple=0
WHERE content_object_type_id = (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='expense')
AND dimension_id IN (SELECT id FROM <?php echo $table_prefix ?>dimensions WHERE code IN ('customer_project','customers','rate_schedules','expense_categories'));



INSERT INTO <?php echo $table_prefix ?>widgets (name,title,plugin_id,path,default_options,default_section,default_order,icon_cls) VALUES
("expenses_progress","expenses progress",(SELECT id FROM <?php echo $table_prefix ?>plugins WHERE name='expenses2'),"","","left",2,"ico-expense")
ON DUPLICATE KEY UPDATE `name`=`name`;


INSERT INTO `<?php echo $table_prefix ?>config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
('expenses', 'actual_expense_name_generation', 'date_quantity_product', 'ListConfigHandler', 0, 0, '', ' { "no_empty_value":1, "option": [{ "value": "date_quantity_product", "text": "date_quantity_product" }, { "value": "date_product", "text": "date_product" }, { "value": "only_product", "text": "only_product" }] }')
ON DUPLICATE KEY UPDATE `category_name`=`category_name`;

INSERT INTO `<?php echo $table_prefix ?>config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
('expenses', 'set_actual_expense_type','direct_to_vendor,reimbursable,field_lab_testing,rental_consumable,credit_card_purchase','MultipleListConfigHandler',0,12,'','direct_to_vendor,reimbursable,field_lab_testing,rental_consumable,credit_card_purchase')
ON DUPLICATE KEY UPDATE `category_name`=`category_name`;

INSERT INTO `<?php echo $table_prefix ?>custom_properties` (`object_type_id`,`name`,`code`,`type`,`description`,`values`,`default_value`,`is_required`,`is_multiple_values`,`property_order`,`visible_by_default`, `is_special`, `is_disabled`) VALUES 
((SELECT id FROM  fo_object_types WHERE name='payment_receipt'),'Bill no','payment_receipt_bill_no','text','','','',0,0,1,1, 1,0);

INSERT INTO `<?php echo $table_prefix ?>config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
('expenses', 'default_actual_expense_types','none_blank','DefaultActualExpenseTypesConfigHandler',0,13,'','')
ON DUPLICATE KEY UPDATE `category_name`=`category_name`;

INSERT INTO `<?php echo $table_prefix ?>config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) 
VALUES ('general', 'allow_to_edit_invoices', '0', 'BoolConfigHandler', '0', '999', '', '')
ON DUPLICATE KEY UPDATE `category_name`=`category_name`;

INSERT INTO `<?php echo $table_prefix ?>config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
('expenses', 'default_expense_payment_term', '4', 'ListConfigHandler', 0, 0, '', ' { "no_empty_value":1, "option": [{ "value": "1", "text": "payment term due_on_receipt" }, { "value": "2", "text": "Net 10" }, { "value": "3", "text": "Net 15" }, { "value": "4", "text": "Net 30" }, { "value": "5", "text": "Net 45" }, { "value": "6", "text": "Net 60" }, { "value": "7", "text": "Net 90" }] }')
ON DUPLICATE KEY UPDATE `category_name`=`category_name`;

INSERT INTO `<?php echo $table_prefix ?>custom_properties` (`object_type_id`,`name`,`code`,`type`,`description`,`values`,`default_value`,`is_required`,`is_multiple_values`,`property_order`,`visible_by_default`, `is_special`, `is_disabled`) VALUES 
((SELECT id FROM `<?php echo $table_prefix ?>object_types` WHERE name='payment_receipt'),'Deposit day','payment_receipt_deposit_day','date','','','',0,0,30,1, 1,1) 
ON DUPLICATE KEY UPDATE code=code;

INSERT INTO `<?php echo $table_prefix ?>contact_config_categories` (`name`, `is_system`, `type`, `category_order`, `located_under`)
VALUES ('expenses', '0', '0', '12', '0');

INSERT INTO `<?php echo $table_prefix ?>contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`)
VALUES ('expenses', 'hide_cost_in_actual_expenses_form', '0', 'BoolConfigHandler', '0', '1', '', '');

