
og.expenses2 = {
	
	init: function() {
		og.openLink(og.getUrl('expense', 'get_expense_status'), {callback: function(success, data){
			og.expenses2.all_status = [];
			for (x=0; x<data.status.length; x++) {
				var st = data.status[x];
				if (st.only_for_expenses) continue;
				og.expenses2.all_status.push(st);
			}
			og.expenses2.next_status_config = data.next_status_config;
		}});
		
		og.openLink(og.getUrl('expense', 'get_disabled_subtabs'), {callback: function(success, data){
			if (success) {
				og.expenses2.disabled_subtabs = data.disabled_subtabs;
			}
		}});
		
		og.openLink(og.getUrl('payment_receipt', 'get_list_config'), {
			preventPanelLoad: true,
			callback: function(success, data){
				eval(data.html);
				return;
			}
		});
		
		/*
		og.openLink(og.getUrl('expense_item', 'get_expense_item_list_config'), {
			preventPanelLoad: true,
			callback: function(success, data){
				eval(data.html);
				return;
			}
		});*/
		
		og.product_types.reload_allowed_dimensions();
		
		og.eventManager.addListener('load input events', function(data){
			for (var i= 0; i < data.length; i++){
				switch( data[i] ) {

					case "expenses_graph_unit":
						$("#list_"+data[i]).change( function() {
							og.openLink(og.getUrl('object', 'set_user_config_option_value', {config_option_name: 'expenses_graph_unit', config_option_value: $(this).val()}), {preventPanelLoad: true, hideLoading: true});
							og.eventManager.fireEvent('reload current panel');
							$("#quick-form").fadeOut();
						});
						break;
					case "expenses_graph_date_range":
						var html = '<button id="btn_apply_date_range_expenses_graph">'+lang('apply date range button')+'</button>';
					    $('.expenses_graph_date_range.date-range-container').append(html);
					          
						$("#date_range_type_"+data[i]).change( function(){
	    					var data_values = { type: $(this).val(), range_start: '', range_end: ''};
	    					if ( $(this).val() != "range" ) {
	    						og.openLink(og.getUrl('object', 'set_user_config_option_value', {config_option_name: 'expenses_graph_date_range', config_option_value: Ext.util.JSON.encode(data_values) }), {preventPanelLoad: true, hideLoading: true});
	    						og.eventManager.fireEvent('reload current panel');
	    						$("#quick-form").fadeOut();
	    					}
						});
						break;
						
				}
		
			}
			
			$("#btn_apply_date_range_expenses_graph").click(function() {
				var data_values = { type: $("#date_range_type_expenses_graph_date_range").val(), range_start: $("#date_range_start_expenses_graph_date_range").val(), range_end: $("#date_range_end_expenses_graph_date_range").val()};

				og.openLink(og.getUrl('object', 'set_user_config_option_value', {config_option_name: 'expenses_graph_date_range', config_option_value: Ext.util.JSON.encode(data_values) }), {preventPanelLoad: true, hideLoading: true, callback: function(success){
					if (success) og.eventManager.fireEvent('reload current panel');
				}});
				
				$("#quick-form").fadeOut();
			});
			
		});

		// Add 'budgeted revenue' and 'budgeted cost' columns to the project list
		og.eventManager.addListener('after get projects dimension info', function (dim) {
			if (dim && dim.dimension_id && dim.object_type_id) {
				
				if (!og.listing_member_type_cols) og.listing_member_type_cols = [];
				if (!og.listing_member_type_cols[dim.dimension_id]) og.listing_member_type_cols[dim.dimension_id] = [];
				if (!og.listing_member_type_cols[dim.dimension_id][dim.object_type_id]) og.listing_member_type_cols[dim.dimension_id][dim.object_type_id] = [];

				// Estimated values
				if(og.loggedUser.can_see_billing_info){
					og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
						id: 'estimated_expense_billable_price',
						name: lang('estimated expense billable price'),
						renderer: og.clean,
						align: 'right',
						hidden: true
					});

					og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
						id: 'estimated_expense_non_billable_price',
						name: lang('estimated expense non-billable price'),
						renderer: og.clean,
						align: 'right',
						hidden: true
					});


					og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
						id: 'estimated_expense_total_price',
						name: lang('estimated expense total price'),
						renderer: og.clean,
						align: 'right',
						hidden: true
					});
				}

				if(og.loggedUser.can_see_cost_info){
					og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
						id: 'estimated_expense_billable_cost',
						name: lang('estimated expense billable cost'),
						renderer: og.clean,
						align: 'right',
						hidden: true
					});

					og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
						id: 'estimated_expense_non_billable_cost',
						name: lang('estimated expense non-billable cost'),
						renderer: og.clean,
						align: 'right',
						hidden: true
					});

					og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
						id: 'estimated_expense_total_cost',
						name: lang('estimated expense total cost'),
						renderer: og.clean,
						align: 'right',
						hidden: true
					});
				}

				// Executed values
				if(og.loggedUser.can_see_billing_info){
					og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
						id: 'executed_expense_total_price',
						name: lang('executed expense total price'),
						renderer: og.clean,
						align: 'right',
						hidden: true
					});
				}

				if(og.loggedUser.can_see_cost_info){
					og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
						id: 'executed_expense_billable_cost',
						name: lang('executed expense billable cost'),
						renderer: og.clean,
						align: 'right',
						hidden: true
					});

					og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
						id: 'executed_expense_non_billable_cost',
						name: lang('executed expense non-billable cost'),
						renderer: og.clean,
						align: 'right',
						hidden: true
					});

					og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
						id: 'executed_expense_total_cost',
						name: lang('executed expense total cost'),
						renderer: og.clean,
						align: 'right',
						hidden: true
					});
				}
			}
		});
	},
	
	loadSubtab: function (t) {
		if (this.load_subtab_functions && this.load_subtab_functions.length > 0) {
			for (var i=0; i<this.load_subtab_functions.length; i++) {
				var fn = this.load_subtab_functions[i];
				if (typeof(fn) == 'function') {
					fn.call(null, t);
				}
			}
		}
	},
	
	buildExpenseItemsTableRowHtml: function(expense_item, alt, column_model) {
		
		var cell_class = ' expense-subtable';
		if (alt) cell_class += ' alt';
		
		var row_html = '<tr class="expense-subtable-row">';
		
		var extra_expense_amount_columns = [];
		if (og.extra_expense_list_columns && og.extra_expense_list_columns.length>0) {
			for (var i=0; i<og.extra_expense_list_columns.length; i++) {
				var tmp = og.extra_expense_list_columns[i];
				if (tmp && tmp.id && tmp.id != 'invoicing_status') extra_expense_amount_columns.push(tmp.id);
			}
		}
		
		for (var i=0; i<column_model.config.length; i++) {
			var col = column_model.config[i];
			if (col.hidden) {
				continue;
			}

			if (col.id == 'checker' || col.id == 'draghandle' || col.id == 'expand' || col.id == 'icon' || col.id == 'is_billable') {
				if (col.id.indexOf('dim_') == 0) {
					row_html += '<td class="x-grid3-col x-grid3-cell'+ cell_class +'"></td>';
				} else {
					row_html += '<td></td>';
				}
			
			} else if (col.id == 'name') {
				
				var item_name_to_show = expense_item.name;
				/*var product_type = null;
				if (expense_item.product_type_id) {
					product_type = og.product_types.get_by_id(expense_item.product_type_id);
				}
				if (product_type) {
					item_name_to_show += ' (' + product_type.name + ')';
				}*/
				//var link = '<a href="javascript:og.render_modal_form(\'\', {c:\'expense_item\', a:\'edit\', params:{id:'+expense_item.id+'}});">'+ expense_item.name +'</a>';
				var link = '<a href="javascript:og.openLink(og.getUrl(\'expense\', \'view\', {id:'+expense_item.expense_id+'}));">'+ item_name_to_show +'</a>';
				
				row_html += '<td class="x-grid3-col x-grid3-cell'+ cell_class +'"><div class="x-grid3-cell-inner">'+ link +'</div></td>';
			
			} else if (col.id == 'status_id' || col.id == 'invoicing_status') {
				row_html += '<td class="x-grid3-col x-grid3-cell'+ cell_class +'"><div class="x-grid3-cell-inner"></div></td>'
			
			} else if (col.id == 'date') {
				row_html += '<td class="x-grid3-col x-grid3-cell'+ cell_class +'"><div class="x-grid3-cell-inner" style="text-align:center;">'+expense_item.date+'</div></td>'
			
			} else if (col.id.indexOf('total_') == 0 || extra_expense_amount_columns.indexOf(col.id) != -1) {
				
				row_html += '<td class="x-grid3-col x-grid3-cell'+ cell_class +'"><div class="x-grid3-cell-inner">';
				
				var detail_col = col.id.replace('total', 'unit');
				
				var total_str = expense_item['currency_sym'] + " " + expense_item[col.id].toFixed(expense_item.amount_decimals);
				
				var detail_str = expense_item['quantity'] +  ' x ';
				detail_str += expense_item['currency_sym'] + " " + expense_item[detail_col].toFixed(expense_item.amount_decimals);
				
				row_html += '<span style="float:right">' + detail_str + " = " + total_str + '</span>';
				
				row_html += '</div></td>';
				
			} else if (col.id.indexOf('dim_') == 0) {
				var dim_id = col.id.substring(4);
				row_html += "<td class='x-grid3-col x-grid3-cell"+ cell_class +"'>" + (typeof(expense_item[col.id])!='undefined' ? expense_item[col.id] : "") + '</td>';
			}
			
		}

		row_html += '</tr>';
		
		return row_html;
	},
	
	buildExpenseItemsTable: function(el, expense_items) {
		if (!expense_items) return;
		
		var column_model = Ext.getCmp('expense-manager').getColumnModel();
		for (var i=0; i<expense_items.length; i++) {
			var alt = i % 2 != 0;
			var html = og.expenses2.buildExpenseItemsTableRowHtml(expense_items[i], alt, column_model);
			
			var other_pay_rows = $('#'+el.id).closest('tr').siblings(".expense-subtable-row");
			if (other_pay_rows.length > 0) {
				$(other_pay_rows).last().after(html);
			} else {
				$('#'+el.id).closest('tr').after(html);
			}
		}
		
	},
	
	requestExpenseItems: function(el, object_id) {
		$('#'+el.id).removeClass('ico-expand-lens').addClass('ico-collapse-lens');
		el.setAttribute('onclick', 'og.expenses2.collapseSubtable(this);');
		
		og.openLink(og.getUrl('expense','get_expense_items',{id:object_id}), {
			callback: function (success, data) {
				og.expenses2.buildExpenseItemsTable(el, data.expense_items);
				og.eventManager.fireEvent('replace all empty breadcrumb', null);
			}
		});
	},
	
	collapseSubtable: function(el) {
		$('#'+el.id).parent('.x-grid3-row-table').children('.expense-subtable-row').hide();
		var table = $('#'+el.id).closest('.x-grid3-row-table').get(0);
		for (i=0; i<table.rows.length; i++) {
			if (table.rows[i].className == 'expense-subtable-row') table.rows[i].style.display = 'none';
		}

		$('#'+el.id).removeClass('ico-collapse-lens').addClass('ico-expand-lens');
		el.setAttribute('onclick', 'og.expenses2.expandSubtable(this);');
	},
	
	expandSubtable: function(el) {
		$('#'+el.id).parent('.x-grid3-row-table').children('.expense-subtable-row').hide();
		var table = $('#'+el.id).closest('.x-grid3-row-table').get(0);
		for (i=0; i<table.rows.length; i++) {
			if (table.rows[i].className == 'expense-subtable-row') table.rows[i].style.display = '';
		}
		
		$('#'+el.id).removeClass('ico-expand-lens').addClass('ico-collapse-lens');
		el.setAttribute('onclick', 'og.expenses2.collapseSubtable(this);');
	},

	addExpenseItemTableRow: function(table_id, values, genid) {
		var table = document.getElementById(table_id);
		var table_type = 'expense_items';
		var len = table.rows.length;
		var pos = len - 1;
		var row = table.insertRow(len);
		var row_id = Math.floor((Math.random()*10000)+1);
		var is_billable = $("#" + genid + "expenseFormIsBillable") ? $("#" + genid + "expenseFormIsBillable").is(':checked') : true;

		if (table.max_num) {
			num = parseInt(table.max_num) + 1;
		} else if (values && values.num) {
			num = parseInt(values.num);
			if (!table.max_num) table.max_num = num;
		} else {
			table.max_num = 0;
			num = 1;
		}
		if (parseInt(table.max_num) < num) table.max_num = num;
		
		row.id = row_id;
		row.className = (len % 2 == 0) ? 'alt' : '';
		
		var columnsToSkip = og.columns_to_hide_in_expenses ? og.columns_to_hide_in_expenses : [];

		// item id
		var id = values && values.id ? values.id : '';
		// price multiplier
		var pm = values && values.price_multiplier ? values.price_multiplier : '1';
		

		
		// product_type_id
		var cellpt = row.insertCell(row.cells.length);
		var product_type_id = values && values.product_type_id ? values.product_type_id : '';
		var pt_options = ['<option value=""></option>'];
		
		var product_types = og.expenses2.product_types;

		
		
		if (og.expenses2.filtered_product_types) {
			product_types = og.expenses2.filtered_product_types;
		}
		
		
		for (i=0; i<product_types.length; i++) {
			var c = product_types[i];
			var sel = product_type_id == c.id ? 'selected="selected"' : '';
			pt_options += '<option '+sel+' value="'+ c.id +'">'+ c.name +'</option>';
		}
		var cell_id = genid + '_' + pos + '_product_type_id';
		cellpt.innerHTML = '<select id="'+cell_id+'" class="product_type_selector" type="text" name="expense['+table_type+']['+pos+'][product_type_id]" onchange="og.expenses2.onItemProductTypeChange(\''+genid+'\', '+pos+', false, true)" style="width:100%;max-width:200px;">' + pt_options + '</select>';
		

		// quantity
		var celluc = row.insertCell(row.cells.length);
		var quantity = values && values.quantity ? values.quantity : '';
		var cell_id = genid + '_' + pos + '_quantity';
		celluc.innerHTML += '<input type="text" id="'+cell_id+'" class="short" name="expense['+table_type+']['+pos+'][quantity]" value="'+quantity+'" onchange="og.expenses2.updateItemTotals(\''+genid+'\', '+pos+')"/>';
		
		// description
		var description = values && values.desc ? values.desc : '';
		var celld = row.insertCell(row.cells.length);
		var desc_style = og.expenses2.use_date_in_expense_level ? "width: 98%;" : "";
		celld.innerHTML = '<input type="text" name="expense['+table_type+']['+pos+'][description]" value="'+description+'" style="'+desc_style+'"/>';

		celld.innerHTML += '<input type="hidden" name="expense['+table_type+']['+pos+'][num]" value="'+num+'"/>';
		celld.innerHTML += '<input type="hidden" name="expense['+table_type+']['+pos+'][id]" value="'+id+'" class="exp-item-id"/>';

		var pm_id = genid + '_' + pos + '_price_multiplier';
		celld.innerHTML += '<input id="'+pm_id+'" type="hidden" name="expense['+table_type+']['+pos+'][price_multiplier]" value="'+pm+'"/>';
		
		// date
		if (!og.expenses2.use_date_in_expense_level) {
			var celldate = row.insertCell(row.cells.length);
			celldate.className += 'date';
			var dateInput = new og.DateField({
				renderTo: celldate,
				width: 80,
				name: 'expense['+table_type+']['+pos+'][date]'
			});
			if (values && values.date) dateInput.setValue(values.date);
		}
		
		// unit cost
		var celluc = row.insertCell(row.cells.length);
		var amount = values && values.unit_cost ? values.unit_cost : '';
		var cell_id = genid + '_' + pos + '_unit_cost';
		var hiddenCost = values && values.show_cost_info ? '' : 'hidden';
		celluc.innerHTML += '<input type="text" '+hiddenCost+' id="'+cell_id+'" class="amount" name="expense['+table_type+']['+pos+'][unit_cost]" value="'+amount+'" onchange="og.expenses2.updateItemTotalCost(\''+genid+'\', '+pos+')"/>';
		
		// total cost
		var celltc = row.insertCell(row.cells.length);
		var amount = values && values.total_cost ? values.total_cost : '';
		var cell_id = genid + '_' + pos + '_total_cost';
		var hiddenCost = values && values.show_cost_info ? '' : 'hidden';
		celltc.innerHTML += '<input type="text" '+hiddenCost+' id="'+cell_id+'" class="amount" name="expense['+table_type+']['+pos+'][total_cost]" value="'+amount+'"/>';
		
		if(!columnsToSkip.includes('unit_price')){
			// unit price
			var cellup = row.insertCell(row.cells.length);
			var amount = values && values.unit_price ? values.unit_price : '';
			var cell_id = genid + '_' + pos + '_unit_price';
			var hiddenPrice = values && values.show_billing_info ? '' : 'hidden';
			var disabled = '';
			if(!is_billable){
				amount = 0;
				disabled = 'disabled';
			}
			cellup.innerHTML += '<input type="text" '+hiddenPrice+' id="'+cell_id+'" class="amount" name="expense['+table_type+']['+pos+'][unit_price]" '+disabled+' value="'+amount+'" onchange="og.expenses2.updateItemTotalPrice(\''+genid+'\', '+pos+')"/>';
		}
		
		if(!columnsToSkip.includes('total_price')){
			// total price
			var celltp = row.insertCell(row.cells.length);
			var amount = values && values.total_price ? values.total_price : '';
			var cell_id = genid + '_' + pos + '_total_price';
			var hiddenPrice = values && values.show_billing_info ? '' : 'hidden';
			var disabled = '';
			if(!is_billable){
				amount = 0;
				disabled = 'disabled';
			}
			celltp.innerHTML += '<input type="text" '+hiddenPrice+' id="'+cell_id+'" class="amount" name="expense['+table_type+']['+pos+'][total_price]" '+disabled+' value="'+amount+'"/>';
		}
	/*
		// status selector
		var cellst = row.insertCell(row.cells.length);
		var options = [];
		for (i=0; i<og.expenses2.statuses.length; i++) {
			var c = og.expenses2.statuses[i];
			if (c.only_for_expenses) continue;
			if (values && typeof(values.status) != 'undefined') {
				var sel = values && values.status == c.id ? 'selected="selected"' : '';
			}
			options += '<option '+sel+' value="'+ c.id +'">'+ c.name +'</option>';
		}
		cellst.className += 'right';
		cellst.innerHTML = '<select type="text" name="expense['+table_type+']['+pos+'][status_id]">' + options + '</select>';		
	*/
		// delete link
		cellremove = row.insertCell(row.cells.length);
		cellremove.innerHTML = '<a href="#" class="link-ico ico-delete" onclick="og.expenses2.removeExpenseItemTableRow(\''+table_id+'\', '+row_id+', '+pos+')"></a>';
		cellremove.style.width = '23px';
		cellremove.style.minWidth = '23px';

		// focus in first input
		celld.getElementsByTagName('input')[0].focus();
		
		// scroll the form if necessary
		og.expenses2.scrollExpenseFormDown(genid);
	},
	
	updateItemTotals: function(genid, pos) {
		var valuesToSkip = og.columns_to_hide_in_expenses ? og.columns_to_hide_in_expenses : [];
		og.expenses2.updateItemTotalCost(genid, pos);
		if(!valuesToSkip.includes('total_price')){
			og.expenses2.updateItemTotalPrice(genid, pos);
		}
		og.expenses2.update_payment_receipt_name(genid, '1');
	},
	
	updateItemTotalCost: function(genid, pos) {
		var quantity = $("#" + genid + '_' + pos + '_quantity').val();
		var unit_cost = $("#" + genid + '_' + pos + '_unit_cost').val();

		quantity = og.clean_thousand_separator(quantity);
		unit_cost = og.clean_thousand_separator(unit_cost);
		
		if (quantity == '') quantity = 0;
		if (isNaN(quantity)) quantity = parseFloat(quantity);
		if (isNaN(unit_cost)) unit_cost = parseFloat(unit_cost);
		
		var all_taxes_amount = 0;
		if (og.expenses2.taxes) {
			for (tax_id in og.expenses2.taxes) {
				og.expenses2.on_tax_change(tax_id, genid, true);
				var tax_val = $("#" + genid + '_' + pos + '_tax_' + tax_id).val();
				tax_val = og.clean_thousand_separator(tax_val);
				if (!isNaN(tax_val)) all_taxes_amount += parseFloat(tax_val);
			}
		}
		
		var total_cost = quantity * unit_cost + all_taxes_amount;
		$("#" + genid + '_' + pos + '_total_cost').val(og.format_money_amount(total_cost, og.expenses2.amount_decimals));

		$("#" + genid + '_' + pos + '_unit_cost').val(og.format_money_amount(unit_cost, og.expenses2.amount_decimals));
		
		var product_type_id = $("#" + genid + '_' + pos + '_product_type_id').val();
		var product_type = og.product_types.get_by_id(product_type_id);
		if (product_type && product_type.uses_price_multiplier) {
			var unit_price = unit_cost * product_type.price_multiplier;
			$("#" + genid + '_' + pos + '_unit_price').val(og.format_money_amount(unit_price, og.expenses2.amount_decimals));
			og.expenses2.updateItemTotalPrice(genid, pos);
		}
	},
	
	updateItemTotalPrice: function(genid, pos) {
		if ($("#" + genid + '_' + pos + '_unit_price').hasClass('nonbillable')) {
			$("#" + genid + '_' + pos + '_unit_price').val(0);
		}
		var quantity = $("#" + genid + '_' + pos + '_quantity').val();
		var unit_price = $("#" + genid + '_' + pos + '_unit_price').val();

		quantity = og.clean_thousand_separator(quantity);
		unit_price = og.clean_thousand_separator(unit_price);
		
		if (quantity == '') quantity = 0;
		if (isNaN(quantity)) quantity = parseFloat(quantity);
		if (isNaN(unit_price)) unit_price = parseFloat(unit_price);
		
		var total_price = quantity * unit_price;
		$("#" + genid + '_' + pos + '_total_price').val(og.format_money_amount(total_price, og.expenses2.amount_decimals));

		$("#" + genid + '_' + pos + '_unit_price').val(og.format_money_amount(unit_price, og.expenses2.amount_decimals));
	},
	
	onItemProductTypeChange: function(genid, pos, dontFillMemberSelectors, ask_before_replace_amounts, use_budgeted_expense_amounts) {
		if (use_budgeted_expense_amounts && og.expenses2.selected_budgeted_expense_amounts) {
			// if this is triggerd after changing budgeted expense then use the temporary variable with the expense amounts instead of getting the prod type
			var product_type = og.expenses2.selected_budgeted_expense_amounts;
		} else {
			var product_type_id = $("#" + genid + '_' + pos + '_product_type_id').val();
			var product_type = og.product_types.get_by_id(product_type_id);
		}
		var valuesToSkip = og.columns_to_hide_in_expenses ? og.columns_to_hide_in_expenses : [];

		if (product_type) {

			var question_to_ask = null;
			if (ask_before_replace_amounts) {

				var current_unit_cost = parseFloat($("#" + genid + '_' + pos + '_unit_cost').val());
				var ask_unit_cost = current_unit_cost > 0 && product_type.hourly_cost > 0 && current_unit_cost != product_type.hourly_cost;

				var ask_unit_price = false
				if (!valuesToSkip.includes('unit_price')) {
					var current_unit_price = parseFloat($("#" + genid + '_' + pos + '_unit_price').val());
					var next_unit_price = product_type.uses_price_multiplier ? product_type.hourly_cost * product_type.price_multiplier : product_type.hourly_rate;
					ask_unit_price = current_unit_price > 0 && next_unit_price > 0 && current_unit_price != next_unit_price;
				}

				if (ask_unit_cost && ask_unit_price) {
					question_to_ask = 'cost_and_price';
				} else if (ask_unit_cost) {
					question_to_ask = 'cost';
				} else if (ask_unit_price) {
					question_to_ask = 'price';
				} 
			}

			if (question_to_ask != null) {

				og.ExtModal.show({
					title: lang('change ' + question_to_ask + '?'),
					basecls: 'add-actual-expense-modal',
					html: og.expenses2.askToReplaceAmountsModalHtml(genid, pos, question_to_ask, product_type.id, use_budgeted_expense_amounts)
				});

			} else {

				og.expenses2.replaceUnitCostUnitPriceWithProductType(genid, pos, product_type, 'cost_and_price');
				
			}

		}
		
		if(!dontFillMemberSelectors){
			og.expenses2.fillEmptyMemberSelectors(genid, product_type);
		}
		og.expenses2.update_payment_receipt_name(genid, '1');
	},

	isCostUpdatedManually(genid, pos) {
		return $("#" + genid + '_' + pos + '_manual_cost').val() > 0;
	},
	isPriceUpdatedManually(genid, pos) {
		return $("#" + genid + '_' + pos + '_manual_price').val() > 0;
	},
	isQuantityUpdatedManually(genid, pos) {
		return $("#" + genid + '_' + pos + '_manual_quantity').val() > 0;
	},

	replaceUnitCostUnitPriceWithProductType: function(genid, pos, product_type, ignore_manual_changes, use_budgeted_expense_amounts) {

		var is_billable = true;
		if ($("#" + genid + "expenseFormIsBillable").length > 0) {
			// we are in budgeted expenses form
			is_billable = $("#" + genid + "expenseFormIsBillable").is(':checked');
		} else {
			// we are in actual expenses form
			is_billable = $("#" + genid + "prFormIsBillable:checked").val() == '1';
		}

		var valuesToSkip = og.columns_to_hide_in_expenses ? og.columns_to_hide_in_expenses : [];

		if (typeof product_type != 'object') {
			if (use_budgeted_expense_amounts && og.expenses2.selected_budgeted_expense_amounts) {
				// if this is triggerd after changing budgeted expense then use the temporary variable with the expense amounts instead of getting the prod type
				var product_type = og.expenses2.selected_budgeted_expense_amounts;
				og.expenses2.selected_budgeted_expense_amounts = null; // reset this var
			} else {
				// get the product type using the given id
				var product_type = og.product_types.get_by_id(product_type);
			}
		}

		// check if the amounts have been updated manually to decide if we overwrite them or not
		// if ignore_manual_changes is true is because the user answered explicity to replace the amounts after system asked to do it or keep old values
		let is_cost_updated_manually = !ignore_manual_changes && og.expenses2.isCostUpdatedManually(genid, pos);
		let is_price_updated_manually = !ignore_manual_changes && og.expenses2.isPriceUpdatedManually(genid, pos);

		if (product_type.hourly_cost > 0 && !is_cost_updated_manually) {
			$("#" + genid + '_' + pos + '_unit_cost').val(product_type.hourly_cost.toFixed(og.expenses2.amount_decimals));
		}

		$("#" + genid + '_' + pos + '_price_multiplier').val(product_type.price_multiplier.toFixed(3));
		
		if(!valuesToSkip.includes('unit_price') && is_billable){
			var unitprice = 0;
			if (product_type.uses_price_multiplier) {
				unitprice = product_type.hourly_cost * product_type.price_multiplier;
			} else if (product_type.hourly_rate > 0) {
				unitprice = product_type.hourly_rate;
			}
			if (unitprice > 0 && !is_price_updated_manually) {
				$("#" + genid + '_' + pos + '_unit_price').val(og.format_money_amount(unitprice, og.expenses2.amount_decimals));
			}
		}

		og.expenses2.updateItemTotals(genid, pos);

	},

	askToReplaceAmountsModalHtml: function(genid, pos, question_to_ask, product_type_id, use_budgeted_expense_amounts) {

		let use_b_exp = use_budgeted_expense_amounts ? 'true' : 'false';

		var replace_action = "og.expenses2.replaceUnitCostUnitPriceWithProductType('"+genid+"',"+pos+","+product_type_id+", true, "+use_b_exp+");";
		
		var question = lang('product type change replace amounts question ' + question_to_ask);
		var replace_btn_text = lang('product type change replace button text ' + question_to_ask);

		var keep_btn = '<button class="submit" onclick="og.ExtModal.hide();">' + lang('keep') + '</button>';
		var replace_btn = '<button class="submit" onclick="og.ExtModal.hide(); '+replace_action+'">' + replace_btn_text + '</button>';

		var html = '<div class="question">' + question + '</div>';
		html += '<div class="button-container">' + keep_btn + replace_btn + '</div>';
		
		return html;
	},
	
	fillEmptyMemberSelectors: function(genid, product_type) {
		
		if (product_type && product_type.members && member_selector[genid]) {
			
			for (var dim_id in product_type.members) {
				if ((!member_selector[genid].sel_context[dim_id] || member_selector[genid].sel_context[dim_id].length == 0) 
					&& member_selector[genid].properties[dim_id]) {
					
					var mem_id = product_type.members[dim_id];
					if (mem_id) {
						member_selector.add_relation(dim_id, genid, mem_id);
						$("#"+genid+"-member-chooser-panel-"+dim_id+"-tree-current-selected .empty-text").hide();
					}
				}
			}
			
		}
	},
	
	scrollExpenseFormDown: function(genid) {
		var offset = $("#"+ genid +"add-expense-item-button").offset();
		if (offset) {
		//	$('#modal-forms-container').animate({scrollTop: offset.top});
		}
	},

	removeExpenseItemTableRow: function(table_id, row_id, suffix) {
		var table = document.getElementById(table_id);
		var row = document.getElementById(row_id);
		if (table && row) {
			var exp_item_id = $(row).find('.exp-item-id').val();
			var del_ids_json = $(table).find('#deleted_item_ids').val();
			var del_ids = Ext.util.JSON.decode(del_ids_json);
			del_ids.push(exp_item_id);
			del_ids_json = Ext.util.JSON.encode(del_ids);
			$(table).find('#deleted_item_ids').val(del_ids_json);
			
			table.deleteRow(row.rowIndex);
			var row2 = document.getElementById(row_id + '-' + suffix);
			if (row2) {
				table.deleteRow(row2.rowIndex);
			}
		}
	},
	
	
	submit_expense_form: function(form_id) {
		var has_empty_amounts = false;
		var amounts = $("#"+form_id+" .expense-items-table-container input.amount");
		for (var i=0; i<amounts.length; i++) {
			var amount = amounts[i];
			
			if ($(amount).val() == '' || parseFloat($(amount).val()) == 0) {
				has_empty_amounts = true;
				break;
			}
		}

		if (has_empty_amounts) {
			switch (og.expenses2.action_for_empty_amount_expense_items) {
				case 'dont_save':
					og.err(lang('cannot save expense it has expense_items with empty amount'));
					break;
				case 'ask_user':
					if (confirm(lang('save expense with empty amounts prompt'))) {
						og.submit_modal_form(form_id);
					}
					break;
				case 'allow_save':
				default:
					og.submit_modal_form(form_id); 
					return false;
			}
		} else {
			og.submit_modal_form(form_id); 
			return false;
		}
	},
	
	
	submit_expense_item_form: function(form_id) {
		var has_empty_amounts = false;
		var amounts = $("#"+form_id+" .expense-items-table-container input.amount");
		for (var i=0; i<amounts.length; i++) {
			var amount = amounts[i];
			
			if ($(amount).val() == '' || parseFloat($(amount).val()) == 0) {
				has_empty_amounts = true;
				break;
			}
		}

		if (has_empty_amounts) {
			switch (og.expenses2.action_for_empty_amount_expense_items) {
				case 'dont_save':
					og.err(lang('cannot save expense it has expense_items with empty amount'));
					break;
				case 'ask_user':
					if (confirm(lang('save expense with empty amounts prompt'))) {
						og.submit_modal_form(form_id);
					}
					break;
				case 'allow_save':
				default:
					og.submit_modal_form(form_id); 
					return false;
			}
		} else {
			og.submit_modal_form(form_id); 
			return false;
		}
	},

	select_task: function(genid) {

		og.ObjectPicker.show(function (objs) {
			if (objs && objs.length > 0) {
				var obj = objs[0].data;
				if (obj.type != 'task') {
					og.msg(lang("error"), lang("object type not supported"), 4, "err");
				} else {
					og.expenses2.set_task(genid, obj);
				}
			}
		}, this, {
			types: ['task'],
			selected_type: 'task',
		});
		
	},

	set_task: function(genid, obj, dont_ask_user) {
		$("#" + genid + "task_name_container").css('display', 'inline-block');
		$("#" + genid + "select_task").hide();
		$("#" + genid + "task_id").val(obj.object_id);
		$("#" + genid + "task_name").html(obj.name);

		og.openLink(og.getUrl('task','get_task_data',{id:obj.object_id, task_info:true}),{
			callback: function(success, data) {
				if (data && data.task) {
					var task_is_fixed_fee = !data.task.is_calculated_estimated_price && data.task.is_fixed_fee;
					var task_non_billable = !data.task.is_billable;
					if (task_is_fixed_fee || task_non_billable) {
						if (dont_ask_user) {
							og.expenses2.set_non_billable_and_disable(genid);
							return;
						}

						if(task_is_fixed_fee){
							var question = lang("You are trying to link a billable expense to a fixed price task. If you continue, this expense will be set to non-billable. Continue?");
						} else {
							var question = lang("You are trying to link a billable expense to a non-billable task. If you continue, this expense will be set to non-billable. Continue?");
						}
						var html = '<div style="padding: 10px;">'+ 
							'<div id="'+genid+'_question">'+ question +'</div>'+
							'<div class="clear"></div></div>';
						og.ExtendedDialog.show({
							YESNO: true,
							html: html,
							height: 200,
							width: 400,
							title: lang('confirm set non billable'),
							okBtnCls: 'submit-btn-blue',
							cancelBtnCls: 'cancel-btn-g',
							iconCls: ' ',
							cls: 'ext-modal-object-list no-border',
							ok_fn: function() {
								og.expenses2.set_non_billable_and_disable(genid);
								$("#" + genid + "task_non_billable").val(1);
								og.ExtendedDialog.hide();
							},
							cancel_fn: function() {
								og.expenses2.remove_task(genid);
								og.ExtendedDialog.hide();
							},
						});

					} else {
						og.expenses2.enable_is_billable_input(genid); 
					}
				}
			}
		});
	},

	set_non_billable_and_disable: function(genid) {
		// for actual expenses form
		$("#" + genid + "prFormIsBillable[value='0']").click(); // set to non billable
		$("#" + genid + "prFormIsBillable.yes_no").attr('disabled', 'disabled'); // disable the billable radio buttons

		// for budgeted expenses form
		$("#" + genid + "expenseFormIsBillable").removeAttr('checked'); // set to non billable
		$("#" + genid + "expenseFormIsBillable").attr('disabled', 'disabled'); // disable the billable checkbox

		og.expenses2.update_bud_exp_price_inputs_after_billable_change(genid);
	},

	enable_is_billable_input: function(genid) {
		// for actual expenses form
		$("#" + genid + "prFormIsBillable.yes_no").removeAttr('disabled'); // enable the billable radio buttons
		// for budgeted expenses form
		$("#" + genid + "expenseFormIsBillable").removeAttr('disabled'); // disable the billable checkbox

		og.expenses2.update_bud_exp_price_inputs_after_billable_change(genid);
	},

	update_bud_exp_price_inputs_after_billable_change: function(genid) {
		var is_billable_input = $("#" + genid + "expenseFormIsBillable");
		if(is_billable_input.length == 0) return;

		var is_billable = $("#" + genid + "expenseFormIsBillable").is(':checked');

		if (is_billable) {
			// Enable unit price
			$('[id*="_unit_price"]').each(function() {
				$(this).removeAttr('disabled');
			});

			// Enable total price
			$('[id*="_total_price"]').each(function() {
				$(this).removeAttr('disabled');
			});	

			// Set action for empty amount expense items
			if(typeof og.expenses2.action_for_empty_amount_expense_items !== 'undefined' && og.expenses2.config_for_empty_amount_expense_items !== 'undefined') {
				og.expenses2.action_for_empty_amount_expense_items = og.expenses2.config_for_empty_amount_expense_items;
			}
		} else {
			// Set unit price to 0 and disable it
			$('[id*="_unit_price"]').each(function() {
				$(this).val(0);
				$(this).attr('disabled', 'disabled');
			});

			// Set total price to 0 and disable it
			$('[id*="_total_price"]').each(function() {
				$(this).val(0);
				$(this).attr('disabled', 'disabled');
			});

			// Set action for empty amount expense items
			if(typeof og.expenses2.action_for_empty_amount_expense_items !== 'undefined') {
				og.expenses2.action_for_empty_amount_expense_items = 'allow_save';
			}
		
		}
	},

	remove_task: function(genid) {
		
		$("#" + genid + "task_name_container").hide();
		$("#" + genid + "select_task").show();
		$("#" + genid + "task_id").val(0);
		$("#" + genid + "task_name").html('');

		// Set hidden 'task_non_billable' field to 0
		$("#" + genid + "task_non_billable").val(0);
		
		og.expenses2.enable_is_billable_input(genid);
	},
	
	
	showExpenseItemHistory: function(expense_id, expense_item_num) {
		
		og.openLink(og.getUrl('expense_item', 'show_expense_item_history', {expense_id:expense_id, expense_item_num:expense_item_num}), {
			callback: function(success, data) {
	
				var modal_params = {
					'closeHTML': '<a id="'+genid+'_close_link" class="modal-close" title="'+lang('close')+'"></a>',
					'onShow': function (dialog) {
						$("#"+genid+"_close_link").addClass("modal-close-img");
				    }
				};
				var html = '<div class="modal-container" style="background-color: white;padding: 10px;">'+data.html+'</div>';
				setTimeout(function() {
					$.modal(html, modal_params);
				}, 100);
			}
		});
	},
	
	reorderExpenseItemsTable: function(exp_id, order, odir) {
		if (odir != 'ASC' && odir != 'DESC') odir = 'ASC';
		
		og.openLink(og.getUrl('expense', 'get_expense_items_table_html', {id:exp_id, order:order, order_dir:odir}), {
			callback: function(success, data) {
				$("#expense-items-table-container").html(data.html);
			}
		});
	},
	
	
	renderExpenseItemGridActions: function(value, p, r) {
		var actions = '';
		if (r.data.id == '__total_row__' || r.data.id <= 0) return actions;
		
		var actionStyle= ' style="font-size:105%;padding-top:2px;padding-bottom:3px;padding-left:16px;background-repeat:no-repeat;" '; 
		
		actions += String.format(
			'<a class="list-action ico-edit" href="#" onclick="og.render_modal_form(\'\', {c:\'expense_item\', a:\'edit\', params:{id:'+r.data.object_id+'}});" title="{1}" ' + actionStyle + '>&nbsp;</a>',
			r.data.object_id, lang('edit'));
		
		var current_status = null;
		for (x in og.expenses2.all_status) {
			var st = og.expenses2.all_status[x];
			if (st.code == r.data.status_code) {
				current_status = st;
				break;
			}
		}
		if (current_status && !current_status.is_final) {
			var next_status = og.expenses2.next_status_config[current_status.code];
			if (next_status) {
				actions += String.format( 
					'<a class="list-action ico-change-pstatus ico-change-pstatus-'+next_status.code+'" href="#" onclick="og.openLink(og.getUrl(\'expense\', \'change_expense_item_status\', {'+
					'expense_item_id:'+r.data.object_id+', st:'+next_status.id+'}));" title="'+ lang('change status to', next_status.name) +'" ' + actionStyle + '>&nbsp;</a>');
			}
		}
		
		if (actions != '')
			actions = '<span>' + actions + '</span>';
			
		return actions;
	},
	
	renderExpenseItemGridStatus: function(value, p, r) {
		if (r.data.status_code) {
			return '<span class="expense-row-status-'+r.data.status_code+'">' + r.data.status + '</span>';
		} else {
			return '';
		}
	},

	renderTaskLink: function(value, p, r) {
		if (r.data.id == 'quick_add_row') return value; 
		if (r.data.task_id && r.data.task_id > 0) {
			return '<a class="underline" href="#" onclick="og.openLink(og.getUrl(\'task\', \'view\', {id: '+r.data.task_id+'})); return false;" >' + r.data.task_name + '</span>';
		} else {
			return '';
		}
	},
	
	renderInvoiceLink: function(value, p, r) {
		if (r.data.invoice_id && r.data.invoicing_status=='invoiced') {
			return '<a class="underline" href="#" onclick="og.openLink(og.getUrl(\'invoice\', \'view\', {id: '+r.data.invoice_id+'})); return false;" >' + lang('view invoice') + '</span>';
		} else {
			return '';
		}
	},
	
	renderInvoicingStatus: function(value, p, r) {
		if (r.data.invoicing_status) {
			return '<span class="invoicing-status-'+r.data.invoicing_status+'">' + lang('invoicing_status '+r.data.invoicing_status) + '</span>';
		} else {
			return '';
		}
	},
	
	renderPaymentTerm: function(value, p, r) {
		if (r.data.payment_term_name) {
			return r.data.payment_term_name;
		} else {
			return '';
		}
	},
	
	renderExpenseDocumentLink: function(value, p, r) {
		if (r.data.id == 'quick_add_row') return value; 
		if (r.data.id == '__total_row__' || r.data.object_id <= 0) return '';

		if (r.data.document_id && r.data.document_id != '') {
			let document_url = og.getUrl('files', 'get_public_file', {id: r.data.document_id});
			return '<a href="'+document_url+'" target="_blank" class="link-ico ico-open-link">' + lang('view receipt') + '</a>';
		} else {
			return '';
		}
	},
	
	
	addTotalsRow: function(store, filters, manager_id) {
		var params = {st: filters.status};
		if (filters.from_date) params['fromd'] = filters.from_date;
		if (filters.to_date) params['tod'] = filters.to_date;
		if (filters.expense_id) params['expense_id'] = filters.expense_id;
		
		og.openLink(og.getUrl('expense', 'get_totals_for_listing', params), {callback: function(success, data){

			var obj = data.totals;
			
			var record = new Ext.data.Record(obj, obj.id);
			var records = [];
			records.push(record);
			store.add(records);
			
			$("#"+manager_id+" #__total_row__").closest('tr').addClass('expenses-list-totals');
			
			// scroll list to top
			setTimeout(function(){
				$("#"+ manager_id +" .x-grid3-scroller").scrollTop(0);
				$("#expenses-panel .x-panel-body").scrollTop(0);
			}, 10);
			
		}});
	},
	renderContactName: function(value, p, r) {
		return r.data.paid_by_name;
	},

	renderExpenseNameColumn: function(value, p, r) {		
		return r.data.expense_name;
	},
	
	renderProductTypeColumn: function (value, p, r) {							
		return r.data.product_type_name
	},

	update_payment_receipt_name: function(genid, is_new_pr) {

		if (is_new_pr && !og.expenses2.user_has_changed_object_name) {
			var pr_name = '';

			var include_date = og.expenses2.actual_expense_name_generation == 'date_quantity_product' || og.expenses2.actual_expense_name_generation == 'date_product';
			var include_quantity = og.expenses2.actual_expense_name_generation == 'date_quantity_product';

			if (include_date) {
				var date_cmp = Ext.getCmp(genid + "payment_receipt_date");
				if (date_cmp) {
					var date_obj = date_cmp.getValue();
					if (date_obj) {
						pr_name = date_obj.format(og.preferences.date_format);
					}
				}
			}

			if (include_quantity) {
				var quantity =$("#" + genid + '_0_quantity').val();
				if(quantity){
					pr_name += ' ' + quantity;
				}
			}

			var product_type_id = $("#" + genid + '_0_product_type_id').val();
			var product_type = og.product_types.get_by_id(product_type_id);
			
			if(product_type && product_type.name){
				pr_name += ' ' + product_type.name;
			}

			pr_name = pr_name.trim();

			/* COMMENTED OUT: Add expense category to the name of the actual expense

			var exp_cat_dim_id = null;
			for (var i=0; i<og.dimensionPanels.length; i++) {
				if (og.dimensionPanels[i].dimensionCode == 'expense_categories') {
					exp_cat_dim_id = og.dimensionPanels[i].dimensionId;
					break;
				}
			}
			var exp_cat_name = '';
			if (exp_cat_dim_id && member_selector[genid].sel_context[exp_cat_dim_id] && member_selector[genid].sel_context[exp_cat_dim_id].length > 0) {
				var exp_cat_member_id = member_selector[genid].sel_context[exp_cat_dim_id][0];
				if (exp_cat_member_id > 0) {
					exp_cat_name = og.contextManager.getMemberName(exp_cat_dim_id, exp_cat_member_id);
				}
			}
			
			if (exp_cat_name != '') {
				pr_name += (pr_name == '' ? '' : ' - ') + exp_cat_name;
			}*/

			if (pr_name != '') {
				$("#" + genid + "payment_receipt_name").val(pr_name);
			}
		}
	},
	
	actual_expenses_bulk_actions: {
		pending: function(panel_id) {
			var params = og.expenses2.get_actual_expenses_grid_params(panel_id);
	        og.openLink(og.getUrl('expenses_approval', 'put_pending_actual_expenses', params), {preventPanelLoad: true});
		},
		lock: function(panel_id) {
			var params = og.expenses2.get_actual_expenses_grid_params(panel_id);
	        og.openLink(og.getUrl('expenses_approval', 'lock_actual_expenses', params), {preventPanelLoad: true});
		},
		approve: function(panel_id) {
			var params = og.expenses2.get_actual_expenses_grid_params(panel_id);
	        og.openLink(og.getUrl('expenses_approval', 'approve_actual_expenses', params), {preventPanelLoad: true});
		},
		invoice: function(panel_id) {
			var params = og.expenses2.get_actual_expenses_grid_params(panel_id);
	        og.openLink(og.getUrl('expenses_approval', 'invoice_actual_expenses', params), {preventPanelLoad: true});
		},
		process: function(panel_id) {
			var params = og.expenses2.get_actual_expenses_grid_params(panel_id);
	        og.openLink(og.getUrl('expenses_approval', 'process_actual_expenses', params), {preventPanelLoad: true});
		},
		review: function(panel_id) {
			var params = og.expenses2.get_actual_expenses_grid_params(panel_id);
	        og.openLink(og.getUrl('expenses_approval', 'put_under_review_actual_expenses', params), {preventPanelLoad: true});
		}
	},
	
	get_actual_expenses_grid_params: function(panel_id) {
		var ids = [];

        var grid = Ext.getCmp(panel_id);
        if (grid) {
            ids = grid.getSelectedIds();
        }
        
        var params = {
			req_channel: 'actual expense list - bulk actions'
		};
        
        if (ids.length > 0) {
        	params.expense_ids = ids;
        } else {
        	params.all_expenses = true;
        	if (grid) {
        		Ext.apply(params, grid.store_params);
        	}
        }
        
        return params;
	},

	on_expense_type_change: function(genid) {
		var sel_value = $("#" + genid + 'expense_type').val();
		var display_deposit_date =  $("#" + genid + 'display_deposit_date').val() == '1';
		if(display_deposit_date) {
			var deposit_day_cp = $("#" + genid + 'deposit_day_cp').val();
		}
		var suppliers_dim_id = og.suppliers_dimension_id;

		var payment_method_cp = $("#" + genid + 'payment_method_cp').val();
		var payment_account_cp = $("#" + genid + 'payment_account_cp').val();

		$("#" + genid + '-container-cp' + payment_method_cp).hide();
		$("#" + genid + '-container-cp' + payment_account_cp).hide();
	
		if (sel_value == 'reimbursable') {
	
			$("#" + genid + 'paid_by_container').show();
			$("#" + genid + 'submit-edit-form .due-date-col').hide();
			$("#" + genid + 'terms_container').show();
			$("#" + genid + 'actual_expense_payments').parent().show();
			if (suppliers_dim_id > 0) {
				$("#" + genid + '-member-chooser-panel-'+suppliers_dim_id+'-container').closest(".dimension-selector-container").show();
			}
			if(display_deposit_date) {
				$("#" + genid + '-container-cp' + deposit_day_cp).show();
			}
	
		} else if (sel_value == 'direct_to_vendor') {
	
			$("#" + genid + 'paid_by_container').hide();
			$("#" + genid + 'submit-edit-form .due-date-col').show();
			$("#" + genid + 'terms_container').show();
			$("#" + genid + 'actual_expense_payments').parent().show();
			if (suppliers_dim_id > 0) {
				$("#" + genid + '-member-chooser-panel-'+suppliers_dim_id+'-container').closest(".dimension-selector-container").show();
			}
			if(display_deposit_date) {
				$("#" + genid + '-container-cp' + deposit_day_cp).hide();
			}
	
		} else if (sel_value == 'rental_consumable') {

			$("#" + genid + 'paid_by_container').show();
			$("#" + genid + 'submit-edit-form .due-date-col').hide();
			$("#" + genid + 'terms_container').hide();
			$("#" + genid + 'actual_expense_payments').parent().hide();
			if (suppliers_dim_id > 0) {
				$("#" + genid + '-member-chooser-panel-'+suppliers_dim_id+'-container').closest(".dimension-selector-container").hide();
			}
			if(display_deposit_date) {
				$("#" + genid + '-container-cp' + deposit_day_cp).hide();
			}
			
		} else if (sel_value == 'field_lab_testing') {

			$("#" + genid + 'paid_by_container').show();
			$("#" + genid + 'submit-edit-form .due-date-col').hide();
			$("#" + genid + 'terms_container').hide();
			$("#" + genid + 'actual_expense_payments').parent().hide();
			if (suppliers_dim_id > 0) {
				$("#" + genid + '-member-chooser-panel-'+suppliers_dim_id+'-container').closest(".dimension-selector-container").hide();
			}
			if(display_deposit_date) {
				$("#" + genid + '-container-cp' + deposit_day_cp).hide();
			}
			
		} else if (sel_value == 'credit_card_purchase') {
			if (suppliers_dim_id > 0) {
				$("#" + genid + '-member-chooser-panel-'+suppliers_dim_id+'-container').closest(".dimension-selector-container").show();
			}
			if(display_deposit_date) {
				$("#" + genid + '-container-cp' + deposit_day_cp).hide();
			}

			$("#" + genid + '-container-cp' + payment_method_cp).show();
			$("#" + genid + '-container-cp' + payment_account_cp).show();

		}
	},

	// stores the last unit price for an expense and product type
	storeLastExpenseLinePrice: function(genid, line, product_type_id, unit) {
		if (!og.expenses2.last_expense_line_price) og.expenses2.last_expense_line_price = {};
		if (!og.expenses2.last_expense_line_price[genid]) og.expenses2.last_expense_line_price[genid] = {};
		
		og.expenses2.last_expense_line_price[genid][line] = {};
		og.expenses2.last_expense_line_price[genid][line][product_type_id] = unit;
	},

	// recovers last unit price of an expense using the selected product type
	recoverLastExpenseLinePrice: function(genid, line, product_type_id) {

		var use_product_type = true;

		// search the last unit price of the given product type
		if (og.expenses2.last_expense_line_price[genid] && og.expenses2.last_expense_line_price[genid][line]) {
			var last_price = og.expenses2.last_expense_line_price[genid][line][product_type_id];
			if (last_price) {
				// recover unit price
				$('#'+genid+"_"+line+"_unit_price").val(last_price);
				
				// update total
				og.expenses2.updateItemTotals(genid, line);

				delete(og.expenses2.last_expense_line_price[genid][line]);

				use_product_type = false;
			}
		}

		// if unit price was not found in the local variable, then use the price of the selected product type
		if (use_product_type) {
			var product_type = og.product_types.get_by_id(product_type_id);
			if (product_type) {
				if (product_type.uses_price_multiplier) {
					var unit_cost = $('#'+genid+"_"+line+"_unit_cost").val();
					var unit_price = unit_cost * product_type.price_multiplier;
				} else {
					var unit_price = product_type.hourly_rate;
				}
				$("#" + genid + '_' + line + '_unit_price').val(og.format_money_amount(unit_price, og.expenses2.amount_decimals));
				og.expenses2.updateItemTotalPrice(genid, line);
			}
		}

	},

	onExpenseBillableChange: function(genid, obj){
		
		var product_type_id = $('#'+genid+"_0_product_type_id").val();
		
		if(obj.value == 0){ // NOT billable

			$('#'+genid+"_0_unit_price").addClass('nonbillable');

			var current_unit_price = $('#'+genid+"_0_unit_price").val();
			
			// save the unit price before deleting it
			og.expenses2.storeLastExpenseLinePrice(genid, 0, product_type_id, current_unit_price);
			
			// Sets values to zero
			$('#'+genid+"_0_unit_price").val(0);
			$('#'+genid+"_0_total_price").val(0);

			// Readonly
			og.expenses2.enableDisableExpenseLinePrices(genid, 0, false);

		}else{ // Billable

			$('#'+genid+"_0_unit_price").removeClass('nonbillable');

			// set previous price for the product if available
			og.expenses2.recoverLastExpenseLinePrice(genid, 0, product_type_id);

			// Removes readonly
			og.expenses2.enableDisableExpenseLinePrices(genid, 0, true);
		}
	},

	// enables or disables the fields unit price and total price of an expense/expense line
	enableDisableExpenseLinePrices: function (genid, line, enable) {
		if (enable) {
			$('#'+genid+"_"+line+"_unit_price").prop('disabled', false);
			$('#'+genid+"_"+line+"_total_price").prop('disabled', false);
		} else {
			$('#'+genid+"_"+line+"_unit_price").prop('disabled', true);
			$('#'+genid+"_"+line+"_total_price").prop('disabled', true);
		}
	},
	
	/**********************************************************************************
	 * QUICK ADD ROW FUNCTIONS
	 **********************************************************************************/

	add_expenses_module_quick_add_row : function(grid, config) {

		if (!config) config = grid.initialConfig;
		if (!config) return;
	
		if (!config.genid) config.genid = Ext.id();
	
		let record_config = {
			id: 'quick_add_row',
		};

		let expense_cat_dim_id = 0;
		for (did in og.dimensions_info) {
			if (!isNaN(did) && og.dimensions_info[did].code == "expense_categories") {
				expense_cat_dim_id = did;
			}
		}


		var first_input_column = null;
		var focusable_columns = ['description', 'expense_id', 'product_type_name', 'expense_type', 'paid_by_id', 'quantity', 'unit_cost', 'unit_price'];
		for (var i=0; i<grid.colModel.config.length; i++) {
			var col_conf = grid.colModel.config[i];
			if (focusable_columns.indexOf(col_conf.id) >= 0) {
				first_input_column = col_conf.id;
				break;
			}
		}
		
		
		// dimension selector containers
		for (var i=0; i<grid.colModel.config.length; i++) {
			var col_conf = grid.colModel.config[i];
			if (col_conf.id.indexOf('dim_') == 0) {
				var dim_id = col_conf.id.substring(4);
				record_config[col_conf.id] = '<span id="'+ config.genid + 'members_' + dim_id +'"></span>';
			}
		}
	

		var expense_types = [];
		for (var i=0; i<og.expenses2.actual_expense_types.length; i++) {
			expense_types.push([
				og.expenses2.actual_expense_types[i], lang(og.expenses2.actual_expense_types[i])
			]);
		}

		var user_options = grid.filters.pr_user_filter.options;

		
		// name and description inputs
	//	record_config.name = og.expenses2.renderBasicInput(config.genid, 'name');
		record_config.description = og.expenses2.renderBasicInput(config.genid, 'description');
		
		// associated budgeted expense
		record_config.expense_name = og.expenses2.renderSelectorFields(config.genid, 'expense_id');
		// actual expense type
		record_config.expense_type = og.expenses2.renderSelectorFields(config.genid, 'expense_type');
		// task id
		record_config.task_id = og.expenses2.renderSelectorFields(config.genid, 'task_id');
		// employee
		record_config.paid_by_name = og.expenses2.renderSelectorFields(config.genid, 'paid_by_id');
		// product type
		record_config.product_type_name = og.expenses2.renderSelectorFields(config.genid, 'product_type_id');
		// is billable
		//record_config.is_billable = og.expenses2.renderBooleanField(config.genid, 'is_billable', true);
		record_config.is_billable = og.expenses2.renderSelectorFields(config.genid, 'is_billable');
		// date
		record_config.date = og.expenses2.renderDateSelector(config.genid, 'date');

		// receipt document
		record_config.document_id = og.expenses2.renderDocumentSelector(config.genid, 'document_id');

		// amount inputs
		record_config.quantity = og.expenses2.renderNumericInput(config.genid, 'quantity');
		record_config.unit_cost = og.expenses2.renderNumericInput(config.genid, 'unit_cost');
		record_config.unit_price = og.expenses2.renderNumericInput(config.genid, 'unit_price');
		record_config.amount = og.expenses2.renderDisableInput(config.genid, 'amount', "number");
		record_config.total_price = og.expenses2.renderDisableInput(config.genid, 'total_price', "number");

		// actions column
		record_config.actions = og.expenses2.renderActions(config.genid, grid, first_input_column);

		
		// custom properties
		/////render the custom properties for payment_receipt
		if (og.custom_properties_by_type.payment_receipt) {
			for (var i=0; i<og.custom_properties_by_type.payment_receipt.length; i++) {
				var cp = og.custom_properties_by_type.payment_receipt[i];
				var cp_input_html = '';
				if (cp.cp_type == 'text') {
					cp_input_html = og.expenses2.renderBasicInput(config.genid, 'cp_' + cp.id);
				} else if (cp.cp_type == 'numeric') {
					cp_input_html = og.expenses2.renderNumericInput(config.genid, 'cp_' + cp.id);
				} else if (cp.cp_type == 'date' || cp.type == 'datetime') {
					cp_input_html = og.expenses2.renderDateSelector(config.genid, 'cp_' + cp.id);
				} else if (cp.cp_type == 'boolean') {
					//cp_input_html = og.expenses2.renderBooleanField(config.genid, 'cp_' + cp.id);
					cp_input_html = og.expenses2.renderSelectorFields(config.genid, 'cp_' + cp.id);
				}else if (cp.cp_type == 'list') {//render list types
					//cp_input_html = og.expenses2.renderBooleanField(config.genid, 'cp_' + cp.id);
					cp_input_html = og.expenses2.renderSelectorFields(config.genid, 'cp_' + cp.id);
				}

				record_config['cp_' + cp.id] = cp_input_html;
			}
		}

	
		// insert row in the grid
		var record = new Ext.data.Record(record_config, 'quick_add_row');
		grid.store.insert(0, record);
		
		// var to keep the extjs component of the inputs
		og.expenses2.quick_add_row_selectors = [];
	
		// remove checkbox and add background
		var add_row = grid.getView().getRow(0);
		$(add_row).find('.x-grid3-row-checker').removeClass('x-grid3-row-checker');
		$(add_row).addClass('quick-add-row');
		$(add_row).addClass('expenses');
	
		// prevent focus in the td element, we only have to focus in the inputs
		$("#" + grid.id + " .quick-add-row td").attr("tabindex", -1);


		// date selector
		og.expenses2.quick_add_row_selectors.date_picker = og.quick_add_row_date_input({
			id: config.genid + 'date',
			name: "payment_receipt[date]",
			renderTo: config.genid + "date_container",
			value: new Date()
		});


		// user selector
		og.expenses2.quick_add_row_selectors.user_combo = og.quick_add_row_combo_input({
			id: config.genid + 'paid_by_id',
			genid: config.genid,
			name: "payment_receipt[paid_by_id]",
			options: user_options,
			width: 120,
			initial_val: og.loggedUser.id,
			renderTo: config.genid + 'paid_by_id_container',
		//	listeners: user_combo_listeners
		});

		// billable selector
		og.expenses2.quick_add_row_selectors.is_billable = og.quick_add_row_combo_input({
			id: config.genid + 'is_billable',
			genid: config.genid,
			name: "payment_receipt[is_billable]",
			options: [[0, lang('no')], [1, lang('yes')]],
			width: 50,
			initial_val: 1,
			renderTo: config.genid + 'is_billable_container',
		});

		let set_payment_method_available = {
			'select': og.expenses2.set_payment_method_available
		}

		// expense type selector
		og.expenses2.quick_add_row_selectors.exp_type_combo = og.quick_add_row_combo_input({
			id: config.genid + 'expense_type',
			genid: config.genid,
			name: "payment_receipt[expense_type]",
			options: expense_types,
			width: 150,
			initial_val: 'reimbursable',
			renderTo: config.genid + 'expense_type_container',
			listeners: set_payment_method_available
		});

		// Task selector
		og.expenses2.quick_add_row_selectors.task_combo = og.quick_add_row_combo_input({
			id: config.genid + 'task_id',
			genid: config.genid,
			name: "payment_receipt[task_id]",
			options: [],
			width: 200,
			renderTo: config.genid + 'task_id_container',
		});

		// get the filtered tasks using selected members
		og.expenses2.load_quick_add_row_tasks();


	
		// budgeted expense selector
		og.expenses2.quick_add_row_selectors.budgeted_expense_combo = og.quick_add_row_combo_input({
			id: config.genid + 'expense_id',
			genid: config.genid,
			name: "payment_receipt[expense_id]",
			options: [],
			width: 200,
			renderTo: config.genid + 'expense_id_container',
		});

		// get the filtered product types using selected members
		og.expenses2.load_quick_add_row_budgeted_expenses();

		// on budgeted expense select
		// - reorganize the product type selector and autocomplete if possible
		og.expenses2.quick_add_row_selectors.budgeted_expense_combo.on('select', function() {
			og.expenses2.quick_add_row_fill_inputs_using_budgeted_expense(config, this.getValue());
		});

	
		// product type type selector
		og.expenses2.quick_add_row_selectors.prod_type_combo = og.quick_add_row_combo_input({
			id: config.genid + 'product_type_id',
			genid: config.genid,
			name: "payment_receipt[product_type_id]",
			options: [],
			width: 200,
			renderTo: config.genid + 'product_type_id_container',
		});

		// get the filtered product types using selected members
		og.expenses2.load_quick_add_row_product_types();

		// on product type select
		// - set dimension selectors with the member values of the product type (rate sch, exp cat)
		// - set unit cost and unit price, calculate total cost and total price
		og.expenses2.quick_add_row_selectors.prod_type_combo.on('select', function() {

			og.expenses2.quick_add_row_fill_inputs_using_product_type(config, this.getValue());

			// return the dropdown to the original state, without filters, so any value can be selected
			if (og.expenses2.quick_add_row_selectors.prod_type_combo.store.isFiltered()) {
				og.expenses2.quick_add_row_selectors.prod_type_combo.store.filter('text','');
			}

		});


		// change events to update totals when modifying quantity, unit cost or unit price
		$("#" + config.genid + "quantity").change(function() {
			og.expenses2.update_quick_add_totals(config.genid);
		});
		$("#" + config.genid + "unit_cost").change(function() {
			og.expenses2.update_quick_add_unit_price(config.genid);
			og.expenses2.update_quick_add_totals(config.genid);
		});
		$("#" + config.genid + "unit_price").change(function() {
			og.expenses2.update_quick_add_totals(config.genid);
		});


		// upload receipt image to tmp dir after selecting
		$("#" + config.genid + "document_id_file_input").change(function() {
			og.upload_tmp_file_content(config.genid, config.genid + 'document_id_file_input', 'document_id_file_input', config.genid + 'document_id', og.expenses2.quick_add_update_document_input_status);
		});
		$("#" + config.genid + "document_id_status").click(function() {
			$("#" + config.genid + 'document_id').val("");
			$("#" + config.genid + 'document_id_file_input').val("").show();
			$(this).hide();
		});
	
		// render dimension member selectors
		for (var i=0; i<grid.colModel.config.length; i++) {
			var col_conf = grid.colModel.config[i];
			if (col_conf.id.indexOf('dim_') == 0) {
				var dim_id = col_conf.id.substring(4);

				// after changing exepnse category selector we must filter the product types selector
				var onselect = null;
				if (dim_id == expense_cat_dim_id) {
					onselect = og.expenses2.filter_product_type_combo;
				}
				
				dim_sel = new og.SimpleMemberSelector({
					dimensionId: dim_id,
					genid: config.genid,
					renderTo: config.genid + 'members_' + dim_id,
					width: grid.colModel.getColumnWidth(i) - 14,
					select_current_context: true,
					onselect_fn: onselect
				});
			}
		}

		
		// custom properties complex selectors
		//add quick row selectors for payment_receipt
		if (og.custom_properties_by_type.payment_receipt) {
			for (var i=0; i<og.custom_properties_by_type.payment_receipt.length; i++) {
				var cp = og.custom_properties_by_type.payment_receipt[i];

				if (cp.cp_type == 'date' || cp.cp_type == 'datetime') {
					og.expenses2.quick_add_row_selectors['cp_'+cp.id] = og.quick_add_row_date_input({
						id: config.genid + "cp_" + cp.id,
						name: "payment_receipt[cp_" + cp.id + "]",
						renderTo: config.genid + "cp_" + cp.id + "_container",
					//	value: new Date()
					});
				} else if (cp.cp_type == 'boolean') {
					//og.expenses2.renderBooleanField(config.genid, 'cp_' + cp.id);
					og.expenses2.quick_add_row_selectors['cp_'+cp.id] = og.quick_add_row_combo_input({
						id: config.genid + 'cp_' + cp.id,
						genid: config.genid,
						name: "payment_receipt[cp_" + cp.id + "]",
						options: [[0, ''],[-1, lang('no')],[1, lang('yes')]],
						width: 50,
						initial_val: cp.cp_default_value,
						renderTo: config.genid + 'cp_' + cp.id + '_container',
					});
				} else if (cp.cp_type == 'list') {

					var cp_values = cp.cp_values.split(',');
					let cp_value=[];
					//let cp_value_str='';	
					for(var ii=0;ii<cp_values.length;ii++){
						cp_value[ii] = cp_values[ii].split('@');
					}
					//og.expenses2.renderBooleanField(config.genid, 'cp_' + cp.id);
					og.expenses2.quick_add_row_selectors['cp_'+cp.id] = og.quick_add_row_combo_input({
						id: config.genid + 'cp_' + cp.id,
						genid: config.genid,
						name: "payment_receipt[cp_" + cp.id + "]",
						options: cp_value,
						width: 130,
						initial_val: cp.cp_default_value,
						renderTo: config.genid + 'cp_' + cp.id + '_container',
					});

					let cmp = Ext.getCmp(config.genid + 'cp_' + cp.id);
					if (cmp) cmp.disable();
				}


				$("#" + config.genid + "cp_" + cp.id).addClass('custom-property');
			}
		}

	
		// listen to the scroll event of the grid contents, so we can fix the position 
		// of the expanded member selectors lists
		og.quick_add_row_event_to_fix_mem_selector_position(grid);

		setTimeout(function() {
			// remember some inputs
			og.expenses2.fill_quick_add_row_inputs_to_remember(grid)
			
			// focus on first input field
			if (!config.dont_focus_in_first_input) {
				og.expenses2.quick_add_focus_in_first_input(grid, first_input_column);
			}
		},1000);

		// focus on first input after reaching the 'add' button
		$("#"+ config.genid +"expenses_quick_add_btn").blur(function() {
			og.expenses2.quick_add_focus_in_first_input(grid, first_input_column);
		})

		// fix input focus when clicking it, extjs is doing something that prevents it
		$("#" + grid.id + " .quick-add-row input").click(function() {
			$(this).focus();
		});
	
	},

	quick_add_update_document_input_status: function(genid, file_input_id, hf_id) {
		
		if ($("#" + file_input_id).val() != '') {
			$("#" + genid + "document_id_status").show();
			$("#" + file_input_id).hide();

			if (window.FileReader) {
				var fr = new FileReader();
				fr.readAsDataURL(document.getElementById(file_input_id).files[0]);
				fr.finput_id = file_input_id;
	
				fr.onload = function (fevent) {
					var file_full_name = $("#"+file_input_id).val();
					if (file_full_name) {
						var start_index = (file_full_name.indexOf('\\') >= 0 ? file_full_name.lastIndexOf('\\') : file_full_name.lastIndexOf('/'));
						var filename = file_full_name.substring(start_index);
						if (filename.indexOf('\\') === 0 || filename.indexOf('/') === 0) {
							filename = filename.substring(1);
						}
						$("#"+genid+"document_id_status").html(filename);
					}
				}
			}

		} else {
			$("#" + genid + "document_id_status").hide();
			$("#" + file_input_id).show();
		}
	},

	quick_add_focus_in_first_input: function(grid, first_input_column) {

		var col_id = first_input_column;
		if (first_input_column == 'product_type_name') {
			col_id = first_input_column.replace('_name', '_id');
		}
		
		$("#" + grid.id + " .quick-add-row #" + grid.genid + col_id).focus();
	},


	quick_add_row_fill_member_selector: function(config, dim_id, mem_id) {

		if (og.dimensions && og.dimensions[dim_id] && og.dimensions[dim_id][mem_id]) {
			// if member data already in cache -> use it and select the member
			member_selector.add_relation(dim_id, config.genid, mem_id);
		} else {
			// go to server and get the member data and then select the member
			og.getMemberFromServer(mem_id, og.expenses2.member_selector_add_relation, {dimension_id: dim_id, member_id: mem_id, genid: config.genid});
		}
		$("#"+config.genid+"-member-chooser-panel-"+dim_id+"-tree-current-selected .empty-text").hide();
	},

	load_quick_add_row_tasks: function () {
		og.openLink(og.getUrl('expense', 'get_tasks_in_context', {context: og.contextManager.plainContext()}), {
			callback: function(success, data) {
				
				if (!data || !data.tasks) return;
				og.expenses2.filtered_tasks = data.tasks;

				var task_store = [[0,'--']];
				for (var i=0; i<data.tasks.length; i++) {
					task_store.push([
						data.tasks[i].id, data.tasks[i].name
					]);
				}

				og.expenses2.quick_add_row_selectors.task_combo.store.loadData(task_store);
			}
		});
	},



	load_quick_add_row_budgeted_expenses: function () {
		
		var sel_members = og.contextManager.getSelectedMembers();

		og.openLink(og.getUrl('expense', 'get_expenses_in_context', {context: og.contextManager.plainContext()}), {
			callback: function(success, data) {
				
				if (!data || !data.expenses) return;
				og.expenses2.filtered_budgeted_expenses = data.expenses;

				var exp_store = [[0,'--']];
				for (var i=0; i<data.expenses.length; i++) {
					exp_store.push([
						data.expenses[i].object_id, data.expenses[i].name
					]);
				}

				og.expenses2.quick_add_row_selectors.budgeted_expense_combo.store.loadData(exp_store);
				
			}
		});
	},

	quick_add_row_fill_inputs_using_budgeted_expense: function (config, expense_id) {
		
		var expense = null;

		if (!og.expenses2.filtered_budgeted_expenses) og.expenses2.filtered_budgeted_expenses = [];
		
		// get the expense
		for (var i=0; i<og.expenses2.filtered_budgeted_expenses.length; i++) {
			if (og.expenses2.filtered_budgeted_expenses[i].object_id == expense_id) {
				expense = og.expenses2.filtered_budgeted_expenses[i];
				break;
			}
		}
		
		if (expense) {
			
			// reorganize prod type selector to put expense's prod types first
			og.expenses2.update_quick_add_row_product_types_store(expense);
			
			// if has only one product type then SELECT IT and trigger the autocomplete using product type function
			if (expense.items.length == 1) {

				// get the expense item and its product type
				var exp_item = expense.items[0];
				var pt_id = exp_item.product_type_id;
				
				// select the product type and trigger the autofill of inputs
				og.expenses2.quick_add_row_selectors.prod_type_combo.setValue(pt_id);
				og.expenses2.quick_add_row_fill_inputs_using_product_type(config, pt_id, expense);

			}

			// copy classification of the budgeted expense to member selectors that are empty
			var be_members = Ext.util.JSON.decode(expense.memPath);
			for (dim_id in be_members) {
				// the members are grouped in 2 levels: by dimension and object type
				for (ot_id in be_members[dim_id]) {
					if (isNaN(ot_id)) continue;

					for (k in be_members[dim_id][ot_id]) {
						if (isNaN(k)) continue;
						var mem_id = be_members[dim_id][ot_id][k];

						if (og.simple_member_selectors[config.genid] && og.simple_member_selectors[config.genid][dim_id]) {
							var selector = og.simple_member_selectors[config.genid][dim_id];
							selector.selectMember(mem_id);
						}
					}
				}
			}

		} else {
			// plain product type selector
			og.expenses2.update_quick_add_row_product_types_store();
		}
	},


	update_quick_add_row_product_types_store: function(expense) {

		if (expense) {
			// get the expense prod types to put them in the first positions of the product type selector
			var expense_prod_type_ids = [];
			for (var i=0; i<expense.items.length; i++) {
				var pt_id = expense.items[i].product_type_id;
				if (pt_id > 0) {
					expense_prod_type_ids.push(pt_id);

					// if prod type doesn't exist in the list then add it
					var found = false;
					for (var j=0; j<og.expenses2.filtered_product_types.length; j++) {
						if (og.expenses2.filtered_product_types[j].id == pt_id) {
							found = true;
							break;
						}
					}
					if (!found) {
						var pt = og.product_types.get_by_id(pt_id);
						if (pt) og.expenses2.filtered_product_types.push(pt);
					}
				}
			}
		}

		var prod_types = [];
		var main_prod_types = [];
		var filtered_prod_type_ids = [];
		for (var i=0; i<og.expenses2.filtered_product_types.length; i++) {

			filtered_prod_type_ids.push(og.expenses2.filtered_product_types[i].id);
			
			if (expense_prod_type_ids && expense_prod_type_ids.indexOf(og.expenses2.filtered_product_types[i].id) >= 0) {
				main_prod_types.push([
					og.expenses2.filtered_product_types[i].id, og.expenses2.filtered_product_types[i].name
				]);
			} else {
				prod_types.push([
					og.expenses2.filtered_product_types[i].id, og.expenses2.filtered_product_types[i].name
				]);
			}
		}

		var all_prod_types = [[0,'--']];
		if (main_prod_types.length > 0) {
			main_prod_types.push([0, '<div style="border-bottom: 1px solid #aaa;"></div>'])
			all_prod_types = all_prod_types.concat(main_prod_types);
		}
		all_prod_types = all_prod_types.concat(prod_types);

		og.expenses2.quick_add_row_selectors.prod_type_combo.store.loadData(all_prod_types);


		if (expense) {
			// reset prod type selector if selected prod type is not in the expense
			if (expense_prod_type_ids.indexOf(og.expenses2.quick_add_row_selectors.prod_type_combo.getValue()) == -1) {
				og.expenses2.quick_add_row_selectors.prod_type_combo.setValue(0);
			}
		}

		// if we fitered the combo and prev selected value is not in the result then unselect it
		if (filtered_prod_type_ids.indexOf(og.expenses2.quick_add_row_selectors.prod_type_combo.getValue()) == -1) {
			og.expenses2.quick_add_row_selectors.prod_type_combo.setValue(0);
		}
	},


	load_quick_add_row_product_types: function (sel_members) {
		
		if (!sel_members) {
			sel_members = og.contextManager.getSelectedMembers();
		}

		og.openLink(og.getUrl('product_type', 'get_filtered_product_types_for_payment_receipt', {member_ids: Ext.util.JSON.encode(sel_members), get_assoc_mem_ids:true}), {
			callback: function(success, data) {
				
				if (!data || !data.product_types) return;
				og.expenses2.filtered_product_types = data.product_types;

				og.expenses2.update_quick_add_row_product_types_store();
				
			}
		});
	},

	//set payment_receipt custom properties avalibale or not
	set_payment_method_available:function(){
		var expense_type = og.expenses2.quick_add_row_selectors.exp_type_combo.getValue();
		if (og.custom_properties_by_type.payment_receipt) {
			for (var i=0; i<og.custom_properties_by_type.payment_receipt.length; i++) {
				var cp = og.custom_properties_by_type.payment_receipt[i];
				if(cp.code=="quickbooks_payment_method" ||cp.code=="quickbooks_payment_account")
				{
					let cp_aux='cp_'+cp.id;
					if(og.expenses2.quick_add_row_selectors[cp_aux].id)
					{
						let cmp = Ext.getCmp(og.expenses2.quick_add_row_selectors[cp_aux].id);
						if(cmp && expense_type!='credit_card_purchase')
						{
							cmp.setValue(0);
							cmp.disable();
						}else{
							cmp.enable();
						}
					}
				}
			}
		}
	},
	

	// filters the product types selector using the selected expense category
	filter_product_type_combo: function(exp_cat_combo) {
		
		var exp_cat_id = exp_cat_combo.getValue();
		var sel_members = [];
		if (exp_cat_id > 0) {
			sel_members.push(exp_cat_id);
		}

		// filter the combo
		og.expenses2.load_quick_add_row_product_types(sel_members);

	},

	quick_add_row_fill_inputs_using_product_type: function (config, pt_id, budgeted_expense) {
		
		var pt = null;
		
		// get the product type
		for (var i=0; i<og.expenses2.filtered_product_types.length; i++) {
			if (og.expenses2.filtered_product_types[i].id == pt_id) {
				pt = og.expenses2.filtered_product_types[i];
				break;
			}
		}
		
		if (pt) {
			// set values for related dim member selectors (exp cat, rate sch, etc)
			for (dim_id in pt.members) {
				var mem_id = pt.members[dim_id];

				if (og.simple_member_selectors[config.genid] && og.simple_member_selectors[config.genid][dim_id]) {
					var selector = og.simple_member_selectors[config.genid][dim_id];
					selector.selectMember(mem_id);
				}

			}

			var unit_cost = 0;
			var unit_price = 0;
			var exp_item = null;

			// try to get the selected budgeted expense to get the expense item related to the product type selected
			if (!budgeted_expense) {
				var b_exp_id = og.expenses2.quick_add_row_selectors.budgeted_expense_combo.getValue();
				if (b_exp_id > 0) {
					for (var i=0; i<og.expenses2.filtered_budgeted_expenses.length; i++) {
						if (og.expenses2.filtered_budgeted_expenses[i].object_id == b_exp_id) {
							budgeted_expense = og.expenses2.filtered_budgeted_expenses[i];
							break;
						}
					}
				}
			}
			// if we have a selected budgeted expense then try to get the item with the same product type id, so we can use it to autocomplete the inputs
			if (budgeted_expense) {
				for (var i=0; i<budgeted_expense.items.length; i++) {
					if (budgeted_expense.items[i].product_type_id == pt_id) {
						exp_item = budgeted_expense.items[i];
						break;
					}
				}
			}

			// if we have the expense item of the selected budgeted expense then use the data in it to autocomplete the inputs
			if (exp_item) {

				unit_cost = exp_item.unit_cost;
				unit_price = exp_item.unit_price;

				$("#" + config.genid + "quantity").val(exp_item.quantity);
				$("#" + config.genid + "description").val(exp_item.description);

			} else {
				// if we don't have a budgeted expense or a defined item then use product type data to autofill amounts
				if (pt.hourly_cost > 0) {
					unit_cost = pt.hourly_cost;
				}
				if (pt.uses_price_multiplier && pt.price_multiplier > 0 && pt.hourly_cost > 0) {
					unit_price = pt.hourly_cost * pt.price_multiplier;
				} else if (pt.hourly_rate > 0) {
					unit_price = pt.hourly_rate;
				}
			}

			// update values for unit_cost and unit_price
			if (unit_cost > 0) {
				$("#" + config.genid + "unit_cost").val(og.format_money_amount(unit_cost));
			}
			if (unit_price > 0) {
				$("#" + config.genid + "unit_price").val(og.format_money_amount(unit_price));
			}


			// update totals
			og.expenses2.update_quick_add_totals(config.genid);

		}
	},

	update_quick_add_unit_price: function(genid) {
		var pt_id = og.expenses2.quick_add_row_selectors.prod_type_combo.getValue();

		if (pt_id > 0) {
			var pt = og.product_types.get_by_id(pt_id);
			if (pt && pt.uses_price_multiplier && pt.price_multiplier > 0) {
				var unit_cost = $("#" + genid + "unit_cost").val();
				unit_cost = og.clean_thousand_separator(unit_cost);

				var unit_price = unit_cost * pt.price_multiplier;
				$("#" + genid + "unit_price").val(og.format_money_amount(unit_price));
			}
		}
	},

	update_quick_add_totals: function(genid) {

		var quantity = $("#" + genid + "quantity").val();
		var unit_cost = $("#" + genid + "unit_cost").val();
		var unit_price = $("#" + genid + "unit_price").val();

		quantity = og.clean_thousand_separator(quantity);
		unit_cost = og.clean_thousand_separator(unit_cost);
		unit_price = og.clean_thousand_separator(unit_price);

		if (isNaN(quantity)) quantity = 0;
		if (isNaN(unit_cost)) unit_cost = 0;
		if (isNaN(unit_price)) unit_price = 0;
		
		$("#" + genid + "amount").val(og.format_money_amount(quantity * unit_cost));
		$("#" + genid + "total_price").val(og.format_money_amount(quantity * unit_price));

	},

	member_selector_add_relation: function(ignored1, ignored2, data) {
		member_selector.add_relation(data.dimension_id, data.genid, data.member_id);
	},

	quick_add_submit: function(grid_id, first_input_column) {
		var grid = Ext.getCmp(grid_id);

		// get actual expense params
		var form_params = og.expenses2.get_quick_add_params(grid);

		// remember last user input
		grid.quick_add_last_params = form_params;
			
		// submit actual expense
		og.openLink(og.getUrl('payment_receipt','add'),{
			post: form_params,
			preventPanelLoad: true,
			callback: function(success, data) {
				if (success && data.payment_receipt) {
					data.payment_receipt.type = 'payment_receipt';
					var record = new Ext.data.Record(data.payment_receipt, data.payment_receipt.id);
					
					// clear inputs
					og.expenses2.clear_quick_add_row_inputs(grid);
					
					// add new actual expense to the top of the grid
					grid.store.insert(1, record);
	
					og.eventManager.fireEvent('replace all empty breadcrumb', null);

					// focus on first input again
					setTimeout(function() {
						og.expenses2.quick_add_focus_in_first_input(grid, first_input_column);
					}, 200);
				
					// reload totals row if needed
				//	grid.reloadTotalsRow();
				}
			}
		});
	},

	get_quick_add_params: function(grid) {
		var params = {'dont_reload': true, 'members': '[]'};
		var add_row = grid.getView().getRow(0);
		var member_ids = [];
	
		$(add_row).find('input, select').each(function() {
			if ($(this).attr('name').indexOf('members_input_') == 0) {
				//var mem_ids = Ext.util.JSON.decode($(this).val());
				//member_ids = member_ids.concat(mem_ids);
			} else {
				params[$(this).attr('name')] = $(this).val();
			}
		});
		
		for (did in og.simple_member_selectors[grid.genid]) {
			var mem_selector = og.simple_member_selectors[grid.genid][did];
			if (mem_selector) {
				var mem_id = mem_selector.getValue();
				if (mem_id > 0) {
					member_ids.push(mem_id);
				}
			}
		}
		if (member_ids.length > 0) {
			params['members'] = Ext.util.JSON.encode(member_ids);
		}
	
		var cmp = null;

		cmp = Ext.getCmp(grid.genid + 'paid_by_id');
		if (cmp) params['payment_receipt[paid_by_id]'] = cmp.getValue();

		cmp = Ext.getCmp(grid.genid + 'expense_id');
		if (cmp) params['payment_receipt[expense_id]'] = cmp.getValue();

		cmp = Ext.getCmp(grid.genid + 'task_id');
		if (cmp) params['payment_receipt[task_id]'] = cmp.getValue();

		cmp = Ext.getCmp(grid.genid + 'product_type_id');
		if (cmp) params['payment_receipt[product_type_id]'] = cmp.getValue();

		cmp = Ext.getCmp(grid.genid + 'expense_type');
		if (cmp) params['payment_receipt[expense_type]'] = cmp.getValue();

		cmp = Ext.getCmp(grid.genid + 'is_billable');
		if (cmp) params['payment_receipt[is_billable]'] = cmp.getValue();

		if (og.custom_properties_by_type.payment_receipt) {
			for (var i=0; i<og.custom_properties_by_type.payment_receipt.length; i++) {
				var cp = og.custom_properties_by_type.payment_receipt[i];

				if (cp.cp_type == 'boolean') {
					cmp = Ext.getCmp(grid.genid + 'cp_' + cp.id);
					params['object_custom_properties['+ cp.id +']'] = cmp.getValue();
				} if (cp.cp_type == 'list') {
					cmp = Ext.getCmp(grid.genid + 'cp_' + cp.id);
					params['object_custom_properties['+ cp.id +']'] = cmp.getValue();
				} else {
					var input_id = grid.genid + "cp_" + cp.id;
					params['object_custom_properties['+ cp.id +']'] = $("#" + input_id).val();
				}
			}
		}
	
		return params;
	},


	clear_quick_add_row_inputs: function(grid) {

		var genid = grid.genid;

		// regual fields to reset
		$("#" + genid + 'quantity').val('');
		$("#" + genid + 'unit_cost').val('');
		$("#" + genid + 'unit_price').val('');
		$("#" + genid + 'amount').val('');
		$("#" + genid + 'total_price').val('');
		$("#" + genid + 'description').val('');
		$("#" + genid + 'document_id').val('');
		$("#" + genid + 'document_id_file_input').val('');
		$("#" + genid + "document_id_status").hide();
		og.expenses2.quick_add_row_selectors.task_combo.setValue(0);

		// if we selected a budgeted expense then reset the prod type combo and trigger the autocompletion again
		// if not then remember prod type
		var expenses_combo = og.expenses2.quick_add_row_selectors.budgeted_expense_combo;
		if (expenses_combo.getValue() > 0) {
			// clear product type combo
			og.expenses2.quick_add_row_selectors.prod_type_combo.setValue(0);
	
			// the expense is remembered so we trigger the autofill to fill prod type and amounts if the expense has only one
			// if expense has more than one then the prod selector is reseted and the user has to choose one
			og.expenses2.quick_add_row_fill_inputs_using_budgeted_expense(config, expenses_combo.getValue());

		} else {
			// remember prod type and trigger autofill of inputs
			og.expenses2.quick_add_row_fill_inputs_using_product_type(config, og.expenses2.quick_add_row_selectors.prod_type_combo.getValue());
		}

		// clear all custom properties
		if (og.custom_properties_by_type.payment_receipt) {
			for (var i=0; i<og.custom_properties_by_type.payment_receipt.length; i++) {
				var cp = og.custom_properties_by_type.payment_receipt[i];
				
				if (cp.cp_type == 'boolean') {
					cmp = Ext.getCmp(grid.genid + 'cp_' + cp.id);
					if (cmp) cmp.setValue(cp.cp_default_value);
				} else {
					$("#" + genid + 'cp_' + cp.id ).val(cp.cp_default_value);
				}
			}
		}

	},

	quick_add_row_inputs_remember: ['product_type_id', 'expense_type', 'paid_by_id', 'date'],

	fill_quick_add_row_inputs_to_remember: function(grid) {

		if (!grid.quick_add_last_params) return;

		for (var i=0; i<og.expenses2.quick_add_row_inputs_remember.length; i++) {
			var field = og.expenses2.quick_add_row_inputs_remember[i];
			var key = 'payment_receipt[' + field + ']';

			// autoselect product type only if NO budgeted expense was selected in the previous request 
			// (if they selected the product by hand)
			if (field == 'product_type_id' && grid.quick_add_last_params['payment_receipt[expense_id]'] > 0) {
				continue;
			}

			if (grid.quick_add_last_params[key]) {
				var input_val = grid.quick_add_last_params[key];

				var cmp = Ext.getCmp(grid.genid + field);
				if (cmp) {
					cmp.setValue(input_val);
				}
			}
		}

		// if product type was selected -> trigger the autocompletion of amounts, use a timeout to wait the member selectors to load
		var cmp = Ext.getCmp(grid.genid + 'product_type_id');
		if (cmp && cmp.getValue() > 0) {
			setTimeout(function() {
				og.expenses2.quick_add_row_fill_inputs_using_product_type(config, cmp.getValue());
			},2000);
		}

	},


	renderBasicInput: (genid, input_id) => {
		return `<div class="">
			<input class="exp-quick-add-input-text" type="text" placeholder="" value="" name="payment_receipt[`+ input_id+`]" id="`+ genid + input_id+`" data-tabgroup="quick-add-row-tabgroup" />
		</div>`;
	},

	renderNumericInput: (genid, input_id) => {
		return `<div class="">
			<input class="exp-quick-add-input-number" type="text" placeholder="" value="" name="payment_receipt[`+ input_id+`]" id="`+ genid + input_id+`" data-tabgroup="quick-add-row-tabgroup" />
		</div>`;
	},

	renderSelectorFields: (genid, input_id) => {
		return `<div class="" id="`+ genid + input_id +`_container"></div>`;
	},

	renderDisableInput: (genid, input_id, type) => {
		if (!type) type='text';
		return `<div class="">
			<input class="exp-quick-add-input-`+type+` exp-quick-add-input-disabled" type="text" placeholder="" value="" name="payment_receipt[`+ input_id+`]" id="`+ genid + input_id+`" data-tabgroup="quick-add-row-tabgroup" disabled />
		</div>`;
	},
	renderBooleanField: (genid, input_id, checked) => {
		return `<div class="">
			<select class="exp-quick-add-input-boolean" type="checkbox" name="payment_receipt[`+ input_id+`]" id="`+ genid + input_id+`" data-tabgroup="quick-add-row-tabgroup">
				<option value="0" `+ (checked ? '' : 'selected="selected"') +`>No</option>
				<option value="1" `+ (checked ? 'selected="selected"' : '') +`>Yes</option>
			</select>
		</div>`;
		return `<div class="">
			<input class="exp-quick-add-input-boolean" type="checkbox" `+(checked ? 'checked="checked"' : '')+` name="payment_receipt[`+ input_id+`]" id="`+ genid + input_id+`" data-tabgroup="quick-add-row-tabgroup" />
		</div>`;
	},
	renderDateSelector: (genid, input_id) => {
		return `<div class="exp-quick-add-input-date" id="`+ genid + input_id +`_container"></div>`;
	/*	return `<div class="">
			<input class="exp-quick-add-input-date" type="date" placeholder="" value="" data-tabgroup="quick-add-row-tabgroup" />
		</div>`;*/
	},

	renderActions: (genid, grid, first_input_column) => {
		
		var quick_add_submit_fn = 'og.expenses2.quick_add_submit(\''+grid.id+'\', \''+first_input_column+'\'); return false;';
		var quick_add_btn_class = 'x-btn-text ico-new add-first-btn blue';

		return '<button id="'+genid+'expenses_quick_add_btn" class="'+quick_add_btn_class+'" onclick="'+quick_add_submit_fn+'">'+lang('add')+'</button>';
	},

	renderDocumentSelector: function (genid, input_id) {
		
		var html = '<div class="exp-quick-add-input-document" id="'+ genid + input_id +'_container">';
		html += '<div class="link-ico ico-delete cursor-pointer" id="'+ genid + input_id +'_status" title="'+lang('remove')+'" style="display:none;"></div>';
		html += '<input id="'+ genid + input_id + '_file_input" type="file" name="'+ input_id +'_file_input" />';
		html += '<input id="'+ genid + input_id + '" type="hidden" name="payment_receipt['+ input_id +']" />'
		html += '</div>';

		return html;
	}


	/**********************************************************************************
	 * END QUICK ADD ROW FUNCTIONS
	 **********************************************************************************/

 }


og.product_types = {
	get_by_id: function (product_type_id) {
		var product_type = null;
		
		for (var x in og.expenses2.product_types) {
			var pt = og.expenses2.product_types[x];
			if (pt.id == product_type_id) {
				product_type = pt;
				break;
			}
		}
		
		return product_type;
	},
	
	def_ratecost_toggle: function(genid, type, checkbox) {
		var id = genid + (type == 'cost' ? 'cost_def' : 'rate_def');

		if ($(checkbox).attr('checked') == 'checked') {
			$("#"+id).removeClass('block-disabled');
		} else {
			$("#"+id).addClass('block-disabled');
		}
	},
	
	price_multiplier_toggle: function(genid, checkbox) {
		
		if ($(checkbox).attr('checked') == 'checked') {
			$("#" + genid + 'rate_def').hide();
			$("#" + genid + 'price_multiplier').show();
		} else {
			$("#" + genid + 'rate_def').show();
			$("#" + genid + 'price_multiplier').hide();
		}
	},


	product_type_dimension_changed: function(checkbox, dim_id) {
		var enable = $(checkbox).attr('checked') == 'checked' ? '1' : '0';
		og.openLink(og.getUrl('product_type', 'enable_disable_dimension', {dim_id:dim_id, enable:enable}), {
			silent:true,
			callback: function(success, data) {

				og.product_types.reload_allowed_dimensions(parseInt(dim_id));
				
			}
		});
		
	},


	product_type_filter_up_dimension_changed: function(checkbox, dim_id) {
		var enable = $(checkbox).attr('checked') == 'checked' ? '1' : '0';
		og.openLink(og.getUrl('product_type', 'enable_disable_filter_up_dimension', {dim_id:dim_id, enable:enable}), {
			silent:true
		});
		
	},
	
	reload_product_type_selectors: function(genid) {

		og.openLink(og.getUrl('product_type', 'get_filtered_product_types', {member_ids: $("#"+genid+"members").val()}), {
			callback: function(success, data) {
				
				if (!data || !data.product_types) return;
				og.expenses2.filtered_product_types = data.product_types;

				$("#" + genid + "submit-edit-form .product_type_selector").each(function(index, obj) {
					var selected_value = $(obj).val();

					// remove old options
					$(obj).find("option").remove();

					// add new options
					$(obj).append($('<option>', {value: 0, text : ""}));
					$.each(og.expenses2.filtered_product_types, function (i, item) {
						$(obj).append($('<option>', { 
							value: item.id,
							text : item.name.replaceAll('\\"', '"')
						}));
					});

					$(obj).val(selected_value);
				});
			}
		});
	},

	reload_product_type_selectors_for_payment_receipt: function(genid, expense_id) {
	
	  // use a timeout to prevent multiple requests when this fn is called many times by the member selector
	  if (og.expenses2.timeout_reload_pt) clearTimeout(og.expenses2.timeout_reload_pt);
	  
	  og.expenses2.timeout_reload_pt = setTimeout(function(){
	  
		// Comment out selecting product types from budgeted expense
		og.openLink(og.getUrl('product_type', 'get_filtered_product_types_for_payment_receipt', {member_ids: $("#"+genid+"members").val()/*, expense_id: $("#"+genid+"paymentExpenseId").val()*/}), {
			callback: function(success, data) {
				
				if (!data || !data.product_types) return;
				og.expenses2.filtered_product_types = data.product_types;

				$("#" + genid + "submit-edit-form .product_type_selector").each(function(index, obj) {
					var selected_value = $(obj).val();

					// remove old options
					$(obj).find("option").remove();

					// add new options
					$(obj).append($('<option>', {value: 0, text : ""}));
					$.each(og.expenses2.filtered_product_types, function (i, item) {
						$(obj).append($('<option>', { 
							value: item.id,
							text : item.name.replaceAll('\\"', '"')
						}));
					});
					$(obj).val(selected_value);

					// if there is only one element in the selector and not already selected then autoselect it
					if(data.product_types.length == 1 && $("option:eq(1)", obj).val() != selected_value){
						setTimeout(function(){
							$("option:eq(1)", obj).attr('selected','selected');
							$("option:eq(1)", obj).trigger('change');
						}, 1000);
					}
				});
			}
		});
	  }, 100);
	},

	reload_allowed_dimensions: function(changed_dim) {
		og.openLink(og.getUrl('product_type', 'get_allowed_dimensions'), {
			silent: true,
			callback: function(success, data) {
				if (success) {
					og.product_types_allowed_dimensions = [];
					for (i=0; i<data.allowed_dimensions.length; i++) {
						og.product_types_allowed_dimensions.push(parseInt(data.allowed_dimensions[i]));
					}
					
					var man = Ext.getCmp('product-types-manager');
					if (man) {
						var cm = man.getColumnModel();
						if (cm) {
						  for (var i=0; i<og.product_types_allowed_dimensions.length; i++) {
							var dim_id = og.product_types_allowed_dimensions[i];
							
							var col = cm.getColumnById('dim_' + dim_id);
							if (!col && og.product_types_allowed_dimensions.indexOf(parseInt(dim_id)) >= 0) {
								cm.config.push({
									id: 'dim_' + dim_id,
									header: og.dimensions_info[dim_id].name,
									dataIndex: 'dim_' + dim_id,
									sortable: true,
									renderer: og.renderDimCol
								});
								cm.fireEvent('configchange', cm);
								man.reset();
							}
						  }
						}
						
						if (changed_dim) {
							if (og.product_types_allowed_dimensions.indexOf(parseInt(changed_dim)) > -1) {
								$("#advanced-billing-manager .x-grid3-col.x-grid3-cell.x-grid3-td-dim_"+changed_dim).show();
								$("#advanced-billing-manager .x-grid3-hd.x-grid3-cell.x-grid3-td-dim_"+changed_dim).show();
							} else {
						//		$("#advanced-billing-manager .x-grid3-col.x-grid3-cell.x-grid3-td-dim_"+changed_dim).hide();
						//		$("#advanced-billing-manager .x-grid3-hd.x-grid3-cell.x-grid3-td-dim_"+changed_dim).hide();
							}
						}
					}
				}
			}
		});
	},
}

