<?php 

// Adds payment_receipt content_object
function expenses2_update_1_2() {
	
	DB::execute("
		UPDATE ".TABLE_PREFIX."dimension_object_type_contents
		SET is_multiple=0
		WHERE content_object_type_id = (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='expense')
		AND dimension_id IN (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code IN ('customer_project','customers','rate_schedules','expense_categories'));
	");
	
	DB::execute("
		CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."payment_receipts` (
		  `object_id` int(10) unsigned NOT NULL,
		  `expense_id` int(10) unsigned NOT NULL DEFAULT 0,
		  `status_id` int(10) unsigned NOT NULL DEFAULT 0,
		  `date` datetime NOT NULL,
		  `description` text collate utf8_unicode_ci NOT NULL,
		  `product_type_id` int(10) unsigned NOT NULL DEFAULT 0,
		  `currency_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
		  `amount` decimal(20,2) unsigned NOT NULL DEFAULT 0,
		  `document_id` varchar(255) NOT NULL DEFAULT '',
		  PRIMARY KEY (`object_id`),
		  KEY `expense_id` (`expense_id`),
		  KEY `product_type_id` (`product_type_id`,`expense_id`),
		  KEY `date` (`date`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`) VALUES
		('payment_receipt', 'PaymentReceipts', 'payment_receipts', 'content_object', 'payment_receipt', (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='expenses2'))
		ON DUPLICATE KEY UPDATE id=id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
		SELECT dimension_id, dimension_object_type_id, (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='payment_receipt'), 0, 0
		FROM `".TABLE_PREFIX."dimension_object_type_contents` x
		WHERE x.`content_object_type_id` = (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='task')
		ON DUPLICATE KEY UPDATE ".TABLE_PREFIX."dimension_object_type_contents.dimension_id=".TABLE_PREFIX."dimension_object_type_contents.dimension_id;
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 1, 1
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('payment_receipt')
		AND p.`name` IN ('Super Administrator','Administrator','Manager','Executive');
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 0, 0
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('payment_receipt')
		AND p.`name` IN ('Collaborator Customer','Internal Collaborator','External Collaborator','Guest Customer');
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 1, 1
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('payment_receipt')
		AND p.`name` IN ('Super Administrator','Administrator','Manager');
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 0, 1
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('payment_receipt')
		AND p.`name` IN ('Executive');
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."contact_member_permissions (permission_group_id, member_id, object_type_id, can_delete, can_write)
		SELECT cmp.permission_group_id, cmp.member_id, (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='payment_receipt'), cmp.can_delete, cmp.can_write
		FROM ".TABLE_PREFIX."contact_member_permissions cmp
		WHERE cmp.object_type_id = (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='task')
		ON DUPLICATE KEY UPDATE ".TABLE_PREFIX."contact_member_permissions.member_id=".TABLE_PREFIX."contact_member_permissions.member_id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_content_object_options` (`dimension_id`,`content_object_type_id`,`option`,`value`)
		SELECT d.id, ot.id, 'hide_member_selector_in_forms', '0'
				FROM ".TABLE_PREFIX."dimensions d LEFT JOIN ".TABLE_PREFIX."object_types ot ON true
				WHERE ot.name IN ('payment_receipt')
				ON DUPLICATE KEY UPDATE `value`=`value`;
	");
}

function expenses2_update_2_3() {
	$config_option_exists = ConfigOptions::getByName("product_type_filter_up_dimensions");
	if (!$config_option_exists instanceof ConfigOption) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
			 ('system', 'product_type_dimensions', '', 'AllDimensionsConfigHandler', 1, 0, ''),
			 ('system', 'product_type_filter_up_dimensions', (SELECT GROUP_CONCAT(id) FROM ".TABLE_PREFIX."dimensions WHERE code IN ('customer_project','customers')), 'AllDimensionsConfigHandler', 1, 0, '')
			ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
		");
	}
}

function expenses2_update_3_4() {
	if (!check_column_exists(TABLE_PREFIX."expenses", "is_billable")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."expenses`
			ADD `is_billable` tinyint(1) NOT NULL;
		");
	}
	if (!check_column_exists(TABLE_PREFIX."payment_receipts", "is_billable")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."payment_receipts`
			ADD `is_billable` tinyint(1) NOT NULL;
		");
	}
}

function expenses2_update_4_5() {
	$config_option_exists = ConfigOptions::getByName("product_type_decimals");
	if (!$config_option_exists instanceof ConfigOption) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
			 ('expenses', 'product_type_decimals', '2', 'IntegerConfigHandler', 0, 50, '')
			ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
		");
	}
	
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."expense_items`
		CHANGE `unit_cost` `unit_cost` decimal(20,3) unsigned NOT NULL DEFAULT '0.00',
		CHANGE `total_cost` `total_cost` decimal(20,3) unsigned NOT NULL DEFAULT '0.00',
		CHANGE `unit_price` `unit_price` decimal(20,3) unsigned NOT NULL DEFAULT '0.00',
		CHANGE `total_price` `total_price` decimal(20,3) unsigned NOT NULL DEFAULT '0.00',
		COMMENT='';
	");
	
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."expense_items_history`
		CHANGE `unit_cost` `unit_cost` decimal(20,3) unsigned NOT NULL DEFAULT '0.00',
		CHANGE `total_cost` `total_cost` decimal(20,3) unsigned NOT NULL DEFAULT '0.00',
		CHANGE `unit_price` `unit_price` decimal(20,3) unsigned NOT NULL DEFAULT '0.00',
		CHANGE `total_price` `total_price` decimal(20,3) unsigned NOT NULL DEFAULT '0.00',
		COMMENT='';
	");
	
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."expense_totals`
		CHANGE `unit_cost` `unit_cost` decimal(20,3) unsigned NOT NULL DEFAULT '0.00',
		CHANGE `total_cost` `total_cost` decimal(20,3) unsigned NOT NULL DEFAULT '0.00',
		CHANGE `unit_price` `unit_price` decimal(20,3) unsigned NOT NULL DEFAULT '0.00',
		CHANGE `total_price` `total_price` decimal(20,3) unsigned NOT NULL DEFAULT '0.00',
		COMMENT='';
	");
	
	
	
}

function expenses2_update_5_6() {
    if (!check_column_exists(TABLE_PREFIX."payment_receipts", "paid_by_id")) {
        DB::execute("
			ALTER TABLE `".TABLE_PREFIX."payment_receipts`
			ADD `paid_by_id` int(10) unsigned NOT NULL DEFAULT 0;
		");
    }
    if (!check_column_exists(TABLE_PREFIX."payment_receipts", "quantity")) {
        DB::execute("
			ALTER TABLE `".TABLE_PREFIX."payment_receipts`
			ADD `quantity` decimal(20,3) unsigned NOT NULL DEFAULT 0;
		");
    }
    if (!check_column_exists(TABLE_PREFIX."payment_receipts", "unit_cost")) {
        DB::execute("
			ALTER TABLE `".TABLE_PREFIX."payment_receipts`
			ADD `unit_cost` decimal(20,3) unsigned NOT NULL DEFAULT 0;
		");
    }
}


function expenses2_update_6_7() {
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."widgets (name,title,plugin_id,path,default_options,default_section,default_order,icon_cls) VALUES
		('expenses_progress','expenses progress',(SELECT id FROM ".TABLE_PREFIX."plugins WHERE name='expenses2'),'','','left',2,'ico-expense');
	");
}



function expenses2_update_7_8() {
	DB::execute("
		UPDATE `".TABLE_PREFIX."tab_panels` SET `title` = 'all_expenses'
		WHERE `id` = 'expenses-panel';
	");
}


function expenses2_update_8_9() {
	if (!check_column_exists(TABLE_PREFIX."payment_receipts", "unit_price")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."payment_receipts`
			ADD `unit_price` decimal(20,3) unsigned NOT NULL DEFAULT '0',
			ADD `total_price` decimal(20,3) unsigned NOT NULL DEFAULT '0',
			ADD `price_multiplier` decimal(20,3) unsigned NOT NULL DEFAULT '1';
		");
	}
}




function expenses2_update_9_10() {
	$is_plugin_active = Plugins::instance()->isActivePlugin('workflow_permissions');
	
	if ($is_plugin_active) {
		
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."workflow_permissions` (`name`, `object_type_id`, `type`, `action`, `member_id`) VALUES
			('can_edit_locked_expenses', (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='payment_receipt'), 'permission_group_list', 'edit', (SELECT `value` FROM ".TABLE_PREFIX."config_options WHERE name='time_bulk_action_locked_member_id')),
			('can_edit_review_expenses', (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='payment_receipt'), 'permission_group_list', 'edit', (SELECT `value` FROM ".TABLE_PREFIX."config_options WHERE name='time_bulk_action_review_member_id')),
			('can_approve_expenses', (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='payment_receipt'), 'permission_group_list', 'approve', (SELECT `value` FROM ".TABLE_PREFIX."config_options WHERE name='time_bulk_action_approved_member_id')),
			('can_edit_approved_expenses', (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='payment_receipt'), 'permission_group_list', 'edit', (SELECT `value` FROM ".TABLE_PREFIX."config_options WHERE name='time_bulk_action_approved_member_id')),
			('can_invoice_expenses', (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='payment_receipt'), 'permission_group_list',	'invoice', (SELECT `value` FROM ".TABLE_PREFIX."config_options WHERE name='time_bulk_action_invoiced_member_id')),
			('can_edit_invoiced_expenses', (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='payment_receipt'), 'permission_group_list', 'edit', (SELECT `value` FROM ".TABLE_PREFIX."config_options WHERE name='time_bulk_action_invoiced_member_id'));
		");
		
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`, `dimension_object_type_id`, `content_object_type_id`, `is_required`, `is_multiple`) VALUES
			((SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='status_timesheet'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='status_timesheet'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='payment_receipt'), '0', '0')
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");
		
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."workflow_permission_values(workflow_permission_id, permission_group_id, bool_value)
			SELECT wp.id, u.permission_group_id, true
			FROM ".TABLE_PREFIX."contacts u
			JOIN ".TABLE_PREFIX."workflow_permissions wp
			WHERE u.user_type IN (1,2)
			ON DUPLICATE KEY UPDATE workflow_permission_id=workflow_permission_id;
		");
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."workflow_permission_value_pgs (workflow_permission_value_id, affected_permission_group_id)
			SELECT wpv.id, au.permission_group_id
			FROM ".TABLE_PREFIX."workflow_permission_values wpv
			INNER JOIN ".TABLE_PREFIX."contacts u ON u.permission_group_id = wpv.permission_group_id
			JOIN ".TABLE_PREFIX."contacts au
			WHERE u.user_type IN (1,2) AND au.user_type > 0
			ON DUPLICATE KEY UPDATE workflow_permission_value_id=workflow_permission_value_id;
		");
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."workflow_permission_values(workflow_permission_id, permission_group_id, bool_value)
			SELECT wp.id, u.permission_group_id, true
			FROM ".TABLE_PREFIX."contacts u
			JOIN ".TABLE_PREFIX."workflow_permissions wp
			WHERE u.user_type IN (3)
			AND wp.name IN ('can_edit_locked_expenses','can_edit_review_expenses','can_approve_expenses')
			ON DUPLICATE KEY UPDATE workflow_permission_id=workflow_permission_id;
		");
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."workflow_permission_value_pgs (workflow_permission_value_id, affected_permission_group_id)
			SELECT wpv.id, au.permission_group_id
			FROM ".TABLE_PREFIX."workflow_permission_values wpv
			INNER JOIN ".TABLE_PREFIX."workflow_permissions wp ON wp.id = wpv.workflow_permission_id
			INNER JOIN ".TABLE_PREFIX."contacts u ON u.permission_group_id = wpv.permission_group_id
			JOIN ".TABLE_PREFIX."contacts au
			WHERE u.user_type IN (3) AND au.user_type >= 3 AND au.object_id<>u.object_id
			AND wp.name IN ('can_edit_locked_expenses','can_edit_review_expenses','can_approve_expenses')
			ON DUPLICATE KEY UPDATE workflow_permission_value_id=workflow_permission_value_id;
		");
		
	}
}

function expenses2_update_10_11() {
	if (!check_column_exists(TABLE_PREFIX."system_permissions", "can_see_expenses_of_others") && !check_column_exists(TABLE_PREFIX."max_system_permissions", "can_see_expenses_of_others")) {
		DB::executeAll("
			ALTER TABLE ".TABLE_PREFIX."system_permissions 
			ADD can_see_expenses_of_others TINYINT(1) UNSIGNED NOT NULL DEFAULT '1';
		");

		DB::executeAll("
			ALTER TABLE ".TABLE_PREFIX."max_system_permissions 
			ADD can_see_expenses_of_others TINYINT(1) UNSIGNED NOT NULL DEFAULT '1';
		");
			
		DB::executeAll("
			UPDATE ".TABLE_PREFIX."system_permissions 
			SET can_see_expenses_of_others=0
			WHERE permission_group_id IN (SELECT id FROM ".TABLE_PREFIX."permission_groups WHERE name IN ('Executive','Collaborator Customer', 'Internal Collaborator', 'External Collaborator', 'Guest Customer', 'Guest'));
		");

		DB::executeAll("
			UPDATE ".TABLE_PREFIX."max_system_permissions 
			SET can_see_expenses_of_others=0
			WHERE permission_group_id IN (SELECT id FROM ".TABLE_PREFIX."permission_groups WHERE name IN ('Internal Collaborator', 'External Collaborator'));
		");

		DB::executeAll("
			UPDATE ".TABLE_PREFIX."system_permissions 
			SET can_see_expenses_of_others=0
			WHERE permission_group_id IN (SELECT permission_group_id FROM ".TABLE_PREFIX."contacts WHERE user_type IN (SELECT id FROM ".TABLE_PREFIX."permission_groups WHERE name IN ('Executive','Collaborator Customer', 'Internal Collaborator', 'External Collaborator', 'Guest Customer', 'Guest')));
		");
	 }
}

function expenses2_update_11_12() {
	if (!check_column_exists(TABLE_PREFIX."product_types", "is_reimbursable")) {
		DB::execute("
			ALTER TABLE ".TABLE_PREFIX."product_types 
			ADD is_reimbursable TINYINT(1) UNSIGNED NOT NULL DEFAULT '1';
		");
	}
}


function expenses2_update_12_13() {
	
	DB::execute("
		CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."actual_expense_taxes` (
		  `id` int NOT NULL AUTO_INCREMENT,
		  `name` varchar(255) collate utf8_unicode_ci NOT NULL,
		  `value` decimal(20,3) unsigned NOT NULL DEFAULT 0,
		  `is_percentage` tinyint(1) NOT NULL,
		  `valid_from` datetime NOT NULL,
		  `valid_to` datetime NOT NULL,
		  `currency_id` int(10) NOT NULL DEFAULT 0,
		  `select_by_default` tinyint(1) NOT NULL,
  		  PRIMARY KEY (`id`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
	");
	
	DB::execute("
		CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."actual_expense_tax_values` (
		  `tax_id` int(10) NOT NULL,
		  `object_id` int(10) NOT NULL,
		  `applied_value` decimal(20,3) unsigned NOT NULL DEFAULT 0,
		  `value` decimal(20,3) unsigned NOT NULL DEFAULT 0,
		  PRIMARY KEY (`tax_id`,`object_id`),
		  KEY `object_id` (`object_id`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
	");
	
	if (!check_column_exists(TABLE_PREFIX."payment_receipts", "total_cost_without_taxes")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."payment_receipts`
			ADD `total_cost_without_taxes` decimal(20,3) unsigned NOT NULL DEFAULT '0.000';
		");
	}
	
	$config_option = ConfigOptions::getByName('use_taxes_in_actual_expenses');
	if (!$config_option) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
			 ('expenses', 'use_taxes_in_actual_expenses', '0', 'BoolConfigHandler', 0, 60, '')
			ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
		");
	}
	
	$config_option = ConfigOptions::getByName('disable_expenses_subtab');
	if (!$config_option) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
			 ('expenses', 'disable_expenses_subtab', '0', 'BoolConfigHandler', 0, 70, ''),
			 ('expenses', 'disable_actual_expenses_subtab', '0', 'BoolConfigHandler', 0, 80, '')
			ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
		");
	}
	
}

function expenses2_update_13_14() {
	$is_plugin_active = Plugins::instance()->isActivePlugin('workflow_permissions') && Plugins::instance()->isActivePlugin('status_dimension_timesheet');
	
	if ($is_plugin_active) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`, `dimension_object_type_id`, `content_object_type_id`, `is_required`, `is_multiple`) VALUES
			((SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='status_timesheet'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='status_timesheet'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='payment_receipt'), '0', '0')
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");
	}
}



function expenses2_update_14_15() {
	$config_option = ConfigOptions::getByName('actual_expense_name_generation');
	if (!$config_option) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
			('expenses', 'actual_expense_name_generation', 'date_quantity_product', 'ListConfigHandler', 0, 0, '', ' { \"no_empty_value\":1, \"option\": [{ \"value\": \"date_quantity_product\", \"text\": \"date_quantity_product\" }, { \"value\": \"date_product\", \"text\": \"date_product\" }, { \"value\": \"only_product\", \"text\": \"only_product\" }] }')
			ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
		");
  }
  
  $config_option = ConfigOptions::getByName('set_paid_by_contacts_users');
	if (!$config_option) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment` , `options`) VALUES
			 ('expenses', 'set_paid_by_contacts_users', 'users', 'MultipleListConfigHandler', 0, 09, '','contacts,users')
			ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
		");
	}
}


function expenses2_update_15_16() {
	// new column for expense type
	if (!check_column_exists(TABLE_PREFIX."payment_receipts", "expense_type")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."payment_receipts`
			ADD `expense_type` varchar(100) NOT NULL DEFAULT 'reimbursable';
		");
	}

	// new column for due date
	if (!check_column_exists(TABLE_PREFIX."payment_receipts", "due_date")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."payment_receipts`
			ADD `due_date` datetime NOT NULL;
		");
	}
}


function expenses2_update_16_17() {
	// new column for payment terms
	if (!check_column_exists(TABLE_PREFIX."payment_receipts", "payment_term_id")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."payment_receipts`
			ADD `payment_term_id` int(10) NOT NULL DEFAULT 0;
		");
	}
}


function expenses2_update_17_18() {
	// new config option to enable or disable the expense type "Rentals/Consumables"
	$config_option = ConfigOptions::getByName('use_rentals_cons_expense');
	if (!$config_option) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
			 ('expenses', 'use_rentals_cons_expense', '0', 'BoolConfigHandler', 0, 90, '')
			ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
		");
	}
}


function expenses2_update_18_19() {
	// new config option to enable or disable the expense type "Field and Laboratory Testing"
	$config_option = ConfigOptions::getByName('use_field_lab_test_expense');
	if (!$config_option) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
			 ('expenses', 'use_field_lab_test_expense', '0', 'BoolConfigHandler', 0, 90, '')
			ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
		");
	}
}

function expenses2_update_19_20() {
	if (!check_column_exists(TABLE_PREFIX."expenses", "currency_id")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."expenses`
			ADD `currency_id` int(10) NOT NULL default '0';
		");

		DB::execute("
			UPDATE `".TABLE_PREFIX."expenses` e
			SET currency_id = (SELECT currency_id 
								FROM `".TABLE_PREFIX."expense_items` ei
								WHERE e.object_id=ei.expense_id
								LIMIT 1);
		");
	}
}

function expenses2_update_20_21() {
	$is_plugin_active = Plugins::instance()->isActivePlugin('status_dimension_timesheet');
	
	if ($is_plugin_active) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`, `dimension_object_type_id`, `content_object_type_id`, `is_required`, `is_multiple`) VALUES
			((SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='status_timesheet'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='status_timesheet'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='payment_receipt'), '0', '0')
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");
	}
}

function expenses2_update_21_22()
{

	$config_option = ConfigOptions::getByName('set_actual_expense_type');
	if (!$config_option) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment` , `options`) VALUES
			 ('expenses', 'set_actual_expense_type', 'direct_to_vendor,reimbursable,field_lab_testing,rental_consumable,credit_card_purchase', 'MultipleListConfigHandler', 0, 12, '','direct_to_vendor,reimbursable,field_lab_testing,rental_consumable,credit_card_purchase')
			ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
		");
	}
}

function expenses2_update_22_23()
{
	$config_option_exists = CustomProperties::instance()->findOne(array('conditions' => "code='payment_receipt_bill_no'"));
	if (!$config_option_exists instanceof CustomProperty) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "custom_properties` (`object_type_id`,`name`,`code`,`type`,`description`,`values`,`default_value`,`is_required`,`is_multiple_values`,`property_order`,`visible_by_default`, `is_special`, `is_disabled`) VALUES 
			((SELECT id FROM  `" . TABLE_PREFIX . "object_types` WHERE name='payment_receipt'),'Bill no','payment_receipt_bill_no','text','','','',0,0,1,1, 1,0) 
			ON DUPLICATE KEY UPDATE code=code;
		");
	}


	$config_option = ConfigOptions::getByName('default_actual_expense_types');
	if (!$config_option) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment` , `options`) VALUES
			 ('expenses', 'default_actual_expense_types', 'none_blank', 'DefaultActualExpenseTypesConfigHandler', 0, 13, '','')
			ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
		");
	}
}

function expenses2_update_23_24()
{
	$config_option_exists = ConfigOptions::getByName("allow_to_edit_invoices");
	if (!$config_option_exists instanceof ConfigOption) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) 
			VALUES ('general', 'allow_to_edit_invoices', '0', 'BoolConfigHandler', '0', '999', '', '');
		");
	}
}

function expenses2_update_24_25()
{
	$custom_property_exists = CustomProperties::instance()->findOne(array('conditions' => "code='payment_receipt_deposit_day'"));
	if (!$custom_property_exists instanceof CustomProperty) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "custom_properties` (`object_type_id`,`name`,`code`,`type`,`description`,`values`,`default_value`,`is_required`,`is_multiple_values`,`property_order`,`visible_by_default`, `is_special`, `is_disabled`) VALUES 
			((SELECT id FROM  `" . TABLE_PREFIX . "object_types` WHERE name='payment_receipt'),'Deposit day','payment_receipt_deposit_day','date','','','',0,0,30,1, 1,1) 
			ON DUPLICATE KEY UPDATE code=code;
		");
	}
}

function expenses2_update_25_26() {
	DB::execute("
		ALTER TABLE `" . TABLE_PREFIX . "payment_receipts`
		CHANGE `amount` `amount` decimal(20,3) unsigned NOT NULL DEFAULT '0';
	");

	DB::execute("
		UPDATE `" . TABLE_PREFIX . "payment_receipts`
		SET amount = (quantity * unit_cost)
		WHERE amount <> (quantity * unit_cost) AND abs(amount-(quantity * unit_cost)) < 1;
	");
}


function expenses2_update_26_27() {
	// remove deprecated expense report
	DB::execute("
		DELETE FROM `" . TABLE_PREFIX . "reports`
		WHERE `code`='payments_report' AND function_url='?c=expense_reports&a=payments_by_state_parameters';
	");
}


function expenses2_update_27_28() {

	// config option to make actual expense type madatory or not
	$config_option = ConfigOptions::getByName('actual_expense_type_mandatory');
	if (!$config_option) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
			 ('expenses', 'actual_expense_type_mandatory', '0', 'BoolConfigHandler', 0, 110, '')
			ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
		");
	}
}




function expenses2_update_28_29() {
	// add task id to budgeted expenses
	if (!check_column_exists(TABLE_PREFIX."expenses", "task_id")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."expenses`
			ADD `task_id` int(10) NOT NULL default '0';
		");
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."expenses`
			ADD INDEX `task_id` (`task_id`);
		");
	}
	// add task id to actual expenses
	if (!check_column_exists(TABLE_PREFIX."payment_receipts", "task_id")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."payment_receipts`
			ADD `task_id` int(10) NOT NULL default '0';
		");
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."payment_receipts`
			ADD INDEX `task_id` (`task_id`);
		");
	}
}

function expenses2_update_29_30() {

	$exp_options_cat = ContactConfigCategories::instance()->findOne(array("conditions"=>"name='expenses'"));
	if (!$exp_options_cat instanceof ContactConfigCategory) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."contact_config_categories` (`name`, `is_system`, `type`, `category_order`, `located_under`)
			VALUES ('expenses', '0', '0', '12', '0');
		");
	}
	
	$exp_option = ContactConfigOptions::getByName('hide_cost_in_actual_expenses_form');
	if (!$exp_option instanceof ContactConfigOption) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`)
			VALUES ('expenses', 'hide_cost_in_actual_expenses_form', '0', 'BoolConfigHandler', '0', '1', '', '');
		");
	}
}

function expenses2_update_30_31() {
	$config_option = ConfigOptions::getByName('default_expense_payment_term');
	if (!$config_option) {
		$options = '{ "no_empty_value":1, "option": [{ "value": "1", "text": "payment term due_on_receipt" }, { "value": "2", "text": "Net 10" }, { "value": "3", "text": "Net 15" }, { "value": "4", "text": "Net 30" }, { "value": "5", "text": "Net 45" }, { "value": "6", "text": "Net 60" }, { "value": "7", "text": "Net 90" }] }';
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
			('expenses', 'default_expense_payment_term', '4', 'ListConfigHandler', 0, 0, '', '".$options."')
			ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
		");
	}
}
