<?php
class FacturalistaWrapper
{

    function __construct() {
       Env::useHelper('facturalista_class/facturalista_service', 'facturalista');
       Env::useHelper('facturalista_class/factura', 'facturalista');
       Env::useHelper('facturalista_class/nota_credito', 'facturalista');
       Env::useHelper('facturalista_class/nota_debito', 'facturalista');
    }

    function send_invoice(IncomeInvoice $invoice)
    {
        $service = new FacturalistaService();

        $external_type_id = FacturalistaController::get_einvoice_external_type($invoice->getColumnValue('object_subtype_id'),$invoice->getFinalConsumer());
        switch ($external_type_id) {
            //e-Factura
            case 101:
            case 111:
            	$factura = new Factura($invoice);
            	break;
            	//Nota de Crédito de e-Factura
            case 102:
            case 112:
            	$factura = new NotaCredito($invoice);
            	break;
            	//Nota de Débito de e-Factura
            case 103:
            case 113:
            	$factura = new NotaDebito($invoice);
                break;
            default:
                //error
        }

        $service->generarFactura($factura, $invoice->getId());
    }

    function get_invoice($invoice)
    {
        $service = new FacturalistaService();
        $file = $service->getImprimible($invoice->getId(), $invoice->getMembers());

        return $file;
    }

	function get_qr_einvoice($invoice)
    {
        $service = new FacturalistaService();
        $file = $service->getQRImprimible($invoice->getId(), $invoice->getMembers());
        return $file;
    }
	
}