<?php
	$genid = gen_id();
	$grid_id = array_var($_REQUEST, 'current')."_forms_module_grid";
	
	$additional_actions_params = array('panel_id' => $grid_id);
	$additional_actions = array();
	Hook::fire('form_list_additional_actions', $additional_actions_params, $additional_actions);
	
	$show_billing = can_manage_billing(logged_user());
	
	$current_filters = array_var($_SESSION, 'current_form_module_filters', array());
	
	$active_members = array();
	foreach (active_context() as $selection) {
		if ($selection instanceof Member) $active_members[] = $selection;
	}
	
	$dummy_form = new Form();
	$can_add_forms = $dummy_form->canAdd(logged_user(), active_context());
	
	
	$new_buttons = array(array(
			'id' => 'new_form_btn',
			'name' => lang('add form'),
			'icon' => 'ico-new',
			'action' => 'og.render_modal_form(\'\', {c:\'form\', a:\'add\'})',
	));
	if (Plugins::instance()->isActivePlugin("object_subtypes")) {
		$subtypes = ObjectSubtypes::instance()->findAll(array("conditions" => array("object_type_id = ?",Forms::instance()->getObjectTypeId())));
		foreach ($subtypes as $subtype) {
			$new_buttons[] = array(
					'id' => $subtype->getName() . '_btn',
					'name' => lang('add'). " " .$subtype->getName(),
					'icon' => 'ico-new',
					'action' => 'og.render_modal_form(\'\', {c:\'form\', a:\'add\', params: {object_subtype_id:'.$subtype->getId().'}})',
			);
		}	
	}
?>

<div id="formPanel" class="ogContentPanel" style="height:100%;">

	<div id="<?php echo $grid_id ?>_container" style="height:100%;"></div>

</div>


<script>
	
	var grid_id = '<?php echo $grid_id ?>';
	
    og.module_forms_grid = {
		
    	grid_id: grid_id,
		
    	delete_form: function(tid) {
    		if (confirm('<?php echo escape_single_quotes(lang('confirm delete form'))?>')) {
    			og.openLink(og.getUrl('time', 'delete_form', {id:tid}), {
    				callback: function(success, data) {
    					var g = Ext.getCmp(og.module_forms_grid.grid_id);
    					if (g) g.reset();
    				}
    			});
    		}
    	}
    }
    
    
	// columns
    var forms_columns = [];
    
	// system columns
    var system_columns = ['uid','uname','can_edit','can_delete','add_cls','start_time_ts','paused_on_ts','paused_time_sec','rel_object_id'];
    for (var j=0; j<system_columns.length; j++) {
    	forms_columns.push({
        	name: system_columns[j],
        	is_system: true
        });
    }

<?php
	$add_columns = "";
	Hook::fire("view_form_render_more_columns", $dummy_ts, $add_columns);
	if (is_array($add_columns)) {
		foreach ($add_columns as $col_id => $val) {
			$align = in_array($dummy_ts->getColumnType($col_id), array(DATA_TYPE_FLOAT, DATA_TYPE_INTEGER)) ? 'right' : 'left';
		?>
		forms_columns.push({
			name: '<?php echo $col_id ?>',
			header: '<?php echo lang($col_id) ?>',
			align: '<?php echo $align ?>',
	    	hidden: true,
			renderer: 'string',
			sortable: true
		});
	<?php
		}
	}
?>

    // buttons
    var forms_tbar_items = [];

<?php
	if ($can_add_forms) {
		if (count($new_buttons) == 1) { ?>

		    var new_btn = new Ext.Button({
		    	iconCls: 'ico-new add-first-btn blue',
		    	text: '<?php echo lang('add form')?>',
		    	id: 'new_form_btn',
		    	handler: function() {
		    		og.render_modal_form('', {c:'form', a:'add'});
		    	}
		    });
		    forms_tbar_items.push(new_btn);

    <?php 
		} else { ?>
			var menu_items = [];
		<?php 
			foreach ($new_buttons as $nb) { ?>
				menu_items.push(
					new Ext.Action({
						id: '<?php echo $nb['id']?>',
						text: '<?php echo $nb['name']?>',
				        iconCls: '<?php echo $nb['icon']?>',
				        handler: function() {
				        	<?php echo $nb['action']?>
						}
					})
				);
		<?php 
			} ?>
			var new_menu = new Ext.Button({
				iconCls: 'ico-new',
				text: lang('new'),
				id: 'new_form_btn',
				menu: {
					cls:'scrollable-menu',
					items: menu_items
				}
			});
			
			forms_tbar_items.push(new_menu);
		<?php 
		}
	} 
?>



	var trash_action = new Ext.Action({
		text: lang('move to trash'),
	    tooltip: lang('move selected objects to trash'),
	    iconCls: 'ico-trash',
		disabled: true,
		handler: function() {
			var confirm_trash_config = parseInt(og.preferences['enableTrashConfirmation']);
			var grid = Ext.getCmp("<?php echo $grid_id?>");
			if (og.confirmNorification(lang('confirm move to trash'), confirm_trash_config)) {
				grid.load({
					action: 'delete',
					ids: grid.getSelectedIds()
				});
				grid.getSelectionModel().clearSelections();
			}
		},
		selection_dependant: true,
		is_multiple: true
	});
	
	var edit_action = new Ext.Action({
		text: lang('edit'),
	    tooltip: lang('edit selected object'),
	    iconCls: 'ico-edit',
		disabled: true,
		handler: function() {
			var grid = Ext.getCmp("<?php echo $grid_id?>");
			og.render_modal_form('', {c:'form', a:'edit', params: {id:grid.getFirstSelectedId()}});
		},
		selection_dependant: true,
		is_multiple: false
	});
	
	forms_tbar_items.push(edit_action);
	forms_tbar_items.push(trash_action);
	

<?php 
foreach ($additional_actions as $add_action) { ?>
	forms_tbar_items.push(new Ext.Button({
		iconCls: '<?php echo array_var($add_action, 'cls') ?>',
		text: '<?php echo array_var($add_action, 'text') ?>',
		handler: function() {
			<?php if (isset($add_action['onclick'])) { ?>
			eval("<?php echo $add_action['onclick']?>");
		<?php } else if (isset($add_action['url'])) { ?>
			og.openLink("<?php echo $add_action['url'] ?>");
		<?php } ?>
		}
	}));
<?php } ?>


	// toolbar buttons to the right
	var forms_tbar_right_items = [];

    // filters
    var type_options = [
		[0, '<?php echo lang('all forms')?>'], [1, '<?php echo lang('task forms')?>'], [2, '<?php echo lang('time forms')?>']
    ];
    if (og.additional_form_type_filter_values) {
    	for (var j=0; j<og.additional_form_type_filter_values.length; j++) {
    		type_options.push(og.additional_form_type_filter_values[j]);
    	}
    }

    var add_row_user_options = [];
    var user_options = [[0, lang('everyone')]];
    <?php foreach ($users as $user) { ?>
	user_options.push([<?php echo $user->getId()?>, '<?php echo clean($user->getObjectName()) ?>']);
	add_row_user_options.push([<?php echo $user->getId()?>, '<?php echo clean($user->getObjectName()) ?>']);
    <?php } ?>

    var type_ini_val = '<?php echo array_var($current_filters,'type_filter','0')?>';
    var user_ini_val = '<?php echo array_var($current_filters,'user_filter','0')?>';
    
    var filters = {};

    var store_parameters = {
    	url_controller: 'form',
    	url_action: 'list_all'
    }
    
    var forms_module_grid = new og.ObjectGrid({
        genid: '<?php echo $genid ?>',
    	renderTo: grid_id + '_container',
    	url: og.getUrl(store_parameters.url_controller, store_parameters.url_action),
    	type_name: 'form',
    	response_objects_root: 'forms',
    	grid_id: grid_id,
    	nameRenderer: og.gridObjectNameRenderer,
    	store_params: store_parameters,
    	filters: filters,
    	checkbox_sel_model: true,
    	fixed_height: true,
    	columns: forms_columns,
    	tbar_items: forms_tbar_items,
    	tbar_right_items: forms_tbar_right_items,
    	stateId: 'forms-module'
    });


	var active_tab = Ext.getCmp('tabs-panel').activeTab;
	if (active_tab.events.resize.listeners.length < 2) {
    	active_tab.on('resize', function() {
    		og.resize_all_grids(this);
    	});
    }

    og.resize_all_grids = function(active_tab) {
    	var grids = $("#"+active_tab.id+" .x-grid-panel");
		for (var i=0; i<grids.length; i++) {
			var g = Ext.getCmp($(grids[i]).attr('id'));
			if (g) g.fireEvent('resize');
		}
    }

    forms_module_grid.getView().override({
    	getRowClass: function (record, index, rowParams, store) {
   			return record.data.add_cls ? record.data.add_cls : "";
    	}
    });

    forms_module_grid.load();


	
</script>
