<?php
if (isset($form) && $form instanceof Form) {
	if (!$form->isTrashed()){
		if($form->canEdit(logged_user())) {
			add_page_action(lang('edit'), "javascript:og.render_modal_form('', {c:'form', a:'edit', params: {id:".$form->getId()."}});", 'ico-edit', null, null, true);
			
			if (!$form->isArchived()) {
				add_page_action(lang('archive'), "javascript:if(confirm(lang('confirm archive object'))) og.openLink('" . $form->getArchiveUrl() ."');", 'ico-archive-obj');
			} else {
				add_page_action(lang('unarchive'), "javascript:if(confirm(lang('confirm unarchive object'))) og.openLink('" . $form->getUnarchiveUrl() ."');", 'ico-unarchive-obj');
			}
		}
	}
	if ($form->canDelete(logged_user())) {
		if ($form->isTrashed()) {
			add_page_action(lang('restore from trash'), "javascript:if(confirm(lang('confirm restore objects'))) og.openLink('" . $form->getUntrashUrl() ."');", 'ico-restore', null, null, true);
			add_page_action(lang('delete permanently'), "javascript:if(confirm(lang('confirm delete permanently'))) og.openLink('" . $form->getDeletePermanentlyUrl() ."');", 'ico-delete', null, null, true);
		} else {
			add_page_action(lang('move to trash'), "javascript:if(confirm(lang('confirm move to trash'))) og.openLink('" . $form->getTrashUrl() ."');", 'ico-trash', null, null, true);
		}
	}
?>

<div style="padding:7px">
<div class="form">
<?php
	tpl_assign("content", "");
	tpl_assign("object", $form);
	tpl_assign('iconclass', 'ico-large-form');
	
	$this->includeTemplate(get_template_path('view', 'co'));
?>
</div>
</div>
<?php } ?>
