<?php 
/*
 *  DO NOT DELETE. this is needed for  plugins to work
 */
class GanttController extends ApplicationController {
	
	var $plugin_name = "gantt";
	
	function __construct() {
		parent::__construct();
		prepare_company_website_controller($this, 'website');
	}   
	
	function to_pdf() {
		$genid = gen_id();
		if (logged_user()->isGuest()) {
			flash_error(lang('no access permissions'));
			ajx_current("empty");
			return;
		}
		ajx_current("empty");
	
		if(array_var($_REQUEST, 'html_to_convert')){
			$html_to_convert = array_var($_REQUEST, 'html_to_convert');
		}
		
		//generate the pdf
		$pdf_data = $this->convert_to_pdf($html_to_convert, $genid);
		$pdf_name = $pdf_data['name'];

		if(!$pdf_name){
			flash_error(lang('error file download'));
			ajx_current("empty");
			return;
		}else{
			$file_data = array();
			$file_data['file_data_name'] = $pdf_name;
			$file_data['file_data_type'] = "pdf";
			ajx_extra_data($file_data);
		}
	}
	
	function to_img() {
		if(is_exec_available()){
			$genid = gen_id();
			if (logged_user()->isGuest()) {
				flash_error(lang('no access permissions'));
				ajx_current("empty");
				return;
			}
			ajx_current("empty");
			
			if(array_var($_REQUEST, 'html_to_convert')){
				$html_to_convert = array_var($_REQUEST, 'html_to_convert');
			}

			//generate the image
			$img_name = $this->convert_to_img($html_to_convert, $genid);

			if(!$img_name){
				flash_error(lang('error file download'));
				ajx_current("empty");
				return;
			}else{			
				$file_data = array();
				$file_data['file_data_name'] = $img_name;
				$file_data['file_data_type'] = "png";
				ajx_extra_data($file_data);
			}
			
		}
	}
	
	/**
	 * convert_to_pdf
	 *
	 * @access private
	 * @param string $html the html string to generate the page
	 * @param string $genid
	 * @return string the pdf name
	 */
	private function convert_to_pdf($html, $genid) {
		if(is_exec_available()){
			//controlar q sea linux
			$pdf_name = "gantPag".$genid.".pdf";
			$pdf_path = "tmp/".$pdf_name;
			
			//convert to image
			$img_name = $this->convert_to_img($html, $genid);
			$img_path = "tmp/".$img_name;
			
			if(!$img_name){
				return false;
			}
			
			//convert png to pdf in background
			exec("convert ".$img_path." ".$pdf_path." > /dev/null &", $result, $return_var);
			
			if ($return_var > 0){
				Logger::log("command not found convert",Logger::WARNING);
				return false;
			}
			
			//wait for the file
			$seconds = 8;
			while (!file_exists(ROOT."/tmp/".$pdf_name) && $seconds > 0){
				sleep(1);
				$seconds = $seconds - 1;
			}
			//give time to finish
			sleep(2);
			$filesize = filesize(ROOT."/tmp/".$pdf_name);
			
			//delete the png file
			unlink($img_path);
			
			//check if pdf exist
			if (!file_exists(ROOT."/tmp/".$pdf_name)) {
				return false;
			}
			
			return array('name' => $pdf_name, 'size' => $filesize);
		}
	}
	
	/**
	 * convert_to_img
	 *
	 * @access private
	 * @param string $html the html string to generate the page
	 * @param string $genid 
	 * @return string the image name
	 */
	private function convert_to_img($html, $genid) {
		if(is_exec_available()){
			$img_name = "gantPag".$genid.".png";
			$img_path = "tmp/".$img_name;
			
			//generate the html page
			$html_page_name = $this->generate_html_page($html, $genid);
			$html_page_path = "tmp/".$html_page_name;
			
			//convert html to png in background
			if (substr(php_uname(), 0, 7) == "Windows") {
					
				if (!defined('WKHTMLTOPDF_PATH')) define('WKHTMLTOPDF_PATH', "C:\\Program Files\\wkhtmltopdf\\bin\\");
				$command_location = with_slash(WKHTMLTOPDF_PATH) . "wkhtmltoimage";
					
				$command = "\"$command_location\" --encoding 'utf-8' --quality 10 \"".$html_page_path."\" \"".$img_path."\"";
				
			} else {
				$command = "wkhtmltoimage --encoding 'utf-8' --quality 10 \"".$html_page_path."\" \"".$img_path."\" > /dev/null &";
			}
			exec($command, $result, $return_var);
						
			if ($return_var > 0){
				Logger::log("command not found wkhtmltoimage",Logger::WARNING);
				return false;
			}
						
			//wait for the file
			$seconds = 8;
			while (!file_exists(ROOT."/tmp/".$img_name) && $seconds > 0){
				sleep(1);
				$seconds = $seconds - 1;
			}
			//give time to finish
			sleep(5);
						
			//check if image exist
			if (!file_exists(ROOT."/tmp/".$img_name)) {
				return false;
			}
			
			return 	$img_name;			
		}
	}
	
	/**
	 * generate_html_page
	 *
	 * @access private
	 * @param string $html the html string to generate the page	 
	 * @return string the html page name
	 */
	private function generate_html_page($html, $genid){
		$html_name = "gantPag".$genid.".html";
		$path = "tmp/".$html_name;
		$out = fopen($path, "w");
		fwrite($out, $html);
		fclose($out);
		
		return $html_name;
	}
	
	function download_file() {
		if (logged_user()->isGuest()) {
			flash_error(lang('no access permissions'));
			ajx_current("empty");
			return;
		}
		ajx_current("empty");
		
		if(array_var($_REQUEST, 'file_name')){
			$file_name = array_var($_REQUEST, 'file_name');
		}
		if(array_var($_REQUEST, 'file_type')){
			$file_type = array_var($_REQUEST, 'file_type');
		}
		
		$file_path = "tmp/".$file_name;
		$size = filesize($file_path);
		
		//user current date
		$now_date = DateTimeValueLib::now();
		$now_date->advance(logged_user()->getUserTimezoneValue());
		$now = $now_date->format('Y-m-d_H:i:s');
		
		download_file($file_path, 'text/'.$file_type , "Gantt_".$now.".".$file_type , $size, true);
		
		unlink($file_path);
		
		die();
	}
	
}