<?php $genid = gen_id(); ?>
<div class="x-clear"></div>
<div class="gantt-chart-widget widget">

	<div class="widget-header" onclick="og.dashExpand('<?php echo $genid?>');">
		<?php echo lang('gantt chart'); ?>
		<div class="dash-expander ico-dash-expanded" id="<?php echo $genid; ?>expander"></div>
	</div>
	
	<div class="widget-body" id="<?php echo $genid; ?>_widget_body">
	
		<div id="<?php echo $genid?>ganttChartContainer" class="gantt-chart-container" data-tasks-url="<?php get_url('task', 'view', array('id' => $this->getId())); ?>" ></div>
	
	</div>
</div>

<script>

var projects = [];
<?php 
	$i=0;
	foreach ($projects as $project) {
		$sdate = null;
		$lower_ts = null;
		$nodes = '';

		foreach($gantt_tasks as $task){
			
			if (!$task->getStartDate() instanceof DateTimeValue) continue;
			
			$sd = $task->getStartDate()->getTimestamp();
			$dd = $task->getDueDate() instanceof DateTimeValue ? $task->getDueDate()->getTimestamp() : $sd + $task->getTimeEstimate()*60;
			
			$sd = $sd + logged_user()->getUserTimezoneValue();
			$dd = $dd + logged_user()->getUserTimezoneValue();
		
			if ($sd > 0 && (is_null($lower_ts) || $lower_ts > $sd)) $lower_ts = $sd;
			
			$duration = (int) (($dd - $sd)/(3600));
			$previous_task = array_var($gantt_tasks_dependencies, $task->getId(), "");
			
			$nodes .= "\n".'projects['.$i.'].addTask(new GanttTaskInfo('.$task->getId().', "'.clean($task->getObjectName()).'", new Date('.date('Y', $sd).','.(date('m', $sd)-1).', '.date('d', $sd).'), '.$duration.', '.(int) $task->getPercentCompleted().', "'.$previous_task.'"));';
		}
		
		$i++;
		
		if (is_null($lower_ts)) $sdate = 'new Date()';
		else $sdate = 'new Date('.date('Y', $lower_ts).','.(date('m', $lower_ts)-1).', '.date('d', $lower_ts).')';
?>
		projects.push(new GanttProjectInfo(<?php echo $project->getId()?>, '<?php echo escape_character(clean($project->getObjectName()))?>', <?php echo $sdate ?>));
<?php } ?>

	var ganttChartControl = new GanttChart();
	ganttChartControl.setImagePath("plugins/gantt/public/assets/javascript/dhtmlxGantt/codebase/imgs/");
	ganttChartControl.setEditable(false);

	for(i=0; i<projects.length; i++) {
		ganttChartControl.addProject(projects[i]);
	}
	<?php echo $nodes; ?>
	
	$('#<?php echo $genid?>ganttChartContainer').html('');
	$('#<?php echo $genid?>ganttChartContainer').css('height','320px');
	ganttChartControl.create('<?php echo $genid?>ganttChartContainer');
	
</script>
