<?php
Hook::register("gesl_remote");

if (!defined('SCRIPT_TO_CREATE_REMOTE_FOLDER')) {
	define('SCRIPT_TO_CREATE_REMOTE_FOLDER', ROOT . '/gesl_create_remote_folder.sh');
}
if (!defined('RMEOTE_FOLDER_CREATION_LOG')) {
	define('RMEOTE_FOLDER_CREATION_LOG', ROOT . '/cache/remote_folder_creation.log');
}

function gesl_remote_after_member_save_and_commit($params, &$ret) {
	
	$is_new = array_var($params, 'is_new');
	$member = array_var($params, 'member');
	if (!$member instanceof Member) {
		return;
	}
	
	$dim_id = config_option("dimension_that_generate_folders");
	$project_ot = ObjectTypes::findByName('project');
	
	if ($dim_id == $member->getDimensionId() && $is_new && $member->getObjectTypeId() == $project_ot->getId()) {
		/*
		$all_hierarchy_members = $member->getAllParentMembersInHierarchy(true, false);
		$mem_names = array();
		foreach ($all_hierarchy_members as $m) {
			$mem_names[] = $m->getName();
		}
		$mem_names = array_reverse($mem_names);
		
		// implode with 4 directory separator escaped => it results in 8 slashes
		$folder_name = implode('\\\\\\\\', $mem_names);
		*/
		
		$folder_name = trim($member->getName());
		$folder_name = preg_replace("/[^a-zA-Z ]/", "", $folder_name);
		
		// remove tabs and extra spaces
		$folder_name = preg_replace('/[ ]{2,}|[\t]/', ' ', trim($folder_name));
		
		if (function_exists("get_prefix_for_object")) {
			$project = Projects::instance()->findById($member->getObjectId());
			if ($project instanceof Project) {
				$prefix_obj = get_prefix_for_object($project);
				if ($prefix_obj instanceof ObjectPrefix) {
					$prefix = $prefix_obj->getPrefix();
					if (!str_starts_with($folder_name, $prefix)) {
						$folder_name = $prefix .OBJECT_PREFIX_SEPARATOR. $folder_name;
					}
				}
			}
		}
		
		Env::useHelper('sharepoint_functions', 'gesl_remote_actions');
		create_project_folder_in_sharepoint($folder_name);
		
		/*
		// build command
		$command = 'sh ' . SCRIPT_TO_CREATE_REMOTE_FOLDER . ' "'. $folder_name .'" >> '.ROOT.'/cache/remote_folder_creation_'.date('Y_m_d').'.log';
		
		// log command to execute
		file_put_contents(RMEOTE_FOLDER_CREATION_LOG, date('Y-m-d H:i:s')." $command\n", FILE_APPEND);
		
		// execute command: execute the script that creates the remote folder
		exec($command);
		*/
	}
	
}
