<?php

class HourTypeController extends ApplicationController {

	function __construct() {
		parent::__construct();
		prepare_company_website_controller($this, 'website');
	} // __construct
	

	function fill_user_default_labor_category_from_request($user) {

		if ($user instanceof Contact && $user->isUser() && isset($_REQUEST['contact'])) {

			// get the form submitted data from the request
			$default_hour_type_id_json = array_var($_REQUEST['contact'], 'default_hour_type_id');
			
			// if attribute was not sent don't update anything
			if (!is_null($default_hour_type_id_json)) {
				// decode the data sent by the member selector input
				$decoded = json_decode($default_hour_type_id_json, true);
				$default_hour_type_id = count($decoded) > 0 ? $decoded[0] : 0;
	
				// do the query directly to the database to avoid calling the "save" function and trigger unnecessary hooks
				DB::execute("
					UPDATE ".TABLE_PREFIX."contacts
					SET default_hour_type_id = '$default_hour_type_id'
					WHERE object_id = ".$user->getId()."
				");
			}
		}
	}


	function get_user_default_hour_type() {

		ajx_current("empty");
		
		$user_id = array_var($_REQUEST, 'user_id');
		$genid = array_var($_REQUEST, 'genid');
		$task_id = array_var($_REQUEST, 'task_id');
		
		$ht_dimension = Dimensions::findByCode('hour_types');

		$remove_on_empty = true;
		$member_id = 0;
		$dimension_id = $ht_dimension->getId();
		$hour_type_set = false;
		$task_member_ids = array();
		
		if ($task_id > 0) {
			$task = ProjectTasks::instance()->findById($task_id);
			if ($task instanceof ProjectTask) {
				$task_member_ids = $task->getMemberIds();
			}
		}
		
		if (count($task_member_ids) > 0) {
			foreach ($task_member_ids as $mid) {
				$m = Members::instance()->findById($mid);
				if ($m instanceof Member && $m->getDimensionId() == $ht_dimension->getId()) {
					$hour_type_set = true;
					$remove_on_empty = null;
					break;
				}
			}
		}
		
		$user = Contacts::instance()->findById($user_id);
		if (!$hour_type_set && $user instanceof Contact && $user->getColumnValue('default_hour_type_id') > 0) {
			$member = Members::instance()->findById($user->getColumnValue('default_hour_type_id'));
			if ($member instanceof Member) {
				$member_id = $member->getId();
			}
		}
		
		ajx_extra_data(array(
				'genid' => $genid,
				'member_id' => $member_id,
				'dimension_id' => $dimension_id,
				'remove_on_empty' => $remove_on_empty,
		));
	}



	function get_labor_category_data() {
		ajx_current("empty");
		
		$genid = array_var($_REQUEST, 'genid');
		$cat_id = array_var($_REQUEST, 'id');
		$data = array();

		$labor_category = Members::getMemberById($cat_id);

		if ($labor_category instanceof Member) {
			$data = $labor_category->getArrayInfo();
	
			if (Plugins::instance()->isActivePlugin('member_custom_properties')) {
				$cps = MemberCustomProperties::instance()->findAll(array("conditions" => array("object_type_id=? AND code<>''", $labor_category->getObjectTypeId())));
				foreach ($cps as $cp) {
					$v = MemberCustomPropertyValues::getMemberCustomPropertyValue($labor_category->getId(), $cp->getId());
					if ($v instanceof MemberCustomPropertyValue) {
						$data[$cp->getCode()] = $v->getValue();
					} else {
						$data[$cp->getCode()] = $cp->getDefaultValue();
					}
				}
			}
		}

		ajx_extra_data(array(
			'genid' => $genid,
			'member_data' => $data,
		));
	}

} // HourTypeController
