og.hour_types = {
	init: function () {
		
		if (!og.on_ts_contact_combo_select) og.on_ts_contact_combo_select = []; 
		og.on_ts_contact_combo_select.push(og.hour_types.select_hour_type_by_contact);
		
		if (!og.time_quick_add_user_combo_listeners) og.time_quick_add_user_combo_listeners = {};
		og.time_quick_add_user_combo_listeners['select'] = og.hour_types.quick_add_user_combo_select;
	},
	
	quick_add_user_combo_select: function(combo, record, index) {
		var params = {genid: combo.genid, selected_user_id: combo.getValue(), combo: combo, task_id:0, isQuickAdd: true};
		og.hour_types.select_hour_type_by_contact(params);
	},
	
	member_selector_add_relation: function(ignored1, ignored2, data) {
		member_selector.add_relation(data.dimension_id, data.genid, data.member_id);
	},

	after_quick_add_labor_cat_select: function(combo) {

		let is_billable_combo = Ext.getCmp(combo.genid + 'add_ts_is_billable');
		if (is_billable_combo) {
			// check if selected labor category is billable or not and autocomplete the is_billable selector
			og.openLink(og.getUrl('hour_type', 'get_labor_category_data', {id: combo.getValue(), genid: combo.genid}), {
				hideLoading: true,
				callback: function(success, data) {
					
					if (data && data.member_data) {
						let is_billable = parseInt(data.member_data.is_billable) > 0;
						
						let ts_billable_selector_val = is_billable ? 'yes' : 'no';
	
						let is_billable_combo = Ext.getCmp(data.genid + 'add_ts_is_billable');
						if (is_billable_combo) {
							is_billable_combo.setValue(ts_billable_selector_val);
							og.quick_add_row_time_on_is_billable_select(is_billable_combo);
						}
					}
				}
			});
		}
	},
	
	select_hour_type_by_contact: function(params) {
		var genid = params.genid;
		var selected_user_id = params.selected_user_id;
		var combo = params.combo;
		var task_id = params.task_id;
		var isQuickAdd = params.isQuickAdd ? true : false;
		
		if (selected_user_id > 0) {
			og.openLink(og.getUrl('hour_type', 'get_user_default_hour_type', {user_id: selected_user_id, genid: genid, task_id: task_id}), {
				hideLoading: true,
				callback: function(success, data) {

					if(isQuickAdd) {
						var selector = null;
						if (og.simple_member_selectors[data.genid] && og.simple_member_selectors[data.genid][data.dimension_id]) {
							selector = og.simple_member_selectors[data.genid][data.dimension_id];
						}
						if (selector) {
							// check if we have a labor category in the current context (left panel tree)
							let context_hour_types = og.contextManager.getDimensionMembers(data.dimension_id);
							context_hour_types = context_hour_types.filter(function(mid){ return mid > 0; });

							// if user has a labor category selected in context then use that
							if (context_hour_types && context_hour_types.length > 0) {
								selector.selectMember(context_hour_types[0]);
							} else {
								// use default labor category
								if (data && data.member_id) {
									selector.selectMember(data.member_id);
								} else if (data.remove_on_empty) {
									selector.selectMember(0);
								}
							}

							// autofill the is_billable selector
							og.hour_types.after_quick_add_labor_cat_select(selector);
						}
					} else {
	
						if (data && data.member_id) {
							
							member_selector.remove_all_dimension_selections(data.genid, data.dimension_id);
							
							if (og.dimensions && og.dimensions[data.dimension_id] && og.dimensions[data.dimension_id][data.member_id]) {
								// if member data already in cache -> use it and select the member
								member_selector.add_relation(data.dimension_id, data.genid, data.member_id);
							} else {
								// go to server and get the member data and then select the member
								og.getMemberFromServer(data.member_id, og.hour_types.member_selector_add_relation, data);
							}
							
							$("#"+data.genid+"-member-chooser-panel-"+data.dimension_id+"-tree-current-selected .empty-text").hide();

							// patch for time quick add row
							$("#"+data.genid+"members_input_"+data.dimension_id).val("["+data.member_id+"]");
							
						} else if (data.remove_on_empty) {

							member_selector.remove_all_dimension_selections(data.genid, data.dimension_id);
							$("#"+data.genid+"-member-chooser-panel-"+data.dimension_id+"-tree-current-selected .empty-text").show();
							
							// patch for time quick add row
							$("#"+data.genid+"members_input_"+data.dimension_id).val("[]");
						}
					}
				}
			});
		}
	},
	
	show_hide_time_off_code_cp: function(genid, is_time_off_cp_id, time_off_code_cp_id) {
		
		let is_time_off = $("#" + genid + 'cp' + is_time_off_cp_id).val() == 1;

		if (is_time_off) {
			$("#" + genid + '-container-cp' + time_off_code_cp_id).show();
		} else {
			$("#" + genid + '-container-cp' + time_off_code_cp_id).hide();
		}
		
	}
}