<?php

/**
 * InvoiceChildController
 * Generado el 17/11/2022
 * 
 */
class InvoiceChildController extends ApplicationController {

    var $plugin_name = "income";

    /**
     * Construct the InvoiceChildController
     *
     * @access public
     * @param void
     * @return InvoiceChildController
     */
    function __construct() {
        parent::__construct();
        prepare_company_website_controller($this, 'website');
    }

    /**
     * Show parents-childs
     *
     * @param void
     * @return null
     */
    function index() {
        if (!can_manage_invoicing_configuration(logged_user())) {
            flash_error(lang('no access permissions'));
            ajx_current("empty");
            return;
        } // if
        $this->addHelper('textile');

        $parentChilds = IncomeInvoiceChilds::instance()->findAll(array('condition' => array('removed_by_id = 0')));
        tpl_assign('parentChilds', $parentChilds);

    }
    
    
    function add() {
    	if (!can_manage_invoicing_configuration(logged_user())) {
    		flash_error(lang('no access permissions'));
    		ajx_current("empty");
    		return;
    	}
    	
    	$parentChilds_post = array_var($_POST, 'parentChilds');
	    	try {
	    		DB::beginWork();
	    		$parentChilds_data = new IncomeInvoiceChild();
	    		
				$this->save_parentChilds($parentChilds_post, $parentChilds_data, true);
				
	    		if (array_var($_REQUEST, 'modal')) {
	    			evt_add("reload current panel");
		    		ajx_current("empty");
	    		} else {
	    			ajx_current("reload");
	    		}
	    		
	    		DB::commit();
    		} catch (Exception $e) {
    			DB::rollback();
    			flash_error($e->getMessage());
    			ajx_current("empty");
    		}
    }
    
    function save_parentChilds($parentChilds_post, $parentChilds_data, $is_new=true) {
    	
    	$parentChilds_data->setFromAttributes($parentChilds_post);
    	$parentChilds_data->save();
   		
   		$parentChild_record = new IncomeInvoiceChild();
   		$parentChild_record->setInvoiceParentd($parentChilds_post['object_id_parent']);
   		$parentChild_record->setInvoiceChild($parentChilds_post['object_id_child']);
   		$parentChild_record->save();
    	
    	if ($is_new) {
    		flash_success(lang('success add parentChild'));
    	} else {
    		flash_success(lang('success edit parentChild'));
    	}
    	
    }
    

    function delete() {
        ajx_current("empty");
        $invoice = IncomeInvoiceChilds::instance()->findById(get_id("object_id_parent"));
        $invoice->delete();

        flash_success(lang('success delete invoice child'));
    }

}

?>