<?php

/**
 * IncomeInvoiceLine
 * Generado el 10/5/2012
 * 
 */
class IncomeInvoiceLine extends BaseIncomeInvoiceLine {
    // ---------------------------------------------------
    //  System
    // ---------------------------------------------------

    /**
     * Delete this object
     *
     * @access public
     * @param void
     * @return boolean
     */
    function delete() {
    	
    	IncomeInvoiceLineTaxes::instance()->delete("invoice_line_id = ".$this->getId());
    	
        return parent::delete();
    }

    /**
     * Validate before save
     *
     * @access public
     * @param array $errors
     * @return null
     */
    function validate($errors) {
        
    }

    function getArrayInfo() {
        return array(
	            "id" => $this->getId(),
	            "object_id" => $this->getObjectId(),
	            "amount" => $this->getAmount(),
	            "unit_value" => $this->getUnitValue(),
         		"detail" => $this->getDetail(),
        		"exchange_rate" => $this->getExchangeRate(),
        		"currency_id" => $this->getCurrencyId(),
        		"user_id" => $this->getUserId(),
        		"date" => $this->getDate(),
        		"category_id" => $this->getCategoryId(),
        		"rel_object_id" => $this->getRelObjectId(),
        );
    }
    
    function getUserName() {
    	$u = Contacts::instance()->findById($this->getUserId());
    	return $u instanceof Contact ? $u->getObjectName() : '';
    }
    
    function getUserInitials() {
        $u = Contacts::instance()->findById($this->getUserId());
		if (!$u instanceof Contact) return '';
        
        $cp = CustomProperties::instance()->findOne(array('conditions' => "code ='initials'"));
		if (!$cp instanceof CustomProperty) return '';

		$cp_value = CustomPropertyValues::getCustomPropertyValue($u->getId(), $cp->getId());
		if ($cp_value instanceof CustomPropertyValue) {
			return $cp_value->getValue();
		} else {
			return '';
		}  
    }
    
    function getCurrencyId() {
    	if ($this->columnExists('currency_id')) {
    		return $this->getColumnValue('currency_id');
    	}
    	return 0;
    }
    
    function getExchangeRate() {
    	if ($this->columnExists('exchange_rate')) {
    		return $this->getColumnValue('exchange_rate');
    	}
    	return 1;
    }
    
    function getLineTaxes() {
    	return IncomeInvoiceLineTaxes::getAllLineTaxes($this->getId());
    }
    
    function getLineTaxesInfo() {
    	return IncomeInvoiceLineTaxes::getAllLineTaxesInfo($this->getId());
    }
    
}

?>