<?php

/**
 * IncomeInvoiceNotebook
 * Generado el 20/8/2012
 * 
 */
class IncomeInvoiceNotebook extends BaseIncomeInvoiceNotebook {
    // ---------------------------------------------------
    //  System
    // ---------------------------------------------------

    /**
     * Delete this object
     *
     * @access public
     * @param void
     * @return boolean
     */
    function delete() {
        $this->setRemovedOn(date('Y-m-g H:m'));
        $this->setRemovedById(logged_user()->getId());
        $this->save();
        //return parent::delete();
    }
    
    function getInvoiceType() {
        $type = ObjectSubtypes::instance()->findById($this->getInvoiceTypeId());
        return $type instanceof ObjectSubtype ? $type->getName() : "";
    }

    /**
     * Validate before save
     *
     * @access public
     * @param array $errors
     * @return null
     */
    function validate($errors) {
        if (!$this->validatePresenceOf('expiration_date')) {
            $errors[] = lang('expiration date required');
        }
        if (!$this->validatePresenceOf('series')) {
            $errors[] = lang('series required');
        }
        if (!$this->validatePresenceOf('initial_number')) {
            $errors[] = lang('initial number required');
        }
        if (!$this->validatePresenceOf('final_number')) {
            $errors[] = lang('final number required');
        }
        if (!$this->validatePresenceOf('invoice_type_id')) {
            $errors[] = lang('invoice type required');
        }
    }

    function getArrayInfo() {
        return array(
            "id" => $this->getId(),
            "invoice_type_id" => $this->getInvoiceTypeId(),
            "rut" => $this->getRut(),
            "expiration_date" => $this->getExpirationDate() instanceof DateTimeValue ? $this->getExpirationDate()->advance(logged_user()->getUserTimezoneValue(), false) : null,
            "series" => $this->getSeries(),
            "initial_number" => $this->getInitialNumber(),
            "final_number" => $this->getFinalNumber(),
            "address" => $this->getAddress(),
            "extra_information" => $this->getExtraInformation(),
            "press_information" => $this->getPressInformation(),
        );
    }

}

?>