<?php

class IncomeInvoiceReference extends BaseIncomeInvoiceReference {
    // ---------------------------------------------------
    //  System
    // ---------------------------------------------------

    /**
     * Delete this object
     *
     * @access public
     * @param void
     * @return boolean
     */
    function delete() {
        return parent::delete();
    }

    /**
     * Validate before save
     *
     * @access public
     * @param array $errors
     * @return null
     */
    function validate($errors) {
        
    }

    function getArrayInfo() {
        return array(
            "id" => $this->getId(),
            "object_id" => $this->getObjectId(),
            "serie" => $this->getSerie(),
            "invoice_number" => $this->getInvoiceNumber(),
            "referenced_object_id" => $this->getReferencedObjectId(),
            "amount" => $this->getAmount(),
            "detail" => $this->getDetail(),
            "referenced_object_name" => $this->getReferencedObjectName()
        );
    }

	function getReferencedObjectName() {
		$name = '';

		$referenced_object = $this->getReferencedObject();
		if ($referenced_object instanceof IncomeInvoice) {
			if ($referenced_object->getInvoiceNumber() != '') {
				$name = $referenced_object->getInvoiceType() ." ". $referenced_object->getInvoiceNumber();
			} else {
				$name = $referenced_object->getName();
			}
		} else {
			// backwards compatibility
			$name = trim($this->getSerie() . " " . $this->getInvoiceNumber());
		}

		return $name;

	}

	function getMainObject() {
		return IncomeInvoices::instance()->findById($this->getObjectId());
	}

	function getReferencedObject() {
		return IncomeInvoices::instance()->findById($this->getReferencedObjectId());
	}
}

?>