<?php

/**
 * IncomeInvoiceTemplates
 * Created: 06/15/20
 * Author: Alex Zonis
 * 
 */
class IncomeInvoiceTemplateOptions extends BaseIncomeInvoiceTemplateOptions {

    function __construct() {
        parent::__construct();
    }

	/**
	 * get table project option
	 */
	static function getInvoiceTemplateProjectTable(int $template_id) {
		
		$invoice_template_options = self::getInvoiceTemplateOptions($template_id);
		
		$invoice_template_options_array=[];

		foreach ($invoice_template_options as $invoice_template_option) {
			//create an array with the options
			$invoice_template_options_items['name'] = $invoice_template_option->getName();
			$invoice_template_options_items['label'] = $invoice_template_option->getLabel();
			$invoice_template_options_items['order'] = $invoice_template_option->getOrderNumber();
			$invoice_template_options_items['visible'] = $invoice_template_option->getVisible();
			$invoice_template_options_items['selected_option'] = $invoice_template_option->getSelectedOption();
			$invoice_template_options_array[$invoice_template_option->getName()] = $invoice_template_options_items;
		}	

		return $invoice_template_options_array;

	}

	static function getInvoiceTemplateOptions(int $template_id) {
    	$info = array();
    	$templates = IncomeInvoiceTemplateOptions::instance()->find(array(
			'conditions' => array('`template_id` = ?', $template_id),
			'order' => '`order_number` ASC'
		));
    	return $templates;
    }
    
	
    
    static function getInvoiceTemplateOption($template_id, $option_name) {
		$option = self::instance()->findOne(array("conditions" => "template_id = $template_id AND name = '$option_name'"));
		if ($option instanceof IncomeInvoiceTemplateOption) {
			return $option->getArrayInfo(false);
		}
		return null;
	}
    
}
