<?php

/**
 * IncomeInvoiceTemlate
 * Created: 06/15/20
 * Author: Alex Zonis
 * 
 */
class IncomeInvoiceTemplate extends BaseIncomeInvoiceTemplate
{
	// ---------------------------------------------------
	//  System
	// ---------------------------------------------------

	function getArrayInfo($include_html_fields = true)
	{

		$result = array();
		foreach ($this->getColumns() as $col) {
			$result[$col] = $this->getColumnValue($col);
		}

		if (!$include_html_fields) {
			unset($result['footer_text']);
		}

		return $result;
	}

	function orderMultiDimensionalArray($toOrderArray, $field, $inverse)
	{
		$position = array();
		$newRow = array();
		foreach ($toOrderArray as $key => $row) {
			$position[$key] = $row[$field];
			$newRow[$key] = $row;
		}
		if ($inverse) {
			arsort($position);
		} else {
			asort($position);
		}
		$returnArray = array();
		foreach ($position as $key => $pos) {
			$returnArray[] = $newRow[$key];
		}
		return $returnArray;
	}

	function getHtmlDetailsTableForInvoice(IncomeInvoice $invoice, $print_options = array())
	{
		Env::useHelper('functions', 'income');
		$use_taxes_in_lines = income_config_option("use_line_taxes");
		$print_labels = array_var($print_options, 'labels', array());

		$use_taxes_in_lines = income_config_option("use_line_taxes");

		$date_format = $this->getDateFormat();
		if (!$date_format) {
			$date_format = user_config_option('date_format');
		}

		/***********lump sum and timeslots */
		$column_order = array();
		$columns = array();

		/***************EXPENSES LINES **********************/
		$act_exp_column_order = array();
		$act_exp_columns = array();

		if ($use_taxes_in_lines && $this->getShowTaxesForEachLine()) {
			$inv_taxes = $invoice->getTaxes();
			$taxes_by_id = array();
			foreach ($inv_taxes as $inv_tax) {
				$column_order[] = 'tax_' . $inv_tax->getTaxId();
				$taxes_by_id[$inv_tax->getTaxId()] = IncomeTaxes::instance()->findById($inv_tax->getTaxId());
			}
		}

		if ($use_taxes_in_lines && $this->getShowTaxesForEachLine()) {
			foreach ($inv_taxes as $inv_tax) {
				$columns['tax_' . $inv_tax->getTaxId()] = $taxes_by_id[$inv_tax->getTaxId()]->getName();
			}
		}

		/*******detailed template*************/
		if (
			$this->getTemplateType() == 'detailed'
			|| ($this->getTemplateType() == 'fixed fee tasks'
				//&& $this->getTaskGroup()!='aggregated into a single line'
			)
		) {

			/******************TIMES LINES*****************/
			if ($this->getIncludeDate()) {
				$column_order[] = 'date';
				$columns['date'] = $this->getCustomLabelIncludeDate();
			}

			if (strtolower($this->getIncludeUserNameCol()) != strtolower('Do not Display')) {
				$column_order[] = 'user';
				$columns['user'] = $this->getCustomLabelIncludeUserNameCol();
				$initials = $this->getIncludeUserNameCol() == 'Initials';
			}

			if ($this->getCategoryForTimeslotCol()) {
				$column_order[] = 'category';
				$columns['category'] = $this->getCustomLabelCategoryForTimeslotCol();
			}
			/*deprecated*/
			if ($this->getProductTypeForTimeslotCol()) {
				$column_order[] = 'product type';
				$columns['product type'] = lang('product type');
			}

			if ($this->getIncludeDescription() || $this->getIncludeCustomDescription()) {
				$column_order[] = 'description';
				$columns['description'] = $this->getCustomLabelIncludeDescription();
			}

			if ($this->getIncludeHours()) {
				$column_order[] = 'amount';
				$columns['amount'] = $this->getCustomLabelIncludeHours();
				;
			}

			if ($this->getIncludeRate()) {
				$column_order[] = 'unit_value';
				$columns['unit_value'] = $this->getCustomLabelIncludeRate();
			}

			if ($this->getIncludeTotal()) {
				$column_order[] = 'total';
				$columns['total'] = $this->getCustomLabelIncludeTotal();
			}

			///////////////////Expenses///////////////////////////////
			////date
			if ($this->getIncludeExpDate()) {
				$act_exp_column_order[] = 'date';
				$act_exp_columns['date'] = $this->getCustomLabelIncludeExpDate();
			}

			if (strtolower($this->getIncludeExpUserNameCol()) != strtolower('Do not Display')) {
				$act_exp_column_order[] = 'user';
				$act_exp_columns['user'] = $this->getCustomLabelIncludeExpUserNameCol();
				$initials_exp = $this->getIncludeExpUserNameCol() == 'Initials';
			}

			if ($this->getProductTypeForExpenseCol()) {
				$act_exp_column_order[] = 'product type';
				$act_exp_columns['product type'] = $this->getCustomLabelProductTypeForExpensesCol();
			}

			if ($this->getCategoryForExpenseCol()) {
				$act_exp_column_order[] = 'category';
				$act_exp_columns['category'] = $this->getCustomLabelCategoryForExpensesCol();
			}

			///detail
			if ($this->getIncludeExpDescription()) {
				$act_exp_column_order[] = 'description';
				$act_exp_columns['description'] = $this->getCustomLabelIncludeExpDescription();
			}

			///quantity
			if ($this->getIncludeExpQuantity()) {
				$act_exp_column_order[] = 'amount';
				$act_exp_columns['amount'] = $this->getCustomLabelIncludeExpQuantity();
			}

			//unit cost

			if ($this->getIncludeExpUnitCost()) {
				$act_exp_column_order[] = 'unit_cost';
				$act_exp_columns['unit_cost'] = $this->getCustomLabelIncludeExpUnitCost();
			}

			///fee
			if ($this->getIncludeExpFee()) {
				$act_exp_column_order[] = 'fee';
				$act_exp_columns['fee'] = $this->getCustomLabelIncludeExpFee();
			}

			// markup amount
			if ($this->getIncludeExpMarkupAmount()) {
				$act_exp_column_order[] = 'markup_amount';
				$act_exp_columns['markup_amount'] = $this->getCustomLabelIncludeExpMarkupAmount();
			}

			///amount
			if ($this->getIncludeExpAmount()) {
				$act_exp_column_order[] = 'unit_value';
				$act_exp_columns['unit_value'] = $this->getCustomLabelIncludeExpAmount();
			}



			///total
			if ($this->getIncludeExpTotal()) {
				$act_exp_column_order[] = 'total';
				$act_exp_columns['total'] = $this->getCustomLabelIncludeExpTotal();
			}


			// set the same amount of columns for each table
			$exp_col_count = count($act_exp_column_order);
			while ($exp_col_count < count($column_order)) {
				$last_cols_count = $this->getDisplayCostOrPrice() == 'cost_and_fee' ? -4 : -3; //getIncludeExpFee getDisplayCostOrPrice
				$last_cols = array_splice($act_exp_column_order, $last_cols_count);
				$act_exp_column_order[] = '';
				$act_exp_column_order = array_merge($act_exp_column_order, $last_cols);
				$exp_col_count++;
			}

			$col_count = count($column_order);
			while ($col_count < count($act_exp_column_order)) {
				$last_3_cols = array_splice($column_order, -3);
				$column_order[] = '';
				$column_order = array_merge($column_order, $last_3_cols);
				$col_count++;
			}

		} else if ($this->getTemplateType() == 'lumpsum') {
			//|| ($this->getTemplateType()=='fixed fee tasks' && $this->getTaskGroup()=='aggregated into a single line')){

			if ($this->getIncludeLumpSumDateCol()) {
				$column_order[] = 'date';
				$columns['date'] = $this->getCustomLabelIncludeLumpSumDateCol();
				$act_exp_column_order[] = 'date';
				$act_exp_columns['date'] = $this->getCustomLabelIncludeLumpSumDateCol();
			}

			if ($this->getCategoryForLumpSumCol()) {
				$column_order[] = 'category';
				$columns['category'] = $this->getCustomLabelCategoryForLumpSumCol();
				$act_exp_column_order[] = 'category';
				$act_exp_columns['category'] = $this->getCustomLabelCategoryForLumpSumCol();
			}
			if ($this->getProductTypeForLumpSumCol()) {
				$column_order[] = 'product type';
				$columns['product type'] = $this->getCustomLabelProductTypeForLumpSumCol();
				$act_exp_column_order[] = 'product type';
				$act_exp_columns['product type'] = $this->getCustomLabelProductTypeForLumpSumCol();
			}

			$column_order[] = 'description';
			$columns['description'] = $this->getCustomLabelIncludeLumpSumDeetailCol();
			$act_exp_column_order[] = 'description';
			$act_exp_columns['description'] = $this->getCustomLabelIncludeLumpSumDeetailCol();

			if ($this->getIncludeLumpQuantity()) {
				$column_order[] = 'amount';
				$columns['amount'] = $this->getCustomLabelIncludeLumpSumQuantity();
				$act_exp_column_order[] = 'amount';
				$act_exp_columns['amount'] = $this->getCustomLabelIncludeLumpSumQuantity();
			}

			if ($this->getIncludeLumpSumUnitPrice()) {
				$column_order[] = 'unit_value';
				$columns['unit_value'] = $this->getCustomLabelIncludeLumpSumUnitPrice();
				$act_exp_column_order[] = 'unit_value';
				$act_exp_columns['unit_value'] = $this->getCustomLabelIncludeLumpSumUnitPrice();
			}

			if ($this->getTemplateType() == 'lumpsum' && $use_taxes_in_lines && $this->getShowTaxesForEachLine()) {

				$column_order[] = 'subtotal';
				$columns['subtotal'] = lang('subtotal');
			}

			$column_order[] = 'total';
			$columns['total'] = lang('total');
			$act_exp_column_order[] = 'total';
			$act_exp_columns['total'] = lang('total');

		} else if ($this->getTemplateType() == 'lumpsum_view') {
			$column_order = array('description', 'amount', 'total');
			$columns = array(
				'description' => lang('description'),
				'amount' => lang('quantity'),
				'total' => lang('amount'),
			);

		}

		if ($this->getBreakDownBySubprojects() == 'MULTI') {
			//1 get all the invoices related
			$invoice_ids = [];

			$resInvoices = IncomeInvoiceChilds::getInvoiceChild($invoice->getObjectId());

			//search by childs invoices
			if (!$resInvoices) {
				$resInvoicesParents = IncomeInvoiceChilds::getInvoiceParent($invoice->getObjectId());
				foreach ($resInvoicesParents as $resInvoicesParent) {
					$resInvoices = IncomeInvoiceChilds::getInvoiceChild($resInvoicesParent->getInvoiceParent());
				}
			}

			foreach ($resInvoices as $resInvoice) {
				$invoice_ids[] = $resInvoice->getInvoiceChild();
			}

			//2 find all timeslot and expenses for all the invoices related
			$timeslots = Timeslots::instance()->findAll(array("conditions" => "invoice_id IN (" . implode(',', $invoice_ids) . ")"));
			$PaymentReceipts = PaymentReceipts::instance()->findAll(array("conditions" => "invoice_id IN (" . implode(',', $invoice_ids) . ")"));

			//3 group by subproject
			$this->setBreakDownBySubprojects('SINGLE');
			$grouped_timeslots = IncomeInvoiceTemplates::groupTimeslotsUsingTemplate($this, $timeslots);
			$grouped_payment_receipts = IncomeInvoiceTemplates::groupTimeslotsUsingTemplate($this, $PaymentReceipts);
			$this->setBreakDownBySubprojects('MULTI');

			//3 build the lines
			$lines = IncomeInvoiceTemplates::buildInvoiceLinesFromGroups($this, $grouped_timeslots, $grouped_payment_receipts);
		} else {
			$lines = $invoice->getInvoiceLines();
		}
		;

		$discount = 0;
		$subtotal = 0;
		$act_exp_subtotal = 0;
		$lines_data = array();
		$act_exp_lines_data = array();
		$line_groups = array();

		if ($this->getTemplateType() == 'lumpsum_view') {
			// generate one line accumulating all non-discount lines

			// build lump sum description {Project name}, {from date} To {until date}
			// project name
			$project_ot = ObjectTypes::findByName('project');
			$project_name = '';
			$invoice_members = $invoice->getMembers();
			foreach ($invoice_members as $invoice_member) {
				if ($invoice_member->getObjectTypeId() == $project_ot->getId()) {
					$project_name = $invoice_member->getName();
					break;
				}
			}

			// from date and to date
			$billing_from_cp = CustomProperties::getCustomPropertyByCode($invoice->getObjectTypeId(), 'billing_period_from');
			$billing_to_cp = CustomProperties::getCustomPropertyByCode($invoice->getObjectTypeId(), 'billing_period_to');
			$billing_from_date = '';
			$billing_to_date = '';
			$cp_val = CustomPropertyValues::getCustomPropertyValue($invoice->getId(), $billing_from_cp->getId());
			if ($cp_val && $cp_val->getValue() != '') {
				try {
					$dt = DateTimeValueLib::dateFromFormatAndString('Y-m-d', $cp_val->getValue());
					$billing_from_date = format_date($dt, $date_format, 0);
				} catch (Exception $e) {
				}
			}
			$cp_val = CustomPropertyValues::getCustomPropertyValue($invoice->getId(), $billing_to_cp->getId());
			if ($cp_val && $cp_val->getValue() != '') {
				try {
					$dt = DateTimeValueLib::dateFromFormatAndString('Y-m-d', $cp_val->getValue());
					$billing_to_date = format_date($dt, $date_format, 0);
				} catch (Exception $e) {
				}
			}

			// concat description parts
			$ls_description = $project_name . ", $billing_from_date " . lang('to') . " $billing_to_date";

			// accumulate lump sum total
			$ls_total_raw = 0;
			foreach ($lines as $line) {
				$ls_total_raw += $line->getTotal();
			}

			// total to show in line
			$c_sym = '$';
			$currency = Currencies::instance()->getCurrency($line->getCurrencyId());

			if ($currency) {
				$c_sym = $currency->getSymbol();
			}

			$ls_total = format_money_amount($ls_total_raw, $c_sym);
			$lineShowTotal = $ls_total_raw;

			// build lines data object to send to the view
			$ls_lines_data = array(
				array(
					'description' => $ls_description,
					'amount' => 1,
					'total' => $ls_total,
				)
			);

			$line_group_id = 0;
			$line_group_name = '';
			$line_group_code = '';

			// build lines group to send to the view
			$line_groups[$line_group_id] = self::initLineGroups($line_group_name, $line_group_code, $ls_lines_data);
			/*
												$line_groups[$line_group_id] = array(
													'name' => $line_group_name,
													'code' => $line_group_code,
													'lines_data' => $ls_lines_data,
													'discount' => 0,
													'subtotal' => $ls_total_raw,
													'act_exp_lines_data' => array(),
													'act_exp_subtotal' => 0,
													'labor_subtotal' => 0,
												);
												*/

		} else {
			$key = 0;
			$lineShowTotal = 0;
			foreach ($lines as $line) { /* @var $line IncomeInvoiceLine */

				if($this->getBreakDownBySubprojects()=='MULTI'){
					$key++;
					$lineCategoryId=$line['category_id'];	
					$lineGroupByCategoryId=$line['group_by_category_id'];
					$lineTotal = $use_taxes_in_lines ? $line['subtotal'] : $line['total'];
					$lineMemberId=$line['member_id'];
					$lineGetFormObjectType=$line['from_object_type_id'];;
					$lineGetCurrencyId=$line['currency_id'];;
					$lineGetDetail=$line['detail'];
					$lineGetDate=$line['date'];
					$lineGetUnitValue=$line['unit_value'];
					$lineGetId=$key;
					$lineGetProductType=$line['product_type_id'];
					$lineGetAnount=$line['amount'];
					$lineItemTypeId= $line['item_type_id'];
					$lineGetUnitCost=$line['unit_cost'];
					$lineGetPriceMultiplier=$line['price_multiplier'];
					$LineDiscountPercentType=$line['discount_percent_type'];;
					if($lineItemTypeId!=7)//retainer
					{
						$lineShowTotal=$lineShowTotal+$line['total'];
					}
					$lineUserNames=Contacts::instance()->findById($line['user_id']);
					if($lineUserNames instanceof Contact)
					{
					    $lineUserName=$lineUserNames->getUserName();
					}
				}else{
					$lineCategoryId=$line->getCategoryId();
					$lineGroupByCategoryId=$line->getGroupByCategoryId();
					$lineTotal = $use_taxes_in_lines ? $line->getSubtotal() : $line->getTotal();	
					$lineMemberId=$line->getMemberId();
					$lineGetFormObjectType=$line->getFromObjectTypeId();
					$lineGetCurrencyId=$line->getCurrencyId();
					$lineGetDetail=$line->getDetail();
					$lineGetDate=$line->getDate();
					$lineGetUnitValue=$line->getUnitValue();
					$lineGetId=$line->getId();
					$lineGetProductType=$line->getProductTypeId();
					$lineGetAnount = $line->getAmount();
					$lineItemTypeId= $line->getItemTypeId();
					$lineGetUnitCost=$line->getUnitCost();
					$lineGetPriceMultiplier=$line->getPriceMultiplier();
					$LineDiscountPercentType=$line->getDiscountPercentType();

					if ($lineItemTypeId != 7) //retainer
					{
						$lineShowTotal = $invoice->getTotal();
					}
					$lineUserName = $line->getUserName();
				}

				// first level grouping: projects
				if ($this->getBreakDownBySubprojects() == 'MULTI' || $this->getBreakDownBySubprojects() == 'SINGLE' || $this->getGroupBy() == 'project_labor_category' || $this->getExpGroupBy() == 'project_expense_category') {
					$line_group_id = $lineMemberId;
					if ($line_group_id > 0) {
						$line_member = Members::getMemberById($line_group_id);
						if ($line_member) {
							$raw_name = $line_member->getName();
							$tmp_mem = array($line_member);
							build_member_list_text_to_show_in_trees($tmp_mem);
							$line_group_name = $line_member ? $line_member->getName() : '';
							$line_group_code = str_replace($raw_name, '', $line_group_name);
						}
					} else {
						$line_group_name = '';
						$line_group_code = '';
					}
				} else {
					$line_group_id = 0;
					$line_group_name = '';
					$line_group_code = '';
				}
				$accumulate_discounts = $this->getAccumulateDiscounts();

				if ($lineGetFormObjectType == 0 || $lineGetFormObjectType == Timeslots::instance()->getObjectTypeId()) {
					$c_sym = '$';
					$currency = Currencies::instance()->getCurrency($invoice->getCurrencyId());
					if ($currency)
						$c_sym = $currency->getSymbol();
					if ($lineItemTypeId == 3 || $lineItemTypeId == 4 || $lineItemTypeId == 8) { //is discount type
						//////// discounts
						if($LineDiscountPercentType==1 || $lineItemTypeId==3 && $LineDiscountPercentType==2 && $accumulate_discounts=='between_line_items')
						{
							$accumulate_discounts='consolidated';
						}

						if ($accumulate_discounts == 'consolidated') {

							if (!isset($line_groups[$line_group_id])) {
								$line_groups[$line_group_id] = self::initLineGroups($line_group_name, $line_group_code, array());
								/*
																																$line_groups[$line_group_id] = array(
																																		'name' => $line_group_name,
																																		'code' => $line_group_code,
																																		'lines_data' => array(),
																																		'discount' => 0,
																																		'subtotal' => 0,
																																		'act_exp_lines_data' => array(),
																																		'act_exp_subtotal' => 0,
																																		'labor_subtotal' => 0,
																																);
																																*/
							}
							$line_groups[$line_group_id]['discount'] += abs($lineTotal);
							$line_groups[$line_group_id]['discounts_table_total'] += $lineTotal;
							continue;

						} else if ($accumulate_discounts == 'separated_section') {

							$line_group_id = 'discounts_table';
							if (!isset($line_groups[$line_group_id])) {

								$line_group_code = 'discounts_table';
								$line_groups[$line_group_id] = self::initLineGroups($line_group_name, $line_group_code, array());
								/*
																																$line_groups[$line_group_id] = array(
																																		'name' => $line_group_name,
																																		'code' => $line_group_code,
																																		'lines_data' => array(),
																																		'discount' => 0,
																																		'subtotal' => 0,
																																		'act_exp_lines_data' => array(),
																																		'act_exp_subtotal' => 0,
																																		'labor_subtotal' => 0,
																																);
																																*/
							}
							$row = array(
								'line_type' => 'discount',
								'description' => nl2br($lineGetDetail),
								'total' => format_money_amount($lineTotal, $c_sym),
							);

							$line_groups[$line_group_id]['discounts_table_total'] += $lineTotal;
							$line_groups[$line_group_id]['lines_data'][] = $row;
							continue;

						} else if ($accumulate_discounts == 'between_line_items') {

							$line_group_id = '0';
							if (!isset($line_groups[$line_group_id])) {

								$line_group_code = '0';
								$line_groups[$line_group_id] = self::initLineGroups($line_group_name, $line_group_code, array());
								/*
																																$line_groups[$line_group_id] = array(
																																		'name' => $line_group_name,
																																		'code' => $line_group_code,
																																		'lines_data' => array(),
																																		'discount' => 0,
																																		'subtotal' => 0,
																																		'act_exp_lines_data' => array(),
																																		'act_exp_subtotal' => 0,
																																		'labor_subtotal' => 0,
																																);
																																*/
							}

							$valueDateDisscount = '';
							if ($lineGetDate instanceof DateTimeValue) {
								$valueDateDisscount = format_date($lineGetDate, $date_format, 0);
							}
							$row = array(
								'date' => $valueDateDisscount,
								'detail' => nl2br($lineGetDetail),
								'description' => nl2br($lineGetDetail),
								'category' => nl2br($lineGetDetail),
								'amount' => $lineGetAnount,
								'unit_value' => format_money_amount($lineGetUnitValue, $c_sym),
								'total' => format_money_amount($lineTotal, $c_sym),
							);


							/*$first_col = $column_order[0];
																												$first_col_val = strtolower($row[$first_col]);*/
							$row_sort_key = /*$first_col_val .'-'.*/$lineGetId; // add the line id to the key to avoid overlapping of rows with the same key

							$line_groups[$line_group_id]['discounts_table_total'] += $lineTotal;
							$line_groups[$line_group_id]['subtotal'] += $lineTotal;
							$line_groups[$line_group_id]['lines_data'][$row_sort_key] = $row;

							continue;

						}

						////////end discounts
					}

					if ($lineItemTypeId == 9) //discount allocate precent
					{
						$line_group_code = 'discounts_allocate_percentage';
						$line_group_id = 'discounts_allocate_percentage';

						$row = array(
							'line_type' => 'discounts_allocate_percentage',
							'description' => nl2br($lineGetDetail),
							'total' => format_money_amount($lineTotal, $c_sym),
						);

						$line_groups[$line_group_id]['code'] = $line_group_id;
						$line_groups[$line_group_id]['name'] = $line_group_id;
						$line_groups[$line_group_id]['discounts_allocate_percentage_description'] = nl2br($lineGetDetail);
						$line_groups[$line_group_id]['discounts_allocate_percentage_total'] += $lineTotal;
						$line_groups[$line_group_id]['lines_data'][] = $row;

						continue;


					}


					/* @var $line IncomeInvoiceLine */
					$row = array();

					foreach ($column_order as $col) {
						$value = '';
						switch ($col) {
							case 'date':
								if ($lineGetDate instanceof DateTimeValue)
									$value = format_date($lineGetDate, $date_format, 0);
								break;
							case 'user':
								$value = $initials ? $line->getUserInitials() : $lineUserName;
								break;
							case 'category':
								$cat_member = Members::getMemberById($lineCategoryId);
								if ($cat_member)
									$value = $cat_member->getName();
								break;
							case 'product type':
								$product_type_aux = ProductTypes::getById($lineGetProductType);
								$value = $product_type_aux instanceof ProductType ? $product_type_aux->getName() : '';
								break;
							case 'description':
								/*if ($include_cat_in_description) {
																																	$cat_member = Members::getMemberById($line->getCategoryId());
																																	if ($cat_member) $value .= '<span class="cat-name">'. $cat_member->getName() . '</span><br />';
																																}*/
								$value .= nl2br($lineGetDetail);
								break;
							case 'amount':
								if ($lineItemTypeId > 4) {
									$value = '';
								} else {
									$value = number_format($lineGetAnount, 2);
								}

								break;
							case 'unit_value':
								if ($lineItemTypeId > 4) {
									$value = '';
								} else {
									$value = format_money_amount($lineGetUnitValue, $c_sym);
								}
								break;
							case 'total':
								if ($lineItemTypeId > 4) {
									$value = '';
								} else {
									$value = format_money_amount($lineTotal, $c_sym);
								}
								break;
							case 'subtotal':
								$value = format_money_amount($line->getSubTotal(), $c_sym);
								break;
							default:
								if (str_starts_with($col, "tax_")) {
									$tax_id = str_replace("tax_", "", $col);
									$tax_line_amount = IncomeInvoiceLineTaxes::getTaxValue($lineGetId, $tax_id);
									$value = format_money_amount($tax_line_amount, $c_sym);
								}
								break;
						}
						$row[$col] = $value;
					}
					$row['linetype'] = $lineItemTypeId;

					if (!isset($line_groups[$line_group_id])) {
						$line_groups[$line_group_id] = self::initLineGroups($line_group_name, $line_group_code, array());
						/*
																								$line_groups[$line_group_id] = array(
																										'name' => $line_group_name,
																										'code' => $line_group_code,
																										'lines_data' => array(),
																										'discount' => 0,
																										'subtotal' => 0,
																										'act_exp_lines_data' => array(),
																										'act_exp_subtotal' => 0,
																										'labor_subtotal' => 0,
																								);
																								*/
					}

					// build a key sort the rows by the first column (description, date, etc.)
					if( count( $column_order)){
				 		$first_col = $column_order[0];
						$first_col_val = strtolower($row[$first_col]);
					}
					$row_sort_key = /*$first_col_val .'-'.*/$lineGetId; // add the line id to the key to avoid overlapping of rows with the same key
					$line_groups[$line_group_id]['lines_data'][$row_sort_key] = $row;
					$line_groups[$line_group_id]['subtotal'] += $lineTotal;
					$line_groups[$line_group_id]['labor_subtotal'] += $lineTotal;

				} else if (Plugins::instance()->isActivePlugin('expenses2') && $lineGetFormObjectType == PaymentReceipts::instance()->getObjectTypeId()) { //if line is expense (product/service) type

					if ($lineItemTypeId == 7) //is retainer-->acumulate in other group
					{
						//$totalRet += abs($lineTotal);

						if (!isset($line_groups[$line_group_id])) {
							$line_groups[$line_group_id] = array(
								'name' => $line_group_name,
								'code' => $line_group_code,
								'lines_data' => array(),
								'discount' => 0,
								'subtotal' => 0,
								'act_exp_lines_data' => array(),
								'act_exp_subtotal' => 0,
								'labor_subtotal' => 0,
							);
						}

						$row = array(
							'description' => nl2br($lineGetDetail ? $lineGetDetail : lang('retainer')),
							'total' => $lineTotal,
							'totalClean' => $lineTotal,
						);


						$line_groups[$line_group_id]['retainer'][] = $row;
						continue;
					}

					if ($lineItemTypeId == 3 || $lineItemTypeId == 4 || $lineItemTypeId == 8) { //is discount
						$discount += abs($lineTotal);
						if ($accumulate_discounts == 'consolidated') {

							if (!isset($line_groups[$line_group_id])) {
								$line_groups[$line_group_id] = array(
									'name' => $line_group_name,
									'code' => $line_group_code,
									'lines_data' => array(),
									'discount' => 0,
									'subtotal' => 0,
									'act_exp_lines_data' => array(),
									'act_exp_subtotal' => 0,
									'labor_subtotal' => 0,
								);
							}
							$line_groups[$line_group_id]['discount'] += abs($lineTotal);
							continue;

						} else if ($accumulate_discounts == 'separated_section') {

							$line_group_id = 'discounts_table';
							if (!isset($line_groups[$line_group_id])) {
								$line_group_code = 'discounts_table';

								$line_groups[$line_group_id] = self::initLineGroups($line_group_name, $line_group_code, array());
								/*
																										$line_groups[$line_group_id] = array(
																											'name' => $line_group_name,
																											'code' => $line_group_code,
																											'lines_data' => array(),
																											'discount' => 0,
																											'subtotal' => 0,
																											'act_exp_lines_data' => array(),
																											'act_exp_subtotal' => 0,
																											'labor_subtotal' => 0,
																										);
																										*/
							}
							$row = array(
								'line_type' => 'discount',
								'description' => nl2br($lineGetDetail),
								'total' => format_money_amount($lineTotal, $c_sym),
							);



							$line_groups[$line_group_id]['lines_data'][] = $row;

							continue;

						}
					}
					$sub_group_id = 0;
					if ($this->getBreakDownExpensesByCategory() != 'no') {
						$sub_group_id = $lineGroupByCategoryId;
					}

					/* @var $line IncomeInvoiceLine */
					$c_sym = '$';
					$currency = Currencies::instance()->getCurrency($lineGetCurrencyId);
					if ($currency)
						$c_sym = $currency->getSymbol();
					$row = array();

					$line_has_markup = $lineGetUnitCost > 0 && $lineGetUnitCost != $lineGetUnitValue;

					foreach ($act_exp_column_order as $col) {
						$value = '';

						switch ($col) {
							case 'date':
								$value = $lineGetDate ? format_date($lineGetDate, $date_format, 0) : '';
								break;
							case 'user':
								$value = $initials_exp ? $line->getUserInitials() : $lineUserName;
								break;
							case 'category': //outdated
								$cat_member = Members::getMemberById($lineCategoryId);
								if ($cat_member)
									$value = $cat_member->getName();
								break;
							case 'product type':
								$product_type_aux = ProductTypes::getById($lineGetProductType);
								$value = $product_type_aux instanceof ProductType ? $product_type_aux->getName() : '';
								break;
							case 'description':
								$value .= nl2br($lineGetDetail);
								break;
							case 'amount':
								$value = number_format($lineGetAnount, 2);
								if ($lineItemTypeId > 4) {
									$value = '';
								}

								break;
							case 'unit_value':

								if ($lineItemTypeId > 4) {
									$value = '';
								} else {
									if ($this->getShowExpensesMarkupSeparated() && $line_has_markup) {
										// if displaying markup in a separate line show the unit value without markup
										$value = format_money_amount($lineGetUnitCost, $c_sym);
									} else {
										$value = format_money_amount($lineGetUnitValue, $c_sym);
									}
								}


								break;
							case 'total':
								if ($lineItemTypeId > 4) {
									$value = '';
								} else {
									if ($this->getShowExpensesMarkupSeparated() && $line_has_markup) {
										// if displaying markup in a separate line show the total without markup
										$value = format_money_amount($lineGetUnitCost * $lineGetAnount, $c_sym);
									} else {
										$value = format_money_amount($lineTotal, $c_sym);
									}
								}
								break;
							case 'unit_cost':
								$value = format_money_amount($lineGetUnitCost, $c_sym);
								break;
							case 'markup_amount':
								$markup_amount = $lineGetAnount * ($lineGetUnitValue - $lineGetUnitCost);
								$value = format_money_amount($markup_amount, $c_sym);;
								break;
							case 'fee':
								if ($lineGetUnitCost > 0) {
									$multiplier = $line->getUnitValue() / $lineGetUnitCost;
									$value = round((($multiplier - 1) * 100), 2) . '%';
								} else {
									$value = '';
								}
								break;
						}
						$row[$col] = $value;
					}

					$row['linetype'] = $lineItemTypeId;

					if (!isset($line_groups[$line_group_id])) {
						$line_groups[$line_group_id] = self::initLineGroups($line_group_name, $line_group_code, array());
						/*
																			  $line_groups[$line_group_id] = array(
																				  'name' => $line_group_name,
																				  'code' => $line_group_code,
																				  'lines_data' => array(),
																				  'discount' => 0,
																				  'subtotal' => 0,
																				  'actual_expense_groups' => array(),
																				  'act_exp_subtotal' => 0,
																				  'labor_subtotal' => 0,
																			  );
																			  */
					}

					// build a key sort the rows by the first column (description, date, etc.)
					$first_col = $act_exp_column_order[0];
					$first_col_val = strtolower($row[$first_col]);
					$row_sort_key = /*$first_col_val .'-'.*/$lineGetId; // add the line id to the key to avoid overlapping of rows with the same key

					if (!isset($line_groups[$line_group_id]['actual_expense_groups'][$sub_group_id])) {
						$sub_group_name = '';
						if ($this->getBreakDownExpensesByCategory() != 'no' && $sub_group_id > 0) {
							$cat = Members::getMemberById($sub_group_id);
							if ($cat instanceof Member)
								$sub_group_name = $cat->getName();
						}

						$line_groups[$line_group_id]['actual_expense_groups'][$sub_group_id] = array(
							'name' => $sub_group_name,
							'data' => array(),
							'subtotal' => 0,
							'discount' => 0,
							'more_expense_table_rows' => array(),
						);
					}

					$line_groups[$line_group_id]['actual_expense_groups'][$sub_group_id]['data'][$row_sort_key] = $row;
					$line_groups[$line_group_id]['actual_expense_groups'][$sub_group_id]['subtotal'] += $lineTotal;
					$line_groups[$line_group_id]['act_exp_subtotal'] += $lineTotal;

					// accumulate this line's markup amounts, to be shown at the end of the expenses table
					if ($this->getShowExpensesMarkupSeparated() && $line_has_markup) {

						$markup = ($lineTotal * 100 / ($lineGetUnitCost * $lineGetAnount)) - 100;
						$markup = round($markup, 2);

						$amount_to_apply_markup = $lineGetUnitCost * $lineGetAnount;
						$markup_amount = $lineTotal - $amount_to_apply_markup;

						$mark_up_row_key = 'markup-row-' . $markup;
						if (!isset($line_groups[$line_group_id]['actual_expense_groups'][$sub_group_id]['more_expense_table_rows'][$mark_up_row_key])) {

							$markup_label = $line_groups[$line_group_id]['actual_expense_groups'][$sub_group_id]['name'] == '' ? 'Markup' : 'Markup on ' . $line_groups[$line_group_id]['actual_expense_groups'][$sub_group_id]['name'];

							$markup_text_key = 'description';
							if (!in_array('description', $act_exp_column_order)) {
								if (in_array('expense_name', $act_exp_column_order))
									$markup_text_key = 'expense_name';
								else if (in_array('product_type', $act_exp_column_order))
									$markup_text_key = 'product_type';
								else if (in_array('category', $act_exp_column_order))
									$markup_text_key = 'category';
							}

							$line_groups[$line_group_id]['actual_expense_groups'][$sub_group_id]['more_expense_table_rows'][$mark_up_row_key] = array(
								$markup_text_key => $markup_label,
								'amount' => $markup . '%',
								'unit_value' => 0,
								'total' => 0,
							);
						}

						$line_groups[$line_group_id]['actual_expense_groups'][$sub_group_id]['more_expense_table_rows'][$mark_up_row_key]['total'] += $markup_amount;
						$line_groups[$line_group_id]['actual_expense_groups'][$sub_group_id]['more_expense_table_rows'][$mark_up_row_key]['unit_value'] += $amount_to_apply_markup;
					}
				}
			}
		}

		$currency_symbol = '$';
		$currency = Currencies::instance()->getCurrency($invoice->getCurrencyId());
		if ($currency)
			$currency_symbol = $currency->getSymbol();

		$html = '';

		tpl_assign('invoice', $invoice);
		tpl_assign('invoice_template', $this);
		tpl_assign('print_options', $print_options);
		tpl_assign('currency_symbol', $currency_symbol);
		tpl_assign('column_order', $column_order);
		tpl_assign('columns', $columns);
		tpl_assign('act_exp_column_order', $act_exp_column_order);
		tpl_assign('act_exp_columns', $act_exp_columns);


		//$line_groups[$line_group_id]['lines_data'];


		$line_count = 0;
		$line_groups = $this->orderMultiDimensionalArray($line_groups, 'name', false);


		//tpl_assign('discount_allocation_percent', $line_group['discounts_allocate_percentage']);

		//set project table visible
		$ctrl_project_table = 0;

		foreach ($line_groups as $line_group_id => $line_group) {

			// sort each table's lines using their keys
			ksort($line_group['lines_data']);
			if( isset($line_groups[$line_group_id]['actual_expense_groups']) ){
				foreach ($line_groups[$line_group_id]['actual_expense_groups'] as $sub_group_id => $sub_group) {
					ksort($sub_group['data']);
				}
			}
			$line_count++;
			// only show invoice total after the last group
			$show_grand_total = count($line_groups) == $line_count;
			tpl_assign('show_grand_total', $show_grand_total);
			if ($show_grand_total) {
				$taxes = $invoice->getTaxes();
				foreach ($taxes as $inv_tax) {
					$tax = IncomeTaxes::instance()->findById($inv_tax->getTaxId());
					$tax_name = $tax->getName();
					if ($inv_tax->getType() == 'percentage') {
						$tax_name .= " (" . $inv_tax->getValue() . "%)";
					}
					$taxes_data[] = array(
						'name' => $tax_name,
						'amount' => $inv_tax->getFixedValue(),
						'type' => $inv_tax->getType(),
						'value' => $inv_tax->getValue(),
					);
					tpl_assign('taxes_data', $taxes_data);
				}
			}

			$invoice_total_to_show = $lineShowTotal; //$invoice->getTotal();

			$discount_to_show = $line_group['discount'];


			if (array_var($print_options, 'ignore_discount') && $discount_to_show > 0) {
				$invoice_total_to_show += $discount_to_show;
				$discount_to_show = 0;
			}

			$actual_expense_groups = array_var($line_group, 'actual_expense_groups');
			
			// verify if we need to hide the fee column
			if($actual_expense_groups){
				foreach ($actual_expense_groups as &$actual_expense_group) {
					if ($this->checkIfHideFeeAndCostColumns($actual_expense_group)) {
						$actual_expense_group['hide_cost_fee_column'] = true;
					}
				}
			}
			
    		tpl_assign('group_name', $line_group['name']);
    		tpl_assign('group_code', $line_group['code']);
			tpl_assign('discount_table_total', isset($line_group['discounts_table_total']) ? $line_group['discounts_table_total'] : 0);

			tpl_assign('discounts_allocate_percentage_detail', isset($line_group['discounts_allocate_percentage_description']) ? $line_group['discounts_allocate_percentage_description'] : 0);
			tpl_assign('discounts_allocate_percentage_total', isset( $line_group['discounts_allocate_percentage_total']) ? $line_group['discounts_allocate_percentage_total'] : 0);


			tpl_assign('lines_data', $line_group['lines_data']);
			tpl_assign('discount', $discount_to_show);


			tpl_assign('retainers', isset($line_group['retainer']) ? $line_group['retainer'] : 0);

			if ($line_group['subtotal'] > 0) {
				tpl_assign('subtotal', $line_group['subtotal']);
			}

			tpl_assign('invoice_total', $invoice_total_to_show);

    		
    		tpl_assign('actual_expense_groups', $actual_expense_groups ? $actual_expense_groups : array());

			// tpl_assign('actual_expense_groups', $line_group['actual_expense_groups']);

			if ($line_group['act_exp_subtotal'] > 0) {
				tpl_assign('act_exp_subtotal', $line_group['act_exp_subtotal']);
			}

			//send control visible project table
			tpl_assign('ctrl_project_table', $ctrl_project_table);

			$html .= tpl_fetch(get_template_path('invoice_lines_table', 'invoice_template', 'income'));

			//set to no visible project table
			$ctrl_project_table=1;
    	}
   		
    	return $html;
    }

	/**
	 * When the template breaks down only by top level expense categories check if all lines of the group have any fee
	 * If none of them have fee then we need to hide the fee column
	 */
	private function checkIfHideFeeAndCostColumns($actual_expense_group) {
		$hide_fee_column = false;

		if ($this->getBreakDownExpensesByCategory() != 'no') {
			$all_lines_have_fee_zero = true;

			foreach ($actual_expense_group['data'] as $line) {
				$fee = array_var($line, 'fee');
				$fee = trim(str_replace('%', '', $fee));

				if ($fee != 0) {
					$all_lines_have_fee_zero = false;
					break;
				}
			}

			$hide_fee_column = $all_lines_have_fee_zero;
		}

		return $hide_fee_column;		
	}

	function initLineGroups($line_group_name, $line_group_code, $ar){
		return array(
			'name' => $line_group_name,
			'code' => $line_group_code,
			'lines_data' => $ar,
			'discount' => 0,
			'subtotal' => 0,
			'act_exp_lines_data' => array(),
			'act_exp_subtotal' => 0,
			'labor_subtotal' => 0,
		);
	}	

}