<?php

/**
 * BaseIncomeInvoiceTemplates class
 * Created: 06/15/20
 * Author: Alex Zonis
 * 
 */
abstract class BaseIncomeInvoiceTemplates extends DataManager {

    /**
     * Column name => Column type map
     *
     * @var array
     * @static
     */
    static private $columns = array(
	        'id' => DATA_TYPE_INTEGER,
	        'name' => DATA_TYPE_STRING,
    		'is_default' => DATA_TYPE_INTEGER,
    		'template_type' => DATA_TYPE_STRING,
    		'group_by' => DATA_TYPE_STRING,
	        'include_date' => DATA_TYPE_INTEGER,
	        'include_user_name' => DATA_TYPE_STRING,
	        'include_labor_category' => DATA_TYPE_INTEGER,
    		'include_description' => DATA_TYPE_INTEGER,
    		'exp_group_by' => DATA_TYPE_STRING,
    		'display_cost_or_price' => DATA_TYPE_STRING,
	      
    		'show_taxes_for_each_line' => DATA_TYPE_BOOLEAN,
    		'show_headers_before_details' => DATA_TYPE_BOOLEAN,
            'include_account_summary' => DATA_TYPE_BOOLEAN,
            'break_down_by_subprojects' => DATA_TYPE_STRING,
            'break_down_expenses_by_category' => DATA_TYPE_STRING,
            'show_expenses_markup_separated' => DATA_TYPE_BOOLEAN,
    		'footer_text' => DATA_TYPE_STRING,
			'accumulate_discounts' => DATA_TYPE_STRING,
			'include_additional_info_in_footer' => DATA_TYPE_BOOLEAN,
            'include_project_location' => DATA_TYPE_BOOLEAN,
            
            /*times lines*/
            'include_detail' => DATA_TYPE_INTEGER,
            'include_task_name' => DATA_TYPE_INTEGER,
            'include_hours' => DATA_TYPE_INTEGER,
            'include_rate' => DATA_TYPE_INTEGER,
            'include_total' => DATA_TYPE_INTEGER,
            'include_time_entry_description'=> DATA_TYPE_INTEGER,
            'include_custom_description'=> DATA_TYPE_STRING,
            'include_project_name' => DATA_TYPE_INTEGER,
            'include_project_description' => DATA_TYPE_INTEGER,
            'include_time_line_date'=>DATA_TYPE_STRING,
            
            'category_for_timeslot_col'=>DATA_TYPE_INTEGER,
            'category_for_timeslot'=>DATA_TYPE_INTEGER,
            'product_type_for_timeslot_col'=>DATA_TYPE_INTEGER,
            'product_type_for_timeslot'=>DATA_TYPE_INTEGER,
            'include_user_name_col'=>DATA_TYPE_STRING,

            /*expense lines*/
            'include_exp_date' => DATA_TYPE_INTEGER,
    		'include_paid_by' => DATA_TYPE_BOOLEAN,
    		'include_product_type' => DATA_TYPE_BOOLEAN,
    		'include_expense_name' => DATA_TYPE_BOOLEAN,
			'include_expense_description' => DATA_TYPE_BOOLEAN,
    		'include_expense_category' => DATA_TYPE_BOOLEAN,
            'include_exp_quantity' => DATA_TYPE_INTEGER,
            'include_exp_amount' => DATA_TYPE_INTEGER,
            'include_exp_fee' => DATA_TYPE_INTEGER,
            'include_exp_markup_amount' => DATA_TYPE_INTEGER,
            'include_exp_total' => DATA_TYPE_INTEGER,
            'include_expense_project_number' => DATA_TYPE_INTEGER,
            'include_expense_project_name' => DATA_TYPE_INTEGER,
            'include_exp_type_date' =>DATA_TYPE_STRING,

            'include_exp_user_name_col'=>DATA_TYPE_STRING,
            'category_for_expenses_col'=>DATA_TYPE_INTEGER,
            'category_for_expenses'=>DATA_TYPE_INTEGER,
            'product_type_for_expenses_col'=>DATA_TYPE_INTEGER,
            'product_type_for_expenses'=>DATA_TYPE_INTEGER,
            'include_paid_by_col'=>DATA_TYPE_INTEGER,
            'include_exp_description'=>DATA_TYPE_INTEGER,
            'include_exp_unit_cost' => DATA_TYPE_INTEGER,
            'custom_label_include_exp_include_exp_unit_cost' =>DATA_TYPE_STRING,
            'include_expense_task_name' => DATA_TYPE_BOOLEAN,

            /*for lump sum*/
            'include_lump_sum_project_number'=>DATA_TYPE_INTEGER,
            'include_lump_sum_project_name'=>DATA_TYPE_INTEGER,
            'include_lump_sum_from_to'=>DATA_TYPE_INTEGER,
            'include_lump_sum_date'=>DATA_TYPE_STRING,
            'include_lump_sum_quantity'=>DATA_TYPE_INTEGER,
            'include_lump_sum_budget_completion' =>DATA_TYPE_INTEGER,
            'include_lump_sum_date_col'=>DATA_TYPE_INTEGER,
            'include_lump_sum_unit_price' =>DATA_TYPE_INTEGER,
            'include_lump_sum_project_type' =>DATA_TYPE_INTEGER,
            'category_for_lump_sum' => DATA_TYPE_INTEGER,
			'product_type_for_lump_sum' => DATA_TYPE_INTEGER,
            'category_for_lump_sum_col' => DATA_TYPE_INTEGER,
			'product_type_for_lump_sum_col' => DATA_TYPE_INTEGER,
            'include_lump_sum_deetail_col' => DATA_TYPE_INTEGER,
            
            // => INVOICE TEMPLATES ::
            'invoice_template_assigned' => DATA_TYPE_STRING,

            // => INVOICE LANGUAGE ::
            'template_language_assigned' => DATA_TYPE_STRING,

			// date format for printing
			'date_format' => DATA_TYPE_STRING,

            /*Custom labels for timeslots*/
            'custom_label_include_date' => DATA_TYPE_STRING,
            'custom_label_include_user_name_col' => DATA_TYPE_STRING,
            'custom_label_category_for_timeslot_col' => DATA_TYPE_STRING,
            'custom_label_include_description' => DATA_TYPE_STRING,
            'custom_label_include_hours' => DATA_TYPE_STRING,
            'custom_label_include_rate' => DATA_TYPE_STRING,
            'custom_label_include_total' => DATA_TYPE_STRING,
            
            /*Custom labels for expenses*/
            'custom_label_include_exp_date' => DATA_TYPE_STRING,
            'custom_label_include_paid_by_col' => DATA_TYPE_STRING,
            'custom_label_include_exp_user_name_col' => DATA_TYPE_STRING,
            'custom_label_category_for_expenses_col' => DATA_TYPE_STRING,
            'custom_label_product_type_for_expenses_col' => DATA_TYPE_STRING,
            'custom_label_include_exp_description' => DATA_TYPE_STRING,
            'custom_label_include_exp_quantity' => DATA_TYPE_STRING,
            'custom_label_include_exp_amount' => DATA_TYPE_STRING,
            'custom_label_include_exp_fee' => DATA_TYPE_STRING,
            'custom_label_include_exp_total' => DATA_TYPE_STRING,
			'custom_label_include_exp_markup_amount' => DATA_TYPE_STRING,

            'expense_detail_vendor_name' => DATA_TYPE_BOOLEAN,
            'expense_detail_bill_no' => DATA_TYPE_BOOLEAN,

            /*custom label for lump sum*/
            'custom_label_include_lump_sum_date_col' => DATA_TYPE_STRING,
            'custom_label_category_for_lump_sum_col' => DATA_TYPE_STRING,
            'custom_label_product_type_for_lump_sum_col' => DATA_TYPE_STRING,
            'custom_label_include_lump_sum_deetail_col' => DATA_TYPE_STRING,
            'custom_label_include_lump_sum_quantity' => DATA_TYPE_STRING,
            'custom_label_include_lump_sum_unit_price' => DATA_TYPE_STRING,
            'labor_detail_separator_value'=>DATA_TYPE_STRING,
            'expense_detail_separator_value'=>DATA_TYPE_STRING,
            'tasks_detail_separator_value'=>DATA_TYPE_STRING,
            'lump_sum_detail_separator_value'=>DATA_TYPE_STRING,
            /*tasks lines*/
            'task_all_expenses_includes' =>DATA_TYPE_INTEGER,
            'task_group' =>DATA_TYPE_STRING,
            'task_custom_detail' =>DATA_TYPE_STRING,
            'task_allow_billing_per_percent'=>DATA_TYPE_INTEGER,
            'task_invoice_billing_type'=>DATA_TYPE_STRING,

    );

    /**
     * Construct
     *
     * @return BaseIncomeInvoiceTemplates
     */
    function __construct() {
        Hook::fire('object_definition', 'IncomeInvoiceTemplate', self::$columns);
        parent::__construct('IncomeInvoiceTemplate', 'income_invoice_templates', true);
    }

    // -------------------------------------------------------
    //  Description methods
    // -------------------------------------------------------

    /**
     * Return array of object columns
     *
     * @access public
     * @param void
     * @return array
     */
    function getColumns() {
        return array_keys(self::$columns);
    }

    /**
     * Return column type
     *
     * @access public
     * @param string $column_name
     * @return string
     */
    function getColumnType($column_name) {
        if (isset(self::$columns[$column_name])) {
            return self::$columns[$column_name];
        } else {
            return DATA_TYPE_STRING;
        } // if
    }

    /**
     * Return array of PK columns. If only one column is PK returns its name as string
     *
     * @access public
     * @param void
     * @return array or string
     */
    function getPkColumns() {
        return 'id';
    }

    /**
     * Return name of first auto_incremenent column if it exists
     *
     * @access public
     * @param void
     * @return string
     */
    function getAutoIncrementColumn() {
        return 'id';
    }

    // -------------------------------------------------------
    //  Finders
    // -------------------------------------------------------

    /**
     * Do a SELECT query over database with specified arguments
     *
     * @access public
     * @param array $arguments Array of query arguments. Fields:
     *
     *  - one - select first row
     *  - conditions - additional conditions
     *  - order - order by string
     *  - offset - limit offset, valid only if limit is present
     *  - limit
     *
     * @throws DBQueryError
     */
    function find($arguments = null) {
        if (isset($this) && instance_of($this, 'IncomeInvoiceTemplates')) {
            return parent::find($arguments);
        } else {
            return IncomeInvoiceTemplates::instance()->find($arguments);
        } // if
    }

    /**
     * Find all records
     *
     * @access public
     * @param array $arguments
     */
    function findAll($arguments = null) {
        if (isset($this) && instance_of($this, 'IncomeInvoiceTemplates')) {
            return parent::findAll($arguments);
        } else {
            return IncomeInvoiceTemplates::instance()->findAll($arguments);
        } // if
    }

    /**
     * Find one specific record
     *
     * @access public
     * @param array $arguments
     */
    function findOne($arguments = null) {
        if (isset($this) && instance_of($this, 'IncomeInvoiceTemplates')) {
            return parent::findOne($arguments);
        } else {
            return IncomeInvoiceTemplates::instance()->findOne($arguments);
        } // if
    }

    /**
     * Return object by its PK value
     *
     * @access public
     * @param mixed $id
     * @param boolean $force_reload If true cache will be skipped and data will be loaded from database
     */
    function findById($id, $force_reload = false) {
        if (isset($this) && instance_of($this, 'IncomeInvoiceTemplates')) {
            return parent::findById($id, $force_reload);
        } else {
            return IncomeInvoiceTemplates::instance()->findById($id, $force_reload);
        } // if
    }

    /**
     * Return number of rows in this table
     *
     * @access public
     * @param string $conditions Query conditions
     * @return integer
     */
    function count($condition = null) {
        if (isset($this) && instance_of($this, 'IncomeInvoiceTemplates')) {
            return parent::count($condition);
        } else {
            return IncomeInvoiceTemplates::instance()->count($condition);
        } // if
    }

    /**
     * Delete rows that match specific conditions. If $conditions is NULL all rows from table will be deleted
     *
     * @access public
     * @param string $conditions Query conditions
     * @return boolean
     */
    function delete($condition = null) {
        if (isset($this) && instance_of($this, 'IncomeInvoiceTemplates')) {
            return parent::delete($condition);
        } else {
            return IncomeInvoiceTemplates::instance()->delete($condition);
        } // if
    }

    /**
     * This function will return paginated result. Result is an array where first element is
     * array of returned object and second populated pagination object that can be used for
     * obtaining and rendering pagination data using various helpers.
     *
     * Items and pagination array vars are indexed with 0 for items and 1 for pagination
     * because you can't use associative indexing with list() construct
     *
     * @access public
     * @param array $arguments Query argumens (@see find()) Limit and offset are ignored!
     * @param integer $items_per_page Number of items per page
     * @param integer $current_page Current page number
     * @return array
     */
    /*function paginate($arguments = null, $items_per_page = 10, $current_page = 1, $count = null) {
        if (isset($this) && instance_of($this, 'IncomeInvoiceNotebooks')) {
            return parent::paginate($arguments, $items_per_page, $current_page);
        } else {
            return IncomeInvoiceNotebooks::instance()->paginate($arguments, $items_per_page, $current_page);
        } // if
    }*/

    /**
     * Return manager instance
     *
     * @return IncomeInvoiceTemplates
     */
    static function instance() {
        static $instance;
        if (!instance_of($instance, 'IncomeInvoiceTemplates')) {
            $instance = new IncomeInvoiceTemplates();
        }
        return $instance;
    }

}

?>
