<?php
require_javascript('addInvoiceForm.js', 'income');
$genid = gen_id();
$object = $invoice;

$categories = array();
Hook::fire('object_edit_categories', $object, $categories);

// on submit functions
// now the submit function are controler via jquery are indicated as events in income.js

$main_cp_count = CustomProperties::countVisibleCustomPropertiesByObjectType($object->getObjectTypeId());
$other_cp_count = CustomProperties::countHiddenCustomPropertiesByObjectType($object->getObjectTypeId());

$loc = user_config_option('localization');
if (strlen($loc) > 2)
	$loc = substr($loc, 0, 2);

$invoice_lines = IncomeInvoiceLines::getInvoiceLines($invoice->getObjectId());

$all_currencies = Currencies::getCurrenciesInfo();

$allow_multiline_line_desc = income_config_option("allow_multiline_line_desc");
$mandatory_customer_address = income_config_option("mandatory_customer_address");
$mandatory_customer_city = income_config_option("mandatory_customer_city");
$mandatory_customer_rut = income_config_option("mandatory_customer_rut");
$use_line_taxes = income_config_option("use_line_taxes");
$use_serie_for_invoice_number = income_config_option("use_serie_for_invoice_number");
$split_invoice_for_billing_clients = income_config_option("split_invoice_for_billing_clients");

$object_subtype = ObjectSubtypes::instance()->findById($object->getColumnValue('object_subtype_id'));

$invoice_template_cp = CustomProperties::getCustomPropertyByCode($invoice->getObjectTypeId(), 'invoice_template');

$payment_period_cp = CustomProperties::getCustomPropertyByCode($invoice->getObjectTypeId(), 'invoice_payment_period');

$attn_value=$object->getAttn();
//set in javascript
// if($attn_value=='')//if attn is empty, try to get it first from the prject's contact, second from customer contact
// {

// 	$project_ot = ObjectTypes::findByName('project');
// 	$client_ot = ObjectTypes::findByName('customer');

// 	$members = $invoice->getMembers();

// 	$project_member = null;
// 	$client_member = null;
// 	foreach ($members as $member) {
// 		if ($member->getObjectTypeId() == $project_ot->getId()) {
// 			$project_member = $member;
// 		}
// 		if ($client_ot->getId() == $member->getObjectTypeId()) {
// 			$client_member = $member;
// 		}
// 	}

// 	// try to get the billing contact from project
// 	if ($project_member instanceof Member) {
// 		$billing_contact_cp = CustomProperties::getCustomPropertyByCode($project_member->getObjectTypeId(), 'billing_contact');
// 		if ($billing_contact_cp) {
// 			$cp_val = CustomPropertyValues::getCustomPropertyValue($project_member->getObjectId(), $billing_contact_cp->getId());
// 			if ($cp_val) {
// 				$billing_contact = Contacts::instance()->findById($cp_val->getValue());
// 				if ($billing_contact) {
// 					$attn_value = $billing_contact->getName();
// 				}
// 			}
// 		}
// 	}

// 	// if attn is null, try to get the billing contact from client
// 	if (!$attn_value) {
// 		if ($client_member instanceof Member) {
// 			$billing_contact_cp = CustomProperties::getCustomPropertyByCode($client_member->getObjectTypeId(), 'billing_contact');
// 			if ($billing_contact_cp) {
// 				$cp_val = CustomPropertyValues::getCustomPropertyValue($client_member->getObjectId(), $billing_contact_cp->getId());
// 				if ($cp_val) {
// 					$billing_contact = Contacts::instance()->findById($cp_val->getValue());
// 					if ($billing_contact) {
// 						$attn_value = $billing_contact->getName();
// 					}
// 				}
// 				if ($billing_contact instanceof Contact) $is_client_billing_contact_cp = true;
// 			}
// 		}
// 	}
// }
?>
<form class="add-invoice" id="<?php echo $genid ?>submit-edit-form" action="<?php echo $invoice->isNew() ? get_url('invoice', 'add') : $invoice->getEditUrl() ?>" method="post">

	<input type="hidden" name="allow_multiline_line_desc" id="<?php echo $genid ?>allow_multiline_line_desc" value="<?php echo $allow_multiline_line_desc ? "1" : "0" ?>" />
	<input type="hidden" name="no_action" value="1">
	<input type="hidden" name="temp_invoice_id" id="<?php echo $genid ?>invoice_id" value="<?php echo $invoice->getId() ?>">

	<input type="hidden" name="invoice[ordered_by_id]" id="<?php echo $genid ?>ordered_by_id" value="<?php echo $invoice->getOrderedById() ?>" />

	<input type="hidden" name="req_channel" value="<?php echo array_var($_REQUEST, 'req_channel', 'modal form') ?>" />
	
	<div class="invoice">

		<div class="coInputHeader">

			<div class="coInputHeaderUpperRow">
				<div class="coInputTitle">
					<?php echo $object->getAddEditFormTitle(); ?>
				</div>
			</div>

			<div>
				<div class="coInputName">
					<?php echo text_field('invoice[name]', array_var($invoice_data, 'name'), array('id' => $genid . 'invoiceFormTitle', 'style' => 'width:540px !important; height: 28px; font-size: 130%;', 'placeholder' => lang('type name here'))); ?>
				</div>

				<div class="coInputButtons">
					<?php echo button(lang('save'), 's', array('style' => 'margin: 0 10px;', 'id' => 'save_invoice')) ?>
				</div>
				<div class="coInputButtons">
					<?php
					$is_mail_active = Plugins::instance()->isActivePlugin('mail');
					$save_and_send_class = $is_mail_active ? "submit" : "submit disabled";
					echo button(lang('save and send'), 's', array('style' => 'margin: 0 10px;', 'id' => 'save_send_invoice', 'class' => $save_and_send_class));
					?>
				</div>
				<div class="clear"></div>
			</div>
		</div>

		<div class="coInputMainBlock">
			<input id="<?php echo $genid ?>merge-changes-hidden" type="hidden" name="merge-changes" value="">
			<input id="<?php echo $genid ?>genid" type="hidden" name="genid" value="<?php echo $genid ?>">
			<input id="invoice_form_genid" type="hidden" value="<?php echo $genid ?>">
			<input id="<?php echo $genid ?>is_mail_active" type="hidden" value="<?php echo ($is_mail_active ? "1" : "") ?>">
			<input id="<?php echo $genid ?>updated-on-hidden" type="hidden" name="updatedon" value="<?php echo !$invoice->isNew() ? $invoice->getUpdatedOn()->getTimestamp() : '' ?>">

			<div id="<?php echo $genid ?>tabs" class="edit-form-tabs">

				<ul id="<?php echo $genid ?>tab_titles">

					<li><a href="#<?php echo $genid ?>add_invoice_data_div"><?php echo lang('invoice data') ?></a></li>
					<li><a href="#<?php echo $genid ?>add_invoice_select_customer_div"><?php echo lang('bill to title tab') ?></a></li>

					<?php if (in_array($object_subtype->getCode(), array('credit_note','debit_note'))) { ?>
					<li><a href="#<?php echo $genid ?>add_invoice_reference_div"><?php echo lang('invoice references') ?></a></li>
					<?php } ?>

					<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
						<li><a href="#<?php echo $genid ?>add_custom_properties_div"><?php echo lang('custom properties') ?></a></li>
					<?php } ?>

					<li><a href="#<?php echo $genid ?>add_subscribers_div"><?php echo lang('object subscribers') ?></a></li>

					<li><a href="#<?php echo $genid ?>add_more_details_div"><?php echo lang('more details') ?></a></li>

					<?php foreach ($categories as $category) {
						if (array_var($category, 'hidden')) continue;
					?>
						<li><a href="#<?php echo $genid . $category['name'] ?>"><?php echo $category['name'] ?></a></li>
					<?php } ?>
				</ul>


				<div id="<?php echo $genid ?>add_invoice_data_div" class="form-tab">
					<table>
						<tr>
							<td style="padding-right:30px; min-width:350px; max-width: 660px;">
								<?php
								$is_pending = $invoice->getStatus() == 'pending';
								if ($invoice->isNew() || $is_pending) { ?>
									<?php if (Plugins::instance()->isActivePlugin('multiple_currencies')) { ?>
										<div class="dataBlock" style="display:<?php echo (count($all_currencies) > 1 ? "block" : "none") ?>;">
											<?php echo label_tag(lang('currency'), $genid . 'invoiceCurrencyId', true);
											if (count($all_currencies) > 1) {
												echo currency_selector('invoice[currency_id]', array_var($invoice_data, 'currency_id'), array(
													'id' => $genid . 'invoiceCurrencyId', 'onchange' => "App.modules.addInvoiceForm.onInvoiceCurrencyChange('$genid');"
												));
											} else {
												$curr_id = $all_currencies[0]['id'];
												if (array_var($invoice_data, 'currency_id') > 0) {
													$curr_id = array_var($invoice_data, 'currency_id');
												}
											?>
												<input type="hidden" id="<?php echo $genid ?>invoiceCurrencyId" value="<?php echo $curr_id ?>" />
											<?php
											}
											?>
											<div class="clear"></div>
											<?php if (Plugins::instance()->isActivePlugin('einvoice')) { ?>
												<div id="<?php echo $genid ?>einvoice_rate_div" style="display:none;">
													<?php echo label_tag(lang('einvoice_destiny_rate'), $genid . 'einvoice_destiny_rate', true) ?>
													<?php
													$def_curr = Currencies::getDefaultCurrencyInfo();
													$ex_rate_curr = Currencies::instance()->getCurrency(array_var($invoice_data, 'einvoice_destiny_currency_id'));
													$ex_rate_csymbol = $ex_rate_curr instanceof Currency ? $ex_rate_curr->getSymbol() : $def_curr['symbol'];
													?>

													<input id="<?php echo $genid ?>einvoice_destiny_curr_id" type="hidden" name="invoice[einvoice_destiny_currency_id]" value="<?php echo array_var($invoice_data, 'einvoice_destiny_currency_id', $def_curr['id']) ?>" />
													<span id="<?php echo $genid ?>einvoice_destiny_curr_sym" style="width:8px;"><?php echo $ex_rate_csymbol ?></span>

													<?php echo text_field(
														'invoice[einvoice_destiny_rate]',
														array_var($invoice_data, 'einvoice_destiny_rate'),
														array('id' => $genid . 'einvoice_destiny_rate', 'class' => 'price')
													) ?>
												</div>
												<div class="clear"></div>
											<?php } ?>
										</div>
									<?php } ?>
								<?php } else { ?>

									<?php if (Plugins::instance()->isActivePlugin('multiple_currencies')) { ?>
										<div class="dataBlock">
											<?php echo label_tag(lang('currency')) ?>
											<?php echo array_var($invoice_data, 'currency_symbol'); ?>
											<input type="hidden" id="<?php echo $genid ?>invoiceCurrencyId" value="<?php echo array_var($invoice_data, 'currency_id') ?>" />
											<div class="clear"></div>
										</div>
									<?php } ?>
								<?php } ?>

								<?php if ($use_serie_for_invoice_number && (array_var($invoice_data, 'series') || $is_pending || $invoice->isNew())) { ?>
									<div class="dataBlock">
										<?php echo label_tag(lang('series'), $genid . 'invoiceFormSeries', true) ?>
										<?php
										if ($is_pending || $invoice->isNew()) {
											echo text_field('invoice[series]', array_var($invoice_data, 'series'), array('id' => 'invoiceFormNumber', 'maxlength' => 2, 'style' => 'width:30px;'));
										} else {
											echo array_var($invoice_data, 'series');
										}
										?>
										<div class="clear"></div>
									</div>
								<?php } ?>

								<?php if (array_var($invoice_data, 'invoice_number') || $is_pending || $invoice->isNew()) { ?>
									<div class="dataBlock">
										<?php echo label_tag(lang('invoice number'), $genid . 'invoiceFormNumber', true) ?>
										<?php
										if ($is_pending || $invoice->isNew()) {
											echo text_field('invoice[invoice_number]', array_var($invoice_data, 'invoice_number'), array('id' => 'invoiceFormNumber', 'maxlength' => 40, 'style' => 'width:150px;'));
										} else {
											echo array_var($invoice_data, 'invoice_number');
										}
										?>
										<div class="clear"></div>
									</div>
								<?php } ?>

								<div class="dataBlock">
									<?php echo label_tag(lang('date'), $genid . 'invoiceFormDate', true) ?>
									<?php echo pick_date_widget2('invoice[date]', array_var($invoice_data, 'date'), $genid, 70, true, 'invoiceFormDate'); ?>
									<div class="clear"></div>
								</div>

								<div class="dataBlock">
									<?php echo label_tag(lang('expiration date'), $genid . 'invoiceFormExpirationDate') ?>
									<?php echo pick_date_widget2('invoice[expiration_date]', array_var($invoice_data, 'expiration_date'), $genid, 70, true, 'invoiceFormExpirationDate'); ?>
									<div class="clear"></div>
								</div>

								<?php if (count($taxes) && !$use_line_taxes) { ?>
									<div class="dataBlock">
										<?php echo label_tag(lang('tax')) ?>
										<div style="float:left"><?php

																foreach ($taxes as $tax) { ?>
												<input type="hidden" id="<?php echo $genid ?>_tax_<?php echo $tax['id'] ?>" name="taxes[<?php echo $tax['id'] ?>]" value="<?php echo $tax['select'] ?>" />
												<?php
																	echo checkbox_field('tax_' . $tax['id'] . '_check', $tax['select'], array(
																		'id' => $genid . '_tax_' . $tax['id'] . '_check',
																		'onchange' => "document.getElementById('" . $genid . "_tax_" . $tax['id'] . "').value=(this.checked ? 1 : 0); App.modules.addInvoiceForm.recalculateTotalsBox('$genid');"
																	));
												?>
												<label for="<?php echo $genid ?>_tax_<?php echo $tax['id'] ?>_check" class="checkbox-label"><?php echo $tax['name'] ?></label>
												<div class="clear"></div>
											<?php
																}
											?>
										</div>
										<div class="clear"></div>
									</div>
								<?php } ?>

								<?php if (count($copies)) { ?>
									<div class="dataBlock">
										<?php echo label_tag(lang('invoice copies')) ?>
										<div style="float:left"><?php
																foreach ($copies as $copy) { ?>
												<input type="hidden" id="<?php echo $genid ?>_copy_<?php echo $copy['id'] ?>" name="copies[<?php echo $copy['id'] ?>]" value="<?php echo $copy['select'] ?>" />
												<?php
																	echo checkbox_field('copy_' . $copy['id'] . '_check', $copy['select'], array(
																		'id' => $genid . '_copy_' . $copy['id'] . '_check',
																		'onchange' => "document.getElementById('" . $genid . "_copy_" . $copy['id'] . "').value=(this.checked ? 1 : 0);"
																	));
												?>
												<label for="<?php echo $genid ?>_copy_<?php echo $copy['id'] ?>_check" class="checkbox-label"><?php echo $copy['name'] ?></label>
												<div class="clear"></div>
											<?php
																}
											?>
										</div>
										<div class="clear"></div>
									</div>
								<?php } ?>

								<?php
								if (income_config_option("allow_invoice_flexible_status_change")) {
								?><div class="dataBlock"><?php
															echo label_tag(lang('status'));
															echo invoice_status_selector("invoice[status]", $object->getStatus());
															?></div><?php
																}
																	?>

								<div class="dataBlock">
									<?php
									echo label_tag(lang('sent'));
									echo income_sent_status_selector("invoice[sent]", $object->getSent());
									?>
								</div>

								<?php $null = null;
								Hook::fire('before_render_main_custom_properties', array('object' => $object), $null); ?>

								<?php /* HIDE HINT
					
					if ($invoice->isNew() || $invoice->getStatus() == 'pending') { ?>
						<div class="desc" style="max-width:300px;"><?php echo lang('invoice numeration hint'); ?></div>
					<?php } */ ?>

							</td>
							<td style="/*border-left:1px dotted #ccc;*/ margin-left:10px; /*padding-left:10px;*/ min-width: 350px">
								<!--</div><div style="float:left;width: 48%;">-->

								<?php
								$listeners = array('on_selection_change' => 'og.reload_subscribers("' . $genid . '",' . $object->manager()->getObjectTypeId() . '); App.modules.addInvoiceForm.updateClientData("' . $genid . '", true)');
								if ($object->isNew()) {
									render_member_selectors($object->manager()->getObjectTypeId(), $genid, null, array('select_current_context' => true, 'listeners' => $listeners, 'object' => $object, 'width' => 370), null, null, false);
								} else {
									render_member_selectors($object->manager()->getObjectTypeId(), $genid, $object->getMemberIds(), array('listeners' => $listeners, 'object' => $object, 'width' => 370, 'disabled_dimension_ids' => $disabled_dimension_ids), null, null, false);
								}
								?>

								<div class="dataBlock">
									<?php echo label_tag(lang('additional info'), null, false) ?>
									<?php echo textarea_field('invoice[additional_information]', array_var($invoice_data, 'additional_information'), array('class' => 'short')) ?>
									<div class="clear"></div>
								</div>
							</td>
						</tr>

						<?php
						if ($main_cp_count) {
							$aligned_properties = get_aligned_object_custom_properties($object);
							$left_side_custom_properties = array_var($aligned_properties, 'left_side', '');
							$right_side_custom_properties = array_var($aligned_properties, 'right_side', '');

							if ($left_side_custom_properties == '' && $right_side_custom_properties == '') {
								echo '<tr><td>';
								echo render_object_custom_properties($object, false, null, 'visible_by_default');
								echo '</td><td></td></tr>';
							} else {
								echo '<tr><td style="padding-right:30px;max-width: 660px;">' . $left_side_custom_properties . '</td>';
								echo '<td>' . $right_side_custom_properties . '</td></tr>';
							}
						}
						?>
					</table>
					<?php 	
						$product_types = array();
						if (Plugins::instance()->isActivePlugin('expenses2')) {
							$product_types = ProductTypes::getAllProductTypesData();
						}
						$active_context = active_context();
						$active_context_members_and_associated = $active_context;
						$assoc_member_ids = array();
						foreach ($active_context as $selection) {
							if ($selection instanceof Member) {
								$more_assoc_ids = MemberPropertyMembers::getAllAssociatedMemberIds($selection->getId(),true);
								$assoc_member_ids = array_merge($assoc_member_ids, array_flat($more_assoc_ids));
							}
						}
						$assoc_member_ids = array_filter(array_unique($assoc_member_ids));
						if (count($assoc_member_ids) > 0) {
							$assoc_members = Members::instance()->findAll(array("conditions" => "id IN (".implode(',', $assoc_member_ids).")"));
							$active_context_members_and_associated = array_merge($active_context_members_and_associated, $assoc_members);
						}
						
						$members_to_filter = $invoice->isNew() ? $active_context_members_and_associated : $invoice->getMembers();
						//$members_to_filter =  $expense->getMembers();
						$filtered_product_types = array();
						if (Plugins::instance()->isActivePlugin('expenses2')) {
							$filtered_product_types = ProductTypes::getFilteredProductTypesData($members_to_filter);
						}
					?>

					<div class="sub-section-div sub-section-invoice-lines">
						<h2><?php echo lang('lines of the invoice') ?></h2>
						<div id="anchotabla">
						<table id="<?php echo $genid ?>invoice_line" class="add-invoice-lines" style="width:100%">
							<tr>
								<th class="order handle" id="order"></th>
								<th><?php echo lang('type') ?></th>
								<th class="line-category"><?php echo lang('category') ?></th>
								<th><?php echo lang('product/service') ?></th>
								<th><?php echo lang('quantity') ?></th>
								<!--<th><?php //echo product_types_select_box('payment_receipt[product_type_id]'); ?></th>-->
								<th class="line-user"><?php echo lang('user') ?></th>
								<th class="line-date"><?php echo lang('date') ?></th>
								<th class="line-detail"><?php echo lang('detail') ?></th>
								<th class="price"><?php echo lang('unit value') ?></th>
								<th class="line-amount-type" style="display:;"><?php echo lang('applies to') ?></th>
								<th class="line-discount-type" style="display:;"><?php echo lang('discount %') ?></th>
								<!--<th class=" line-applies-to" style="display:;"><?php echo lang('applies to') ?></th>-->
								
								

								<?php if ($use_line_taxes) { ?>
									<th class="price"><?php echo lang('subtotal') ?></th>
									<?php foreach ($taxes as $tax) { ?>
										<th class="price"><?php echo $tax['name'] ?></th>
									<?php } ?>
								<?php } ?>
								<th class="price line-total" style="display:;"><?php echo lang('total') ?></th>
								<th></th>
							</tr>
						</table>
						</div>

						
							<div style="margin: 5px 0;display: flex;">
								<a href="#" class="link-ico ico-add genid-button" style="width: 200px;" data-genid="<?= $genid; ?>" onclick="App.modules.addInvoiceForm.addLine({genid:'<?php echo $genid ?>', amount:'1', labor_dimension_id: og.income.labor_dimension_id, productService_dim_id: og.income.productService_dim_id, item_type_id:1,});"><?php echo lang('add invoice line') ?></a>
								<table id="<?php echo $genid ?>invoice_totals" class="add-invoice-totals">
								<?php if (count($taxes) > 0) { ?>
									<tr>
										<td class="label"><?php echo lang('subtotal') ?></td>
										<td class="invoice-subtotal price"></td>
									</tr>
									<?php foreach ($taxes as $tax) { ?>
										<tr>
											<td class="label"><?php echo $tax['name'] ?></td>
											<td class="invoice-tax-<?php echo $tax['id'] ?> price"></td>
										</tr>
									<?php } ?>
								<?php } ?>
								<tr>
									<td class="label"><?php echo lang('total') ?></td>
									<td class="invoice-total price"></td>
								</tr>
							</table>
							</div>
					</div>
					<div class="coInputHeader">
						<div style="display: flex; justify-content: flex-end; width: 100%; height: 36px;">
							<div class="coInputButtons">
								<?php echo button(lang('save'), 's', array('style' => 'margin: 0 10px;', 'id' => 'save_invoice')) ?>
							</div>
							<div class="coInputButtons">
								<?php
								$is_mail_active = Plugins::instance()->isActivePlugin('mail');
								$save_and_send_class = $is_mail_active ? "submit" : "submit disabled";
								echo button(lang('save and send'), 's', array('style' => 'margin: 0 10px;', 'id' => 'save_send_invoice', 'class' => $save_and_send_class));
								?>
							</div>
						</div>
					</div>

				</div>

				<!-- Billing Information Form Tab -->
                <div id="<?php echo $genid ?>add_invoice_select_customer_div" class="form-tab">
					<div>
						<div class="desc" style="max-width:400px; margin-bottom: 1rem;"><?php echo lang('please select a contact to autofill the billing information'); ?></div>
						<div id="bill_to_list" class="bill-to-list">
						</div>

						<div class="coInputMainBlock invoiceInputBlock" style="float:left;width: 48%;">
							<div class="dataBlock">
                            <?php echo label_tag(lang('billing company'), 'invoiceFormCustomerName', true) ?>
								<?php echo textarea_field('invoice[customer_name]', array_var($invoice_data, 'customer_name'), array('id' => $genid . 'invoiceFormCustomerName', 'rows' => 3)) ?>
								<div class="clear"></div>
							</div>

							<?php
							Hook::fire('add_invoice_form_before_customer_doc', array('invoice' => $invoice), $null); 
							?>
							<div class="dataBlock">
								<?php $label_lang = array_var($invoice_data, 'final_consumer') ? lang('customer document') : lang('customer rut'); ?>
								<?php echo label_tag($label_lang, 'invoiceFormCustomerRut', $mandatory_customer_rut, array('id' => $genid . "customer_rut_label")) ?>
								<?php echo text_field('invoice[customer_rut]', array_var($invoice_data, 'customer_rut'), array('id' => $genid . 'invoiceFormCustomerRut')) ?>
								<div class="clear"></div>
							</div>

							<div class="dataBlock">
								<?php echo label_tag(lang('billing contact')) ?>
								<?php echo textarea_field('invoice[attn]', $attn_value, array('id' => $genid . 'invoiceFormAttn', 'rows' => 3)) ?>
								<div class="clear"></div>
							</div>

							<div class="dataBlock">
								<?php echo label_tag(lang('customer address'), 'invoiceFormCustomerAddress', $mandatory_customer_address) ?>
								<?php echo textarea_field('invoice[customer_address]', array_var($invoice_data, 'customer_address'), array('id' => $genid . 'invoiceFormCustomerAddress', 'data-clean-bill-to' => 'true')) ?>
								<div class="clear"></div>
							</div>

							<div class="dataBlock">
								<?php echo label_tag(lang('city'), 'invoiceFormCustomerCity', $mandatory_customer_city) ?>
								<?php echo text_field('invoice[customer_city]', array_var($invoice_data, 'customer_city'), array('id' => $genid . 'invoiceFormCustomerCity', 'data-clean-bill-to' => 'true')) ?>
								<div class="clear"></div>
							</div>

							<div class="dataBlock">
								<?php echo label_tag(lang('state'), 'invoiceFormCustomerState') ?>
								<?php echo text_field('invoice[customer_state]', array_var($invoice_data, 'customer_state'), array('id' => $genid . 'invoiceFormCustomerState', 'data-clean-bill-to' => 'true')) ?>
								<div class="clear"></div>
							</div>

							<div class="dataBlock">
								<?php echo label_tag(lang('country'), 'invoiceFormCustomerCountry') ?>
								<?php

								$country_code = array_var($invoice_data, 'customer_country');

								if (strlen($country_code) > 2) {
									$country_code = CountryCodes::getCountryCodeByName($country_code);
								}
								$country_code = strtolower($country_code);
								echo select_country_widget('invoice[customer_country]', $country_code, array('id' => $genid . 'invoiceFormCustomerCountry', 'data-clean-bill-to' => 'true'));

								?>
								<div class="clear"></div>
							</div>

							<div class="dataBlock">
								<?php echo label_tag(lang('zipcode'), 'invoiceFormCustomerZipcode') ?>
								<?php echo text_field('invoice[customer_zipcode]', array_var($invoice_data, 'customer_zipcode'), array('id' => $genid . 'invoiceFormCustomerZipcode', 'data-clean-bill-to' => 'true')) ?>
								<div class="clear"></div>
							</div>

							<div class="dataBlock">
								<?php echo label_tag(lang('email'), 'invoiceFormCustomerEmail') ?>
								<?php echo text_field('invoice[customer_email]', array_var($invoice_data, 'customer_email'), array('id' => $genid . 'invoiceFormCustomerEmail', 'data-type' => 'email_bill_to', 'data-clean-bill-to' => 'true')) ?>
								<div class="clear"></div>
							</div>

							<div class="dataBlock">
								<?php echo label_tag(lang('phone'), 'invoiceFormCustomerPhone') ?>
								<?php echo text_field('invoice[customer_phone]', array_var($invoice_data, 'customer_phone'), array('id' => $genid . 'invoiceFormCustomerPhone', 'data-clean-bill-to' => 'true')) ?>
								<div class="clear"></div>
							</div>


							<div class="dataBlock">
								<?php echo label_tag(lang('customer number'), 'invoiceFormCustomerNumber') ?>
								<?php echo text_field('invoice[customer_number]', array_var($invoice_data, 'customer_number'), array('id' => $genid . 'invoiceFormCustomerNumber')) ?>
								<div class="clear"></div>
							</div>

							<div class="dataBlock">
								<?php echo label_tag(lang('final consumer'), $genid . 'invoiceFormFinalConsumer') ?>
								<?php echo checkbox_field(
									'invoice[final_consumer]',
									array_var($invoice_data, 'final_consumer'),
									array('id' => $genid . 'c_f', 'onchange' => "App.modules.addInvoiceForm.onFinalConsumerChange('$genid');", 'style' => "width: 20px;")
								) ?>
								<div class="clear"></div>
							</div>
						</div>
						<div class="clear"></div>
					</div> <!-- END of Billing Information Form Tab -->


				</div>

				<?php if (in_array($object_subtype->getCode(), array('credit_note','debit_note'))) { ?>
					<div id="<?php echo $genid ?>add_invoice_reference_div" class="form-tab">
						<div id="<?php echo $genid ?>invoice_reference_list_div" class="invoice-reference-list"></div>
						<a href="#" class="link-ico ico-add" onclick="og.pick_referenced_invoice(this, '<?php echo $genid ?>', '<?php echo $invoice->getId()?>')"><?php echo lang('add reference') ?></a>
						
					</div>
				<?php } ?>

				<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
					<div id="<?php echo $genid ?>add_custom_properties_div" class="form-tab other-custom-properties-div">
						<?php echo render_object_custom_properties($object, false, null, 'other') ?>
						<?php echo render_add_custom_properties($object); ?>
					</div>
				<?php } ?>

				<div id="<?php echo $genid ?>add_subscribers_div" class="form-tab">
					<?php $subscriber_ids = array();
					if (!$object->isNew()) {
						$subscriber_ids = $object->getSubscriberIds();
					} else {
						$subscriber_ids[] = logged_user()->getId();
					}
					?>
					<input type="hidden" id="<?php echo $genid ?>subscribers_ids_hidden" value="<?php echo implode(',', $subscriber_ids) ?>" />
					<div id="<?php echo $genid ?>add_subscribers_content"><?php

						$active_members = [];
						foreach ($active_context as $selection) {
							if ($selection instanceof Member) $active_members[] = $selection;
						}
						$subscribers = $object->isNew() ? array(logged_user()) : $object->getSubscribers();
						$subscriber_members = $object->isNew() ? $active_members : $object->getMembers();
						
						echo render_add_subscribers($object, $genid, $subscribers, $subscriber_members);
						
						if (isset($subscriber_ids) && is_array($subscriber_ids)) {
							foreach ($subscriber_ids as $subid) {
								echo '<input type="hidden" name="subscribers[user_'.$subid.']" value="1"/>';
							}
						}

					?></div>
				</div>

				<div id="<?php echo $genid ?>add_more_details_div" class="form-tab">
					<?php
					tpl_assign('genid', $genid);
					tpl_assign('invoice_data', $invoice_data);
					?>

					<div class="repeat-options-div sub-section-div" style="border-top:0px none;">
						<h2><?php echo lang('repeat options') ?></h2>
						<?php
						$this->includeTemplate(get_template_path('repeat_options', 'invoice', 'income'));
						?>
					</div>

					<?php if ($object->isNew() || $object->canLinkObject(logged_user())) { ?>
						<div class="linked-objects-div sub-section-div">
							<h2><?php echo lang('linked objects') ?></h2>
							<?php
							echo render_object_link_form($object)
							?>
						</div>
					<?php }  
					?>

				</div>

				<?php foreach ($categories as $category) { ?>
					<div id="<?php echo $genid . $category['name'] ?>" class="form-tab">
						<?php echo $category['content'] ?>
					</div>
				<?php } ?>

				<?php if (!array_var($_REQUEST, 'modal')) {
					echo submit_button($object->isNew() ? lang('add invoice') : lang('save changes'), 's', array('style' => 'margin-top:0px'));
				} ?>
			</div>
		</div>
	</div>
</form>

<div style="display:none;" id="<?php echo $genid ?>_currency_selector_template"><?php
																				echo currency_selector('invoice_lines[{i}][currency_id]', 0, array(
																					'id' => $genid . "_currency_selector_{i}", 'onchange' => "App.modules.addInvoiceForm.onLineCurrencyChange('$genid', {i}, this);", "class" => "invline_currency_selector"
																				));
																				?></div>
<script>
<?php if (Plugins::instance()->isActivePlugin('expenses2')) { ?>
	og.expenses2.product_types = Ext.util.JSON.decode('<?php echo(json_encode($product_types))?>');
<?php
} else {
?>
	og.expenses2 = {};
	og.expenses2.product_types = [];
<?php } ?>
	


	function set_grid_color() {
		var table_rows = $("#" + <?php echo $genid ?> + "invoice_line tr.invoice-line-tr");
		for (var i = 0; i < table_rows.length; i++) {
			if (i % 2 == 0) $(table_rows[i]).addClass('alt');
			else $(table_rows[i]).removeClass('alt');
		}
	}

	$("#<?php echo $genid ?>invoice_line tbody").sortable({

		stop: function(event, ui) {
			set_grid_color();
		},
		update: function(event, ui) {
			$(this).children().each(function(index) {
				$(this).find('input').first().val(index)
				});
			}
	});

	<?php
	$exchange_rates_info = ExchangeRates::getLastExchangeRatesInfo();
	$invoice_templates_info = IncomeInvoiceTemplates::instance()->getInvoiceTemplatesInfo();

	$labor_cat_dim = Dimensions::findByCode('hour_types');
	if ($labor_cat_dim instanceof Dimension)
	{
		$labor_dimension_id = $labor_cat_dim->getId();
	}

	$productService_cat_dim = Dimensions::findByCode('expense_categories');
	if ($productService_cat_dim instanceof Dimension)
	{
		$productService_dim_dimension_id = $productService_cat_dim->getId();
	}
	?>
	og.exchange_rates_info = Ext.util.JSON.decode('<?php echo json_encode($exchange_rates_info); ?>');
	og.invoice_templates_info = Ext.util.JSON.decode('<?php echo str_replace('\"', '&quot;', json_encode($invoice_templates_info)); ?>');
	og.income.taxes = Ext.util.JSON.decode('<?php echo json_encode($taxes); ?>');
	og.income.use_line_taxes = <?php echo $use_line_taxes ? '1' : '0' ?>;

	Ext.get('<?php echo $genid ?>invoiceFormTitle').focus();

	COUNT_LINE = 1;
	<?php
				$labor_cat_dim = Dimensions::findByCode('hour_types');
				if ($labor_cat_dim instanceof Dimension)
				{
					$labor_dimension_id = $labor_cat_dim->getId();
				} 

				$productService_cat_dim = Dimensions::findByCode('expense_categories');
				if ($productService_cat_dim instanceof Dimension)
				{
					$productService_dim_dimension_id = $productService_cat_dim->getId();
				} 
				
			?>
			<?php 
			      $item_type_id_default=3;
				  if(!in_array($labor_dimension_id,config_option('enabled_dimensions')))
				  {
					$labor_dimension_id='';
				  }else{
                    $item_type_id_default=2;
				  }
				  if(!in_array($productService_dim_dimension_id,config_option('enabled_dimensions')))
				  {
				    $productService_dim_dimension_id='';
				  }else{
					$item_type_id_default=1;
				  }
				 
			?>
				og.income.labor_dimension_id= "<?php echo $labor_dimension_id ?>"; // og.income.labor_dimension_id='' is disabled
				og.income.productService_dim_id="<?php echo $productService_dim_dimension_id ?>";	// og.income.productService_dim_id='' is disabled
				og.income.item_type_id_default=1;//"<?php //echo $item_type_id_default;?>";
				
	<?php if ($object->isNew()) { ?>
			App.modules.addInvoiceForm.addLine({
			genid: '<?php echo $genid ?>',
			labor_dimension_id: '<?php echo $labor_dimension_id ?>',
			productService_dim_id: '<?php echo $productService_dim_dimension_id ?>',
			item_type_id:og.income.item_type_id_default,
		});
		
		og.income.cat_mem_id='';
		setTimeout(function() {
			App.modules.addInvoiceForm.updateClientData('<?php echo $genid ?>', true);
		}, 1000);

		<?php foreach (array_var($invoice_data, 'invoice_references_data') as $invoice_ref) { ?>
			var ref_data = {
				id: "<?php echo $invoice_ref->getId() ?>",
				referenced_object_name: "<?php echo $invoice_ref->getReferencedObjectName() ?>",
				serie: "<?php echo $invoice_ref->getSerie() ?>",
				invoice_number: "<?php echo $invoice_ref->getInvoiceNumber() ?>",
				detail: "<?php echo $invoice_ref->getDetail() ?>",
				referenced_object_id: "<?php echo $invoice_ref->getReferencedObjectId() ?>",
				amount: "<?php echo $invoice_ref->getAmount() ?>"
			};
			og.invoices.drawAddReference('<?php echo $genid ?>', ref_data);
		<?php } ?>

	<?php } else { ?>

		<?php
		$labor_cat_dim = Dimensions::findByCode('hour_types');
		$category_product_dimension_id='';
		foreach ($invoice->getInvoiceLines() as $invoice_line) { /* @var $invoice_line IncomeInvoiceLine */
			$category_dimension_id = 0;
			$main_member_dim_id = 0;

			if ($invoice_line->getRelObjectId() > 0 && Plugins::instance()->isActivePlugin('expenses2')) {
				$rel_obj = Objects::findObject($invoice_line->getRelObjectId());
				if ($rel_obj instanceof PaymentReceipt) {
					$exp_cat_dim = Dimensions::findByCode('expense_categories');
					$category_dimension_id = $exp_cat_dim instanceof Dimension ? $exp_cat_dim->getId() : 0;
				}
			}

			if (!$category_dimension_id) {
				if ($invoice_line->getCategoryId() > 0) {
					$cat_m = Members::getMemberById($invoice_line->getCategoryId());
					if ($cat_m instanceof Member) 
					{
						$category_dimension_id = $cat_m->getDimensionId();
						$category_product_dimension_id=$cat_m->getDimensionId();
					}
				}
			}

			if (!$category_dimension_id) {
				if ($labor_cat_dim instanceof Dimension)
				{
					$category_dimension_id = $labor_cat_dim->getId();
				} 
			}

			$main_member = null;
			$main_member_name = '';
			if ($invoice_line->getMemberId() > 0) {
				$main_member = Members::getMemberById($invoice_line->getMemberId());
				if ($main_member instanceof Member) $main_member_dim_id = $main_member->getDimensionId();
				$tmp_mems = array($main_member);
				build_member_list_text_to_show_in_trees($tmp_mems);
				$main_member_name = $main_member->getName();
			}
		?>
		<?php 
				 if(!in_array($labor_dimension_id,config_option('enabled_dimensions')))
				 {
				   $labor_dimension_id='';
				   //$productService_dim_dimension_id='';
				 }

				
				 if(!in_array($productService_dim_dimension_id,config_option('enabled_dimensions')))
				 {
					 $productService_dim_dimension_id = '';
				 } 

			?>

			og.income.labor_dimension_id= '<?php echo $labor_dimension_id ?>';
	    	og.income.productService_dim_id='<?php echo $productService_dim_dimension_id ?>';

			App.modules.addInvoiceForm.addLine({
				genid: '<?php echo $genid ?>',
				order: '<?php echo $invoice_line->getOrder() ?>',
				id: '<?php echo $invoice_line->getId() ?>',
				amount: '<?php echo $invoice_line->getAmount() ?>',
				detail: '<?php echo str_replace("\n", "%|%", escape_character($invoice_line->getDetail(), "'", true)) ?>',
				user_id: '<?php echo $invoice_line->getUserId() ?>',
				user_name: '<?php echo $invoice_line->getUserName() ?>',
				unit_value: '<?php echo $invoice_line->getUnitValue() ?>',
				date: '<?php if ($invoice_line->getDate()) echo format_date($invoice_line->getDate(), null, 0) ?>',
				cat_dim_id: '<?php echo $category_dimension_id ?>',
				cat_mem_id: '<?php echo $invoice_line->getCategoryId() ?>',
				main_dim_id: '<?php echo $main_member_dim_id ?>',
				main_mem_id: '<?php echo $invoice_line->getMemberId() ?>',
				main_mem_name: '<?php echo escape_character($main_member_name) ?>',
				rel_object_id: '<?php echo $invoice_line->getRelObjectId() ?>',
				from_object_type_id: '<?php echo $invoice_line->getFromObjectTypeId() ?>',
				product_type_id: '<?php echo $invoice_line->getProductTypeId() ?>',
				unit_cost: '<?php echo $invoice_line->getUnitCost() ?>',
				price_multiplier: '<?php echo $invoice_line->getPriceMultiplier() ?>',
				total: '<?php echo $invoice_line->getTotal() ?>',
				subtotal: '<?php echo $invoice_line->getSubtotal() ?>',
				taxes: '<?php echo $invoice_line->getTaxes() ?>',
				taxes_info: Ext.util.JSON.decode('<?php echo json_encode($invoice_line->getLineTaxesInfo()) ?>'),
				currency: '<?php echo $invoice_line->getCurrencyId() ?>',
				exchange_rate: '<?php echo $invoice_line->getExchangeRate() ?>',
				item_type_id: '<?php echo $invoice_line->getItemTypeId() ?>',
				labor_dimension_id: '<?php echo $labor_dimension_id ?>',
				productService_dim_id: '<?php echo $productService_dim_dimension_id ?>',
				discount_percent_value: '<?php echo $invoice_line->getDiscountPercentValue() ?>',
				discount_percent_type: '<?php echo $invoice_line->getDiscountPercentType() ?>',
				split_invoice_for_billing_clients: '<?php echo $split_invoice_for_billing_clients ?>',
				group_by_category_id: '<?php echo $invoice_line->getGroupByCategoryId() ?>',
			});
		<?php } ?>

		<?php foreach ($invoice->getInvoiceReferences() as $invoice_ref) { ?>
			var ref_data = {
				id: "<?php echo $invoice_ref->getId() ?>",
				referenced_object_name: "<?php echo $invoice_ref->getReferencedObjectName() ?>",
				serie: "<?php echo $invoice_ref->getSerie() ?>",
				invoice_number: "<?php echo $invoice_ref->getInvoiceNumber() ?>",
				detail: "<?php echo $invoice_ref->getDetail() ?>",
				referenced_object_id: "<?php echo $invoice_ref->getReferencedObjectId() ?>",
				amount: "<?php echo $invoice_ref->getAmount() ?>",
			};
			og.invoices.drawAddReference('<?php echo $genid ?>', ref_data);
		<?php } ?>

		setTimeout(function() {
			App.modules.addInvoiceForm.updateClientData('<?php echo $genid ?>', false);
		}, 1000);

	<?php } ?>

	$(function() {
		$("#<?php echo $genid ?>tabs").tabs();
		<?php if (count($all_currencies) > 1) { ?>
			App.modules.addInvoiceForm.onInvoiceCurrencyChange('<?php echo $genid ?>');
		<?php } ?>

		<?php if ($invoice_template_cp instanceof CustomProperty) { ?>
			$('select[name ="object_custom_properties[<?php echo $invoice_template_cp->getId() ?>]"]').change(function() {
				App.modules.addInvoiceForm.currentInvoiceTemplate = og.invoice_templates_info[$(this).val()];
				App.modules.addInvoiceForm.showHideLineTableColumns();
			});
		<?php } ?>
		/**
		 * HARDCODED FOR KJOLHAUG, SET DUE DATE DEPENDING ON THE VALUE OF PAYMENT TERMS
		 */
		<?php if ($payment_period_cp instanceof CustomProperty) { ?>
			$('select[name ="object_custom_properties[<?php echo $payment_period_cp->getId() ?>]"]').change(function() {
				og.recalculate_invoice_due_date($(this).val());
			});
		<?php } ?>
		/**
		 * END HARDCODED FOR KJOLHAUG
		 */

		<?php if ($invoice_template_cp instanceof CustomProperty && !$invoice->isNew()) { ?>
			// dont allow to change invoice template if invoice is not new
			$('select[name ="object_custom_properties[<?php echo $invoice_template_cp->getId() ?>]"]').attr('disabled', 'disabled');
		<?php } ?>

		App.modules.addInvoiceForm.currentInvoiceTemplate = null;
		var current_inv_template_id = $('select[name ="object_custom_properties[<?php echo $invoice_template_cp->getId() ?>]"]').val();
		if (current_inv_template_id) {
			App.modules.addInvoiceForm.currentInvoiceTemplate = og.invoice_templates_info[current_inv_template_id];
			App.modules.addInvoiceForm.showHideLineTableColumns();
		}

		App.modules.addInvoiceForm.recalculateTotalsBox('<?php echo $genid ?>');

		// correct totals table position
		setTimeout(function() {
			var lines_width = $(".add-invoice-lines").outerWidth();
			$(".add-invoice-totals").width(lines_width);
		},200);
	});

	og.pick_referenced_invoice = function(element, genid, this_obj_id) {
		og.ObjectPicker.show(function (objs) {
			if (objs && objs.length > 0) {
				var obj = objs[0].data;
				
				var ref_data = {
					id: 0,
					referenced_object_name: obj.invoice_number ? lang('invoice') + " " + obj.invoice_number : obj.name,
					serie: '',
					invoice_number: obj.invoice_number,
					detail: '',
					referenced_object_id: obj.object_id,
					amount: og.format_money_amount(obj.due_amount),
				};
				og.invoices.drawAddReference(genid, ref_data);
			}
		}, element, {
			types: ['invoice'],
			selected_type: 'invoice'
		},'',this_obj_id);
	};

	/**
	 * HARDCODED FOR KJOLHAUG, SET DUE DATE DEPENDING ON THE VALUE OF PAYMENT TERMS
	 */
	og.recalculate_invoice_due_date = function(payment_terms) {
		var due_date = null;
		var inv_date = Ext.getCmp("invoiceFormDate").getValue();
		switch (payment_terms) {
			case 'Due on receipt':
			case 'Net D':
				due_date = new Date(inv_date);
				break;
			case '1% 30 Days':
				due_date = new Date(inv_date.setDate(inv_date.getDate() + 30));
				break;
			case 'net 45 term':
				due_date = new Date(inv_date.setDate(inv_date.getDate() + 45));
				break;
			default: 
				// this will cover each payment term called "Net X" where X is the amount of days like Net 30, Net 60, etc.
				let splitted = payment_terms.split(' ');
				let days = splitted[splitted.length - 1];
				if (!isNaN(days) && days > 0) {
					due_date = new Date(inv_date.setDate(inv_date.getDate() + parseInt(days)));
				}
				break;
		}
		if (due_date) {
			Ext.getCmp("invoiceFormExpirationDate").setValue(due_date);
		}
	}
	/**
	 * END HARDCODED FOR KJOLHAUG
	 */
</script>

<script id="invoice-new-reference-template" type="text/x-handlebars-template">
	<div id="{{genid}}_{{line_number}}_invoice_reference_line" class="invoice_reference_line {{row_class}}">
		<span class="invoice-name" id="{{genid}}_{{line_number}}_referenced_object_name">{{referenced_object_name}}</span>
		<input type="hidden" name="invoice_references[{{line_number}}][id]" value="{{id}}" id="{{genid}}_{{line_number}}_invoice_reference_id">
		<input type="text" name="invoice_references[{{line_number}}][detail]" value="{{detail}}" placeholder="{{lang 'description'}}" class="subtask-name" style="display: inline-block;">
		<input type="text" name="invoice_references[{{line_number}}][amount]" value="{{amount}}" placeholder="{{lang 'amount'}}" class="subtask-name right" style="display: inline-block;">
		<input type="hidden" name="invoice_references[{{line_number}}][deleted]" value="0" id="{{genid}}_{{line_number}}_invoice_reference_deleted" class="deleted-hf">
		<input type="hidden" name="invoice_references[{{line_number}}][referenced_object_id]" value="{{referenced_object_id}}" class="subtask-name" style="display: inline-block;">
		<div class="remove-link-container" style="display: inline-block;">
			<a href="#" class="link-ico ico-delete remove-subtask-link"
			   onclick="og.invoices.removeReference('{{genid}}','{{line_number}}')">
				{{lang 'remove'}}
			</a>
		</div>
	</div>
</script>
<script id="bill_to_option" type="text/x-handlebars-template">
	{{#if type}}
		<h4>{{type}}</h4>
	{{/if}}
	<div class="bill-to-option">
		<input id="bill_to_{{code}}" name="bill_to_option" type="radio" data-contact-bill-to="true" data-json="{{json_data}}">
		<span><b>{{name}}</b> {{address}}</span>
	</div>
</script>
