<?php 
$genid = gen_id();
// on submit functions
if (array_var($_REQUEST, 'modal')) {
	$on_submit = "og.submit_modal_form('".$genid."submit-edit-form', og.invoices.goToPrintInvoice); return false;";
} else {
	$on_submit = "return true;";
}

$notebooks_array[0] = array(0, lang('select invoice notebook'));
foreach ($invoice_notebooks as $invoice_notebook) {
	$notebooks_array[] = array($invoice_notebook->getId(), lang('series') . " " . $invoice_notebook->getSeries() . " " . $invoice_notebook->getInitialNumber() . " - " . $invoice_notebook->getFinalNumber());
}

$use_serie_for_invoice_number = income_config_option("use_serie_for_invoice_number");
?>

<script>
var genid = '<?php echo $genid?>';

og.invoices.tmp_notebooks_info = Ext.util.JSON.decode('<?php echo json_encode($notebooks_info)?>');

og.invoices.goToPrintInvoice = function(data) {
	setTimeout(function() {
		og.openLink(og.getUrl('invoice', 'print_view', {id: data.id}), {
			preventPanelLoad: true,
			callback: function (success, data) {
				var disp_setting = "toolbar=yes,location=no,directories=yes,menubar=yes,scrollbars=yes,";
				var printWindow = window.open("","",disp_setting);
				printWindow.document.open(); 
				printWindow.document.write('<html><head><title></title>');
				printWindow.document.write('<link href="' + og.hostName + '/public/assets/themes/default/stylesheets/website.css" rel="stylesheet" type="text/css">');
				printWindow.document.write('<link href="' + og.hostName + '/public/assets/themes/default/stylesheets/general/rewrites.css" rel="stylesheet" type="text/css">');
				printWindow.document.write('</head><body id="body" style="padding:10px;">');

				printWindow.document.write(data.current.data);

				printWindow.document.write('</body></html>');    
				printWindow.document.close();
				printWindow.focus();
			}
		});
	}, 1000);
}

og.invoices.printParamsChangeNotebook = function(combo, genid) {
	var n = $(combo).val();
	var info = null;
	if (n > 0) {
		info = og.invoices.tmp_notebooks_info[n];
	}
	if (info) {
		$('#'+genid+'invoiceFormSeries').val(info.serie);
		$('#'+genid+'invoiceFormNumber').val(info.next_num);
	} else {
		$('#'+genid+'invoiceFormSeries').val('');
		$('#'+genid+'invoiceFormNumber').val('');
	}
}
</script>
<style>
.print-parameters label {
	padding-top: 4px;
	min-width: 150px;
}
</style>

<form onsubmit="<?php echo $on_submit?>" class="print-parameters" id="<?php echo $genid ?>submit-edit-form" action="<?php echo get_url('invoice', 'print_parameters', array('id' => array_var($invoice_data, 'id'))) ?>" 
	method="post" style="min-width: 350px;">

<div class="coInputHeader">
	<div class="coInputHeaderUpperRow" id="<?php echo $genid?>_title_label">
		<div class="coInputTitle"><?php echo lang('invoice number') ?></div>
	</div>
	<div class="clear"></div>
</div>

<div class="coInputMainBlock">

	<div class="dataBlock">
		<?php echo label_tag(lang('invoice notebook'), $genid . 'invoiceIncomeNotebook') ?>
		<?php echo simple_select_box('invoice_data[invoice_notebook_id]', $notebooks_array, array_var($invoice_data, 'invoice_notebook_id'), 
				array('id' => 'invoiceIncomeNotebook', 'style' => 'min-width:160px;', 'onchange' => 'og.invoices.printParamsChangeNotebook(this, \''.$genid.'\')')); ?>
		<div class="clear"></div>
	</div>
	
	<?php if ($use_serie_for_invoice_number) { ?>
	<div class="dataBlock">
		<?php echo label_tag(lang('series'), $genid . 'invoiceFormSeries', true) ?>
		<?php echo text_field('invoice_data[series]', array_var($invoice_data, 'series'), array('id' => $genid.'invoiceFormSeries', 'maxlength' => 40, 'style' => 'width:150px;')) ?>
		<div class="clear"></div>
	</div>
	<?php } ?>

	<div class="dataBlock">
		<?php echo label_tag(lang('invoice number'), $genid . 'invoiceFormNumber', true) ?>
		<?php echo text_field('invoice_data[invoice_number]', array_var($invoice_data, 'invoice_number'), array('id' => $genid.'invoiceFormNumber', 'maxlength' => 40, 'style' => 'width:150px;')) ?>
		<div class="clear"></div>
	</div>
	
	
	<div style="float:right;margin-right:10px;"><?php echo submit_button(lang('confirm data and print')) ?></div>
	<div class="clear"></div>
	
</div>

</form>
	
