<?php
set_page_title(lang('invoice layouts'));
$genid = gen_id();
?>

<div id="<?php echo $genid ?>invoiceLayouts" class="coInputMailAccounts" style="height: 100%; background-color: white">
	<div class="coInputHeader">
		<div class="coInputTitle"><?php echo lang('invoice layouts') ?></div>
	</div>
	<div class="adminMainBlock">
		<?php if(isset($invoice_layouts) && is_array($invoice_layouts) && count($invoice_layouts)) { ?>
		<table class="adminListing" style="min-width: 400px; margin-top: 10px;">
				<tr>
					<th style="text-align: left; padding-left: 20px;"><?php echo lang('name') ?></th>
					<th><?php echo lang('enabled') ?></th>
					<th><?php echo lang('options') ?></th>
				</tr>
				<?php
				$isAlt = true;
				foreach($invoice_layouts as $layout) {
						$isAlt = !$isAlt;
				?>
				<tr class="<?php echo $isAlt? 'altRow' : ''?>" id="<?php echo $genid ?>tr_<?php echo $layout->getId()?>">
					<td style="text-align: left; padding-left: 20px;"><?php echo $layout->getName() ?></td>
					<td><?php echo $layout->getEnabled() ? lang('yes') : lang('no') ?></td>
					<?php
					$options = array();
					$options[] = '<a target="_blank" class="link-ico ico-print" href="'.get_url('invoice_layout', 'preview_layout', array('id' => $layout->getId())).'">' . lang('preview') . '</a>';
					$options[] = '<a target="_self" class="link-ico ico-download" href="'.get_url('invoice_layout', 'download_layout_content', array('id' => $layout->getId())).'">' . lang('download') . '</a>';
					if (!$layout->getIsSystem()) {
						$options[] = '<a class="internalLink link-ico ico-edit" href="#" onclick="og.render_modal_form(\'\',{c:\'invoice_layout\', a:\'edit\', params:{id:'.$layout->getId().'}});">' . lang('edit') . '</a>';
						$options[] = '<a class="internalLink link-ico ico-delete" href="javascript:og.income.delete_layout(' . $layout->getId() . ')">' . lang('delete') . '</a>';
					}
					?>
					<td style="text-align: left; padding-left: 20px; width:400px;"><?php 
					foreach ($options as $option) {
						echo '<span style="margin:0 10px">' . $option . '</span>';
					}
					//echo implode(' ', $options) 
					?></td>
				</tr>
				<?php } // foreach ?>
		</table>
		<?php } else { ?><div><?php echo lang('no invoice layouts') ?></div><?php } // if ?>
		
		</br><a href="#" onclick="og.render_modal_form('',{c:'invoice_layout', a:'add'});" class="link-ico ico-add"><?php echo lang('add invoice layout')?></a>
	</div>

</div>

<script>
		
	og.income.delete_layout = function(layout_id) {        
		if (confirm(lang('delete invoice layout'))) {
			og.openLink(og.getUrl('invoice_layout', 'delete', { id : layout_id }), {
				callback: function(success, data) {
					$('#<?php echo $genid ?>tr_'+layout_id).remove();
				}
			});
		}
	};


</script>
