<?php
set_page_title(lang('invoice notebook'));
        
$genid = gen_id();
?>

<div id="<?php echo $genid ?>InvoiceNotebooks" class="adminMailAccounts" style="height: 100%; background-color: white">
    <div class="coInputHeader">
        <div class="coInputTitle"><?php echo lang('invoice notebooks') ?></div>
    </div>
    <div class="adminMainBlock">
        <?php if(isset($invoice_notebooks) && is_array($invoice_notebooks) && count($invoice_notebooks)) { ?>
        <table class="adminListing" style="min-width: 400px; margin-top: 10px;">
                <tr>
                    <th><?php echo lang('invoice type') ?></th>
                    <th><?php echo lang('series') ?></th>
                    <th><?php echo lang('initial number') ?></th>
                    <th><?php echo lang('final number') ?></th>
                    <th><?php echo lang('expiration date') ?></th>
                    <th><?php echo lang('options') ?></th>
                </tr>
                <?php
                $isAlt = true;
                foreach($invoice_notebooks as $invoice_notebook) {
                        $isAlt = !$isAlt;
                ?>
                <tr class="<?php echo $isAlt? 'altRow' : ''?>" id="<?php echo $genid ?>tr_<?php echo $invoice_notebook->getId()?>">
                    <td><?php echo $invoice_notebook->getInvoiceType(); ?></td>
                    <td><?php echo $invoice_notebook->getSeries() ?></td>
                    <td><?php echo $invoice_notebook->getInitialNumber() ?></td>
                    <td><?php echo $invoice_notebook->getFinalNumber() ?></td>
                    <td><?php echo $invoice_notebook->getExpirationDate() instanceof DateTimeValue ? format_date($invoice_notebook->getExpirationDate()->advance(logged_user()->getUserTimezoneValue() * -1, false)) : '' ?></td>
                    <?php
                    $options = array();
                    $options[] = '<a class="internalLink" href="#" onclick="og.render_modal_form(\'\',{c:\'invoice_notebook\', a:\'edit\', params:{id:'.$invoice_notebook->getId().'}});">' . lang('edit') . '</a>';
                    $options[] = '<a class="internalLink" href="javascript:og.DeleteInvoiceNotebook(' . $invoice_notebook->getId() . ')">' . lang('delete') . '</a>';
                    ?>
                    <td><?php echo implode(' | ', $options) ?></td>
                </tr>
                <?php } // foreach ?>
        </table>
        <?php } else { ?><div><?php echo lang('no invoice notebooks') ?></div><?php } // if ?>
        
        </br><a href="#" onclick="og.render_modal_form('',{c:'invoice_notebook', a:'add'});" class="link-ico ico-add"><?php echo lang('add invoice notebook')?></a>
    </div>
</div>

<script>
	var div = document.getElementById('<?php echo $genid ?>InvoiceNotebooks');
	div.parentNode.style.backgroundColor = '#FFFFFF'; 
        
        og.DeleteInvoiceNotebook = function(invoice_notebookId) {        
            if (confirm(lang('delete invoice notebook'))) {
                og.openLink(og.getUrl('invoice_notebook', 'delete', {
                        invoice_notebook_id : invoice_notebookId
                }), {
                    callback: function(success, data) {
                    	$('#<?php echo $genid ?>tr_'+invoice_notebookId).remove();
                	}
                });
            }
        };
</script>
