<?php 
$genid = gen_id();
$project_ot = ObjectTypes::findByName('project');
$expense_cat_dim = Dimensions::findByCode('expense_categories');

//search for income invoice template options
if($invoice_template instanceof incomeInvoiceTemplate && $invoice_template->getId()){
	$invoice_template_options = IncomeInvoiceTemplateOptions::getInvoiceTemplateOptions($invoice_template->getId());
}


//create an array with the options
foreach($invoice_template_options as $invoice_template_option){

    $invoice_template_options_items['name']=$invoice_template_option->getName();
    $invoice_template_options_items['label']=$invoice_template_option->getLabel();
    $invoice_template_options_items['order']=$invoice_template_option->getOrderNumber();
    $invoice_template_options_items['visible']=$invoice_template_option->getVisible();
    $invoice_template_options_items['selected_option']=$invoice_template_option->getSelectedOption();

    $invoice_template_options_array[$invoice_template_option->getName()] = $invoice_template_options_items; 
}

if (Plugins::instance()->isActivePlugin('expenses2')) {
	$filtered_product_types_lump_sum = null;
	$exp_cat_ls = Members::instance()->findById(array_var($invoice_template_edit, 'category_for_lump_sum'));
	if ($exp_cat_ls instanceof Member) {
		$filtered_product_types_lump_sum = ProductTypes::getFilteredProductTypesData(array($exp_cat_ls));
	}
	$exp_cat_exp = Members::instance()->findById(array_var($invoice_template_edit, 'category_for_expenses'));
	if ($exp_cat_exp instanceof Member) {
		$filtered_product_types_expenses = ProductTypes::getFilteredProductTypesData(array($exp_cat_exp));
	}
}

$labor_cat_dim = Dimensions::findByCode('hour_types');
if (Plugins::instance()->isActivePlugin('expenses2')) {
	$filtered_product_types_timeslot = null;
	$exp_cat_ls = Members::instance()->findById(array_var($invoice_template_edit, 'category_for_timeslot'));
	if ($exp_cat_ls instanceof Member) {
		$filtered_product_types_timeslot = ProductTypes::getFilteredProductTypesData(array($exp_cat_ls));
	}
}

$form_url = get_url('invoice_template', 'add');
if (!$invoice_template->isNew()) {
	$form_url = get_url('invoice_template', 'edit', array('id' => $invoice_template->getId()));
}

$on_submit = "og.submit_modal_form('".$genid."submit-edit-form'); return false;";
?>
<style>
.invoice-template .coInputMainBlock label { float: left; /*min-width: 300px;*/ max-width: 300px; clear: both; }
.invoice-template input.title { width: 100%; }

@import url('https://fonts.googleapis.com/css2?family=Montserrat:wght@200;300;400;500;600;700&display=swap');  
#invoiceOptions { margin: 0 auto; border-spacing: 3px; width: 100%; }
#invoiceOptions tr th { background: #2E4551; -webkit-print-color-adjust: exact !important; color: white; font-family: 'Montserrat', sans-serif; padding: 5px; text-align: left; text-transform: capitalize; }
#invoiceOptions { clear: both; width: 100%; margin: 10px 0 0 0; }
#invoiceOptions tr td { vertical-align: middle; border: 0; padding: 5px; font-size: 13px; font-family: sans-serif; width: 33.333%;}
#invoiceOptions tr:nth-child(even) td { background: #E6E6E6; -webkit-print-color-adjust: exact !important; }
#invoiceOptions tr:nth-child(odd) td { background: #FFFFFF; -webkit-print-color-adjust: exact !important; }
#invoiceOptions td input, #invoiceOptions td select{ width: 100%; box-sizing: border-box; vertical-align: middle; }
.title_lines { position: relative; font-size: 20px; z-index: 1; overflow: hidden; text-align: left; color: #2E4551; font-family: arial; }
.title_lines:before, .title_lines:after { position: absolute; top: 51%; overflow: hidden; width: 100%; height: 2px; content: '\a0'; background-color: #2A9D8F; margin-left: 2%; z-index: -1;}
.title_lines:before { text-align: right; }
.title_lines h3 {background: #ffffff; display: inline-block; padding: 10px 10px 10px 0; text-decoration: none;}
.tabs__content{padding: 20px 0;}
input[type="checkbox"]:before { border-radius: 4px; }
input[type="checkbox"]:after { width: 9.6px; height: 16px; border-radius: 0; transform: translate(-50%, -85%) scale(0) rotate(45deg); background-color: transparent; box-shadow: 4px 4px 0px 0px #2A9D8F; }
input[type="checkbox"]:checked:after { -webkit-animation: toggleOnCheckbox 0.2s ease forwards; animation: toggleOnCheckbox 0.2s ease forwards; }
input[type="checkbox"].filled:before { border-radius: 4px; transition: 0.2s border-color ease, 0.2s background-color ease; }
input[type="checkbox"].filled:checked:not(:disabled):before { background-color: #2A9D8F; }
input[type="checkbox"].filled:not(:disabled):after { box-shadow: 4px 4px 0px 0px white; }
input { position: relative !important; -webkit-appearance: none; -moz-appearance: none; appearance: none; /*overflow: hidden;*/ }
input:before { content: ''; display: block; box-sizing: content-box; width: 16px; height: 16px; border: 2px solid #ccc; transition: 0.2s border-color ease; margin: auto; }
input:checked:before { border-color: #2A9D8F; transition: 0.5s border-color ease; }
input:disabled:before { border-color: #ccc; background-color: #ccc; }
input:after { content: ''; display: block; position: absolute; box-sizing: content-box; top: 50%; left: 50%; transform-origin: 50% 50%; background-color: #2A9D8F; width: 16px; height: 16px; border-radius: 100vh; transform: translate(-50%, -50%) scale(0); }
@-webkit-keyframes toggleOnCheckbox { 0% { opacity: 0; transform: translate(-50%, -85%) scale(0) rotate(45deg); } 70% { opacity: 1; transform: translate(-50%, -85%) scale(0.9) rotate(45deg); } 100% { transform: translate(-50%, -85%) scale(0.8) rotate(45deg); } }
@keyframes toggleOnCheckbox { 0% { opacity: 0; transform: translate(-50%, -85%) scale(0) rotate(45deg); } 70% { opacity: 1; transform: translate(-50%, -85%) scale(0.9) rotate(45deg); } 100% { transform: translate(-50%, -85%) scale(0.8) rotate(45deg); } }
.groupSelects{ display: grid; grid-template-columns: calc(33.3333% - 5%) calc(33.3333% - 5%) calc(33.3333% - 5%); gap: 5%; }
.groupSelects .dataBlock select { width: 100% !important; }
.groupSelects .dataBlock{
    display: flex;
    flex-direction: column;
    justify-content: end;
}
.labelAndCheckboxFlex{display: flex; align-items: center;}
.labelAndCheckboxFlex input[type="checkbox"]:first-child{
	margin-right: 5px;
}

@import url('https://fonts.googleapis.com/css2?family=Montserrat:wght@200;300;400;500;600;700&display=swap');  
#invoiceOptions { margin: 0 auto; border-spacing: 3px; width: 100%; }
#invoiceOptions tr th { background: #2E4551; -webkit-print-color-adjust: exact !important; color: white; font-family: 'Montserrat', sans-serif; padding: 5px; text-align: left; text-transform: capitalize; }
#invoiceOptions { clear: both; width: 100%; margin: 10px 0 0 0; }
#invoiceOptions tr td { border: 0; padding: 5px; font-size: 13px; font-family: sans-serif; width: 33.333%;}
#invoiceOptions tr:nth-child(even) td { background: #E6E6E6; -webkit-print-color-adjust: exact !important; }
#invoiceOptions tr:nth-child(odd) td { background: #FFFFFF; -webkit-print-color-adjust: exact !important; }
#invoiceOptions td input, #invoiceOptions td select{ width: 100%; }
</style>

<form id="<?php echo $genid ?>submit-edit-form" class="internalForm" action="<?php echo $form_url ?>" method="post" onsubmit="<?php echo $on_submit ?>">
<div class="invoice-template">
	<div class="coInputHeader">
	
	  <div class="coInputHeaderUpperRow">
		<div class="coInputTitle">
			<?php echo $invoice_template->isNew() ? lang('add invoice template') : lang('edit invoice template') ?>
		</div>
	  </div>
	
	  <div>
		<div class="coInputButtons" style="float:right;">
			<?php echo submit_button(array_var($invoice_template_edit, 'id') ? lang('save changes') : lang('add invoice template')); ?>
		</div>
		<div class="clear"></div>
	  </div>
	</div>
	
	<div class="coInputMainBlock">

		<div class="wrapper">
			<div class="tabs">
				<nav class="tabs__nav" role="tablist">
				    <button class="tabs__btn_template is-active-template" data-tab-target="tab-template-1" type="button" role="tab" aria-selected="true">General Settings</button>
					<button class="tabs__btn_template" data-tab-target="tab-template-2" type="button" role="tab" aria-selected="false">Columns</button>
					<button class="tabs__btn_template" data-tab-target="tab-template-3" type="button" role="tab" aria-selected="false">Template</button>
				</nav>
				<!-- tabs pane -->
				<div class="tabs__content">
					<!-- tab pane 1 -->
				    <div class="tabs__pane_template is-visible-template" id="tab-template-1" role="tabpanel">

						<div class="property-group">
							<div class="groupSelects">
								<div class="dataBlock">
									<?php
										echo label_tag(lang('template name'), $genid . 'name');
										echo text_field('invoice_template[name]', array_var($invoice_template_edit, 'name'), array('class' => 'title template_name'));
									?>
								</div>

								<div class="dataBlock">
									<?php
										echo label_tag(lang('type'), $genid . 'template_type');
										$type_options = array('detailed', 'lumpsum', 'lumpsum_view', 'fixed fee tasks' );
										$type_options_html = array();
										foreach ($type_options as $type_option) {
											$attr = $type_option == array_var($invoice_template_edit, 'template_type') ? array('selected' => 'selected') : null;
											$type_options_html[] = option_tag(lang($type_option), $type_option, $attr);
										}
										echo select_box("invoice_template[template_type]", $type_options_html, array("id" => $genid."template_type"));
									?>
								</div>
								<div class="dataBlock">
									<?php
										echo label_tag(lang('break_down_by_subprojects'), $genid . 'break_down_by_subprojects');
										$type_options = array('no', 'SINGLE', 'MULTI');
										$type_options_html = array();
										foreach ($type_options as $type_option) {
											$attr = $type_option == array_var($invoice_template_edit, 'break_down_by_subprojects') ? array('selected' => 'selected') : null;
											$type_options_html[] = option_tag(lang($type_option), $type_option, $attr);
										}
										echo select_box("invoice_template[break_down_by_subprojects]", $type_options_html, array("id" => $genid."break_down_by_subprojects"));
									?>
								</div>
								<div class="dataBlock">
									<?php
									$select_discounts_options=[];
									$select_discounts_options[] = ['between_line_items',lang('in between line items')];
									$select_discounts_options[] = ['separated_section',lang('in a separate section')];
									$select_discounts_options[] = ['consolidated',lang('consolidated as a single line')];
										echo label_tag(lang('accumulate discounts'), $genid . 'accumulate_discounts');
										echo simple_select_box("invoice_template[accumulate_discounts]", $select_discounts_options , array_var($invoice_template_edit, 'accumulate_discounts'));
									?>
								</div>
								<?php if (income_config_option("use_line_taxes")) { ?>
								<div class="dataBlock">
									<div class="labelAndCheckboxFlex">
										<?php
											echo checkbox_field('invoice_template[show_taxes_for_each_line]', array_var($invoice_template_edit, 'show_taxes_for_each_line'));
											echo label_tag(lang('show taxes in invoice lines'), $genid . 'show_taxes_for_each_line');
										?>
									</div>
								</div>
								<?php } ?>

								<div class="dataBlock" id="<?php echo $genid . 'show_headers_before_details'?>">
									<div class="labelAndCheckboxFlex">
										<?php
											echo checkbox_field('invoice_template[show_headers_before_details]', array_var($invoice_template_edit, 'show_headers_before_details'));
											echo label_tag(lang('show headers before labor and expenses details'), $genid . 'show_headers_before_details');
										?>
									</div>
								</div>

								<div class="dataBlock">
									<div class="labelAndCheckboxFlex">
										<?php
											echo checkbox_field('invoice_template[is_default]', array_var($invoice_template_edit, 'is_default'));
											echo label_tag(lang('is this the default template'), $genid . 'is_default');
										?>
									</div>
								</div>
							</div>
						</div>
					</div>
					<?php 
					  $project_ot = ObjectTypes::findByName('project');
					  $project_id_cp = CustomProperties::getCustomPropertyByCode($project_ot->getId(), "project_id");
					  $po_desc_cp = CustomProperties::getCustomPropertyByCode($project_ot->getId(), "description_special");
					  $billing_from_cp = CustomProperties::getCustomPropertyByCode(IncomeInvoices::instance()->getObjectTypeId(), 'billing_period_from');
                      $billing_to_cp = CustomProperties::getCustomPropertyByCode(IncomeInvoices::instance()->getObjectTypeId(), 'billing_period_to');
					  $po_number_cp = CustomProperties::getCustomPropertyByCode($project_ot->getId(), "po_number");

					  $site_address_cp = CustomProperties::getCustomPropertyByCode($project_ot->getId(), "(New format) Address (Street, City):");

					  ?>
					<!-- tab pane 2 -->
					<div class="tabs__pane_template opacityTempInvoice" id="tab-template-2" role="tabpanel">
					    <!-- time and task properties -->
						<div class="property-group" id="<?php echo $genid?>project_properties">

						    <div class="title_lines" id="<?php echo $genid?>title_project_properties"><h3><?php echo lang('project information table') ?></h3></div>

     						<div class="dataBlock" id="<?php echo $genid?>title_project_description">
								<strong style="color: #999999;"><?php echo lang('select one or more item to show the project table when printing invoices') ?></strong>
	     					</div>
		 					
		    			    <table id="invoiceOptions">
								<tr>
									<th><?php echo lang('column')?></th>
									<th style="text-align: center;"><?php echo lang('display')?></th>
									<th><?php echo lang('custom label')?></th>
									<th><?php echo lang('order')?></th>
								</tr>
								<?php if($site_address_cp){?>
									<tr><!------ project number--->
									<td><?php echo label_tag(lang('site_address'), $genid . 'site_address');?></td>
									<td><?php echo checkbox_field('invoice_template[project_options][site_address][visible]',$invoice_template_options_array['site_address']['visible'], array("id" => $genid . "site_address")); ?></td>
									<td><?php echo text_field('invoice_template[project_options][site_address][label]', $invoice_template_options_array['site_address']['label']?$invoice_template_options_array['site_address']['label']:lang('site_address'), array('class' => 'input'));?></td>
									<td><?php echo text_field('invoice_template[project_options][site_address][order]', $invoice_template_options_array['site_address']['order']?$invoice_template_options_array['site_address']['order']:1, array('class' => 'input'));?></td>
								</tr>
								<?php }?>
								<?php if($project_id_cp){?>
									<tr><!------ project number--->
									<td><?php echo label_tag(lang('project_number'), $genid . 'project_number');?></td>
									<td><?php echo checkbox_field('invoice_template[project_options][project_number][visible]',$invoice_template_options_array['project_number']['visible'], array("id" => $genid . "project_number")); ?></td>
									<td><?php echo text_field('invoice_template[project_options][project_number][label]', $invoice_template_options_array['project_number']['label']?$invoice_template_options_array['project_number']['label']:lang('project_number'), array('class' => 'input'));?></td>
									<td><?php echo text_field('invoice_template[project_options][project_number][order]', $invoice_template_options_array['project_number']['order']?$invoice_template_options_array['project_number']['order']:1, array('class' => 'input'));?></td>
								</tr>
								<?php }?>
								<tr><!------ project complete name--->
									<td><?php echo label_tag(lang('project_complete_name'), $genid . 'project_complete_name');?></td>
									<td><?php 
										echo invoice_template_project_name_options_selector("invoice_template[project_options][project_complete_name][selected_option]", $invoice_template_options_array['project_complete_name']['selected_option'], array("id" => $genid . "project_complete_name"));
									?></td>
									<td><?php echo text_field('invoice_template[project_options][project_complete_name][label]', $invoice_template_options_array['project_complete_name']['label']?$invoice_template_options_array['project_complete_name']['label']:lang('project_complete_name'), array('class' => 'input'));?></td>
									<td><?php echo text_field('invoice_template[project_options][project_complete_name][order]', $invoice_template_options_array['project_complete_name']['order']?$invoice_template_options_array['project_complete_name']['order']:2, array('class' => 'input'));?></td>
								</tr>
								<tr><!------ project name--->
									<td><?php echo label_tag(lang('project_name'), $genid . 'project_name');?></td>
									<td><?php echo checkbox_field('invoice_template[project_options][project_name][visible]',$invoice_template_options_array['project_name']['visible'], array("id" => $genid . "project_name")); ?></td>
									<td><?php echo text_field('invoice_template[project_options][project_name][label]', $invoice_template_options_array['project_name']['label']?$invoice_template_options_array['project_name']['label']:lang('project_name'), array('class' => 'input'));?></td>
									<td><?php echo text_field('invoice_template[project_options][project_name][order]', $invoice_template_options_array['project_name']['order']?$invoice_template_options_array['project_name']['order']:3, array('class' => 'input'));?></td>
								</tr>
								<?php if($po_desc_cp){?>
								<tr><!------ project description--->
									<td><?php echo label_tag(lang('project_description'), $genid . 'project_description');?></td>
									<td><?php echo checkbox_field('invoice_template[project_options][project_description][visible]',$invoice_template_options_array['project_description']['visible'], array("id" => $genid . "project_description")); ?></td>
									<td><?php echo text_field('invoice_template[project_options][project_description][label]', $invoice_template_options_array['project_description']['label']?$invoice_template_options_array['project_description']['label']:lang('project_description'), array('class' => 'input'));?></td>
									<td><?php echo text_field('invoice_template[project_options][project_description][order]', $invoice_template_options_array['project_description']['order']?$invoice_template_options_array['project_description']['order']:4, array('class' => 'input'));?></td>
								</tr>
								<?php }?>
								<tr><!------ project manager--->
									<td><?php echo label_tag(lang('project_manager'), $genid . 'project_manager');?></td>
									<td><?php echo checkbox_field('invoice_template[project_options][project_manager][visible]',$invoice_template_options_array['project_manager']['visible'], array("id" => $genid . "project_manager")); ?></td>
									<td><?php echo text_field('invoice_template[project_options][project_manager][label]', $invoice_template_options_array['project_manager']['label']?$invoice_template_options_array['project_manager']['label']:lang('project_manager'), array('class' => 'input'));?></td>
									<td><?php echo text_field('invoice_template[project_options][project_manager][order]', $invoice_template_options_array['project_manager']['order']?$invoice_template_options_array['project_manager']['order']:5, array('class' => 'input'));?></td>
								</tr>
								<tr><!------ project manager initials--->
									<td><?php echo label_tag(lang('project_manager_initials'), $genid . 'project_manager_initials');?></td>
									<td><?php echo checkbox_field('invoice_template[project_options][project_manager_initials][visible]',$invoice_template_options_array['project_manager_initials']['visible'], array("id" => $genid . "project_manager_initials")); ?></td>
									<td><?php echo text_field('invoice_template[project_options][project_manager_initials][label]', $invoice_template_options_array['project_manager_initials']['label']?$invoice_template_options_array['project_manager_initials']['label']:lang('project_manager_initials'), array('class' => 'input'));?></td>
									<td><?php echo text_field('invoice_template[project_options][project_manager_initials][order]', $invoice_template_options_array['project_manager_initials']['order']?$invoice_template_options_array['project_manager_initials']['order']:5, array('class' => 'input'));?></td>
								</tr>
								<?php if($billing_from_cp && $billing_to_cp){?>
								<tr><!------ project bill from to--->
									<td><?php echo label_tag(lang('project_bill_fromto'), $genid . 'project_bill_fromto');?></td>
									<td><?php echo checkbox_field('invoice_template[project_options][project_bill_fromto][visible]',$invoice_template_options_array['project_bill_fromto']['visible'], array("id" => $genid . "project_bill_fromto")); ?></td>
									<td><?php echo text_field('invoice_template[project_options][project_bill_fromto][label]', $invoice_template_options_array['project_bill_fromto']['label']?$invoice_template_options_array['project_bill_fromto']['label']:lang('project_bill_fromto'), array('class' => 'input'));?></td>
									<td><?php echo text_field('invoice_template[project_options][project_bill_fromto][order]', $invoice_template_options_array['project_bill_fromto']['order']?$invoice_template_options_array['project_bill_fromto']['order']:6, array('class' => 'input'));?></td>
								</tr>
								<?php }?>
								<tr><!------ project payment terms--->
									<td><?php echo label_tag(lang('project_payment_terms'), $genid . 'project_payment_terms');?></td>
									<td><?php echo checkbox_field('invoice_template[project_options][project_payment_terms][visible]', $invoice_template_options_array['project_payment_terms']['visible'], array("id" => $genid . "project_payment_terms")); ?></td>
									<td><?php echo text_field('invoice_template[project_options][project_payment_terms][label]', $invoice_template_options_array['project_payment_terms']['label']?$invoice_template_options_array['project_payment_terms']['label']:lang('project_payment_terms'), array('class' => 'input'));?></td>
									<td><?php echo text_field('invoice_template[project_options][project_payment_terms][order]',$invoice_template_options_array['project_payment_terms']['order']?$invoice_template_options_array['project_payment_terms']['order']:7, array('class' => 'input'));?></td>
								</tr>
								<tr><!------ project due date--->
									<td><?php echo label_tag(lang('project_due_date'), $genid . 'project_due_date');?></td>
									<td><?php echo checkbox_field('invoice_template[project_options][project_due_date][visible]', $invoice_template_options_array['project_due_date']['visible'], array("id" => $genid . "project_due_date")); ?></td>
									<td><?php echo text_field('invoice_template[project_options][project_due_date][label]', $invoice_template_options_array['project_due_date']['label']?$invoice_template_options_array['project_due_date']['label']:lang('project_due_date'), array('class' => 'input'));?></td>
									<td><?php echo text_field('invoice_template[project_options][project_due_date][order]',  $invoice_template_options_array['project_due_date']['order']?$invoice_template_options_array['project_due_date']['order']:8, array('class' => 'input'));?></td>
								</tr>
								<?php if($po_number_cp){?>
								<tr><!------ project ponumber--->
									<td><?php echo label_tag(lang('project_PO_number'), $genid . 'project_id_show');?></td>
									<td><?php echo checkbox_field('invoice_template[project_options][project_po_number][visible]', $invoice_template_options_array['project_po_number']['visible'], array("id" => $genid . "project_po_number")); ?></td>
									<td><?php echo text_field('invoice_template[project_options][project_po_number][label]', $invoice_template_options_array['project_po_number']['label']?$invoice_template_options_array['project_po_number']['label']:lang('project_PO_number'), array('class' => 'input'));?></td>
									<td><?php echo text_field('invoice_template[project_options][project_po_number][order]', $invoice_template_options_array['project_po_number']['order']?$invoice_template_options_array['project_po_number']['order']:9, array('class' => 'input'));?></td>
								</tr>
								<?php }?>
								<tr><!------ project project_type_value--->
									<td><?php echo label_tag(lang('project_type_value'), $genid . 'project_type_value');?></td>
									<td><?php echo checkbox_field('invoice_template[project_options][project_type_value][visible]', $invoice_template_options_array['project_type_value']['visible'], array("id" => $genid . "project_type_value")); ?></td>
									<td><?php echo text_field('invoice_template[project_options][project_type_value][label]', $invoice_template_options_array['project_type_value']['label']?$invoice_template_options_array['project_type_value']['label']:lang('project_type_value'), array('class' => 'input'));?></td>
									<td><?php echo text_field('invoice_template[project_options][project_type_value][order]', $invoice_template_options_array['project_type_value']['order']?$invoice_template_options_array['project_type_value']['order']:10, array('class' => 'input'));?></td>
								</tr>
							</table>
						</div>
						
     						
					    <!-- time and task properties -->
						<div class="property-group" id="<?php echo $genid?>time_properties">
							<div class="title_lines" id="<?php echo $genid?>title_time_tasks"><h3><?php echo lang('labor (time) lines') ?></h3></div>
							<!--- task task_all_expenses_includes-->
							<div style="background-color: #E3E3E3; padding:10px;" id="<?php echo $genid?>task_all_expenses_includes_div">
								<div class="groupSelects">
									<div class="dataBlock">
										<div class="labelAndCheckboxFlex">
											<?php
												echo checkbox_field('invoice_template[task_all_expenses_includes]', array_var($invoice_template_edit, 'task_all_expenses_includes'), array("id" => $genid."task_all_expenses_includes"));
												echo label_tag(lang('all expenses are included in the lump sum'), $genid . 'task_all_expenses_includes');
											?>
										</div>
									</div>
									<div class="dataBlock">
										<div class="labelAndCheckboxFlex">
											<?php
												echo checkbox_field('invoice_template[task_allow_billing_per_percent]', array_var($invoice_template_edit, 'task_allow_billing_per_percent'), array("id" => $genid."task_allow_billing_per_percent"));
												echo label_tag(lang('invoice unfinished tasks with % complete'), $genid . 'task_allow_billing_per_percent');
											?>
										</div>
									</div>
									<div class="dataBlock">
								    <?php
										$include_task_group_options = array('Invoice completed task and discount previous bill', 'Invoice difference only');
										$include_task_group_html = array();
										foreach ($include_task_group_options as $include_task_group_option) {
											$attr = $include_task_group_option == array_var($invoice_template_edit, 'task_invoice_billing_type') ? array('selected' => 'selected') : null;
											$include_task_group_html[] = option_tag($include_task_group_option, $include_task_group_option, $attr);
										}
										echo label_tag(lang('Invoicing schema'), $genid . 'task_invoice_billing_typetask_group');
										echo select_box("invoice_template[task_invoice_billing_type]", $include_task_group_html, array("id" => $genid."task_invoice_billing_type"));
									?>
									</div>
								</div>
							</div>

							<div class="dataBlock" id="<?php echo $genid?>time_title_description">
								<strong style="color: #999999;"><?php echo lang('when automatically generating the invoice lines for labor (using time entries), use the following criteria') ?></strong>
							</div>
							
							<div class="groupSelects">
								<div class="dataBlock" id="<?php echo $genid?>time_block_group_by">
									<?php
										$group_by_options = array('timeslots', 'tasks', 'users', 'date-users', 'project');
										$group_by_options_html = array();
										$labor_category_dimension = Dimensions::findByCode('hour_types');
										$labor_cat_dim_enabled = $labor_category_dimension instanceof Dimension && in_array($labor_category_dimension->getId(), config_option('enabled_dimensions'));
										if ($labor_cat_dim_enabled){
											$group_by_options[] = 'date_users_labor_category';
											$group_by_options[] = 'labor_category';
											$group_by_options[] = 'labor_category_tasks';
											$group_by_options[] = 'project_labor_category';
										}
										$group_by_options[] = 'project';
		
										foreach($group_by_options as $opt){
											$attr = $opt == array_var($invoice_template_edit, 'group_by') ? array('selected' => 'selected') : null;
											if ($labor_cat_dim_enabled && $opt == 'labor_category'){
												$group_by_options_html[] = option_tag($labor_category_dimension->getName(), $opt, $attr);
											} else {
												$group_by_options_html[] = option_tag(lang($opt), $opt, $attr);
											}
										}
										$html = select_box("invoice_template[group_by]", $group_by_options_html, array("id" => "group_by"));
										echo label_tag(lang('group by'), $genid . 'group_by');
										echo select_box("invoice_template[group_by]", $group_by_options_html, array("id" => $genid."group_by"));
									?>
								</div>
								<div class="dataBlock" id="<?php echo $genid?>task_block_group_by">
								    <?php
										$include_task_group_options = array('aggregated into a single line', 'separate by task');
										$include_task_group_html = array();
										foreach ($include_task_group_options as $include_task_group_option) {
											$attr = $include_task_group_option == array_var($invoice_template_edit, 'task_group') ? array('selected' => 'selected') : null;
											$include_task_group_html[] = option_tag($include_task_group_option, $include_task_group_option, $attr);
										}
										echo label_tag(lang('display tasks'), $genid . 'task_group');
										echo select_box("invoice_template[task_group]", $include_task_group_html, array("id" => $genid."task_group"));
									?>
								</div>
								<div class="dataBlock" >
									<?php
										$include_time_line_date_options = array('Item date', 'Invoice date', 'Date of the earliest item', 'Date of the most recent item', 'Billing from date', 'Billing to date');
										$include_time_line_date_html = array();
										foreach ($include_time_line_date_options as $include_time_line_date_option) {
											$attr = $include_time_line_date_option == array_var($invoice_template_edit, 'include_time_line_date') ? array('selected' => 'selected') : null;
											$include_time_line_date_html[] = option_tag($include_time_line_date_option, $include_time_line_date_option, $attr);
										}
										echo label_tag(lang('assign date based on'), $genid . 'include_time_line_date');
										echo select_box("invoice_template[include_time_line_date]", $include_time_line_date_html, array("id" => $genid."include_time_line_date"));
									?>
								</div>

								<!---category and product type for timeslot-->
								<?php if (Plugins::instance()->isActivePlugin('expenses2')) { ?>
								
									<div class="dataBlock" style="display:;" id="<?php echo $genid . 'category_for_timeslot_block'?>">
										<?php echo label_tag(lang('labor category'), $genid . 'category_for_timeslot');?>
										<div id="<?php echo $genid; ?>category_for_timeslot_container"></div>
									</div>

								<?php } ?>
							</div>
							<!-- Detail -->
							<div style="background-color: #E3E3E3; padding:10px;">
								<div class="dataBlock" >
									<strong>
										<?php
											echo lang('detail');
										?>
									</strong>
								</div>
				
								<div class="dataBlock" id="<?php echo $genid; ?>task_agruppated_detail">
								    <div class="groupSelects">
									    <div class="dataBlock">
										    <?php echo label_tag(lang('custom_task_detail'), $genid . 'task_custom_detail');?>
									        <?php echo text_field('invoice_template[task_custom_detail]', array_var($invoice_template_edit, 'task_custom_detail'), array('class' => 'input task_custom_detail'));?>
								        </div>
								    </div>
								</div>

								<div class="dataBlock" id="<?php echo $genid; ?>labor_and_task_detail">
									<div class="groupSelects">
										<!-- Person name -->
										<div class="dataBlock">
											<?php
												$user_name_options = array('No name', 'Full name', 'Initials');
												$user_name_options_html = array();
												
												foreach ($user_name_options as $user_name_option) {
													$attr = $user_name_option == array_var($invoice_template_edit, 'include_user_name') ? array('selected' => 'selected') : null;
													$user_name_options_html[] = option_tag($user_name_option, $user_name_option, $attr);
												}
												echo label_tag(lang('include person name'), $genid . 'include_user_name');
												echo select_box("invoice_template[include_user_name]", $user_name_options_html, array("id" => $genid."include_user_name"));							
											?>
										</div>
										<!-- Labor categories -->
										<div class="dataBlock">
											<div class="labelAndCheckboxFlex">
												<?php
													echo checkbox_field('invoice_template[include_labor_category]', array_var($invoice_template_edit, 'include_labor_category'), array("id" => $genid . "include_labor_category"));
													echo label_tag(lang('include labor category'), $genid . 'include_labor_category');
												?>
											</div>
										</div>
										<!-- Task name -->
										<div class="dataBlock">
											<div class="labelAndCheckboxFlex">
												<?php
													echo checkbox_field('invoice_template[include_task_name]', array_var($invoice_template_edit, 'include_task_name'), array("id" => $genid . "include_task_name"));
													echo label_tag(lang('include task name'), $genid . 'include_task_name');
												?>
											</div>
										</div>
										<!-- time entry  -->
										<div class="dataBlock" id="<?php echo $genid?>time_time_entry">
											<div class="labelAndCheckboxFlex">
												<?php
													echo checkbox_field('invoice_template[include_time_entry_description]', array_var($invoice_template_edit, 'include_time_entry_description'), array("id" => $genid . "include_time_entry_description"));
													echo label_tag(lang('include time entry description'), $genid . 'include_time_entry_description');
												?>
											</div>
										</div>
										<!-- include_project_description -->
										<!--<div class="dataBlock">
										<?php
											//echo label_tag(lang('custom project number'), $genid . 'include_project_description');
											//echo checkbox_field('invoice_template[include_project_description]', array_var($invoice_template_edit, 'include_project_description'), array("id" => $genid . "include_project_description"));
										?>
										</div>-->
										<!-- include_project_name -->
										<div class="dataBlock" >
											<div class="labelAndCheckboxFlex">
												<?php
													echo checkbox_field('invoice_template[include_project_name]', array_var($invoice_template_edit, 'include_project_name'), array("id" => $genid . "include_project_name"));
													echo label_tag(lang('include project name'), $genid . 'include_project_name');
												?>
											</div>
										</div>
										<!-- separation labor detail -->
										<div class="dataBlock">
											<?php
												//$labor_detail_separation_value_options = array(' ', '\r\n', '-', '/');
												$labor_detail_separation_value_options=array('Blank space', 'Middle dash', 'Forward slash', 'Line break');
												$labor_detail_separation_value_html = array();
												//$labor_detail_separation_value_html = array(' ', '\r\n', '-', '/');
												
												foreach ($labor_detail_separation_value_options as $labor_detail_separation_value_option) {
													$attr =$labor_detail_separation_value_option == array_var($invoice_template_edit, 'labor_detail_separator_value') ? array('selected' => 'selected') : null;
													$labor_detail_separation_value_html[] = option_tag($labor_detail_separation_value_option, $labor_detail_separation_value_option, $attr);
												}
												echo label_tag(lang('separator'), $genid . 'labor_detail_separator_value');
												echo select_box("invoice_template[labor_detail_separator_value]", $labor_detail_separation_value_html, array("id" => $genid."labor_detail_separator_value"));							
											?>
										</div>
									</div>	
								</div>
							</div>
            

							<div class="dataBlock">
								<strong>
										<div><?php echo lang('columns to display') ?></div>
								</strong>
							</div> 
			
							<table id="invoiceOptions">
								<tr>
									<th><?php echo lang('column')?></th>
									<th style="text-align: center;"><?php echo lang('display')?></th>
									<th><?php echo lang('custom label')?></th>
								</tr>
								<tr>
									<td><?php echo label_tag(lang('date'), $genid . 'include_date');?></td>
									<td><?php echo checkbox_field('invoice_template[include_date]', array_var($invoice_template_edit, 'include_date'), array("id" => $genid . "include_date")); ?></td>
									<td><?php echo text_field('invoice_template[custom_label_include_date]', array_var($invoice_template_edit, 'custom_label_include_date')?array_var($invoice_template_edit, 'custom_label_include_date'):lang('date'), array('class' => 'input'));?></td>
								</tr>
								<tr>
									<td><?php 
											$user_name_options_time_cols = array('Do not Display', 'Full name', 'Initials');
											$user_name_options_html_time_cols = array();

											
											foreach ($user_name_options_time_cols as $user_name_option_time_col) {
												$attr = $user_name_option_time_col == array_var($invoice_template_edit, 'include_user_name_col') ? array('selected' => 'selected') : null;
												$user_name_options_html_time_cols[] = option_tag($user_name_option_time_col, $user_name_option_time_col, $attr);
											}
											echo label_tag(lang('person name'), $genid . 'include_user_name_col');?>
									<td><?php echo select_box("invoice_template[include_user_name_col]", $user_name_options_html_time_cols, array("id" => $genid."include_user_name_col"));?></td>
									<td><?php echo text_field('invoice_template[custom_label_include_user_name_col]', array_var($invoice_template_edit, 'custom_label_include_user_name_col')?array_var($invoice_template_edit, 'custom_label_include_user_name_col'):lang('person_name'), array('class' => 'input'));?></td>
								</tr>
								<tr>
									<td><?php echo label_tag(lang('labor category'), $genid . 'category_for_timeslot_col');?></td>
									<td><?php echo checkbox_field('invoice_template[category_for_timeslot_col]', array_var($invoice_template_edit, 'category_for_timeslot_col'), array("id" => $genid . "category_for_timeslot_col"));?></td>
									<td><?php echo text_field('invoice_template[custom_label_category_for_timeslot_col]', array_var($invoice_template_edit, 'custom_label_category_for_timeslot_col')?array_var($invoice_template_edit, 'custom_label_category_for_timeslot_col'):lang('labor category'), array('class' => 'input'));?></td>
								</tr>
								<tr>
									<td><?php echo label_tag(lang('detail'), $genid . 'include_description',false, array('class' => 'label_include_description'));?></td>
									<td><?php echo checkbox_field('invoice_template[include_description]', array_var($invoice_template_edit, 'include_description'), array("id" => $genid . "include_description"));?></td>
									<td><?php echo text_field('invoice_template[custom_label_include_description]', array_var($invoice_template_edit, 'custom_label_include_description')?array_var($invoice_template_edit, 'custom_label_include_description'):lang('detail'), array('class' => 'input'));?></td>
								</tr>
								<tr>
									<td><?php echo label_tag(lang('hours'), $genid . 'include_hours');?></td>
									<td><?php echo checkbox_field('invoice_template[include_hours]', array_var($invoice_template_edit, 'include_hours'), array("id" => $genid . "include_hours"));?></td>
									<td><?php echo text_field('invoice_template[custom_label_include_hours]', array_var($invoice_template_edit, 'custom_label_include_hours')?array_var($invoice_template_edit, 'custom_label_include_hours'):lang('hours'), array('class' => 'input'));?></td>
								</tr>
								<tr>
									<td><?php echo label_tag(lang('rate'), $genid . 'include_rate');?></td>
									<td><?php echo checkbox_field('invoice_template[include_rate]', array_var($invoice_template_edit, 'include_rate'), array("id" => $genid . "include_rate"));?></td>
									<td><?php echo text_field('invoice_template[custom_label_include_rate]', array_var($invoice_template_edit, 'custom_label_include_rate')?array_var($invoice_template_edit, 'custom_label_include_rate'):lang('rate'), array('class' => 'input'));?></td>
								</tr>
								<tr>
									<td><?php echo label_tag(lang('total'), $genid . 'include_total');?></td>
									<td><?php echo checkbox_field('invoice_template[include_total]', array_var($invoice_template_edit, 'include_total'), array("id" => $genid . "include_total"));?></td>
									<td><?php echo text_field('invoice_template[custom_label_include_total]', array_var($invoice_template_edit, 'custom_label_include_total')?array_var($invoice_template_edit, 'custom_label_include_total'):lang('total'), array('class' => 'input'));?></td>
								</tr>
							</table>
           
        				</div>
                        <!-- expense properties -->
        				<div class="property-group" id="<?php echo $genid?>expense_properties">
							<div class="title_lines"><h3><?php echo lang('expenses, products and other services') ?></h3></div>
							<div class="dataBlock" >
								<strong style="color: #999999;"><?php echo lang('when automatically generating the invoice lines for expenses, products and other services (not from time entries), use the following criteria') ?></strong>
							</div>
							<div class="groupSelects">
								<div class="dataBlock">
									<?php
										$group_by_options = array('payment_receipts', 'expense_name', 'expense_description', 'product_type', 'paid_by', 'project','project_product');
										$group_by_options_html = array();
										$expense_category_dimension = Dimensions::findByCode('expense_categories');
										$exp_cat_dim_enabled = $expense_category_dimension instanceof Dimension && in_array($expense_category_dimension->getId(), config_option('enabled_dimensions'));
										if ($exp_cat_dim_enabled){
											$group_by_options[] = 'expense_category';
											$group_by_options[] = 'project_expense_category';
										}
										foreach($group_by_options as $opt){
											$attr = $opt == array_var($invoice_template_edit, 'exp_group_by') ? array('selected' => 'selected') : null;
											if ($exp_cat_dim_enabled && $opt == 'expense_category'){
												$group_by_options_html[] = option_tag($expense_category_dimension->getName(), $opt, $attr);
											} else {
												$group_by_options_html[] = option_tag(lang($opt), $opt, $attr);
											}
										}
										//$html = select_box("invoice_template[group_by]", $group_by_options_html, array("id" => "group_by"));
										echo label_tag(lang('group by'), $genid . 'exp_group_by');
										echo select_box("invoice_template[exp_group_by]", $group_by_options_html, array("id" => $genid."exp_group_by"));
									?>
								</div>

								
	
								<div class="dataBlock" >
									<?php
									
										$include_exp_type_date_options = array('Item date', 'Invoice date', 'Date of the earliest item', 'Date of the most recent item', 'Billing from date', 'Billing to date');
										$include_exp_type_date_html = array();
										
										foreach ($include_exp_type_date_options as $include_exp_type_date_option) {
											$attr = $include_exp_type_date_option == array_var($invoice_template_edit, 'include_exp_type_date') ? array('selected' => 'selected') : null;
											$include_exp_type_date_html[] = option_tag($include_exp_type_date_option, $include_exp_type_date_option, $attr);
										}
										echo label_tag(lang('assign date based on'), $genid . 'include_exp_type_date');
										echo select_box("invoice_template[include_exp_type_date]", $include_exp_type_date_html, array("id" => $genid."include_exp_type_date"));
	
									?>
								</div>
	
								<!---category and product type for expenses-->
								<?php if (Plugins::instance()->isActivePlugin('expenses2')) { ?>
				
									<div class="dataBlock" style="display:;" id="<?php echo $genid . 'category_for_expenses_block'?>">
										<?php echo label_tag(lang('expense category'), $genid . 'category_for_expenses');?>
										<div id="<?php echo $genid; ?>category_for_expenses_container"></div>
									</div>
	
									<div class="dataBlock">
										<?php echo label_tag(lang('product type'), $genid . 'product_type_for_expenses');?>
										<div id="<?php echo $genid; ?>product_type_for_expenses_container">
												<?php
													Env::useHelper('functions', 'expenses2');
													echo product_types_select_box(
														"invoice_template[product_type_for_expenses]", 
														array_var($invoice_template_edit, 'product_type_for_expenses'), 
														$filtered_product_types_expenses, 
														array('id' => $genid . 'product_type_for_expenses', 'style'=>'max-width:300px;')
													);
												?>
										</div>
									</div>
								<?php } ?>

								<?php if ($exp_cat_dim_enabled) { ?>
									<div class="dataBlock">
										<?php echo label_tag(lang('break_down_expenses_by_category'), $genid . 'break_down_expenses_by_category'); ?>
										<div id="<?php echo $genid; ?>break_down_expenses_by_category_container">
											<?php
												echo break_down_by_exp_category_selector(
													"invoice_template[break_down_expenses_by_category]", 
													array_var($invoice_template_edit, 'break_down_expenses_by_category', 'no'), 
													array("id" => $genid."break_down_expenses_by_category")
												);
											?>
										</div>	
									</div>
								<?php } ?>
	
								<div class="dataBlock">
									<div class="labelAndCheckboxFlex">
										<?php
											echo checkbox_field('invoice_template[show_expenses_markup_separated]', array_var($invoice_template_edit, 'show_expenses_markup_separated'), array("id" => $genid."show_expenses_markup_separated"));
										?>
										<?php
											echo label_tag(lang('show_expenses_markup_separated'), $genid . 'show_expenses_markup_separated');
										?>
									</div>
								</div>
							</div>

							<!-- detail -->
							<div style="background-color: #E3E3E3; padding:10px;">
								<div class="dataBlock" >
									<strong>
										<?php
											echo label_tag(lang('detail'), $genid . 'include_detail');
										?>
									</strong>
								</div>
								
								<div class="groupSelects">
									<!-- paid by -->
									<div class="dataBlock">
										<div class="labelAndCheckboxFlex">
											<?php
												echo checkbox_field('invoice_template[include_paid_by]', array_var($invoice_template_edit, 'include_paid_by'), array("id" => $genid."include_paid_by"));
												echo label_tag(lang('include paid by'), $genid . 'include_paid_by');
											?>
										</div>
									</div>

									<!-- expense category -->
									<div class="dataBlock">
										<div class="labelAndCheckboxFlex">
											<?php
												echo checkbox_field('invoice_template[include_expense_category]', array_var($invoice_template_edit, 'include_expense_category'), array("id" => $genid."include_expense_category"));
												echo label_tag(lang('include expense category'), $genid . 'include_expense_category');
											?>
										</div>
									</div>

									<!-- product type -->
									<div class="dataBlock">
										<div class="labelAndCheckboxFlex">
											<?php
												echo checkbox_field('invoice_template[include_product_type]', array_var($invoice_template_edit, 'include_product_type'), array("id" => $genid."include_product_type"));
												echo label_tag(lang('include product type'), $genid . 'include_product_type');
											?>
										</div>
									</div>
		
									<!-- include_expense_name-->
									<div class="dataBlock">
										<div class="labelAndCheckboxFlex">
											<?php
												echo checkbox_field('invoice_template[include_expense_name]', array_var($invoice_template_edit, 'include_expense_name'), array("id" => $genid."include_expense_name"));
												echo label_tag(lang('include expense name'), $genid . 'include_expense_name');
											?>
										</div>
									</div> 

									<!-- include_expense_description-->
									<div class="dataBlock" id="<?php echo $genid . 'include_expense_description_container'?>">
										<div class="labelAndCheckboxFlex">
											<?php
												echo checkbox_field('invoice_template[include_expense_description]', array_var($invoice_template_edit, 'include_expense_description'), array("id" => $genid."include_expense_description"));
												echo label_tag(lang('include expense description'), $genid . 'include_expense_description');
											?>
										</div>
									</div>

									<!-- include_expense_project_number -->
									<div class="dataBlock">
										<div class="labelAndCheckboxFlex">
											<?php
												echo checkbox_field('invoice_template[include_expense_project_number]', array_var($invoice_template_edit, 'include_expense_project_number'), array("id" => $genid . "include_expense_project_number"));
												echo label_tag(lang('project number'), $genid . 'include_expense_project_number');
											?>
										</div>
									</div>

									<!-- include_expense_project_name -->
									<div class="dataBlock">
										<div class="labelAndCheckboxFlex">
											<?php
												echo checkbox_field('invoice_template[include_expense_project_name]', array_var($invoice_template_edit, 'include_expense_project_name'), array("id" => $genid . "include_expense_project_name"));
												echo label_tag(lang('project name'), $genid . 'include_expense_project_name');
											?>
										</div>
									</div>

									<!-- Task include_expense_task_name -->
									<div class="dataBlock">
											<div class="labelAndCheckboxFlex">
												<?php
													echo checkbox_field('invoice_template[include_expense_task_name]', array_var($invoice_template_edit, 'include_expense_task_name'), array("id" => $genid . "include_expense_task_name"));
													echo label_tag(lang('include task name'), $genid . 'include_expense_task_name');
												?>
											</div>
										</div>
									<!-- include expense_detail_vendor_name-->
									<div class="dataBlock">
										<div class="labelAndCheckboxFlex">
											<?php
												echo checkbox_field('invoice_template[expense_detail_vendor_name]', array_var($invoice_template_edit, 'expense_detail_vendor_name'), array("id" => $genid."expense_detail_vendor_name"));
												echo label_tag(lang('include vendor name'), $genid . 'expense_detail_vendor_name');
											?>
										</div>
									</div>

									<!-- include expense_detail_vendor_name-->
									<div class="dataBlock">
										<div class="labelAndCheckboxFlex">
											<?php
												echo checkbox_field('invoice_template[expense_detail_bill_no]', array_var($invoice_template_edit, 'expense_detail_bill_no'), array("id" => $genid."expense_detail_bill_no"));
												echo label_tag(lang('include bill number'), $genid . 'expense_detail_bill_no');
											?>
										</div>
									</div>

									<!-- separation expense detail -->
									<div class="dataBlock">
										<?php
											$expense_detail_separation_value_options=array('Blank space', 'Middle dash', 'Forward slash', 'Line break');
											$expense_detail_separation_value_html = array();
											
											foreach ($expense_detail_separation_value_options as $expense_detail_separation_value_option) {
												$attr =$expense_detail_separation_value_option == array_var($invoice_template_edit, 'expense_detail_separator_value') ? array('selected' => 'selected') : null;
												$expense_detail_separation_value_html[] = option_tag($expense_detail_separation_value_option, $expense_detail_separation_value_option, $attr);
											}
											echo label_tag(lang('separator'), $genid . 'expense_detail_separator_value');
											echo select_box("invoice_template[expense_detail_separator_value]", $expense_detail_separation_value_html, array("id" => $genid."expense_detail_separator_value"));							
										?>
									</div>
								</div>
							</div>
							
							<div class="dataBlock">
								<strong>
										<div><?php echo lang('columns to display') ?></div>
								</strong>
							</div> 

							<table id="invoiceOptions">
								<tr>
									<th><?php echo lang('column')?></th>
									<th style="text-align: center;"><?php echo lang('display')?></th>
									<th><?php echo lang('custom label')?></th>
								</tr>
								<tr>
									<td><?php echo label_tag(lang('date'), $genid . 'include_exp_date');?></td>
									<td><?php echo checkbox_field('invoice_template[include_exp_date]', array_var($invoice_template_edit, 'include_exp_date'), array("id" => $genid."include_exp_date")); ?></td>
									<td><?php echo text_field('invoice_template[custom_label_include_exp_date]', array_var($invoice_template_edit, 'custom_label_include_exp_date')?array_var($invoice_template_edit, 'custom_label_include_exp_date'):lang('date'), array('class' => 'input'));?></td>
								</tr>
								<tr>
									<td><?php echo label_tag(lang('paid by'), $genid . 'include_paid_by_col');?></td>
									<td><?php echo checkbox_field('invoice_template[include_paid_by_col]', array_var($invoice_template_edit, 'include_paid_by_col'), array("id" => $genid."include_paid_by_col"));?></td>
									<td><?php echo text_field('invoice_template[custom_label_include_paid_by_col]', array_var($invoice_template_edit, 'custom_label_include_paid_by_col')?array_var($invoice_template_edit, 'custom_label_include_paid_by_col'):lang('paid by'), array('class' => 'input'));?></td>
								</tr>
								<tr>
									<td><?php 
										$user_name_options_time_cols = array('Do not Display', 'Full name', 'Initials');
										$user_name_options_html_time_cols = array();
										
										foreach ($user_name_options_time_cols as $user_name_option_time_col) {
											$attr = $user_name_option_time_col == array_var($invoice_template_edit, 'include_exp_user_name_col') ? array('selected' => 'selected') : null;
											$user_name_options_html_time_cols[] = option_tag($user_name_option_time_col, $user_name_option_time_col, $attr);
										}
										echo label_tag(lang('person name'), $genid . 'include_exp_user_name_col');
									?></td>
									<td><?php echo select_box("invoice_template[include_exp_user_name_col]", $user_name_options_html_time_cols, array("id" => $genid."include_exp_user_name_col"));?></td>
									<td><?php echo text_field('invoice_template[custom_label_include_exp_user_name_col]', array_var($invoice_template_edit, 'custom_label_include_exp_user_name_col')?array_var($invoice_template_edit, 'custom_label_include_exp_user_name_col'):lang('person name'), array('class' => 'input'));?></td>
								</tr>
								<tr>
									<td><?php echo label_tag(lang('expense category'), $genid . 'category_for_expenses_col');?></td>
									<td><?php echo checkbox_field('invoice_template[category_for_expenses_col]', array_var($invoice_template_edit, 'category_for_expenses_col'), array("id" => $genid . "category_for_expenses_col"));?></td>
									<td><?php echo text_field('invoice_template[custom_label_category_for_expenses_col]', array_var($invoice_template_edit, 'custom_label_category_for_expenses_col')?array_var($invoice_template_edit, 'custom_label_category_for_expenses_col'):lang('expense category'), array('class' => 'input'));?></td>
								</tr>
								<tr>
									<td><?php echo label_tag(lang('product type'), $genid . 'product_type_for_expenses_col');?></td>
									<td><?php echo checkbox_field('invoice_template[product_type_for_expenses_col]', array_var($invoice_template_edit, 'product_type_for_expenses_col'), array("id" => $genid . "product_type_for_expenses_col"));?></td>
									<td><?php echo text_field('invoice_template[custom_label_product_type_for_expenses_col]', array_var($invoice_template_edit, 'custom_label_product_type_for_expenses_col')?array_var($invoice_template_edit, 'custom_label_product_type_for_expenses_col'):lang('product type'), array('class' => 'input'));?></td>
								</tr>
								<tr>
									<td><?php echo label_tag(lang('detail'), $genid . 'include_exp_description');?></td>
									<td><?php echo checkbox_field('invoice_template[include_exp_description]', array_var($invoice_template_edit, 'include_exp_description'), array("id" => $genid."include_exp_description"));?></td>
									<td><?php echo text_field('invoice_template[custom_label_include_exp_description]', array_var($invoice_template_edit, 'custom_label_include_exp_description')?array_var($invoice_template_edit, 'custom_label_include_exp_description'):lang('expense line'), array('class' => 'input'));?></td>
								</tr>
								<tr>
									<td><?php echo label_tag(lang('quantity'), $genid . 'include_exp_quantity');?></td>
									<td><?php echo checkbox_field('invoice_template[include_exp_quantity]', array_var($invoice_template_edit, 'include_exp_quantity'), array("id" => $genid."include_exp_quantity"));?></td>
									<td><?php echo text_field('invoice_template[custom_label_include_exp_quantity]', array_var($invoice_template_edit, 'custom_label_include_exp_quantity')?array_var($invoice_template_edit, 'custom_label_include_exp_quantity'):lang('quantity'), array('class' => 'input'));?></td>
								</tr>
								

								<tr>
									<td><?php echo label_tag(lang('unit cost'), $genid . 'include_exp_unit_cost');?></td>
									<td><?php echo checkbox_field('invoice_template[include_exp_unit_cost]', array_var($invoice_template_edit, 'include_exp_unit_cost'), array("id" => $genid."include_exp_unit_cost"));?></td>
									<td><?php echo text_field('invoice_template[custom_label_include_exp_include_exp_unit_cost]', array_var($invoice_template_edit, 'custom_label_include_exp_include_exp_unit_cost')?array_var($invoice_template_edit, 'custom_label_include_exp_include_exp_unit_cost'):lang('unit cost'), array('class' => 'input'));?></td>
								</tr>
								<tr>
									<td><?php echo label_tag(lang('fee'), $genid . 'include_exp_fee');?></td>
									<td><?php echo checkbox_field('invoice_template[include_exp_fee]', array_var($invoice_template_edit, 'include_exp_fee'), array("id" => $genid."include_exp_fee"));?></td>
									<td><?php echo text_field('invoice_template[custom_label_include_exp_fee]', array_var($invoice_template_edit, 'custom_label_include_exp_fee')?array_var($invoice_template_edit, 'custom_label_include_exp_fee'):lang('fee'), array('class' => 'input'));?></td>
								</tr>
								<tr>
									<td><?php echo label_tag(lang('markup amount'), $genid . 'include_exp_markup_amount');?></td>
									<td><?php echo checkbox_field('invoice_template[include_exp_markup_amount]', array_var($invoice_template_edit, 'include_exp_markup_amount'), array("id" => $genid."include_exp_markup_amount"));?></td>
									<td><?php echo text_field('invoice_template[custom_label_include_exp_markup_amount]', array_var($invoice_template_edit, 'custom_label_include_exp_markup_amount', lang('markup amount')), array('class' => 'input'));?></td>
								</tr>
								<tr>
									<td><?php echo label_tag(lang('unit value'), $genid . 'include_exp_amount');?></td>
									<td><?php echo checkbox_field('invoice_template[include_exp_amount]', array_var($invoice_template_edit, 'include_exp_amount'), array("id" => $genid."include_exp_amount"));?></td>
									<td><?php echo text_field('invoice_template[custom_label_include_exp_amount]', array_var($invoice_template_edit, 'custom_label_include_exp_amount')?array_var($invoice_template_edit, 'custom_label_include_exp_amount'):lang('unit value'), array('class' => 'input'));?></td>
								</tr>

								<tr>
									<td><?php echo label_tag(lang('total'), $genid . 'include_exp_total');?></td>
									<td><?php echo checkbox_field('invoice_template[include_exp_total]', array_var($invoice_template_edit, 'include_exp_total'), array("id" => $genid."include_exp_total"));?></td>
									<td><?php echo text_field('invoice_template[custom_label_include_exp_total]', array_var($invoice_template_edit, 'custom_label_include_exp_total')?array_var($invoice_template_edit, 'custom_label_include_exp_total'):lang('total'), array('class' => 'input'));?></td>
								</tr>
							</table>
						</div>
                        <!-- lump sum properties -->
						<div class="property-group" id="<?php echo $genid?>lump_sum_properties">

							<div class="title_lines"><h3><?php echo lang('automatic generation of invoice lines') ?></h3></div>
							<div class="groupSelects">
								<!-- include_lump_sum_date -->
								<div class="dataBlock">
									<?php
									
										/*check if it has 'job schedule property'*/
                                        $project_scheduled_cp = CustomProperties::getCustomPropertyByCode($project_ot->getId(), "job_scheduled");
                                        if ($project_scheduled_cp instanceof CustomProperty) 
										{
                                            $include_lump_sum_date_options = array('Invoice date', 'Date of the earliest item', 'Date of the most recent item', 'Billing from date', 'Billing to date', 'Job scheduled');	
                                        }else{
                                            $include_lump_sum_date_options = array('Invoice date', 'Date of the earliest item', 'Date of the most recent item', 'Billing from date', 'Billing to date');
                                        }

                                        $include_lump_sum_date_html = array();

                                        foreach ($include_lump_sum_date_options as $include_lump_sum_date_option) 
										{
                                            $attr = $include_lump_sum_date_option == array_var($invoice_template_edit, 'include_lump_sum_date') ? array('selected' => 'selected') : null;
                                            $include_lump_sum_date_html[] = option_tag($include_lump_sum_date_option, $include_lump_sum_date_option, $attr);
                                        }
                                        echo label_tag(lang('date'), $genid . 'include_lump_sum_date');
                                        echo select_box("invoice_template[include_lump_sum_date]", $include_lump_sum_date_html, array("id" => $genid."include_lump_sum_date"));
										
									?>
								</div>
								<!---category and product type for lump sum-->
								<?php if (Plugins::instance()->isActivePlugin('expenses2')) { ?>
								
									<div class="dataBlock" style="display:none;" id="<?php echo $genid . 'category_for_lump_sum_block'?>">
										<?php echo label_tag(lang('category'), $genid . 'category_for_lump_sum');?>
										<div id="<?php echo $genid; ?>category_for_lump_sum_container"></div>
									</div>

								<div class="dataBlock">
									<?php echo label_tag(lang('product type'), $genid . 'product_type_for_lump_sum');?>
									<div id="<?php echo $genid; ?>product_type_for_lump_sum_container">
											<?php
												Env::useHelper('functions', 'expenses2');
												echo product_types_select_box(
													"invoice_template[product_type_for_lump_sum]", 
													array_var($invoice_template_edit, 'product_type_for_lump_sum'), 
													$filtered_product_types_lump_sum, 
													array('id' => $genid . 'product_type_for_lump_sum', 'style'=>'max-width:300px;')
												);
											?>
									</div>
								</div>
								<?php } ?>
							</div>
							
							<div style="background-color: #E3E3E3; padding:10px;">
								<!-- Detail -->
								<div class="dataBlock">
									<strong>
									<?php
										echo label_tag(lang('detail'), $genid . 'include_detail');
										//echo checkbox_field('invoice_template[include_detail]', array_var($invoice_template_edit, 'include_detail'), array("id" => $genid . "include_detail"));
									?>
									</strong>
								</div>			
								<div class="groupSelects">
									<!-- include_lump_sum_project_number -->
									<div class="dataBlock">
										<div class="labelAndCheckboxFlex">
											<?php
												echo checkbox_field('invoice_template[include_lump_sum_project_number]', array_var($invoice_template_edit, 'include_lump_sum_project_number'), array("id" => $genid . "include_lump_sum_project_number"));
												echo label_tag(lang('project number'), $genid . 'include_lump_sum_project_number');
											?>
										</div>
									</div>

									<!-- include_lump_sum_project_name -->
									<div class="dataBlock">
										<div class="labelAndCheckboxFlex">
											<?php
												echo checkbox_field('invoice_template[include_lump_sum_project_name]', array_var($invoice_template_edit, 'include_lump_sum_project_name'), array("id" => $genid . "include_lump_sum_project_name"));
												echo label_tag(lang('project name'), $genid . 'include_lump_sum_project_name');
											?>
										</div>
									</div>

									<!-- include_lump_sum_project_type -->
									<div class="dataBlock">
										<div class="labelAndCheckboxFlex">
											<?php
												echo checkbox_field('invoice_template[include_lump_sum_project_type]', array_var($invoice_template_edit, 'include_lump_sum_project_type'), array("id" => $genid . "include_lump_sum_project_type"));
												echo label_tag(lang('project type'), $genid . 'include_lump_sum_project_type');
											?>
										</div>
									</div>

									<!-- include_lump_sum_budget_completion -->
									<div class="dataBlock">
										<div class="labelAndCheckboxFlex">
											<?php
												echo checkbox_field('invoice_template[include_lump_sum_budget_completion]', array_var($invoice_template_edit, 'include_lump_sum_budget_completion'), array("id" => $genid . "include_lump_sum_budget_completion"));
												echo label_tag(lang('% completion'), $genid . 'include_lump_sum_budget_completion');
											?>
										</div>
									</div>
									<!-- include_lump_sum_from_to -->
									<div class="dataBlock">
										<div class="labelAndCheckboxFlex">
											<?php
												echo checkbox_field('invoice_template[include_lump_sum_from_to]', array_var($invoice_template_edit, 'include_lump_sum_from_to'), array("id" => $genid . "include_lump_sum_from_to"));
												echo label_tag(lang('from - to'), $genid . 'include_lump_sum_from_to');
											?>
										</div>
									</div>
									<!-- separation lump-sum detail -->
									<div class="dataBlock">
										<?php
											$lump_sum_detail_separation_value_options=array('Blank space', 'Middle dash', 'Forward slash', 'Line break');
											$lump_sum_detail_separation_value_html = array();
											
											foreach ($lump_sum_detail_separation_value_options as $lump_sum_detail_separation_value_option) {
												$attr =$lump_sum_detail_separation_value_option == array_var($invoice_template_edit, 'lump_sum_detail_separator_value') ? array('selected' => 'selected') : null;
												$lump_sum_detail_separation_value_html[] = option_tag($lump_sum_detail_separation_value_option, $lump_sum_detail_separation_value_option, $attr);
											}
											echo label_tag(lang('separator'), $genid . 'lump_sum_detail_separator_value');
											echo select_box("invoice_template[lump_sum_detail_separator_value]", $lump_sum_detail_separation_value_html, array("id" => $genid."lump_sum_detail_separator_value"));							
										?>
									</div>
								</div>
							</div>
							<div class="property-group-header"><h3><?php echo lang('columns to display') ?></h3></div>
							<table id="invoiceOptions">
								<tr>
									<th>Column</th>
									<th style="text-align: center;">Display</th>
									<th>Custom Label</th>
								</tr>
								<tr>
									<td><?php echo label_tag(lang('date'), $genid . 'include_lump_sum_date_col');?></td>
									<td><?php echo checkbox_field('invoice_template[include_lump_sum_date_col]', array_var($invoice_template_edit, 'include_lump_sum_date_col'), array("id" => $genid . "include_lump_sum_date_col")); ?></td>
									<td><?php echo text_field('invoice_template[custom_label_include_lump_sum_date_col]', array_var($invoice_template_edit, 'custom_label_include_lump_sum_date_col')?array_var($invoice_template_edit, 'custom_label_include_lump_sum_date_col'):lang('date'), array('class' => 'input'));?></td>
								</tr>
								<tr>
									<td><?php echo label_tag(lang('category'), $genid . 'category_for_lump_sum_col');?></td>
									<td><?php echo checkbox_field('invoice_template[category_for_lump_sum_col]', array_var($invoice_template_edit, 'category_for_lump_sum_col'), array("id" => $genid . "category_for_lump_sum_col"));?></td>
									<td><?php echo text_field('invoice_template[custom_label_category_for_lump_sum_col]', array_var($invoice_template_edit, 'custom_label_category_for_lump_sum_col')?array_var($invoice_template_edit, 'custom_label_category_for_lump_sum_col'):lang('category'), array('class' => 'input'));?></td>
								</tr>
								<tr>
									<td><?php echo label_tag(lang('product type'), $genid . 'product_type_for_lump_sum_col');?></td>
									<td><?php echo checkbox_field('invoice_template[product_type_for_lump_sum_col]', array_var($invoice_template_edit, 'product_type_for_lump_sum_col'), array("id" => $genid . "product_type_for_lump_sum_col"));?></td>
									<td><?php echo text_field('invoice_template[custom_label_product_type_for_lump_sum_col]', array_var($invoice_template_edit, 'custom_label_product_type_for_lump_sum_col')?array_var($invoice_template_edit, 'custom_label_product_type_for_lump_sum_col'):lang('product type'), array('class' => 'input'));?></td>
								</tr>
								<tr>
									<td><?php echo label_tag(lang('detail'), $genid . 'include_lump_sum_deetail_col');?></td>
									<td><?php echo checkbox_field('invoice_template[include_lump_sum_deetail_col]', array_var($invoice_template_edit, 'include_lump_sum_deetail_col'), array("id" => $genid . "include_lump_sum_deetail_col"));?></td>
									<td><?php echo text_field('invoice_template[custom_label_include_lump_sum_deetail_col]', array_var($invoice_template_edit, 'custom_label_include_lump_sum_deetail_col')?array_var($invoice_template_edit, 'custom_label_include_lump_sum_deetail_col'):lang('detail'), array('class' => 'input'));?></td>
								</tr>
								<tr>
									<td><?php echo label_tag(lang('quantity'), $genid . 'include_lump_sum_quantity');?></td>
									<td><?php echo checkbox_field('invoice_template[include_lump_sum_quantity]', array_var($invoice_template_edit, 'include_lump_sum_quantity'), array("id" => $genid."include_lump_sum_quantity"));?></td>
									<td><?php echo text_field('invoice_template[custom_label_include_lump_sum_quantity]', array_var($invoice_template_edit, 'custom_label_include_lump_sum_quantity')?array_var($invoice_template_edit, 'custom_label_include_lump_sum_quantity'):lang('quantity'), array('class' => 'input'));?></td>
								</tr>
								<tr>
									<td><?php echo label_tag(lang('unit price'), $genid . 'include_lump_sum_unit_price');?></td>
									<td><?php echo checkbox_field('invoice_template[include_lump_sum_unit_price]', array_var($invoice_template_edit, 'include_lump_sum_unit_price'), array("id" => $genid . "include_lump_sum_unit_price"));?></td>
									<td><?php echo text_field('invoice_template[custom_label_include_lump_sum_unit_price]', array_var($invoice_template_edit, 'custom_label_include_lump_sum_unit_price')?array_var($invoice_template_edit, 'custom_label_include_lump_sum_unit_price'):lang('unit price'), array('class' => 'input'));?></td>
								</tr>
							</table>

						</div>
					</div>

					<!-- tab pane 3 -->
					<div class="tabs__pane_template opacityTempInvoice" id="tab-template-3" role="tabpanel">
						<div class="property-group" id="<?php echo $genid?>invoice_template_config">
							<div class="groupSelects">
								<!-- :: INVOICE TEMPLATES SELECTOR :: (START)-->
								<div class="dataBlock">
									<div>
										<?php echo label_tag(lang('invoice layout'), $genid . 'invoice_template_assigned'); ?>
									</div>
									<div>
										<?php
										
										// RENDER LAYOUT SELECTOR
										echo invoice_template_layout_selector("invoice_template[invoice_template_assigned]", array_var($invoice_template_edit, 'invoice_template_assigned'));
										
									?>
									</div>
								</div>
								<!-- :: INVOICE TEMPLATES SELECTOR :: (END)-->
								<!-- <div class="dataBlock">
									<div>
										<?php //echo label_tag(lang('invoice businesses'), $genid . 'invoice_business_assigned'); ?>
									</div>
									<div>
										<select>
											<option>Feng Corp</option>
											<option>Affinity</option>
											<option>EVX Software</option>
										</select>
									</div>
								</div> -->
								<div class="dataBlock">
									<div>
										<?php echo label_tag(lang('invoice language'), $genid . 'invoice_language_assigned'); ?>
									</div>
									<?php

										$handler = new LocalizationConfigHandler();
										$available_locales = $handler->getAvailableLocales();
										$languageAssigned = array_var($invoice_template_edit, 'template_language_assigned');
										$selected = $languageAssigned != '' ? $languageAssigned : get_locale();
										$type_options_html = array();
										foreach ($available_locales as $type_option) {
											$attr = $type_option == $selected ? array('selected' => 'selected') : null;
											$type_options_html[] = option_tag(get_language_name($type_option), $type_option, $attr);
										}
										echo select_box("invoice_template[template_language_assigned]", $type_options_html, array("id" => $genid . "template_language_assigned"));
									?>
								</div>

								<!-- date format selector -->
								<div class="dataBlock">
									<div>
										<?php echo label_tag(lang('show dates in format'), $genid . 'date_format'); ?>
									</div>
									<div>

									<?php
										// reutilize the user preference class that renders the date format selector
										echo DateFormatConfigHandler::renderExtended('invoice_template[date_format]', array_var($invoice_template_edit, 'date_format'), array('id' => $genid . 'date_format'));
									?>

									</div>
								</div>

							</div>
						</div>

						<?php
							$project_location_cp = CustomProperties::getCustomPropertyByCode($project_ot->getId(), "project_location_for_invoice");
							if ($project_location_cp instanceof CustomProperty && $project_location_cp->getIsDisabled() == 0) { 
						?>
						<div class="property-group" id="<?php echo $genid?>invoice_template_project_info">
							<div class="title_lines property-group-header"><h3><?php echo lang('project information section') ?></h3></div>
							<div class="dataBlock">
								<div class="labelAndCheckboxFlex">
									<?php
										echo checkbox_field('invoice_template[include_project_location]', array_var($invoice_template_edit, 'include_project_location'), array("id" => $genid."include_project_location"));
										echo label_tag(lang('include') .' ' . $project_location_cp->getName(), $genid . 'include_project_location', false, null, '');
									?>
								</div>
								
						</div>

						<?php } ?>
							
						<div class="property-group" id="<?php echo $genid?>invoice_template_footer"> 
								<div class="title_lines property-group-header"><h3><?php echo lang('invoice_template_footer_title') ?></h3></div>
								<div class="dataBlock">
									<div class="labelAndCheckboxFlex">
										<?php
											echo checkbox_field('invoice_template[include_account_summary]', array_var($invoice_template_edit, 'include_account_summary'), array("id" => $genid."include_account_summary"));
											echo label_tag(lang('invoice_template_footer_account_summary'), $genid . 'include_account_summary', false, null, '');
										?>
									</div>
								</div>
								<div class="dataBlock">
									<div class="labelAndCheckboxFlex">
										<?php
											echo checkbox_field('invoice_template[include_additional_info_in_footer]', array_var($invoice_template_edit, 'include_additional_info_in_footer'), array("id" => $genid."include_additional_info_in_footer"));
											echo label_tag(lang('include additional info in footer'), $genid . 'include_additional_info_in_footer', false, null, '');
										?>
									</div>
								</div>
								<div class="dataBlock">
									<?php
										echo label_tag(lang('invoice_template_footer_text'), $genid . 'invoice_footer_disclaimer');
										echo text_field('invoice_template[invoice_footer_disclaimer]', array_var($invoice_template_edit, 'footer_text'), array("id" => "invoice_footer_disclaimer",'class' => 'title', 'style' => 'display:none'));
									?>
								</div>
								<div class="dataBlock">
									<div>
										<div id="<?php echo $genid ?>ckcontainer" style="height: 160px">
											<textarea cols="80" id="<?php echo $genid ?>ckeditor" name="invoice_template['invoice_footer_disclaimer']" rows="10"><?php echo $invoice_template->getIncludeFooterText(); ?></textarea>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>

				</div>
			</div>
    	</div>
	</div>
</form>



	        
<script>
	var h = document.getElementById("<?php echo $genid ?>ckcontainer").offsetHeight;
	var editor = CKEDITOR.replace('<?php echo $genid ?>ckeditor', {		
		height: '120px',
		allowedContent: true,
		resize_enabled: false,
		enterMode: CKEDITOR.ENTER_BR,
		shiftEnterMode: CKEDITOR.ENTER_BR,
		disableNativeSpellChecker: false,
		language: '<?php echo $loc ?>',
		customConfig: '',
		contentsCss: ['<?php echo get_javascript_url('ckeditor/contents.css').'?rev='.product_version_revision();?>', '<?php echo get_stylesheet_url('og/ckeditor_override.css').'?rev='.product_version_revision();?>'],
		toolbar: [
					['Bold','Italic','Underline','Strike','-',
						'Font','FontSize','-', 'Blockquote','-',
						'SpellChecker', 'Scayt','-', 
						'NumberedList','BulletedList','-',
						'TextColor','BGColor','RemoveFormat','-',
						'Link','Unlink','-',
						'JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock']
				],
		on: {
				instanceReady: function(ev) {
						og.adjustCkEditorArea('<?php echo $genid ?>');
						editor.resetDirty();						
				}
			},
		fillEmptyBlocks: false,
		removePlugins: 'scayt,liststyle,magicline,contextmenu,tabletools,elementspath',
		entities_additional : '#336,#337,#368,#369,#124'
	});

	
	var el = document.getElementById("invoice_footer_disclaimer");

	editor.on("change", function() {
		el.value = editor.getData();
	})
	

	og.setDescription = function() {
			var form = Ext.getDom('<?php echo $genid ?>submit-edit-form');
			
	

			if (form.preventDoubleSubmit) return false;

			setTimeout(function() {
					form.preventDoubleSubmit = false;
			}, 2000);

			var editor = og.getCkEditorInstance('<?php echo $genid ?>ckeditor');
			form['invoice_template[invoice_footer_disclaimer]'].value = editor.getData();

			return true;
	};    
</script>

<script>

var genid = '<?php echo $genid ?>';

<?php if (Plugins::instance()->isActivePlugin('expenses2') && $expense_cat_dim instanceof Dimension) { ?>
og.render_plain_member_selector({
	dim_id: <?php echo $expense_cat_dim->getId() ?>,
	hf_name: 'invoice_template[category_for_lump_sum]',
	container: genid+ 'category_for_lump_sum_container',
	genid: genid,
	sel_id: <?php echo array_var($invoice_template_edit, 'category_for_lump_sum', '0') ?>,
});

$("#" + genid + 'member_selector_' + '<?php echo $expense_cat_dim->getId() ?>').change(function() {
	var members = Ext.util.JSON.encode([$(this).val()]);
	og.openLink(og.getUrl('product_type', 'get_filtered_product_types', {member_ids: members}), {
		callback: function(success, data) {
			if (!data || !data.product_types) return;

			$("#" + genid + "product_type_for_lump_sum").each(function(index, obj) {
				var selected_value = $(obj).val();

				// remove old options
				$(obj).find("option").remove();

				// add new options
				$(obj).append($('<option>', {value: 0, text : ""}));
				$.each(data.product_types, function (i, item) {
					$(obj).append($('<option>', { 
						value: item.id,
						text : item.name.replaceAll('\\"', '"')
					}));
				});

				$(obj).val(selected_value);
			});
		}
	});
});
<?php } ?>

<?php if (Plugins::instance()->isActivePlugin('expenses2') && $labor_cat_dim instanceof Dimension) { ?>
og.render_plain_member_selector({
	dim_id: <?php echo $labor_cat_dim->getId() ?>,
	hf_name: 'invoice_template[category_for_timeslot]',
	container: genid+ 'category_for_timeslot_container',
	genid: genid,
	sel_id: <?php echo array_var($invoice_template_edit, 'category_for_timeslot', '0') ?>,
});

// $("#" + genid + 'member_selector_' + '<?php echo $labor_cat_dim->getId() ?>').change(function() {
// 	var members = Ext.util.JSON.encode([$(this).val()]);
// 	og.openLink(og.getUrl('product_type', 'get_filtered_product_types', {member_ids: members}), {
// 		callback: function(success, data) {
// 			if (!data || !data.product_types) return;

// 			$("#" + genid + "product_type_for_timeslot").each(function(index, obj) {
// 				var selected_value = $(obj).val();

// 				// remove old options
// 				$(obj).find("option").remove();

// 				// add new options
// 				$(obj).append($('<option>', {value: 0, text : ""}));
// 				$.each(data.product_types, function (i, item) {
// 					$(obj).append($('<option>', { 
// 						value: item.id,
// 						text : item.name.replaceAll('\\"', '"')
// 					}));
// 				});

// 				$(obj).val(selected_value);
// 			});
// 		}
// 	});
// });
<?php } ?>

<?php if (Plugins::instance()->isActivePlugin('expenses2') && $expense_cat_dim instanceof Dimension) { ?>
og.render_plain_member_selector({
	dim_id: <?php echo $expense_cat_dim->getId() ?>,
	hf_name: 'invoice_template[category_for_expenses]',
	container: genid+ 'category_for_expenses_container',
	genid: genid,
	sel_id: <?php echo array_var($invoice_template_edit, 'category_for_expenses', '0') ?>,
});

	$('select[name="invoice_template[category_for_expenses]"]').change(function() {
	var members = Ext.util.JSON.encode([$(this).val()]);
	og.openLink(og.getUrl('product_type', 'get_filtered_product_types', {member_ids: members}), {
		callback: function(success, data) {
			if (!data || !data.product_types) return;

			$("#" + genid + "product_type_for_expenses").each(function(index, obj) {
				var selected_value = $(obj).val();

				// remove old options
				$(obj).find("option").remove();

				// add new options
				$(obj).append($('<option>', {value: 0, text : ""}));
				$.each(data.product_types, function (i, item) {
					$(obj).append($('<option>', { 
						value: item.id,
						text : item.name.replaceAll('\\"', '"')
					}));
				});

				$(obj).val(selected_value);
			});
		}
	});
});

// $("#" + genid + 'product_type_for_expenses').change(function() {
// 	alert($(this).val());        
// 	$("#" + genid + "product_type_for_expenses option[value="+$(this).val()+"]").attr('selected', 'selected');
// });

<?php } ?>

og.invoice_templates_on_template_type_change = function(genid) {

	if($('#'+genid+'template_type').val() == 'lumpsum'){
		$('#'+genid+'lump_sum_properties').show();
		$('#'+genid+'time_properties').hide();
		$('#'+genid+'expense_properties').hide();
		$('#'+genid+'task_properties').hide();
		$('#'+genid+'category_for_lump_sum_block').show();
		$('#'+genid+'show_headers_before_details').hide();
		$('#'+genid+'task_agruppated_detail').hide();
		$('#'+genid+'labor_and_task_detail').show();
	} else if($('#'+genid+'template_type').val() == 'detailed' || $('#'+genid+'template_type').val() == 'lumpsum_view'){
		$('#'+genid+'show_headers_before_details').show();
		$('#'+genid+'time_properties').show();
		$('#'+genid+'title_time_tasks').html('<h3><?php echo lang('labor (time) lines') ?></h3>');
		$('#'+genid+'task_block_group_by').hide();
		$('#'+genid+'time_block_group_by').show();
		$('#'+genid+'time_time_entry').show();
		$('#'+genid+'task_all_expenses_includes_div').hide();
		$('#'+genid+'time_title_description').show();
		$('#'+genid+'task_properties').hide();
		$('#'+genid+'expense_properties').show();
		$('#'+genid+'category_for_lump_sum_block').hide();
		$('#'+genid+'lump_sum_properties').hide();
		$('#'+genid+'task_agruppated_detail').hide();
		$('#'+genid+'labor_and_task_detail').show();
		$('.label_include_description').html('<?php echo lang('detail').':' ?>');
	}else if($('#'+genid+'template_type').val() == 'fixed price project' || $('#'+genid+'template_type').val() == 'fixed fee tasks'){
		$('#'+genid+'time_properties').show();
		$('#'+genid+'title_time_tasks').html('<h3><?php echo lang('tasks lines') ?></h3>');

		$('#'+genid+'task_block_group_by').show();
		$('#'+genid+'time_block_group_by').hide();
		$('#'+genid+'time_time_entry').hide();
		$('#'+genid+'task_all_expenses_includes_div').show();
		$('#'+genid+'time_title_description').hide();
		$('#'+genid+'expense_properties').hide();
		$('#'+genid+'category_for_lump_sum_block').hide();
		$('#'+genid+'lump_sum_properties').hide();
		$('#'+genid+'task_properties').hide();

		//check if all columns are not checked, check default columns
		if(!document.getElementById(genid+'include_date').checked
		   && !document.getElementById(genid+'category_for_timeslot_col').checked
		   && !document.getElementById(genid+'include_description').checked
		   && !document.getElementById(genid+'include_hours').checked
		   && !document.getElementById(genid+'include_rate').checked
		   && !document.getElementById(genid+'include_total').checked)
		{
			$('#'+genid+'include_date').prop('checked', false);
			$('#'+genid+'category_for_timeslot_col').prop('checked', false);
			$('#'+genid+'include_description').prop('checked', true);
			$('#'+genid+'include_hours').prop('checked', false);
			$('#'+genid+'include_rate').prop('checked', false);
			$('#'+genid+'include_total').prop('checked', true);
		}



		if($('#'+genid+'task_group').val() == 'aggregated into a single line')
		{
			$('#'+genid+'task_agruppated_detail').show();
			$('#'+genid+'labor_and_task_detail').hide();
			if($('.task_custom_detail').val()=='' ||$('.task_custom_detail').val()==undefined)
			{
				$('.task_custom_detail').val('<?php echo lang('progress on project tasks') ?>');	
			}
		}else{
			$('#'+genid+'labor_and_task_detail').show();
			$('#'+genid+'task_agruppated_detail').hide();
		}

		if(document.querySelector('#'+genid+'task_all_expenses_includes').checked)
	    {
		    $('#'+genid+'expense_properties').hide();
	    }else{
		    $('#'+genid+'expense_properties').show();
	    }
	}

	
}

og.invoice_templates_on_time_group_by_change = function(genid) {
	if($('#'+genid+'group_by').val() == 'timeslots'){
		$('#'+genid+'include_date').attr("disabled", false);
	    $('#'+genid+'include_user_name').attr("disabled", false);
	    $('#'+genid+'include_labor_category').attr("disabled", false);
		$('#'+genid+'include_task_name').attr("disabled", false);
		$('#'+genid+'include_time_entry_description').attr("disabled", false);
		$('#'+genid+'include_project_name').attr("disabled", false);
		$('#'+genid+'include_hours').attr("disabled", false);
		$('#'+genid+'include_rate').attr("disabled", false);
		$('#'+genid+'include_total').attr("disabled", false);
	} else if ($('#'+genid+'group_by').val() == 'tasks'){
		$('#'+genid+'include_date').attr("disabled", false);
	    $('#'+genid+'include_user_name').attr("disabled", false);
	    $('#'+genid+'include_labor_category').attr("disabled", false);
		$('#'+genid+'include_task_name').attr("disabled", false);
		$('#'+genid+'include_time_entry_description').attr("disabled", false);
		$('#'+genid+'include_project_name').attr("disabled", false);
		$('#'+genid+'include_hours').attr("disabled", false);
		$('#'+genid+'include_rate').attr("disabled", false);
		$('#'+genid+'include_total').attr("disabled", false);
	} else if ($('#'+genid+'group_by').val() == 'users'){
		$('#'+genid+'include_date').attr("disabled", false);
	    $('#'+genid+'include_user_name').attr("disabled", false);
	    $('#'+genid+'include_labor_category').attr("disabled", false);
		$('#'+genid+'include_task_name').attr("disabled", false);
		$('#'+genid+'include_time_entry_description').attr("disabled", false);
		$('#'+genid+'include_project_name').attr("disabled", false);
		$('#'+genid+'include_hours').attr("disabled", false);
		$('#'+genid+'include_rate').attr("disabled", false);
		$('#'+genid+'include_total').attr("disabled", false);
	} else if ($('#'+genid+'group_by').val() == 'date-users'){
		$('#'+genid+'include_date').attr("disabled", false);
	    $('#'+genid+'include_user_name').attr("disabled", false);
	    $('#'+genid+'include_labor_category').attr("disabled", false);
		$('#'+genid+'include_task_name').attr("disabled", false);
		$('#'+genid+'include_time_entry_description').attr("disabled", false);
		$('#'+genid+'include_project_name').attr("disabled", false);
		$('#'+genid+'include_hours').attr("disabled", false);
		$('#'+genid+'include_rate').attr("disabled", false);
		$('#'+genid+'include_total').attr("disabled", false);
	} else if ($('#'+genid+'group_by').val() == 'date_users_labor_category'){
		$('#'+genid+'include_date').attr("disabled", false);
	    $('#'+genid+'include_user_name').attr("disabled", false);
	    $('#'+genid+'include_labor_category').attr("disabled", false);
		$('#'+genid+'include_task_name').attr("disabled", false);
		$('#'+genid+'include_time_entry_description').attr("disabled", false);
		$('#'+genid+'include_project_name').attr("disabled", false);
		$('#'+genid+'include_hours').attr("disabled", false);
		$('#'+genid+'include_rate').attr("disabled", false);
		$('#'+genid+'include_total').attr("disabled", false);
	} else if ($('#'+genid+'group_by').val() == 'labor_category'){
		$('#'+genid+'include_date').attr("disabled", false);
	    $('#'+genid+'include_user_name').attr("disabled", false);
	    $('#'+genid+'include_labor_category').attr("disabled", false);
		$('#'+genid+'include_task_name').attr("disabled", false);
		$('#'+genid+'include_time_entry_description').attr("disabled", false);
		$('#'+genid+'include_project_name').attr("disabled", false);
		$('#'+genid+'include_hours').attr("disabled", false);
		$('#'+genid+'include_rate').attr("disabled", false);
		$('#'+genid+'include_total').attr("disabled", false);
	} else if ($('#'+genid+'group_by').val() == 'labor_category_tasks'){
		$('#'+genid+'include_date').attr("disabled", false);
	    $('#'+genid+'include_user_name').attr("disabled", false);
	    $('#'+genid+'include_labor_category').attr("disabled", false);
		$('#'+genid+'include_task_name').attr("disabled", false);
		$('#'+genid+'include_time_entry_description').attr("disabled", false);
		$('#'+genid+'include_project_name').attr("disabled", false);
		$('#'+genid+'include_hours').attr("disabled", false);
		$('#'+genid+'include_rate').attr("disabled", false);
		$('#'+genid+'include_total').attr("disabled", false);
	}  else if ($('#'+genid+'group_by').val() == 'project' ){
		$('#'+genid+'include_date').attr("disabled", false);
	    $('#'+genid+'include_user_name').attr("disabled", false);
	    $('#'+genid+'include_labor_category').attr("disabled", false);
		$('#'+genid+'include_task_name').attr("disabled", false);
		$('#'+genid+'include_time_entry_description').attr("disabled", false);
		$('#'+genid+'include_project_name').attr("disabled", false);
		$('#'+genid+'include_hours').attr("disabled", false);
		$('#'+genid+'include_rate').attr("disabled", false);
		$('#'+genid+'include_total').attr("disabled", false);
	} else if ( $('#'+genid+'group_by').val() == 'project_labor_category'){
		$('#'+genid+'include_date').attr("disabled", false);
	    $('#'+genid+'include_user_name').attr("disabled", false);
	    $('#'+genid+'include_labor_category').attr("disabled", false);
		$('#'+genid+'include_task_name').attr("disabled", false);
		$('#'+genid+'include_time_entry_description').attr("disabled", false);
		$('#'+genid+'include_project_name').attr("disabled", false);
		$('#'+genid+'include_hours').attr("disabled", false);
		$('#'+genid+'include_rate').attr("disabled", false);
		$('#'+genid+'include_total').attr("disabled", false);
	}
}

og.invoice_templates_on_expense_group_by_change = function(genid) {
	if($('#'+genid+'exp_group_by').val() == 'payment_receipts'){//actual expenses
		$('#'+genid+'include_exp_date').attr("disabled", false);
		$('#'+genid+'include_paid_by').attr("disabled", false);
	    $('#'+genid+'include_product_type').attr("disabled", false);
	    $('#'+genid+'include_expense_category').attr("disabled", false);
	    $('#'+genid+'include_expense_name').attr("disabled", false);
	    $('#'+genid+'include_expense_description').attr("disabled", false);
		$('#'+genid+'include_expense_project_number').attr("disabled", false);
		//$('#'+genid+'include_expense_project_number').prop('checked', false);
		$('#'+genid+'include_expense_project_name').attr("disabled", false);
		//$('#'+genid+'include_expense_project_name').prop('checked', false);
		$('#'+genid+'include_exp_quantity').attr("disabled", false);
		$('#'+genid+'include_exp_amount').attr("disabled", false);
		$('#'+genid+'include_exp_fee').attr("disabled", false);
		$('#'+genid+'include_exp_total').attr("disabled", false);
		$('#'+genid+'include_detail').prop('checked', true);

	} else if ($('#'+genid+'exp_group_by').val() == 'expense_name'){
		$('#'+genid+'include_exp_date').attr("disabled", false);
		$('#'+genid+'include_paid_by').attr("disabled", false);
	    $('#'+genid+'include_product_type').attr("disabled", false);
	    $('#'+genid+'include_expense_category').attr("disabled", false);
	    $('#'+genid+'include_expense_name').attr("disabled", false);
	    $('#'+genid+'include_expense_description').attr("disabled", false);
		$('#'+genid+'include_expense_project_number').attr("disabled", false);
		//$('#'+genid+'include_expense_project_number').prop('checked', false);
		$('#'+genid+'include_expense_project_name').attr("disabled", false);
		//$('#'+genid+'include_expense_project_name').prop('checked', false);
		$('#'+genid+'include_exp_quantity').attr("disabled", false);
		$('#'+genid+'include_exp_amount').attr("disabled", false);
		$('#'+genid+'include_exp_fee').attr("disabled", false);
		$('#'+genid+'include_exp_total').attr("disabled", false);
		$('#'+genid+'include_detail').prop('checked', true);

	} else if ($('#'+genid+'exp_group_by').val() == 'expense_description'){
		$('#'+genid+'include_exp_date').attr("disabled", false);
		$('#'+genid+'include_paid_by').attr("disabled", false);
	    $('#'+genid+'include_product_type').attr("disabled", false);
	    $('#'+genid+'include_expense_category').attr("disabled", false);
	    $('#'+genid+'include_expense_name').attr("disabled", false);
	    $('#'+genid+'include_expense_description').attr("disabled", false);
		$('#'+genid+'include_expense_project_number').attr("disabled", false);
		//$('#'+genid+'include_expense_project_number').prop('checked', false);
		$('#'+genid+'include_expense_project_name').attr("disabled", false);
		//$('#'+genid+'include_expense_project_name').prop('checked', false);
		$('#'+genid+'include_exp_quantity').attr("disabled", false);
		$('#'+genid+'include_exp_amount').attr("disabled", false);
		$('#'+genid+'include_exp_fee').attr("disabled", false);
		$('#'+genid+'include_exp_total').attr("disabled", false);
		$('#'+genid+'include_detail').prop('checked', true);
		
	} else if ($('#'+genid+'exp_group_by').val() == 'product_type'){
		$('#'+genid+'include_exp_date').attr("disabled", false);
		$('#'+genid+'include_paid_by').attr("disabled", false);
	    $('#'+genid+'include_product_type').attr("disabled", false);
	    $('#'+genid+'include_expense_category').attr("disabled", false);
	    $('#'+genid+'include_expense_name').attr("disabled", false);
	    $('#'+genid+'include_expense_description').attr("disabled", false);
		$('#'+genid+'include_expense_project_number').attr("disabled", false);
		//$('#'+genid+'include_expense_project_number').prop('checked', false);
		$('#'+genid+'include_expense_project_name').attr("disabled", false);
		//$('#'+genid+'include_expense_project_name').prop('checked', false);
		$('#'+genid+'include_exp_quantity').attr("disabled", false);
		$('#'+genid+'include_exp_amount').attr("disabled", false);
		$('#'+genid+'include_exp_fee').attr("disabled", false);
		$('#'+genid+'include_exp_total').attr("disabled", false);
		$('#'+genid+'include_detail').prop('checked', true);

	} else if ($('#'+genid+'exp_group_by').val() == 'paid_by'){
		$('#'+genid+'include_exp_date').attr("disabled", false);
		$('#'+genid+'include_paid_by').attr("disabled", false);
	    $('#'+genid+'include_product_type').attr("disabled", false);
	    $('#'+genid+'include_expense_category').attr("disabled", false);
	    $('#'+genid+'include_expense_name').attr("disabled", false);
	    $('#'+genid+'include_expense_description').attr("disabled", false);
		$('#'+genid+'include_expense_project_number').attr("disabled", false);
		//$('#'+genid+'include_expense_project_number').prop('checked', false);
		$('#'+genid+'include_expense_project_name').attr("disabled", false);
		//$('#'+genid+'include_expense_project_name').prop('checked', false);
		$('#'+genid+'include_exp_quantity').attr("disabled", false);
		$('#'+genid+'include_exp_amount').attr("disabled", false);
		$('#'+genid+'include_exp_fee').attr("disabled", false);
		$('#'+genid+'include_exp_total').attr("disabled", false);
		$('#'+genid+'include_detail').prop('checked', true);

	} else if ($('#'+genid+'exp_group_by').val() == 'expense_category'){
		$('#'+genid+'include_exp_date').attr("disabled", false);
		$('#'+genid+'include_paid_by').attr("disabled", false);
	    $('#'+genid+'include_product_type').attr("disabled", false);
	    $('#'+genid+'include_expense_category').attr("disabled", false);
	    $('#'+genid+'include_expense_name').attr("disabled", false);
	    $('#'+genid+'include_expense_description').attr("disabled", false);
		$('#'+genid+'include_expense_project_number').attr("disabled", false);
		//$('#'+genid+'include_expense_project_number').prop('checked', false);
		$('#'+genid+'include_expense_project_name').attr("disabled", false);
		//$('#'+genid+'include_expense_project_name').prop('checked', false);
		$('#'+genid+'include_exp_quantity').attr("disabled", false);
		$('#'+genid+'include_exp_amount').attr("disabled", false);
		$('#'+genid+'include_exp_fee').attr("disabled", false);
		$('#'+genid+'include_exp_total').attr("disabled", false);
		$('#'+genid+'include_detail').prop('checked', true);

	} else if ($('#'+genid+'exp_group_by').val() == 'project' ){
		$('#'+genid+'include_exp_date').attr("disabled", false);
		$('#'+genid+'include_paid_by').attr("disabled", false);
	    $('#'+genid+'include_product_type').attr("disabled", false);
	    $('#'+genid+'include_expense_category').attr("disabled", false);
	    $('#'+genid+'include_expense_name').attr("disabled", false);
	    $('#'+genid+'include_expense_description').attr("disabled", false);
		$('#'+genid+'include_expense_project_number').attr("disabled", false);
		//$('#'+genid+'include_expense_project_number').prop('checked', false);
		$('#'+genid+'include_expense_project_name').attr("disabled", false);
		//$('#'+genid+'include_expense_project_name').prop('checked', false);
		$('#'+genid+'include_exp_quantity').attr("disabled", false);
		$('#'+genid+'include_exp_amount').attr("disabled", false);
		$('#'+genid+'include_exp_fee').attr("disabled", false);
		$('#'+genid+'include_exp_total').attr("disabled", false);
		$('#'+genid+'include_detail').prop('checked', true);
		
	}else if( $('#'+genid+'exp_group_by').val() == 'project_expense_category'){
		$('#'+genid+'include_exp_date').attr("disabled", false);
		$('#'+genid+'include_paid_by').attr("disabled", false);
	    $('#'+genid+'include_product_type').attr("disabled", false);
	    $('#'+genid+'include_expense_category').attr("disabled", false);
	    $('#'+genid+'include_expense_name').attr("disabled", false);
	    $('#'+genid+'include_expense_description').attr("disabled", false);
		$('#'+genid+'include_expense_project_number').attr("disabled", false);
		//$('#'+genid+'include_expense_project_number').prop('checked', false);
		$('#'+genid+'include_expense_project_name').attr("disabled", false);
		//$('#'+genid+'include_expense_project_name').prop('checked', false);
		$('#'+genid+'include_exp_quantity').attr("disabled", false);
		$('#'+genid+'include_exp_amount').attr("disabled", false);
		$('#'+genid+'include_exp_fee').attr("disabled", false);
		$('#'+genid+'include_exp_total').attr("disabled", false);
		$('#'+genid+'include_detail').prop('checked', true);
	}
}

og.invoice_templates_on_task_allow_billing_per_percent_change = function(genid) {
    if(document.getElementById(genid+'task_allow_billing_per_percent').checked)
    {
        $("#" + genid + "task_invoice_billing_type").each(function(index, obj) {
                // remove old options
                $(obj).find("option").remove();
                // add new options
                    $(obj).html($('<option>', {
                        value: 'Invoice completed task and discount previous bill',
                        text : 'Invoice completed task and discount previous bills'
                    }));
            });
    }else{
        $("#" + genid + "task_invoice_billing_type").each(function(index, obj) {
                //before remove get what is selected
                var selected_value = $(obj).val();
                // remove old options
                $(obj).find("option").remove();
                // add new options
                    var selected=false;
                    if(selected_value != 'Invoice difference only')
                    {
                        selected=true;
                    }
                    $(obj).html($('<option>', {
                        value: 'Invoice completed task and discount previous bill',
                        text : 'Invoice completed task and discount previous bill',
                        selected: selected
                    }));
                    selected=false;
                    if(selected_value == 'Invoice difference only')
                    {
                        selected=true;
                    }
                    $(obj).append($('<option>', {
                        value: 'Invoice difference only',
                        text : 'Invoice difference only',
                        selected: selected
                    }));
            });
    }
}


$('#'+genid+'task_allow_billing_per_percent').on('change',function()
{
   og.invoice_templates_on_task_allow_billing_per_percent_change(genid);
});

og.invoice_templates_on_template_type_change(genid);
og.invoice_templates_on_time_group_by_change(genid);
og.invoice_templates_on_expense_group_by_change(genid);
og.invoice_templates_on_expense_group_by_change(genid);
og.invoice_templates_on_task_allow_billing_per_percent_change(genid);

$('#'+genid+'task_group').on('change', function(){
  if($('#'+genid+'task_group').val() == 'aggregated into a single line')
		{
			$('#'+genid+'task_agruppated_detail').show();
			$('#'+genid+'labor_and_task_detail').hide();
		}else{
			$('#'+genid+'labor_and_task_detail').show();
			$('#'+genid+'task_agruppated_detail').hide();
		}
});

$('#'+genid+'template_type').on('change', function(){
	var genid = '<?php echo $genid ?>';
	og.invoice_templates_on_template_type_change(genid);
});

$('#'+genid+'group_by').on('change', function(){
	var genid = '<?php echo $genid ?>';
	og.invoice_templates_on_time_group_by_change(genid);
});

$('#'+genid+'exp_group_by').on('change', function(){
	var genid = '<?php echo $genid ?>';
	og.invoice_templates_on_expense_group_by_change(genid);
});

$('#'+genid+'task_all_expenses_includes').on('change', function(){
	
	if(document.querySelector('#'+genid+'task_all_expenses_includes').checked)
	{
		$('#'+genid+'expense_properties').hide();
	}else{
		$('#'+genid+'expense_properties').show();
	}
});


og.atviveTabInvoiceTemplate = function() {
	const opacityDisable = document.querySelector(".opacityTempInvoice");
	opacityDisable.style.display = 'none';
	opacityDisable.style.opacity = '1';

	// Tabs
	const tabBtns = document.querySelectorAll(".tabs__btn_template");
	const tabPanes = document.getElementsByClassName("tabs__pane_template");

	let fadeTime = 200;

	function fadeOut(target) {
		target.style.opacity = 1;
		target.style.transition = `opacity ${fadeTime}ms`;
		target.style.opacity = 0;
		setTimeout(() => {
			target.style.display = "none";
		}, fadeTime);
	}

	function fadeIn(target) {
		target.style.opacity = 0;
		target.style.transition = `opacity ${fadeTime}ms`;
		target.style.opacity = 1;
		setTimeout(() => {
			target.style.display = "block";
		}, fadeTime);
	}

	function triggerTab(elt) {
		elt.preventDefault();

		tabBtns.forEach((btn) => {
			btn.classList.remove("is-active-template");
			btn.setAttribute("aria-selected", false);
		});

		[].forEach.call(tabPanes, (pane) => {
			fadeOut(pane);
		});

		elt.target.classList.add("is-active-template");
		elt.target.setAttribute("aria-selected", true);
		let clickedTab = elt.target.dataset.tabTarget;
		fadeIn(document.querySelector(`#${clickedTab}`));
	}

	tabBtns.forEach((tab) => {
		tab.addEventListener("click", triggerTab);
	});
}

og.newTemplateSetup = function() {
	//labor detail
	$('#'+genid+'include_time_entry_description').attr('checked','checked');

	///labor columns
	$('#'+genid+'include_date').attr('checked','checked');
	$('#'+genid+'include_description').attr('checked','checked');
	$('#'+genid+'include_hours').attr('checked','checked');
	$('#'+genid+'include_rate').attr('checked','checked');
	$('#'+genid+'include_total').attr('checked','checked');

	//expenses detail
	$('#'+genid+'include_expense_description').attr('checked','checked');

	//expenses columns
	$('#'+genid+'include_exp_date').attr('checked','checked');
	$('#'+genid+'include_exp_description').attr('checked','checked');
	$('#'+genid+'include_exp_quantity').attr('checked','checked');
	$('#'+genid+'include_exp_amount').attr('checked','checked');
	$('#'+genid+'include_exp_total').attr('checked','checked');

	$('#'+genid+'include_time_entry_description').attr('checked','checked');

	//lump sum columns
	$('#'+genid+'include_lump_sum_deetail_col').attr('checked','checked');
	$('#'+genid+'include_lump_sum_project_name').attr('checked','checked');

	$('.template_name').val('New template');
	//set the focus en the name field
	
	setTimeout(() => {
		$('.template_name').focus();
		$('.template_name').select();
}, 1000);

	
	
}

<?php if ($invoice_template->isNew()) { ?>
	og.newTemplateSetup();
<?php } ?>

og.atviveTabInvoiceTemplate();

</script>
