<?php
set_page_title(lang('invoice templates'));
$genid = gen_id();
?>

<div id="<?php echo $genid ?>InvoiceTemplates" class="coInputMailAccounts" style="height: 100%; background-color: white">
    <div class="coInputHeader">
        <div class="coInputTitle"><?php echo lang('invoice templates') ?></div>
    </div>
    <div class="adminMainBlock">
        <?php if(isset($invoice_templates) && is_array($invoice_templates) && count($invoice_templates)) { ?>
        <table class="adminListing" style="min-width: 400px; margin-top: 10px;">
                <tr>
                    <th style="text-align: left; padding-left: 20px;"><?php echo lang('name') ?></th>
                    <th><?php echo lang('default') ?></th>
                    <th><?php echo lang('options') ?></th>
                </tr>
                <?php
                $isAlt = true;
                foreach($invoice_templates as $template) {
                        $isAlt = !$isAlt;
                ?>
                <tr class="<?php echo $isAlt? 'altRow' : ''?>" id="<?php echo $genid ?>tr_<?php echo $template->getId()?>">
                    <td style="text-align: left; padding-left: 20px;"><?php echo $template->getName() ?></td>
                    <td><?php echo $template->getIsDefault() ? 'Yes' : '' ?></td>
                    <?php
                    $options = array();
                    $options[] = '<a class="internalLink" href="#" onclick="og.render_modal_form(\'\',{c:\'invoice_template\', a:\'edit\', params:{id:'.$template->getId().'}});">' . lang('edit') . '</a>';
                    $options[] = '<a class="internalLink" href="javascript:og.DeleteTemplate(' . $template->getId() . ')">' . lang('delete') . '</a>';
                    ?>
                    <td><?php echo implode(' | ', $options) ?></td>
                </tr>
                <?php } // foreach ?>
        </table>
        <?php } else { ?><div><?php echo lang('no invoice templates') ?></div><?php } // if ?>
        
        </br><a href="#" onclick="og.render_modal_form('',{c:'invoice_template', a:'add'});" class="link-ico ico-add"><?php echo lang('add invoice template')?></a>
    </div>
    
</div>

<script>
	var div = document.getElementById('<?php echo $genid ?>InvoiceTemplates');
    div.parentNode.style.backgroundColor = '#FFFFFF';
        
    og.DeleteTemplate = function(templateId) {        
        if (confirm(lang('delete invoice template'))) {
            og.openLink(og.getUrl('invoice_template', 'delete', {
                    template_id : templateId
            }), {
                callback: function(success, data) {
                    $('#<?php echo $genid ?>tr_'+templateId).remove();
                }
            });
        }
    };


</script>
