<?php
$project_member = null;
$project_ot = ObjectTypes::findByName('project');

//prevent use cache on get members
$invoice_members = $invoice->getMembers(false);

///set to 0 in case not exists
$subtotal = isset($subtotal) ? $subtotal : 0;
$labor_subtotal_aux = isset($labor_subtotal_aux) ? $labor_subtotal_aux : 0;
$act_exp_subtotal = isset($act_exp_subtotal) ? $act_exp_subtotal : 0;

$discount = $discount ? $discount : 0;
$discounts_allocate_percentage = isset($discounts_allocate_percentage) ? $discounts_allocate_percentage : 0;
$project_member_getName = '';
$project_member_complete_name = "";

$discount_table_total = isset($discount_table_total) ? $discount_table_total:1;
//get the project of the invoice
foreach ($invoice_members as $member) {
	if ($member instanceof Member && $member->getObjectTypeId() == $project_ot->getId()) {
		$project_member = $member;

		//get the project manager name
	    $project_manager_id = get_associated_status_member_id($project_member, Dimensions::findByCode('project_managers'));
	    if ($project_manager_id != null) {
			
			$project_manager = Members::getMemberById($project_manager_id);

			if ($project_manager instanceof Member) {
				$project_manager_name = $project_manager->getName();
				$project_manager_initials=$project_manager->getCustomPropertyValueByCode('Initials');
			}
	    }

		//get main project name
	    $project_member_getName = $project_member->getName();
		//$project_member_complete_name = $project_member->getName();

		break;
	}
}


$project_id_cp_val = "";
$project_number = "";
$project_po_number = "";
$project_description = "";
$table_count = 0;

//only for installations that have projects
$project_type_value = "";
if ($project_member instanceof Member) {
	//get the project member name
	$tmp_array = array($project_member);
	build_member_list_text_to_show_in_trees($tmp_array);


	if ( ! isset($project_manager_name) || $project_manager_name  == "") {
		$manager_member = null;
		$managers_dim = Dimensions::findByCode('project_managers');
		// if invoice is classified in a manager then use that member
		if($managers_dim instanceof Dimension)
		{
			foreach ($invoice->getMembers() as $inv_mem) {
				if ($inv_mem->getDimensionId() == $managers_dim->getId()) {
					$manager_member = $inv_mem;
					break;
				}
			}
		}

		// if not classified in any manager then use the manager associated to the project
		if (!$manager_member) {
			$manager_member_id = get_associated_status_member_id($project_member, $managers_dim);
			$manager_member = Members::getMemberById($manager_member_id);
		}

		if ($manager_member instanceof Member) {
			$project_manager_name = $manager_member->getName();
		}
	}

	//get project complete name
	if($project_member_complete_name=='')
	{
		$project_member_complete_name = $project_member->getName();
	}
	//check that exists project name
	if($project_member_getName=='')
	{
		$project_member_getName = $project_member->getName();
	}

	//get project type value
	$project_type_id = get_associated_status_member_id($project_member, Dimensions::findByCode('countries'));
	$project_type_value = "";
	if ($project_type_id != null) {
		$project_type = Members::getMemberById($project_type_id);
		if ($project_type instanceof Member) {
			$project_type_value = $project_type->getName();
			$project_type_value = preg_replace('/[^A-Za-z\-]/', '', $project_type_value);
		}
	}

	//get project id value
	$project_id_cp = CustomProperties::getCustomPropertyByCode($project_ot->getId(), "project_id");
	if ($project_id_cp instanceof CustomProperty) {
		$tmp_project_obj_id = $project_member->getObjectId();
		$cpval = CustomPropertyValues::getCustomPropertyValue($tmp_project_obj_id, $project_id_cp->getId());
		if ($cpval instanceof CustomPropertyValue) {
			$project_id_cp_val = $cpval->getValue();
		}
	}

	/* for number project*/
	$customProject_cp = CustomProperties::getCustomPropertyByCode($project_member->getObjectTypeId(), "project_id");
	if ($customProject_cp instanceof CustomProperty) {
		$customProject_cp_val = CustomPropertyValues::getCustomPropertyValue($project_member->getObjectId(), $customProject_cp->getId());
		if ($customProject_cp_val instanceof CustomPropertyValue) {
			$project_number = $customProject_cp_val->getValue();
		}
	}

	// PO Number
	$po_number_cp = CustomProperties::getCustomPropertyByCode($project_ot->getId(), "po_number");
	if ($po_number_cp instanceof CustomProperty && $project_member instanceof Member) {
		$cpval = CustomPropertyValues::getCustomPropertyValue($project_member->getObjectId(), $po_number_cp->getId());
		if ($cpval instanceof CustomPropertyValue) {
			$project_po_number = $cpval->getValue();
		}
	}

	// project description
	$po_desc_cp = CustomProperties::getCustomPropertyByCode($project_ot->getId(), "description_special");
	if ($po_desc_cp instanceof CustomProperty && $project_member instanceof Member) {
		$cpval = CustomPropertyValues::getCustomPropertyValue($project_member->getObjectId(), $po_desc_cp->getId());
		if ($cpval instanceof CustomPropertyValue) {
			$project_description = $cpval->getValue();
		}
	}

	///get site address custom properties for the table project options
    $site_address_arr=[];
    $site_address_cp = CustomProperties::getCustomPropertyByCode($project_ot->getId(), "(New format) Address (Street, City):");
	if ($site_address_cp instanceof CustomProperty && $project_member instanceof Member) {
		$cpval = CustomPropertyValues::getCustomPropertyValue($project_member->getObjectId(), $site_address_cp->getId());
		if ($cpval instanceof CustomPropertyValue) {
			$site_address_val = $cpval->getValue();
			
			$site_address_arr=explode("|",$site_address_val);
			$site_address_val='';
			//$site_address_val = $site_address_arr[0]?$site_address_arr[0].", ":'';
			$site_address_val .= $site_address_arr[1]?$site_address_arr[1].", ":'';
			$site_address_val .= $site_address_arr[2]?$site_address_arr[2].", ":'';
			$site_address_val .= $site_address_arr[3]?$site_address_arr[3].", ":'';
			$site_address_val .= $site_address_arr[5]?$site_address_arr[5].", ":'';
			$site_address_val = trim($site_address_val, ", ");
		}
	}

}

$project_and_po_number_text = "";
$inv_po_number_cp = CustomProperties::getCustomPropertyByCode($invoice->getObjectTypeId(), "po_number");
if ($inv_po_number_cp instanceof CustomProperty) {
	$cpval = CustomPropertyValues::getCustomPropertyValue($invoice->getId(), $inv_po_number_cp->getId());
	if ($cpval instanceof CustomPropertyValue && $cpval->getValue() != '') {
		$project_and_po_number_text = trim($cpval->getValue());
	} else {
		if ($project_member instanceof Member) {
			$project_id_cp = CustomProperties::getCustomPropertyByCode($project_ot->getId(), "po_number_for_project");
			if ($project_id_cp instanceof CustomProperty) {
				$cpval = CustomPropertyValues::getCustomPropertyValue($project_member->getObjectId(), $project_id_cp->getId());
				if ($cpval instanceof CustomPropertyValue) {
					$project_and_po_number_text = trim($cpval->getValue());
				}
			}
		}
	}
}

$terms_text = "";
if (class_exists('IncomePaymentTerms')) {
	$payment_term = IncomePaymentTerms::instance()->findById($invoice->getPaymentTermId());
	if (!$payment_term) {
		$payment_term = IncomePaymentTerms::getDefaultPaymentTerm();
	}
	if ($payment_term instanceof IncomePaymentTerm) {
		$terms_text = $payment_term->getName();
	}
} else {
	// use old custom property
	$payment_period_cp = CustomProperties::getCustomPropertyByCode($invoice->getObjectTypeId(), 'invoice_payment_period');
	if ($payment_period_cp instanceof CustomProperty) {
		$payment_period_cp_val = CustomPropertyValues::getCustomPropertyValue($invoice->getId(), $payment_period_cp->getId());
		if ($payment_period_cp_val instanceof CustomPropertyValue) {
			$terms_text = $payment_period_cp_val->getValue();
		}
	}
}

$due_date_text = '';
if ($invoice->getExpirationDate() instanceof DateTimeValue) {
	$due_date_text = format_date($invoice->getExpirationDate(), array_var($invoice_options, 'date_format'), 0);
}

$billing_from_cp = CustomProperties::getCustomPropertyByCode(IncomeInvoices::instance()->getObjectTypeId(), 'billing_period_from');
$billing_to_cp = CustomProperties::getCustomPropertyByCode(IncomeInvoices::instance()->getObjectTypeId(), 'billing_period_to');
$billing_from_date = '';
$billing_to_date = '';

$cp_val = CustomPropertyValues::getCustomPropertyValue($invoice->getId(), $billing_from_cp->getId());
if ($cp_val && $cp_val->getValue() != '') {
	try {
		$dt = DateTimeValueLib::dateFromFormatAndString('Y-m-d', $cp_val->getValue());
		$billing_from_date = format_date($dt, array_var($invoice_options, 'date_format'), 0);
	} catch (Exception $e) {
	}
}

$cp_val = CustomPropertyValues::getCustomPropertyValue($invoice->getId(), $billing_to_cp->getId());
if ($cp_val && $cp_val->getValue() != '') {
	try {
		$dt = DateTimeValueLib::dateFromFormatAndString('Y-m-d', $cp_val->getValue());
		$billing_to_date = format_date($dt, array_var($invoice_options, 'date_format'), 0);
	} catch (Exception $e) {
	}
}

    

/****get table project options***/
$invoice_template_options = IncomeInvoiceTemplateOptions::getInvoiceTemplateOptions($invoice_template->getId());
if ($invoice_template_options) {
	foreach ($invoice_template_options as $invoice_template_option) {

		//create an array with the options
		$invoice_template_options_items['name'] = $invoice_template_option->getName();
		$invoice_template_options_items['label'] = $invoice_template_option->getLabel();
		$invoice_template_options_items['order'] = $invoice_template_option->getOrderNumber();
		$invoice_template_options_items['visible'] = $invoice_template_option->getVisible();
		$invoice_template_options_items['selected_option'] = $invoice_template_option->getSelectedOption();
		$invoice_template_options_array[$invoice_template_option->getName()] = $invoice_template_options_items;
	}
}

if ($project_member instanceof Member && $invoice_template_options_array['project_complete_name']['selected_option'] == 'project_and_subprojects') {
	$subprojects = $project_member->getAllChildren(false, null, " AND object_type_id = ".$project_member->getObjectTypeId());
	foreach ($subprojects as $subp) {
		$project_member_complete_name .= "<br/>" . $subp->getDisplayName();
	}
}

$invoice_template_options_array['project_number']['value'] = $project_number;
$invoice_template_options_array['project_complete_name']['value'] = $project_member_complete_name;
$invoice_template_options_array['project_name']['value'] = $project_member_getName;
$invoice_template_options_array['project_description']['value'] = $project_description;
$invoice_template_options_array['project_manager']['value'] = isset($project_manager_name) ? $project_manager_name : "";
$invoice_template_options_array['project_bill_fromto']['value'] = $billing_from_date . " - " . $billing_to_date;
$invoice_template_options_array['project_payment_terms']['value'] = $terms_text;
$invoice_template_options_array['project_due_date']['value'] = $due_date_text;
$invoice_template_options_array['project_po_number']['value'] = $project_po_number;
$invoice_template_options_array['project_type_value']['value'] = $project_type_value;
$invoice_template_options_array['project_compnay_bill_to']['value'] = $invoice->getCustomerLegalName();
$invoice_template_options_array['project_invoice_number']['value'] = trim(strval($invoice->getSeries() . " " . $invoice->getInvoiceNumber()));
$invoice_template_options_array['project_manager_initials']['value'] = isset($project_manager_initials) ? $project_manager_initials : "";
$invoice_template_options_array['site_address']['value'] = isset($site_address_val) ? $site_address_val : "";

if ($billing_from_date instanceof DateTimeValue) {
	$invoice_template_options_array['project_invoice_period']['value'] = format_date($billing_from_date->advance(logged_user()->getUserTimezoneValue() * -1, false), 'F j') . " through " . format_date($billing_to_date->advance(logged_user()->getUserTimezoneValue() * -1, false), 'F j, Y', 0);
}

$company = owner_company();
$company_name = trim($company->getName());

$additional_table_sections = array();
$project_location_cp = CustomProperties::getCustomPropertyByCode($project_ot->getId(), "project_location_for_invoice");
if ($project_location_cp instanceof CustomProperty && $project_location_cp->getIsDisabled() == 0 && $invoice_template->getIncludeProjectLocation() == 1) {
	$cpval = CustomPropertyValues::getCustomPropertyValue($project_member->getObjectId(), $project_location_cp->getId());
	if ($cpval instanceof CustomPropertyValue) {
		$value = nl2br(trim($cpval->getValue()));
		if($value != '') {
			$additional_table_sections[] = array('header' => lang('project locations'), 'value' => $value);
		}
	}
}

////////////////////////////////////////////////////PROJECT TABLE////////////////////////////////////
if($group_code != 'discounts_table' && $group_code != 'discounts_allocate_percentage'){

if ($company_name != 'Robinson Noble' && $ctrl_project_table==0) {
	?>

	<div style="clear:both"></div>
	<div class="project-table">
		<table id="items">
			<thead>
			<tr>
				<?php
				foreach ($invoice_template_options_array as $invoice_template_option_data) {
					if (isset( $invoice_template_option_data['visible']) && $invoice_template_option_data['visible'] == 1) {
						$termClass = determine_invoice_option_class_by_label($invoice_template_option_data['label']);
						?>
						<th class="left <?= $termClass ?>"><b>
								<?php echo strval($invoice_template_option_data['label']) ?>
							</b></th>
						<?php
					}
				} ?>
			</tr>
			</thead>
			<tr>
				<?php
				foreach ($invoice_template_options_array as $invoice_template_option_data) {
					if ( isset( $invoice_template_option_data['visible']) && $invoice_template_option_data['visible'] == 1) {
						$termClass = determine_invoice_option_class_by_label($invoice_template_option_data['label']);
						if($invoice_template_option_data['name']=='site_address')
						{
							$widthfix='width: 200px;';
						}else{
							$widthfix='';
						}
						?>
						<td  class="<?= $termClass ?>" style="<?php echo $widthfix?>">
							<?php echo strval($invoice_template_option_data['value']) ?>
						</td>
						<?php
					}
				} ?>
			</tr>
			<?php
				foreach ($additional_table_sections as $section) {
					?>
					<thead>
						<tr>
							<th class="left" colspan='20' >
								<b><?php echo $section['header'] ?></b>
							</th>
						</tr>
					</thead>
					<tr>
						<td colspan='20'>
							<?php echo $section['value'] ?>
						</td>
					</tr>
					<?php
				}
			?>
		</table>
	</div>
	<?php
} else if ('Robinson Noble' == $company_name && $ctrl_project_table==0) { 
	?>
		<div style="clear:both"></div>
		<div class="project-table">
			<table>
				<?php
				foreach ($invoice_template_options_array as $invoice_template_option_data) {
					if ($invoice_template_option_data['visible'] == 1 && $invoice_template_option_data['value'] != '') { ?>
						<tr>
							<td class="label">
							<?php echo $invoice_template_option_data['label'] ?>
							</td>
							<td>
							<?php echo $invoice_template_option_data['value'] ?>
							</td>
						</tr>
				<?php } ?>
			<?php } ?>
			</table>
		</div>

		<div style="clear:both"></div>
		<div style="font-size: 300%; text-align:center; margin-top: 160px;">INVOICE</div>
		<div style="clear:both"></div>
<?php } 
}
?>
<!-----------------------------------END PROJECT TABLE----------------------------------------------->

<div style="clear:both"></div>

<!--hide now until next analisis phase, this is additional information for the invoice-->
<!-- <?php //if (trim($invoice->getAdditionalInformation()) && $ctrl_project_table==0) { ?>
	<div class="project-desc">
		<?php //echo nl2br($invoice->getAdditionalInformation()) ?>
	</div>
<?php //} ?> -->

<?php
$print_labels = array_var($print_options, 'labels', array());

$discountControlTable = 0;
if ($group_code == 'discounts_table' && $group_code != 'discounts_allocate_percentage') {

	//show labor and expenses subtotal
	$discountControlTable=1;

 	$discountsTableTitulosName = array_var($print_labels, 'discounts', lang('discounts'));

 	$columns = array('description' => array_var($print_labels, 'discounts', lang('discounts')), 'total' => array_var($print_labels, 'amount', lang('amount')));
 	$column_order = array('description', 'total');
 }

 if ($group_code == 'discounts_allocate_percentage') {

 	$columns = array('description' => array_var($print_labels, 'discount allocation percentage', lang('discount allocation percentage')), 'total' => array_var($print_labels, 'amount', lang('amount')));
 	$column_order = array('description', 'total');
 }



if ( isset( $taxes_data) && count($taxes_data) > 0) {
	$sumTaxes = 0;
	foreach ($taxes_data as $tax_data) {
		$sumTaxes += $tax_data['amount'];
	}
}

foreach ($column_order as $key => $value) {
	if (str_starts_with($value, "tax_")) {
		moveElement($column_order, 0, count($column_order) - 1);
	}
}

if (in_array('total', $column_order))
	moveElement($column_order, array_keys($column_order, "total")[0], count($column_order) - 1);
if (in_array('date', $column_order))
	moveElement($column_order, array_keys($column_order, "date")[0], 0);
?>



<!-------------------------------LABOR,  DISCOUNTS TABLE or PREVIUSLLY BILLED------------------------------------------>
<?php if (count($lines_data) > 0 ) { ?>
	<div id="table_expenses" class="table_expenses">
	<table id="items">
		<?php if ($invoice_template->getShowHeadersBeforeDetails() && !in_array($invoice_template->getTemplateType(), array('lumpsum', 'lumpsum_view'))) { ?>
			<thead class="main-header object-type-header ">
				<tr>
					<th colspan="<?php echo count($column_order) ?>" class="left">
						<?php
						
						if (isset($lines_data[0]) && strval($lines_data[0]['line_type']) == strval('discount')) {
							echo array_var($print_labels, 'discounts', lang('discounts'));
						} else if (isset($lines_data[0]) && strval($lines_data[0]['line_type']) == strval('discounts_allocate_percentage')) {
							echo array_var($print_labels, 'discount allocation percentage', lang('discount allocation percentage'));
						}else{
							echo array_var($print_labels, 'labor', lang('labor'));
						}
						?>
					</th>
				</tr>
			</thead>
		<?php } ?>
		<thead class="hide_extra_columns">
			<tr>
				<?php
				$countColumnDesriptions = 0;

				// add one to the tables count
				$table_count++;

				foreach ($column_order as $col) {
					if ($col == '')
						continue;
					
					$cls = '';
					if (in_array($col, array('amount', 'unit_value', 'total', 'subtotal')))
						$cls = 'right ';
					else if (in_array($col, array('description', 'user', 'category', 'product_type', 'expense_name', 'product type'))) {
						$cls = 'left';
						$countColumnDesriptions++;
					} else if (in_array($col, array('date')))
						$cls = 'left dateWidht';
					else
						$cls = 'right';
					?>
                   <!-- columns name must NOT has lang because is set in template options!!!!!-->					
					<th class="<?php echo $cls ?>"><?php echo $columns[$col] ?></th>
				<?php } ?>
			</tr>
		</thead>
		<tbody>
			<?php
			foreach ($lines_data as $line_data):
				?>
				<tr class="item-row <?php echo (count($line_data) > 9) ? 'maxColumn' : ''; ?>">
					<?php
					$colspan = 0;

					foreach ($column_order as $k => $col) {
						$colspanDesc = 0;
						// don't render empty column
						if ($col == '')
							continue;

						// select cell class
						$cls = '';
						switch ($col) {
							case 'amount':
								$cls = 'right TotalWidht';
								break;
							case 'date':
								$cls = 'left dateWidht';
								break;
							// case 'description':
							// 	break;
							case 'product type':
							case 'category':
								$cls = 'description countColumn_' . $countColumnDesriptions;
								break;
							case 'unit_value':
							case 'total':
							case 'subtotal':
								$cls = 'right TotalWidht';
								break;
							case 'user':
								$cls = 'user countColumn_' . $countColumnDesriptions;
								break;
							default:
								if (str_starts_with($col, "tax_")) {
									$cls = 'right short';
								}
								break;
						}

						$colDescBreak = 0;
						while ($colDescBreak < count($column_order)) {
							$colspanDesc++;
							if ($column_order[$colDescBreak] == 'description') {
								break;
							}

							$colDescBreak++;
						}

						if ($line_data['linetype'] == '5') {
							?>
							<td colspan="<?php echo $colspanDesc ?>" class="<?php echo $cls ?>"><?php echo $line_data['description'] ?>
							</td>
							<?php break;
						} else {
							?>
							<td colspan="<?php echo $colspan ?>" class="<?php echo $cls ?>"><?php echo $line_data[$col] ?></td>
							<?php
						}
						?>
						<?php
					} ?>
				</tr>
			<?php endforeach; ?>
			<?php if ($group_code != 'discounts_table' && $group_code != 'discounts_allocate_percentage') { ?>
				<table style="width: 100%;" id="labor_subtotal_ctrl">
					<tbody>
						<tr>
							<td class="totalLine">
								<div class="totalContainer">
									<span colspan="1" class="global-subtotal-line totalText">
										<?=
											array_var(
												$print_labels,
												'subtotal_labor',
												(in_array($invoice_template->getTemplateType(), array('lumpsum', 'lumpsum_view', 'fixed fee tasks'))) ? lang('subtotal') : lang('subtotal_labor')
											);
										?>:
									</span>
									<span colspan="1" class="global-subtotal-value lineNotImportant totalValue">
										<?=
											format_money_amount(
												(in_array($invoice_template->getTemplateType(), array('lumpsum', 'lumpsum_view'))) ? $subtotal /*- $sumTaxes*/ : $subtotal,
												$currency_symbol
											);
										?>
									</span>
								</div>
							</td>
						</tr>
					</tbody>
				</table>
		</tbody>
		<?php } ?>
	</table>
	</div>
<?php } ?>
<!-------------------------------END LABOR OR  DISCOUNTS TABLE------------------------------------------>


<!----------------------------------EXPENSES (PRODUCTS SERVICES) TABLE -------------------------------------->
<?php
$subgroup_count = 0;
foreach ($actual_expense_groups as $actual_expense_group) {
	$subgroup_count++;
	$act_exp_lines_data = $actual_expense_group['data'];

	if ($invoice_template->getShowExpensesMarkupSeparated() && count($actual_expense_group['more_expense_table_rows']) > 0) {
		// format the markup line amounts
		foreach ($actual_expense_group['more_expense_table_rows'] as $row_key => &$row_val) {
			$row_val['total'] = format_money_amount($row_val['total'], $currency_symbol);
			$row_val['unit_value'] = format_money_amount($row_val['unit_value'], $currency_symbol);
		}
		// append the markup lines
		$act_exp_lines_data = array_merge($actual_expense_group['data'], $actual_expense_group['more_expense_table_rows']);
	}

	if (count($act_exp_lines_data) > 0) { ?>
	<div id="table_expenses" class="table_expenses">
		<table id="items">
			<?php if ($invoice_template->getShowHeadersBeforeDetails() && $subgroup_count == 1) { ?>
				<thead class="main-header object-type-header">
					<tr>
						<th colspan="<?php echo count($act_exp_column_order) ?>" class="left"><?php echo array_var($print_labels, 'expenses', lang('expenses')) ?></th>
					</tr>
				</thead>
			<?php } ?>
			<?php if ($actual_expense_group['name'] != '') { ?>
				<thead class="main-header group-name-header">
					<tr>
						<th colspan="<?php echo count($act_exp_column_order) ?>"><?php echo $actual_expense_group['name'] ?></th>
					</tr>
				</thead>
			<?php } ?>
			<thead>
				<tr>
					<?php 
					
					// add one to the tables count
					$table_count++;

					$countColumnDesriptions = 0;
					
					foreach ($act_exp_column_order as $col) {
						if ($col == '') {
							continue;
						}
						// check if the template calculated that fee column must be hidden for this group (if break down by top level cat and all lines have fee=0)
						if (in_array($col, array('fee','unit_cost','markup_amount')) && array_var($actual_expense_group, 'hide_cost_fee_column')) {
							continue;
						}
						$cls = '';
						if (in_array($col, array('amount', 'unit_cost','unit_value', 'total', 'unit_cost', 'markup_amount')))
							$cls = 'right';
						else if (in_array($col, array('description', 'user', 'category', 'product_type', 'expense_name', 'product type'))) {
							$cls = 'left';
							$countColumnDesriptions++;
						} else if (in_array($col, array('date')))
							$cls = 'left dateWidht';
						else
							$cls = 'center';
						?>
						
						<th class="<?php echo $cls ?>"><?php echo $act_exp_columns[$col] ?></th>
					<?php } ?>
				</tr>
			</thead>
			<tbody>
				<?php

				foreach ($act_exp_lines_data as $line_data): ?>
					<tr class="item-row <?php echo (count($line_data) > 9) ? 'maxColumn' : ''; ?>">
						<?php foreach ($act_exp_column_order as $k => $col) {
							$colspanDesc = 1;
							// don't render empty column
							if ($col == '') {
								continue;
							}

							// check if the template calculated that fee column must be hidden for this group (if break down by top level cat and all lines have fee=0)
							if (in_array($col, array('fee','unit_cost','markup_amount')) && array_var($actual_expense_group, 'hide_cost_fee_column')) {
								continue;
							}

							// select cell class
							$cls = '';
							switch ($col) {
								case 'fee':
								case 'amount':
									$cls = 'right TotalWidht';
									break;
								case 'date':
									$cls = 'left dateWidht';
									break;
								case 'description':
								case 'product type':
								case 'category':
									$cls = 'description countColumn_' . $countColumnDesriptions;
									break;
								case 'markup_amount':
								case 'unit_value':
								case 'unit_cost':
								case 'total':
									$cls = 'right TotalWidht';
									break;
								case 'user':
									$cls = 'user description countColumn_' . $countColumnDesriptions;
									break;
							}

							$colDescBreak = 0;
							while ($colDescBreak < count($column_order)) {
								if ($column_order[$colDescBreak] == 'description') {
									break;
								} else if ($column_order[$colDescBreak] == 'date' || $column_order[$colDescBreak] == 'user' || $column_order[$colDescBreak] == 'category' || $column_order[$colDescBreak] == 'product type') {
									$colspanDesc++;
								}
								$colDescBreak++;
							}

							if ($line_data['linetype'] == '6') {
								?>
								<td colspan="<?php echo $colspanDesc ?>" class="<?php echo $cls ?>"><?php echo $line_data['description'] ?>
								</td>
								<?php break;
							} else {
								?>
								<td colspan="<?php echo isset($colspan) ? $colspan : "0" ?>" class="<?php echo $cls ?>"><?php echo $line_data[$col] ?></td>
								<?php
							}
							?>
							<?php
						} ?>
					</tr>
				<?php endforeach; ?>
			
				<?php
				// if there are more than 1 expense subgroups then put the subtotal for each one
				if (count($actual_expense_groups) > 1) { ?>
					<table style="width: 100%;" id="exp_subtotal_ctrl_<?php echo $subgroup_count ?>" class="expense-subgroup-totals">
						<tbody>
							<tr>
								<td class="totalLine">
									<div class="totalContainer">
										<span class="cell spacer"></span>
										<span class="global-subtotal-line totalText" colspan="1">
											<?php echo $actual_expense_group['name'] . ' ' . lang('subtotal') ?>:
										</span>
										<span class="global-subtotal-value totalValue" colspan="1">
											<?php echo format_money_amount($actual_expense_group['subtotal'], $currency_symbol); ?>
										</span>
									</div>
								</td>
							</tr>
						</tbody>
					</table>
				<?php } ?>

				<?php
				// general expense subtotal, only print it after the last group and if there are more than 1 separate tables
				if ($subgroup_count == count($actual_expense_groups) && $table_count > 1) { ?>
				<!-- aca vamos 1--->
					<table style="width: 100%;" id="exp_subtotal_ctrl">
						<tbody>
							<tr>
								<td class="totalLine">
									<div class="totalContainer">
										<span class="cell spacer"></span>
										<span class="global-subtotal-line totalText" colspan="1">
											<?php echo array_var($print_labels, 'subtotal_expenses', lang('subtotal_expenses')) ?>: <!--Expenses subtotal-->
										</span>
										<span class="global-subtotal-value lineNotImportant totalValue" colspan="1">
											<?php echo format_money_amount($act_exp_subtotal, $currency_symbol); ?>
										</span>
									</div>
								</td>
							</tr>
						</tbody>
					</table>
				<?php } ?>
			</tbody>
		</table>
	</div>
	<?php
	}
} ?>
<!-------------------------------------------------------- EXPENSES TABLE END ----------------------------------------------->

<!------------------------------DISCOUNTS TABLE WHEN DISCOUNT IS SEPARATED---------------------------->
		<?php if (($group_code != '' && $group_code != 'discounts_table' && $group_code != 'discounts_allocate_percentage') || ($discountControlTable && $group_code != 'discounts_allocate_percentage')) { ?>
			<!------------------------SUBTOTAL------------------->
			<tr>
				<table style="width: 100%;">
					<tbody>
						<tr>
							<td class="totalLine">
								<div class="totalContainer">
									<span class="cell spacer"></span>
									<span class="global-subtotal-line totalText" colspan="1">
										<?php if($group_code=='discounts_table'){
											$total_amount_to_show=0;
										        echo array_var($print_labels, 'discounts_table', lang('Discounts subtotal'));
											    $total_amount_to_show=$subtotal + $act_exp_subtotal + $discount_table_total;
											 }else{
												$total_amount_to_show=$subtotal + $act_exp_subtotal;
												echo array_var($print_labels, 'amount_due', lang('amount_due'));
											 }?>
										
										<?php ///echo array_var($print_labels, 'amount_due', lang('amount_due')) ?>: <!--Amount due-->
									</span>
									<span class="global-subtotal-value lineNotImportant totalValue" colspan="1">
										<?php echo format_money_amount($total_amount_to_show, $currency_symbol); ?>
									</span>
								</div>
							</td>
						</tr>
					</tbody>
				</table>
			</tr>
		<?php } ?>

		<!------discounts totals--------------------------------------------------------->
		<?php
		if ($discount > 0) { ?>
			<table style="width: 100%;" id="table_discounts_totals">
				<tbody>
					<tr>
						<td class="totalLine">
							<div class="totalContainer">
								<span class="cell spacer"></span>
								<span class="totalText" colspan="1">
									<?= array_var($print_labels, 'subtotal', lang('subtotal')) ?>: <!--Subtotal-->
								</span>
								<span class="totalValue" colspan="1">
									<?php echo format_money_amount($subtotal + $act_exp_subtotal, $currency_symbol); ?>
								</span>
							</div>
						</td>
					</tr>
					<tr>
						<td class="totalLine">
							<div class="totalContainer">
								<span class="cell spacer"></span>
								<span class="totalText" colspan="1">
									<?= array_var($print_labels, 'discount', lang('discount')) ?>: <!--Discounts-->
								</span>
								<span class="totalValue" colspan="1">
									<?= "(" . format_money_amount(abs($discount), $currency_symbol) . ")" ?>
								</span>
							</div>
						</td>
					</tr>
				</tbody>
			</table>
		<?php } ?>

		<!----------------------------TABLE DISCOUNT ALLOCATION PERCENTAGE-------------------------------------->
		<?php 
		?>
		<?php if ($group_code == 'discounts_allocate_percentage' ) { ?>
		
			<!-- <table style="width: 100%;">
					<tbody>
						<tr>
							<td class="totalLine">
								<div class="totalContainer">
									<span class="global-subtotal-line totalText" colspan="1">
										<?php 
										        echo array_var($print_labels, 'Subtotal', lang('subtotal'));
											  
											 ?>
										
										<?php ///echo array_var($print_labels, 'amount_due', lang('amount_due')) ?>: 
									</span>
									<span class="global-subtotal-value lineNotImportant totalValue" colspan="1">
										<?php echo format_money_amount($discounts_allocate_percentage_total, $currency_symbol); ?>
									</span>
								</div>
							</td>
						</tr>
					</tbody>
				</table> -->

			<?php } ?>
		<!----------------------------END TABLE DISCOUNT PERCENTAGE-------------------------------------------->
		
		<?php if ($show_grand_total) { ?>
		<?php if ( isset( $taxes_data) && count($taxes_data) > 0) { 
			$discount=$discount?$discount:0;
			$act_exp_subtotal=$act_exp_subtotal?$act_exp_subtotal:0;
			$subtotal=$subtotal?$subtotal:0;
			?>
			<!----------------taxes--------------------------------------------->
			<table style="width: 100%;">
				<tbody>
					<tr>
						<td class="totalLine">
							<div class="totalContainer">
								<span class="cell spacer"></span>
								<span class="totalText" colspan="1">
									<?= array_var($print_labels, 'subtotal', lang('subtotal')) ?>: <!--Subtotal-->
								</span>
								<span class="totalValue" colspan="1">
									<?php echo format_money_amount($subtotal + $act_exp_subtotal - $discount, $currency_symbol) ?>
								</span>
							</div>
						</td>
					</tr>
				</tbody>
			</table>
		<?php
		foreach ($taxes_data as $tax_data) { ?>
			<table style="width: 100%;">
				<tbody>
					<tr>
						<td class="totalLine">
							<div class="totalContainer">
								<span class="cell spacer"></span>
								<span class="totalText" colspan="1">
									<?= $tax_data['name'] ?>:
								</span>
								<span class="totalValue" colspan="1">
									<?= format_money_amount($tax_data['amount'], $currency_symbol); ?>
								</span>
							</div>
						</td>
					</tr>
				</tbody>
			</table>
		<?php } ?>
		<?php } ?>
		<!----------------total--------------------------------------------->
			<table style="width: 100%;">
				<tbody>
					<tr>
						<td class="totalLine mainTotal">
							<div class="totalContainer">
								<span class="cell spacer"></span>
								<span class="global-total-line totalText" colspan="1">
									<?= array_var($print_labels, 'total', lang('total_due_for_this_invoice')) ?>: <!--Total due for this invoice-->
								</span>
								<span class="global-total-value totalValue" colspan="1">
									<?= format_money_amount($invoice_total, $currency_symbol); ?>
								</span>
							</div>
						</td>
					</tr>
				</tbody>
			</table>
		<?php } ?>

		<!-- retainer-->
		<?php
		$subtotal_table = 'off';
		if ($retainers) {
			foreach ($retainers as $retainer) {
				if ($retainer > 0) {
					$total_retainer = trim(str_replace('-', " ", $retainer['total']));
					if ($subtotal_table == 'off') {
						?>
									<?php $subtotal_table = 'on';
					} ?>
								<table style="width: 100%;">
									<tbody>
										<tr>
											<td class="totalLine">
												<div class="totalContainer">
													<span class="cell spacer"></span>
													<span class="global-subtotal-line textBold totalText" colspan="1">
														<?= $retainer['description'] ?>:
													</span>
													<span class="global-subtotal-value totalValue" colspan="1">
										
													<?= "(" . format_money_amount($total_retainer, $currency_symbol) . ")" ?> 
													</span>
												</div>
											</td>
										</tr>
									</tbody>
								</table>
								<table style="width: 100%;">
									<tbody>
										<tr>
											<td class="totalLine">
												<div class="totalContainer">
													<span class="cell spacer"></span>
													<span class="global-subtotal-line textBold totalText" colspan="1">
														<?= array_var($print_labels, 'subtotal', lang('due')) ?>: <!--Due-->
													</span>
													<span class="global-subtotal-value totalValue" colspan="1">
														<?= format_money_amount($invoice_total + $retainer['totalClean']) ?>
													</span>
												</div>
											</td>
										</tr>
									</tbody>
								</table>
							<?php
				}
			}
		}
		?>
		<!-- fin retainer-->

<script>

	// if there is only one table then hide each table's minor subtotals
	let table_count = <?php echo $table_count ?>;
	if (table_count <= 1) {
		document.getElementById("labor_subtotal_ctrl").style.display = "none";
		$(".expense-subgroup-totals").hide();
	}




// 	var divs = document.getElementsByClassName("hola").length;
// console.log("Hay " + divs + " elementos");
</script>

<style>
	thead.hide_extra_columns tr th:empty {
		display: none !important;
	}

	#items .item-row:nth-child(33) td {
		background-color: rgba(0, 0, 0, .08);
		/* border-bottom: .1px solid #1a4567 !important;
		background-color: red; */
	}

	/** css for total blocks, they can be overriden in the custom layouts if necessary */
	.totalLine {
		padding: 5px;
	}
	.totalLine .totalContainer {
		display: table;
		width: 100%;
	}

	.totalLine .totalContainer .totalText {
		margin-right: 10px;
		display: table-cell;
		white-space: nowrap;
	}
	.totalLine .totalContainer .totalValue {
		min-width: 100px;
		text-align: right;
		display: table-cell;
		white-space: nowrap;
	}

	.cell {
		display: table-cell;
	}

	.spacer {
		width: 100%;
	}
	#page-wrap {
        width: auto;
		/*max-width: 1024px;*/
        /*min-width: 680px;*/
        margin: 10px 10px;
        padding: 10px 0;
        /*overflow-x: auto;*/
    }

	.fixedFooter{
		break-inside: avoid;
	}

	.invoiceData {
		width: 100%;
		overflow: auto;
		display: block;
	}

	.invoiceHeader {
		display: table;
		width: 100%;
	}

	.invoiceHeader>div {
		display: table-cell;
		max-width: 480px;
	}

	.invoiceHeader>div:last-child {
		max-width: 260px;
	}

	.invoiceTitle {
		position: relative;
		top: -14px;
	}

	@media print {
		.invoiceTitle {
			top: -1px;
		}
	}

	.invoiceData .invoiceDataItem {
		float: left;
		margin-bottom: 10px;
		width: 50%;
	}
</style>
