<?php
set_page_title(lang('invoice type'));
$genid = gen_id();
?>

<div id="<?php echo $genid ?>InvoiceTypes" class="adminMailAccounts" style="height: 100%; background-color: white">
    <div class="coInputHeader">
        <div class="coInputTitle"><?php echo lang('invoice type') ?></div>
    </div>
    <div class="adminMainBlock">
        <?php if(isset($invoice_types) && is_array($invoice_types) && count($invoice_types)) { ?>
        <table class="adminListing" style="min-width: 400px; margin-top: 10px;">
                <tr>
                    <th><?php echo lang('name') ?></th>
                    <th><?php echo lang('options') ?></th>
                </tr>
                <?php
                $isAlt = true;
                foreach($invoice_types as $invoice_type) {
                        $isAlt = !$isAlt;
                ?>
                <tr class="<?php echo $isAlt? 'altRow' : ''?>" id="<?php echo $genid ?>tr_<?php echo $invoice_type->getId()?>">
                    <td><?php echo $invoice_type->getName() ?></td>
                    <?php
                    $options = array();
                    $options[] = '<a class="internalLink" href="#" onclick="og.render_modal_form(\'\',{c:\'invoice_type\', a:\'edit\', params:{id:'.$invoice_type->getId().'}});">' . lang('edit') . '</a>';
                    $options[] = '<a class="internalLink" href="javascript:og.DeleteInvoiceType(' . $invoice_type->getId() . ')">' . lang('delete') . '</a>';
                    ?>
                    <td><?php echo implode(' | ', $options) ?></td>
                </tr>
                <?php } // foreach ?>
        </table>
        <?php } else { ?><div><?php echo lang('no invoice types') ?></div><?php } // if ?>
        
        </br><a href="#" onclick="og.render_modal_form('',{c:'invoice_type', a:'add'});" class="link-ico ico-add"><?php echo lang('add invoice type')?></a>
    </div>
    
</div>

<script>
	var div = document.getElementById('<?php echo $genid ?>InvoiceTypes');
	div.parentNode.style.backgroundColor = '#FFFFFF'; 
        
        og.DeleteInvoiceType = function(invoice_typeId) {        
            if (confirm(lang('delete invoice type'))) {
                og.openLink(og.getUrl('invoice_type', 'delete', {
                        invoice_type_id : invoice_typeId
                }), {
                    callback: function(success, data) {
                    	$('#<?php echo $genid ?>tr_'+invoice_typeId).remove();
                	}
                });
            }
        };
</script>
