<?php
set_page_title(lang('tax'));
$genid = gen_id();
?>

<div id="<?php echo $genid ?>Taxes" class="coInputMailAccounts" style="height: 100%; background-color: white">
    <div class="coInputHeader">
        <div class="coInputTitle"><?php echo lang('tax') ?></div>
    </div>
    <div class="adminMainBlock">
        <?php if(isset($taxes) && is_array($taxes) && count($taxes)) { ?>
        <table class="adminListing" style="min-width: 400px; margin-top: 10px;">
                <tr>
                    <th><?php echo lang('name') ?></th>
                    <th><?php echo lang('type') ?></th>
                    <th><?php echo lang('value') ?></th>
                    <th><?php echo lang('options') ?></th>
                </tr>
                <?php
                $isAlt = true;
                foreach($taxes as $tax) {
                        $isAlt = !$isAlt;
                ?>
                <tr class="<?php echo $isAlt? 'altRow' : ''?>" id="<?php echo $genid ?>tr_<?php echo $tax->getId()?>">
                    <td><?php echo $tax->getName() ?></td>
                    <td><?php echo lang($tax->getRecord()->getType()) ?></td>
                    <td><?php echo $tax->getRecord()->getValue() ?></td>
                    <?php
                    $options = array();
                    $options[] = '<a class="internalLink" href="#" onclick="og.render_modal_form(\'\',{c:\'tax\', a:\'edit\', params:{id:'.$tax->getId().'}});">' . lang('edit') . '</a>';
                    $options[] = '<a class="internalLink" href="javascript:og.DeleteTax(' . $tax->getId() . ')">' . lang('delete') . '</a>';
                    $options[] = '<a class="internalLink" href="'.get_url('tax', 'record', array('tax_id' => $tax->getId())).'">' . lang('record') . '</a>';
                    ?>
                    <td><?php echo implode(' | ', $options) ?></td>
                </tr>
                <?php } // foreach ?>
        </table>
        <?php } else { ?><div><?php echo lang('no taxes') ?></div><?php } // if ?>
        
        </br><a href="#" onclick="og.render_modal_form('',{c:'tax', a:'add'});" class="link-ico ico-add"><?php echo lang('add tax')?></a>
    </div>
    
</div>

<script>
	var div = document.getElementById('<?php echo $genid ?>Taxes');
	div.parentNode.style.backgroundColor = '#FFFFFF'; 
        
        og.DeleteTax = function(taxId) {        
            if (confirm(lang('delete tax'))) {
                og.openLink(og.getUrl('tax', 'delete', {
                        tax_id : taxId
                }), {
                    callback: function(success, data) {
                    	$('#<?php echo $genid ?>tr_'+taxId).remove();
                	}
                });
            }
        };
</script>
