<?php

include_once dirname(__FILE__)."/../../../application/helpers/plugin_installer_functions.php";


function income_get_additional_install_queries($db_connection, $table_prefix) {
	
	$queries = array();

	if (check_is_installed_plugin($db_connection, $table_prefix, 'advanced_core')) {
	
		include_once dirname(__FILE__)."/../../advanced_core/application/helpers/installer_functions.php";
	
		$prop_groups_queries = get_default_property_groups_queries($db_connection, $table_prefix);
		$queries = array_merge($queries, $prop_groups_queries);
	
	}
	
	if (check_is_installed_plugin($db_connection, $table_prefix, 'expenses2')) {
		$queries[] = "ALTER TABLE `".$table_prefix."payment_receipts` ADD `invoice_id` int(10) NOT NULL DEFAULT '0';";
		$queries[] = "ALTER TABLE `".$table_prefix."payment_receipts` ADD `invoicing_status` VARCHAR(100) NOT NULL DEFAULT 'pending';";
		$queries[] = "ALTER TABLE `".$table_prefix."expenses` ADD `invoicing_status` VARCHAR(100) NOT NULL DEFAULT 'pending';";
	}
	
	if (!chcek_if_column_exists($db_connection, TABLE_PREFIX."timeslots", "invoicing_status")) {
		$queries[] = "ALTER TABLE `".$table_prefix."timeslots` ADD `invoicing_status` VARCHAR(50) NOT NULL DEFAULT 'pending';";
	}

	if (!chcek_if_column_exists($db_connection, TABLE_PREFIX."timeslots", "invoice_id")) {
		$queries[] = "ALTER TABLE `".$table_prefix."timeslots` ADD `invoice_id` INTEGER UNSIGNED NOT NULL DEFAULT 0;";
	}

	if (!chcek_if_column_exists($db_connection, TABLE_PREFIX."contact_addresses", "default_billing_address")) {
		$queries[] = "ALTER TABLE `".$table_prefix."contact_addresses` ADD `default_billing_address` tinyint(1) unsigned NOT NULL default '0';";
	}

	if (!chcek_if_column_exists($db_connection, TABLE_PREFIX."contact_emails", "default_billing_email")) {
		$queries[] = "ALTER TABLE `".$table_prefix."contact_emails` ADD  `default_billing_email` tinyint(1) unsigned NOT NULL default '0';";
	}

	if (check_is_installed_plugin($db_connection, $table_prefix, 'member_association_attributes')) {
		
		// to use when creating the invoice_allocation attribute for relations between clients and projects
		if (!chcek_if_column_exists($db_connection, TABLE_PREFIX."income_invoices", "allocation_percentage")) {
			$queries[] = "
				ALTER TABLE `".$table_prefix."income_invoices`
				ADD `allocation_percentage` decimal(20,3) unsigned NOT NULL DEFAULT '100';
			";
		}
	}

	return $queries;
}
?>