-- <?php echo $table_prefix ?>
-- DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci
-- collate utf8_unicode_ci
-- <?php echo $engine ?> InnoDB
-- varchar cannot be larger than 256
-- blob/text cannot have default values
-- sql queries must finish with ;\n (line break inmediately after ;)

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_config_options` (
`id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
`name` varchar(50) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
`value` text COLLATE utf8_unicode_ci,
`config_handler_class` varchar(50) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
`is_system` tinyint(1) NOT NULL,
`options` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
PRIMARY KEY (`id`),
UNIQUE KEY `name` (`name`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_invoices` (
`object_id` int(10) unsigned NOT NULL,
`invoice_notebook_id` INT( 10 ) UNSIGNED NOT NULL,
`invoice_number` varchar(50) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
`series` varchar(5) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
`date` date NOT NULL,
`expiration_date` date NOT NULL,
`final_consumer` tinyint(1) NOT NULL,
`currency_id` int(10) NOT NULL DEFAULT '0',
`subtotal` DECIMAL(20,3) NOT NULL,
`total` DECIMAL(20,3) NOT NULL,
`paid_amount` DECIMAL(20,3) NOT NULL,
`due_amount` DECIMAL(20,3) NOT NULL,
`customer_id` int(10) unsigned NOT NULL,
`customer_name` text COLLATE utf8_unicode_ci NOT NULL,
`customer_address` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
`customer_city` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
`customer_state` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
`customer_country` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
`customer_zipcode` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
`customer_email` varchar(500) COLLATE utf8_unicode_ci NOT NULL,
`customer_phone` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
`customer_rut` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
`customer_number` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
`status` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
`repeat_end` date NOT NULL,
`repeat_forever` tinyint(1) NOT NULL,
`repeat_num` int(10) unsigned NOT NULL,
`repeat_d` int(10) unsigned NOT NULL,
`repeat_m` int(10) unsigned NOT NULL,
`repeat_y` int(10) unsigned NOT NULL,
`repeat_h` int(10) unsigned NOT NULL,
`repeat_dow` int(10) unsigned NOT NULL,
`repeat_wnum` int(10) unsigned NOT NULL,
`repeat_mjump` int(10) unsigned NOT NULL,
`from_invoice_id` int(10) unsigned NOT NULL,
`additional_information` text COLLATE utf8_unicode_ci NOT NULL,
`invoice_preview_file_id` int(10) unsigned NOT NULL DEFAULT 0,
`sent_invoice_mail_id` int(10) unsigned NOT NULL DEFAULT 0,
`ordered_by_id` int(10) unsigned NOT NULL DEFAULT 0,
`sent` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
`attn` varchar(255) COLLATE utf8_unicode_ci NULL DEFAULT '',
PRIMARY KEY (`object_id`),
KEY `date` (`date`),
KEY `series_invoice_number` (`series`,`invoice_number`),
KEY `invoice_number` (`invoice_number`),
KEY `total` (`total`),
KEY `status` (`status`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_invoice_lines` (
`id` int(10) unsigned NOT NULL AUTO_INCREMENT,
`object_id` int(10) unsigned NOT NULL,
`amount` DECIMAL(20,3) unsigned NOT NULL,
`currency_id` int(10) NOT NULL DEFAULT '0',
`unit_value` DECIMAL(20,3) NOT NULL,
`total` DECIMAL(20,3) NOT NULL,
`subtotal` DECIMAL(20,3) NOT NULL,
`taxes` DECIMAL(20,3) NOT NULL,
`detail` text COLLATE utf8_unicode_ci NOT NULL,
`exchange_rate` DECIMAL(20,10) NOT NULL DEFAULT '1',
`rel_object_id` int(10) NOT NULL DEFAULT '0',
`user_id` int(10) NOT NULL DEFAULT '0',
`category_id` int(10) NOT NULL DEFAULT '0',
`date` DATE NOT NULL,
`from_object_type_id` int(10) NOT NULL DEFAULT '0',
`product_type_id` int(10) NOT NULL DEFAULT '0',
`member_id` int(10) NOT NULL DEFAULT '0',
`group_by_category_id` int(10) NOT NULL DEFAULT '0',
`unit_cost` DECIMAL(20,3) unsigned NOT NULL DEFAULT '0',
`price_multiplier` DECIMAL(20,3) unsigned NOT NULL DEFAULT '0',
`order` int(10),
`item_type_id` int(10) NOT NULL DEFAULT '0',
`discount_percent_value` decimal(20,3) DEFAULT '0',
`discount_percent_type` int(1) DEFAULT '0',
PRIMARY KEY (`id`),
KEY `object_id` (`object_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_invoice_references` (
`id` int(10) unsigned NOT NULL AUTO_INCREMENT,
`object_id` int(10) unsigned NOT NULL,
`serie` VARCHAR(100) NOT NULL,
`invoice_number` int(10) unsigned NOT NULL,
`referenced_object_id` int(10) unsigned NOT NULL,
`detail` text COLLATE utf8_unicode_ci NOT NULL,
`amount` DECIMAL(20,3) unsigned NOT NULL DEFAULT 0,
PRIMARY KEY (`id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_invoice_taxes` (
`invoice_id` int(10) NOT NULL,
`tax_id` int(10) NOT NULL,
`type` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
`value` float NOT NULL,
`fixed_value` float NOT NULL,
PRIMARY KEY (`invoice_id`,`tax_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_taxes` (
`id` int(10) unsigned NOT NULL AUTO_INCREMENT,
`name` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
`select_default` tinyint(1) NOT NULL,
`code` varchar(255) <?php echo $default_collation ?> NOT NULL,
`is_special` BOOLEAN NOT NULL default '0',
`removed_on` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
`removed_by_id` INT( 10 ) UNSIGNED NOT NULL DEFAULT '0',
PRIMARY KEY (`id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_tax_records` (
`id` int(10) unsigned NOT NULL AUTO_INCREMENT,
`tax_id` int(10) unsigned NOT NULL,
`type` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
`value` float NOT NULL,
`date` date NOT NULL,
`removed_on` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
`removed_by_id` INT( 10 ) UNSIGNED NOT NULL DEFAULT '0',
PRIMARY KEY (`id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?> ;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_invoice_types` (
`id` INT( 10 ) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
`name` VARCHAR( 100 ) NOT NULL ,
`select_default` TINYINT( 1 ) NULL,
`removed_on` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
`removed_by_id` INT( 10 ) UNSIGNED NOT NULL DEFAULT '0'
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_copies` (
`id` INT( 10 ) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
`name` VARCHAR( 100 ) NOT NULL ,
`description` TEXT NULL ,
`color` VARCHAR( 100 ) NULL ,
`select_default` TINYINT( 1 ) NULL,
`removed_on` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
`removed_by_id` INT( 10 ) UNSIGNED NOT NULL DEFAULT '0'
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_invoice_notebooks` (
`id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
`invoice_type_id` INT(10) UNSIGNED NOT NULL,
`rut` VARCHAR(100) NULL,
`expiration_date` DATE NOT NULL,
`series` VARCHAR(100) NOT NULL,
`initial_number` INT(10) NOT NULL,
`final_number` INT(10) NOT NULL,
`address` VARCHAR(255) NULL,
`extra_information` TEXT NULL,
`press_information` TEXT NULL,
`exhausted` TINYINT( 1 ) NULL DEFAULT '0',
`removed_on` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
`removed_by_id` INT( 10 ) UNSIGNED NOT NULL DEFAULT '0'
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_invoice_copies` (
`invoice_id` int(10) NOT NULL,
`copy_id` int(10) NOT NULL,
PRIMARY KEY (`invoice_id`,`copy_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_invoice_templates` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `is_default` tinyint(1) NOT NULL DEFAULT '0',
  `group_by` varchar(100) NOT NULL DEFAULT '',
  `include_date` tinyint(1) NOT NULL DEFAULT '0',
  `include_user_name` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `include_labor_category` tinyint(1) NOT NULL DEFAULT '0',
  `include_description` tinyint(1) NOT NULL DEFAULT '0',
  `exp_group_by` varchar(100) NOT NULL DEFAULT '',
  `display_cost_or_price` varchar(100) NOT NULL DEFAULT 'price',
  `include_paid_by` tinyint(1) NOT NULL DEFAULT '0',
  `include_product_type` tinyint(1) NOT NULL DEFAULT '0',
  `include_expense_category` tinyint(1) NOT NULL DEFAULT '0',
  `template_type` varchar(100) NOT NULL DEFAULT 'detailed',
  `show_taxes_for_each_line` tinyint(1) NOT NULL DEFAULT '0',
  `show_headers_before_details` tinyint(1) NOT NULL DEFAULT '0',
  `include_exp_date` tinyint(1) NOT NULL DEFAULT '0',
  `include_expense_name` tinyint(1) NOT NULL DEFAULT '0',
  `include_expense_description` tinyint(1) NOT NULL DEFAULT '0',
  `include_account_summary` tinyint(1) DEFAULT '0',
  `include_project_location` tinyint(1) NOT NULL DEFAULT '0',
  `break_down_by_subprojects` varchar(100) NOT NULL DEFAULT 'NO',
  `footer_text` varchar(2024) NOT NULL DEFAULT '',
  `break_down_expenses_by_category` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'no',
  `show_expenses_markup_separated` tinyint(1) NOT NULL DEFAULT '0',
  `accumulate_discounts` varchar(100) NOT NULL DEFAULT 'between_line_items',
  `include_project_name` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `include_project_description` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `include_lump_sum_project_number` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `include_lump_sum_project_name` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `include_lump_sum_from_to` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `include_lump_sum_date` varchar(100) NOT NULL DEFAULT '',
  `include_lump_sum_quantity` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `include_lump_sum_budget_completion` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `include_expense_project_number` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `include_expense_project_name` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `include_time_line_date` varchar(100) NOT NULL DEFAULT 'Item date',
  `include_exp_type_date` varchar(100) NOT NULL DEFAULT 'Item date',
  `include_lump_sum_date_col` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `include_lump_sum_unit_price` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `include_lump_sum_project_type` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `category_for_lump_sum` int(10) NOT NULL DEFAULT '0',
  `product_type_for_lump_sum` int(10) NOT NULL DEFAULT '0',
  `category_for_lump_sum_col` tinyint(1) NOT NULL DEFAULT '0',
  `product_type_for_lump_sum_col` tinyint(1) NOT NULL DEFAULT '0',
  `category_for_timeslot` int(10) NOT NULL DEFAULT '0',
  `product_type_for_timeslot` int(10) NOT NULL DEFAULT '0',
  `category_for_timeslot_col` tinyint(1) NOT NULL DEFAULT '0',
  `product_type_for_timeslot_col` tinyint(1) NOT NULL DEFAULT '0',
  `category_for_expenses` int(10) NOT NULL DEFAULT '0',
  `product_type_for_expenses` int(10) NOT NULL DEFAULT '0',
  `category_for_expenses_col` tinyint(1) NOT NULL DEFAULT '0',
  `product_type_for_expenses_col` tinyint(1) NOT NULL DEFAULT '0',
  `include_paid_by_col` tinyint(1) NOT NULL DEFAULT '0',
  `include_lump_sum_deetail_col` tinyint(1) NOT NULL DEFAULT '0',
  `include_exp_description` tinyint(1) NOT NULL DEFAULT '0',
  `include_exp_user_name_col` varchar(100) NOT NULL DEFAULT 'Do not display',
  `include_detail` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `include_user_name_col` varchar(100) NOT NULL DEFAULT 'Do not display',
  `include_task_name` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `include_hours` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `include_rate` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `include_custom_description` varchar(100) NOT NULL DEFAULT '',
  `include_time_entry_description` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `include_total` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `include_exp_quantity` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `include_exp_amount` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `include_exp_fee` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `include_exp_total` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `invoice_template_assigned` varchar(100) NOT NULL DEFAULT 'original',
  `custom_label_include_date` varchar(100) NOT NULL DEFAULT 'date',
  `custom_label_include_user_name_col` varchar(100) NOT NULL DEFAULT 'person name',
  `custom_label_category_for_timeslot_col` varchar(100) NOT NULL DEFAULT 'labor category',
  `custom_label_include_description` varchar(100) NOT NULL DEFAULT 'detail',
  `custom_label_include_hours` varchar(100) NOT NULL DEFAULT 'hours',
  `custom_label_include_rate` varchar(100) NOT NULL DEFAULT 'rate',
  `custom_label_include_total` varchar(100) NOT NULL DEFAULT 'total',
  `custom_label_include_exp_date` varchar(100) NOT NULL DEFAULT 'date',
  `custom_label_include_paid_by_col` varchar(100) NOT NULL DEFAULT 'paid by',
  `custom_label_include_exp_user_name_col` varchar(100) NOT NULL DEFAULT 'person name',
  `custom_label_category_for_expenses_col` varchar(100) NOT NULL DEFAULT 'expense category',
  `custom_label_product_type_for_expenses_col` varchar(100) NOT NULL DEFAULT 'product type',
  `custom_label_include_exp_description` varchar(100) NOT NULL DEFAULT 'detail',
  `custom_label_include_exp_quantity` varchar(100) NOT NULL DEFAULT 'quantity',
  `custom_label_include_exp_amount` varchar(100) NOT NULL DEFAULT 'unit value',
  `custom_label_include_exp_fee` varchar(100) NOT NULL DEFAULT 'Markup %',
  `custom_label_include_exp_total` varchar(100) NOT NULL DEFAULT 'total',
  `custom_label_include_lump_sum_date_col` varchar(100) NOT NULL DEFAULT 'Date',
  `custom_label_category_for_lump_sum_col` varchar(100) NOT NULL DEFAULT 'Category',
  `custom_label_product_type_for_lump_sum_col` varchar(100) NOT NULL DEFAULT 'Product type',
  `custom_label_include_lump_sum_deetail_col` varchar(100) NOT NULL DEFAULT 'Detail',
  `custom_label_include_lump_sum_quantity` varchar(100) NOT NULL DEFAULT 'Quantity',
  `custom_label_include_lump_sum_unit_price` varchar(100) NOT NULL DEFAULT 'total',
  `template_language_assigned` varchar(100) NOT NULL DEFAULT '',
  `task_all_expenses_includes` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `task_group` varchar(100) NOT NULL DEFAULT 'aggregated into a single line',
  `task_custom_detail` varchar(100) NOT NULL DEFAULT '',
  `labor_detail_separator_value` varchar(100) NOT NULL DEFAULT '',
  `expense_detail_separator_value` varchar(100) NOT NULL DEFAULT '',
  `tasks_detail_separator_value` varchar(100) NOT NULL DEFAULT '',
  `lump_sum_detail_separator_value` varchar(100) NOT NULL DEFAULT '',
  `task_allow_billing_per_percent` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `task_invoice_billing_type` varchar(100) NOT NULL DEFAULT 'Invoice difference only',
  `include_exp_unit_cost` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `custom_label_include_exp_include_exp_unit_cost` varchar(100) NOT NULL DEFAULT 'Unit cost',
  `expense_detail_vendor_name` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `expense_detail_bill_no` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `include_expense_task_name` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `include_exp_markup_amount` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `custom_label_include_exp_markup_amount` varchar(100) NOT NULL DEFAULT 'Markup $',
  `date_format` varchar(50) NOT NULL DEFAULT '',
  `include_additional_info_in_footer` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_invoice_template_options` (
  `template_id` int(10) unsigned NOT NULL,
  `group_option` varchar(200) COLLATE utf8_unicode_ci NOT NULL,
  `name` varchar(200) COLLATE utf8_unicode_ci NOT NULL,
  `label` varchar(200) COLLATE utf8_unicode_ci NOT NULL,
  `order_number` int(10) unsigned NOT NULL DEFAULT '0',
  `visible` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `selected_option` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`template_id`,`name`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_invoice_line_taxes` (
`invoice_line_id` int(10) NOT NULL,
`tax_id` int(10) NOT NULL,
`value` DECIMAL(20,3) NOT NULL,
`applied_value` DECIMAL(20,3) NOT NULL,
PRIMARY KEY (`invoice_line_id`,`tax_id`),
KEY `tax_id` (`tax_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_invoice_layouts` (
`id` int(10) unsigned NOT NULL AUTO_INCREMENT,
`code` VARCHAR(100) NOT NULL default '',
`name` VARCHAR(100) NOT NULL default '',
`enabled` tinyint(1) unsigned NOT NULL default 1,
`is_system` tinyint(1) unsigned NOT NULL default 0,
`content` text COLLATE utf8_unicode_ci NOT NULL,
PRIMARY KEY (`id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

