<?php

function income_update_1_2()
{
    DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_taxes`
				 MODIFY COLUMN `removed_on` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
				 MODIFY COLUMN `removed_by_id` INTEGER UNSIGNED NOT NULL DEFAULT 0;
		");
    DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_tax_records`
				 MODIFY COLUMN `removed_on` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
				 MODIFY COLUMN `removed_by_id` INTEGER UNSIGNED NOT NULL DEFAULT 0;
		");
    DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_invoice_types`
				 MODIFY COLUMN `removed_on` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
				 MODIFY COLUMN `removed_by_id` INTEGER UNSIGNED NOT NULL DEFAULT 0;
		");
    DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_copies`
				 MODIFY COLUMN `removed_on` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
				 MODIFY COLUMN `removed_by_id` INTEGER UNSIGNED NOT NULL DEFAULT 0;
		");
    DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_invoice_notebooks`
				 MODIFY COLUMN `removed_on` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
				 MODIFY COLUMN `removed_by_id` INTEGER UNSIGNED NOT NULL DEFAULT 0;
		");
}


function income_update_2_3()
{
    DB::executeAll("INSERT INTO " . TABLE_PREFIX . "max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
			 SELECT rtp.role_id, (SELECT `id` FROM `" . TABLE_PREFIX . "object_types` WHERE `name`='invoice'), can_delete, can_write
			 FROM " . TABLE_PREFIX . "max_role_object_type_permissions rtp WHERE rtp.object_type_id=(SELECT `id` FROM `" . TABLE_PREFIX . "object_types` WHERE `name`='task')
			ON DUPLICATE KEY UPDATE " . TABLE_PREFIX . "max_role_object_type_permissions.role_id=" . TABLE_PREFIX . "max_role_object_type_permissions.role_id;");
}

function income_update_3_4()
{
    DB::executeAll("
				DELETE FROM " . TABLE_PREFIX . "max_role_object_type_permissions 
				WHERE object_type_id IN (
					 SELECT o.id
					 FROM `" . TABLE_PREFIX . "object_types` o 
					 WHERE o.`name` IN ('invoice')				
				 );
		");
    DB::executeAll("
				 INSERT INTO " . TABLE_PREFIX . "max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
				 SELECT p.id, o.id, 1, 1
				 FROM `" . TABLE_PREFIX . "object_types` o JOIN `" . TABLE_PREFIX . "permission_groups` p
				 WHERE o.`name` IN ('invoice')
				 AND p.`name` IN ('Super Administrator','Administrator','Manager');
		");
    DB::executeAll("
				INSERT INTO " . TABLE_PREFIX . "max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
				 SELECT p.id, o.id, 0, 1
				 FROM `" . TABLE_PREFIX . "object_types` o JOIN `" . TABLE_PREFIX . "permission_groups` p
				 WHERE o.`name` IN ('invoice')
				 AND p.`name` IN ('Executive');
		");
    DB::executeAll("
				INSERT INTO " . TABLE_PREFIX . "max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
				 SELECT p.id, o.id, 0, 0
				 FROM `" . TABLE_PREFIX . "object_types` o JOIN `" . TABLE_PREFIX . "permission_groups` p
				 WHERE o.`name` IN ('invoice')
				 AND p.`name` IN ('Collaborator Customer','Internal Collaborator','External Collaborator','Guest Customer');
		");
    DB::executeAll("
				DELETE FROM " . TABLE_PREFIX . "role_object_type_permissions
				WHERE object_type_id IN (
					SELECT o.id
					FROM `" . TABLE_PREFIX . "object_types` o
					WHERE o.`name` IN ('invoice')
				);
		");
    DB::executeAll("
				INSERT INTO " . TABLE_PREFIX . "role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
				 SELECT p.id, o.id, 1, 1
				 FROM `" . TABLE_PREFIX . "object_types` o JOIN `" . TABLE_PREFIX . "permission_groups` p
				 WHERE o.`name` IN ('invoice')
				 AND p.`name` IN ('Super Administrator','Administrator');
		");
    DB::executeAll("
				INSERT INTO " . TABLE_PREFIX . "role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
				 SELECT p.id, o.id, 0, 1
				 FROM `" . TABLE_PREFIX . "object_types` o JOIN `" . TABLE_PREFIX . "permission_groups` p
				 WHERE o.`name` IN ('invoice')
				 AND p.`name` IN ('Manager','Executive');
		");

    DB::executeAll("
				UPDATE `" . TABLE_PREFIX . "max_system_permissions` SET `can_edit_confirmed_invoices`=0, `can_manage_invoicing_configuration`=0 WHERE `permission_group_id` IN (
					SELECT id FROM `" . TABLE_PREFIX . "permission_groups` WHERE `type`='roles' AND `name` IN ('Executive')
				);
		");


}


function income_update_4_5()
{

    if (Plugins::instance()->isActivePlugin('member_custom_properties')) {
        Env::useHelper('functions', 'crpm');

        // define custom properties for customers
        if (!check_member_custom_prop_exists(TABLE_PREFIX, 'company_id', 'customer')) {
            DB::execute("
					INSERT INTO " . TABLE_PREFIX . "member_custom_properties (object_type_id, name, code, `type`, `values`, `visible_by_default`) VALUES
					((SELECT id FROM " . TABLE_PREFIX . "object_types WHERE name='customer'), 'Company ID', 'company_id', 'text', '', 1),
					((SELECT id FROM " . TABLE_PREFIX . "object_types WHERE name='customer'), 'Legal name', 'legal_name', 'text', '', 1);
				");

            $id_rows = MemberCustomProperties::instance()->findAll(array('id' => true, 'conditions' => "object_type_id=(SELECT id FROM " . TABLE_PREFIX . "object_types WHERE name='customer') AND code='company_id'"));
            $ci_cp = array_var($id_rows, 0);
            $id_rows = MemberCustomProperties::instance()->findAll(array('id' => true, 'conditions' => "object_type_id=(SELECT id FROM " . TABLE_PREFIX . "object_types WHERE name='customer') AND code='legal_name'"));
            $ln_cp = array_var($id_rows, 0);

            $all_customers = Members::instance()->findAll(array('conditions' => "object_type_id=(SELECT id FROM " . TABLE_PREFIX . "object_types WHERE name='customer')"));
            foreach ($all_customers as $customer_member) {
                $member_id = $customer_member->getId();
                $customer_id = $customer_member->getObjectId();
                $c = Customers::instance()->findById($customer_id);
                if ($c instanceof Customer) {

                    if (trim($c->getCustomerRut()) != '') {
                        $sql = "INSERT INTO " . TABLE_PREFIX . "member_custom_property_values (member_id, custom_property_id, `value`) VALUES
							('$member_id', '$ci_cp', '" . trim($c->getCustomerRut()) . "');";

                        DB::execute($sql);
                    }

                    if (trim($c->getCustomerName()) != '') {
                        $sql = "INSERT INTO " . TABLE_PREFIX . "member_custom_property_values (member_id, custom_property_id, `value`) VALUES
							('$member_id', '$ln_cp', '" . trim($c->getCustomerName()) . "');";

                        DB::execute($sql);
                    }
                }
            }
        }
    }
}


function income_update_5_6()
{

    if (!check_column_exists(TABLE_PREFIX . "timeslots", "invoicing_status")) {
        DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "timeslots`
				 ADD COLUMN `invoicing_status` VARCHAR(50) NOT NULL DEFAULT 'pending',
 				 ADD COLUMN `invoice_id` INTEGER UNSIGNED NOT NULL DEFAULT 0;
			");

        DB::execute("
				INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`) VALUES
					('generate_one_inv_line_per_timeslot', '0', 'BoolConfigHandler', 1)
				ON DUPLICATE KEY UPDATE name=name;
			");

        DB::execute("
				INSERT INTO `" . TABLE_PREFIX . "contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES 
				('task panel', 'tasksShowInvoicingStatus', '1', 'BoolConfigHandler', 1, 0, '');
			");
    }
}

function income_update_6_7()
{

    $p_controller = new PluginController();
    $p_controller->ensure_installed_and_activated('multiple_currencies');
    $p_controller->ensure_installed_and_activated('object_subtypes');

    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "currency_id")) {
        DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_invoices` ADD `currency_id` int(10) NOT NULL DEFAULT 0 AFTER `final_consumer`;
			");
        DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_invoice_lines` ADD `currency_id` int(10) NOT NULL DEFAULT 0 AFTER `object_id`;
			");
        DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_invoice_lines` ADD `exchange_rate` int(10) NOT NULL DEFAULT 1;
			");
        DB::execute("
				UPDATE `" . TABLE_PREFIX . "income_invoices` SET `currency_id`=(SELECT id FROM " . TABLE_PREFIX . "currencies LIMIT 1);
			");
        DB::execute("
				UPDATE `" . TABLE_PREFIX . "income_invoice_lines` SET `currency_id`=(SELECT id FROM " . TABLE_PREFIX . "currencies LIMIT 1);
			");
        DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_invoice_lines`
					CHANGE `unit_value` `unit_value` decimal(20,3) NOT NULL,
					CHANGE `total` `total` decimal(20,3) NOT NULL;
			");
        DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_invoices`
					CHANGE `subtotal` `subtotal` decimal(20,3) NOT NULL,
					CHANGE `total` `total` decimal(20,3) NOT NULL;
			");
    }


    if (!check_column_exists(TABLE_PREFIX . "income_taxes", "code")) {
        DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_taxes`
				 ADD COLUMN `code` VARCHAR(255) COLLATE 'utf8_unicode_ci' NOT NULL;
			");
    }

    if (!check_column_exists(TABLE_PREFIX . "income_taxes", "is_special")) {
        DB::execute("
						ALTER TABLE `" . TABLE_PREFIX . "income_taxes`
						 ADD COLUMN `is_special` BOOLEAN NOT NULL DEFAULT 0;
					");
    }

    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "expiration_date")) {
        DB::execute("
						ALTER TABLE `" . TABLE_PREFIX . "income_invoices`
						 ADD COLUMN `expiration_date` date NOT NULL;
					");
    }

    DB::execute("
				INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`) VALUES
				('owner_company_id', '', 'StringConfigHandler', 0)
				ON DUPLICATE KEY UPDATE name = name;
			");

    DB::execute("
				INSERT INTO `" . TABLE_PREFIX . "object_subtypes` (`object_type_id`, `name`, `sum_in_total`, `code`, `is_special`) VALUES
				((SELECT id FROM `" . TABLE_PREFIX . "object_types` WHERE name = 'invoice'),'invoice', 1, 'invoice', 1),
				((SELECT id FROM `" . TABLE_PREFIX . "object_types` WHERE name = 'invoice'),'credit note', 0, 'credit_note', 1)
				ON DUPLICATE KEY UPDATE name = name;
			");

    if (check_column_exists(TABLE_PREFIX . "income_invoices", "invoice_type_id")) {
        DB::execute("
						ALTER TABLE `" . TABLE_PREFIX . "income_invoices`
						 DROP `invoice_type_id`;
					");
    }
    if (check_column_exists(TABLE_PREFIX . "income_invoices", "invoice_type")) {
        DB::execute("
						ALTER TABLE `" . TABLE_PREFIX . "income_invoices`
						 DROP `invoice_type`;
					");
    }

    DB::execute("
			UPDATE " . TABLE_PREFIX . "objects 
			SET object_subtype_id=(SELECT id FROM " . TABLE_PREFIX . "object_subtypes WHERE code='invoice')
			WHERE object_type_id=(SELECT id FROM " . TABLE_PREFIX . "object_types WHERE name='invoice');
		");

    DB::execute("
			UPDATE " . TABLE_PREFIX . "income_invoice_notebooks
			SET invoice_type_id=(SELECT id FROM " . TABLE_PREFIX . "object_subtypes WHERE code='invoice');
		");

    DB::execute("
				CREATE TABLE IF NOT EXISTS `" . TABLE_PREFIX . "income_invoice_references` (
				`id` int(10) unsigned NOT NULL AUTO_INCREMENT,
				`object_id` int(10) unsigned NOT NULL,
				`serie` VARCHAR(100) NOT NULL,
				`invoice_number` int(10) unsigned NOT NULL,
				`referenced_object_id` int(10) unsigned NOT NULL,
				`detail` text COLLATE utf8_unicode_ci NOT NULL,
				PRIMARY KEY (`id`)
				) ENGINE=InnoDB;
		");
}


function income_update_7_8()
{
    DB::execute("
				INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`) VALUES
				('allow_multiline_line_desc', '0', 'BoolConfigHandler', 1);
		");
}


function income_update_8_9()
{

    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "customer_city")) {
        DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_invoices` 
				ADD COLUMN `customer_city` VARCHAR(100) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '' AFTER `customer_address`;
			");
    }

    DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`) VALUES
				('mandatory_customer_address', '0', 'BoolConfigHandler', 1),
				('mandatory_customer_city', '0', 'BoolConfigHandler', 1);
		");

    $pending_invoices = IncomeInvoices::instance()->findAll(array('conditions' => "`status`='pending'"));
    $cli_ot = ObjectTypes::findByName('customer')->getId();

    foreach ($pending_invoices as $inv) {
        if ($inv->getCustomerCity() == "") {
            $customer_member = null;
            $members = $inv->getMembers();
            foreach ($members as $m) {
                if ($m instanceof Member && $m->getObjectTypeId() == $cli_ot) {
                    $customer_member = $m;
                    break;
                }
            }
            if ($customer_member instanceof Member) {
                $customer = Customers::instance()->findById($customer_member->getObjectId());
                if ($customer instanceof Customer) {
                    $customer_city = "";
                    $contact = $customer->getContact();
                    if ($contact instanceof Contact) {
                        $address_obj = $contact->getAddress('work');
                        if ($address_obj instanceof ContactAddress) {
                            $customer_city = $address_obj->getCity();
                        }
                    }
                }
                if ($customer_city != "") {
                    $inv->setCustomerCity($customer_city);
                    $inv->save();
                }
            }
        }
    }
}


function income_update_9_10()
{
    DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`) VALUES
				('mandatory_customer_rut', '0', 'BoolConfigHandler', 1);
		");
}

function income_update_10_11()
{
    DB::execute("
                    INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`) VALUES
                    ('generate_next_invoice_repetition_on_print', '0', 'BoolConfigHandler', 1);
            ");

    DB::execute("
                    INSERT INTO `" . TABLE_PREFIX . "custom_properties` (`object_type_id`,`name`,`code`,`type`,`description`,`values`,`default_value`,`is_required`,`is_multiple_values`,`property_order`,`visible_by_default`, `is_special`, `is_disabled`, `object_subtype_id`) VALUES
                    ((SELECT object_type_id FROM " . TABLE_PREFIX . "object_subtypes WHERE code='invoice'),'Payment Period','invoice_payment_period','list','','Due on receipt,Net D','',1,0,1,1, 1,0,(SELECT id FROM " . TABLE_PREFIX . "object_subtypes WHERE code='invoice'))
                    ON DUPLICATE KEY UPDATE object_type_id=object_type_id;
            ");
}

function income_update_11_12()
{
    DB::execute("
    		INSERT INTO `" . TABLE_PREFIX . "dimension_content_object_options` (`dimension_id`,`content_object_type_id`,`option`,`value`) 
				SELECT d.id, ot.id, 'hide_member_selector_in_forms', '0'
				FROM " . TABLE_PREFIX . "dimensions d LEFT JOIN " . TABLE_PREFIX . "object_types ot ON true
				WHERE ot.name IN ('invoice')
			ON DUPLICATE KEY UPDATE `value`=`value`;
    	");
}

function income_update_12_13()
{
    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "invoice_preview_file_id")) {
        DB::execute("
	    		ALTER TABLE `" . TABLE_PREFIX . "income_invoices`
				ADD `invoice_preview_file_id` int(10) unsigned NOT NULL DEFAULT 0;
	    	");
    }
    if (!check_column_exists(TABLE_PREFIX . "income_config_options", "options")) {
        DB::execute("
	    		ALTER TABLE `" . TABLE_PREFIX . "income_config_options`
				ADD `options` varchar(255) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '';
	    	");
    }
    DB::execute("
    		INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
			('enabled_invoices_status', 'printed', 'MultipleListConfigHandler', 1, 'printed');
    	");
    DB::execute("
    		INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
			('allow_invoice_flexible_status_change', '0', 'BoolConfigHandler', 1, '');
    	");
}

function income_update_13_14()
{
    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "sent_invoice_mail_id")) {
        DB::execute("
	    		ALTER TABLE `" . TABLE_PREFIX . "income_invoices`
				ADD `sent_invoice_mail_id` int(10) unsigned NOT NULL DEFAULT 0;
	    	");
    }
}

function income_update_14_15()
{

    DB::execute("
    		INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
			('mandatory_customer', '1', 'BoolConfigHandler', 1, '');
    	");
}

function income_update_15_16()
{
    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "ordered_by_id")) {
        DB::execute("
	    		ALTER TABLE `" . TABLE_PREFIX . "income_invoices` 
	    		ADD `ordered_by_id` int(10) unsigned NOT NULL DEFAULT 0;
	    	");
    }
}

function income_update_16_17()
{
    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "external_transaction_id")) {
        DB::execute("
	    		ALTER TABLE `" . TABLE_PREFIX . "income_invoices`
			    ADD `payment_method` varchar(255) COLLATE 'utf8_unicode_ci' NOT NULL,
			    ADD `external_transaction_id` varchar(255) COLLATE 'utf8_unicode_ci' NOT NULL AFTER `payment_method`;
	    	");
    }
}

function income_update_17_18()
{
    DB::execute("INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
                ('invoice_payment_url', '', 'StringConfigHandler', 1, '')");
}

function income_update_18_19()
{
    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "customer_state")) {
        DB::execute(
            "ALTER TABLE `" . TABLE_PREFIX . "income_invoices` 
	    		ADD `customer_state` varchar(100) COLLATE utf8_unicode_ci NOT NULL
	    		;"
        );
    }
    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "customer_country")) {
        DB::execute(
            "ALTER TABLE `" . TABLE_PREFIX . "income_invoices` 
	    		ADD `customer_country` varchar(100) COLLATE utf8_unicode_ci NOT NULL
	    		;"
        );
    }
    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "customer_zipcode")) {
        DB::execute(
            "ALTER TABLE `" . TABLE_PREFIX . "income_invoices`
            ADD `customer_zipcode` varchar(100) COLLATE utf8_unicode_ci NOT NULL
	    		;"
        );
    }
    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "customer_email")) {
        DB::execute(
            "ALTER TABLE `" . TABLE_PREFIX . "income_invoices` 
	    		ADD `customer_email` varchar(100) COLLATE utf8_unicode_ci NOT NULL
	    		;"
        );
    }
    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "customer_phone")) {
        DB::execute(
            "ALTER TABLE `" . TABLE_PREFIX . "income_invoices` 
	    		ADD `customer_phone` varchar(100) COLLATE utf8_unicode_ci NOT NULL
	    		;"
        );
    }
    $result = DB::executeOne("
    	SELECT * FROM `" . TABLE_PREFIX . "custom_properties` 
    	WHERE name like 'Representative'
    	AND object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer')
    ");
    if(!is_null($result)){
        DB::execute("
        	UPDATE `" . TABLE_PREFIX . "custom_properties` set code = 'representative' WHERE id = '{$result['id']}';
        ");
    } else {
	    DB::execute("
	    	INSERT INTO `" . TABLE_PREFIX . "custom_properties` (`object_type_id`,`name`,`type`,`is_required`,`is_multiple_values`,`property_order`,`visible_by_default`,`code`) VALUES 
	    	((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer'),'Representative','contact',0,0,10,0,'representative');
	    ");
    }
}

function income_update_19_20()
{
	if (!check_column_exists(TABLE_PREFIX . "income_invoices", "external_transaction_desc")) {
		DB::execute("
	    		ALTER TABLE `" . TABLE_PREFIX . "income_invoices`
			    ADD `external_transaction_desc` TEXT COLLATE 'utf8_unicode_ci' NOT NULL;
	    	");
	}
}


function income_update_20_21()
{
	Env::useHelper('functions', 'income');
	$printed_enabled = is_invoice_status_available("printed");
	$val = $printed_enabled ? "1" : "0";
	
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='assign_number_when_printing'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
			('assign_number_when_printing', '$val', 'BoolConfigHandler', 1, '');
	    ");
	}
}


function income_update_21_22()
{
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='send_invoice_default_mail_account'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
			('send_invoice_default_mail_account', '0', 'MailAccountConfigHandler', 1, '');
	    ");
	}
	
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='send_invoice_bcc'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
			('send_invoice_bcc', '', 'StringConfigHandler', 1, '');
	    ");
	}
}

function income_update_22_23() {
	// add column to indicate if invoice has been sent
	if (!check_column_exists(TABLE_PREFIX . "income_invoices", "sent")) {
		DB::execute("
    		ALTER TABLE `" . TABLE_PREFIX . "income_invoices`
			ADD `sent` tinyint(1) unsigned NOT NULL DEFAULT 0;
    	");
	}
	// remove sent status from invoices
	DB::execute("UPDATE " . TABLE_PREFIX . "income_invoices SET sent='1' WHERE status IN ('sent') OR sent_invoice_mail_id>0;");
	// remove sent status from invoices
	DB::execute("UPDATE " . TABLE_PREFIX . "income_invoices SET status='pending' WHERE status='sent';");
	
	// update config option
	DB::execute("
		UPDATE `" . TABLE_PREFIX . "income_config_options` SET `options`='printed'
		WHERE `name`='enabled_invoices_status';
	");
}

/**
 * Migrate payment_method, external_transaction_id and external_transaction_desc to custom properties
 */
function income_update_23_24() {
	// 7custom properties
	DB::execute("
    	INSERT INTO `" . TABLE_PREFIX . "custom_properties` (`object_type_id`,`name`,`code`,`type`,`values`,`is_required`,`is_multiple_values`,`property_order`,`visible_by_default`,`is_special`) VALUES
    	((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='invoice'), 'Payment type', 'payment_method', 'list', ',check,money_order,cash,credit_card,other', 0,0,10,1,1),
		((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='invoice'), 'Check/Mo/Other #', 'external_transaction_id', 'text', '',0,0,10,1,1),
		((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='invoice'), 'Comments on Payment type', 'external_transaction_desc', 'memo', '',0,0,10,1,1);
    ");
	
	// migrate payment_method
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."custom_property_values (`object_id`, `custom_property_id`, `value`)
		SELECT i.object_id,
			(SELECT id FROM ".TABLE_PREFIX."custom_properties WHERE code='payment_method' AND object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='invoice')),
			i.payment_method
		FROM ".TABLE_PREFIX."income_invoices i
		WHERE i.payment_method != '';
	");
	
	// migrate external_transaction_id
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."custom_property_values (`object_id`, `custom_property_id`, `value`)
		SELECT i.object_id,
			(SELECT id FROM ".TABLE_PREFIX."custom_properties WHERE code='external_transaction_id' AND object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='invoice')),
			i.external_transaction_id
		FROM ".TABLE_PREFIX."income_invoices i
		WHERE i.external_transaction_id != '';
	");
	
	// migrate external_transaction_desc
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."custom_property_values (`object_id`, `custom_property_id`, `value`)
		SELECT i.object_id,
			(SELECT id FROM ".TABLE_PREFIX."custom_properties WHERE code='external_transaction_desc' AND object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='invoice')),
			i.external_transaction_desc
		FROM ".TABLE_PREFIX."income_invoices i
		WHERE i.external_transaction_desc != '';
	");
	
	if (Plugins::instance()->isActivePlugin('advanced_core')) {
		Env::useHelper('functions', 'advanced_core');
		fill_property_groups_default_data();
	}
}


function income_update_24_25() {
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."income_invoices`
		CHANGE `sent` `sent` varchar(255) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '';
	");

	DB::execute("
		UPDATE `".TABLE_PREFIX."income_invoices` SET `sent`='invoice_sent' WHERE `sent`='1' AND status='pending';
	");
	
	DB::execute("
		UPDATE `".TABLE_PREFIX."income_invoices` SET `sent`='invoice_sent' WHERE `sent`='1' AND status='confirmed';
	");
	
	DB::execute("
		UPDATE `".TABLE_PREFIX."income_invoices` SET `sent`='void_sent' WHERE `sent`='1' AND status='canceled';
	");
	
	DB::execute("
		UPDATE `".TABLE_PREFIX."income_invoices` SET `sent`='no' WHERE `sent`='0' OR `sent`='';
	");
}

function income_update_25_26() {
	// refresh searchable objects for all invoices
	$invoices = IncomeInvoices::instance()->findAll();
	foreach ($invoices as $invoice) {
		/* $var $invoice IncomeInvoice */
		$invoice->addToSearchableObjects(true);
	}
}

function income_update_26_27() {
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='default_invoice_template_for_preview'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
			('default_invoice_template_for_preview', '1', 'BoolConfigHandler', 1, '');
	    ");
		// disable this option for affinity editions
		if (Plugins::instance()->isActivePlugin('event_tickets')) {
			DB::execute("
				UPDATE `" . TABLE_PREFIX . "income_config_options` SET `value`='0'
				WHERE `name`='default_invoice_template_for_preview';
			");
		}
	}
}


function income_update_27_28() {
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='generate_inv_line_detailed'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`) VALUES
				('generate_inv_line_detailed', '1', 'BoolConfigHandler', 1)
			ON DUPLICATE KEY UPDATE name=name;
		");
	}
}

function income_update_28_29() {
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='group_invoice_timeslots_by'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
				('group_invoice_timeslots_by', 'Task', 'ListConfigHandler', 1, ' { \"option\": [{ \"value\": \"Task\", \"text\": \"Task\" }, { \"value\": \"Timeslot\", \"text\": \"Timeslot\" }, { \"value\": \"Person\", \"text\": \"Person\" } ] }')
			ON DUPLICATE KEY UPDATE name=name;
		");
	}
	
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='generated_invoice_line_prefix_text'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
				('generated_invoice_line_prefix_text', '', 'StringConfigHandler', 1, '')
			ON DUPLICATE KEY UPDATE name=name;
		");
	}
}


function income_update_29_30() {
	// Add debit note subtype
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."object_subtypes` (`object_type_id`, `name`, `sum_in_total`, `code`, `is_special`) VALUES
			((SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name = 'invoice'),'debit note', 0, 'debit_note', 1)
		ON DUPLICATE KEY UPDATE name = name;
	");
}

function income_update_30_31() {
	// Add income_invoice_templates table
	DB::execute("
		CREATE TABLE IF NOT EXISTS `" . TABLE_PREFIX . "income_invoice_templates` (
		`id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
		`name` VARCHAR(255) NULL,
		`is_default` TINYINT( 1 ) NOT NULL DEFAULT '0',
		`group_by` VARCHAR(100) NOT NULL DEFAULT '',
		`include_date` TINYINT( 1 ) NOT NULL DEFAULT '0',
		`include_user_name` TINYINT( 1 ) NOT NULL DEFAULT '0',
		`include_labor_category` TINYINT( 1 ) NOT NULL DEFAULT '0',
		`include_description` TINYINT( 1 ) NOT NULL DEFAULT '0'
		) ENGINE=InnoDB CHARSET=utf8;
	");

	// Add "invoice template" custom property to project
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."custom_properties` (`object_type_id`, `name`, `type`, `description`, `values`, `default_value`, `code`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `show_in_lists`, `is_special`) VALUES
			((SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name = 'project'),'Invoice template', 'list', '', '', '', 'invoice_template', 0, 0, 10, 1, 1, 1),
			((SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name = 'customer'),'Invoice template', 'list', '', '', '', 'invoice_template', 0, 0, 10, 1, 1, 1),
			((SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name = 'invoice'),'Invoice template', 'list', '', '', '', 'invoice_template', 0, 0, 10, 1, 1, 1),
			((SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name = 'invoice'),'Billing from', 'date', '', '', '', 'billing_period_from', 0, 0, 20, 1, 1, 1),
			((SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name = 'invoice'),'Billing to', 'date', '', '', '', 'billing_period_to', 0, 0, 20, 1, 1, 1)
		ON DUPLICATE KEY UPDATE name = name;
	");
	
	// add more columns to invoice lines table
	if (!check_column_exists(TABLE_PREFIX."income_invoice_lines", "rel_object_id")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
			ADD `rel_object_id` int(10) NOT NULL DEFAULT '0'
			");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_lines", "category_id")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
			ADD `category_id` int(10) NOT NULL DEFAULT '0'
			");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_lines", "user_id")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
			ADD `user_id` int(10) NOT NULL DEFAULT '0'
			");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_lines", "date")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
			ADD `date` DATE NOT NULL
			");
	}
}

function income_update_31_32() {
	DB::execute("
		UPDATE ".TABLE_PREFIX."custom_properties SET `name`='Payment terms' WHERE `code`='invoice_payment_period';
	");
	
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "exp_group_by")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `exp_group_by` VARCHAR(100) NOT NULL DEFAULT '';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "display_cost_or_price")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `display_cost_or_price` VARCHAR(100) NOT NULL DEFAULT 'price';
		");
	}
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "include_paid_by")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `include_paid_by` TINYINT( 1 ) NOT NULL DEFAULT '0';
		");
	}
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "include_product_type")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `include_product_type` TINYINT( 1 ) NOT NULL DEFAULT '0';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "include_expense_category")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `include_expense_category` TINYINT( 1 ) NOT NULL DEFAULT '0';
		");
	}
	
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
		ADD INDEX IF NOT EXISTS `object_id` (`object_id`);
	");

	if (!check_column_exists(TABLE_PREFIX."income_invoice_lines", "from_object_type_id")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
			ADD `from_object_type_id` int(10) NOT NULL DEFAULT '0';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_lines", "product_type_id")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
			ADD `product_type_id` int(10) NOT NULL DEFAULT '0';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_lines", "unit_cost")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
			ADD `unit_cost` DECIMAL(20,3) unsigned NOT NULL DEFAULT '0';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_lines", "price_multiplier")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
			ADD `price_multiplier` DECIMAL(20,3) unsigned NOT NULL DEFAULT '0';
		");
	}
	
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
		ADD INDEX IF NOT EXISTS `object_id` (`object_id`);
	");
	
	if (Plugins::instance()->isActivePlugin('expenses2') && !check_column_exists(TABLE_PREFIX."payment_receipts", "invoice_id")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."payment_receipts`
			ADD `invoice_id` int(10) NOT NULL DEFAULT '0';
		");
		
	}
	if (Plugins::instance()->isActivePlugin('expenses2') && !check_column_exists(TABLE_PREFIX."payment_receipts", "invoicing_status")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."payment_receipts`
			ADD `invoicing_status` VARCHAR(100) NOT NULL DEFAULT 'pending';
		");
	}

	if (Plugins::instance()->isActivePlugin('expenses2') && !check_column_exists(TABLE_PREFIX."expenses", "invoicing_status")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."expenses`
			ADD `invoicing_status` VARCHAR(100) NOT NULL DEFAULT 'pending';
		");
	}
}


function income_update_32_33() {
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "template_type")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `template_type` VARCHAR(100) NOT NULL DEFAULT 'detailed';
		");
	}
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "show_taxes_for_each_line")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `show_taxes_for_each_line` tinyint(1) NOT NULL default 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "show_headers_before_details")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `show_headers_before_details` tinyint(1) NOT NULL default 0;
		");
	}

	// adds a default invoice template if no one is present
	$def_row = DB::executeOne("SELECT * FROM ".TABLE_PREFIX."income_invoice_templates WHERE is_default=1");
	if (!$def_row) {
		
		Env::useHelper('functions', 'income');
		$group_invoice_timeslots_by = income_config_option('group_invoice_timeslots_by');
		$gb = 'timeslots';
		if ($group_invoice_timeslots_by == 'Task') $gb = 'tasks';
		else if ($group_invoice_timeslots_by == 'Person') $gb = 'users';

		DB::execute("
			INSERT INTO ".TABLE_PREFIX."income_invoice_templates (`name`,`group_by`,`include_description`,`exp_group_by`,`is_default`) VALUES
			('Default', '$gb', 1, 'payment_receipts', 1)
			ON DUPLICATE KEY UPDATE `name`=`name`;
		");
		
	}
}


function income_update_33_34() {
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "template_type")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `template_type` VARCHAR(100) NOT NULL DEFAULT 'detailed';
		");
	}
}

function income_update_34_35() {
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='automatic_adm_fee_line_text'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
				('automatic_adm_fee_line_text', 'Administrative fee', 'StringConfigHandler', 1, '')
			ON DUPLICATE KEY UPDATE name=name;
		");
	}
}


function income_update_35_36() {
	$config_option_exists = ContactConfigOptions::getByName("timeReportInvoicingStatus");
	if (!$config_option_exists instanceof ContactConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
			('general', 'timeReportInvoicingStatus', '', 'StringConfigHandler', 1, 0, '')
			ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
		");
	}
}


function income_update_36_37() {
	
	// Add "po number" custom property to invoices
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."custom_properties` (`object_type_id`, `name`, `type`, `description`, `values`, `default_value`, `code`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `show_in_lists`, `is_special`) VALUES
			((SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name = 'invoice'),'PO Number', 'text', '', '', '', 'po_number', 0, 0, 25, 1, 1, 1)
		ON DUPLICATE KEY UPDATE name = name;
	");
	
	if (Plugins::instance()->isActivePlugin('advanced_core')) {
		Env::useHelper('functions', 'advanced_core');
		fill_property_groups_default_data();
	}
}


function income_update_37_38() {
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='invoice_footer_disclaimer'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
				('invoice_footer_disclaimer', '', 'StringConfigHandler', 1, '')
			ON DUPLICATE KEY UPDATE name=name;
		");
	}
}



function income_update_38_39() {
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='disable_general_invoices_tab'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
				('disable_general_invoices_tab', '0', 'BoolConfigHandler', 1, '')
			ON DUPLICATE KEY UPDATE name=name;
		");
	}
}


function income_update_39_40() {
	if (!check_column_exists(TABLE_PREFIX."income_invoice_lines", "subtotal")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
			ADD `subtotal` decimal(20,3) NOT NULL AFTER `total`,
			ADD `taxes` decimal(20,3) NOT NULL AFTER `subtotal`;
		");
		DB::execute("
			UPDATE `".TABLE_PREFIX."income_invoice_lines` SET subtotal=total;
		");
	}
	
	DB::execute("
		CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."income_invoice_line_taxes` (
		  `invoice_line_id` int(10) NOT NULL,
		  `tax_id` int(10) NOT NULL,
		  `value` decimal(20,3) NOT NULL,
		  `applied_value` decimal(20,3) NOT NULL,
		  PRIMARY KEY (`invoice_line_id`,`tax_id`),
		  KEY `tax_id` (`tax_id`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
	");
	
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='use_line_taxes'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`)
			VALUES ('use_line_taxes', '0', 'BoolConfigHandler', '1', '');
		");
	}
	
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "show_taxes_for_each_line")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `show_taxes_for_each_line` tinyint(1) NOT NULL default 0;
		");
	}
}

function income_update_40_41() {
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "show_headers_before_details")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `show_headers_before_details` tinyint(1) NOT NULL default 0;
		");
	}
}

function income_update_41_42() {

	Env::useHelper('functions', 'crpm');
	$projects_dim = Dimensions::findByCode('customer_project');
	$clients_dim = get_customers_dimension();
	
	if ($clients_dim->getId() != $projects_dim->getId()) {
		
		$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='billing_client_dim_assoc'"));
		if (!$option instanceof IncomeConfigOption) {
		  DB::execute("
			INSERT INTO ".TABLE_PREFIX."income_config_options (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES 
			(
				'billing_client_dim_assoc',
				(SELECT id FROM ".TABLE_PREFIX."dimension_member_associations WHERE `code`='project_customer'),
				'DimAssociationsConfigHandler', 1, 
				COALESCE(CONCAT (
					'{\"no_empty_value\":1, \"dim_id\":', (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='customer_project'), ',',
					'\"ot_id\":', (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project'), ',',
					'\"assoc_dim_id\":', (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='customers'), ',',
					'\"assoc_ot_id\":', (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer'), '}'
					),'')
			);
		  ");
		}
	}
	
}

function income_update_42_43() {
	
	DB::execute("
		UPDATE `".TABLE_PREFIX."custom_properties` 
		SET `name` = 'Billing contact', `code` = 'billing_contact', is_special=1
		WHERE (`name` LIKE 'Billing client' OR `name` LIKE 'Billing contact') AND `type`='contact'
			AND `object_type_id` = (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project');
	");
	
	$project_ot = ObjectTypes::findByName('project');
	$billing_contact_cp = CustomProperties::getCustomPropertyByCode($project_ot->getId(), 'billing_contact');
	if (!$billing_contact_cp instanceof CustomProperty) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."custom_properties` (`object_type_id`, `name`, `type`, `description`, `values`, `default_value`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `code`, `is_special`) VALUES
			((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project'), 'Billing contact', 'contact', '', '', '', '0', '0', '30', '1', 'billing_contact', '1')
		");
	}
	
	if (Plugins::instance()->isActivePlugin('advanced_core')) {
		Env::useHelper('functions', 'advanced_core');
		fill_property_groups_default_data();
	}
	
}

function income_update_43_44() {
	if (!check_column_exists(TABLE_PREFIX."income_invoice_lines", "member_id")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
			ADD `member_id` int(10) NOT NULL DEFAULT 0;
		");
	}
}

function income_update_44_45() {
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."income_invoices`
		CHANGE `customer_name` `customer_name` text COLLATE 'utf8_unicode_ci' NOT NULL;
	");

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "include_exp_date")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `include_exp_date` tinyint(1) NOT NULL default 0;
		");
	}
}

function income_update_45_46() {
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."income_invoices`
		ADD INDEX IF NOT EXISTS `date` (`date`),
		ADD INDEX IF NOT EXISTS `series_invoice_number` (`series`, `invoice_number`),
		ADD INDEX IF NOT EXISTS `invoice_number` (`invoice_number`),
		ADD INDEX IF NOT EXISTS `total` (`total`),
		ADD INDEX IF NOT EXISTS `status` (`status`);
	");
}

function income_update_46_47() {
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."income_invoices`
		CHANGE `invoice_number` `invoice_number` varchar(50) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '',
		CHANGE `series` `series` varchar(5) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '';
	");

	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='use_serie_for_invoice_number'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`)
			VALUES ('use_serie_for_invoice_number', '1', 'BoolConfigHandler', '1', '');
		");
	}
}

function income_update_47_48() {
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "include_expense_name")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `include_expense_name` tinyint(1) NOT NULL default 0;
		");
	}
}

function income_update_48_49() {
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "include_expense_description")) {
		// add new column for expense description in invoice templates
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `include_expense_description` tinyint(1) NOT NULL default 0;
		");
		// initialize it with the same value as the include description column
		DB::execute("
			UPDATE `".TABLE_PREFIX."income_invoice_templates`
			SET `include_expense_description` = `include_description`;
		");
	}
}

function income_update_49_50() {
	if (!check_custom_prop_exists(TABLE_PREFIX, 'invoice_memo', 'project')) {
		DB::execute("
				INSERT INTO " . TABLE_PREFIX . "custom_properties (`object_type_id`, `name`, `code`, `type`, `values`, `visible_by_default`, `is_special`, `description`) VALUES
				((SELECT id FROM " . TABLE_PREFIX . "object_types WHERE name='project'), 'Invoice memo', 'invoice_memo', 'memo', '', 1, 1, 'This is the default memo for all invoices for this project')
			");
	}
}


function income_update_50_51() {


	if(!check_column_exists(TABLE_PREFIX . "income_invoice_templates", 'include_account_summary')){

		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates`
			ADD COLUMN `include_account_summary` BOOLEAN DEFAULT 0;
		");

	}

	if(checkTableExists(TABLE_PREFIX . "custom_properties")){

		$contact_obect_type_id = ObjectTypes::findByName('contact')->getId();
		
		DB::execute("
			INSERT INTO " . TABLE_PREFIX . "custom_properties (`object_type_id`, `name`, `type`, `description`, `values`, `default_value`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `code`, `is_special`, `is_disabled`, `show_in_lists`, `total_operation`, `object_subtype_id`, `default_currency_id`, `contact_type`) 
			VALUES ('$contact_obect_type_id', 'Initials', 'text', 'User Initials', '', '', '0', '0', '10', '1', 'initials', '0', '0', '1', '', '0', '1', 'user');
		");
		
	}
}

function income_update_51_52() {
	if(checkTableExists(TABLE_PREFIX . "income_invoice_templates")){

		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates`
			CHANGE `include_user_name` `include_user_name` varchar(100) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '';
		");

		
		if (check_column_exists(TABLE_PREFIX."income_invoice_templates", 'include_user_name')) {
			DB::execute("	
				UPDATE `" . TABLE_PREFIX . "income_invoice_templates` 
				SET `include_user_name` = IF (include_user_name = '1', 'Full name', 'No name');
			");
		}
	}
}

function income_update_52_53() {
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", 'break_down_by_subprojects')) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `break_down_by_subprojects` tinyint(1) NOT NULL default 0;
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", 'footer_text')) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `footer_text` VARCHAR(511) NOT NULL DEFAULT '';
		");
	}
}

function income_update_53_54() {

	if (!check_column_exists(TABLE_PREFIX."income_invoice_lines", "group_by_category_id")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
			ADD `group_by_category_id` int(10) NOT NULL DEFAULT '0';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", 'break_down_expenses_by_category')) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `break_down_expenses_by_category` tinyint(1) NOT NULL default 0;
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", 'show_expenses_markup_separated')) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `show_expenses_markup_separated` tinyint(1) NOT NULL default 0;
		");
	}
}

function income_update_54_55() {
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", 'accumulate_discounts')) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `accumulate_discounts` tinyint(1) NOT NULL default 1;
		");
	}
}

function income_update_55_56() {

	// add new config option to use invoice notebooks or not
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='use_invoice_notebooks'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."income_config_options` (`name`, `value`, `config_handler_class`, `is_system`) VALUES
			('use_invoice_notebooks', '0', 'BoolConfigHandler', 1);
		");
	}

	// modify custom properties
	DB::execute("	
				UPDATE `" . TABLE_PREFIX . "custom_properties` 
					SET `values` = ',check,money_order,transfer,cash,credit_card,other'
				WHERE object_type_id in (select id
										from " . TABLE_PREFIX . "object_types
										where name='invoice' or name='invoice_payment_receipt')
				and code ='payment_method';
			");
}

function income_update_56_57() 
{
	if (check_column_exists(TABLE_PREFIX . "income_invoice_lines", "amount")) {
        DB::execute("
						ALTER TABLE `" . TABLE_PREFIX . "income_invoice_lines`
						modify amount decimal(20,3) not null;
					");
    }

	if (check_column_exists(TABLE_PREFIX . "income_invoice_templates", "accumulate_discounts")) {
        DB::execute("
						ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates`
						modify accumulate_discounts varchar(100) not null default 'between_line_items';
					");
    }
}

function income_update_57_58(){
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_lines", "order")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_lines` ADD `order` int(10);
		");
	}
}
function income_update_58_59() {

	// if clients already have a billing contact custom property, then ensure that it has the correct code
	DB::execute("
		UPDATE ".TABLE_PREFIX."custom_properties SET code='billing_contact'
		WHERE name LIKE 'Billing Contact' 
		AND object_type_id = (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer');
	");

	// if clients already have a billing address custom property, then ensure that it has the correct code
	DB::execute("
		UPDATE ".TABLE_PREFIX."custom_properties SET code='billing_address'
		WHERE name LIKE 'Billing Address' 
		AND object_type_id = (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer');
	");
}

function income_update_59_60(){
	if (!check_column_exists(TABLE_PREFIX . "income_invoices", "attn")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoices` ADD `attn` varchar(255) COLLATE utf8_unicode_ci NULL DEFAULT '';
		");
	}

	$project_ot_id = ObjectTypes::findByName('project')->getId();
	$contract_amount_cp = CustomProperties::getCustomPropertyByCode($project_ot_id, 'contract_amount');

	if($contract_amount_cp instanceof CustomProperty){
		$contract_amount_cp->setCode('budget_total');
		$contract_amount_cp->save();
	}
}

function income_update_60_61()
{
	if (!check_column_exists(TABLE_PREFIX . "contact_emails", "default_billing_email")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "contact_emails` ADD `default_billing_email` tinyint(1) unsigned NOT NULL DEFAULT 0;
		");
	}

	if (!check_column_exists(TABLE_PREFIX . "contact_addresses", "default_billing_address")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "contact_addresses` ADD `default_billing_address` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
}

function income_update_61_62()
{
		if (!check_column_exists(TABLE_PREFIX . "income_invoice_lines", "item_type_id")) {
			DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_invoice_lines` ADD `item_type_id` int(10);
			");
		}
		if (!check_column_exists(TABLE_PREFIX . "income_invoice_lines", "discount_percent_type")) {
			DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_invoice_lines` ADD `discount_percent_type` int(1) DEFAULT 0;
			");
		}
		if (!check_column_exists(TABLE_PREFIX . "income_invoice_lines", "discount_percent_value")) {
			DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_invoice_lines` ADD `discount_percent_value` decimal(20,3) DEFAULT 0;
			");
		}
}

function income_update_62_63() {
	DB::execute("
		UPDATE ".TABLE_PREFIX."custom_properties SET code='po_number'
		WHERE (name LIKE 'P.O. Number' OR name LIKE 'PO Number')
		AND object_type_id = (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project');
	");
}

function income_update_63_64()
{
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='allow_duplicated_invoice_numbers'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
			('allow_duplicated_invoice_numbers', '0', 'BoolConfigHandler', 1, '');
	    ");
	}
	
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_detail")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_detail` tinyint(1) unsigned NOT NULL DEFAULT 0;
		");
	}

	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_task_name")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_task_name` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_hours")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_hours` tinyint(1) unsigned NOT NULL DEFAULT 1;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_rate")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_rate` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_custom_description")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_custom_description` varchar(100) NOT NULL DEFAULT '';
    ");
	}

	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_time_entry_description")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_time_entry_description` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}

	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_total")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_total` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}

	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_quantity")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_exp_quantity` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_amount")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_exp_amount` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_fee")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_exp_fee` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_total")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_exp_total` tinyint(1) unsigned NOT NULL DEFAULT 1;
    ");
	}
	
}

function income_update_64_65()
{
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_project_name")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_project_name` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_project_description")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_project_description` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
}
function income_update_65_66()
{
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_lump_sum_project_number")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_lump_sum_project_number` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_lump_sum_project_name")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_lump_sum_project_name` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_lump_sum_from_to")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_lump_sum_from_to` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_lump_sum_date")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_lump_sum_date` varchar(100) NOT NULL DEFAULT '';
	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_lump_sum_quantity")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_lump_sum_quantity` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_lump_sum_budget_completion")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_lump_sum_budget_completion` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
}
function income_update_66_67()
{
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_expense_project_number")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_expense_project_number` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_expense_project_name")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_expense_project_name` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_time_line_date")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_time_line_date` varchar(100) NOT NULL DEFAULT 'Item date';
	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_type_date")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_exp_type_date` varchar(100) NOT NULL DEFAULT 'Item date';
	");
	}
}
function income_update_67_68()
{
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_lump_sum_date_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_lump_sum_date_col` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_lump_sum_unit_price")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_lump_sum_unit_price` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
}
function income_update_68_69()
{
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_lump_sum_project_type")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_lump_sum_project_type` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
}


function income_update_69_70(){
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "category_for_lump_sum")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `category_for_lump_sum` int(10) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "product_type_for_lump_sum")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `product_type_for_lump_sum` int(10) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "category_for_lump_sum_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `category_for_lump_sum_col` tinyint(1) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "product_type_for_lump_sum_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `product_type_for_lump_sum_col` tinyint(1) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "category_for_timeslot")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `category_for_timeslot` int(10) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "product_type_for_timeslot")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `product_type_for_timeslot` int(10) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "category_for_timeslot_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `category_for_timeslot_col` tinyint(1) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "product_type_for_timeslot_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `product_type_for_timeslot_col` tinyint(1) NOT NULL DEFAULT 0;
		");
	}

	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "category_for_expenses")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `category_for_expenses` int(10) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "product_type_for_expenses")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `product_type_for_expenses` int(10) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "category_for_expenses_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `category_for_expenses_col` tinyint(1) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "product_type_for_expenses_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `product_type_for_expenses_col` tinyint(1) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_paid_by_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `include_paid_by_col` tinyint(1) NOT NULL DEFAULT 0;
		");
	}
	
	
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_lump_sum_deetail_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `include_lump_sum_deetail_col` tinyint(1) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_description")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `include_exp_description` tinyint(1) NOT NULL DEFAULT 0;
		");
	}

	/***for compatibility */
	/*get all templates*/
	/*$templates=IncomeInvoiceTemplates::getInvoiceTemplatesInfo();

	foreach($templates as $template)
	{

		//get the template
		$invoice_template = IncomeInvoiceTemplates::instance()->findById($template['id']);
		//set the template
		if($invoice_template->getIncludeUserName()!='No name')
		{
			$invoice_template->setIncludeUserNameCol(1);
		}

		$invoice_template->setCategoryForTimeslotCol($invoice_template->getIncludeLaborCategory());
		$invoice_template->setIncludePaidByCol($invoice_template->getIncludePaidBy());
		$invoice_template->setProductTypeForTimeslotCol($invoice_template->getIncludeProductType());

		//save the template
		$invoice_template->save();

		//destroy the object
		unset($invoice_template);
	}*/
}
function income_update_70_71(){
	
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_user_name_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `include_exp_user_name_col`  varchar(100) NOT NULL DEFAULT 'Do not display'
		");
	}
}

function income_update_71_72(){

	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_detail")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_detail` tinyint(1) unsigned NOT NULL DEFAULT 0;
		");
	}
}

function income_update_72_73(){
	if (check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_user_name_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates`
			DROP COLUMN `include_user_name_col`;
		");
	}

	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_user_name_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates`
			ADD COLUMN `include_user_name_col` varchar(100) NOT NULL DEFAULT 'Do not display';
		");
	}
}

function income_update_73_74(){
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_task_name")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_task_name` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_hours")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_hours` tinyint(1) unsigned NOT NULL DEFAULT 1;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_rate")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_rate` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_custom_description")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_custom_description` varchar(100) NOT NULL DEFAULT '';
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_time_entry_description")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_time_entry_description` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_total")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_total` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}

	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_quantity")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_exp_quantity` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_amount")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_exp_amount` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_fee")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_exp_fee` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_total")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_exp_total` tinyint(1) unsigned NOT NULL DEFAULT 1;
    ");
	}
}

function income_update_74_75()
{
	$pathInvoiceTemplate = 'original';
	$root_exploded = @explode(DIRECTORY_SEPARATOR, ROOT);
	$current_folder_name = end($root_exploded);
	$template_file = "invoice_print_custom_template.php";
	$base_folder = "/plugins/income/invoice_print_templates/" . $current_folder_name;

	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "invoice_template_assigned")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `invoice_template_assigned` varchar(100) NOT NULL DEFAULT '$pathInvoiceTemplate';
    	");

		if (is_dir(ROOT . $base_folder) && file_exists(ROOT . $base_folder . "/$template_file")) {
			$pathInvoiceTemplate = $current_folder_name;
			DB::execute("
				UPDATE " . TABLE_PREFIX . "income_invoice_templates SET invoice_template_assigned='$pathInvoiceTemplate'
				WHERE invoice_template_assigned LIKE 'original';
			");
		}
	}
	
}

function income_update_75_76()
{
	DB::execute("
		CREATE TABLE IF NOT EXISTS `" . TABLE_PREFIX . "income_invoice_childs` (
		`object_id_parent` int(10) unsigned NOT NULL,
		`object_id_child` int(10) unsigned NOT NULL,
		PRIMARY KEY (`object_id_parent`,`object_id_child`)
		)ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
	");

	if (check_column_exists(TABLE_PREFIX . "income_invoice_templates", "break_down_by_subprojects")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates`
			MODIFY COLUMN `break_down_by_subprojects` varchar(100) NOT NULL DEFAULT 'NO';
    ");
	}
}



function income_update_76_77() {
	DB::execute("
		ALTER TABLE `" . TABLE_PREFIX . "income_invoices`
		CHANGE `customer_email` `customer_email` varchar(500) COLLATE 'utf8_unicode_ci' NOT NULL;
	");
}

function income_update_77_78()
{

	$result = DB::executeOne("
	SELECT * FROM `" . TABLE_PREFIX . "custom_properties` 
	WHERE name like 'Job scheduled'
	AND object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project')
	");
	if(!is_null($result)){
		DB::execute("
			UPDATE `" . TABLE_PREFIX . "custom_properties` set code = 'job_scheduled' WHERE id = '{$result['id']}';
		");
	} 

	
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_include_date")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_include_date` VARCHAR(100) NOT NULL DEFAULT 'date';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_include_user_name_col")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_include_user_name_col` VARCHAR(100) NOT NULL DEFAULT 'person name';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_category_for_timeslot_col")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_category_for_timeslot_col` VARCHAR(100) NOT NULL DEFAULT 'labor category';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_include_description")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_include_description` VARCHAR(100) NOT NULL DEFAULT 'detail';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_include_hours")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_include_hours` VARCHAR(100) NOT NULL DEFAULT 'hours';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_include_rate")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_include_rate` VARCHAR(100) NOT NULL DEFAULT 'rate';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_include_total")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_include_total` VARCHAR(100) NOT NULL DEFAULT 'total';
		");
	}
	
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_include_exp_date")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_include_exp_date` VARCHAR(100) NOT NULL DEFAULT 'date';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_include_paid_by_col")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_include_paid_by_col` VARCHAR(100) NOT NULL DEFAULT 'paid by';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_include_exp_user_name_col")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_include_exp_user_name_col` VARCHAR(100) NOT NULL DEFAULT 'person name';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_category_for_expenses_col")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_category_for_expenses_col` VARCHAR(100) NOT NULL DEFAULT 'expense category';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_product_type_for_expenses_col")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_product_type_for_expenses_col` VARCHAR(100) NOT NULL DEFAULT 'product type';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_include_exp_description")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_include_exp_description` VARCHAR(100) NOT NULL DEFAULT 'detail';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_include_exp_quantity")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_include_exp_quantity` VARCHAR(100) NOT NULL DEFAULT 'quantity';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_include_exp_amount")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_include_exp_amount` VARCHAR(100) NOT NULL DEFAULT 'unit value';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_include_exp_fee")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_include_exp_fee` VARCHAR(100) NOT NULL DEFAULT 'fee';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_include_exp_total")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_include_exp_total` VARCHAR(100) NOT NULL DEFAULT 'total';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_include_lump_sum_date_col")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_include_lump_sum_date_col` VARCHAR(100) NOT NULL DEFAULT 'Date';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_category_for_lump_sum_col")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_category_for_lump_sum_col` VARCHAR(100) NOT NULL DEFAULT 'Category';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_product_type_for_lump_sum_col")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_product_type_for_lump_sum_col` VARCHAR(100) NOT NULL DEFAULT 'Product type';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_include_lump_sum_deetail_col")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_include_lump_sum_deetail_col` VARCHAR(100) NOT NULL DEFAULT 'Detail';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_include_lump_sum_quantity")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_include_lump_sum_quantity` VARCHAR(100) NOT NULL DEFAULT 'Quantity';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "custom_label_include_lump_sum_unit_price")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `custom_label_include_lump_sum_unit_price` VARCHAR(100) NOT NULL DEFAULT 'total';
		");
	}
}

function income_update_78_79()
{

	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "template_language_assigned")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `template_language_assigned` varchar(100) NOT NULL DEFAULT '';
    	");
	}

	$locale = get_locale();

	DB::execute("
		UPDATE " . TABLE_PREFIX . "income_invoice_templates SET template_language_assigned='$locale' WHERE template_language_assigned = '';
	");
}

function income_update_79_80()
{

	$result = DB::executeOne("
	SELECT * FROM `" . TABLE_PREFIX . "custom_properties` 
	WHERE name like 'Job scheduled'
	AND object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project')
	");
	if(!is_null($result)){
		DB::execute("
			UPDATE `" . TABLE_PREFIX . "custom_properties` set code = 'job_scheduled' WHERE id = '{$result['id']}';
		");
	} 
}

function income_update_80_81()
{
	
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "task_all_expenses_includes")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `task_all_expenses_includes` tinyint(1) unsigned NOT NULL DEFAULT 1;
    	");
	}

	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "task_group")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `task_group` varchar(100) NOT NULL DEFAULT 'aggregated into a single line';
    	");
	}
}

function income_update_81_82()
{
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "task_custom_detail")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `task_custom_detail` VARCHAR(100) NOT NULL DEFAULT '';
    	");
	}
}

function income_update_82_83()
{
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "labor_detail_separator_value")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `labor_detail_separator_value` varchar(100) NOT NULL DEFAULT '';
    	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "expense_detail_separator_value")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `expense_detail_separator_value` varchar(100) NOT NULL DEFAULT '';
    	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "tasks_detail_separator_value")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `tasks_detail_separator_value` varchar(100) NOT NULL DEFAULT '';
    	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "lump_sum_detail_separator_value")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `lump_sum_detail_separator_value` varchar(100) NOT NULL DEFAULT '';
    	");
	}
}

function income_update_83_84()
{
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "task_allow_billing_per_percent")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `task_allow_billing_per_percent` tinyint(1) unsigned NOT NULL DEFAULT 0;
    	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "task_invoice_billing_type")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `task_invoice_billing_type` varchar(100) NOT NULL DEFAULT 'Invoice difference only';
    	");
	}
}

function income_update_84_85() {
	// new table for invoice layouts
	DB::execute("
		CREATE TABLE IF NOT EXISTS `" . TABLE_PREFIX . "income_invoice_layouts` (
		`id` int(10) unsigned NOT NULL AUTO_INCREMENT,
		`code` VARCHAR(100) NOT NULL default '',
		`name` VARCHAR(100) NOT NULL default '',
		`enabled` tinyint(1) unsigned NOT NULL default 1,
		`is_system` tinyint(1) unsigned NOT NULL default 0,
		`content` text COLLATE utf8_unicode_ci NOT NULL,
		PRIMARY KEY (`id`)
		) ENGINE=InnoDB;
	");

	// upload the invoice layouts in the source code to the new structure
	Env::useHelper('functions', 'income');
	reset_invoice_layouts_from_source_code();
	
}

// Adds more payment term options to the "invoice_payment_period" custom property for invoices
function income_update_85_86() {

	$pt_cp = CustomProperties::getCustomPropertyByCode(IncomeInvoices::instance()->getObjectTypeId(), 'invoice_payment_period');

	$current_terms = explode(',', $pt_cp->getValues());
	$mandatory_terms = array('Net D', 'Net 10', 'Net 30', 'Net 45', 'Net 60', 'Net 90', 'Net 120');

	foreach ($mandatory_terms as $term) {
		if (!in_array($term, $current_terms)) {
			$current_terms[] = $term;
		}
	}
	$sorted_terms = array();
	foreach ($current_terms as $term) {
		if ($term == 'Due on receipt') $key = 0;
		else if ($term == 'Net D') $key = 1;
		else $key = trim(str_replace('Net ', '', $term));

		$sorted_terms[$key] = $term;
	}
	ksort($sorted_terms, SORT_NUMERIC);

	$pt_cp->setValues(implode(',', $sorted_terms));
	$pt_cp->save();
}

function income_update_86_87()
{
	
	//1 create new template
	Env::useHelper('functions', 'income');
	reset_invoice_layouts_from_source_code();

	//2 create template options table
	DB::execute("
		CREATE TABLE IF NOT EXISTS `" . TABLE_PREFIX . "income_invoice_template_options` (
		`template_id` int(10) unsigned NOT NULL,
		`group_option` varchar(200) NOT NULL,
		`name` varchar(200) NOT NULL,
		`label` varchar(200) NOT NULL,
		`order_number` int(10) unsigned NOT NULL DEFAULT 0,
		`visible` tinyint(1) unsigned NOT NULL DEFAULT 1,
		PRIMARY KEY (`template_id`,`name`)
		)ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
	");

	//3 get current company
	$company=owner_company();
	$company_name=trim($company->getName());

	//4 get all templates for current company
	$templates=IncomeInvoiceTemplates::instance()->findAll();

	//5 for each templates add new options
	foreach($templates as $template)
	{
	    if('BCA Environmental Consultants, LLC'==$company_name)
		{
	        DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																					VALUES(
																					".$template->getId().", 
																					'project_options',
																					 'project_payment_terms',
																					 'Terms',
																					 1,
																					 1);");
	
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
																					 group_option,
																					 name, 
																					 label, 
																					 order_number,
																					 visible)
																					 VALUES(
																					 ".$template->getId().", 
																					 'project_options',
																					 'project_due_date',
																					 'Due date',
																					 2,
																					 1);");	
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
																					 group_option,
																					 name, 
																					 label, 
																					 order_number,
																					 visible)
																					 VALUES(
																					 ".$template->getId().", 
																					 'project_options',
																					 'project_complete_name',
																					 'Project',
																					 3,
																					 1);");	
				DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
																					 group_option,
																					 name, 
																					 label, 
																					 order_number,
																					 visible)
																					 VALUES(
																					 ".$template->getId().", 
																					 'project_options',
																					 'project_type_value',
																					 'Office',
																					 4,
																					 1);");	
			    DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
																					 group_option,
																					 name, 
																					 label, 
																					 order_number,
																					 visible)
																					 VALUES(
																					 ".$template->getId().", 
																					 'project_options',
																					 'project_PO_number',
																					 'P.O Number',
																					 5,
																					 1);");		
		}elseif('Bio-logical'==$company_name)
		{
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options',
																						'project_payment_terms',
																						'PAYMENT TERMS',
																						2,
																						1);");
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options',
																						'project_complete_name',
																						'JOB',
																						1,
																						1);");																						 
																						
		}elseif('Environmental Resources Managers Limited'==$company_name)
		{
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options', 
																						'project_name',
																						'PROJECT',
																						1,
																						1);");
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options', 
																						'project_payment_terms',
																						'TERMS',
																						2,
																						1);");
			
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options', 
																						'project_due_date',
																						'DUE DATE',
																						3,
																						1);");																						
																										
																						
		}elseif('Guzi-West Inspection and Consulting, LLC'==$company_name)
		{
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options', 
																						'project_complete_name',
																						'PROJECT',
																						1,
																						1);");
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options', 
																						'project_manager',
																						'PROJECT MANAGER',
																						2,
																						1);");	
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options', 
																						'project_payment_terms',
																						'TERMS',
																						3,
																						1);");
		}elseif('Kjolhaug Environmental Services'==$company_name)
		{
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options',
																						'project_due_date',
																						'Date of service',
																						1,
																						1);");
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options',
																						'project_complete_name',
																						'PROJECT ',
																						2,
																						1);");
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options',
																						'project_payment_terms',
																						'TERMS ',
																						3,
																						1);");
		}elseif('National Econ Corporation'==$company_name)
		{
			
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options', 
																						'project_complete_name',
																						'PROJECT ',
																						1,
																						1);");
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options', 
																						'project_manager',
																						'PROJECT MANAGER',
																						2,
																						1);");																						
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options', 
																						'project_payment_terms',
																						'TERMS',
																						3,
																						1);");
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options', 
																						'project_due_date',
																						'DUE DATE',
																						4,
																						1);");
		}elseif('Aitana Props - NIT 700320294'==$company_name)
		{
			
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options', 
																						'project_complete_name',
																						'PROPERTY ',
																						1,
																						1);");
																								
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options', 
																						'project_payment_terms',
																						'TERMS',
																						2,
																						1);");
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options', 
																						'project_due_date',
																						'DUE DATE',
																						3,
																						1);");
		}elseif('Quinn Environmental Strategies'==$company_name)
		{
			
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options', 
																						'project_complete_name',
																						'PROJECT ',
																						1,
																						1);");
																								
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options', 
																						'project_manager',
																						'PROJECT MANAGER',
																						2,
																						1);");
		}elseif('Robinson Noble'==$company_name)
		{
			
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options', 
																						'project_number',
																						'Project Id: ',
																						1,
																						1);");
																								
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options', 
																						'project_name',
																						'Project Name:',
																						2,
																						1);");
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options', 
																						'project_manager',
																						'Project Manager:',
																						3,
																						1);");
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options', 
																						'project_po_number',
																						'Project PO:',
																						4,
																						1);");
		}elseif('Triplo4'==$company_name)
		{
			DB::executeAll("INSERT INTO " . TABLE_PREFIX . "income_invoice_template_options (template_id, 
			                                                                            group_option,
																						name, 
																						label, 
																						order_number,
																						visible)
																						VALUES(
																						".$template->getId().", 
																						'project_options', 
																						'project_description',
																						'PROJECT DESCRIPTION: ',
																						1,
																						1);");
		}
	}		
}

function income_update_87_88() {
	DB::execute("
		UPDATE ".TABLE_PREFIX."custom_properties SET code='po_number'
		where object_type_id = (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project')
		and name LIKE 'PO #';
	");
}

function income_update_88_89(){
	if (!check_column_exists(TABLE_PREFIX . "income_invoices", "attn")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoices` ADD `attn` varchar(255) COLLATE utf8_unicode_ci NULL DEFAULT '';
		");
	}
}

function income_update_89_90(){
	if (check_column_exists(TABLE_PREFIX . "income_invoice_templates", "footer_text")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` MODIFY COLUMN `footer_text` varchar(2024) CHARACTER SET utf8 COLLATE utf8_general_ci DEFAULT '' NOT NULL;
		");

		//3 get current company
	    $company=owner_company();
	    $company_name=trim($company->getName());
	    if('Guzi-West Inspection and Consulting, LLC'==$company_name)
		{
 		    DB::execute("
                		UPDATE ".TABLE_PREFIX."income_invoice_templates SET footer_text='Mail payment to: PO Box 492770 Redding, CA 96049, Tel: 888-351-8189
						PAYMENT DUE IN FULL WITHIN 30 DAYS, PLEASE MAKE CHECKS PAYABLE TO GUZIWEST AND INCLUDE THE INVOICE NUMBER LISTED ABOVE. CREDIT CARD PAYMENTS CAN BE MADE BY CALLING 888-351-8189';
					");
		 }
	}
}

function income_update_90_91(){
	DB::execute("
           		UPDATE ".TABLE_PREFIX."income_invoice_template_options SET name='project_po_number'
				where name='project_PO_number';
				");
}

function income_update_91_92(){
	DB::execute("
           		UPDATE ".TABLE_PREFIX."custom_properties SET code='customer_number'
				where name='Client Number'
				and object_type_id = (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer');
				");
}

function income_update_92_93(){
	$invoice_ot = ObjectTypes::findByName('invoice');
	$bill_from_cp = CustomProperties::getCustomPropertyByCode($invoice_ot->getId(), 'billing_period_from');
	if ($bill_from_cp instanceof CustomProperty) {
		DB::execute("
			UPDATE ".TABLE_PREFIX."custom_properties 
			SET property_order=".($bill_from_cp->getOrder() + 1)."
			where code='billing_period_to'
				and object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='invoice');
		");
	}
}

function income_update_93_94(){

	// try to insert new status types for paid and unpaid invoices
	if (Plugins::instance()->isActivePlugin('object_templates')) {
		
         if(checkTableExists(TABLE_PREFIX . "object_status_types")){////check that table object_status_types exists
            
            $result = DB::executeOne("
                         SELECT * FROM `" . TABLE_PREFIX . "object_status_types` 
                         WHERE object_type_id = (SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name = 'invoice')
                         AND name= 'send paid invoice';
                    ");
            
            if(is_null($result)){
                DB::execute("
                         INSERT INTO ".TABLE_PREFIX."object_status_types
                         (object_type_id, name, description, code, status, created_on, created_by_id, updated_on, updated_by_id)
                         VALUES((SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name = 'invoice'), 'send paid invoice', '', 'general_invoice_paid', 'confirmed', NULL, 0, NULL, 0);");
            }

            $result = DB::executeOne("
                         SELECT * FROM `" . TABLE_PREFIX . "object_status_types` 
                         WHERE object_type_id = (SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name = 'invoice')
                         AND name= 'send open invoice';
                    ");
            if(is_null($result)){
                DB::execute("
                         INSERT INTO ".TABLE_PREFIX."object_status_types
                         (object_type_id, name, description, code, status, created_on, created_by_id, updated_on, updated_by_id)
                         VALUES((SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name = 'invoice'), 'send open invoice', '', 'general_invoice_pending', 'pending', NULL, 0, NULL, 0);");
            }
        }
    }
}

function income_update_94_95(){
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='no_billing_contact_blank'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."income_config_options` (`name`, `value`, `config_handler_class`, `is_system`)
			VALUES ('no_billing_contact_blank', '0', 'BoolConfigHandler', 1);
        ");
	}
}

function income_update_95_96(){
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='no_billing_contact_blank'"));
	if ($option instanceof IncomeConfigOption) {
		DB::execute("
			DELETE FROM `".TABLE_PREFIX."income_config_options`
			where name='no_billing_contact_blank';
        ");
	}

	$option_new = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='if_no_billing_contact_then_use_main_address'"));
	if (!$option_new instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."income_config_options` (`name`, `value`, `config_handler_class`, `is_system`)
			VALUES ('if_no_billing_contact_then_use_main_address', '1', 'BoolConfigHandler', 1);
        ");
	}
}

function income_update_96_97(){
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_unit_cost")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_exp_unit_cost` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "custom_label_include_exp_include_exp_unit_cost")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `custom_label_include_exp_include_exp_unit_cost` VARCHAR(100) NOT NULL DEFAULT 'Unit cost';
    ");
	}
}

function income_update_97_98(){
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='set_objects_non_billable_if_price_is_manual'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."income_config_options` (`name`, `value`, `config_handler_class`, `is_system`)
			VALUES ('set_objects_non_billable_if_price_is_manual', '0', 'BoolConfigHandler', 1);
		");
	}
}

function income_update_98_99() {
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."income_invoice_templates` 
		CHANGE `break_down_expenses_by_category` `break_down_expenses_by_category` VARCHAR(100) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'no'; 
	");

	DB::execute("
		UPDATE `".TABLE_PREFIX."income_invoice_templates` 
		SET break_down_expenses_by_category = 'no'
		WHERE break_down_expenses_by_category = 0;
	");
	DB::execute("
		UPDATE `".TABLE_PREFIX."income_invoice_templates` 
		SET break_down_expenses_by_category = 'each category'
		WHERE break_down_expenses_by_category = 1;
	");
}

function income_update_99_100(){
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "expense_detail_vendor_name")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `expense_detail_vendor_name` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "expense_detail_bill_no")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `expense_detail_bill_no` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
}

function income_update_100_101(){
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_expense_task_name")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_expense_task_name` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
}


function income_update_101_102(){

	// add new option to invoice templates to show invoice's additional information field in the footer
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_additional_info_in_footer")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_additional_info_in_footer` tinyint(1) unsigned NOT NULL DEFAULT 0;
		");
	}

	// extend invoice template options to allow having different options when some data is visible
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_template_options", "selected_option")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_template_options`
			ADD `selected_option` varchar(200) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '';
		");
	}

	// for project complete name option apply the new sub-options depending on visibility
	DB::execute("
		UPDATE `".TABLE_PREFIX."income_invoice_template_options` 
		SET selected_option = IF (visible, 'only_main_project', 'no')
		WHERE name = 'project_complete_name';
	");
	
	// add new column to include markup amount in the invoice line details
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_markup_amount")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `include_exp_markup_amount` TINYINT(1) UNSIGNED NOT NULL DEFAULT 0;
		");

	}

	// add new column for custom label of markup amount
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "custom_label_include_exp_markup_amount")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `custom_label_include_exp_markup_amount` VARCHAR(100) NOT NULL DEFAULT 'Markup $';
		");
	}

	// change default value of fee label to 'Markup %'
	DB::execute("
		ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates`
		CHANGE `custom_label_include_exp_markup_amount` `custom_label_include_exp_markup_amount` varchar(100) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT 'Markup %';
	");

  // new option to select date format in invoice templates
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "date_format")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `date_format` VARCHAR(50) NOT NULL DEFAULT '';
		");
	}

}

// add the paid_amount and due_amount columns to the core of this plugin
function income_update_102_103() {

	if (!check_column_exists(TABLE_PREFIX . "income_invoices", "paid_amount")) {
		// add the column
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoices`
			ADD `paid_amount` DECIMAL(20,3) NOT NULL DEFAULT 0;
		");

		// initialize values
		DB::execute("
			UPDATE `".TABLE_PREFIX."income_invoices` 
			SET `paid_amount`=`total` 
			WHERE `status`='confirmed';
		");
	}

	if (!check_column_exists(TABLE_PREFIX . "income_invoices", "due_amount")) {
		// add the column
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoices`
			ADD `due_amount` DECIMAL(20,3) NOT NULL DEFAULT 0;
		");

		// initialize values
		DB::execute("
			UPDATE `".TABLE_PREFIX."income_invoices` 
			SET `due_amount`=`total` 
			WHERE `status`!='confirmed';
		");
	}
}

// add the amount column to the invoice references table, to use when a credit note affects one or more invoices
function income_update_103_104() {

	if (!check_column_exists(TABLE_PREFIX . "income_invoice_references", "amount")) {
		// add the column for amount
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_references`
			ADD `amount` DECIMAL(20,3) NOT NULL DEFAULT 0;
		");

		// set the value for the amount for current credit notes
		DB::execute("
			UPDATE `".TABLE_PREFIX."income_invoice_references` 
			SET `amount`= (SELECT `total` FROM ".TABLE_PREFIX."income_invoices WHERE object_id=referenced_object_id)
		");
	}
}

function income_update_104_105() {
	// ensure that due amount has the correct value
	DB::execute("
		UPDATE `".TABLE_PREFIX."income_invoices` 
		SET `paid_amount` = `total`
		WHERE `status` = 'confirmed';
	");
	DB::execute("
		UPDATE `".TABLE_PREFIX."income_invoices` 
		SET `due_amount` = `total` - `paid_amount`
		WHERE `due_amount` != `total` - `paid_amount`;
	");
}

function income_update_105_106() {
	// ensure that due amount has the correct value
	DB::execute("
		DELETE FROM `".TABLE_PREFIX."income_config_options`
		WHERE `name`='default_invoice_template_for_preview';
	");
}

function income_update_106_107() {
	// ensure that due amount has the correct value
	DB::execute("
		DELETE FROM `".TABLE_PREFIX."income_config_options`
		WHERE `name`='default_invoice_template_for_preview';
	");
}

function income_update_107_108() {
	// add new widget for invoicing status
	$widget = Widgets::instance()->findOne(array('conditions' => "name='invoices_status'"));

	if (!$widget instanceof Widget) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."widgets` (`name`, `title`, `plugin_id`, `path`, `default_options`, `default_section`, `default_order`, `icon_cls`) 
			VALUES ('invoices_status','invoices_status', 36,'','','none', 2,'ico-invoice');
		");
	}

	$filter_preference = user_config_option("invoices_widget_date_filter");
	if (!isset($filter_preference)) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`) 
			VALUES ('invoices_widget', 'invoices_widget_date_filter', 'ytd', 'StringConfigHandler', 1, 0);
		");
	}
	// Add new custom property 'Project location (for invoice)' to the project object type
	$project_ot = ObjectTypes::findByName('project');
	$location_cp = CustomProperties::getCustomPropertyByCode($project_ot->getId(), 'project_location_for_invoice');
	if (!$location_cp instanceof CustomProperty) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."custom_properties` (`object_type_id`, `name`, `code`, `description`, `type`, `values`, `property_order`, `is_required`, `visible_by_default`, `is_special`, `is_disabled`, `show_in_lists`)
			VALUES ('".$project_ot->getId()."', 'Project location for invoice', 'project_location_for_invoice', '', 'memo', '', 20, 0, 1, 1, 1, 1);
		");

		if (Plugins::instance()->isActivePlugin('advanced_core')) {
			Env::useHelper('functions', 'advanced_core');
			fill_property_groups_default_data();
		}
	}

	if(!check_column_exists(TABLE_PREFIX . "income_invoice_templates", 'include_project_location')){
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates`
			ADD COLUMN `include_project_location` BOOLEAN DEFAULT 0;
		");
	}
	
	// fix due amount for invoices affected for the bug that didn't assign due amount on creation
	DB::execute("
		UPDATE `".TABLE_PREFIX."income_invoices` 
		SET `due_amount` = `total`
		WHERE `status` = 'pending' AND `due_amount`=0 and `paid_amount`=0;
	");
}
