<?php
if (isset($indicator) && $indicator instanceof Indicator) {
	if (!$indicator->isTrashed()){
		if($indicator->canEdit(logged_user())) {
			add_page_action(lang('edit'), "javascript:og.render_modal_form('', {c:'indicator', a:'edit', params: {id:".$indicator->getId()."}});", 'ico-edit', null, null, true);
			
			if (!$indicator->isArchived()) {
				add_page_action(lang('archive'), "javascript:if(confirm(lang('confirm archive object'))) og.openLink('" . $indicator->getArchiveUrl() ."');", 'ico-archive-obj');
			} else {
				add_page_action(lang('unarchive'), "javascript:if(confirm(lang('confirm unarchive object'))) og.openLink('" . $indicator->getUnarchiveUrl() ."');", 'ico-unarchive-obj');
			}
		}
	}
	if ($indicator->canDelete(logged_user())) {
		if ($indicator->isTrashed()) {
			add_page_action(lang('restore from trash'), "javascript:if(confirm(lang('confirm restore objects'))) og.openLink('" . $indicator->getUntrashUrl() ."');", 'ico-restore', null, null, true);
			add_page_action(lang('delete permanently'), "javascript:if(confirm(lang('confirm delete permanently'))) og.openLink('" . $indicator->getDeletePermanentlyUrl() ."');", 'ico-delete', null, null, true);
		} else {
			add_page_action(lang('move to trash'), "javascript:if(confirm(lang('confirm move to trash'))) og.openLink('" . $indicator->getTrashUrl() ."');", 'ico-trash', null, null, true);
		}
	}
?>

<div style="padding:7px">
<div class="indicator">
<?php
	$content = '';
	
	tpl_assign("content", $content);
	tpl_assign("object", $indicator);
	tpl_assign('iconclass', 'ico-large-indicator');
	
	$this->includeTemplate(get_template_path('view', 'co'));
?>
</div>
</div>
<?php } ?>
