
INSERT INTO `<?php echo $table_prefix ?>object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`,`uses_order`) VALUES
 ('indicator', 'Indicators', 'indicators', 'content_object', 'indicator', (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='indicators'), 0),
 ('indicator_value', 'IndicatorValues', 'indicator_values', 'content_object', 'indicator_value', (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='indicators'), 0)
ON DUPLICATE KEY UPDATE id=id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
 SELECT dimension_id, dimension_object_type_id, (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='indicator'), 0, 1
 FROM `<?php echo $table_prefix ?>dimension_object_type_contents` x
 WHERE x.`content_object_type_id` = (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>dimension_object_type_contents.dimension_id=<?php echo $table_prefix ?>dimension_object_type_contents.dimension_id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
 SELECT dimension_id, dimension_object_type_id, (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='indicator_value'), 0, 1
 FROM `<?php echo $table_prefix ?>dimension_object_type_contents` x
 WHERE x.`content_object_type_id` = (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>dimension_object_type_contents.dimension_id=<?php echo $table_prefix ?>dimension_object_type_contents.dimension_id;

DELETE FROM `<?php echo $table_prefix ?>dimension_object_type_contents` WHERE `dimension_id`=0 OR dimension_id IS NULL;


INSERT INTO `<?php echo $table_prefix ?>tab_panels` (`id`,`title`,`icon_cls`,`refresh_on_context_change`,`default_controller`,`default_action`,`initial_controller`,`initial_action`,`enabled`,`type`,`ordering`,`plugin_id`,`object_type_id`) VALUES 
 ('indicators-panel', 'indicators', 'ico-indicators', 1, 'indicator', 'init', '', '', 1, 'system', 11, (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='indicators'), (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='indicator')) 
ON DUPLICATE KEY UPDATE id=id;

INSERT INTO <?php echo $table_prefix ?>max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 1, 1
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('indicator', 'indicator_value')
	 AND p.`name` IN ('Super Administrator','Administrator','Manager','Executive');

INSERT INTO <?php echo $table_prefix ?>max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 0, 0
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('indicator', 'indicator_value')
	 AND p.`name` IN ('Collaborator Customer','Internal Collaborator','External Collaborator','Guest Customer');

INSERT INTO <?php echo $table_prefix ?>role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 1, 1
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('indicator', 'indicator_value')
	AND p.`name` IN ('Super Administrator','Administrator','Manager','Executive');


-- add permissions to users where the users already have permissions (copy permissions from tasks)

INSERT INTO <?php echo $table_prefix ?>contact_member_permissions (permission_group_id, member_id, object_type_id, can_delete, can_write)
 SELECT cmp.permission_group_id, cmp.member_id, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='indicator'), cmp.can_delete, cmp.can_write 
 FROM <?php echo $table_prefix ?>contact_member_permissions cmp
 WHERE cmp.object_type_id = (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>contact_member_permissions.member_id=<?php echo $table_prefix ?>contact_member_permissions.member_id;

INSERT INTO <?php echo $table_prefix ?>contact_member_permissions (permission_group_id, member_id, object_type_id, can_delete, can_write)
 SELECT cmp.permission_group_id, cmp.member_id, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='indicator_value'), cmp.can_delete, cmp.can_write 
 FROM <?php echo $table_prefix ?>contact_member_permissions cmp
 WHERE cmp.object_type_id = (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>contact_member_permissions.member_id=<?php echo $table_prefix ?>contact_member_permissions.member_id;

INSERT INTO <?php echo $table_prefix ?>tab_panel_permissions (permission_group_id, tab_panel_id)
 SELECT pg.id, 'indicators-panel' FROM <?php echo $table_prefix ?>permission_groups pg WHERE pg.type='roles' AND pg.name IN ('Super Administrator','Administrator','Manager','Executive')
ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;

INSERT INTO <?php echo $table_prefix ?>tab_panel_permissions (permission_group_id, tab_panel_id)
 SELECT c.permission_group_id, 'indicators-panel' FROM <?php echo $table_prefix ?>contacts c 
 WHERE c.user_type IN (SELECT pg.id FROM <?php echo $table_prefix ?>permission_groups pg WHERE pg.type='roles' and pg.name IN ('Super Administrator','Administrator','Manager','Executive'))
ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;

-- general indicator custom properties
INSERT INTO `<?php echo $table_prefix ?>custom_properties` (`object_type_id`,`name`,`code`,`type`,`description`,`values`,`default_value`,`is_required`,`is_multiple_values`,`property_order`,`visible_by_default`, `is_special`, `is_disabled`) VALUES 
 ((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='indicator'),'Unit','indicator_unit','text','','','',0,0,1,1, 1,0),
 ((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='indicator'),'Description','indicator_description','memo','','','',0,0,2,1, 1,0)
ON DUPLICATE KEY UPDATE object_type_id=object_type_id;

-- indicator subtypes
INSERT INTO `<?php echo $table_prefix ?>object_subtypes` (`object_type_id`,`name`,`gender`,`code`,`created_on`,`created_by_id`) VALUES
((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='indicator'),'Numeric indicator','m','numeric_indicator',NOW(),0),
((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='indicator'),'Boolean indicator','m','boolean_indicator',NOW(),0);

-- custom properties for indicator subtypes
INSERT INTO `<?php echo $table_prefix ?>custom_properties` (`object_type_id`,`name`,`code`,`type`,`description`,`values`,`default_value`,`is_required`,`is_multiple_values`,`property_order`,`visible_by_default`, `is_special`, `is_disabled`, `object_subtype_id`) VALUES 
 ((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='indicator'),'Minimum desirable','min_desirable','numeric','','','',0,0,3,1, 1,0, (SELECT id FROM <?php echo $table_prefix ?>object_subtypes WHERE code='numeric_indicator')),
 ((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='indicator'),'Maximum desirable','max_desirable','numeric','','','',0,0,4,1, 1,0, (SELECT id FROM <?php echo $table_prefix ?>object_subtypes WHERE code='numeric_indicator')),
 ((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='indicator'),'Minimum acceptable','min_acceptable','numeric','','','',0,0,5,1, 1,0, (SELECT id FROM <?php echo $table_prefix ?>object_subtypes WHERE code='numeric_indicator')),
 ((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='indicator'),'Maximum acceptable','max_acceptable','numeric','','','',0,0,6,1, 1,0, (SELECT id FROM <?php echo $table_prefix ?>object_subtypes WHERE code='numeric_indicator')),
 ((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='indicator'),'Acceptable if','acceptable_if','boolean','','','',0,0,3,1, 1,0, (SELECT id FROM <?php echo $table_prefix ?>object_subtypes WHERE code='boolean_indicator'))
ON DUPLICATE KEY UPDATE object_type_id=object_type_id;

-- general indicator value custom properties
INSERT INTO `<?php echo $table_prefix ?>custom_properties` (`object_type_id`,`name`,`code`,`type`,`description`,`values`,`default_value`,`is_required`,`is_multiple_values`,`property_order`,`visible_by_default`, `is_special`, `is_disabled`) VALUES 
 ((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='indicator_value'),'Date','indicator_value_date','date','','','',0,0,1,1, 1,0)
ON DUPLICATE KEY UPDATE object_type_id=object_type_id;

-- indicator value subtypes
INSERT INTO `<?php echo $table_prefix ?>object_subtypes` (`object_type_id`,`name`,`gender`,`code`,`created_on`,`created_by_id`) VALUES
((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='indicator_value'),'Numeric value','m','numeric_indicator_value',NOW(),0),
((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='indicator_value'),'Boolean value','m','boolean_indicator_value',NOW(),0);

-- custom properties for indicator values subtypes
INSERT INTO `<?php echo $table_prefix ?>custom_properties` (`object_type_id`,`name`,`code`,`type`,`description`,`values`,`default_value`,`is_required`,`is_multiple_values`,`property_order`,`visible_by_default`, `is_special`, `is_disabled`, `object_subtype_id`) VALUES 
 ((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='indicator_value'),'Value','iv_num_value','numeric','','','',0,0,2,1, 1,0, (SELECT id FROM <?php echo $table_prefix ?>object_subtypes WHERE code='numeric_indicator_value')),
 ((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='indicator_value'),'Value','iv_bool_value','boolean','','','',0,0,2,1, 1,0, (SELECT id FROM <?php echo $table_prefix ?>object_subtypes WHERE code='boolean_indicator_value'))
ON DUPLICATE KEY UPDATE object_type_id=object_type_id;

-- indicator/ind_value dependency
INSERT INTO `<?php echo $table_prefix ?>object_type_dependencies` (`object_type_id`,`dependant_object_type_id`) VALUES
((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='indicator'),(SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='indicator_value'))
ON DUPLICATE KEY UPDATE object_type_id=object_type_id;

-- indicator/ind_value subtypes dependencies
INSERT INTO `<?php echo $table_prefix ?>object_subtype_dependencies` (`object_subtype_id`,`dependant_object_subtype_id`) VALUES
((SELECT id FROM <?php echo $table_prefix ?>object_subtypes WHERE code='numeric_indicator'),(SELECT id FROM <?php echo $table_prefix ?>object_subtypes WHERE code='numeric_indicator_value')),
((SELECT id FROM <?php echo $table_prefix ?>object_subtypes WHERE code='boolean_indicator'),(SELECT id FROM <?php echo $table_prefix ?>object_subtypes WHERE code='boolean_indicator_value'))
ON DUPLICATE KEY UPDATE object_subtype_id=object_subtype_id;
