<?php
class InvoicePaymentReceiptInvoice extends BaseInvoicePaymentReceiptInvoice {
		
	
	private $invoice = null;
	private $payment_receipt = null;

	/**
	 * 
	 * {@inheritDoc}
	 * @see DataObject::manager()
	 */
	function manager() {
		if (!($this->manager instanceof InvoicePaymentReceiptInvoices))
			$this->manager = InvoicePaymentReceiptInvoices::instance();
		return $this->manager;
	}
	
	
	function getArrayInfo() {
		$info = array();
		
		$columns = $this->getColumns();
		foreach ($columns as $col) {
			$info[$col] = $this->getColumnValue($col);
			if ($info[$col] instanceof DateTimeValue) $info[$col] = format_date($info[$col], null, 0);
		}
		
		return $info;
	}
	
	function getInvoice() {
		if ($this->invoice == null) {
			$this->invoice = IncomeInvoices::instance()->findById($this->getInvoiceId());
		}
		return $this->invoice;
	}
	
	function getPaymentReceipt() {
		if ($this->payment_receipt == null) {
			$this->payment_receipt = InvoicePaymentReceipts::instance()->findById($this->getPaymentReceiptId());
		}
		return $this->payment_receipt;
	}
	
	function recalculateInvoicePaidAmount() {
		return $this->manager()->recalculateInvoicePaidAmount($this->getInvoiceId());
	}
	
	function save() {
		
		$ok = parent::save();
		
		$this->recalculateInvoicePaidAmount();
		
		return $ok;
	}
}

