<?php 

class InvoicePaymentReceiptInvoices extends BaseInvoicePaymentReceiptInvoices {
	
	function getByInvoiceAndPaymentReceiptId($invoice_id, $payment_receipt_id) {
		return self::instance()->findOne(array("conditions" => array("invoice_id=? AND payment_receipt_id=?", $invoice_id, $payment_receipt_id)));
	}
	
	function getByInvoiceId($invoice_id) {
		return self::instance()->findAll(array("conditions" => array("invoice_id=? AND 0=(SELECT o.trashed_by_id FROM ".TABLE_PREFIX."objects o WHERE o.id=payment_receipt_id)", $invoice_id)));
	}
	
	function getByPaymentReceiptId($payment_receipt_id) {
		return self::instance()->findAll(array("conditions" => array("payment_receipt_id=?", $payment_receipt_id)));
	}
	
	function getAffectedInvoices($payment_receipt_id) {
		return IncomeInvoices::instance()->findAll(array(
			"conditions" => array("id IN (SELECT invoice_id FROM ".$this->getTableName()." WHERE payment_receipt_id=?) AND o.trashed_by_id=0", $payment_receipt_id)
		));
	}
	
	
	function recalculateInvoicePaidAmount($invoice_id) {
		
		$invoice = IncomeInvoices::instance()->findById($invoice_id);
		if ($invoice instanceof IncomeInvoice) {
			$invoice->recalcualtePaidAndDueAmounts();
		}

		// update project member financial values (total due and total paid amounts)
		if (Plugins::instance()->isActivePlugin('advanced_billing')) {
			
			if ($invoice instanceof IncomeInvoice) {
				Env::useHelper('persisting_member_totals_functions', 'advanced_billing');
				Env::useHelper('persist_member_invoice_totals', 'income');

				update_invoice_total_info_for_member($invoice);
			}
		}
	}
}
