<?php 

class InvoicePaymentReceipts extends BaseInvoicePaymentReceipts {
	function __construct() {
		parent::__construct();
		$this->object_type_name = 'invoice_payment_receipt';
	}
	
	static function getPaymentsForInvoiceIds($invoice_ids) {
		if (!is_array($invoice_ids)) {
			if (is_numeric($invoice_ids)) $invoice_ids = array($invoice_ids);
		}
		if (!is_array($invoice_ids)) {
			return array();
		} else {
			$invoice_ids = array_filter($invoice_ids, 'is_numeric');
		}
		
		if (is_array($invoice_ids) && count($invoice_ids) > 0) {
			$grouped_payments = array();
			$inv_payments = DB::executeAll("SELECT * FROM ".TABLE_PREFIX."invoice_payment_receipt_invoices WHERE invoice_id IN (".implode(',', $invoice_ids).")");

			$date_cp = CustomProperties::getCustomPropertyByCode(InvoicePaymentReceipts::instance()->getObjectTypeId(), 'date');
			$external_transaction_cp = CustomProperties::getCustomPropertyByCode(InvoicePaymentReceipts::instance()->getObjectTypeId(), 'external_transaction_id');

			foreach ($inv_payments as &$ip) {
				
				$p_receipt = DB::executeOne("SELECT * FROM ".TABLE_PREFIX."invoice_payment_receipts pr INNER JOIN ".TABLE_PREFIX."objects o ON o.id=pr.object_id WHERE pr.object_id=".$ip['payment_receipt_id']. " AND o.trashed_by_id=0 AND o.archived_by_id=0");

				if(!$p_receipt) continue;
				
				$ip['name'] = $p_receipt['name'];
				
				$cp_val = CustomPropertyValues::getCustomPropertyValue($ip['payment_receipt_id'], $date_cp->getId());
				$date = '';
				if ($cp_val instanceof CustomPropertyValue) $date = $cp_val->getValue();
				$ip['date'] = $date;

				$cp_val = CustomPropertyValues::getCustomPropertyValue($ip['payment_receipt_id'], $external_transaction_cp->getId());
				$ext_transaction_id = '';
				if ($cp_val instanceof CustomPropertyValue) $ext_transaction_id = $cp_val->getValue();
				$ip['ext_transaction_id'] = $ext_transaction_id;

				if (!isset($grouped_payments[$ip['invoice_id']])) $grouped_payments[$ip['invoice_id']] = array();
				$grouped_payments[$ip['invoice_id']][] = $ip;
			}

			return $grouped_payments;			

		} else {
			return array();
		}
	}
	
	
	function getColumnsToAggregateInTotals() {
		return array(
			'amount' => array('operation' => 'sum', 'format' => 'money', 'currency_id_col' => 'currency_id', 'group_by' => 'currency_id'),
			'balance' => array('operation' => 'sum', 'format' => 'money', 'currency_id_col' => 'currency_id', 'group_by' => 'currency_id'),
		);
	}
}
