<?php 
	$genid = gen_id();
	$invoice_payment_receipt = $invoice_payment_receipt;
	$currencies = Currencies::getAllCurrencies();
	$show_currencies = count($currencies) > 1;
	/* @var $payment_receipt InvoicePaymentReceipt */
	
	// on submit functions
	if (array_var($_REQUEST, 'modal')) {
		$on_submit = "og.submit_modal_form('".$genid."submit-edit-form'); return false;";
	} else {
		$on_submit = "return true;";
	}
	
	$categories = array();
	Hook::fire('object_edit_categories', $invoice_payment_receipt, $categories);

	$main_cp_count = CustomProperties::countVisibleCustomPropertiesByObjectType($invoice_payment_receipt->getObjectTypeId());
	$other_cp_count = CustomProperties::countHiddenCustomPropertiesByObjectType($invoice_payment_receipt->getObjectTypeId());
		
	$is_new_pr = $invoice_payment_receipt->isNew() ? '1' : '0';
	
	$selected_member_ids = null;
	if (isset($for_invoice) && $for_invoice instanceof IncomeInvoice) {
		$selected_member_ids = $for_invoice->getMemberIds();
		
		$invoice_payment_receipt->setCurrencyId($for_invoice->getCurrencyId());
		$invoice_payment_receipt->setAmount($for_invoice->getColumnValue('due_amount'));
	}
	
	$invoices_tab_disabled = income_config_option('disable_general_invoices_tab');
?>

<form class="add-invoice-payment-receipt" id="<?php echo $genid ?>submit-edit-form" onsubmit="<?php echo $on_submit?>" action="<?php echo $invoice_payment_receipt->isNew() ? get_url('invoice_payment_receipt', 'add') : $invoice_payment_receipt->getEditUrl() ?>" method="post" enctype="multipart/form-data" >
<div class="invoice-payment-receipt">
<div class="coInputHeader">

  <div class="coInputHeaderUpperRow">
	<div class="coInputTitle">
		<?php echo $invoice_payment_receipt->getAddEditFormTitle(); ?>
	</div>
  </div>

  <div>
      
	<div class="coInputName">
		<?php echo text_field('invoice_payment_receipt[name]', $invoice_payment_receipt->getName(), array('id' => $genid . 'payment_receipt_name', 'class' => 'title', 'placeholder' => lang('type name here'))) ?>
	</div>	
	<div class="coInputButtons" style="float: right;">
		<?php echo submit_button($invoice_payment_receipt->getSubmitButtonFormTitle(),'s', array('style'=>'margin-top:0px;margin-left:10px;', 'id' => $genid.'submit_button')) ?>
	</div>
	<div class="clear"></div>
  </div>
</div>

<div class="coInputMainBlock">
	
	<input id="<?php echo $genid?>genid" type="hidden" name="genid" value="<?php echo $genid ?>">
	<input id="<?php echo $genid?>for_invoice_id" type="hidden" name="for_invoice_id" value="<?php echo (isset($for_invoice) && $for_invoice instanceof IncomeInvoice ? $for_invoice->getId() : 0) ?>">
	
	<div id="<?php echo $genid?>tabs" class="edit-form-tabs">
	
		<ul id="<?php echo $genid?>tab_titles">
		
			<li><a href="#<?php echo $genid?>add_payment_details"><?php echo lang('details') ?></a></li>
			
			<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
			<li><a href="#<?php echo $genid?>add_custom_properties_div"><?php echo lang('custom properties') ?></a></li>
			<?php } ?>
			
			<li><a href="#<?php echo $genid?>add_subscribers_div"><?php echo lang('object subscribers') ?></a></li>
			
			<?php if($invoice_payment_receipt->isNew() || $invoice_payment_receipt->canLinkObject(logged_user())) { ?>
			<li><a href="#<?php echo $genid?>add_linked_objects_div"><?php echo lang('linked objects') ?></a></li>
			<?php } ?>
			
			<?php foreach ($categories as $category) {
					if (array_var($category, 'hidden')) continue;
				?>
			<li><a href="#<?php echo $genid . $category['name'] ?>"><?php echo $category['name'] ?></a></li>
			<?php } ?>
		</ul>
	
		<div id="<?php echo $genid ?>add_payment_details" class="form-tab">
		
			<div id="payment-receipt-details">
			
			<!-- LEFT BOTTOM SECTION OF THE FORM -->
			<div class="left-section">
			
			
			<div class="dataBlock"><?php
				echo label_tag(lang('amount'), null, true);
				echo currency_selector('invoice_payment_receipt[currency_id]', $invoice_payment_receipt->getCurrencyId(), array('id' => $genid . 'currency_id'));
				echo text_field('invoice_payment_receipt[amount]', format_amount($invoice_payment_receipt->getAmount(),2), array('id' => $genid . 'amount', 'class' => 'amount'));
			?></div>
			<div class="clear"></div>

			<div class="main-custom-properties-div"><?php
				if ($main_cp_count) {
					echo render_object_custom_properties($invoice_payment_receipt, false, null, 'visible_by_default');
				}
			?></div>
			<div class="clear"></div>
			
			</div> 
			<!-- END OF LEFT BOTTOM SECTION -->




			<!-- RIGHT BOTTOM SECTION OF THE FORM -->
			<div class="right-section">

			<?php $null = null; Hook::fire('before_render_member_selectors', array('object' => $invoice_payment_receipt, 'genid' => $genid), $null);?>
		
			<div id="<?php echo $genid ?>add_payment_select_context_div" class="dataBlock"> 
				<?php
				
				$update_receipt_name_fn = "og.invoice_payment_receipts.reload_invoices_to_affect('".$genid."');";
				
				$listeners = array(
					'on_remove_relation' => $update_receipt_name_fn,
					'on_selection_change' => 'og.reload_subscribers("'.$genid.'",'.$invoice_payment_receipt->manager()->getObjectTypeId().');'
						. $update_receipt_name_fn
				);
				Hook::fire('modify_member_selector_listeners', array('genid' => $genid, 'object' => $invoice_payment_receipt), $listeners);
				
				$skipped_dimensions = array();
				Hook::fire('add_member_selector_skipped_dimensions', array('genid' => $genid, 'object' => $invoice_payment_receipt), $skipped_dimensions);
				
				if ($invoice_payment_receipt->isNew()) {
					render_member_selectors($invoice_payment_receipt->manager()->getObjectTypeId(), $genid, $selected_member_ids, array('select_current_context' => !$selected_member_ids, 'listeners' => $listeners, 'object' => $invoice_payment_receipt, 'dont_select_associated_members'=>true), $skipped_dimensions, null, false);
				} else {
					render_member_selectors($invoice_payment_receipt->manager()->getObjectTypeId(), $genid, $invoice_payment_receipt->getMemberIds(), array('listeners' => $listeners, 'object' => $invoice_payment_receipt, 'dont_select_associated_members'=>true), $skipped_dimensions, null, false);
				}
				?>
			</div>
			<div class="clear"></div>
			
			<?php $null = null; Hook::fire('after_render_member_selectors', array('object' => $invoice_payment_receipt, 'genid' => $genid), $null);?>

			<?php $null = null; Hook::fire('before_render_main_custom_properties', array('object' => $invoice_payment_receipt, 'genid' => $genid), $null);?>
			
			</div> 
			<div class="clear"></div>
			<!-- END OF RIGHT BOTTOM SECTION -->
			
			<div style="<?php echo ($invoices_tab_disabled ? "display:none;" : "") ?>">
				<table class="affected-invoices" id="<?php echo $genid ?>affected_invoices">
					<thead>
					<tr>
						<th><?php echo lang('invoice')?></th>
						<th><?php echo lang('date')?></th>
						<th class="right"><?php echo lang('total')?></th>
						<th class="right"><?php echo lang('pending amount')?></th>
						<th class="right"><?php echo lang('amount to pay')?></th>
					</tr>
					</thead>
					<tbody>
					</tbody>
				</table>
			</div>

			<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
			<div id="<?php echo $genid ?>add_custom_properties_div" class="form-tab other-custom-properties-div">
				<?php  echo render_object_custom_properties($invoice_payment_receipt, false, null, 'other') ?>
				<?php  echo render_add_custom_properties($invoice_payment_receipt); ?>
			</div>
			<?php } ?>
			</div>
			
		</div>
		
	
		<div id="<?php echo $genid ?>add_subscribers_div" class="form-tab">
			<div id="<?php echo $genid ?>add_subscribers_content"><?php
				$subscribers = $invoice_payment_receipt->isNew() ? array(logged_user()) : $invoice_payment_receipt->getSubscribers();
				
				echo render_add_subscribers($invoice_payment_receipt, $genid, $subscribers);
				
				if (isset($subscriber_ids) && is_array($subscriber_ids)) {
					foreach ($subscriber_ids as $subid) {
						echo '<input type="hidden" name="subscribers[user_'.$subid.']" value="1"/>';
					}
				}
			?></div>
		</div>
	
		<?php if($invoice_payment_receipt->isNew() || $invoice_payment_receipt->canLinkObject(logged_user())) { ?>
		<div id="<?php echo $genid ?>add_linked_objects_div" class="form-tab">
			<?php echo render_object_link_form($invoice_payment_receipt) ?>
		</div>
		<?php } // if ?>
		
		
		
		
		<?php foreach ($categories as $category) { ?>
		<div id="<?php echo $genid . $category['name'] ?>" class="form-tab">
			<?php echo $category['content'] ?>
		</div>
		<?php } ?>

	</div>
	<?php if (!array_var($_REQUEST, 'modal')) {
		echo submit_button($invoice_payment_receipt->isNew() ? lang('add payment receipt') : lang('save changes'),'s', array('tabindex' => '20000')); 
	}?>
	<div class="clear"></div>
</div>
<div class="clear"></div>
</div>
</form>

<script>
var genid = '<?php echo $genid?>';

$(function(){
	$("#<?php echo $genid?>tabs").tabs();
	
	// if payment amount is changed then recalculate every line in the affected invoices table
	$("#" + genid + "amount").change(function() {
		//og.invoice_payment_receipts.fix_amount_if_exceeds_pending_sum('<?php echo $genid?>');
		$(this).val(og.format_money_amount($(this).val()));
		og.invoice_payment_receipts.recalculate_amounts_to_pay('<?php echo $genid?>');
	});

	var invoices_to_affect = {
			invoices: []
	};
<?php 
	// initialize affected invoices table
	if (isset($affected_invoices) && count($affected_invoices) > 0) {
		foreach ($affected_invoices as $affected_invoice) {
?>
	invoices_to_affect.invoices.push({
		id: '<?php echo $affected_invoice['id'] ?>',
		name: '<?php echo escape_character($affected_invoice['name']) ?>',
		date: '<?php echo $affected_invoice['date'] ?>',
		total: '<?php echo $affected_invoice['total'] ?>',
		currency_id: '<?php echo $affected_invoice['currency_id'] ?>',
		pending_amount: '<?php echo $affected_invoice['pending_amount'] + $affected_invoice['to_pay'] ?>',
		to_pay: '<?php echo $affected_invoice['to_pay'] ?>'
	});
<?php			
		}
?>
	og.invoice_payment_receipts.render_invoices_to_affect('<?php echo $genid ?>', invoices_to_affect);
<?php 
	} else {
?>
	og.invoice_payment_receipts.reload_invoices_to_affect('<?php echo $genid ?>');
<?php 
	}
?>
});

</script>