
<div>
	<table class="affected-invoices" id="<?php echo $genid ?>affected_invoices">
		<thead>
		<tr>
			<th><?php echo lang('invoice')?></th>
			<th><?php echo lang('date')?></th>
			<th class="right"><?php echo lang('total')?></th>
			<th class="right"><?php echo lang('amount paid')?></th>
		</tr>
		</thead>
		<tbody>
		
<?php
/* @var $invoice_pr InvoicePaymentReceipt */
$sym = $currency_symbol;
$all_invoices_total = 0;
$total_affected_amount = 0;
foreach ($payment_invoices as $payment_invoice) {
	/* @var $payment_invoice InvoicePaymentReceiptInvoice */
	
	$invoice = IncomeInvoices::instance()->findById($payment_invoice->getInvoiceId());
	
	$currency = Currencies::instance()->getCurrency($payment_invoice->getCurrencyId());
	if ($currency) $sym = $currency->getSymbol();
	
	$inv_name = $invoice->getObjectName();
	$inv_date = $invoice->getDate() ? format_date($invoice->getDate(), null, 0) : '';
	$inv_total = format_money_amount($invoice->getTotal(), $sym);
	$amount_paid = format_money_amount($payment_invoice->getAmount(), $sym);
	
	$all_invoices_total += $invoice->getTotal();
	$total_affected_amount += $payment_invoice->getAmount();
	
?>
		<tr>
			<td><a href="<?php echo $invoice->getViewUrl() ?>" class="internalLink"><?php echo $inv_name ?></a></td>
			<td><?php echo $inv_date ?></td>
			<td class="right"><?php echo $inv_total ?></td>
			<td class="right"><?php echo $amount_paid ?></td>
		</tr>
<?php 	
}
?>
		<tr class="affected-invoices-totals-row">
			<td class="bold"><?php echo lang('total')?></td>
			<td></td>
			<td class="right bold"><?php echo format_money_amount($all_invoices_total, $sym) ?></td>
			<td class="right bold"><?php echo format_money_amount($total_affected_amount, $sym) ?></td>
		</tr>
		
<?php 
$balance = $invoice_pr->getAmount() > $total_affected_amount ? $invoice_pr->getAmount() - $total_affected_amount : 0;
?>
		<tr class="affected-invoices-totals-row">
			<td class="bold"><?php echo lang('balance')?></td>
			<td></td>
			<td></td>
			<td class="right bold <?php echo ($balance>0 ? 'positive-balance' : '') ?>"><?php echo format_money_amount($invoice_pr->getAmount() - $total_affected_amount, $sym) ?></td>
		</tr>
		
		</tbody>
	</table>
</div>

