<?php 
	if (!isset($genid)) $genid = gen_id(); 
?>
<div class="invoice-payments">

<div>
	<table class="invoice-lines" id="<?php echo $genid ?>affected_invoices">
		<thead>
		<tr>
			<th><?php echo lang('payments and credit notes')?></th>
			<th><?php echo lang('date')?></th>
			<th class="right"><?php echo lang('amount paid')?></th>
			<th class="right"><?php echo lang('amount due')?></th>
		</tr>
		</thead>
		<tbody>
		
<?php
/* @var $invoice IncomeInvoice */

$payment_invoices = InvoicePaymentReceiptInvoices::instance()->getByInvoiceId($invoice->getId());

$sym = '$';
$currency = Currencies::instance()->getCurrency($invoice->getCurrencyId());
if ($currency) $sym = $currency->getSymbol();

$date_cp = CustomProperties::getCustomPropertyByCode(InvoicePaymentReceipts::instance()->getObjectTypeId(), 'date');

foreach ($payment_invoices as $payment_invoice) {
	/* @var $payment_invoice InvoicePaymentReceiptInvoice */
	
	$payment_receipt = $payment_invoice->getPaymentReceipt();
	
	$payment_date = '';
	$date_str = '';
	$date_cpval = CustomPropertyValues::getCustomPropertyValue($payment_receipt->getId(), $date_cp->getId());
	if ($date_cpval) $date_str = $date_cpval->getValue();
	if ($date_str != '') {
		$dt = DateTimeValueLib::dateFromFormatAndString(DATE_MYSQL, $date_str);
		if ($dt) $payment_date = format_date($dt, null, 0);
	}
	
	$pr_name = $payment_receipt->getObjectName();
	$amount_paid = format_money_amount($payment_invoice->getAmount(), $sym);
	
?>
		<tr>
			<td><a href="<?php echo $payment_receipt->getViewUrl() ?>" class="internalLink"><?php echo $pr_name ?></a></td>
			<td><?php echo $payment_date ?></td>
			<td class="right"><?php echo $amount_paid ?></td>
			<td></td>
		</tr>
<?php 	
}

// show also credit notes
$credit_notes_references = $invoice->getCreditNoteReferences();
foreach ($credit_notes_references as $invoice_ref) {
	$amount_paid = format_money_amount($invoice_ref->getAmount(), $sym);
	$cred_note = $invoice_ref->getMainObject();
	if ($cred_note instanceof IncomeInvoice) {
		$cred_note_date = $cred_note->getDate() ? format_date($cred_note->getDate(),null,0) : '';
?>
	<tr>
		<td><a href="<?php echo $cred_note->getViewUrl() ?>" class="internalLink"><?php echo $cred_note->getInvoiceType() ." ". $cred_note->getName() ?></a></td>
		<td><?php echo $cred_note_date ?></td>
		<td class="right"><?php echo $amount_paid ?></td>
		<td></td>
	</tr>
<?php 
	}
}

?>
		<tr class="separator">
			<td class="bold"><?php echo lang('total') ?></td>
			<td></td>
			<td class="right bold"><?php echo format_money_amount($invoice->getColumnValue('paid_amount'), $sym) ?></td>
			<td class="right bold"><?php echo format_money_amount($invoice->getColumnValue('due_amount'), $sym) ?></td>
		</tr>

		</tbody>
	</table>
</div>
</div>
