<?php
Env::useHelper('format');
if (isset($invoice_pr) && $invoice_pr instanceof InvoicePaymentReceipt) {
	$genid = gen_id();
	if (!$invoice_pr->isTrashed()){
		if($invoice_pr->canEdit(logged_user())) {
			add_page_action(lang('edit'), "javascript:og.render_modal_form('', {c:'invoice_payment_receipt', a:'edit', params: {id:".$invoice_pr->getId()."}});", 'ico-edit', null, null, true);
			if (!$invoice_pr->isArchived())
				add_page_action(lang('archive'), "javascript:if(confirm(lang('confirm archive object'))) og.openLink('" . $invoice_pr->getArchiveUrl() ."');", 'ico-archive-obj');
			else
				add_page_action(lang('unarchive'), "javascript:if(confirm(lang('confirm unarchive object'))) og.openLink('" . $invoice_pr->getUnarchiveUrl() ."');", 'ico-unarchive-obj');
		} // if
	}
	if ($invoice_pr->canDelete(logged_user())) {
		if ($invoice_pr->isTrashed()) {
			add_page_action(lang('restore from trash'), "javascript:if(confirm(lang('confirm restore objects'))) og.openLink('" . $invoice_pr->getUntrashUrl() ."');", 'ico-restore', null, null, true);
			add_page_action(lang('delete permanently'), "javascript:if(confirm(lang('confirm delete permanently'))) og.openLink('" . $invoice_pr->getDeletePermanentlyUrl() ."');", 'ico-delete', null, null, true);
		} else {
			add_page_action(lang('move to trash'), "javascript:og.invoice_payment_receipts.trash(" . $invoice_pr->getObjectId() .");", 'ico-trash', null, null, true);
		}
	}
?>

<div style="padding:7px">
<div class="invoice-payment-receipt">
<?php
	
	$content = '';
		
	$c_symbol = '$';
	$currency = Currencies::instance()->findById($invoice_pr->getCurrencyId());
	if ($currency instanceof Currency) {
		$c_symbol = $currency->getSymbol();
	}

	$content .= '<div class="property"><span class="bold ">'.lang('amount paid').': </span>'.format_money_amount($invoice_pr->getAmount(), $c_symbol).'</div>';
	$content .= '<div class="clear"></div>';
	
	$payment_invoices = InvoicePaymentReceiptInvoices::instance()->getByPaymentReceiptId($invoice_pr->getId());
	tpl_assign('genid', $genid);
	tpl_assign('invoice_pr', $invoice_pr);
	tpl_assign('payment_invoices', $payment_invoices);
	tpl_assign('currency_symbol', $c_symbol);
	$content .= tpl_fetch(get_template_path('affected_invoices_table', 'invoice_payment_receipt', 'invoice_payment_receipts'));
	
	/*
	if (trim($invoice_pr->getDocumentId()) != "" && $can_see_cost_info) {
		$preview_url = get_url('files', 'get_public_file', array('id' => $invoice_pr->getDocumentId()));
		
		try {
			$file_attributes = FileRepository::getFileAttributes($invoice_pr->getDocumentId());
		} catch (FileNotInRepositoryError $e) {
			$file_attributes = null;
		}
		if (!is_null($file_attributes)) {
			$content .= '<div class="expense-property"><div class="bold">'.lang('receipt image').': </div>';
			
			if ($file_attributes['type'] == 'application/pdf') {
				$content .= '<iframe src="'.$preview_url.'" style="width:100%; min-height:350px; max-width: 100%; border:0px none;"></iframe>';
			} else {
				$content .= '<a href="'.$preview_url.'" target="_blank">';
				$content .= '<img alt="" src="'.$preview_url.'" style="max-width: 100%;"/>';
				$content .= '</a></div>';
			}
		}			
	}*/
	
	tpl_assign("content", $content);
	tpl_assign("object", $invoice_pr);
	tpl_assign('iconclass', $invoice_pr->isTrashed()? 'ico-large-invoice-payment-receipt-trashed' : ($invoice_pr->isArchived() ? 'ico-large-invoice-payment-receipt-archived' : 'ico-large-invoice-payment-receipt'));
	
	$this->includeTemplate(get_template_path('view', 'co'));
	
?>
</div>
</div>

<?php } //if isset ?>
