<?php
Hook::register('invoice_payment_receipts');


function invoice_payment_receipts_view_invoice_additional_sections($parameters, &$info) {
	$invoice = array_var($parameters, 'invoice');
	
	tpl_assign('invoice', $invoice);
	tpl_display(get_template_path('invoice_payments_table', 'invoice_payment_receipt', 'invoice_payment_receipts'));
}


function invoice_payment_receipts_render_page_actions($invoice, &$ret) {
	if ($invoice instanceof IncomeInvoice && !$invoice->isTrashed()){
		// remove mark as paid action
		PageActions::instance()->removeAction('ico-complete');
		
		// add action to pay this invoice
		$action_url = "javascript:og.render_modal_form('', {c:'invoice_payment_receipt', a:'add', params: {invoice_id:".$invoice->getId()."}});";
		add_page_action(lang('add payment'), $action_url, 'ico-invoice-payment-receipt', null, null, true);
	}
}


function invoice_payment_receipts_custom_reports_override_column_format($parameters, &$value) {
	$report = array_var($parameters, 'report');
	$manager = array_var($parameters, 'manager');
	$field = array_var($parameters, 'field');
	$object = array_var($parameters, 'object');
	
	if ($manager instanceof InvoicePaymentReceipts && in_array($field, array('amount','balance'))) {
		$currency = Currencies::instance()->getCurrency($object->getCurrencyId());
		$csymbol = null;
		if ($currency instanceof Currency) {
			$csymbol = $currency->getSymbol();
		}
		$value = format_money_amount($value, $csymbol);
	}
}

function invoice_payment_receipts_add_allowed_object_types_to_import($parameters, &$allowed_object_types_to_import){
	$allowed_object_types_to_import[] = 'invoice_payment_receipt';
}


function invoice_payment_receipts_on_invoice_recalculate_paid_amount($invoice, &$total_paid_amount) {

	$grouped_payments = InvoicePaymentReceipts::getPaymentsForInvoiceIds($invoice->getId());
	$invoice_payments = array_var($grouped_payments, $invoice->getId(), array());
	foreach ($invoice_payments as $invoice_payment) {
		$total_paid_amount += $invoice_payment['amount'];
	}

}
