og.invoice_payment_receipts = {
	init: function () {
		

		//columns: og.expenses2.payment_receipt_list_grid_config.columns,
		//tbar_items: og.expenses2.payment_receipt_list_grid_config.tbar_items,
		//filters: og.expenses2.payment_receipt_list_grid_config.filters
		
		if (!og.income.additional_panels) og.income.additional_panels = [];
		
		og.income.additional_panels.push({
			id: 'invoice-payment-receipts-subtab',
			grid_id: 'invoice-payment-receipts-manager',
			title: lang('invoice_payment_receipts'),
			type_name: 'invoice_payment_receipt',
			response_objects_root: 'invoice_payment_receipts',
			controller: 'invoice_payment_receipt',
			action: 'list_all',
			columns: this.get_grid_columns(),
			tbar_items: this.grid_config.tbar_items,
			filters: this.grid_config.filters,
		});
		
		/*
		if (!og.invoices.additional_list_columns) og.invoices.additional_list_columns = [];
		og.invoices.additional_list_columns.push({name:'paid_amount', text:lang('paid'), align:'right', renderer: og.invoice_payment_receipts.render_grid_amount});
		og.invoices.additional_list_columns.push({name:'due_amount', text:lang('due'), align:'right', renderer: og.invoice_payment_receipts.render_grid_amount});
		*/
	},
	/*
	render_grid_amount: function(value, p, r) {
		if (r.data.id == '__total_row__') return value;
		var currency = og.get_currency_by_id(r.data.currency_id);
		var sym = currency ? currency.symbol : '$';
		return '<div class="right">' + sym + ' ' + og.format_money_amount(value, 2) + '</div>';
	},*/

	get_grid_columns: function() {
		var columns = [
			{ name:'amount', header:lang('amount'), sortable:true, align:'right' },
			{ name:'balance', header:lang('balance'), sortable:true, align:'right', renderer: og.invoice_payment_receipts.render_balance_column },
		];

		if (og.invoice_payment_receipts.additional_list_columns && og.invoice_payment_receipts.additional_list_columns.length>0) {
			for (var x=0; x<og.invoice_payment_receipts.additional_list_columns.length; x++) {
				columns.push(og.invoice_payment_receipts.additional_list_columns[x]);
			}
 		}

		return columns;
	},

	render_balance_column: function(value, p, r){
		if (isNaN(r.data.object_id)) return;

		// remove currency and get the number
		let splitted = value.split(" ");
		let balance_amount = parseFloat(splitted[1]);

		let cell_cls = balance_amount > 0 ? "positive-balance" : "";

		let html = '<span class="'+ cell_cls +'">' + value + '</span>';

		return html;
	},
	
	grid_config: {
		
		//columns: og.invoice_payment_receipts.get_grid_columns(),
		
		tbar_items: [
			new Ext.Action({
				id: 'new_invoice_payment_receipt_btn',
				text: lang('add new invoice payment receipt'),
		        iconCls: 'ico-new',
		        handler: function() {
		        	og.render_modal_form('', {c:'invoice_payment_receipt', a:'add'});
				}
			}),
			
			new Ext.Action({
				text: lang('edit'),
			    tooltip: lang('edit selected object'),
			    iconCls: 'ico-edit',
				disabled: true,
				handler: function() {
					var man = Ext.getCmp('invoice-payment-receipts-manager');
					og.render_modal_form('', {c:'invoice_payment_receipt', a:'edit', params: {id:man.getFirstSelectedId()}});
				},
				selection_dependant: true,
				is_multiple: false
			}),
			
			new Ext.Action({
				text: lang('move to trash'),
			    tooltip: lang('move selected objects to trash'),
			    iconCls: 'ico-trash',
				disabled: true,
				handler: function() { 
					var man = Ext.getCmp('invoice-payment-receipts-manager');
					og.openLink(og.getUrl('invoice_payment_receipt', 'check_payment_receipts_integration_status', {ids: man.getSelectedIds()}), {
						hideLoading: true,
						callback: function(success, data) {
							if(data.result){
								if (confirm(lang('confirm move to trash'))) {
									man.load({
										action: 'delete',
										ids: man.getSelectedIds()
									});
									man.getSelectionModel().clearSelections();
								}
							}
						}
					});
				},
				selection_dependant: true,
				is_multiple: true
			}),
		
			new Ext.Action({
				text: lang('archive'),
			    tooltip: lang('archive selected object'),
			    iconCls: 'ico-archive-obj',
				disabled: true,
				handler: function() {
					if (confirm(lang('confirm archive selected objects'))) {
						var man = Ext.getCmp('invoice-payment-receipts-manager');
						man.load({
							action: 'archive',
							ids: man.getSelectedIds()
						});
						man.getSelectionModel().clearSelections();
					}
				},
				selection_dependant: true,
				is_multiple: true
			})
		],
		
		filters: [],
	},
	
	get_affected_invoice_table_row_html: function(genid, invoice, i) {
		
		var sym = '$';
		var currency = og.get_currency_by_id(invoice.currency_id);
		if (currency) currency.symbol = currency.symbol;
		
		var html = '<tr>'+
			'<td class="name" id="'+genid+'inv_name_'+i+'">' + invoice.name +
				'<input type="hidden" id="'+genid+'inv_id_'+i+'" name="invoices['+i+'][id]" value="'+ invoice.id +'" />'+
			'</td>'+
			'<td class="date" id="'+genid+'inv_date_'+i+'">' + invoice.date + '</td>'+
			'<td class="amount right">' + sym + ' ' + og.format_money_amount(invoice.total) +
				'<input type="hidden" id="'+genid+'inv_total_'+i+'" name="invoices['+i+'][total]" value="'+ invoice.total +'" />'+
			'</td>'+
			'<td class="amount right">' + sym + ' ' + og.format_money_amount(invoice.pending_amount) +
				'<input type="hidden" class="amount_pending" id="'+genid+'inv_pending_'+i+'" name="invoices['+i+'][pending]" value="'+ invoice.pending_amount +'" />'+
			'</td>'+
			'<td class="amount right">' + sym + ' ' +
				'<input type="hidden" id="'+genid+'inv_currency_id_'+i+'" name="invoices['+i+'][currency_id]" value="'+ invoice.currency_id +'" />'+
				'<input type="text" class="right amount_to_pay" id="'+genid+'inv_to_pay_'+i+'" name="invoices['+i+'][to_pay]" value="'+ og.format_money_amount(invoice.to_pay) +'"'+
					'onchange="og.invoice_payment_receipts.validate_to_pay(\''+genid+'\','+i+',this)" />'+
			'</td>'+
		'</tr>';
		
		return html;
	},
	
	get_affected_invoice_table_totals_row_html: function(genid, totals_obj, count) {
		var sym = '$';
		var currency = og.get_currency_by_id(totals_obj.currency_id);
		if (currency) sym = currency.symbol;
		
		var html = '<tr class="affected-invoices-totals-row">'+
			'<td class="name" colspan="2">' + count +' '+lang('pending invoices')+'</td>'+
			'<td class="amount right">' + sym + ' ' + og.format_money_amount(totals_obj.total) +'</td>'+
			'<td class="amount right">' + sym + ' ' + og.format_money_amount(totals_obj.pending_amount) +'</td>'+
			'<td class="amount right" id="'+genid+'total_to_pay">' + sym + ' ' + og.format_money_amount(totals_obj.to_pay) +'</td>'+
		'</tr>';
		
		var payment_amount = parseFloat(og.clean_thousand_separator($("#" + genid + "amount").val()));
		var positive_balance = 0;
		if (payment_amount > totals_obj.to_pay) positive_balance = payment_amount - totals_obj.to_pay;
		var pb_class = positive_balance > 0 ? 'positive-balance' : '';
		
		html += '<tr class="affected-invoices-totals-row">'+
			'<td class="name" colspan="2">' + lang('balance')+'</td>'+
			'<td class="amount right"></td>'+
			'<td class="amount right"></td>'+
			'<td class="amount right '+pb_class+'" id="'+genid+'positive_balance">' + sym + ' ' + og.format_money_amount(positive_balance) +'</td>'+
		'</tr>';
		
		return html;
	},
	
	render_invoices_to_affect: function (genid, data) {
		if (data && data.invoices) {
			
			$("#" + genid + "affected_invoices tbody").html("");

			var total_total = 0;
			var total_pending = 0;
			var total_to_pay = 0;
			var cid = $("#"+genid+"currency_id").val();
			
			for (var i=0; i<data.invoices.length; i++) {
				var invoice = data.invoices[i];
				var row_html = og.invoice_payment_receipts.get_affected_invoice_table_row_html(genid, invoice, i);
				
				$("#" + genid + "affected_invoices tbody").append(row_html);
				
				total_total += parseFloat(invoice.total);
				total_pending += parseFloat(invoice.pending_amount);
				total_to_pay += parseFloat(invoice.to_pay);
			}

			var totals_obj = {currency_id:cid, total: total_total, pending_amount: total_pending, to_pay: total_to_pay};
			var totals_row_html = og.invoice_payment_receipts.get_affected_invoice_table_totals_row_html(genid, totals_obj, data.invoices.length);
			$("#" + genid + "affected_invoices tbody").append(totals_row_html);
		}
		
	},
	
	reload_invoices_to_affect: function (genid) {
		
		if (!this.reloading_invoices) {
			this.reloading_invoices = true;
			
			var selected_members_json = $("#" + genid + "members").val();
			var for_invoice_id = $("#" + genid + "for_invoice_id").val();
			
			og.openLink(og.getUrl('invoice_payment_receipt', 'get_possible_invoices_to_affect', {
				member_ids: selected_members_json,
				payment_total: $("#" + genid + "amount").val(),
				for_invoice_id: for_invoice_id,
				genid: genid
			}), {
				callback: function(success, data) {
					og.invoice_payment_receipts.reloading_invoices = false;
					
					if (success && data) {
						og.invoice_payment_receipts.render_invoices_to_affect(data.genid, data);
					}
				}
			});
		}
		
	},
	
	recalculate_amounts_to_pay: function (genid, recalculate_from_index) {
		var available_amount = parseFloat(og.clean_thousand_separator($("#" + genid + "amount").val()));
		var total_to_pay = 0;
		
		$("#" + genid + "affected_invoices .amount_to_pay").each(function() {
			
			var id = $(this).attr('id');
			var splitted = id.split('_');
			var i = splitted.pop();
			
			var pending_amount = parseFloat(og.clean_thousand_separator($('#'+genid+'inv_pending_'+i).val()));

			if (isNaN(recalculate_from_index) || i > recalculate_from_index) {
				var to_pay = available_amount > pending_amount ? pending_amount : available_amount;
				to_pay = parseFloat(to_pay.toFixed(2));
			} else {
				var to_pay = parseFloat(og.clean_thousand_separator($(this).val()));
			}
			
			available_amount -= to_pay;
			available_amount = parseFloat(available_amount.toFixed(2));
			total_to_pay += to_pay;
			
			$(this).val(og.format_money_amount(to_pay));
		});
		
		var cid = $("#"+genid+"currency_id").val();
		var sym = '$';
		var currency = og.get_currency_by_id(cid);
		if (currency) currency.symbol = currency.symbol;
		
		$("#" + genid + "total_to_pay").html(sym+' '+og.format_money_amount(total_to_pay));
		
		var payment_amount = parseFloat(og.clean_thousand_separator($("#" + genid + "amount").val()));
		var positive_balance = 0;
		if (payment_amount > total_to_pay) positive_balance = payment_amount - total_to_pay;
		
		$("#" + genid + "positive_balance").html(sym+' '+og.format_money_amount(positive_balance));
		if (positive_balance > 0) {
			$("#" + genid + "positive_balance").addClass('positive-balance');
		} else {
			$("#" + genid + "positive_balance").removeClass('positive-balance');
		}
	},
	/*
	fix_amount_if_exceeds_pending_sum: function(genid) {
		var payment_total = parseFloat($("#" + genid + "amount").val());
		var pending_sum = 0;
		$("#" + genid + "affected_invoices .amount_pending").each(function() {
			pending_sum += parseFloat($(this).val());
		});
		
		if (pending_sum < payment_total) {
			$("#" + genid + "amount").val(pending_sum);
		}
	},*/
	
	validate_to_pay:  function(genid, index, input) {

		var payment_total = parseFloat(og.clean_thousand_separator($("#" + genid + "amount").val()));
		var pending_amount = parseFloat(og.clean_thousand_separator($("#" + genid + "inv_pending_" + index).val()));
		var current_amount = parseFloat(og.clean_thousand_separator($(input).val()));

		// sum the previous lines amounts
		var invoices_sum = 0;
		$("#" + genid + "affected_invoices .amount_to_pay").each(function() {
			var id = $(this).attr('id');
			var splitted = id.split('_');
			var i = splitted.pop();
			if (i<index) {
				invoices_sum += parseFloat(og.clean_thousand_separator($(this).val()));
			}
		});

		// if prev amounts + this input's amount is greater than the maximum -> reduce the amount to match the max
		if (invoices_sum + current_amount > payment_total) {
			current_amount = payment_total - invoices_sum;
			$(input).val(og.format_money_amount(current_amount));
		}

		// if input amount is greater than the pending amount -> set the pending amount
		var to_pay = parseFloat($(input).val());
		if (to_pay > pending_amount) {
			$(input).val(og.format_money_amount(pending_amount));
		}

		// recalculate next rows amounts
		og.invoice_payment_receipts.recalculate_amounts_to_pay(genid, index);
	},

	trash: function(id) {
        og.openLink(og.getUrl('invoice_payment_receipt', 'check_payment_receipts_integration_status', {ids: id}), {
            hideLoading: true,
            callback: function(success, data) {
                if(data.result){
                    if(confirm(lang('confirm move to trash'))){
                        og.openLink(og.getUrl('object', 'trash', {object_id: id}));
                    }
                }
            }
        });
    }
}
