<?php

/**
 * SplittedInvoices controller
 *
 * @version 1.0
 * @author Alvaro Torterola <alvaro.torterola@fengoffice.com>
 */
class SplittedInvoicesController extends ApplicationController {

	var $plugin_name = "invoice_split_feature";
	
	/**
	 * Construct the SplittedInvoicesController
	 *
	 * @access public
	 * @param void
	 * @return SplittedInvoicesController
	 */
	function __construct() {
		parent::__construct();
		prepare_company_website_controller($this, 'website');
		
	} // __construct
	
	
	
	function before_invoice_trash_verifications() {
		ajx_current("empty");

		$invoice_id = array_var($_REQUEST, 'invoice_id');
		$invoice = IncomeInvoices::instance()->findById($invoice_id);

		$has_twin_invoices = false;
		$twin_invoices_data = array();
		
		if ($invoice instanceof IncomeInvoice) {

			$twin_invoices = SplittedInvoiceThreads::instance()->getRelatedInvoices($invoice);
			$has_twin_invoices = count($twin_invoices) > 0;
			foreach ($twin_invoices as $i) {
				$twin_invoices_data[] = $i->getArrayInfo();
			}

		}

		ajx_extra_data(array('has_twin_invoices' => $has_twin_invoices, 'invoices_data' => $twin_invoices_data));

	}

	

} // SplittedInvoicesController

