<?php 

function invoice_split_feature_update_1_2() {
	
	// insert association between projects and billing clients if it doesn't exist
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_member_associations` (`dimension_id`, `object_type_id`, `associated_dimension_id`, `associated_object_type_id`, `is_required`, `is_multiple`, `keeps_record`, `allows_default_selection`, `code`)
		SELECT 
			(SELECT `id` FROM ".TABLE_PREFIX."dimensions WHERE `code` = 'customer_project'),
			(SELECT `id` FROM ".TABLE_PREFIX."object_types WHERE `name` = 'project'),
			(SELECT `id` FROM ".TABLE_PREFIX."dimensions WHERE `code` = 'customers'),
			(SELECT `id` FROM ".TABLE_PREFIX."object_types WHERE `name` = 'customer'),
			'0', '1', '0', '1', 'project_billing_client'
		WHERE 
			(SELECT count(`id`) FROM `".TABLE_PREFIX."dimension_member_associations` WHERE `code` = 'project_billing_client') = 0;
	");

	// insert config options for the association between projects and billing client
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_associations_config` (`association_id`, `config_name`, `type`, `value`) VALUES
		((SELECT `id` FROM `".TABLE_PREFIX."dimension_member_associations` WHERE `code`='project_billing_client'), 'allow_remove_from_property_member', 'boolean', '1'),
		((SELECT `id` FROM `".TABLE_PREFIX."dimension_member_associations` WHERE `code`='project_billing_client'), 'autoclassify_in_property_member', 'boolean', '1'),
		((SELECT `id` FROM `".TABLE_PREFIX."dimension_member_associations` WHERE `code`='project_billing_client'), 'custom_association_name', 'text', 'Billing client')
		ON DUPLICATE KEY UPDATE `association_id`=`association_id`;
	");

	// ensure that allocation attribute is present if the relation between project and billing client exists
	$assoc = DimensionMemberAssociations::getAssociationByCode('project_billing_client');
	if ($assoc) {
		$assoc_attr = MemberAssociationAttributes::instance()->getAttributeByCode($assoc->getId(), 'invoice_allocation');

		if (!$assoc_attr) {
			DB::execute("
				INSERT INTO `".TABLE_PREFIX."member_association_attributes` (`association_id`, `name`, `type`, `code`, `order`, `is_required`) VALUES
				(".$assoc->getId().", 'Invoice allocation', 'numeric', 'invoice_allocation', '1', '0');
			");
		}
	}

	// config option to decide if we have to generate splitted invoices for different billing clients
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='split_invoice_for_billing_clients'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`)
			VALUES ('split_invoice_for_billing_clients', '1', 'BoolConfigHandler', '1', '');
		");
	}

}

function invoice_split_feature_update_2_3() {
	// update config option to add more options in the split invoice mode
	DB::execute("
		UPDATE `".TABLE_PREFIX."income_config_options`
		SET `config_handler_class` = 'ListConfigHandler',
			`options` = ' { \"no_empty_value\":1, \"option\": [{ \"value\": \"single\", \"text\": \"single\" }, { \"value\": \"multiple\", \"text\": \"multiple\" }, { \"value\": \"multiple-with-discount\", \"text\": \"multiple-with-discount\" }] }',
			`value` = IF (`value` = '1', 'multiple-with-discount', 'single')
		WHERE `name`='split_invoice_for_billing_clients';
	");
}
