<?php 
class SampleController extends ApplicationController {
	
	var $plugin_name = "lab_samples";
	
	function __construct() {
		parent::__construct();
		prepare_company_website_controller($this, 'website');
	}
	
	
	function print_sample_label() {
		$this->setLayout("html");
		$this->addHelper('textile');
		
		$member_id = array_var($_REQUEST, 'id');
		$member = Members::instance()->findById($member_id);
		
		if (!$member instanceof Member) {
			flash_error("obj dnx");
			ajx_current("empty");
			return;
		}
		tpl_assign('member', $member);
		
		$client_ot = ObjectTypes::findByName('customer');
		
		// client name
		$client_name = "";
		$all_parents = $member->getAllParentMembersInHierarchy();
		foreach ($all_parents as $parent) {
			if ($parent->getObjectTypeId() == $client_ot->getId()) {
				$client_name = $parent->getName();
				break;
			}
		}
		
		// number of samples
		$num_samples = MemberCustomProperties::getMemberCustomPropertySingleValueByCode('num_samples', $member->getId()) . " " . lang('samples');
		
		// operator
		$operator_id = MemberCustomProperties::getMemberCustomPropertySingleValueByCode('operator', $member->getId());
		$c = Contacts::instance()->findById($operator_id);
		$operator = $c instanceof Contact ? $c->getObjectName() : "";
		
		// due date
		$due_date_val = MemberCustomProperties::getMemberCustomPropertySingleValueByCode('due_date', $member->getId());
		$dt_val = DateTimeValueLib::dateFromFormatAndString(DATE_MYSQL, $due_date_val);
		$due_date = format_date($dt_val, null, 0);
		
		// analysis types
		$experiments = "";
		$analysist_ot = ObjectTypes::findByName('analysis_type');
		$associations = DimensionMemberAssociations::getAssociatations($member->getDimensionId(), $member->getObjectTypeId());
		foreach ($associations as $a) {
			/* @var $a DimensionMemberAssociation */
			if ($a->getAssociatedObjectType() == $analysist_ot->getId()) {
				$assoc_mem_ids = MemberPropertyMembers::getAllPropertyMemberIds($a->getId(), $member->getId());
				if ($assoc_mem_ids != '') {
					$assoc_members = Members::instance()->findAll(array('conditions' => 'id IN('.$assoc_mem_ids.')'));
					foreach ($assoc_members as $am) {
						$experiments .= ($experiments == "" ? "" : ", ") . clean($am->getName());
					}
				}
			}
		}
		
		
		// set view variables
		tpl_assign('client_name', $client_name);
		tpl_assign('num_samples', $num_samples);
		tpl_assign('operator', $operator);
		tpl_assign('due_date', $due_date);
		tpl_assign('experiments', $experiments);
		
		// use custom print template if defined
		if (file_exists(ROOT."/sample_label_print_custom_template.php")) {
			$this->setTemplate(ROOT."/sample_label_print_custom_template.php");
		}
	}
	
}
