<?php
	class Analysis extends BaseAnalysis {
		
		/**
		 * Can $user view this object
		 *
		 * @param Contact $user
		 * @return boolean
		 */
		function canView(Contact $user){
			return can_read($user, $this->getMembers(), $this->getObjectTypeId());
		}
		
		
		/**
		 * Check if this user can add a new object to this project. This method is called staticly
		 *
		 * @param Contact $user
		 * @param Member $member
		 * @return boolean
		 */
		static function canAdd(Contact $contact, $context_members, &$notAllowedMember = '') {
			return can_manage_dimension_members($contact);
		} // canAdd
		
		
		/**
		 * Returns true if this user can edit this object
		 *
		 * @param Contact $user
		 * @return boolean
		 */
		function canEdit(Contact $contact){
			return can_manage_dimension_members($contact);
		}
		
		
		/**
		 * Returns true if this user can delete this object
		 *
		 * @param Contact $user
		 * @return boolean
		 */
		function canDelete(Contact $contact) {
			return can_manage_dimension_members($contact);
		}
		
		
		function getEditUrl() {
			return get_url('analysis', 'edit', array('id' => $this->getId()));
		}
	} 
