<?php
/**
 * MacroFacultad controller
 *
 * @version 1.0
 * @author Alvaro Torterola <alvaro.torterola@fengoffice.com>
 */
class MacroFacultadController extends ApplicationController {

	var $plugin_name = "macro_facultad";
	
	function __construct() {
		parent::__construct();
		prepare_company_website_controller($this, 'website');
	//	Env::useHelper('functions', $this->plugin_name);
	}
	
	
	function get_selected_supplier_data() {
		ajx_current("empty");
		
		$member_ids = array();
		$members_str = array_var($_REQUEST, 'member_ids');
		if ($members_str) {
			$member_ids = json_decode($members_str, true);
		}

		$suppliers_dim = Dimensions::findByCode("suppliers");
		$data = array();
		
		if (count($member_ids) > 0) {
			$members = Members::instance()->findAll(array("conditions" => "id IN (".implode(',', $member_ids).")"));
			$supplier = null;
			$supplier_member = null;
			foreach ($members as $m) {
				if ($m instanceof Member && $m->getDimensionId() == $suppliers_dim->getId()) {
					$supplier = Objects::findObject($m->getObjectId());
					$supplier_member = $m;
					break;
				}
			}
			
			if ($supplier instanceof Supplier) {
				// buscar las cps rut y rz
				$cp_rut = MemberCustomProperties::getCustomPropertyByCode($supplier->getObjectTypeId(), 'company_id');
				if ($cp_rut instanceof MemberCustomProperty) {
					$cp_rut_val = MemberCustomPropertyValues::getMemberCustomPropertyValue($supplier_member->getId(), $cp_rut->getId());
					$p_cp_rut = CustomProperties::getCustomPropertyByCode(Payments::instance()->getObjectTypeId(), 'rut_proveedor');
					if ($p_cp_rut instanceof CustomProperty && $cp_rut_val instanceof MemberCustomPropertyValue) { 
						$data[$p_cp_rut->getId()] = $cp_rut_val->getValue();
					}
				}
				
				$cp_rz =  MemberCustomProperties::getCustomPropertyByCode($supplier->getObjectTypeId(), 'legal_name');
				if ($cp_rz instanceof MemberCustomProperty) {
					$cp_rz_val = MemberCustomPropertyValues::getMemberCustomPropertyValue($supplier_member->getId(), $cp_rz->getId());
					$p_cp_rz = CustomProperties::getCustomPropertyByCode(Payments::instance()->getObjectTypeId(), 'nombre_proveedor');
						
					if ($p_cp_rz instanceof CustomProperty && $cp_rz_val instanceof MemberCustomPropertyValue) {
						$data[$p_cp_rz->getId()] = $cp_rz_val->getValue();
					}
				}
			}
		}
		
		ajx_extra_data(array('info' => $data));
	}
	
}
