<?php

Hook::register('macro_facultad');

function macro_facultad_before_save_payment($args, &$ignored) {
	$object = array_var($args, 'object');
	
	if ($object instanceof Payment && !$object->getAmount()) {
		throw new Exception(lang('payment amount') . " " . strtolower(lang('is required')));
	}
	
	if ($object instanceof Payment) {
		
		$quota = Quotas::instance()->findById($object->getColumnValue('quota_id'));
			
		if ($quota instanceof Quota && trim($object->getObjectName()) == '') {
			$object->setObjectName($quota->getName());
		}
	}
}

/*
function macro_facultad_before_render_member_selectors($params, &$categories) {

	$object = array_var($params, 'object');
	$genid = array_var($params, 'genid');

	if ($object instanceof Payment) {
		tpl_assign('object', $object);
		tpl_assign('genid', $genid);

		tpl_display(get_template_path('hide_payment_name', 'macro_facultad', 'macro_facultad'));
	}
}
*/

/**
 * dont show date value or input in payments view and add/edit form
 */
function macro_facultad_remove_date_from_payments($payment, &$remove_date_from_payments) {
	$remove_date_from_payments = true;
}

/**
 * dont show date column in payments list
 */
function macro_facultad_additional_system_columns($manager, &$columns) {
	if ($manager instanceof Payments) {
		$columns[] = 'date';
	}
}

/*
// dont show expenses in reports, as this plugin does not use expenses
function macro_facultad_custom_reports_object_types($parameters, &$object_types) {

    foreach ($object_types as $k => &$object_type) {
        if ($object_type->getName() == 'expense') {
            unset($object_types[$k]);
        }
    }
}

function macro_facultad_after_save_payment($params, &$ignored) {
    $object = array_var($params, 'object');
    $data = array_var($params, 'data');
    $old_data = array_var($params, 'old_data');

    if ($object instanceof Payment) {
        // if status is executed => change to approved
        $exe_status = ExpensesStatuses::instance()->getStatusByCode('executed');
        if ($object->getStatusId() == $exe_status->getId()) {
            $app_status = ExpensesStatuses::instance()->getStatusByCode('approved');
            $object->setStatusId($app_status->getId());
            $object->save();
            $object->addToHistory(logged_user(), 'edit');
        }
    }
}

function macro_facultad_modify_member_selector_listeners($params, &$listeners) {

    $object = array_var($params, 'object');
    $genid = array_var($params, 'genid');

    if ($object instanceof Payment) {
        $listeners['on_selection_change'] .= 'og.updatePaymentSupplierInfo("' . $genid . '");';
    }
}

function macro_facultad_more_member_selector_additional_selected_ids($args, &$additional_sel_ids) {
    $object = array_var($args, 'object');
    if ($object instanceof Payment && $object->isNew()) {
        $ff_dim = Dimensions::findByCode('funding_sources');
        $eu_dim = Dimensions::findByCode('executor_units');

        // select default founding source as corfo
        $context = active_context();
        $add_corfo_member = true;
        foreach ($context as $selection) {
            if ($selection instanceof Member && $selection->getDimensionId() == $ff_dim->getId()) {
                $add_corfo_member = false;
                break;
            }
        }
        if ($add_corfo_member) {
            $corfo_member = Members::instance()->findOne(array("conditions" => "name LIKE 'CORFO' AND dimension_id=" . $ff_dim->getId()));
            if ($corfo_member instanceof Member)
                $additional_sel_ids[] = $corfo_member->getId();
        }

        // if user can view only one executor unit then autoselect it
        $logged_user_pg_ids = implode(",", logged_user()->getPermissionGroupIds());
        if ($logged_user_pg_ids == "")
            $logged_user_pg_ids = "0";

        $eu_members = DB::executeAll("SELECT id FROM " . TABLE_PREFIX . "members m
			WHERE m.dimension_id=" . $eu_dim->getId() . " AND EXISTS (
				SELECT * FROM " . TABLE_PREFIX . "contact_member_permissions cmp
				WHERE cmp.permission_group_id IN ($logged_user_pg_ids) AND cmp.member_id=m.id
			)
			LIMIT 2");

        if (is_array($eu_members) && count($eu_members) == 1 && isset($eu_members[0]['id'])) {
            $additional_sel_ids[] = $eu_members[0]['id'];
        }
    }
}

function macro_facultad_before_save_payment($args, &$ignored) {
    $object = array_var($args, 'object');
    if ($object instanceof Payment) {
        $nombre = $object->getName();
        
        if ($nombre == "" || $nombre == null) {
            $dimExecUnit = "";
            $dimActivity = "";
            
            $memberIdList = array_var($args, 'members');
            
            $i = 0;
            while ($i < count($memberIdList) && ($dimExecUnit == "" || $dimActivity == "")) {
                $member = Members::getMemberById($memberIdList[$i]);
                $dimension = Dimensions::getDimensionById($member->getDimensionId());
                
                if ($dimension->getCode() == 'executor_units')
                    $dimExecUnit = $member->getName();

                if ($dimension->getCode() == 'activities')
                    $dimActivity = $member->getName();
                
                $i++;
            }
            
            $nombre = $dimExecUnit . " - " . $dimActivity;
            $object->setObjectName($nombre);
        }
    }
}
*/