<?php
	class ManagedEvent extends BaseManagedEvent {
		
		function getEditUrl() {
			return null;
		}
		
		function delete() {
			$project_event = ProjectEvents::instance()->findById($this->getEventId());
			if ($project_event instanceof ProjectEvent) {
				$project_event->delete();
			}
			parent::delete();
		}
		
		static function canAdd(Contact $user, $context, &$notAllowedMember = ''){
			return can_manage_dimension_members($user);
		}
		
		/**
		 * Returns true if $user can access this event
		 *
		 * @param Contact $user
		 * @return boolean
		 */
		function canView(Contact $user) {
			return can_read($user, $this->getMembers(), $this->getObjectTypeId());
		} // canView
	
		/**
		 * Check if specific user can edit this events
		 *
		 * @access public
		 * @param Contact $user
		 * @return boolean
		 */
		function canEdit(Contact $user) {
			return can_manage_dimension_members($user);
		} // canEdit
	
	
		/**
		 * Check if specific user can delete this events
		 *
		 * @access public
		 * @param Contact $user
		 * @return boolean
		 */
		function canDelete(Contact $user) {
			return can_manage_dimension_members($user);
		} // canDelete
	
		/**
		 * Check if specific user can comment this event
		 *
		 * @access public
		 * @param void
		 * @return boolean
		 */
		function canAddComment(Contact $user) {
			return can_manage_dimension_members($user);
		} // canAddComment
		
		
		
		
		
		




		function getAdditionalCustomPropertyValues($cp) {
			$cp_values = array();
			if ($cp instanceof CustomProperty) {
				$cp_values = CustomPropertyValues::getCustomPropertyValues($this->getEventId(), $cp->getId());
			}
			return $cp_values;
		}
		
		function getAdditionalCustomPropertyAssociatedObject($cp) {
			return ProjectEvents::instance()->findById($this->getEventId());
		}
	}