<?php

if (isset($members) && is_array($members)) {
	
	$managed_events_ot_id = ManagedEvents::instance()->getObjectTypeId();
	$event_members = array();
	foreach ($members as $m) {
		if ($m->getObjectTypeId() == $managed_events_ot_id) {
			$event_members[] = $m;
		}
	}
	
	if (count($event_members) > 0) {
?>
<strong>Event Details:</strong>
<br />
<br />
<?php 
		$count = 0;
		foreach ($event_members as $member) {
			/* @var Member $member */
			
			$start_date = "";
			$end_date = "";
			
			$managed_event = ManagedEvents::instance()->findById($member->getObjectId());
			
			// format dates string
			if ($managed_event instanceof ManagedEvent) {
				$project_event = ProjectEvents::instance()->findById($managed_event->getEventId());
				if ($project_event instanceof ProjectEvent && $project_event->getStart() instanceof DateTimeValue) {
					$start_date = format_date($project_event->getStart(), null, 0);
				}
				if ($project_event instanceof ProjectEvent && $project_event->getDuration() instanceof DateTimeValue) {
					$end_date = format_date($project_event->getDuration(), null, 0);
				}
			}
			$dates_str = "";
			if ($start_date != "") $dates_str .= $start_date;
			if ($end_date != "") $dates_str .= ($dates_str == "" ? "" : " - ") . $end_date;
			
			// format description string
			$description_str = "";
			$desc_cp = CustomProperties::instance()->getCustomPropertyByCode($member->getObjectTypeId(), 'description_special');
			if ($desc_cp instanceof CustomProperty) {
				$desc_cp_val = CustomPropertyValues::getCustomPropertyValue($member->getObjectId(), $desc_cp->getId());
				if ($desc_cp_val instanceof CustomPropertyValue) {
					$description_str = $desc_cp_val->getValue();
				}
			}
			
			// format venue string
			$venue_str = "";
			$venue_cp = CustomProperties::instance()->getCustomPropertyByCode($member->getObjectTypeId(), 'venue');
			if ($venue_cp instanceof CustomProperty) {
				$venue_cp_val = CustomPropertyValues::getCustomPropertyValue($member->getObjectId(), $venue_cp->getId());
				if ($venue_cp_val instanceof CustomPropertyValue) {
					$tmp = explode('|', $venue_cp_val->getValue());
					unset($tmp[0]); //remove address type
					$venue_str = implode(' - ', array_filter($tmp));
				}
			}
?>
<table cellpadding="4" cellspacing="0" class="mail-event-data-table">
	<tbody>
		<tr>
			<td>Name:</td>
			<td><?php echo $member->getName() ?></td>
		</tr>
		<tr>
			<td>Date:</td>
			<td><?php echo $dates_str ?></td>
		</tr>
		<tr>
			<td>Description:</td>
			<td><?php echo $description_str ?></td>
		</tr>
		<tr>
			<td>Venue:</td>
			<td><?php echo $venue_str ?></td>
		</tr>
	</tbody>
</table>
<?php 
			$count++;
			if ($count < count($event_members)) { 
?>
<br />
<br />
<?php 
			}
		}
	}
}

