<?php 

function managed_events_update_1_2() {
	
	$ot = ObjectTypes::findByName('managed_event');
	
	$mcp = CustomProperties::getCustomPropertyByCode($ot->getId(), 'venue');
	if (!$mcp instanceof CustomProperty) {
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."custom_properties (object_type_id, name, code, `type`, `is_special`, `property_order`, `visible_by_default`) VALUES
				((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='managed_event'), 'Venue', 'venue', 'address', 1, 8, 1);
		");
	}
	
	$mcp = CustomProperties::getCustomPropertyByCode($ot->getId(), 'banner');
	if (!$mcp instanceof CustomProperty) {
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."custom_properties (object_type_id, name, code, `type`, `is_special`, `property_order`, `visible_by_default`) VALUES
				((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='managed_event'), 'Event Flyer', 'banner', 'image', 1, 9, 1);
		");
	}
	
	$mcp = CustomProperties::getCustomPropertyByCode($ot->getId(), 'thumbnail');
	if (!$mcp instanceof CustomProperty) {
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."custom_properties (object_type_id, name, code, `type`, `is_special`, `property_order`, `visible_by_default`) VALUES
				((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='managed_event'), 'Event Thumbnail', 'thumbnail', 'image', 1, 10, 1);
		");
	}
}

function managed_events_update_2_3() {
	DB::execute("
		CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."managed_events` (
		  `object_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
		  `event_id` int(10) unsigned NOT NULL DEFAULT 0,
		  PRIMARY KEY (`object_id`),
		  KEY `event_id` (`event_id`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
	");
	
	DB::execute("
		UPDATE ".TABLE_PREFIX."object_types
		SET handler_class='ManagedEvents', table_name='managed_events'
		WHERE name='managed_event';
	");

	DB::execute("
		INSERT INTO ".TABLE_PREFIX."objects (name, object_type_id, created_by_id, created_on, updated_by_id, updated_on)
		SELECT o.name, (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='managed_event'), 
				o.created_by_id, o.created_on, o.updated_by_id, o.updated_on
			FROM ".TABLE_PREFIX."project_events e
			INNER JOIN ".TABLE_PREFIX."objects o ON e.object_id=o.id
			WHERE e.is_managed_event=1;
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."managed_events (object_id, event_id)
		SELECT o.id, e.object_id 
			FROM ".TABLE_PREFIX."project_events e
			INNER JOIN ".TABLE_PREFIX."objects oe ON oe.id=e.object_id
			INNER JOIN ".TABLE_PREFIX."objects o ON o.name=oe.name AND o.created_on=oe.created_on
			WHERE e.is_managed_event=1 
				AND o.object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='managed_event');
	");
	
	DB::execute("
		UPDATE ".TABLE_PREFIX."members 
		SET object_id = (SELECT object_id FROM ".TABLE_PREFIX."managed_events WHERE event_id = ".TABLE_PREFIX."members.object_id)
		WHERE object_type_id = (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='managed_event')
	");
}

function managed_events_update_3_4() {
    $ot = ObjectTypes::findByName('managed_event');
    $mcp = CustomProperties::getCustomPropertyByCode($ot->getId(), 'display_on_website');
    
    if (!$mcp instanceof CustomProperty) {
        DB::execute("
			INSERT INTO ".TABLE_PREFIX."custom_properties (object_type_id, name, code, type, default_value, is_special, property_order, visible_by_default) VALUES
				((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='managed_event'), 'Display on website', 'display_on_website', 'boolean', 1, 1, 11, 1);
		");
    }
    
}

function managed_events_update_4_5() {
	$dim_events = Dimensions::findByCode('managed_events');
	$dim_events->setPermissionQueryMethod('not_mandatory');
	$dim_events->save();
	
	if (Plugins::instance()->isActivePlugin('income')) {
		$invoices = IncomeInvoices::instance()->findAll();
		foreach ($invoices as $invoice) {/* @var $invoice IncomeInvoice */
			$invoice->addToSharingTable();
		}
	}
	
}