<?php 

class MemberAssociationAttributes extends BaseMemberAssociationAttributes {
	
	static $attributes = null;
	
	/**
	 * Gets the attribute object by its id
	 * @param integer $id
	 * @return MemberAssociationAttribute
	 */
	static function getAttributeById($id) {
		
		if (is_null(self::$attributes)) {
			$attrs = self::instance()->findAll();
			self::$attributes = array();
			foreach ($attrs as $attr) {
				self::$attributes[$attr->getId()] = $attr;
			}
		}
		
		return array_var(self::$attributes, $id);
		
	}

	/**
	 * Gets the attribute object by its code
	 * @param string $code
	 * @return MemberAssociationAttribute
	 */
	static function getAttributeByCode($association_id, $code) {
		return self::instance()->findOne(array("conditions" => array("association_id=? AND code=?", $association_id, $code)));
	}
	
}
