<?php
Hook::register('association_attributes');



function association_attributes_after_member_association_changed($parameters, &$ignored) {
	
	$member = array_var($parameters, 'member');
	//$is_new = array_var($parameters, 'is_new');
	$request = array_var($parameters, 'request');
	
	$associated_member_attributes = array_var($request, 'associated_members_attr', array());
	
	// save the entered attribute values for the current associated members
	foreach ($associated_member_attributes as $assoc_id => $member_attributes) {
		
		foreach ($member_attributes as $assoc_member_id => $attributes) {
			
			$mpm = MemberPropertyMembers::instance()->findOne(array(
					"conditions" => array("association_id=? AND member_id=? AND property_member_id=?", $assoc_id, $member->getId(), $assoc_member_id)
			));
			if (!$mpm) continue;
			
			foreach ($attributes as $attr_id => $attr_value) {
				
				$attribute = MemberAssociationAttributes::getAttributeById($attr_id);
				if ($attribute->getType() == 'date') {
					$dt_val = getDateValue($attr_value);
					if ($dt_val instanceof DateTimeValue) {
						$attr_value = $dt_val->toMySQL();
					}
				}
				
				$mpm_attr = MemberPropertyMemberAttributes::instance()->findOne(array(
						"conditions" => array("mpm_id=? AND attribute_id=?", $mpm->getId(), $attr_id)
				));
				if (!$mpm_attr) {
					$mpm_attr = new MemberPropertyMemberAttribute();
					$mpm_attr->setMpmId($mpm->getId());
					$mpm_attr->setAttributeId($attr_id);
				}
				
				$mpm_attr->setValue($attr_value);
				$mpm_attr->save();
			}
		}
	}
	
	// delete the attribute values for the previous associated members
	DB::execute("DELETE FROM ".TABLE_PREFIX."member_property_member_attributes WHERE NOT EXISTS (
		SELECT id FROM ".TABLE_PREFIX."member_property_members x WHERE x.id = mpm_id
	)");
	
}

function association_attributes_before_render_associated_dimension_selector($parameters, &$ignored) {
	
	$genid = array_var($parameters, 'genid');
	$selected_ids = array_var($parameters, 'selected_ids');
	$dim_association = array_var($parameters, 'dim_association');
	$member = array_var($parameters, 'member');
	
	$a_id = $dim_association->getId();
	
	$assoc_attributes = MemberAssociationAttributes::instance()->findAll(array(
			"conditions" => array("association_id=?", $a_id),
			"order" => "`order`"
	));
	
	$initial_values = array();
	
	foreach ($selected_ids as $assoc_member_id) {
		$mpm = MemberPropertyMembers::instance()->findOne(array(
				"conditions" => array("association_id=? AND member_id=? AND property_member_id=?", $a_id, $member->getId(), $assoc_member_id)
		));
		if (!$mpm) continue;
		
		foreach ($assoc_attributes as $assoc_attribute) {
			$mpm_attr = MemberPropertyMemberAttributes::instance()->findOne(array(
					"conditions" => array("mpm_id=? AND attribute_id=?", $mpm->getId(), $assoc_attribute->getId())
			));
			if (!$mpm_attr) continue;
			
			$mpm_value = $mpm_attr->getValue();
			if ($mpm_value == '') continue;
			
			if ($assoc_attribute->getType() == 'date') {
				$dt_val = DateTimeValueLib::dateFromFormatAndString(DATE_MYSQL, $mpm_value);
				$mpm_value = format_date($dt_val, null, 0);
			}
			
			if (!isset($initial_values[$a_id])) $initial_values[$a_id] = array();
			if (!isset($initial_values[$a_id][$assoc_member_id])) $initial_values[$a_id][$assoc_member_id] = array();
			
			$initial_values[$a_id][$assoc_member_id][$assoc_attribute->getId()] = $mpm_value;
		}
		
	}
	
	if (!empty($initial_values)) {
		tpl_assign('genid', $genid);
		tpl_assign('initial_values', $initial_values);
		
		tpl_display(get_template_path('association_selector_initial_attr_values', 'member_association_attributes', 'member_association_attributes'));
	}
	
}


function association_attributes_append_data_to_assoc_member_view($parameters, &$assoc_mem_html_vals) {
	
	$genid = array_var($parameters, 'genid');
	$member = array_var($parameters, 'member');
	$assoc_member = array_var($parameters, 'assoc_member');
	$dim_association = array_var($parameters, 'dim_association');
	
	$attributes_html = '';
	
	$attributes_with_values = MemberPropertyMemberAttributes::getFormattedAttributeValues($dim_association->getId(), $member->getId(), $assoc_member->getId());
	
	if (!empty($attributes_with_values)) {
		tpl_assign('genid', $genid);
		tpl_assign('attributes_with_values', $attributes_with_values);
		
		$attributes_html = tpl_fetch(get_template_path('associated_member_view_attributes', 'member_association_attributes', 'member_association_attributes'));
	}
	
	if ($attributes_html != '') {
		$assoc_mem_html_vals .= $attributes_html;
	}
}


