
og.member_association_attributes = {
	
	attributes: [],
	
	init: function() {
		this.load_all_attributes();
		
		if (!og.fn_sel_member_additional_html) og.fn_sel_member_additional_html = [];
		
		og.fn_sel_member_additional_html.push(og.member_association_attributes.render_dim_assoc_attributes);
		
		
		og.eventManager.addListener('after member_selector init', function(params) {
			var genid = params.genid;
			if (member_selector[genid] && member_selector[genid].member_association_id && member_selector[genid].sel_context) {
				
				for (dim_id in member_selector[genid].sel_context) {
					var sel_member_ids = member_selector[genid].sel_context[dim_id];
					
					for (var i=0; i<sel_member_ids.length; i++) {
						og.member_association_attributes.render_dim_assoc_attributes(genid, {id: sel_member_ids[i]});
					}
				}
				
			}
		});	
	},
	
	
	load_all_attributes: function() {
		
		og.openLink(og.getUrl('member_association_attributes', 'get_all_associations_with_attributes'),{
			hideLoading: true,
			hideErrors: true,
			preventPanelLoad: true,
			callback: function(success, data) {
				if (data && data.association_attributes) {
					og.member_association_attributes.attributes = data.association_attributes;
				}
			}
		});
		
	},
	
	render_dim_assoc_attributes: function(genid, member) {
		var assoc_id = member_selector[genid].member_association_id;
		var container_id = genid+'selected-member'+member.id;
		
		if (!isNaN(assoc_id)) {
		
			var is_multiple = false;
			for (did in member_selector[genid].properties) {
				is_multiple = member_selector[genid].properties[did].isMultiple;
				break;
			}
		
			og.member_association_attributes.render_association_attributes(genid, assoc_id, member, container_id, is_multiple);
		}	
	},
	
	render_association_attributes: function(genid, assoc_id, member, container_id, is_multiple) {
		
		if (!og.member_association_attributes.attributes[assoc_id]) return;
		
		var attributes_def = this.attributes[assoc_id];
		
		var all_attrs_html = '';
		
		for (var i=0; i<attributes_def.length; i++) {
			
			var attr_def = attributes_def[i];
			
			var input_name = 'associated_members_attr['+assoc_id+']['+member.id+']['+attr_def.id+']';
			var input_id = genid+'associated_members_attr_'+assoc_id+'_'+member.id+'_'+attr_def.id;
			
			var input_value = '';
			// get the initial values for the attribute of the associated member
			if (og.initial_assoc_attribute_values && og.initial_assoc_attribute_values[genid]
				&& og.initial_assoc_attribute_values[genid][assoc_id]
				&& og.initial_assoc_attribute_values[genid][assoc_id][member.id] 
				&& og.initial_assoc_attribute_values[genid][assoc_id][member.id][attr_def.id]) {
							
				input_value = og.initial_assoc_attribute_values[genid][assoc_id][member.id][attr_def.id];
				
			}
			
			var input_html = '';
			var current_attr_html = '<div class="assoc-attribute">';
			current_attr_html += '<label for="'+input_id+'">'+attr_def.name+'</label>';
			
			switch (attr_def.type) {
				case 'date': 
					input_html = '<span id="'+genid+'date_attr_container_'+assoc_id+'_'+member.id+'_'+attr_def.id+'" class="assoc-attribute-date"></span>';
					input_html += '<script>var date_attr = new og.DateField({'+
							'renderTo: "'+genid+'date_attr_container_'+assoc_id+'_'+member.id+'_'+attr_def.id+'",'+
							'name: "'+input_name+'",'+
							'id: "'+input_id+'",'+
							'value: "'+input_value+'"'+
						'});</script>';
					break;
				case 'text':
				case 'numeric':
					var onchange = '';
					if (attr_def.type == 'numeric') {
						onchange = 'onchange="og.check_if_valid_cp_num(this);"';
					}

					input_html = `
						<input type="text" class="${attr_def.type}" name="${input_name}" id="${input_id}" value="${input_value}" ${onchange}/>
						${(attr_def.name == 'Invoice allocation') ? `<span style="padding-left: 3px;">%</span>` : ''}
					`;

					break;
				case 'boolean':
					var yes_checked = input_value > 0 ? 'checked="checked"' : '';
					var no_checked = input_value == 0 ? 'checked="checked"' : '';
					
					input_html = '<input id="'+input_id+'Yes" class="yes_no" value="1" type="radio" '+yes_checked+' name="'+input_name+'">'+
						'<label class="yes_no" for="'+input_id+'Yes">'+ lang('yes') +'</label>'+
						'<input id="'+input_id+'No" class="yes_no" value="0" type="radio" '+no_checked+' name="'+input_name+'">'+
						'<label class="yes_no" for="'+input_id+'No">'+ lang('no') +'</label>';
					break;
				default: 
					break;
			}
			
			current_attr_html += input_html + '</div>';
			
			all_attrs_html += current_attr_html;
		}
		
		if (all_attrs_html != '') {
		
			var attr_list_html = '<div class="assoc-attributes-list">' + all_attrs_html + '<div class="clear"></div></div>';
			
			if (is_multiple) {
				$("#" + container_id).append(attr_list_html);
			} else {
				// remove previous inputs if exists
				$("#" + container_id).closest('.single-tree.x-tree').parent().children('.assoc-attributes-list').remove();
				// add new inputs for new selected member
				$("#" + container_id).closest('.single-tree.x-tree').after(attr_list_html);
			}
			
		}
		
	}
	
}
