<?php

Hook::register('member_custom_properties');

function member_custom_properties_custom_properties_admin_sections($ignored, &$ret) {
	echo tpl_fetch(get_template_path('administration', 'member_custom_properties', 'member_custom_properties'));
}
/*
function member_custom_properties_render_administration_icons($ignored, &$icons){
	if (logged_user() instanceof Contact && can_manage_configuration(logged_user())) {
		$icons[] = array(
			'ico' => 'ico-large-custom-properties',
			'name' => lang('member custom properties'),
			'url' => get_url('member_custom_properties', 'edit_custom_properties'),
		);
	}
}*/

function member_custom_properties_get_cusotm_property_columns($params, &$grouped) {
	
	// color condition - not include color cp in listings
	$color_condition = "cp.code != 'color_special'";
	
	$cp_rows = DB::executeAll("SELECT cp.id, cp.name as cp_name, cp.code as cp_code, ot.name as obj_type, cp.visible_by_default as visible_def, cp.is_disabled, cp.type as cp_type, cp.values as cp_values, cp.default_value as cp_default_value, cp.is_special as cp_special, cp.show_in_lists
			FROM ".TABLE_PREFIX."member_custom_properties cp 
			INNER JOIN ".TABLE_PREFIX."object_types ot on ot.id=cp.object_type_id
			WHERE $color_condition AND ot.type IN ('dimension_group')
			ORDER BY ot.name");
	
	if (is_array($cp_rows)) {
		foreach ($cp_rows as $row) {
			if (!isset($grouped[$row['obj_type']])) $grouped[$row['obj_type']] = array();
			
			$cp_name = $row['cp_name'];
			if ($row['cp_special']) {
				$label_code = str_replace("_special", "", $row['cp_code']);
				$label_value = Localization::instance()->lang($label_code);
				if (is_null($label_value)) {
					$label_value = Localization::instance()->lang(str_replace('_', ' ', $label_code));
				}
				if (!is_null($label_value)) $cp_name = $label_value;
			}
			
			$grouped[$row['obj_type']][] = array('id' => $row['id'], 'name' => $cp_name, 'code' => $row['cp_code'], 'visible_def' => $row['visible_def'], 'member_cp' => 1, 'disabled' => $row['is_disabled'], 'cp_type' => $row['cp_type'], 'cp_values' => $row['cp_values'], 'cp_default_value' => $row['cp_default_value'], 'show_in_lists' => $row['show_in_lists']);
		}
	}
}



function member_custom_properties_after_member_prepare_object($params, &$object) {
	$member_ids = array_var($params, 'member_ids');
	$member_type_id = array_var($params, 'member_type_id');
	$field = array_var($params, 'field', 'members');
	
	if (!is_array($member_ids) || count($member_ids) == 0 || !$member_type_id) return;
	
	$ot = ObjectTypes::instance()->findById($member_type_id);
	
	if ($ot->getType() == 'dimension_object') {
		$custom_properties = CustomProperties::getAllCustomPropertiesByObjectType($member_type_id);
	} else {
		$custom_properties = MemberCustomProperties::getAllMemberCustomPropertiesByObjectType($member_type_id);
	}
	
	foreach ($custom_properties as $cp) {
		
		$cp_rows = array();
		if ($ot->getType() == 'dimension_object') {
			
			if (count($member_ids) > 0) {
				$cp_rows = DB::executeAll("
					SELECT cpv.*, m.id as member_id FROM ".TABLE_PREFIX."custom_property_values cpv
					INNER JOIN ".TABLE_PREFIX."members m ON m.object_id=cpv.object_id
					WHERE 
						m.id IN (".implode(',', $member_ids).")
						AND cpv.custom_property_id = '".$cp->getId()."' AND cpv.value != ''
						AND cpv.value != '".EMPTY_DATETIME."' AND cpv.value != '".EMPTY_DATE."'
					ORDER BY cpv.object_id");
			}
			$mcpv = new CustomPropertyValue();
			
		} else {
			if (count($member_ids) > 0) {
				$cp_rows = DB::executeAll("SELECT * FROM ".TABLE_PREFIX."member_custom_property_values cpv
					WHERE cpv.member_id IN (".implode(',', $member_ids).")
					AND cpv.custom_property_id = '".$cp->getId()."' AND cpv.value != ''
					AND cpv.value != '".EMPTY_DATETIME."' AND cpv.value != '".EMPTY_DATE."'
					ORDER BY cpv.member_id");
			}
			$mcpv = new MemberCustomPropertyValue();
			
		}
		
		if (is_array($cp_rows)) {
			foreach ($cp_rows as $cp_row) {
				$mcpv->setValue($cp_row['value']);
				
				if ($ot->getType() == 'dimension_object') {
					$cp_val = get_custom_property_value_for_listing($cp, $cp_row['object_id'], array($mcpv));
				} else {
					$cp_val = get_member_custom_property_value_for_listing($cp, $cp_row['member_id'], array($mcpv));
				}
				
				if ($cp->getCode() == 'status_special') {
					$cp_val = "<span class='member-path real-breadcrumb project-row-status-".trim($cp_row['value'])."'>$cp_val</span>";
				}
				
				foreach ($object[$field] as &$x) {
					if ($x['member_id'] == $cp_row['member_id']) {
						$x['cp_'.$cp->getId()] = $cp_val;
						break;
					}
				}
			}
		}
	}
}

function member_custom_properties_additional_system_columns($manager, &$sys_cols) {
	if ($manager instanceof Workspaces) {
		$sys_cols[] = 'description';
	}
	if ($manager instanceof Customers) {
		$sys_cols[] = 'status_id';
		$sys_cols[] = 'cmrr';
		$sys_cols[] = 'start_date';
		$sys_cols[] = 'end_date';
		$sys_cols[] = 'payment_cycle_id';
	}
	if ($manager instanceof Projects) {
		$sys_cols[] = 'description';
		$sys_cols[] = 'status';
		$sys_cols[] = 'start_date';
		$sys_cols[] = 'end_date';
	}
}

function member_custom_properties_additional_external_columns($manager, &$ext_cols) {
	if ($manager instanceof Customers) {
		foreach ($ext_cols as $k => &$v) {
			if (in_array($v, array('status_id', 'payment_cycle_id'))) unset($ext_cols[$k]);
		}
	}
	
	if ($manager instanceof Projects) {
		foreach ($ext_cols as $k => &$v) {
			if (in_array($v, array('status'))) unset($ext_cols[$k]);
		}
	}
}


function member_custom_properties_custom_reports_fixed_additional_columns($args, &$ret) {

	$ot = array_var($args, 'object_type');
	if ($ot instanceof ObjectType && in_array($ot->getType(), array('dimension_object','dimension_group'))) {

		$custom_properties = MemberCustomProperties::getAllMemberCustomPropertiesByObjectType($ot->getId());
		foreach ($custom_properties as $cp) {/* @var $cp MemberCustomProperty */
			if ($cp->getCode() == 'color_special') continue;
			$cp_name = $cp->getName();
			$ret[] = array('id' => $cp->getId(), 'name' => $cp_name, 'type' => $cp->getType(), 'values' => $cp->getValues(), 'multiple' => $cp->getIsMultipleValues());
		}
		
	}
}

function member_custom_properties_render_member_properties_for_view($params, &$cp_html){

    $properties_html = null;
    Hook::fire('override_render_properties_for_view', $params, $properties_html);
    if (!is_null($properties_html)) {
        $cp_html = $properties_html;
        return;
    }
	
    if (!isset($genid)) $genid = gen_id();

    $member = array_var($params, 'member');
    $visible_by_default = array_var($params, 'visible_by_default');
    if($visible_by_default){
        $visible_by_default = 'visible_by_default';
    }

    if ($member instanceof Member) {
        $ot = ObjectTypes::instance()->findById($member->getObjectTypeId());
        
        // show object custom properties
        if ($ot->getType() == 'dimension_object') {
        	$object = Objects::findObject($member->getObjectId());
	        $cp_html = render_custom_properties($object);
	        return;
        }

        $custom_properties = MemberCustomProperties::getAllMemberCustomPropertiesByObjectType($ot->getId());
        foreach ($custom_properties as $cp) {
            if ($cp->getType() == 'color' || $cp->getCode() == 'calculate the status automatically_special') {
                continue;
            }
            $cp_name = $cp->getName();
            $cp_values = MemberCustomPropertyValues::getMemberCustomPropertyValues($member->getId(), $cp->getId());

            $cp_html_cp = "";
            if (is_array($cp_values) && count($cp_values) > 0) {
                $first = true;
                $cp_html_cp .= '<tr class="cp-info"><td><span class="bold">'.$cp_name.': </span></td><td>';
                $cp_html_vals = "";
                foreach ($cp_values as $cp_val) {
                    $formatted_val = $cp_val->format_value();
                    if ($formatted_val == "") continue;

                    if (!$first) {
                        $cp_html_vals .= ", ";
                    }
                    $first = false;
                    $cp_html_vals .= $formatted_val;

                    if (!$cp->getIsMultipleValues()) {
                        break;
                    }
                }
                $cp_html_cp .= $cp_html_vals;
                $cp_html_cp .= '</td></tr>';
                if ($cp_html_vals != "") {
                    // content
                    $cp_html .= $cp_html_cp;
                }
            }
        }
        
        if (trim($cp_html) != "") {
        	$cp_html = '<table style="width:100%;">' . $cp_html . '</table>';
        }

    }

}

function member_custom_properties_render_member_properties($params, &$more_properties){
	
	$properties_html = null;
	Hook::fire('override_render_properties', $params, $properties_html);
	if (!is_null($properties_html)) {
		$more_properties = $properties_html;
		return;
	}
	
    if (!isset($genid)) $genid = gen_id();

    $member = array_var($params, 'member');
    $visible_by_default = array_var($params, 'visible_by_default');
    if($visible_by_default){
        $visible_by_default = 'visible_by_default';
    }

    if ($member instanceof Member) {
        $ot = ObjectTypes::instance()->findById($member->getObjectTypeId());
        
        if ($ot->getType() == 'dimension_object') {
        	$cps = CustomProperties::getAllCustomPropertiesByObjectType($ot->getId(),$visible_by_default);
        	$obj = Objects::findObject($member->getObjectId());
        	
        	if (!$obj instanceof ContentDataObject) {
        		eval('$ot_manager = '.$ot->getHandlerClass().'::instance();');
        		if (isset($ot_manager) && $ot_manager instanceof ContentDataObjects && $ot_manager->getItemClass() != '') {
        			eval('$obj = new '.$ot_manager->getItemClass().'();');
        			$obj->setObjectTypeId($ot->getId());
        		}
        	}
        	
        	$member = $obj;
        } else {
	        $cps = MemberCustomProperties::getAllMemberCustomPropertiesByObjectType($ot->getId(),$visible_by_default);
        }

        foreach($cps as $customProp){
           $html = get_custom_property_input_html($customProp, $member, $genid, 'member_custom_properties',$member->getId());
           //Logger::log_r("Rendering custom properties for a Member.\n");
            $more_properties[] = array('id' => '', 'html' => $html);
        }


    }

}

function member_custom_properties_additional_member_definition_columns($ot_id, &$ext_cols) {
    $cps = MemberCustomProperties::getAllMemberCustomPropertiesByObjectType($ot_id,'visible_by_default');
    $array_cp_info = array();
    foreach($cps as $cp){
        $ext_cols["cp_".$cp->getId()]= array('id' => $cp->getId(), 'type'=>$cp->getType(), 'label'=>$cp->getName(), 'code'=>$cp->getCode());
    }
     
}

function member_custom_properties_additional_member_column_values($params, &$info) {
	$definition = array_var($params, 'definition');
	$member = array_var($params, 'member');
	
	$cps_by_id = array();
	$ot = ObjectTypes::instance()->findById($member->getObjectTypeId());
	if ($ot->getType() == 'dimension_object') {
		$cps = CustomProperties::getAllCustomPropertiesByObjectType($member->getObjectTypeId());
	} else {
		$cps = MemberCustomProperties::getAllMemberCustomPropertiesByObjectType($member->getObjectTypeId());
	}
	
	foreach ($cps as $cp) {
		$cps_by_id[$cp->getId()] = $cp;
	}
	
	foreach ($definition as $property_id => $property_info) {
		if (str_starts_with($property_id, "cp_")) {
			// custom property
			$cp_id = str_replace("cp_", "", $property_id);
			$cp = array_var($cps_by_id, $cp_id);
			if (!$cp) continue;
		
			if ($cp->getIsMultipleValues()) {
				if ($ot->getType() == 'dimension_object') {
					$cp_vals = CustomPropertyValues::getCustomPropertyValues($member->getObjectId(), $cp->getId());
				} else {
					$cp_vals = MemberCustomPropertyValues::getMemberCustomPropertyValues($member->getId(), $cp->getId());
				}
				
				$cp_vals_info = array();
				foreach ($cp_vals as $cp_val) {
					if ($ot->getType() == 'dimension_object') {
						$cp_vals_info[] = get_custom_property_value_for_listing($cp, $member->getObjectId(), array($cp_val), true);
					} else {
						$cp_vals_info[] = get_member_custom_property_value_for_listing($cp, $member, array($cp_val), true);
					}
				}
				$info[$property_id] = $cp_vals_info;
		
			} else {
		
				if ($ot->getType() == 'dimension_object') {
					$cp_val = CustomPropertyValues::getCustomPropertyValue($member->getObjectId(), $cp->getId());
					$info[$property_id] = get_custom_property_value_for_listing($cp, $member->getObjectId(), array($cp_val), true);
				} else {
					$cp_val = MemberCustomPropertyValues::getMemberCustomPropertyValue($member->getId(), $cp->getId());
					$info[$property_id] = get_member_custom_property_value_for_listing($cp, $member, array($cp_val), true);
				}
			}
		}
	}
}




function member_custom_properties_custom_property_input_default_value($params, &$default_value) {
	
	$object = array_var($params, 'object');
	$customProp = array_var($params, 'customProp');
	
	if ($object instanceof Member && $customProp instanceof MemberCustomProperty) {
		
		if ($customProp->getIsMultipleValues() || $customProp->getType() == 'table'){
			$default_value = MemberCustomPropertyValues::getMemberCustomPropertyValues($object->getId(), $customProp->getId());
		
			if (!is_array($default_value) || count($default_value) == 0) {
				$default_value = $customProp->getDefaultValue();
			}
		}else{
			$cpv = MemberCustomPropertyValues::getMemberCustomPropertyValue($object->getId(), $customProp->getId());
			$default_value = $customProp->getDefaultValue();
			if($cpv instanceof MemberCustomPropertyValue){
				$default_value = $cpv->getValue();
			}
		}
	}
}


function member_custom_properties_custom_property_field_initial_value($params, &$cp_value) {

	$configs = array_var($params, 'configs');
	$custom_property = array_var($params, 'cp');
	$mult = array_var($params, 'multiple');
	
	if (isset($configs['member_id'])) {
		if ($mult) {
			$cp_value = MemberCustomPropertyValues::getMemberCustomPropertyValues($configs['member_id'], $custom_property->getId());
		} else {
			$cp_value = MemberCustomPropertyValues::getMemberCustomPropertyValue($configs['member_id'], $custom_property->getId());
		}
	}
}


function member_custom_properties_administration_custom_properties_ot_types($params, &$ot_types) {
	$ot_types[] = "dimension_object";
}


