<?php 

function member_custom_properties_update_12_13() {
	if (!checkTableExists(TABLE_PREFIX."member_custom_properties")) {
		DB::executeAll("
			CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."member_custom_properties` (
			  `id` int(10) NOT NULL AUTO_INCREMENT,
			  `object_type_id` int(10) unsigned NOT NULL,
			  `name` varchar(255) collate utf8_unicode_ci NOT NULL,
			  `type` varchar(255) collate utf8_unicode_ci NOT NULL,
			  `description` text collate utf8_unicode_ci NOT NULL,
			  `values` text collate utf8_unicode_ci NOT NULL,
			  `default_value` text collate utf8_unicode_ci NOT NULL,
			  `is_system` tinyint(1) NOT NULL,
			  `is_required` tinyint(1) NOT NULL,
			  `is_multiple_values` tinyint(1) NOT NULL,
			  `property_order` int(10) NOT NULL,
			  `visible_by_default` tinyint(1) NOT NULL,
			  PRIMARY KEY (`id`)
			) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
		");
	}
	
	if (!checkTableExists(TABLE_PREFIX."member_custom_property_values")) {
		DB::executeAll("
			CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."member_custom_property_values` (
			  `id` int(10) NOT NULL AUTO_INCREMENT,
			  `member_id` int(10) NOT NULL,
			  `custom_property_id` int(10) NOT NULL,
			  `value` text collate utf8_unicode_ci NOT NULL,
			  PRIMARY KEY (`id`),
  			  KEY `member_id_custom_property_id` (`member_id`,`custom_property_id`)
			) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
		");
	}
}

function member_custom_properties_update_13_14() {
	if (!check_column_exists(TABLE_PREFIX."member_custom_properties", "show_in_lists")) {
		DB::executeAll("ALTER TABLE `".TABLE_PREFIX."member_custom_properties` ADD COLUMN `show_in_lists` BOOLEAN NOT NULL DEFAULT 0;");
		DB::executeAll("UPDATE `".TABLE_PREFIX."member_custom_properties` SET `show_in_lists`=`visible_by_default`;");
	}
}

function member_custom_properties_update_14_15() {
	if (!check_column_exists(TABLE_PREFIX."member_custom_properties", "total_operation")) {
		DB::executeAll("ALTER TABLE `".TABLE_PREFIX."member_custom_properties` ADD COLUMN `total_operation` varchar(50) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '';");
	}
}

function member_custom_properties_update_15_16() {
	DB::executeAll("
		UPDATE `".TABLE_PREFIX."member_custom_properties` SET `type`='datetime' WHERE `type`='date';
	");
	DB::executeAll("
		UPDATE `".TABLE_PREFIX."member_custom_property_values` cpv
		INNER JOIN `".TABLE_PREFIX."member_custom_properties` cp ON cpv.custom_property_id=cp.id
		SET cpv.value = DATE_FORMAT(cpv.value, '%Y-%m-%d %H:%i:%s')
		WHERE cp.`type`='datetime' AND cpv.value!='' AND cpv.value != DATE_FORMAT(cpv.value, '%Y-%m-%d %H:%i:%s');
	");
}


function member_custom_properties_update_16_17() {
	// migrate dimension_object member custom properties to object custom properties
	
	$total_operation_col_sql = Plugins::instance()->isActivePlugin('advanced_core') ? "total_operation, " : "";
	
	DB::executeAll("
		INSERT INTO ".TABLE_PREFIX."custom_properties (object_type_id, name, `type`, description, `values`, default_value, is_required, is_multiple_values, property_order, visible_by_default, code, is_special, is_disabled, $total_operation_col_sql show_in_lists)
		SELECT object_type_id, name, `type`, description, `values`, default_value, is_required, is_multiple_values, property_order, visible_by_default, code, is_special, is_disabled, $total_operation_col_sql show_in_lists
		FROM ".TABLE_PREFIX."member_custom_properties
		WHERE object_type_id IN (SELECT id FROM ".TABLE_PREFIX."object_types WHERE `type` = 'dimension_object');
	");
	
	DB::executeAll("
		UPDATE ".TABLE_PREFIX."reports
		SET order_by=(
			SELECT cp.id FROM ".TABLE_PREFIX."custom_properties cp
			INNER JOIN ".TABLE_PREFIX."member_custom_properties mcp ON cp.name=mcp.name AND cp.object_type_id = mcp.object_type_id
			WHERE mcp.id=order_by LIMIT 1 
		)
		WHERE order_by IN (SELECT id FROM ".TABLE_PREFIX."member_custom_properties WHERE object_type_id=report_object_type_id) 
			AND report_object_type_id IN (SELECT id FROM ".TABLE_PREFIX."object_types WHERE `type` = 'dimension_object');
	");
	DB::executeAll("
		UPDATE ".TABLE_PREFIX."report_columns
		INNER JOIN ".TABLE_PREFIX."reports r ON r.object_id=report_id
		SET custom_property_id=(
			SELECT cp.id FROM ".TABLE_PREFIX."custom_properties cp
			INNER JOIN ".TABLE_PREFIX."member_custom_properties mcp ON cp.name=mcp.name AND cp.object_type_id = mcp.object_type_id
			WHERE mcp.id=custom_property_id LIMIT 1 
		)
		WHERE custom_property_id>0 
			AND r.report_object_type_id IN (SELECT id FROM ".TABLE_PREFIX."object_types WHERE `type` = 'dimension_object');
	");
	DB::executeAll("
		UPDATE ".TABLE_PREFIX."report_conditions
		INNER JOIN ".TABLE_PREFIX."reports r ON r.object_id=report_id
		SET custom_property_id=(
			SELECT cp.id FROM ".TABLE_PREFIX."custom_properties cp
			INNER JOIN ".TABLE_PREFIX."member_custom_properties mcp ON cp.name=mcp.name AND cp.object_type_id = mcp.object_type_id
			WHERE mcp.id=custom_property_id LIMIT 1 
		)
		WHERE custom_property_id>0 
			AND r.report_object_type_id IN (SELECT id FROM ".TABLE_PREFIX."object_types WHERE `type` = 'dimension_object');
	");
	
	
	DB::executeAll("
		INSERT INTO ".TABLE_PREFIX."custom_property_values (object_id, custom_property_id, value)
		SELECT m.object_id, cp.id, mcpv.`value`
		FROM ".TABLE_PREFIX."members m
		INNER JOIN ".TABLE_PREFIX."object_types ot ON ot.id=m.object_type_id
		INNER JOIN ".TABLE_PREFIX."member_custom_property_values mcpv ON mcpv.member_id=m.id
		INNER JOIN ".TABLE_PREFIX."member_custom_properties mcp ON mcp.id=mcpv.custom_property_id
		INNER JOIN ".TABLE_PREFIX."custom_properties cp ON cp.name=mcp.name AND cp.object_type_id = mcp.object_type_id
		WHERE ot.`type` = 'dimension_object';
	");
	
	if (Plugins::instance()->isActivePlugin('advanced_core') && checkTableExists(TABLE_PREFIX."property_group_properties")) {
		DB::executeAll("
			DELETE FROM ".TABLE_PREFIX."property_group_properties
			WHERE property_id IN (
				SELECT id FROM ".TABLE_PREFIX."member_custom_properties 
				WHERE object_type_id IN (SELECT id FROM ".TABLE_PREFIX."object_types WHERE `type` = 'dimension_object')
			);
		");
		
		Env::useHelper('functions', 'advanced_core');
		fill_property_groups_default_data();
	}
	
	DB::executeAll("
		DELETE FROM ".TABLE_PREFIX."member_custom_properties
		WHERE object_type_id IN (SELECT id FROM ".TABLE_PREFIX."object_types WHERE `type` = 'dimension_object');
	");
	DB::executeAll("
		DELETE FROM ".TABLE_PREFIX."member_custom_property_values
		WHERE NOT EXISTS (SELECT m.id FROM ".TABLE_PREFIX."member_custom_properties m WHERE m.id=".TABLE_PREFIX."member_custom_property_values.custom_property_id);
	");
	
}

