<?php
$genid = gen_id();
// on submit functions
if (array_var($_REQUEST, 'modal')) {
	$on_submit = "og.submit_modal_form('" . $genid . "template_params', og.reload_active_tab); return false;";
} else {
	$on_submit = "return true;";
}
?>
<form onsubmit="<?php echo $on_submit ?>" id="<?php echo $genid ?>template_params" class="internalForm" action="<?php echo get_url('member_templates', 'instantiate_multiple_templates') ?>" method="post">
	<input type="hidden" name="req_channel" value="<?php echo array_var($_REQUEST, 'req_channel', 'instantiate member template') ?>" />

	<div class="template">
		<div class="coInputHeader">
			<div class="coInputHeaderUpperRow">
				<div class="coInputTitle" style="font-size:180%;"><?php echo lang('instantiate templates') ?></div>
				<div class="desc"><?php echo lang('please fill the form to create the tasks and expenses') ?></div>
			</div>
			<div class="clear"></div>
		</div>
		<div class="coInputMainBlock">

			<input type="hidden" name="member_ids" value="<?php echo json_encode($member_ids) ?>" />
	<?php 
		foreach ($grouped_by_template as $count => $data) {

			$type = $data['type'];

			if ($type == 'generic') {
				$template = $data['template'];
				$template_id = $template->getId();
				$template_name = $template->getName();
				$template_description = $template->getDescription();
				$parameters = CObjTemplateParameters::instance()->getTemplateParameters($template->getId());
	?>
			<input type="hidden" name="template_types[<?php echo $template_id?>]" value="<?php echo $type ?>" />

			<div class="coInputHeader">
				<div class="coInputTitle"><?php echo $template_name ?></div>
				<div class="desc"><?php echo $template_description ?></div>
			</div>

			<div class="coInputMainBlock">
				<table style="width:100%;">
					<tbody>
						<?php foreach ($parameters as $parameter_obj) {

							$parameter = $parameter_obj->getArrayInfo();
							
							$default_value = array_var($parameter, 'default_value');
							
						?>
							<tr style='height:30px;'>
								<td style="padding:3px 10px 0 10px; width:170px;"><span class="bold"><?php
									$parameter_name = $parameter['name'];
									//Hook::fire('template_param_instantiation_name', array('param' => $parameter, 'template' => $template), $parameter_name);
									echo $parameter_name;

									$parameter_id = $parameter['parameter_id'];
									

								?></span></td>
								<td>
									<?php if ($parameter['type'] == 'string') { ?>
										<input name="parameter_values[<?php echo $template_id?>][<?php echo $parameter_id ?>]" class="title" value="<?php echo $default_value ?>" />

									<?php } else if ($parameter['type'] == 'numeric') { ?>

										<input name="parameter_values[<?php echo $template_id?>][<?php echo $parameter_id ?>]" class="title" value="<?php echo $default_value ?>" type="number" step="0.01" />

									<?php } else if ($parameter['type'] == 'date') {

											echo pick_date_widget2('parameter_values['.$template_id.'][' . $parameter_id . ']');

										} else if ($parameter['type'] == 'user') { ?>
											<select name="<?php echo 'parameter_values['.$template_id.'][' . $parameter_id . ']'; ?>">
												<?php
												$context = active_context();
												if (isset($member_id) && $member_id > 0) {
													// filter by context passed by parameter, used when instantiating template after member creation using member templates
													$additional_member = Members::instance()->findById($member_id);
													if ($additional_member instanceof Member) {
														$context = array($additional_member);
													}
												}

												$companies  = allowed_users_to_assign($context, true, true, false, $template->getObjectTypeId());

												?>
												<option value="0"><?php echo lang('none') ?></option>
												<?php
												foreach ($companies as $c) {
													$users = $c['users'];
													if (count($users)) {
														foreach ($users as $usr) { ?>
															<option value="<?php echo $usr['id'] ?>"> <?php echo $usr['name'] ?></option>
												<?php 	}
													}
												}

												?>
											</select>
										<?php	
										}
										?>
								</td>
							</tr>
						<?php } //foreach 
						?>
					</tbody>
				</table>
				
			</div>


	<?php


			} else {

				$template = $data['template'];
				$template_id = $template->getId();
				$template_name = $template->getObjectName();
				$template_description = $template->getDescription();
				$parameters = TemplateParameters::instance()->getParametersByTemplate($template->getId());
	?>
			<input type="hidden" name="template_types[<?php echo $template_id?>]" value="<?php echo $type ?>" />

			<div class="coInputHeader">
				<div class="coInputTitle"><?php echo $template_name ?></div>
				<div class="desc"><?php echo $template_description ?></div>
			</div>
			<div class="coInputMainBlock">
				<table style="width:100%;"><tbody>
				<?php foreach($parameters as $parameter_obj) {

						$parameter = $parameter_obj->getArrayInfo();
						
						$default_value = array_var($parameter, 'default_value');
						
						$dont_render_this_param = false;
						Hook::fire('before_instantiating_template_param_def_value', array('param' => $parameter), $dont_render_this_param);
						if ($dont_render_this_param) {
							continue;
						} else {
							$default_value = str_replace(array('{{email_body}}', '{{email_subject}}'), '', $default_value);
						}
				?>
					<tr style='height:30px;'>
						<td style="padding:3px 10px 0 10px; width:170px;"><span class="bold"><?php
							$parameter_name = $parameter['name'];
							Hook::fire('template_param_instantiation_name', array('param' => $parameter, 'template' => $template), $parameter_name);
							echo $parameter_name;
							
							$parameter_js_key = str_replace("'", "", $parameter['name']);
							
						?></span></td>
						<td>
							<?php if($parameter['type'] == 'string'){ ?>
								<input name="parameter_values[<?php echo $template_id?>][<?php echo $parameter['name'] ?>]" class="title" value="<?php echo $default_value?>"/>
							
							<?php } else if ($parameter['type'] == 'numeric') { ?>

								<input name="parameter_values[<?php echo $template_id?>][<?php echo $parameter['name'] ?>]" class="title" value="<?php echo $default_value?>" type="number" step="0.01" />
							
							<?php } else if ($parameter['type'] == 'date'){
									echo pick_date_widget2('parameter_values['.$template_id.']['.$parameter_js_key.']');
									
								} else if($parameter['type'] == 'user') { ?>
								<select name="<?php echo 'parameter_values['.$template_id.']['.$parameter_js_key.']'; ?>">
								<?php
									$context = active_context();
									if (isset($member_id) && $member_id > 0) {
										// filter by context passed by parameter
										$additional_member = Members::instance()->findById($member_id);
										if ($additional_member instanceof Member) {
											$context = array($additional_member);
										}
									}

									$companies  = allowed_users_to_assign($context);
									?>
									<option value="0"><?php echo lang('none') ?></option>
									<?php
									foreach ($companies as $c) {
										if (config_option('can_assign_tasks_to_companies')) { ?>
										<option value="<?php echo $c['id']; ?>"> <?php echo $c['name']; ?></option>
										
									<?php }
										$users = $c['users'];
										if ( count($users) ) {
											foreach ($users as $usr) {?>																
												<option value="<?php echo $usr['id'] ?>"> <?php echo $usr['name'] ?></option>
												
										<?php }
										}
									}	
									
								?>
								</select>
							<?php } else {
										$null = null;
										Hook::fire('render_param_to_instantiate', array('param' => $parameter), $null);
								}
							?>
						</td>
					</tr>
				<?php }//foreach ?>
				</tbody></table>
			</div>

	<?php
			}

			if ($count + 1 < count($grouped_by_template)) {
			?><div style="margin:20px 10px; border-bottom: 1px solid #ccc; height:1px;"></div><?php 
			}
	?>

	<?php
		}
	?>
			
			<br />
			<div class="right">
				<?php echo submit_button(lang('instantiate templates'), 's',	array('style' => 'margin-top:0px')) ?>
			</div>
		</div>
	</div>
</form>