<?php
	$genid = gen_id();
	$object_type = ObjectTypes::instance()->findById($object_type_id);
	$custom_ot_name = Members::getTypeNameToShowByObjectType($dimension_id, $object_type->getId());
	$member_templates = MemberTemplates::instance()->findAll(array('conditions' => "dimension_id='$dimension_id' AND object_type_id=".$object_type->getId()));
?>

<div class="coInputHeader">
  <div class="coInputHeaderUpperRow upperSeparator">
	<div class="coInputTitle">
		<?php echo lang('x type templates', $custom_ot_name); ?>
	</div>
  </div>
</div>

<div class="coInputMainBlock adminMainBlock">
  <div class="template-list-container">
	<?php if(isset($member_templates) && is_array($member_templates) && count($member_templates)) : ?>
	<table style="min-width: 500px;" id="<?php echo $genid ?>-ws" class="templates-table">
		<tr>
			<th><?php echo lang('template') ?></th>
			<th><?php echo lang('actions') ?></th>
		</tr>
		<?php
		$isAlt = true;
		foreach($member_templates as $member_template) :
			$isAlt = !$isAlt; 	$options = array();
			if (logged_user()->isAdminGroup()) {
				$options[] = '<a class="internalLink link-ico ico-edit" href="' . get_url('member_templates', 'edit', array('id' => $member_template->getId())) .'&popup=true" title="'.lang('edit').'">&nbsp;</a>';
				$options[] = '<a class="internalLink link-ico ico-delete" href="' . get_url('member_templates', 'delete', array('id' => $member_template->getId())) .'&popup=true" onclick="return confirm(\'' . escape_single_quotes(lang('confirm delete template')) . '\')" title="'.lang('delete template').'">&nbsp;</a>';
			}
		?>
		<tr class="<?php echo $isAlt? 'altRow' : ''?>">
			<td><a class="internalLink ico-template bg-ico"
				href="<?php echo get_url('member_templates', 'edit', array('id' => $member_template->getId())) ?>"><?php echo clean($member_template->getName()) ?></a></td>
			
			<td style="width:65px;"><?php echo implode(' ', $options) ?></td>
		</tr>
		<?php endforeach; ?>
	</table>
	
	<div class="template-options">
		<input type="hidden" name="dim_id" id="<?php echo $genid?>dim_id" value="<?php echo $dimension_id?>"/>
		<input type="hidden" name="ot_id" id="<?php echo $genid?>ot_id" value="<?php echo $object_type->getId()?>"/>
		
		<?php
		$checked_str = "";
		$disabled_ids_csv = config_option('disabled_default_add_dimensions');
		$disabled_ids = explode(',', $disabled_ids_csv);
		foreach ($disabled_ids as $key) {
			if ($key == $dimension_id."_".$object_type->getId()) {
				$checked_str = 'checked="checked"';
			}
		} 
		?>
		<input type="checkbox" <?php echo $checked_str?> name="disable_default_menu" id="<?php echo $genid?>disable_default_menu" onchange="og.enable_disable_default_add_action(this, '<?php echo $genid?>');"/>
		<label for="<?php echo $genid?>disable_default_menu"><?php echo lang('disable default add menu',$custom_ot_name); ?></label>
		<div class="desc"><?php echo lang('disable default add menu desc')?></div>
	</div>
	<?php else:?> 
	<?php echo lang('no templates') ?><br/><br/>
	<?php endif; // if ?>
	<a href="<?php echo get_url("member_templates", "add", array('dimension_id' => $dimension_id, 'object_type_id' => $object_type->getId())) ?>" class="internalLink ico-add bg-ico"><?php
	echo lang("new x type template",$custom_ot_name); ?></a>
	
  </div>
</div>
<script>
og.enable_disable_default_add_action = function(checkbox, genid) {
	var dim_id_el = document.getElementById(genid + 'dim_id');
	var dim_id = 0;
	if (dim_id_el) dim_id = dim_id_el.value;

	var ot_id_el = document.getElementById(genid + 'ot_id');
	var ot_id = 0;
	if (ot_id_el) ot_id = ot_id_el.value;
	
	og.openLink(og.getUrl('member_templates', 'enable_disable_default_add_action', { disable: checkbox.checked?1:0, dim_id: dim_id, ot_id:ot_id }), {preventPanelLoad:true, hideLoading:true});
}
</script>