<?php 
function member_templates_update_1_2() {
	if (!check_column_exists(TABLE_PREFIX."member_templates", "can_instantiate_from_mail")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."member_templates`
			ADD COLUMN `can_instantiate_from_mail` tinyint(1) NOT NULL DEFAULT '0';
		");
	}
	if (!check_column_exists(TABLE_PREFIX."members", "from_mail_id")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."members` 
			ADD COLUMN `from_mail_id` INTEGER UNSIGNED NOT NULL DEFAULT 0;
		");
	}
}

function member_templates_update_2_3() {


    if(checkTableExists(TABLE_PREFIX.'member_templates_available_types')){
        
        DB::execute(
            "
            INSERT INTO `".TABLE_PREFIX."member_templates_available_types` (dimension_id,object_type_id)
            (
                SELECT dim.dimension_id,dim.object_type_id
                FROM `".TABLE_PREFIX."dimension_object_types` as dim
                INNER JOIN `".TABLE_PREFIX."dimensions` as d ON d.id = dim.dimension_id
                INNER JOIN `".TABLE_PREFIX."object_types` AS o ON o.id = dim.object_type_id
                WHERE d.code != 'mail_imap_folders'
                AND (d.code != 'customer_project' AND o.name not in ('folder','customer_folder','project_folder'))
            )
            ON DUPLICATE KEY UPDATE dimension_id = dim.dimension_id ,object_type_id = dim.object_type_id
            "
        );
        
    }


}

// fix available types, to exclude client and project folders and ensure that the other member types are included
function member_templates_update_3_4() {
    if(checkTableExists(TABLE_PREFIX.'member_templates_available_types')){
        
        DB::execute(
            "
            INSERT INTO `".TABLE_PREFIX."member_templates_available_types` (dimension_id,object_type_id)
            (
                SELECT dim.dimension_id,dim.object_type_id
                FROM `".TABLE_PREFIX."dimension_object_types` as dim
                INNER JOIN `".TABLE_PREFIX."dimensions` as d ON d.id = dim.dimension_id
                INNER JOIN `".TABLE_PREFIX."object_types` AS o ON o.id = dim.object_type_id
                WHERE d.code != 'mail_imap_folders'
                AND (o.name not in ('customer_folder','project_folder'))
            )
            ON DUPLICATE KEY UPDATE dimension_id = dim.dimension_id ,object_type_id = dim.object_type_id
            "
        );
        
        DB::execute("
        	DELETE FROM `".TABLE_PREFIX."member_templates_available_types`
        	WHERE object_type_id IN (SELECT id FROM ".TABLE_PREFIX."object_types ot WHERE ot.name IN ('customer_folder','project_folder'))
        ");
        
    }
}


function member_templates_update_4_5() {
	if (!check_column_exists(TABLE_PREFIX."member_templates", 'object_subtype_id')) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."member_templates`
			ADD `object_subtype_id` int(10) unsigned NOT NULL DEFAULT '0';
		");
	}
}


function member_templates_update_5_6() {
	if (!check_column_exists(TABLE_PREFIX."member_templates_task_templates", 'cobj_template_ids')) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."member_templates_task_templates`
			ADD `cobj_template_ids` VARCHAR(255) NOT NULL DEFAULT '';
		");
	}

	DB::execute("
		CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."member_cobj_templates_instantiation_log` (
			`member_id` int(10) unsigned NOT NULL DEFAULT '0',
			`cobj_template_id` int(10) unsigned NOT NULL DEFAULT '0',
			PRIMARY KEY (`member_id`,`cobj_template_id`)
		) ENGINE=InnoDB;
	");
}

