<?php

// include all dependencies
// require_once dirname(__FILE__) . '/../../../../mail/library/vendor/autoload.php';
//use Webklex\PHPIMAP\ClientManager;
// use Webklex\PHPIMAP\Client;
 
function get_microsoft_mail_auth_url() {

	$config = array(
		'clientId'                => config_option('ms_mail_client_id'),
		'clientSecret'            => config_option('ms_mail_client_secret_value'),
		'redirectUri'             => with_slash(ROOT_URL) . config_option('ms_mail_redirect_uri_suffix'), 
		'urlAuthorize'            => config_option('ms_mail_url_authorize'),
		'urlAccessToken'          => config_option('ms_mail_url_access_token'),
		'urlResourceOwnerDetails' => config_option('ms_mail_url_resource_owner_details'),
		'scopes'				  => config_option('ms_mail_scopes')
	);
	$oauthClient = new \League\OAuth2\Client\Provider\GenericProvider($config);
	
	$authUrl = $oauthClient->getAuthorizationUrl();

	// Save client state so we can validate in callback
	$_SESSION['microsoftOauthState'] = $oauthClient->getState();

	return $authUrl;
}


function delete_microsoft_mail_access_token($account_id) {
	$link =  @mysqli_connect(DB_HOST, DB_USER, DB_PASS, DB_NAME);
	if($account_id) {
		$sql = "
			UPDATE ".TABLE_PREFIX."mail_accounts SET oauth2_access_token='', oauth2_provider='', uses_oauth2=0
			WHERE id = '$account_id';
		";
		mysqli_query($link, $sql);
	}
	$_SESSION['oauth2_access_token'] = '';
	$_SESSION['oauth2_provider'] = '';
	$_SESSION['uses_oauth2'] = 0;
}

function get_microsoft_mail_access_token($account_id) {
	$account = MailAccounts::instance()->getAccountById($account_id);
	$accessToken = null;
	if ($account instanceof MailAccount) {
		$serialized_token = $account->getColumnValue('oauth2_access_token');
		$accessToken = unserialize(base64_decode($serialized_token));
	}
	return $accessToken;
}
