<?php

/**
 * ExchangeRates class
 *
 * 
 */
class ExchangeRates extends BaseExchangeRates {

	static function getLastExchangeRate($source_currency_id, $destiny_currency_id, $extra_conditions = "") {
		$er = self::instance()->findOne(array(
			"conditions" => "`source_currency_id`='$source_currency_id' AND `destiny_currency_id`='$destiny_currency_id' $extra_conditions",
			"order" => "`date` DESC"
		));
		if ($er instanceof ExchangeRate) {
			return $er->getRate();
		} else {
			
			$inverse_er = self::instance()->findOne(array(
				"conditions" => "`source_currency_id`='$destiny_currency_id' AND `destiny_currency_id`='$source_currency_id' $extra_conditions",
				"order" => "`date` DESC"
			));
			if ($inverse_er instanceof ExchangeRate) {
				return 1 / $inverse_er->getRate();
			}
		}
		return 1;
	}
	
	
	static function getLastExchangeRatesInfo() {
		$sql = "SELECT * FROM ".TABLE_PREFIX."exchange_rates er
				WHERE NOT EXISTS (
				  SELECT * FROM ".TABLE_PREFIX."exchange_rates er2
				  WHERE er2.source_currency_id=er.source_currency_id AND er2.destiny_currency_id=er.destiny_currency_id AND er2.date>er.date
				);";
		$rows = DB::executeAll($sql);
		
		if (!$rows) $rows = array();
		
		return $rows;
	}
	
	
	static function canManageExchangeRates($user) {
		return can_manage_configuration($user);
	}
	
	
}

?>