-- <?php echo $table_prefix ?> 
-- <?php echo $default_charset ?> DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci
-- <?php echo $default_collation ?> collate utf8_unicode_ci
-- <?php echo $engine ?> InnoDB
-- varchar cannot be larger than 256
-- blob/text cannot have default values
-- sql queries must finish with ;\n (line break inmediately after ;)


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>newsletters` (
  `object_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `text` text <?php echo $default_collation ?>,
  `type_content` ENUM( 'text', 'html' ) NOT NULL DEFAULT 'text',
  `start_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `end_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `mail_account_id` int(11) NOT NULL DEFAULT 0,
  `status` varchar(50) <?php echo $default_collation ?> NOT NULL DEFAULT 'pending',
  `subject` text <?php echo $default_collation ?> NOT NULL,
  PRIMARY KEY (`object_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>newsletter_contacts_pending` (
  `newsletter_id` int(11) NOT NULL,
  `contact_id` int(11) NOT NULL,
  `status` varchar(50) <?php echo $default_collation ?> NOT NULL,
  PRIMARY KEY (`newsletter_id`,`contact_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>newsletter_contacts_sent` (
  `newsletter_id` int(11) NOT NULL,
  `contact_id` int(11) NOT NULL,
  `sent_date` datetime NOT NULL,
  PRIMARY KEY (`newsletter_id`,`contact_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>newsletter_sent_emails` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `newsletter_id` int(10) NOT NULL DEFAULT '0',
  `sent_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `to` text <?php echo $default_collation ?>,
  `cc` text <?php echo $default_collation ?>,
  `bcc` text <?php echo $default_collation ?>,
  `from` text <?php echo $default_collation ?>,
  `subject` text <?php echo $default_collation ?>,
  `body` text <?php echo $default_collation ?>,
  `attachments` text <?php echo $default_collation ?>,
  `message_id` varchar(255) <?php echo $default_collation ?> NOT NULL COMMENT 'Message-Id header',
  `status` varchar(50) <?php echo $default_collation ?> NOT NULL DEFAULT '',
  `additional_data` text <?php echo $default_collation ?>,
  PRIMARY KEY (`id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;


-- add column in mail accounts table to know if account is used for newsletters
ALTER TABLE `<?php echo $table_prefix ?>mail_accounts` ADD `for_newsletters` tinyint(1) NOT NULL DEFAULT 0;