og.newsletters = {
	
	init: function() {
		
	},

	addContactsToNewsletter: function(before, newsletter_id,newsletter_object_type_id, genid) {
	
		var contact_types = new Array('contact','company','user');
		
		og.ObjectSelector.show(function (objs) {
	
			if (newsletter_id > 0) {
				og.openLink(og.getUrl('newsletter', 'save_newsletter_contacts', {id: newsletter_id, genid: genid}));
			}
			
		}, before, {
			types: ['contact'],
			ignore_context: true,
			selected_type: 'contact',
			object_id: newsletter_id,
            object_type_id:newsletter_object_type_id,
			show_associated_dimension_filters: true,
			registered_types_of_objects: contact_types,
			keep_selector_changes: newsletter_id == 0
		});
	
		og.newsletters.addContactTypesToObjectSelector(contact_types);
	},
	
	addContactTypesToObjectSelector: function(contact_types) {
		var topToolbar = Ext.getCmp('obj_selector_filters').getTopToolbar();
		var displayOptions = new Array();
		for (i=0; i<contact_types.length; i++) {	
			var cp_option = new Ext.menu.CheckItem ({
				option_index: i,
				checked:false, 
				stateful:true,
				text: lang(contact_types[i]),
				value: contact_types[i],
				stateId: "contact_type_filter_menu_action_view_"+contact_types[i],
		        stateEvents: ['click'],
		        getState: function() {
		            return {checked: this.checked}
		        },
		        applyState: function(state) {
		            this.checked = state.checked;
		        },
				hideOnClick:false,
				listeners: {
					  checkchange: function(item, state){
						//if is checked
						if(state){
							Ext.getCmp('contact_type_filter_menu_action_view').selected_values[this.value] = true;
					    }else{
					    	Ext.getCmp('contact_type_filter_menu_action_view').selected_values[this.value] = false;
					    }

						og.newsletters.filter_newsletter_receivers_by_contact_type(true);
					  },		
					  render: function(item){
						  Ext.getCmp('contact_type_filter_menu_action_view').selected_values[this.value] = item.checked;
						  
						  og.newsletters.filter_newsletter_receivers_by_contact_type(false);
						  
						  // if this is the last option rendered => tell the selector that all contact types have been rendered
						  if (this.option_index == contact_types.length-1) {
							  og.eventManager.fireEvent('object selector all type menu items rendered');
						  }
					  }
				}
			});	   		
			displayOptions.push(cp_option);
		}
		
		//Menu custom properties to reneder
	   	var action = new Ext.Action({
			text: lang('contact type filter'),
			id: "contact_type_filter_menu_action_view",
			iconCls: 'ico-view_options',
			disabled: false,	
			selected_values: {},
			listeners: {
				render: function(item){	   					
	   				item.menu.render();
	   			}
			},
			menu: {items: displayOptions}
		});
	   	
	   	//Add cp menu to the render_to_component toolbar		
	   	topToolbar.add(action);
	},

	filter_newsletter_receivers_by_contact_type: function(reload_the_list){		
		//update component store baseparams 
		Ext.getCmp('obj_selector_grid').store.baseParams.contact_type_filter = Ext.util.JSON.encode(Ext.getCmp('contact_type_filter_menu_action_view').selected_values);
		
		//Reload the list
		if (reload_the_list) {
			Ext.getCmp('obj_selector_grid').store.reload();
		}
		
	}

}