<div class="adminConfiguration">
    <form class="internalForm" action="<?php echo get_url('notifications_manager', 'save_notification_trigger_options'); ?>" method="post">
        <div class="coInputHeader">
            <div class="coInputTitle">
                <table style="width:670px">
                    <tr>
                        <td>
                            <?php echo lang("notification triggers")?>
                        </td>
                        <td style="text-align:right">
                            <?php echo submit_button(lang('save'), 's', array('style' => 'margin-top:0px;', 'class' => 'blue')) ?>
                        </td>
                    </tr>
                </table>
            </div>
        </div>
        
        <div class="adminMainBlock">
            <?php if (isset($options) && is_array($options) && count($options)){ 
        
                $grouped_options = array(
                        'notify_a_user_when' => array(),
                        'change_in_a_task' => array(),
                        'change_in_an_object' => array(),
                );
                
                foreach ($options as $opt) {
                    if (in_array($opt->getName(), array('timeslot_logged', 'estimated_time_exceeded'))) continue;
                    if (in_array($opt->getName(), array('classification_changed',
                                                        'description_changed',
                                                        'name_changed'))) {
                        $grouped_options['change_in_an_object'][] = $opt;
                    } elseif(in_array($opt->getName(), array('start_or_due_date_modified',
                                                             'task_started_or_completed',
                                                             'priority_changed',
                                                             'percent_completed_changed',
                                                             'time_estimate_changed'))) {
                        $grouped_options['change_in_a_task'][] = $opt;                                         
                    }else {
                        $grouped_options['notify_a_user_when'][] = $opt;
                    }
                }
                
                ?>
                <div id="configCategoryOptions">
                    <?php $counter = 0; ?>
                    
                    <?php foreach ($grouped_options as $group_code => $g_options) { 
                    
                        $style = 'style="margin-left:20px;"';
                        if ($group_code != 'none') {
                            echo '<div class="bold" style="font-size:120%;margin:40px 0 25px 0;">'.lang($group_code).'</div>';
                            //$style = 'style="margin-left:20px;"';
                        }
                        ?>
                        <div style="margin: 0 0 5px 295px; color: #333;">
                
                            <div style="padding-right: 65px; display: inline-block;">Immediate</div>
                            <div style="padding-right: 45px; display: inline-block;">Daily Summary</div>
                            <div style="padding-right: 50px; display: inline-block;">Weekly Summary</div>
                            
                        </div>
                        <?php foreach ($g_options as $option){ /* @var $option ConfigOption */ ?>
                            <?php $counter++; ?>
                            <div class="configCategoryOtpion <?php echo $counter % 2 ? 'odd' : 'even' ?>">
                                <div class="configOptionInfo">
                                    <div class="configOptionLabel" <?php echo $style ?>><label><?php echo clean($option->getDisplayName()) ?>:</label></div>
                                    <?php if ($option->getDisplayDescription()) { ?>
                                    <div class="desc"><?php echo $option->getDisplayDescription()?></div>
                                    <?php } ?>
                                </div>
                                <div class="configOptionControl">
                                    <?php
                                        echo $option->renderUsingHideLabel('options[' . $option->getName() . ']', true);
                                    ?>
                                </div>
                                <div class="clear"></div>
                            </div>
                        <?php } // foreach ?>
                    <?php } // foreach ?>
                </div>
                <?php echo submit_button(lang('save'), 's', array('style' => 'margin: 20px 0 30px 615px;')) ?>
            <?php }?>
        </div>
    </form>
</div>