<?php
	class ObjectSubtype extends BaseObjectSubtype {
		
		function getArrayInfo($include_object_type = true) {
			
			$info = array(
				"id" => $this->getId(),
				"name" => $this->getName(),
				"ot_id" => $this->getObjectTypeId(),
				"gender" => $this->getGender(),
				"sum_in_total" => $this->getSumInTotal(),
				"is_special" => $this->getIsSpecial(),
				"member_id" => $this->getMemberId(),
			);
			if ($include_object_type) {
				$ot = ObjectTypes::instance()->findById($this->getObjectTypeId());
				if ($ot instanceof ObjectType) {
					$info['ot_id'] = $ot->getId();
					$info['ot_name'] = escape_character($ot->getName());
					$info['controller'] = $ot->getObjectTypeController();
					$info['add_action'] = $ot->getObjectTypeAddAction();
				}
			}
			
			return $info;
		}

		
		function delete() {
			$custom_properties = CustomProperties::instance()->findAll(array('conditions' => 'object_type_id='.$this->getObjectTypeId().' AND object_subtype_id='.$this->getId()));
			foreach ($custom_properties as $cp) {
				$cp->delete();
			}
			return parent::delete();
		}
		
		
		
		
	}
	 
