<?php
	$genid = gen_id();
	$object = $object_subtype;
	
	// on submit functions
	if (array_var($_REQUEST, 'modal')) {
		$on_submit = "og.submit_modal_form('".$genid."submit-edit-form'); return false;";
	} else {
		$on_submit = "return true;";
	}
	
	$parent_ot_id = ObjectTypeDependencies::getMainObjectTypeId($object_type->getId());
	if ($parent_ot_id) {
		$parent_subtypes = ObjectSubtypes::instance()->findAll(array(
				'conditions' => "object_type_id='$parent_ot_id'"
		));
	}

	$general_type_name = $object_type->getObjectTypeName();
?>

<form onsubmit="<?php echo $on_submit?>" class="add-object_subtype" id="<?php echo $genid ?>submit-edit-form" action="<?php echo $object_subtype->isNew() ? get_url('object_subtypes', 'add') : get_url('object_subtypes', 'edit', array('id' => $object_subtype->getId())) ?>" method="post" enctype="multipart/form-data">

<input type="hidden" name="object_subtype[object_type_id]" value="<?php echo $object_type->getId()?>" />

<div class="object-subtype">
<div class="coInputHeader">

  <div class="coInputHeaderUpperRow">
	<div class="coInputTitle">
		<?php echo $object_subtype->isNew() ? lang('new subtype of', $general_type_name) : lang('edit subtype of', $general_type_name) ?>
	</div>
  </div>

  <div>
	<div class="coInputName">
		
	</div>
	
	<div class="coInputButtons" style="float:right;">
		<?php echo submit_button($object_subtype->isNew() ? lang('add subtype of', $general_type_name) : lang('save changes'),'s',array('style'=>'margin-top:0px;margin-left:10px')) ?>
	</div>
	<div class="clear"></div>
  </div>
</div>

<div class="coInputMainBlock">
	
	<div id="<?php echo $genid?>tabs" class="edit-form-tabs">
	
		<ul id="<?php echo $genid?>tab_titles">
		
			<li><a href="#<?php echo $genid?>add_subtype_details"><?php echo lang('details') ?></a></li>
			
		</ul>

		
		<div id="<?php echo $genid ?>add_subtype_details" class="form-tab" style="min-height:100px;">
		
			<div class="dataBlock">
				<?php echo label_tag(lang('name', $genid . 'object_subtype_title'))?>
				<?php echo text_field('object_subtype[name]', $object->getName(), array('id' => $genid . 'object_subtype_title', 'class' => 'title', 'placeholder' => lang('type name here'))) ?>
			</div>
			
			<div class="dataBlock">
				<?php echo label_tag(lang('color'))?>
				<?php render_color_selector('object_subtype[color]', $object->getColor(), 'object_subtype_color', $genid); ?>
			</div>
			
			<?php if (!is_null($parent_ot_id)) { ?>
			<div class="dataBlock">
				<?php echo label_tag(lang('dependant of'))?>
				<?php 
					$options = array(option_tag('', 0));
					if (is_array($parent_subtypes)) {
						foreach ($parent_subtypes as $parent_subtype) {
							$attr = array();
							if (isset($dependant_of_subtype_id) && $dependant_of_subtype_id == $parent_subtype->getId()) {
								$attr["selected"] = "selected";
							}
							$options[] = option_tag($parent_subtype->getName(), $parent_subtype->getId(), $attr);
						}
					}
					echo select_box('object_subtype[main_object_type_id]', $options);
				?>
			</div>
			<?php } ?>
			
			<?php if (config_option('allow_configure_subtype_gender')) { ?>
			<div class="dataBlock">
				<?php echo label_tag(lang('gender', $genid . 'object_subtype_gender'))?>
				<?php $options = array();
					$attr = $object_subtype->getGender() == 'f' ? array('selected' => 'selected') : array();
					$options[] = option_tag(lang('femenine'), 'f', $attr);
					$attr = $object_subtype->getGender() == 'm' ? array('selected' => 'selected') : array();
					$options[] = option_tag(lang('masculine'), 'm', $attr);
					echo select_box('object_subtype[gender]', $options);
				?>
			</div>
			<?php } else { ?>
				<input type="hidden" name="object_subtype[gender]" value="<?php echo $object_subtype->getGender() ?>"/>
			<?php } ?>
			
			<input type="hidden" name="object_subtype[code]" value="<?php echo $object_subtype->getCode() ?>"/>
			
		</div>
		
		
	</div>
	
</div>

</div>
</form>

<script>
$(function() {
	$("#<?php echo $genid?>tabs").tabs();
	setTimeout(function() {
		$("#<?php echo $genid?>object_subtype_title").focus();
	},250);
});
</script>