<?php

/**
 * MailTemplate class
 *
 * 
 */
class MailTemplate extends BaseMailTemplate {
	
	function getArrayInfo() {
		$info = array();
			
		$columns = $this->getColumns();
		foreach ($columns as $col) {
			$info[$col] = $this->getColumnValue($col);
			if ($info[$col] instanceof DateTimeValue) $info[$col] = format_date($info[$col], null, 0);
		}
		
		/* enable this code when mail templates become content_object
		$general_info = $this->getObject()->getArrayInfo();
		$info = array_merge($info, $general_info);
		*/
			
		return $info;
	}
	
	function getEditUrl() {
		return get_url('mail_template', 'edit', array('id' => $this->getId()));
	}
	
	function getDeleteUrl() {
		return get_url('mail_template', 'delete', array('id' => $this->getId()));
	}
	
} 