<?php
	$genid = gen_id();
	$grid_id = array_var($_REQUEST, 'current')."_mail_templates_module_grid";
	
	/*
	$dummy_mail_template = new Form();
	$can_add_mail_templates = $dummy_mail_template->canAdd(logged_user(), active_context());
	*/
	$can_add_mail_templates = can_manage_mail_templates(logged_user());
	
	$mail_template_columns = MailTemplates::instance()->getColumns();
	
?>

<div id="mail_templatePanel" class="ogContentPanel" style="height:100%;">

	<div id="<?php echo $grid_id ?>_container" style="height:100%;"></div>

</div>


<script>
	
	var grid_id = '<?php echo $grid_id ?>';
	
    og.module_mail_templates_grid = {
		
    	grid_id: grid_id,
		
    	delete_mail_template: function(tid) {
    		if (confirm('<?php echo escape_single_quotes(lang('confirm delete mail_template'))?>')) {
    			og.openLink(og.getUrl('time', 'delete_mail_template', {id:tid}), {
    				callback: function(success, data) {
    					var g = Ext.getCmp(og.module_mail_templates_grid.grid_id);
    					if (g) g.reset();
    				}
    			});
    		}
    	}
    }

    
	// columns
    var mail_templates_columns = [];
    
	// system columns
    var system_columns = ['id','object_id','body','mail_account_id','attachments','send_datetime','member_id','object_status_types_id', 'object_type_id', 'is_notification_template'];
    for (var j=0; j<system_columns.length; j++) {
    	mail_templates_columns.push({
        	name: system_columns[j],
        	is_system: true
        });
    }
<?php
	foreach ($mail_template_columns as $column) {
		if ($column == 'name') continue;
		$renderer = "'string'";
		if (MailTemplates::instance()->getColumnType($column) == DATA_TYPE_BOOLEAN) {
			$renderer = 'og.gridBooleanColumnRenderer';
		}
?>
		var column = '<?php echo $column ?>';
		if (system_columns.indexOf(column) == -1) {
			mail_templates_columns.push({
				name: column,
				header: '<?php echo lang($column) ?>',
				renderer: <?php echo $renderer ?>,
				sortable: true
			});
		}
<?php
	}
?>

	mail_templates_columns.push({
		name: 'actions',
		is_right_column: true,
		fixed: true,
		width: 100, 
		renderer: function(value, p, r) {
			var obj_id = r.data.object_id ? r.data.object_id : r.data.id;
			var actionStyle = ' style="font-size:105%;padding-top:2px;padding-bottom:3px;padding-left:16px;background-repeat:no-repeat;" ';
			var actions = String.format(
				'<a class="list-action ico-edit" href="#" onclick="og.render_modal_form(\'\', {c:\'mail_template\', a:\'edit\', params:{id:'+obj_id+'}});" title="{0}" '+
				actionStyle + '>&nbsp;</a>', lang('edit')
			);
			return actions;
		}
	});


    // buttons
    var mail_templates_tbar_items = [];

	var back = new Ext.Action({
		text: lang('back'),
        tooltip: lang('back'),
        iconCls: 'ico-back',
        handler: function() {
        	og.goback(this.el.dom);
		}
	});
    mail_templates_tbar_items.push(back);

<?php if ($can_add_mail_templates) { ?>
		var new_params = {};

<?php	$new_params = array();
		Hook::fire('new_mail_template_btn_params', null, $new_params);
		foreach ($new_params as $param_name => $param_val) { ?>
			new_params['<?php echo $param_name ?>'] = '<?php echo $param_val ?>';
<?php	} ?>

	    var new_btn = new Ext.Button({
	    	iconCls: 'ico-new add-first-btn blue',
	    	text: '<?php echo lang('add mail_template')?>',
	    	id: 'new_mail_template_btn',
	    	handler: function() {
	    		og.render_modal_form('', {c:'mail_template', a:'add', params: new_params});
	    	}
	    });
	    mail_templates_tbar_items.push(new_btn);
<?php } ?>

	var delete_action = new Ext.Action({
		text: lang('delete'),
	    tooltip: lang('move selected objects to trash'),
	    iconCls: 'ico-delete',
		disabled: true,
		handler: function() {
			var confirm_trash_config = parseInt(og.preferences['enableTrashConfirmation']);
			var grid = Ext.getCmp("<?php echo $grid_id?>");
			if (og.confirmNorification(lang('confirm delete permanently'), confirm_trash_config)) {
				grid.load({
					action: 'delete',
					ids: grid.getSelectedIds()
				});
				grid.getSelectionModel().clearSelections();
			}
		},
		selection_dependant: true,
		is_multiple: true
	});
	
	var edit_action = new Ext.Action({
		text: lang('edit'),
	    tooltip: lang('edit selected object'),
	    iconCls: 'ico-edit',
		disabled: true,
		handler: function() {
			var grid = Ext.getCmp("<?php echo $grid_id?>");
			og.render_modal_form('', {c:'mail_template', a:'edit', params: {id:grid.getFirstSelectedId()}});
		},
		selection_dependant: true,
		is_multiple: false
	});
	
	mail_templates_tbar_items.push(edit_action);
	mail_templates_tbar_items.push(delete_action);
	

<?php 
foreach ($additional_actions as $add_action) { ?>
	mail_templates_tbar_items.push(new Ext.Button({
		iconCls: '<?php echo array_var($add_action, 'cls') ?>',
		text: '<?php echo array_var($add_action, 'text') ?>',
		handler: function() {
			<?php if (isset($add_action['onclick'])) { ?>
			eval("<?php echo $add_action['onclick']?>");
		<?php } else if (isset($add_action['url'])) { ?>
			og.openLink("<?php echo $add_action['url'] ?>");
		<?php } ?>
		}
	}));
<?php } ?>

	og.gridMailTemplateNameRenderer = function(value, p, r) {
		if (r.data.id == '__total_row__' || r.data.object_id <= 0) return '<span id="__total_row__">'+value+'</span>';
		
		var controller = r.data.type_controller ? r.data.type_controller : r.store.baseParams.url_controller;
		var onclick = 'og.render_modal_form(\'\', {c:\'mail_template\', a:\'edit\', params:{id:'+r.data.object_id+'}}); return false;';
		return String.format('<a href="#" onclick="{1}" title="{2}" style="font-size:120%;"><span class="bold">{0}</span></a>', og.clean(value), onclick, og.clean(value));
	}

	// toolbar buttons to the right
	var mail_templates_tbar_right_items = [];
    
    var filters = {};

    var store_parameters = {
    	url_controller: 'mail_template',
    	url_action: 'list_all'
    }

    var grid_params = {};
    <?php 
    $more_grid_params = array();
    Hook::fire('additional_mail_templates_grid_params', array('request' => $_REQUEST), $more_grid_params);
    foreach ($more_grid_params as $param_name => $param_value) {
    ?>
    	grid_params['<?php echo $param_name ?>'] = '<?php echo $param_value ?>';
    <?php 
    }
    ?>
    
    var mail_templates_module_grid = new og.ObjectGrid({
        genid: '<?php echo $genid ?>',
    	renderTo: grid_id + '_container',
    	url: og.getUrl(store_parameters.url_controller, store_parameters.url_action, grid_params),
    	//type_name: 'mail_template',
    	response_objects_root: 'mail_templates',
    	grid_id: grid_id,
    	nameRenderer: og.gridMailTemplateNameRenderer,
    	store_params: store_parameters,
    	filters: filters,
    	checkbox_sel_model: true,
    	skip_dimension_columns: true,
    	fixed_height: true,
    	columns: mail_templates_columns,
    	tbar_items: mail_templates_tbar_items,
    	tbar_right_items: mail_templates_tbar_right_items,
    	add_default_actions_column: false,
    	no_icon_col: true,
    	stateId: 'mail_templates-module'
    });


	var active_tab = Ext.getCmp('tabs-panel').activeTab;
	if (active_tab.events.resize.listeners.length < 2) {
    	active_tab.on('resize', function() {
    		og.resize_all_grids(this);
    	});
    }

    og.resize_all_grids = function(active_tab) {
    	var grids = $("#"+active_tab.id+" .x-grid-panel");
		for (var i=0; i<grids.length; i++) {
			var g = Ext.getCmp($(grids[i]).attr('id'));
			if (g) g.fireEvent('resize');
		}
    }

    mail_templates_module_grid.getView().override({
    	getRowClass: function (record, index, rowParams, store) {
   			return record.data.add_cls ? record.data.add_cls : "";
    	}
    });

    mail_templates_module_grid.load();


	
</script>
