<?php 
	$genid = gen_id();
	/* @var $objective Objective */
	$object = $objective;
	
	$loc = user_config_option('localization');
	if (strlen($loc) > 2) $loc = substr($loc, 0, 2);
	
	// on submit functions
	if (array_var($_REQUEST, 'modal')) {
		$on_submit = "og.setDescription();og.submit_modal_form('".$genid."submit-edit-form'); return false;";
	} else {
		$on_submit = "og.setDescription();";
	}
	
	$categories = array();
	Hook::fire('object_edit_categories', $object, $categories);

	$main_cp_count = CustomProperties::countVisibleCustomPropertiesByObjectType($object->getObjectTypeId());
	$other_cp_count = CustomProperties::countHiddenCustomPropertiesByObjectType($object->getObjectTypeId());
?>
<form class="add-objective" id="<?php echo $genid ?>submit-edit-form" onsubmit="<?php echo $on_submit?>" action="<?php echo $objective->isNew() ? get_url('objective', 'add') : $objective->getEditUrl() ?>" method="post" enctype="multipart/form-data" >
<div class="objective">
<div class="coInputHeader">

  <div class="coInputHeaderUpperRow">
	<div class="coInputTitle">
		<?php echo $object->getAddEditFormTitle(); ?>
	</div>
  </div>

  <div>
	<div class="coInputName">
		<?php echo text_field('objective[name]', $objective->getName(), array('id' => $genid . 'objectiveName', 'class' => 'title', 'placeholder' => lang('type name here'))) ?>
	</div>
		
	<div class="coInputButtons">
		<?php echo submit_button($object->getSubmitButtonFormTitle(),'s', array('style'=>'margin-top:0px;margin-left:10px')) ?>
	</div>
	<div class="clear"></div>
  </div>
</div>


<div class="coInputMainBlock">
	
	<input id="<?php echo $genid?>genid" type="hidden" name="genid" value="<?php echo $genid ?>">
	<input id="<?php echo $genid?>updated-on-hidden" type="hidden" name="updatedon" value="<?php echo !$objective->isNew() ? $objective->getUpdatedOn()->getTimestamp() : '' ?>">
	
	<div id="<?php echo $genid?>tabs" class="edit-form-tabs">
	
		<ul id="<?php echo $genid?>tab_titles">
		
			<li><a href="#<?php echo $genid?>add_objective_details"><?php echo lang('details') ?></a></li>
			
			<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
			<li><a href="#<?php echo $genid?>add_custom_properties_div"><?php echo lang('custom properties') ?></a></li>
			<?php } ?>
			
                        <li><a href="#<?php echo $genid?>add_objective_description"><?php echo lang('description') ?></a></li>
			<li><a href="#<?php echo $genid?>add_subscribers_div"><?php echo lang('object subscribers') ?></a></li>
			
			<?php if($object->isNew() || $object->canLinkObject(logged_user())) { ?>
			<li><a href="#<?php echo $genid?>add_linked_objects_div"><?php echo lang('linked objects') ?></a></li>
			<?php } ?>
			
			<?php foreach ($categories as $category) {
					if (array_var($category, 'hidden')) continue;
				?>
			<li><a href="#<?php echo $genid . $category['name'] ?>"><?php echo $category['name'] ?></a></li>
			<?php } ?>
		</ul>
	
		<div id="<?php echo $genid ?>add_objective_details" class="editor-container form-tab">
	
			<div id="<?php echo $genid ?>add_objective_select_context_div">
				<?php
				$listeners = array('on_selection_change' => 'og.reload_subscribers("'.$genid.'",'.$object->manager()->getObjectTypeId().')');
				if ($objective->isNew()) {
					render_member_selectors($objective->manager()->getObjectTypeId(), $genid, null, array('select_current_context' => true, 'listeners' => $listeners, 'object' => $object), null, null, false);
				} else {
					render_member_selectors($objective->manager()->getObjectTypeId(), $genid, $objective->getMemberIds(), array('listeners' => $listeners, 'object' => $object), null, null, false);
				} 
				?>
			</div>
			
			<div class="clear"></div>
			
			<div class="dataBlock"><?php
		
				echo label_tag(lang('initial value'), $genid . 'objectiveInitialValue');
				echo input_field('objective[initial_value]', $objective->getInitialValue(), array('type'=>'number'));
			
			?></div>
			<div class="dataBlock"><?php
		
				echo label_tag(lang('intermediate objective'), $genid . 'objectiveIntermediateObjective');
				echo input_field('objective[intermediate_objective]', $objective->getIntermediateObjective(), array('type'=>'number'));
			
			?></div>
			<div class="dataBlock"><?php
		
				echo label_tag(lang('final objective'), $genid . 'objectiveFinalObjective');
				echo input_field('objective[final_objective]', $objective->getFinalObjective(), array('type'=>'number'));
			
			?></div>
			<div class="dataBlock"><?php
				$asc_attr = array();
				if ($objective->getDirection() == 'asc') $asc_attr['selected'] = 'selected';
				$desc_attr = array();
				if ($objective->getDirection() == 'desc') $desc_attr['selected'] = 'selected';
				
				echo label_tag(lang('direction'), $genid . 'objectiveDirection');
				echo select_box('objective[direction]', array(
					option_tag(lang('ascending'), 'asc', $asc_attr),
					option_tag(lang('descending'), 'desc', $desc_attr),
				));
			
			?></div>
			<div class="clear"></div>
			
			<div class="dataBlock"><?php
		
				echo label_tag(lang('start date'), $genid . 'objectiveStartDate');
				echo pick_date_widget2('objective[start_date]', $objective->getStartDate(), $genid);
			
			?></div>
			<div class="dataBlock"><?php
		
				echo label_tag(lang('end date'), $genid . 'objectiveEndDate');
				echo pick_date_widget2('objective[end_date]', $objective->getEndDate(), $genid);
			
			?></div>
			<div class="clear"></div>
			
			<div class="dataBlock"><?php
		
				echo label_tag(lang('current value'), $genid . 'objectiveCurrentValue');
				echo input_field('objective[current_value]', $objective->getCurrentValue(), array('type'=>'number'))
			
			?></div>
			<div class="clear"></div>
			
			<?php $null = null; Hook::fire('before_render_main_custom_properties', array('object' => $object), $null);?>
			
			<div class="main-custom-properties-div"><?php
				if ($main_cp_count) {
					echo render_object_custom_properties($object, false, null, 'visible_by_default');
				}
			?></div>
		</div>
            
                <div id="<?php echo $genid ?>add_objective_description" class="editor-container form-tab">
                    <?php
                        $ckEditorContent = purify_html(nl2br($objective->getDescription()));
                    ?>
                    <div>
                        <div id="<?php echo $genid ?>ckcontainer" style="height: 400px">
                            <textarea cols="80" id="<?php echo $genid ?>ckeditor" name="objective[description]" rows="10"><?php echo clean($ckEditorContent) ?></textarea>
                        </div>
                    </div>

                    <script>
                        var h = document.getElementById("<?php echo $genid ?>ckcontainer").offsetHeight;
                        var editor = CKEDITOR.replace('<?php echo $genid ?>ckeditor', {
                                        height: '330px',
                                        allowedContent: true,
                                        resize_enabled: false,
                                        enterMode: CKEDITOR.ENTER_BR,
                                        shiftEnterMode: CKEDITOR.ENTER_BR,
                                        disableNativeSpellChecker: false,
                                        language: '<?php echo $loc ?>',
                                        customConfig: '',
                                        contentsCss: ['<?php echo get_javascript_url('ckeditor/contents.css').'?rev='.product_version_revision();?>', '<?php echo get_stylesheet_url('og/ckeditor_override.css').'?rev='.product_version_revision();?>'],
                                        toolbar: [
                                            ['Bold','Italic','Underline','Strike','-',
                                            'Font','FontSize','-', 'Blockquote','-',
                                            'SpellChecker', 'Scayt','-',
                                            'NumberedList','BulletedList','-',
                                            'TextColor','BGColor','RemoveFormat','-',
                                            'Link','Unlink','-',
                                            'JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock']
                                        ],
                                        on: {
                                            instanceReady: function(ev) {
                                                og.adjustCkEditorArea('<?php echo $genid ?>');
                                                editor.resetDirty();
                                            }
                                        },
                                        fillEmptyBlocks: false,
                                        removePlugins: 'scayt,liststyle,magicline',
                                        entities_additional : '#336,#337,#368,#369,#124'
                                    });

                        og.setDescription = function() {
                                                var form = Ext.getDom('<?php echo $genid ?>submit-edit-form');
                                                if (form.preventDoubleSubmit) return false;
                                                    setTimeout(function() {
                                                        form.preventDoubleSubmit = false;
                                                    }, 2000);

                                                var editor = og.getCkEditorInstance('<?php echo $genid ?>ckeditor');
                                                form['objective[description]'].value = editor.getData();

                                                return true;
                                            };
                    </script>
		</div>
		
		<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
		<div id="<?php echo $genid ?>add_custom_properties_div" class="form-tab other-custom-properties-div">
			<?php  echo render_object_custom_properties($object, false, null, 'other') ?>
			<?php  echo render_add_custom_properties($object); ?>
		</div>
		<?php } ?>
		
		<div id="<?php echo $genid ?>add_subscribers_div" class="form-tab">
			<div id="<?php echo $genid ?>add_subscribers_content">
				<?php echo render_add_subscribers($object, $genid); ?>
			</div>
		</div>
		
		<?php if($object->isNew() || $object->canLinkObject(logged_user())) { ?>
		<div id="<?php echo $genid ?>add_linked_objects_div" class="form-tab">
			<?php echo render_object_link_form($object) ?>
		</div>
		<?php } // if ?>
	
		<?php foreach ($categories as $category) { ?>
		<div id="<?php echo $genid . $category['name'] ?>" class="form-tab">
			<?php echo $category['content'] ?>
		</div>
		<?php } ?>

	
	<div class="clear"></div>
</div>
	<?php if (!array_var($_REQUEST, 'modal')) {
		echo submit_button($objective->isNew() ? lang('add objective') : lang('save changes'),'s', array('tabindex' => '20000')); 
	}?>
</div>

</div>
</form>

<script>
var genid = '<?php echo $genid?>';
$(function(){
	$("#<?php echo $genid?>tabs").tabs();
});
</script>