<?php 

function objectives_update_1_2() {
	DB::executeAll("INSERT INTO ".TABLE_PREFIX."tab_panel_permissions (permission_group_id, tab_panel_id)
		 SELECT pg.id, 'objectives-panel' FROM ".TABLE_PREFIX."permission_groups pg WHERE pg.type='roles' AND pg.name IN ('Super Administrator','Administrator','Manager','Executive')
		ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;");
}

function objectives_update_2_3() {
	DB::executeAll("INSERT INTO ".TABLE_PREFIX."role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		 SELECT rtp.role_id, (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='objective'), can_delete, can_write
		 FROM ".TABLE_PREFIX."role_object_type_permissions rtp WHERE rtp.object_type_id=(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='task')
		ON DUPLICATE KEY UPDATE ".TABLE_PREFIX."role_object_type_permissions.role_id=".TABLE_PREFIX."role_object_type_permissions.role_id;");
}

function objectives_update_3_4() {
	DB::executeAll("INSERT INTO ".TABLE_PREFIX."max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		 SELECT rtp.role_id, (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='objective'), can_delete, can_write
		 FROM ".TABLE_PREFIX."max_role_object_type_permissions rtp WHERE rtp.object_type_id=(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='task')
		ON DUPLICATE KEY UPDATE ".TABLE_PREFIX."max_role_object_type_permissions.role_id=".TABLE_PREFIX."max_role_object_type_permissions.role_id;");
}

function objectives_update_4_5() {
	DB::executeAll("
		DELETE FROM ".TABLE_PREFIX."max_role_object_type_permissions 
		WHERE object_type_id IN (
			 SELECT o.id
			 FROM `".TABLE_PREFIX."object_types` o 
			 WHERE o.`name` IN ('objective')
		);
	");
	DB::executeAll("
		INSERT INTO ".TABLE_PREFIX."max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 1, 1
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('objective')
			 AND p.`name` IN ('Super Administrator','Administrator','Manager');
	");
	DB::executeAll("
		INSERT INTO ".TABLE_PREFIX."max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 0, 1
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('objective')
			 AND p.`name` IN ('Executive');
	");
	DB::executeAll("
		INSERT INTO ".TABLE_PREFIX."max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 0, 0
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('objective')
			 AND p.`name` IN ('Collaborator Customer','Internal Collaborator','External Collaborator','Guest Customer');
	");
	DB::executeAll("
		DELETE FROM ".TABLE_PREFIX."role_object_type_permissions
		WHERE object_type_id IN (
			SELECT o.id
			FROM `".TABLE_PREFIX."object_types` o
			WHERE o.`name` IN ('objective')
		);
	");
	DB::executeAll("
		INSERT INTO ".TABLE_PREFIX."role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 1, 1
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('objective')
			AND p.`name` IN ('Super Administrator','Administrator','Manager');
	");
	DB::executeAll("
		INSERT INTO ".TABLE_PREFIX."role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 0, 1
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('objective')
			AND p.`name` IN ('Executive');
	");
}