<?php 
/*
 *  DO NOT DELETE. this is needed for  plugins to work
 */
class ObjectsImportController extends ApplicationController {
	
	var $plugin_name = "objects_import";
	
	function __construct() {
		parent::__construct();
		prepare_company_website_controller($this, 'website');
        Env::useHelper('object_types_allowed_to_import', $this->plugin_name);
        Env::useHelper('object_fields_allowed_to_import', $this->plugin_name);
        Env::useHelper('object_import_csv_functions', $this->plugin_name);
	}

    function import_from_csv_file() {
        ini_set('memory_limit', '4G');
        set_time_limit(0);
        if (!logged_user()->isAdministrator()) {
            flash_error(lang('no access permissions'));
            ajx_current("empty");
            return;
            render_dimension_trees($content_object_type_id, $genid, $selected, array('select_current_context' => true));
        }

        @set_time_limit(0);
        ini_set('auto_detect_line_endings', '1');
        if (isset($_GET['from_menu']) && $_GET['from_menu'] == 1) unset($_SESSION['history_back']);
        if (isset($_SESSION['history_back'])) {
            unset($_SESSION['history_back']);
            ajx_current("start");
        } else {
            $this->setTemplate(get_template_path('csv_import', 'objects_import', 'objects_import'));

            //Object types
            $types = array(array("", lang("select one")));
            $allowed_object_types = get_allowed_object_types_to_import();
            foreach ($allowed_object_types as $allowed_object_type) {
                $types[] = $allowed_object_type;
            }
            tpl_assign('object_types', $types);

            //Get titles from de csv file
            $filedata = array_var($_FILES, 'csv_file');
            if (is_array($filedata) && !is_array(array_var($_POST, 'objectTypeSel'))) {
                $filename = $filedata['tmp_name'].'.csv';
                copy($filedata['tmp_name'], $filename);

                $first_record_has_names = array_var($_POST, 'first_record_has_names', false);
                $delimiter = array_var($_POST, 'delimiter', '');
                if ($delimiter == '') $delimiter = $this->searchForDelimiter($filename);
                $date_format = array_var($_POST, 'date_format', 'd/m/Y');
                $use_country_name = array_var($_POST, 'to_assign_country_use', false);
                $thousand_separator = array_var($_POST, 'thousand_separator', 0) != 1 ? ',' : '.';
                $decimal_separator = array_var($_POST, 'decimal_separator', 0) != 1 ? '.' : ',';
                $taxes = array_var($_POST, 'taxes', array());

                $_SESSION['delimiter'] = $delimiter;
                $_SESSION['csv_import_filename'] = $filename;
                $_SESSION['first_record_has_names'] = $first_record_has_names;
                $_SESSION['date_format'] = $date_format;
                $_SESSION['to_assign_country_use'] = $use_country_name;
                $_SESSION['thousand_separator'] = $thousand_separator;
                $_SESSION['decimal_separator'] = $decimal_separator;
                $_SESSION['taxes'] = $taxes;

                $titles = read_csv_file($filename, $delimiter, true);

                tpl_assign('titles', $titles);

                //Object properties
                $object_type_id = array_var($_POST, 'objectTypeSel');
                $_SESSION['import_type'] = $object_type_id;
                $object_fields = get_allowed_columns_by_objet_type($object_type_id);
                tpl_assign('object_fields', $object_fields);


                //Objects Classification
                tpl_assign('content_object_type_id', $object_type_id);
            }

            if (array_var($_GET, 'calling_back', false)) {
                $filename = $_SESSION['csv_import_filename'];
                $delimiter = $_SESSION['delimiter'];
                $first_record_has_names = $_SESSION['first_record_has_names'];
                $date_format = $_SESSION['date_format'];
                $use_country_name = $_SESSION['to_assign_country_use'];
                $thousand_separator = $_SESSION['thousand_separator'];
                $decimal_separator = $_SESSION['decimal_separator'];
                $taxes = $_SESSION['taxes'];

                $titles = read_csv_file($filename, $delimiter, true);

                unset($_GET['calling_back']);
                tpl_assign('titles', $titles);
            }

            //Import data and create objects
            if (is_array(array_var($_POST, 'select_object_fields'))) {
                $import_result = array('import_ok' => array(), 'import_fail' => array());
                $filename = $_SESSION['csv_import_filename'];
                $delimiter = $_SESSION['delimiter'];
                $first_record_has_names = $_SESSION['first_record_has_names'];
                $date_format = $_SESSION['date_format'];
                $use_country_name = $_SESSION['to_assign_country_use'];
                $thousand_separator = $_SESSION['thousand_separator'];
                $decimal_separator = $_SESSION['decimal_separator'];
                $taxes = $_SESSION['taxes'];

                $member_ids = json_decode(array_var($_POST, 'members'));
                $object_controller = new ObjectController();

                $object_type_id = $_SESSION['import_type'];
                $object_type = ObjectTypes::instance()->findById($object_type_id);
                if ($object_type instanceof ObjectType && (class_exists($object_type->getHandlerClass()) || $object_type->getType() == 'dimension_group')) {
                    //getHandlerClass();
                    if ($object_type->getType() == 'dimension_group') {
                        $ot_manager = Members::instance();
                        $memberCustomPropertiesController = new MemberCustomPropertiesController();
                    } else {
                        eval('$ot_manager = ' . $object_type->getHandlerClass() . '::instance();');
                    }
                    if ($object_type->getName() == 'project'){
                        Env::useController('project');
                        $mem_controller = new ProjectController();
                    } else if ($object_type->getName() == 'customer'){
                        Env::useController('customer');
                        $mem_controller = new CustomerController();
                    } else if ($object_type->getName() == 'supplier' || $object_type->getType() == 'dimension_group'){
                        Env::useController('member');
                        $mem_controller = new MemberController();
                    }
                    if($object_type->getName() == 'timeslot'){
                        $time_controller = new TimeController();
                    }
                    if($object_type->getName() == 'payment_receipt' || $object_type->getName() == 'timeslot') {
                        $task_ids_cache = array();
                        $project_ids_cache = array();
                    }
                    if($object_type->getName() == 'invoice'){
                        $invoice_controller = new InvoiceController();
                        // Build tax params
                        $applied_taxes = array();
                        foreach($taxes as $key => $value){
                            if($value == 1) $applied_taxes[] = $key;
                        }
                        $use_taxes_in_lines = income_config_option("use_line_taxes");
                        $income_taxes = IncomeTaxes::instance()->findAll(array('condition' => array('removed_by_id = 0')));
                        $array_income_taxes = array();
                        $tax_amount = 0;
                        foreach ($income_taxes as $tax) {
                            $tax_record = $tax->getRecord()->getArrayInfo();
                            $array_income_taxes[] = array(
                                'id' => $tax->getId(),
                                'name' => $tax->getName(),
                                'select' => $tax->getSelectDefault(),
                                'is_default' => $tax->getSelectDefault(),
                                'type' => $tax_record['type'],
                                'value' => $tax_record['value'],
                            );
                            if(in_array($tax->getId(), $applied_taxes)){
                                $tax_amount += $tax_record['value'];
                            }
                        }
                        $tax_params = array('array_income_taxes' => $array_income_taxes,
                                            'tax_amount' => $tax_amount,
                                            'applied_taxes' => $applied_taxes,
                                            'use_taxes_in_lines' => $use_taxes_in_lines);
                    }
                    if($object_type->getName() == 'invoice_payment_receipt'){
                        $controller = new InvoicePaymentReceiptController();
                        $invoice_ot_id = ObjectTypes::instance()->findOne(array('conditions' => '`name`="invoice"'))->getId();
                        $invoice_custom_property = CustomProperties::instance()->findOne(array('conditions' => 'object_type_id='.$invoice_ot_id.' AND is_import_id=1'));
                        if(!($invoice_custom_property instanceof CustomProperty)){
                            flash_error(lang('invoices don\'t have custom property as import id'));
                            ajx_current("empty");
                            return;
                        }
                    }

                    $row_count = count_csv_rows($filename, $delimiter);
                    $items_per_run = 100;
                    if($object_type->getName() == 'timeslot') {
                        $_SESSION['dont_calculate_anything'] = true;
                    }
                    for ($i=0; $i <= $row_count; $i+=$items_per_run) {
                        $desired_stop = $i + $items_per_run;
                        $chunk = slice_csv_file($filename, $i, $desired_stop, $delimiter, $first_record_has_names);

                        $fields_to_get = array(
                            'object_data_fields' => array_var($_POST, 'select_object_fields'),
                            'cp_objects_data_fields' => array_var($_POST, 'select_custom_properties'),
                            'member_cp_objects_data_fields' => array_var($_POST, 'select_member_custom_properties'),
                            'assoc_dim_data_fields' => array_var($_POST, 'select_associated_dimension'),
                            'client_contact_data_fields' => array_var($_POST, 'select_client_contact_info'),
                            'content_object_member_ids_fields' => array_var($_POST, 'select_content_object_member')
                        );
    
                        $formatted_data = $this->formatAllFileData($fields_to_get, $chunk, $ot_manager, $date_format, "H:i:s", $thousand_separator, $decimal_separator);
    
                        $objects_data = $formatted_data['objects_data'];
                        $cp_objects_data = $formatted_data['cp_objects_data'];
                        $member_cp_objects_data = $formatted_data['member_cp_objects_data'];
                        $assoc_dim_data = $formatted_data['assoc_dim_data'];
                        $client_contact_data = $formatted_data['client_contact_data'];
                        $content_object_member_ids = $formatted_data['content_object_member_ids'];

                        if ($ot_manager) {
    
                            foreach ($objects_data as $key_row => $object_data) {
    
                                eval('$object = new ' . $ot_manager->getItemClass() . '();');
                                if ($object instanceof ContentDataObject) {
                                    $object->setObjectTypeId($object_type->getId());
                                    $log_action = ApplicationLogs::ACTION_ADD;
    
                                    try {
                                        DB::beginWork();
                                        
                                        if (in_array($object_type->getName(),array('project', 'customer', 'supplier'))){
                                            $dimension_object_params = array(
                                                'object' => $object,
                                                'object_type' => $object_type,
                                                'object_data' => $object_data,
                                                'mem_controller' => $mem_controller,
                                                'assoc_dim_data' => $assoc_dim_data[$key_row],
                                                'client_contact_data' => $client_contact_data[$key_row]
                                            );
                                            if ($object_type->getName() == 'project'){

												if (!$this->verifyIfMemberExists($object_type, $object_data, $cp_objects_data[$key_row])) {
													$object = $this->addProject($dimension_object_params);
												} else {
													throw new Exception($object_type->getObjectTypeName() . " already exists");
												}

                                            } else if ($object_type->getName() == 'customer'){

												if (!$this->verifyIfMemberExists($object_type, $object_data, $cp_objects_data[$key_row])) {
                                                	$object = $this->addClient($dimension_object_params);
												} else {
													throw new Exception($object_type->getObjectTypeName() . " already exists");
												}

                                            } else if ($object_type->getName() == 'supplier'){

												if (!$this->verifyIfMemberExists($object_type, $object_data, $cp_objects_data[$key_row])) {
                                                	$object = $this->addSupplier($dimension_object_params);
												} else {
													throw new Exception($object_type->getObjectTypeName() . " already exists");
												}
												
                                            }
                                        } else {
                                            if($object_type->getName() == 'timeslot'){
                                                $object_type_id = $object_type->getId();
                                                $timeslot_data = $this->prepare_timeslot_data($object_data, $date_format, $content_object_member_ids[$key_row], $task_ids_cache, $project_ids_cache, $object_type_id);
                                                $object = $time_controller->add_timeslot($timeslot_data, false); 
                                            } else if($object_type->getName() == 'invoice'){
                                                $invoice = $this->get_invoice_object($object_data);
                                                $invoice_data = $this->prepare_invoice_data($object_data, $tax_params,  $invoice);
                                                $invoice_member_ids = $content_object_member_ids[$key_row];
                                                $_POST['object_custom_properties'] = $cp_objects_data[$key_row];
                                                $_POST['taxes'] = $taxes;
                                                $object = $invoice_controller->save_invoice($invoice, $invoice_data, $invoice_member_ids);
                                                $object->save();
                                            } else if($object_type->getName() == 'invoice_payment_receipt'){
                                                $payment_data = $this->prepare_payment_data($object_data, $invoice_custom_property);
                                                $payment = new InvoicePaymentReceipt();
                                                $payment_member_ids = $content_object_member_ids[$key_row];
                                                $_POST['object_custom_properties'] = $cp_objects_data[$key_row];
	                                            $_REQUEST['invoices'] = array_var($payment_data, 'invoices');
                                                $object = $controller->save_invoice_payment_receipt($payment, $payment_data, $payment_member_ids);
                                                $object->save();
                                            }else {
                                                if($object_type->getName() == 'payment_receipt'){
                                                    $this->find_task_id_for_payment_receipt($object_data, $content_object_member_ids[$key_row], $task_ids_cache,$project_ids_cache, $object_type);
                                                }
                                                $this->add_missing_info($object_data, $object_type);
                                                $object->setFromAttributes($object_data);
                                                $object->save();
                                            }
                                        }
    
                                        
                                        // Add custom properties
                                        if (array_var($cp_objects_data, $key_row)) {
                                            $object_controller->add_custom_properties($object,$cp_objects_data[$key_row]);
                                        }
                                        
                                        ApplicationLogs::createLog($object, null, $log_action);
                                        DB::commit();
    
                                        //Classify Object
                                        if (!is_null($member_ids) && $object_type->getName() != 'timeslot') {
                                            $object_controller->add_to_members($object, $member_ids);
                                        }
    
            
                                        if($object_type->getName() != 'timeslot' && $content_object_member_ids[$key_row]){
                                            $object_controller->add_to_members($object, array_values($content_object_member_ids[$key_row]));
                                        }
    
                                        $object_data['import_status'] = '('.lang('new').')';
                                        $import_result['import_ok'][] = $object_data;
                                    } catch (Exception $e) {
                                        DB::rollback();
                                        $object_data['fail_message'] = substr_utf($e->getMessage(), strpos_utf($e->getMessage(), "\r\n"));
                                        $import_result['import_fail'][] = $object_data;
                                    }
                                } else if($object instanceof Member) {
                                    $log_action = ApplicationLogs::ACTION_ADD;
                                    try {
                                        DB::beginWork();
                                        $member = $object;
                                        $dimension_ids = DimensionObjectTypes::getDimensionIdsByObjectTypeId($object_type->getId());
                                        $member->setDimensionId($dimension_ids[0]);
                                        $object_data['object_type_id'] = $object_type->getId();
                                        $mem_controller->saveMember($object_data, $member);
    
                                        $object->save();
    
                                        // Save member custom properties
                                        $_POST['member_custom_properties'] = $member_cp_objects_data[$key_row];
                                        $memberCustomPropertiesController->add_custom_properties($member);
    
                                        ApplicationLogs::createLog($member, null, $log_action);
                                        DB::commit();
    
                                        $object_data['import_status'] = '('.lang('new').')';
                                        $import_result['import_ok'][] = $object_data;
                                    } catch (Exception $e) {
                                        DB::rollback();
                                        $object_data['fail_message'] = substr_utf($e->getMessage(), strpos_utf($e->getMessage(), "\r\n"));
                                        $import_result['import_fail'][] = $object_data;
                                    }
    
                                }
                            }
                        }
                    }

                    $_SESSION['dont_calculate_anything'] = false;
                    // recalculate tasks and projects using task ids cache
                    if($object_type->getName() == 'timeslot') {
                        $this->recalculate_executed_values_for_tasks_and_projects($task_ids_cache, $project_ids_cache);
                    }

                }
                
                tpl_assign('import_result', $import_result);
            }
        }
    } // import_from_csv_file


	private function verifyIfMemberExists($object_type, $object_data, $cp_values = array()) {

		if ($object_type->getName() == 'project') {
			
			// for projects verify unicity of project_id, if cp exists and a value is set for this project
			$project_id_cp = CustomProperties::getCustomPropertyByCode($object_type->getId(), 'project_id');
			if ($project_id_cp instanceof CustomProperty) {
				$proejct_id_value = trim(array_var($cp_values, $project_id_cp->getId()));

				// if project has a project_id value then verify if exists ONLY by this field
				if ($proejct_id_value != '') {

					$cp_val = CustomPropertyValues::instance()->findOne(array(
						"conditions" => array("custom_property_id = ? AND value = ?", $project_id_cp->getId(), $proejct_id_value)
					));
					if ($cp_val instanceof CustomPropertyValue) {
						$m = Members::findOneByObjectId($cp_val->getObjectId());
						// if member with this cp exists then return true
						return $m instanceof Member;

					} else {
						// no cp value with the project id is found -> project doesn't exist
						return false;
					}

				}
			}
			// if project id is not present or cp does not exists then continue with normal flow and verify by name
		}

		// verify if already exists using name
		$m = Members::instance()->findOne(array(
			"conditions" => array("object_type_id = ? AND name = ?", $object_type->getId(), $object_data['name'])
		));
		$exists = $m instanceof Member;

		return $exists;
	}

    
    private function getUserColumns($ot_manager) {
    	$user_columns = array();
    	
    	if ($ot_manager instanceof ProjectTasks) {
    		$user_columns[] = 'assigned_to_contact_id';
    	}

        if ($ot_manager instanceof Timeslots) {
    		$user_columns[] = 'contact_id';
    	}

        if ($ot_manager instanceof PaymentReceipts) {
    		$user_columns[] = 'paid_by_id';
    	}

    	
    	return $user_columns;
    }

    private function formatAllFileData($fields_to_get, $file_fields, $ot_manager, $date_format='d/m/Y', $time_format='H:i:s', $thousand_separator=',', $decimal_separator='.'){
        $object_data_fields = array_var($fields_to_get, 'object_data_fields');
        $cp_objects_data_fields = array_var($fields_to_get, 'cp_objects_data_fields');
        $member_cp_objects_data_fields = array_var($fields_to_get, 'member_cp_objects_data_fields');
        $assoc_dim_data_fields = array_var($fields_to_get, 'assoc_dim_data_fields');
        $client_contact_data_fields = array_var($fields_to_get, 'client_contact_data_fields');
        $content_object_member_ids_fields = array_var($fields_to_get, 'content_object_member_ids_fields') ?? [];

        $enabled_dimension_ids = config_option('enabled_dimensions');

        $formatted_data = array(
            'objects_data' => array(),
            'cp_objects_data' => array(),
            'member_cp_objects_data' => array(),
            'assoc_dim_data' => array(),
            'client_contact_data' => array(),
            'content_object_member_ids' => array()
        );
        $row = 1;
        
        foreach ($file_fields as $key => $file_row){
            // Get Objects data
            $formatted_data['objects_data'][] = $this->formatFileData($object_data_fields, $file_row, $row, $ot_manager, $date_format, $time_format, $thousand_separator, $decimal_separator);
            // Get object custom properties' data
            $formatted_data['cp_objects_data'][] = $this->formatFileData($cp_objects_data_fields, $file_row, $row, $ot_manager, $date_format, $time_format, $thousand_separator, $decimal_separator, true);
            // Get member custom properties data
            $formatted_data['member_cp_objects_data'][] = $this->formatFileData($member_cp_objects_data_fields, $file_row, $row, $ot_manager, $date_format, $time_format, $thousand_separator, $decimal_separator, false, true);
            // Get associated dimensions members data
            $formatted_data['assoc_dim_data'][] = $this->formatFileData($assoc_dim_data_fields, $file_row, $row, $ot_manager, $date_format);
            // Get client/supplier contact data
            $formatted_data['client_contact_data'][] = $this->formatFileData($client_contact_data_fields, $file_row, $row, $ot_manager, $date_format);
            // Get content object member ids
            $formatted_data['content_object_member_ids'][] = $this->getContentObjectMemberIds($content_object_member_ids_fields, $file_row, $ot_manager, $enabled_dimension_ids);

            $row++;
        }
        
        return $formatted_data;
    }


    private function formatFileData($objects_fields, $file_row, $row, $ot_manager, $date_format='d/m/Y', $time_format='H:i:s', $thousand_separator=',', $decimal_separator='.', $is_custom_property=false, $is_member_custom_property=false) {
        $object_data = array();
        if(is_array($objects_fields)){
            foreach ($objects_fields as $key => $object_field_value){
                if(is_array($object_field_value) || ($object_field_value >= 0 && $object_field_value != '')){
                    if(!is_array($object_field_value)){
                        $file_row_value = $file_row[$object_field_value];
                    }
                    if (!$is_custom_property && !$is_member_custom_property){
                        // get the proper object for dates
                        if ($ot_manager instanceof ContentDataObjects && 
                            (($ot_manager->getColumnType($key) == DATA_TYPE_DATE || $ot_manager->getColumnType($key) == DATA_TYPE_DATETIME) || $key == 'invoice_line_date')) {
                                if ($file_row_value != ''){
                                    $dt = DateTimeValueLib::dateFromFormatAndString($date_format, $file_row_value);
                                    $file_row_value = $dt;
                                }
                        }
                        // get user by name
                        if ($ot_manager instanceof ContentDataObjects &&
                            in_array($key, $this->getUserColumns($ot_manager))) {
								// filter the query by user_type > 0 to ensure that only users will be assigned to this value
                                $user = Contacts::instance()->findOne(array('conditions' => array("name=? AND user_type > 0",trim($file_row_value))));
                                $file_row_value = $user instanceof Contact ? $user->getId() : 0;
                        }
                        if ($ot_manager instanceof ContentDataObjects && 
                            ($ot_manager->getColumnType($key) == DATA_TYPE_FLOAT || $ot_manager->getColumnType($key) == DATA_TYPE_INTEGER)) {
                                 // Replace thousand separator
                                $without_t_sep_value = str_replace($thousand_separator, '', $file_row_value);
                                // Replace decimal separator if needed
                                $clean_value = $decimal_separator == ',' ? str_replace($decimal_separator, '.', $without_t_sep_value) : $without_t_sep_value;
                                // Format value
                                $file_row_value = $clean_value;
                        }
                    } else {
                        if ($is_custom_property) {
                            $custom_property = CustomProperties::instance()->findById($key);
                        } else if ($is_member_custom_property){
                            $custom_property = MemberCustomProperties::instance()->findById($key);
                        }
                        // Formate date for custom property
                        if($custom_property && $custom_property->getType() == 'date' || $custom_property->getType() == 'datetime'){
                            $config_date_format = user_config_option('date_format');
                            if ($file_row_value != ''){
                                $dtv = DateTimeValueLib::dateFromFormatAndString($date_format, $file_row_value);
                                $file_row_value = $dtv->format($config_date_format);
                            }
                        }
                        // get user by name
                        if($custom_property && $custom_property->getType() == 'contact'){
                            $user = Contacts::instance()->findOne(array('conditions' => array("name=?",trim($file_row_value))));
                            $file_row_value = $user instanceof Contact ? $user->getId() : 0;
                        }
                        // Assign address as custom property
                        if($custom_property && $custom_property->getType() == 'address'){
                            $file_row_value = array('type' => 2);
                            foreach($object_field_value as $address_key => $field_value){
                                if($field_value != '') {
                                    $use_country_name = $_SESSION['to_assign_country_use'];
                                    if($address_key == "country" && $use_country_name){
                                        $country_name = trim($file_row[$field_value]);
                                        $file_row_value[$address_key] = CountryCodes::getCountryCodeByName($country_name);
                                    } else if($address_key == "country") {
                                        $file_row_value[$address_key] = strtolower(trim($file_row[$field_value]));
                                    } else {
                                        $file_row_value[$address_key] = trim($file_row[$field_value]);
                                    }
                                }
                            }
                        }
                        // assign correct boolean value
                        if($custom_property && $custom_property->getType() == 'boolean'){
                            $file_value = strtolower($file_row_value);
                            $true_values = array('yes', 'y', 1);
                            $file_row_value = in_array($file_value, $true_values) ? 1 : '-1';
                        }
                        
                        // Format amount and numeric custom property
                        if($custom_property && ($custom_property->getType() == 'amount' || $custom_property->getType() == 'numeric')){
                            // Replace thousand separator
                            $without_t_sep_value = str_replace($thousand_separator, '', $file_row_value);
                            // Replace decimal separator if needed
                            $clean_value = $decimal_separator == ',' ? str_replace($decimal_separator, '.', $without_t_sep_value) : $without_t_sep_value;
                            // Format value
                            $formatted_value = format_amount($clean_value);

                            if($custom_property->getType() == 'amount'){
                                // Find default currency
                                $default_currency = Currencies::instance()->findOne(array('conditions' => '`is_default`=1'));
                                
                                if($default_currency instanceof Currency){
                                    $file_row_value =  array('amount'=>$formatted_value, 'currency_id'=>$default_currency->getId());
                                } else {
                                    $file_row_value =  array('amount'=>$formatted_value, 'currency_id'=>1);
                                }
                            } else {
                                $file_row_value = $formatted_value;
                            }
                        }
                    }
                    
                    $object_data[$key] = $file_row_value;
                }
            }
            $object_data['csv_row_number'] = $row;
        }
        
        return $object_data;
    }


    private function getContentObjectMemberIds($objects_fields = [], $file_row, $ot_manager, $enabled_dimension_ids){ 
        $object_data = array();
        foreach ($objects_fields as $dim_and_ot_id => $object_field_value){
        
            if($object_field_value >= 0 && $object_field_value != ''){
                $dim_ot_array = explode('_', $dim_and_ot_id);
                $dim_id = $dim_ot_array[0];
                $ot_id = $dim_ot_array[1];
                $file_row_value = $file_row[$object_field_value];
                $dim = Dimensions::instance()->findById($dim_id);
                $ot = ObjectTypes::instance()->findById($ot_id);
                $member = null;

                if($dim instanceof Dimension && $ot instanceof ObjectType){
                    $project_object_type = ObjectTypes::findByName("project");
                    $custom_property = CustomProperties::instance()->findOne(array('conditions' => 'object_type_id='.$ot_id.' AND is_import_id=1'));
                    $member_custom_property = MemberCustomProperties::instance()->findOne(array('conditions' => 'object_type_id='.$ot_id.' AND is_import_id=1'));
                    if($custom_property instanceof CustomProperty){
                        // Assign member by custom property
                        $cp_value = CustomPropertyValues::instance()->findOne(array('conditions'=>'custom_property_id='.$custom_property->getId().' AND value="'.trim($file_row_value).'"'));
                        if ($cp_value instanceof CustomPropertyValue){
                            $member = Members::instance()->findOne(array('conditions' => 'object_id='.$cp_value->getObjectId()));

                        }
                    } else if ($member_custom_property instanceof MemberCustomProperty){
                        // Assign member by member custom property
                        $cp_value = MemberCustomPropertyValues::instance()->findOne(array('conditions'=>'custom_property_id='.$member_custom_property->getId().' AND value="'.trim($file_row_value).'"'));
                        if ($cp_value instanceof MemberCustomPropertyValue){
                            $member = Members::instance()->findById($cp_value->getMemberId()); 
                        }
                    } else {
                        $member = Members::instance()->findOne(array('conditions' => 'dimension_id='.$dim_id.' AND object_type_id='.$ot_id.' AND `name`="'.trim($file_row_value).'"'));
                    }
                    if($member instanceof Member){
                        $object_data[$dim_id] = $member->getId();
                        foreach($enabled_dimension_ids as $d_id){
                            $dimension = Dimensions::instance()->findById($d_id);
                            $new_member_id = get_associated_status_member_id($member, $dimension);
                            if ($new_member_id > 0 && !isset($object_data[$d_id])) $object_data[$d_id] = $new_member_id;
                        }
                    }
                }    
            }
        }
        
        return $object_data;
    }

    
    private function addProject($params){
    
        $object = $params['object'];
        $object_type = $params['object_type'];
        $object_data = $params['object_data'];
        $mem_controller = $params['mem_controller'];
        $assoc_dim_data = $params['assoc_dim_data'];


        // create POST data to save project members
        $_POST['save_properties'] = true;
        $_POST['associated_members'] = array();
        // Get associated members
        $associated_members = $this->getAssociatedMembers($assoc_dim_data);
        // Assign associated members
        foreach($associated_members as $key => $associated_id_and_member){
            $assoc_id = $associated_id_and_member[0];
            $member_id = $associated_id_and_member[1];
            $_POST['associated_members'][$member_id] = $assoc_id;
        }

        // Assign members from template if project is template
        if($object_type->getName() == 'project' && isset($object_data['is_template'])){
            $template_info = $this->include_project_template_info($object_data);
            $existing_associated_ids = array_values($_POST['associated_members']);
            $template_id = $template_info['template_id'];
            $ini_assocs = MemberTemplatesInitialAssociations::instance()->findAll(array('conditions' => 'template_id='.$template_id));
            foreach ($ini_assocs as $ini_assoc) {
                if(!in_array($ini_assoc->getDimAssociationId(), $existing_associated_ids)){
                    $_POST['associated_members'][$ini_assoc->getAssociatedMemberId()] = $ini_assoc->getDimAssociationId();
                }
            }
        }

        // Assign parent's associated members to the object
        if (!empty($member_ids)) {
            $existing_associated_ids = array_values($_POST['associated_members']);
            $parent_member_id = $member_ids[0];
            $mpms = MemberPropertyMembers::instance()->findAll(array('conditions' => 'member_id='.$parent_member_id));
            foreach($mpms as $mpm){
                if(!in_array($mpm->getAssociationId(), $existing_associated_ids)){
                    $_POST['associated_members'][$mpm->getPropertyMemberId()] = $mpm->getAssociationId();
                } 
            }
        }
        
        
      
        if(isset($object_data['is_template'])){
            $template_info = $this->include_project_template_info($object_data);
            $project_member = $mem_controller->handleSubmit($object_data, $object);
            if(array_var( $template_info, 'task_template_id')) {
                $_GET['id'] =  $template_info['task_template_id'];
                $_POST['parameterValues'] = array(
                    'Due Date' => array_var($template_info, 'formatted_template_due_date'), 
                    'Start Date' => array_var($template_info, 'formatted_template_start_date'));
                // Assign project template members to additional member ids
                $additional_member_ids = array($project_member->getId());
                $ini_assocs = MemberTemplatesInitialAssociations::instance()->findAll(array('conditions' => 'template_id='.$template_info['template_id']));
                foreach ($ini_assocs as $ini_assoc) {
                    $additional_member_ids[] = $ini_assoc->getAssociatedMemberId();
                }
                $_REQUEST['additional_member_ids'] = json_encode($additional_member_ids);
                $template_controller = new TemplateController();
                $template_controller->instantiate_parameters();
            }

        } else {
            $mem_controller->handleSubmit($object_data, $object);
        }
        
        $object->save();

        return $object;
    }


    private function addClient($params){
        
        $object = $params['object'];
        $object_type = $params['object_type'];
        $object_data = $params['object_data'];
        $mem_controller = $params['mem_controller'];
        $assoc_dim_data = $params['assoc_dim_data'];
        $client_contact_data = $params['client_contact_data'];

        // create REQUEST data to save client members
        $_REQUEST['associated_members'] = array();
        // Get associated members
        $associated_members = $this->getAssociatedMembers($assoc_dim_data);
        // Assign associated members
        foreach($associated_members as $key => $associated_id_and_member){
            $assoc_id = $associated_id_and_member[0];
            $member_id = $associated_id_and_member[1];
            $_REQUEST['associated_members'][$assoc_id] = json_encode(array($member_id));
        }

        // Save supplier's address, phone, email and url
        $company_ot_id = ObjectTypes::findByName('company')->getId();
        $object_data['contact_data_type'] = $company_ot_id;
        $contact_data = $this->buildContactData($client_contact_data);
        $_POST['company'] = $contact_data;
        

        // Save client as object
        $mem_controller->handleSubmit($object_data, $object);
        $object->save();

        return $object;
    }


    private function addSupplier($params){
        
        $object = $params['object'];
        $object_type = $params['object_type'];
        $object_data = $params['object_data'];
        $mem_controller = $params['mem_controller'];
        $assoc_dim_data = $params['assoc_dim_data'];
        $client_contact_data = $params['client_contact_data'];

        // create POST data to save supplier members
        $_POST['save_properties'] = true;
        $_POST['associated_members'] = array();
        // Get associated members
        $associated_members = $this->getAssociatedMembers($assoc_dim_data);
        // Assign associated members
        foreach($associated_members as $key => $associated_id_and_member){
            $assoc_id = $associated_id_and_member[0];
            $member_id = $associated_id_and_member[1];
            $_POST['associated_members'][$member_id] = $assoc_id;
        }

        // Save supplier's address, phone, email and url
        $company_ot_id = ObjectTypes::findByName('company')->getId();
        $object_data['contact_data_type'] = $company_ot_id;
        $_REQUEST['supplier'] = array('contact_data_type' => $company_ot_id);
        $contact_data = $this->buildContactData($client_contact_data);
        $_POST['company'] = $contact_data;
        
        // Save supplier as member
        $member = new Member();
        $supplier_dimension = Dimensions::findByCode('suppliers');
        $member->setDimensionId($supplier_dimension->getId());
        $object_data['object_type_id'] = $object_type->getId();
        $mem_controller->saveMember($object_data, $member);
        
        // Save supplier as object
        $object = Objects::instance()->findById($member->getObjectId());
        $object->save();

        return $object;
    }

    private function getAssociatedMembers($assoc_dim_data){
        $associated_members = array();
        foreach($assoc_dim_data as $assoc_id => $assoc_member_value){
            $assoc = DimensionMemberAssociations::instance()->findById($assoc_id);
            if($assoc instanceof DimensionMemberAssociation) {
                $assoc_ot_id = $assoc->getAssociatedObjectType();
                $custom_property = CustomProperties::instance()->findOne(array('conditions' => 'object_type_id='.$assoc_ot_id.' AND is_import_id=1'));
                $member_custom_property = MemberCustomProperties::instance()->findOne(array('conditions' => 'object_type_id='.$assoc_ot_id.' AND is_import_id=1'));
                if($custom_property instanceof CustomProperty){
                    // Assign member by custom property
                    $cp_value = CustomPropertyValues::instance()->findOne(array('conditions'=>'custom_property_id='.$custom_property->getId().' AND value="'.trim($assoc_member_value).'"'));
                    if ($cp_value instanceof CustomPropertyValue){
                        $member = Members::instance()->findOne(array('conditions' => 'object_id='.$cp_value->getObjectId()));
                        if($member instanceof Member){
                            $associated_members[] = array($assoc_id, $member->getId());
                        }
                    }
                } else if ($member_custom_property instanceof MemberCustomProperty){
                    // Assign member by member custom property
                    $cp_value = MemberCustomPropertyValues::instance()->findOne(array('conditions'=>'custom_property_id='.$member_custom_property->getId().' AND value="'.trim($assoc_member_value).'"'));
                    if ($cp_value instanceof MemberCustomPropertyValue){
                        $associated_members[] = array($assoc_id, $cp_value->getMemberId());
                    }
                } else {
                    // Assign member by name
                    $member = Members::instance()->findOne(array('conditions' => 'object_type_id='.$assoc_ot_id.' AND `name`="'.trim($assoc_member_value).'"'));
                    if($member instanceof Member){
                        $associated_members[] = array($assoc_id, $member->getId()); 
                    }
                }
            }
        }
        return $associated_members;
    }

    private function buildContactData($contact_data){
        // Save phone
        $phones = array(
            array(
                'number' => trim($contact_data['work_phone']),
                'type' => 2
            ), array(
                'number' => trim($contact_data['mobile_phone']),
                'type' => 6
            ), array(
                'number' => trim($contact_data['fax_phone']),
                'type' => 8
            )
        );
        // Save url
        $webpages = array(
            array(
                'url' => trim($contact_data['url']),
                'type' => 2
            )
        );
        // Get country code
        if ($use_country_name) {
            $country_name = trim($contact_data['country']);
            $country_code = CountryCodes::getCountryCodeByName($country_name);
        } else {
            $country_code = strtolower(trim($contact_data['country']));
        }
        // Assemble company data
        $formatted_contact_data = array(
            'phone' => $phones,
            'email' => trim($contact_data['email']),
            'webpage' => $webpages,
            'address' => array(
                array(
                    'type' => 2,
                    'street' => trim($contact_data['street']),
                    'city' => trim($contact_data['city']),
                    'state' =>  trim($contact_data['state']),
                    'zip_code' =>  trim($contact_data['zip_code']),
                    'country' => $country_code
                )
            )
        );

        return $formatted_contact_data;
    }

    private function include_project_template_info($object_data){
        $project_ot_id = ObjectTypes::findByName('project')->getId();
        $member_template = MemberTemplates::instance()->findOne(array('conditions' => '`object_type_id`='.$project_ot_id.' AND `name`="'.$object_data['template_name'].'"'));
        $template_info = array();
        if ($member_template instanceof MemberTemplate){
            // Get template id
            $template_info['template_id'] = $member_template->getId();
            // Get task template id
            $task_template = MemberTemplatesTaskTemplates::instance()->findOne(array('conditions' => 'template_id='.$member_template->getId()));
            if ($task_template instanceof MemberTemplatesTaskTemplate){
                $template_info['task_template_id'] = $task_template->getTaskTemplateIds();
            }
            // Get due date
            $date_format = $_SESSION['date_format'];
            $config_date_format = user_config_option('date_format');
            $due_date = array_var($object_data, 'template_due_date', null);
            if(!is_null($due_date)){
                $due_dtv = DateTimeValueLib::dateFromFormatAndString($date_format, $due_date);
            } else {
                $due_dtv = DateTimeValueLib::now();
            }
            $template_info['formatted_template_due_date'] = $due_dtv->format($config_date_format);
            // Get start Date
            $start_date = array_var($object_data, 'template_start_date', null);
            if(!is_null($start_date)){
                $start_dtv = DateTimeValueLib::dateFromFormatAndString($date_format, $start_date);
            } else {
                $start_dtv = DateTimeValueLib::now();
            }
            $template_info['formatted_template_start_date'] = $start_dtv->format($config_date_format);
        }
        
        return $template_info;
    }


    private function searchForDelimiter($filename) {
        $delimiterCount = array(',' => 0, ';' => 0);

        $handle = fopen($filename, 'rb');
        $str = fgets($handle);
        fclose($handle);

        $del = null;
        foreach($delimiterCount as $k => $v) {
            $exploded = explode($k, $str);
            $delimiterCount[$k] = count($exploded);
            if ($del == null || $delimiterCount[$k] > $delimiterCount[$del]) $del = $k;
        }
        return $del;
    }

    private function prepare_timeslot_data($object_data, $date_format, $member_ids, &$task_ids_cache, &$project_ids_cache, $object_type_id){
        // Get date
        $date = array_var($object_data, 'date');
        $date_dtv = DateTimeValueLib::dateFromFormatAndString($date_format, $date);

        // Get minutes and hours
        $total_hours = array_var($object_data, 'total_hours');
        $total_minutes = $total_hours * 60;
        $minutes = $total_minutes % 60;
        $hours = ($total_minutes - $minutes) / 60;

        // Set start time to 8 A.M.
        $start_time = '08:00';

        $timeslot_data = array(
            'hours' => $hours,
			'minutes' => $minutes,
			'date' => $date_dtv,
            'start_time' => $start_time,
			'description' => array_var($object_data, 'description'),
			'contact_id' => array_var($object_data, 'contact_id'),
			'billing_id' => 0,
			'rate_currency_id' => 1,
			'cost_currency_id' => 1,
			'is_fixed_billing' => 0,
            'hourly_billing' => array_var($object_data, 'hourly_billing', 0),
            'fixed_billing' => array_var($object_data, 'fixed_billing', 0),
            'is_fixed_cost' => 0,
            'hourly_cost' => array_var($object_data, 'hourly_cost', 0),
            'fixed_cost' => array_var($object_data, 'fixed_cost', 0),
			'invoicing_status' => array_var($object_data, 'invoicing_status'),
            'additional_member_ids' => $member_ids,
            'skip_force_recalculation' => true
        );

        // Get Task ID
        $task_name = array_var($object_data, 'task_name', '');
        $task_id = $this->get_task_id_by_name_and_members($task_name, $member_ids, $task_ids_cache, $project_ids_cache, $object_type_id);

        $parameters = array();
        $parameters['use_current_time'] = false;
        $parameters['members'] = '[]';
        if ($task_id) {
            $object = Objects::findObject($task_id);
            if ($object instanceof ContentDataObject && $object->canAddTimeslot(logged_user())) {
            	$parameters['object_id'] = $task_id;
            }
        }
        $parameters['timeslot'] = $timeslot_data;

        return $parameters;
    }

    private function get_task_id_by_name_and_members($task_name, $member_ids, &$task_ids_cache, &$project_ids_cache, $object_type_id){
        
        $project_dim_id = Dimensions::findByCode('customer_project')->getId();
        $project_id = array_var($member_ids, $project_dim_id, 0);

        // Cache project ids to recalculate after import is done
        if(array_key_exists($project_id, $project_ids_cache) === false){
            $project_ids_cache[$project_id] = $project_id;
        }

        if($project_id == 0 || $task_name == '') return 0;

        // Get job phase member id if job phase dimension is enabled
        $all_dimensions = Dimensions::getAllowedDimensions($object_type_id);
        $allowed_dim_ids = array_column($all_dimensions, 'dimension_id');
        $job_phase_dim = Dimensions::findByCode('job_phases');
        $allow_job_phase = $job_phase_dim instanceof Dimension && in_array($job_phase_dim->getId(), $allowed_dim_ids);
        $job_phase_mem_id = $allow_job_phase ? array_var($member_ids, $job_phase_dim->getId(), 0) : 0;

        // Set cache key and check if task id is already cached => return it
        $project_task_key = $job_phase_mem_id > 0 ? $project_id . $job_phase_mem_id . $task_name : $project_id . $task_name;
        if(array_key_exists($project_task_key, $task_ids_cache)){
            return $task_ids_cache[$project_task_key];
        }

        if($job_phase_mem_id > 0) {
            // Find tasks with both matching members: project and job phase
            $member_ids_str = $project_id . ',' . $job_phase_mem_id;
            $sql = "SELECT t.id from ".TABLE_PREFIX."objects t
            INNER JOIN ".TABLE_PREFIX."object_members om on om.object_id=t.id
            WHERE 
                t.object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='task') 
                AND t.name='".trim($task_name)."' AND om.member_id IN (".$member_ids_str.")
            GROUP BY t.id
            HAVING COUNT(DISTINCT om.member_id) = 2;";

            $tasks = DB::executeAll($sql);

            if(is_array($tasks) && count($tasks) > 0){
                $task_ids_cache[$project_task_key] = $tasks[0]['id'];
                return $tasks[0]['id'];
            } else {
                // Find tasks with matching project member
                $task_id = $this->get_task_id_by_name_and_project_id($task_name, $project_id, $task_ids_cache, $project_task_key);
                return $task_id;
            } 

        } else {
            // Find tasks with matching project member
            $task_id = $this->get_task_id_by_name_and_project_id($task_name, $project_id, $task_ids_cache, $project_task_key);
            return $task_id;
        }
    }

    private function get_task_id_by_name_and_project_id($task_name, $project_id, &$task_ids_cache, $project_task_key = null){
        if($project_id == 0 || $task_name == '') return 0;

        $project_task_key = null ? $project_id . $task_name : $project_task_key;
        if(array_key_exists($project_task_key, $task_ids_cache)){
            return $task_ids_cache[$project_task_key];
        }

        $sql = "select t.id from ".TABLE_PREFIX."objects t
        inner join ".TABLE_PREFIX."object_members om on om.object_id=t.id
        where 
			t.object_type_id=(select id from ".TABLE_PREFIX."object_types where name='task') 
			and t.name='".trim($task_name)."' and om.member_id=".$project_id;

        $tasks = DB::executeAll($sql);

        if(is_array($tasks) && count($tasks) > 0){
            $task_ids_cache[$project_task_key] = $tasks[0]['id'];
            return $tasks[0]['id'];
        } else {
            $task_ids_cache[$project_task_key] = 0;
            return 0;
        } 
    }

    private function find_task_id_for_payment_receipt(&$object_data, $member_ids, &$task_ids_cache, &$project_ids_cache, $object_type) {
        $object_type_id = $object_type->getId();
        $task_name = array_var($object_data, 'task_name', '');
        $task_id = $this->get_task_id_by_name_and_members($task_name, $member_ids, $task_ids_cache, $project_ids_cache, $object_type_id);

        if($task_id > 0){
            $object_data['task_id'] = $task_id;
        }
    }

    private function prepare_invoice_data($invoice_data, $tax_params, $invoice){ 

        $updated_invoice_data = $this->prepare_invoice_data_using_existing_invoice($invoice_data, $invoice);

        // Build invoice lines from existing invoice
        $invoice_lines = $this->prepare_invoice_lines_data($invoice_data, $tax_params, $invoice);
        $updated_invoice_data['invoice_lines'] = $invoice_lines;

        return $updated_invoice_data;    
    }

    private function get_invoice_object($invoice_data) {
        $invoice_number = array_var($invoice_data, 'invoice_number', '');
        $invoice = IncomeInvoices::findInvoiceByNumber($invoice_number);
        if($invoice instanceof IncomeInvoice) {
            return $invoice;
        } else {
            return new IncomeInvoice();
        }
    }

    private function prepare_invoice_data_using_existing_invoice($invoice_data, $invoice){
        $updated_invoice_data = array();

        if($invoice->isNew()) {
            // Get date and due date
            $invoice_date = array_var($invoice_data, 'date');
            $invoice_due_date = array_var($invoice_data, 'expiration_date');

            // Get invoice subtype id
            $invoice_ot_id = IncomeInvoices::instance()->getObjectTypeId();
            $invoice_subtype = ObjectSubtypes::instance()->findOne(array('conditions' => array("object_type_id=? AND `name`='invoice'", $invoice_ot_id)));
            $invoice_subtype_id = $invoice_subtype ? $invoice_subtype->getId() : 0;

            // Get paid amount and due amount
            $invoice_status = array_var($invoice_data, 'status', 'confirmed');

            $updated_invoice_data = array(
                'name' => array_var($invoice_data, 'name'),
                'object_subtype_id' => $invoice_subtype_id,
                'date' => $invoice_date,
                'expiration_date' => $invoice_due_date,
                'status' => $invoice_status,
                'sent' => array_var($invoice_data, 'sent', 'invoice_sent'),
                'invoice_number' => array_var($invoice_data, 'invoice_number'),
                'currency_id' => 1,
                'additional_information' => array_var($invoice_data, 'additional_information'),
                'customer_email' => array_var($invoice_data, 'customer_email'),
                'customer_name' => null, // will be filled by the controller
                'customer_address' => array_var($invoice_data, 'customer_address'),
                'customer_city' => array_var($invoice_data, 'customer_city'),
                'customer_state' => array_var($invoice_data, 'customer_state'),
                'customer_country' => array_var($invoice_data, 'customer_country'),
                'customer_zipcode' => array_var($invoice_data, 'customer_zipcode')
            );
        } else {
            $updated_invoice_data = array(
                'name' => $invoice->getName(),
                'object_subtype_id' => $invoice->getColumnValue('object_subtype_id'),
                'date' => $invoice->getDate(),
                'expiration_date' => $invoice->getExpirationDate(),
                'status' => $invoice->getStatus(),
                'sent' => $invoice->getSent(),
                'invoice_number' => array_var($invoice_data, 'invoice_number'),
                'currency_id' => $invoice->getCurrencyId(),
                'additional_information' =>$invoice->getAdditionalInformation(),
                'customer_email' => $invoice->getCustomerEmail(),
                'customer_name' => null, // will be filled by the controller
                'customer_address' => $invoice->getCustomerAddress(),
                'customer_city' => $invoice->getCustomerCity(),
                'customer_state' => $invoice->getCustomerState(),
                'customer_country' => $invoice->getCustomerCountry(),
                'customer_zipcode' => $invoice->getCustomerZipcode()
            );
        }

        return $updated_invoice_data;
    }

    private function prepare_invoice_lines_data($invoice_data, $tax_params, $invoice) {
        $array_income_taxes = $tax_params['array_income_taxes'];
        $tax_amount = $tax_params['tax_amount'];
        $use_taxes_in_lines = $tax_params['use_taxes_in_lines'];
        $applied_taxes = $tax_params['applied_taxes'];

        if($invoice->isNew()) {
            $invoice_lines = array();
        } else {
            $invoice_lines = $this->build_data_from_existing_invoice_lines($invoice);
        }
            
        
        // Build new invoice lines to add to existing invoice
        $invoice_line_total = array_var($invoice_data, 'invoice_line_total');
        $quantity = array_var($invoice_data, 'quantity');
        $unit_value = array_var($invoice_data, 'unit_value');
        $description = array_var($invoice_data, 'description');
        $invoice_line_date =  array_var($invoice_data, 'invoice_line_date');

        if($use_taxes_in_lines){
            $tax_adjusted_subtotal = $invoice_line_total * 100 / (100+$tax_amount);
            $tax_adjusted_unit_value = $unit_value * 100 / (100+$tax_amount);
            $line = array(
                "amount" => $quantity,
                "category_id" => '[]',
                "unit_value" => $tax_adjusted_unit_value,
                "detail" => $description,
                "date" => $invoice_line_date,
                "currency_id" => 1,
                "exchange_rate" => 1,
                "subtotal" => $tax_adjusted_subtotal,
                "total" => $invoice_line_total,
                "taxes" => array()
            );
            foreach($array_income_taxes as $tax) {
                if(in_array($tax['id'], $applied_taxes)){
                    $tax_amount_to_apply = $invoice_line_total * $tax['value'] / (100+$tax['value']);
                    $line['taxes'][] = array(
                        'id' => $tax['id'],
                        'applied_value' => $tax['value'],
                        'value' => $tax_amount_to_apply,
                        'applied' => 1
                    );
                } else {
                    $line['taxes'][] = array(
                        'id' => $tax['id'],
                        'applied_value' => $tax['value'],
                        'value' => 0,
                        'applied' => 0
                    );
                }
            }
        } else {
            $line = array(
                "amount" => $quantity,
                "category_id" => '[]',
                "unit_value" => $unit_value,
                "detail" => $description,
                "date" => $invoice_line_date,
                "currency_id" => 1,
                "exchange_rate" => 1,
                "total" => $invoice_line_total
            );
        }

        $invoice_lines[] = $line;

        return $invoice_lines;

    }

    private function build_data_from_existing_invoice_lines($invoice){
        $invoice_lines = IncomeInvoiceLines::getInvoiceLines($invoice->getObjectId());

        $lines_array = array();

        foreach($invoice_lines as $invoice_line) {
            $line = array(
                "amount" => $invoice_line->getAmount(),
                "detail" => $invoice_line->getDetail(),
                "date" => $invoice_line->getDate(),
                "category_id" => $invoice_line->getCategoryId(),
                "unit_value" => $invoice_line->getUnitValue(),
                "currency_id" => $invoice_line->getCurrencyId(),
                "exchange_rate" => $invoice_line->getExchangeRate(),
                "subtotal" => $invoice_line->getSubtotal(),
                "total" => $invoice_line->getTotal(),
                "taxes" => array()
            );

            $taxes = $invoice_line->getTaxes();
            foreach($taxes as $tax) {
                $line['taxes'][] = array(
                    'id' => $tax->getId(),
                    'applied_value' => $tax->getAppliedValue(),
                    'value' => $tax->getValue(),
                    'applied' => $tax->getApplied()
                );
            }

            $lines_array[] = $line;
        }

        return $lines_array;
    }

    private function prepare_payment_data($object_data, $invoice_custom_property){
        $result = array( 
			'name' => array_var($object_data, 'name'),
			'amount' => format_amount(array_var($object_data, 'amount', 0)),
            'currency_id' => 1,
            'invoices' => array()
	    );

        // Find and assign the invoice to the payment receipt by the custom property
        $invoice_number = array_var($object_data, 'invoice_number', '');
        if($invoice_number != ''){
            $cp_value = CustomPropertyValues::instance()->findOne(array('conditions'=>'custom_property_id='.$invoice_custom_property->getId().' AND value="'.$invoice_number.'"'));
            if ($cp_value instanceof CustomPropertyValue){
                $invoice = IncomeInvoices::instance()->findOne(array('conditions' => 'object_id='.$cp_value->getObjectId()));
                if($invoice instanceof IncomeInvoice){
                    $result['invoices'][] = array(
                        'id' => $invoice->getId(),
                        'currency_id' => 1,
                        'to_pay' => format_amount(array_var($object_data, 'amount', 0))
                    );
                }
            }
        }

        return $result;
    }

    function recalculate_executed_values_for_tasks_and_projects($task_ids_cache, $project_ids_cache) {
        $task_ids = array_values($task_ids_cache);
        $task_ids = array_unique($task_ids);
        $task_ids = array_filter($task_ids, function($task_id) {
            return $task_id > 0;
        });
        $task_ids = array_values($task_ids);
        $projects_to_recalculate = array();
        if(count($task_ids) > 0) {
            $task_ids_str = implode(',', $task_ids);
            
            // get the tasks
            $tasks = ProjectTasks::instance()->findAll(array(
                "conditions" => "`object_id` IN (".$task_ids_str.")",
                "order" => "`depth` DESC"
            ));

            $project_ot_id = ObjectTypes::findByName('project')->getId();

            // Get helper functions
            Env::useHelper('dimension');
            if(Plugins::instance()->isActivePlugin('advanced_billing')) {
                Env::useHelper('functions', 'advanced_billing');
                Env::useHelper('persisting_member_totals_functions', 'advanced_billing');
            }
            $dummy_timeslot = new Timeslot();
            foreach ($tasks as $task) {
                // get the project so we can recalculate values for it later
                $project_member = $task->getMemberOfType($project_ot_id);
                if ($project_member instanceof Member && array_key_exists($project_member->getId(), $projects_to_recalculate) === false) {
                    $projects_to_recalculate[$project_member->getId()] = $project_member;
                }

                // recalculate the task
                $task->dont_calculate_project_financials = true;
                $task->onAddTimeslot($dummy_timeslot);
            }
        }

         // Check if project_ids are included in the project_to_recalculate
         foreach ($project_ids_cache as $project_id) {
            if(array_key_exists($project_id, $projects_to_recalculate) === false) {
                $project = Members::instance()->findById($project_id);
                if($project instanceof Member) {
                    $projects_to_recalculate[$project_id] = $project;
                }
            }
        }

        // after all task calculated then calculate for the involved projects
        if(Plugins::instance()->isActivePlugin('advanced_billing')) {
            foreach ($projects_to_recalculate as $project) {
                update_executed_labor_info_for_member_using_member_id($project->getId());
            }
        }
    }

    function add_missing_info(&$object_data, $object_type) {
        if($object_type->getName() == 'payment_receipt') {
            $c = Currencies::getDefaultCurrencyInfo();
			$object_data['currency_id'] = $c ? $c['id'] : 1;
        }
    }


}