<?php

class PrintReceiptReportsController extends ApplicationController {

	function __construct() {
		parent::__construct();
		prepare_company_website_controller($this, 'dialog');
		Env::useHelper('constants', 'paemfe');
	}
	
	
	
	
	// SERVICE REPORT
	
	function services_report_parameters() {
		
	}

	function services_report() {
		$report_data = array_var($_POST, 'report');
		if (!$report_data) {
			$parameters = json_decode(str_replace("'",'"', array_var($_POST, 'post')), true);
			$report_data = array_var($parameters, 'report');
		}
		$_SESSION['services_report_data'] = $report_data;
		
		$ws_ot = ObjectTypes::findByName('workspace');
		$ws_condition = "";
		$workspaces = json_decode(array_var($report_data, 'workspaces', ''));
		
		if (is_array($workspaces) && count($workspaces) > 0) {
			$ws_condition = " AND EXISTS (SELECT om.member_id FROM ".TABLE_PREFIX."object_members om WHERE om.object_id=o.id AND om.member_id IN (".implode(',',$workspaces)."))";
		}
		
		$st = DateTimeValueLib::dateFromFormatAndString(user_config_option('date_format'), array_var($report_data, 'start_value'));
		$et = DateTimeValueLib::dateFromFormatAndString(user_config_option('date_format'), array_var($report_data, 'end_value'));
		
		//$dates_condition = " AND created_on >= '". $st->toMySQL() ."' AND created_on < '". $et->toMySQL() ."'";
		
		$inicio_servicio_cp_id = SERVICE_STARTDATE_CP_ID;
		
		$dates_condition = "
			AND (
				SELECT cpv.value FROM ".TABLE_PREFIX."custom_property_values cpv 
				WHERE cpv.object_id=o.id AND cpv.custom_property_id=$inicio_servicio_cp_id
			) >= '". $st->toMySQL() ."'
			AND (
				SELECT cpv.value FROM ".TABLE_PREFIX."custom_property_values cpv 
				WHERE cpv.object_id=o.id AND cpv.custom_property_id=$inicio_servicio_cp_id
			) < '". $et->toMySQL() ."'
		";
		
		$ot_condition = " o.object_subtype_id = (SELECT id FROM ".TABLE_PREFIX."object_subtypes WHERE code='servicio')";
		
		$tasks = ProjectTasks::instance()->findAll(array(
			'conditions' => "$ot_condition $dates_condition $ws_condition"
		));
		
		tpl_assign('tasks', $tasks);
		
		if (array_var($_POST, 'csv')) {
			self::services_report_csv($tasks);
			ajx_current("empty");
			return;
		} else {
			tpl_assign('post', $_POST);
		}
		
		$this->setTemplate('services_report');
	}
	
	
	private static function services_report_csv($tasks) {
		$csv = "Beneficiario;Localidad;Subsistema;Descripción;Inicio;Completado\n";
		$ws_ot = ObjectTypes::findByName('workspace');
		
		foreach ($tasks as $t) { /* @var $t ProjectTask */
			$ben = "";
			$loc = null;
			$linked = $t->getLinkedObjects();
			foreach ($linked as $lo) {
				if ($lo instanceof Contact && $lo->getIsCompany()) {
					$ben .= ($ben == "" ? "" : ", ") . $lo->getName();
					if ($loc == null) {
						$addresses = ContactAddresses::instance()->getByContact($lo);
						if (count($addresses) > 0) $loc = $addresses[0]->getCity();
					}
				}
			}
			$ws_names = "";
			$members = $t->getMembers();
			foreach ($members as $m) {
				if ($m->getObjectTypeId() == $ws_ot->getId()) {
					$ws_names .= ($ws_names == "" ? "" : ", ") . $m->getName();
				}
			}
			$desc = CustomPropertyValues::getCustomPropertyValue($t->getId(), SERVICE_INSTALLATION_DESCRIPTION);
			$desc = $desc instanceof CustomPropertyValue ? $desc->getValue() : '';
			
			$date = format_date($t->getCompletedOn());
			
			$start_date_cpval = CustomPropertyValues::getCustomPropertyValue($t->getId(), SERVICE_STARTDATE_CP_ID);
			$start_date = $start_date_cpval instanceof CustomPropertyValue ? $start_date_cpval->getValue() : '';
			if ($start_date) {
				$dt = DateTimeValueLib::dateFromFormatAndString(DATE_MYSQL, $start_date);
				if ($dt instanceof DateTimeValue) $start_date = format_date($dt, null, 0);
			}
			
			$csv .= "$ben;$loc;$ws_names;$desc;$start_date;$date\n";
		}
		$csv = iconv('utf-8', 'iso-8859-1', $csv);
		
		download_contents($csv, 'application/csv', lang('services report') . date('_Ymd_His') . ".csv", strlen($csv));
		die();
	}
	
	
	// INSTALLATION REPORT
	
	function installations_report_parameters() {
		
	}
	
	function installations_report() {
		$report_data = array_var($_POST, 'report');
		if (!$report_data) {
			$parameters = json_decode(str_replace("'",'"', array_var($_POST, 'post')), true);
			$report_data = array_var($parameters, 'report');
		}
		$_SESSION['installations_report_data'] = $report_data;

		$ws_ot = ObjectTypes::findByName('workspace');
		
		$ws_ot = ObjectTypes::findByName('workspace');
		$ws_condition = "";
		$workspaces = json_decode(array_var($report_data, 'workspaces', ''));
		
		if (is_array($workspaces) && count($workspaces) > 0) {
			$ws_condition = " AND EXISTS (SELECT om.member_id FROM ".TABLE_PREFIX."object_members om WHERE om.object_id=o.id AND om.member_id IN (".implode(',',$workspaces)."))";
		}
		
		$st = DateTimeValueLib::dateFromFormatAndString(user_config_option('date_format'), array_var($report_data, 'start_value'));
		$et = DateTimeValueLib::dateFromFormatAndString(user_config_option('date_format'), array_var($report_data, 'end_value'));
		
		//$dates_condition = " AND created_on >= '". $st->toMySQL() ."' AND created_on < '". $et->toMySQL() ."'";
		
		$fecha_instalacion_cp_id = INSTALLATION_DATE_CP_ID;
		
		$dates_condition = "
			AND (
				SELECT cpv.value FROM ".TABLE_PREFIX."custom_property_values cpv
				WHERE cpv.object_id=o.id AND cpv.custom_property_id=$fecha_instalacion_cp_id
			) >= '". $st->toMySQL() ."'
			AND (
				SELECT cpv.value FROM ".TABLE_PREFIX."custom_property_values cpv
				WHERE cpv.object_id=o.id AND cpv.custom_property_id=$fecha_instalacion_cp_id
			) < '". $et->toMySQL() ."'
		";
		
		$ot_condition = " o.object_subtype_id = (SELECT id FROM ".TABLE_PREFIX."object_subtypes WHERE code='inst_au')";
		
		$tasks = ProjectTasks::instance()->findAll(array(
			'conditions' => "$ot_condition $dates_condition $ws_condition"
		));
		
		tpl_assign('tasks', $tasks);
		
		if (array_var($_POST, 'csv')) {
			self::installations_report_csv($tasks);
			ajx_current("empty");
			return;
		} else {
			tpl_assign('post', $_POST);
		}
		
		$this->setTemplate('installations_report');
	}
	
	private static function installations_report_csv($tasks) {
		$csv = "Subsistema;Departamento;Centro;Descripción;Cantidad PCs;Aulas;Instalación;Completado\n";
		
		foreach ($tasks as $t) { /* @var $t ProjectTask */
			$loc = "";
			$linked = $t->getLinkedObjects();
			foreach ($linked as $lo) {
				if ($lo instanceof Contact && $lo->getIsCompany()) {
					$addresses = ContactAddresses::instance()->getByContact($lo);
					if (count($addresses) > 0) $loc = $addresses[0]->getCity();
					$company_name = $lo->getName();
					break;
				}
			}
			$ws_names = "";
			foreach ($t->getMembers() as $ws) {
				$ws_names .= ($ws_names == "" ? "" : ", ") . $ws->getName();
			}
			$desc = CustomPropertyValues::getCustomPropertyValue($t->getId(), SERVICE_INSTALLATION_DESCRIPTION);
			$desc = $desc instanceof CustomPropertyValue ? $desc->getValue() : '';
			
			$aulas = CustomPropertyValues::instance()->count("`object_id` = ".$t->getId()." AND `custom_property_id` = " . EXISTING_CLASSROOMS_CP_ID);
			$cant_pc = CustomPropertyValues::instance()->count("`object_id` = ".$t->getId()." AND `custom_property_id` = " . TASKS_INSTALLED_PCS_CP_ID);
			$comp_date = format_date($t->getCompletedOn());
			
			$start_date_cpval = CustomPropertyValues::getCustomPropertyValue($t->getId(), INSTALLATION_DATE_CP_ID);
			$start_date = $start_date_cpval instanceof CustomPropertyValue ? $start_date_cpval->getValue() : '';
			if ($start_date) {
				$dt = DateTimeValueLib::dateFromFormatAndString(DATE_MYSQL, $start_date);
				if ($dt instanceof DateTimeValue) $start_date = format_date($dt, null, 0);
			}
			
			$csv .= "$ws_names;$loc;$company_name;$desc;$cant_pc;$aulas;$start_date;$comp_date\n";
		}
		$csv = iconv('utf-8', 'iso-8859-1', $csv);
		
		download_contents($csv, 'application/csv', lang('installations report') . date('_Ymd_His') . ".csv", strlen($csv));
		die();
	}
}

?>