<?php echo stylesheet_tag(get_public_url('assets/css/paemfe.css', 'paemfe')); ?>
<?php 
	$client_address = null;
	if ($client instanceof Contact) {
		$addresses = ContactAddresses::instance()->getByContact($client);
		if (count($addresses) > 0) $client_address = $addresses[0];
	}
?>
<?php $warnings = array(); ?>
<div class="print-receipt" style="max-height: <?php echo $page_height ?>px; min-height: <?php echo $page_height ?>px;">
	<div class="print-receipt-header">
		<table style="width:100%;">
			<tr>
				<td style="width: 33%;"><img src="<?php echo $company_logo_url1 ?>" /></td>
				<td style="width: 33%;"><img src="<?php echo $company_logo_url2 ?>" /></td>
				<td align="right" style="padding-right: 20px;">
					<table cellpadding="3" style="font-weight: bold;">
						<tr><td><?php echo lang('receipt num') ?></td><td align="right"><?php echo $task->getUniqueObjectId() ?></td></tr>
						<tr><td><?php echo lang('service num') ?></td><td align="right"><?php echo $service_num ?></td></tr>
					</table>
				</td>
			</tr>
		</table>
		<table style="width:100%;" cellpadding="0" cellspacing="0">
			<tr>
				<td style="width:60%; vertical-align:bottom;">
					<div style="border-bottom: 3px solid blue; width:100%; max-height: 1px; margin:1px 0;"></div>
					<div style="border-bottom: 1px solid black; width:100%; max-height: 1px; margin:1px 0;"></div>
				</td>
				<td align="center"><?php echo lang('print title serv') ?></td>
				<td style="width:30px; vertical-align:bottom;">
					<div style="border-bottom: 3px solid blue; width:100%; max-height: 1px; margin:1px 0;"></div>
					<div style="border-bottom: 1px solid black; width:100%; max-height: 1px; margin:1px 0;"></div>
				</td>
			</tr>
		</table>
	</div>
	
	<div>
		<table style="width:100%;">
			<tr><td style="width:60%;vertical-align: top;">
				<fieldset><legend><?php echo lang('institution data') ?></legend>
					<table style="width:100%">
					<tr>
						<td class="print-receipt-label"><?php echo lang('name') ?></td>
						<td class="print-receipt-fill-data" colspan="2" style="min-width: 150px;">
							<?php echo ($client instanceof Contact ? $client->getName() : '&nbsp;') ?>
						</td>
						<td class="print-receipt-label"><?php echo lang('dependency abr') ?></td>
						<td class="print-receipt-fill-data">&nbsp;
							<?php echo $dependency ?>
						</td>
					</tr><tr>
						<td class="print-receipt-label"><?php echo lang('address') ?></td>
						<td class="print-receipt-fill-data" colspan="4">
							<?php echo ($client_address instanceof ContactAddress ? $client_address->getStreet() : '&nbsp;') ?>
						</td>
					</tr><tr>
						<td class="print-receipt-label"><?php echo lang('department abr') ?></td>
						<td class="print-receipt-fill-data" colspan="2">
							<?php echo ($client_address instanceof ContactAddress ? $client_address->getState() : '&nbsp;') ?>
						</td>
						<td class="print-receipt-label"><?php echo lang('city') ?></td>
						<td class="print-receipt-fill-data">
							<?php echo ($client_address instanceof ContactAddress ? $client_address->getCity() : '&nbsp;') ?>
						</td>
					</tr><tr>
						<td class="print-receipt-label"><?php echo lang('phone') ?></td>
						<td class="print-receipt-fill-data">
							<?php echo ($client instanceof Contact ? $client->getPhoneNumber('work', false, false) : '&nbsp;') ?>
						</td>
						<td class="print-receipt-label" style="width:35px;"><?php echo lang('email label') ?></td>
						<td class="print-receipt-fill-data" colspan="2">
							<?php echo ($client instanceof Contact ? $client->getEmailAddress() : '&nbsp;') ?>
						</td>
					</tr>
					</table>
				</fieldset>
			</td><td style="vertical-align: top;">
				<fieldset><legend><?php echo lang('applicant data') ?></legend>
					<table style="width:100%">
					<tr>
						<td class="print-receipt-label"><?php echo lang('date') ?></td>
						<td class="print-receipt-fill-data"><?php echo ($service_date ? $service_date : '&nbsp;') ?></td>
					</tr><tr>
						<td class="print-receipt-label" style="width:50%;"><?php echo lang('by institution') ?></td>
						<td class="print-receipt-fill-data">&nbsp;</td>
					</tr><tr>
						<td class="print-receipt-label"><?php echo lang('user title') ?></td>
						<td class="print-receipt-fill-data">
							<?php echo ($contact instanceof Contact ? $contact->getJobTitle() : '') ?>&nbsp;
						</td>
					</tr><tr>
						<td class="print-receipt-label"><?php echo lang('contact') ?></td>
						<td class="print-receipt-fill-data">
							<?php echo ($contact instanceof Contact ? $contact->getFirstname()." ".$contact->getLastname() : '&nbsp;') ?>
						</td>
					</tr>
					</table>
				</fieldset>
			</td></tr>
		</table>
	</div>
	
	<div>
	<fieldset class="container">
		<table style="width:100%;" cellpadding="0" cellspacing="0">
			<tr>
				<td style="border-top:1px solid black;" align="center" class="print-receipt-body-col-header"><?php echo lang('adsl details') ?></td>
				<td style="border-top:1px solid black;" align="center" class="print-receipt-body-col-header"><?php echo "Nº Servicio Internet" ?></td>
			</tr>
			<tr>
				<td class="print-receipt-body-data" style="border-left: 1px solid black;"><?php echo $adsl_ip ?>&nbsp;</td>
				<td class="print-receipt-body-data" style="border-right: 1px solid black;"><?php echo $adsl_service_num ?>&nbsp;</td>
			</tr>
			<tr><td colspan="2" style="border-left: 1px solid black;border-right: 1px solid black;">&nbsp;</td></tr>
		</table>
	</fieldset>
	<fieldset class="container">
		<table style="width:100%;" cellpadding="0" cellspacing="0">
			<tr><td colspan="2" align="center" class="print-receipt-body-title"><?php echo lang('service description') ?></td></tr>
			<?php
				$desc_lines = explode("\n", strip_tags($task->getText()));
				while (count($desc_lines) < 3) $desc_lines[] = "&nbsp;";
				foreach ($desc_lines as $line) {
			?>
				<tr><td colspan="2" class="print-receipt-body-data" style="border-left: 1px solid black;border-right: 1px solid black;"><?php echo $line ?></td></tr>
			<?php }
				if (count($desc_lines) > 5) $warnings[] = lang('too many lines warning', lang('service description'), 5); 
			?>
		</table>
	</fieldset>
	<fieldset class="container">
		<table style="width:100%;" cellpadding="0" cellspacing="0">
			<tr><td colspan="2" align="center" class="print-receipt-body-title"><?php echo lang('important data') ?></td></tr>
			<?php foreach ($important_data as $line) { ?>
				<tr><td colspan="2" class="print-receipt-body-data" style="border-left: 1px solid black;border-right: 1px solid black;"><?php echo $line ?></td></tr>
			<?php } ?>
		</table>
	</fieldset>
	<fieldset class="container">
		<table style="width:100%;" cellpadding="0" cellspacing="0">
			<tr><td colspan="4" align="center" class="print-receipt-body-title"><?php echo lang('service details') ?></td></tr>
			<tr>
				<td class="print-receipt-body-col-header" style="width:25%;"><?php echo lang('start date') ?></td>
				<td class="print-receipt-body-col-header" style="width:25%;"><?php echo $service_start_date ?></td>
				<td class="print-receipt-body-col-header" style="width:25%;"><?php echo lang('end date') ?></td>
				<td class="print-receipt-body-col-header" style="width:25%;"><?php echo $service_end_date ?></td>
			</tr>
			<?php 
				$service_details = explode("\n", $service_details);
				while (count($service_details) < 5) $service_details[] = "&nbsp;";
				foreach ($service_details as $line) {
			?>
				<tr><td colspan="4" class="print-receipt-body-data" style="border-left: 1px solid black;border-right: 1px solid black;"><?php echo $line ?></td></tr>
			<?php }
				if (count($service_details) > 5) $warnings[] = lang('too many lines warning', lang('service details'), 5); 
			?>
		</table>
	</fieldset>
	<fieldset class="container">
		<table style="width:100%; border-bottom: 1px solid black;" cellpadding="0" cellspacing="0">
			<tr><td colspan="4" align="center" class="print-receipt-body-title"><?php echo lang('parts and inputs movements') ?></td></tr>
			<tr>
				<td class="print-receipt-body-col-header" style="width:120px;"><?php echo lang('inout') ?></td>
				<td class="print-receipt-body-col-header" ><?php echo lang('description') ?></td>
				<td class="print-receipt-body-col-header" style="width:150px;"><?php echo lang('serial number') ?></td>
				<td class="print-receipt-body-col-header" style="width:100px;"><?php echo lang('code') ?></td>
			</tr>
			<?php foreach ($part_movements as $data) { ?>
				<tr>
					<td class="print-receipt-body-data" style="border-left: 1px solid black;"><?php echo array_var($data, 'inout') ?>&nbsp;</td>
					<td class="print-receipt-body-data"><?php echo array_var($data, 'description') ?>&nbsp;</td>
					<td class="print-receipt-body-data"><?php echo array_var($data, 'serial_num') ?>&nbsp;</td>
					<td class="print-receipt-body-data" style="border-right: 1px solid black;"><?php echo array_var($data, 'code') ?>&nbsp;</td>
				</tr>
			<?php } ?>
		</table>
	</fieldset>
	<fieldset class="container">
		<table style="width:100%; border-bottom: 1px solid black;" cellpadding="0" cellspacing="0">
			<tr><td colspan="5" align="center" class="print-receipt-body-title"><?php echo lang('equipment retirement') ?></td></tr>
			<tr>
				<td class="print-receipt-body-col-header" style="width:120px;"><?php echo lang('type') ?></td>
				<td class="print-receipt-body-col-header" ><?php echo lang('brand') ?></td>
				<td class="print-receipt-body-col-header" ><?php echo lang('model') ?></td>
				<td class="print-receipt-body-col-header" style="width:150px;"><?php echo lang('serial number') ?></td>
				<td class="print-receipt-body-col-header" style="width:100px;"><?php echo lang('code') ?></td>
			</tr>
			<?php foreach ($eq_retirement as $data) { ?>
				<tr>
					<td class="print-receipt-body-data" style="border-left: 1px solid black; width: 60px;"><?php echo array_var($data, 'type') ?>&nbsp;</td>
					<td class="print-receipt-body-data"><?php echo array_var($data, 'brand') ?>&nbsp;</td>
					<td class="print-receipt-body-data"><?php echo array_var($data, 'model') ?>&nbsp;</td>
					<td class="print-receipt-body-data"><?php echo array_var($data, 'serial_num') ?>&nbsp;</td>
					<td class="print-receipt-body-data" style="width:100px;border-right: 1px solid black;"><?php echo array_var($data, 'code') ?>&nbsp;</td>
				</tr>
				<tr>
					<td class="print-receipt-body-col-header"><?php echo lang('fail reason') ?></td>
					<td colspan="4" class="print-receipt-fill-data" style="border-right: 1px solid black;"><?php echo array_var($data, 'fail') ?>&nbsp;</td>
				</tr>
			<?php } ?>
		</table>
	</fieldset>
	<fieldset class="container">
		<table style="width:100%;border-bottom: 1px solid black;" cellpadding="0" cellspacing="0">
			<tr><td colspan="2" align="center" class="print-receipt-body-title"><?php echo lang('pending tasks') ?></td></tr>
			<?php
				$pt_lines = explode("\n", $pending_tasks);
				while (count($pt_lines) < 5) $pt_lines[] = "&nbsp;";
				foreach ($pt_lines as $line) {
			?>
				<tr><td colspan="2" class="print-receipt-body-data" style="border-left: 1px solid black;border-right: 1px solid black;"><?php echo $line ?></td></tr>
			<?php }
				if (count($pt_lines) > 5) $warnings[] = lang('too many lines warning', lang('pending tasks'), 5); 
			?>
		</table>
	</fieldset>
	</div>
	
	<div>
		<table style="width:100%;">
			<tr><td style="width:60%;vertical-align: top;">
				<fieldset><legend><?php echo lang('project technicians') ?></legend>
					<table style="width:100%">
					<tr>
						<td class="print-receipt-label" colspan="2" style="width:100px;"><?php echo lang('end date') ?></td>
						<td class="print-receipt-fill-data" colspan="2">&nbsp;</td>
					</tr>
					<?php while (count($signing_users) < 3) $signing_users[] = ''; 
						foreach($signing_users as $user_name) { ?>
					<tr>
						<td class="print-receipt-label"><?php echo lang('name') ?></td>
						<td class="print-receipt-fill-data"><?php echo $user_name ?>&nbsp;</td>
						<td class="print-receipt-label"><?php echo lang('signature') ?></td>
						<td class="print-receipt-fill-data" style="width: 30%;">&nbsp;</td>
					</tr>
					<?php } ?>
					</table>
				</fieldset>
			</td><td style="vertical-align: top;">
				<fieldset><legend><?php echo lang('compliance data') ?></legend>
					<table style="width:100%">
						<tr>
							<td class="print-receipt-label"><?php echo lang('name') ?></td>
							<td class="print-receipt-fill-data">&nbsp;</td>
						</tr>
						<tr>
							<td class="print-receipt-label"><?php echo lang('signature') ?></td>
							<td class="print-receipt-fill-data">&nbsp;</td>
						</tr>
						<tr>
							<td class="print-receipt-label"><?php echo lang('user title') ?></td>
							<td class="print-receipt-fill-data">&nbsp;</td>
						</tr>
						<tr>
							<td align="center" colspan="2" class="print-receipt-label"><?php echo lang('stamp') ?></td>
						</tr>
					</table>
				</fieldset>
			</td></tr>
		</table>
	</div>
	
	<div class="print-receipt-footer">
		<div style="border-bottom: 1px solid black; width:100%; max-height: 1px;"></div>
		<div style="border-bottom: 3px solid blue; width:100%; max-height: 1px; margin:1px 0 5px;"></div>
	<?php 
		$addresses = ContactAddresses::instance()->getByContact(owner_company());
		echo owner_company()->getName();
		if (count($addresses) > 0) echo " - " . $addresses[0]->getStreet();
		if (owner_company()->getPhoneNumber('work', false, false)) echo " - " . lang('phone') . owner_company()->getPhoneNumber('work', false, false);
		if (owner_company()->getEmailAddress()) echo " - " . owner_company()->getEmailAddress();
		if (count($addresses) > 0) echo " - " . $addresses[0]->getCity(); 
	?> 
	</div>
	
</div>
<?php
	$all_warns = "";
	foreach ($warnings as $warn) {
		$all_warns .= "$warn\\n\\n";
	}
	if ($all_warns != "") {
		$all_warns = lang('warnings') . ":\\n\\n$all_warns";
		echo "<script>alert('$all_warns');</script>";
	}
?>
<script>
	window.print();
</script>