<?php

function build_excel_data_for_invoice_report($data, $report_data = array()){
    $excel_data = array();
    $type_of_report = $data['type_of_report'];
    if($type_of_report == 'individual_project'){
        $header_params = array(
            'type_of_report' => $type_of_report
        );
        $project_header_data = build_project_header_for_excel_invoice_report($data, $report_data, $header_params);
        $excel_data = array_merge($excel_data, $project_header_data);
        $project_body_data = build_project_excel_data_for_invoice_report($data, $report_data, $type_of_report);
        $excel_data = array_merge($excel_data, $project_body_data);
    } elseif ($type_of_report == 'total_grouped_by_projects'){
        $header_params = array(
            'include_client_name' => true,
            'type_of_report' => $type_of_report
        );
        $table_separator = array(array('data' => array('')));
        foreach($data['projects'] as $project_data){
            $project_header_data = build_project_header_for_excel_invoice_report($project_data, $report_data, $header_params);
            $excel_data = array_merge($excel_data, $project_header_data);
            $project_body_data = build_project_excel_data_for_invoice_report($project_data, $report_data, $type_of_report);
            $excel_data = array_merge($excel_data, $project_body_data);
            $excel_data = array_merge($excel_data, $table_separator);
        }
        
        $total_params = array(
            'table_name' => lang('totals'),
            'total_budgeted' => $data['report_total_budgeted'],
            'total_invoiced' => $data['report_total_invoiced']
        );
        $total_for_report = build_invoicing_history_total_excel_table($report_data, $total_params);
        $excel_data = array_merge($excel_data, $total_for_report);
        
    } elseif ($type_of_report == 'total_grouped_by_clients_and_projects'){
        $group_by_month = array_var($report_data, 'group_invoices_by_month') == 'checked' ? 1 : 0;
        $table_separator = array(array('data' => array('')));
        $header_params = array(
            'type_of_report' => $type_of_report
        );
        foreach($data['clients'] as $client_name => $client_info){
            $client_header = array(lang('client').' '.$client_name, '');
            if(!$group_by_month){
                $client_header[] = '';
            }
            $client_header_data = array(array('main_header'=>$client_header));
            $excel_data = array_merge($excel_data, $client_header_data);
            $excel_data = array_merge($excel_data, $table_separator);
            foreach($client_info['projects'] as $project_data){
                $project_header_data = build_project_header_for_excel_invoice_report($project_data, $report_data, $header_params);
                $excel_data = array_merge($excel_data, $project_header_data);
                $project_body_data = build_project_excel_data_for_invoice_report($project_data, $report_data, $type_of_report);
                $excel_data = array_merge($excel_data, $project_body_data);
                $excel_data = array_merge($excel_data, $table_separator); 
            }
            $client_total_params = array(
                'table_name' => lang('totals').': '.$client_name,
                'total_budgeted' => $client_info['client_budget_total'],
                'total_invoiced' => $client_info['client_invoices_total']
            );
            $total_for_client = build_invoicing_history_total_excel_table($report_data, $client_total_params);
            $excel_data = array_merge($excel_data, $total_for_client);
            $excel_data = array_merge($excel_data, $table_separator);
        }
    
        $total_params = array(
            'table_name' => lang('totals'),
            'total_budgeted' => $data['report_total_budgeted'],
            'total_invoiced' => $data['report_total_invoiced']
        );
        $total_for_report = build_invoicing_history_total_excel_table($report_data, $total_params);
        $excel_data = array_merge($excel_data,  $total_for_report);
        
    } elseif ($data['type_of_report'] == 'total_grouped_by_clients'){
        $group_by_month = array_var($report_data, 'group_invoices_by_month') == 'checked' ? 1 : 0;
        $table_separator = array(array('data' => array('')));
        foreach($data['clients'] as $client_name => $client_info){
            $client_header = array(lang('client').' '.$client_name, '');
            if(!$group_by_month){
                $client_header[] = '';
                $client_header[] = '';
            }
            $client_header_data = array(array('main_header'=>$client_header));
            $excel_data = array_merge($excel_data, $client_header_data);
            $client_body_data = build_project_excel_data_for_invoice_report($client_info, $report_data, $type_of_report);
            $excel_data = array_merge($excel_data, $client_body_data);
            $excel_data = array_merge($excel_data, $table_separator);
        }
    
        $total_params = array(
            'table_name' => lang('totals'),
            'total_budgeted' => $data['report_total_budgeted'],
            'total_invoiced' => $data['report_total_invoiced']
        );
        $total_for_report = build_invoicing_history_total_excel_table($report_data, $total_params);
        $excel_data = array_merge($excel_data, $total_for_report);
        
    } elseif ($data['type_of_report'] == 'total_without_grouping'){
        $whole_body_data = build_project_excel_data_for_invoice_report($data['whole_system'], $report_data, $type_of_report);
        $excel_data = array_merge($excel_data, $whole_body_data);
        $table_separator = array(array('data' => array('')));
        $excel_data = array_merge($excel_data, $table_separator);
        $total_params = array(
            'table_name' => lang('totals'),
            'total_budgeted' => $data['report_total_budgeted'],
            'total_invoiced' => $data['report_total_invoiced']
        );
        $total_for_report = build_invoicing_history_total_excel_table($report_data, $total_params);
        $excel_data = array_merge($excel_data, $total_for_report);
    }

    return $excel_data;
}

function build_project_header_for_excel_invoice_report($result_data, $report_data = array(), $header_params = array()){
    if (array_var($report_data, 'show_main_project_info')) {
        return build_invoice_project_information_excel($result_data, $report_data, $header_params);
    } else {
        return build_project_name_header_for_excel_invoice_report($result_data, $report_data, $header_params);
    }
}

function build_project_excel_data_for_invoice_report($project_data, $report_data = array(), $type_of_report){

    $excel_data = array();

    $invoice_data_excel = array();
    $invoice_data_excel[] = build_excel_invoice_data($project_data, $report_data, $type_of_report);
    $excel_data = array_merge($excel_data, $invoice_data_excel);

    $billed_to_date = array();
    $billed_to_date[] = build_build_to_date_excel($project_data, $report_data, $type_of_report);
    $excel_data = array_merge($excel_data, $billed_to_date);

    $balance_vs_budget = array();
    $balance_vs_budget[] = build_ballance_vs_budget_excel($project_data, $report_data, $type_of_report);
    $excel_data = array_merge($excel_data, $balance_vs_budget);

    $billed_percentage = array();
    $billed_percentage[] = build_billed_percentage_excel($project_data, $report_data, $type_of_report);
    $excel_data = array_merge($excel_data, $billed_percentage);

    return $excel_data;
}

function build_excel_invoice_data($data = array(), $report_data = array(), $type_of_report){
    $group_by_month = array_var($report_data, 'group_invoices_by_month') == 'checked' ? 1 : 0;
    $use_budget_total_custom_property = array_var($report_data, 'use_budget_total_custom_property');
    $invoices = isset($data['invoice_data']['invoices']) ? $data['invoice_data']['invoices'] : array();
    $invoices_amount_per_phase = isset($data['invoice_data']['invoices_amount_per_phase']) ? $data['invoice_data']['invoices_amount_per_phase'] : array();
    $project_phases = $type_of_report == 'individual_project' ?  array_var($data, 'project_phases') : array();
   
    $currency_sym = config_option('currency_code');

    // Build Header
    $header = array('');
    if(!$group_by_month){
        $header[]= lang('invoice number');
        if($type_of_report == 'total_without_grouping') {
            $header[] = lang('client');
        }
        if($type_of_report == 'total_grouped_by_clients' || $type_of_report == 'total_without_grouping'){
            $header[] = lang('project');
        }
    }
    foreach($project_phases as $phase){
        $header[] = $phase;
    }
    $header[] = lang('total');

    // Build body
    $body_data = array();

    // Build budgeted row
    $budget_row = array(lang('budgeted'));
    if(!$group_by_month){
        $budget_row[]= '';
        if($type_of_report == 'total_without_grouping') {
            $budget_row[]= '';
        }
        if($type_of_report == 'total_grouped_by_clients' || $type_of_report == 'total_without_grouping'){
            $budget_row[]= '';
        }
    }
    foreach($project_phases as $phase){
        if ($use_budget_total_custom_property) {
            $budget_amount = '';
        } else {
            $budget_amount = isset($data['budgeted_amounts_per_phase'][$phase]) ? format_money_amount($data['budgeted_amounts_per_phase'][$phase], $currency_sym) : '0';
        }
        $budget_row[] = $budget_amount;
    }
    $budget_row[] = format_money_amount($data['total_budgeted'], $currency_sym);
    $body_data[] = $budget_row;

    // Build invoices data
    if(count($invoices) > 0){
        if($group_by_month){
            foreach($invoices as $v){
                $row = array($v['month']);
                foreach($project_phases as $phase){
                    if(isset($v[$phase])){
                        $row[] = format_money_amount($v[$phase], $currency_sym);
                    } else {
                        $row[] = '';
                    }
                }
                $row[] = format_money_amount($v['total'], $currency_sym);
                $body_data[] = $row;
            }
        } else {
            foreach($invoices as $invoice){
                $row = array($invoice['date']);
                $row[] = $invoice['invoice_number'];
                if ($type_of_report == 'total_without_grouping'){
                    $row[] = $invoice['client'];
                }
                if($type_of_report == 'total_grouped_by_clients' || $type_of_report == 'total_without_grouping'){
                    $row[] = $invoice['project'];
                }
                foreach($project_phases as $phase){
                    if($invoice['project_phase'] == $phase){
                        $row[] = format_money_amount($invoice['amount'], $currency_sym);
                    } else {
                        $row[] = '';
                        
                    }
                }
                $row[] = format_money_amount($invoice['amount'], $currency_sym);
                $body_data[] = $row;
            }
        }
    }
    
    return array('headers' => $header, 'data' => $body_data);
    
}

function build_build_to_date_excel($data, $report_data, $type_of_report){
    $invoices_amount_per_phase = isset($data['invoice_data']['invoices_amount_per_phase']) ? $data['invoice_data']['invoices_amount_per_phase'] : array();
    $group_by_month = array_var($report_data, 'group_invoices_by_month') == 'checked' ? 1 : 0;
    $project_phases = $type_of_report == 'individual_project' ?  array_var($data, 'project_phases') : array();
    $currency_sym = config_option('currency_code');

    // Build 'Billed to date'
    $billed_to_date = array(lang('billed to date'));
    if(!$group_by_month){
        $billed_to_date[] = '';
        if ($type_of_report == 'total_without_grouping'){
            $billed_to_date[] = '';
        }
        if($type_of_report == 'total_grouped_by_clients' || $type_of_report == 'total_without_grouping'){
            $billed_to_date[] = '';
        }
    }
    foreach($project_phases as $phase){
        if(isset($invoices_amount_per_phase[$phase])){
            $billed_to_date[] = format_money_amount($invoices_amount_per_phase[$phase], $currency_sym);
        } else {
            $billed_to_date[] = format_money_amount(0, $currency_sym);
        }
    }
    $billed_to_date[] = format_money_amount($data['invoice_data']['total_invoices'], $currency_sym);

    return array('totals' => $billed_to_date);
}

function build_ballance_vs_budget_excel($data, $report_data, $type_of_report){
    $project_phases = $type_of_report == 'individual_project' ?  array_var($data, 'project_phases') : array();
    $group_by_month = array_var($report_data, 'group_invoices_by_month') == 'checked' ? 1 : 0;
    $use_budget_total_custom_property = array_var($report_data, 'use_budget_total_custom_property');
    $currency_sym = config_option('currency_code');

    // Build 'Remaining budget'
    $balance_vs_budget = array(lang('remaining budget'));
    if(!$group_by_month){
        $balance_vs_budget[] = '';
        if ($type_of_report == 'total_without_grouping'){
            $balance_vs_budget[] = '';
        }
        if($type_of_report == 'total_grouped_by_clients' || $type_of_report == 'total_without_grouping'){
            $balance_vs_budget[] = '';
        }
    }
    foreach($project_phases as $phase){
        if($use_budget_total_custom_property) {
            $balance_vs_budget[] = '';
        } else {
            if(isset($data['difference_per_phase'][$phase])){
                $opening_parenthesis = $data['difference_per_phase'][$phase] < 0 ? '( ' : '';
                $closing_parenthesis = $data['difference_per_phase'][$phase] < 0 ? ' )' : '';
                $difference_per_phase = $data['difference_per_phase'][$phase] < 0 ? $data['difference_per_phase'][$phase]*(-1) :  $data['difference_per_phase'][$phase];
                $balance_vs_budget[] = $opening_parenthesis.format_money_amount($difference_per_phase, $currency_sym).$closing_parenthesis;
            } else {
                $balance_vs_budget[] = format_money_amount(0, $currency_sym);
            }
        }
    }
    $total_opening_parenthesis = $data['total_difference'] < 0 ? '( ' : '';
    $total_closing_parenthesis = $data['total_difference'] < 0 ? ' )' : '';
    $total_difference = $data['total_difference'] < 0 ? $data['total_difference']*(-1) : $data['total_difference'];
    $balance_vs_budget[] = $total_opening_parenthesis.format_money_amount($total_difference, $currency_sym).$total_closing_parenthesis;

    return array('totals' => $balance_vs_budget);
}

function build_billed_percentage_excel($data, $report_data, $type_of_report){
    $project_phases = $type_of_report == 'individual_project' ?  array_var($data, 'project_phases') : array();
    $group_by_month = array_var($report_data, 'group_invoices_by_month') == 'checked' ? 1 : 0;
    $use_budget_total_custom_property = array_var($report_data, 'use_budget_total_custom_property');
    $currency_sym = config_option('currency_code');

    // Build 'Billed vs budgeted %'
    $billed_percentage = array(lang('billed vs budgeted %'));
    if(!$group_by_month){
        $billed_percentage[] = '';
        if ($type_of_report == 'total_without_grouping'){
            $billed_percentage[] = '';
        }
        if($type_of_report == 'total_grouped_by_clients' || $type_of_report == 'total_without_grouping'){
            $billed_percentage[] = '';
        }
    }
    foreach($project_phases as $phase){
        if($use_budget_total_custom_property) {
            $billed_percentage[] = '';
        } else {
            if(isset($data['percentage_per_phase'][$phase])){
                $billed_percentage[] = $data['percentage_per_phase'][$phase].' %';
            } else {
                $billed_percentage[] = '';  
            }
        }
    }
    $billed_percentage[] = $data['total_percentage'].' %';

    return array('totals' => $billed_percentage);
}

function build_project_name_header_for_excel_invoice_report($result_data, $report_data = array(), $header_params = array()){
    $project_member = $result_data['project_member'];
    $type_of_report = array_var($header_params, 'type_of_report');
    $project_phases = $type_of_report == 'individual_project' ?  array_var($data, 'project_phases') : array();
    $group_by_month = array_var($report_data, 'group_invoices_by_month') == 'checked' ? 1 : 0;
    $excel_data = array();
    $main_header_array = array();
    if ($project_member instanceof Member) {
        $project_prefix_object = ObjectPrefixes::instance()->findById($project_member->getObjectId());
        if($project_prefix_object){
            $prefix_number = $project_prefix_object->getPrefix();
            $project_name = str_replace($prefix_number.' - ', '', $project_member->getName());
            $project_id = lang('number').' '.$prefix_number;
        } else {
            $pot = ObjectTypes::findByName('project');
            $project_id_cp = CustomProperties::getCustomPropertyByCode($pot->getId(), 'project_id');
            $project_id = '';
            if ($project_id_cp instanceof CustomProperty) {
                $cp_val = CustomPropertyValues::getCustomPropertyValue($project_member->getObjectId(), $project_id_cp->getId());
                if ($cp_val instanceof CustomPropertyValue) {
                    $project_number_custom_property_name = CustomProperties::instance()->findById($cp_val->getCustomPropertyId())->getName();
                    $project_id = $project_number_custom_property_name.' '.$cp_val->getValue();
                }
            }
            $project_name = $project_member->getName();
        }
        $client_info = '';
        if (array_var($header_params, 'include_client_name')){
            $client_dimension = Dimensions::findByCode('customers');
            $client_ot = ObjectTypes::findByName('customer');
            $selected_ids = get_all_associated_status_member_ids($project_member, $client_dimension, $client_ot, false, 'project_customer');
            if(!empty($selected_ids)){
                $client_member = Members::getMemberById($selected_ids[0]);
                if($client_member instanceof Member){
                    $client_name = $client_member->getName();
                    // $client_object_type_name = Objects::instance()->findById($client_member->getObjectId())->getObjectTypeName();
                    $client_info = lang('client').' '. $client_name;
                }
            }
        }
        $indent_class = array_var($header_params, 'add_indentation') ? 'indent-medium' : '';
        $project_object_type_name = Objects::instance()->findById($project_member->getObjectId())->getObjectTypeName();
        $main_header_array = array(lang($project_object_type_name).' '.$project_name.' '.$project_id.' '.$client_info, '');
        if(!$group_by_month){
            $main_header_array[] = '';
        }
        foreach($project_phases as $pf){
            $main_header_array[] = '';
        }
    } else  {
        return array();
    }
    $excel_data[] = array('main_header' => $main_header_array);

    return $excel_data;
}

function build_invoice_project_information_excel($result_data, $report_data = array(), $header_params = array()) {
    $report_data = array_var($_SESSION, 'invoice_report_data');
    $type_of_report = array_var($header_params, 'type_of_report');
    $project_phases = $type_of_report == 'individual_project' ?  array_var($data, 'project_phases') : array();
    $project_member = $result_data['project_member'];
    if (!$project_member instanceof Member) {
        return array();
    }
    
    $excel_data = array();
    
    $properties_array = '';
    $params =  array(
            'member' => $project_member,
            'visible_by_default' => true,
            'return_as_array' => true,
    );
    Hook::fire('override_render_properties_for_view', $params, $properties_array);
    
    $left_properties_array = array();
    $right_properties_array = array();
    foreach ($properties_array as $group_id => $group_data) {
        if (count($group_data['properties']) == 0) continue;
        
        $property_group = PropertyGroups::instance()->findById($group_id);
        $group_data['alignment'] = $property_group->getAlignment();
        $group_data['name'] = $property_group->getName();
        
        if ($group_data['alignment'] == 'left') {
            $left_properties_array[] = $group_data;
        } else if ($group_data['alignment'] == 'right') {
            $right_properties_array[] = $group_data;
        }
    }
    
    
    // get project name and project id
    $project_prefix_object = ObjectPrefixes::instance()->findById($project_member->getObjectId());
	if($project_prefix_object){
		$project_id = $project_prefix_object->getPrefix();
		$project_name = str_replace($project_id.' - ', '', $project_member->getName());
	} else {
		$pot = ObjectTypes::findByName('project');
		$project_id_cp = CustomProperties::getCustomPropertyByCode($pot->getId(), 'project_id');
		$project_id = '';
		if ($project_id_cp instanceof CustomProperty) {
			$cp_val = CustomPropertyValues::getCustomPropertyValue($project_member->getObjectId(), $project_id_cp->getId());
			if ($cp_val instanceof CustomPropertyValue) {
				$project_id = $cp_val->getValue();
			}
		}
		$project_name =  $project_member->getName();
	}
    
    $main_header_array = array($project_name.' '.$project_id, '', '');


    for($k=0; $k<count($project_phases)-1; $k++){
        $main_header_array[] = '';
    }


    $excel_data[] = array('headers' => array(), 'data' => array(), 'main_header' => $main_header_array);
    
    $i = 0;
    $more_groups_left = true;
    while ($more_groups_left) {
        $more_groups_left = false;
        
        $headers = array();
        $data = array();
        
        if (isset($left_properties_array[$i])) {
            $group_data = $left_properties_array[$i];
            $more_groups_left = true;
            
            $headers[] = $group_data['name'];
            $headers[] = '';
            $headers[] = '';
            
            $j = 0;
            foreach ($group_data['properties'] as $property) {
                $data[$j] = array();
                
                $data[$j][0] = $property['label'];
                $data[$j][1] = $property['value'];
                $data[$j][2] = '';
                
                $j++;
            }
        } else {
            $headers[] = '';
            $headers[] = '';
            $headers[] = '';
        }
        
        if (isset($right_properties_array[$i])) {
            $group_data = $right_properties_array[$i];
            $more_groups_left = true;
            
            $headers[] = $group_data['name'];
            $headers[] = '';
            
            $j = 0;
            foreach ($group_data['properties'] as $property) {
                if (!isset($data[$j])) $data[$j] = array('','','');
                
                $data[$j][3] = $property['label'];
                $data[$j][4] = $property['value'];
                
                $j++;
            }
        } else {
            $headers[] = '';
            $headers[] = '';
        }
        
        for($k=0; $k<count($project_phases)-3; $k++){
            $headers[] = '';
        }

        $excel_data[] = array('headers' => $headers, 'data' => $data);
        
        $i++;
    }
    
    return $excel_data;
}

function build_invoicing_history_total_excel_table($report_data, $params){
    $table_name = array_var($params, 'table_name');
    $total_budgeted = array_var($params, 'total_budgeted');
    $total_invoiced = array_var($params, 'total_invoiced');
    $group_by_month = array_var($report_data, 'group_invoices_by_month') == 'checked' ? 1 : 0;
    $currency_sym = config_option('currency_code');
    $group_report_by = array_var($report_data, 'group_report_by');

    $colspan = $group_by_month ? 1 : 2;
    if(!$group_by_month){
        if($group_report_by == 3){
            $colspan += 1;
        } elseif ($group_report_by == 1) {
            $colspan += 2;
        }
    }

    $excel_data = array();
    $header = array($table_name);
    for($i = 0; $i < $colspan; $i++){
        $header[] = '';
    }

    // Total Budgeted info
    $budgeted_data = array(lang('budgeted'));
    for($i = 0; $i < $colspan - 1; $i++){
        $budgeted_data[] = '';
    }
    $budgeted_data[] = format_money_amount($total_budgeted, $currency_sym);

    // Total 'Billed to date' info
    $invoiced_data = array(lang('billed to date'));
    for($i = 0; $i < $colspan - 1; $i++){
        $invoiced_data[] = '';
    }
    $invoiced_data[] = format_money_amount($total_invoiced, $currency_sym);

    // Total 'Remaining balance' info
    $total_difference = $total_budgeted - $total_invoiced;
    $total_opening_parenthesis = $total_difference < 0 ? '( ' : '';
    $total_closing_parenthesis = $total_difference < 0 ? ' )' : '';
    $total_difference = $total_difference < 0 ? $total_difference*(-1) : $total_difference;
    $remaining_data = array(lang('remaining budget'));
    for($i = 0; $i < $colspan - 1; $i++){
        $remaining_data[] = '';
    }
    $remaining_data[] = $total_opening_parenthesis.format_money_amount($total_difference, $currency_sym).$total_closing_parenthesis;

    // Total 'Billed to date' info
    $total_percentage = $total_budgeted != 0 ? round(($total_invoiced / $total_budgeted)*100) : 0;
    $percentage_data = array(lang('billed vs budgeted %'));
    for($i = 0; $i < $colspan - 1; $i++){
        $percentage_data[] = '';
    }
    $percentage_data[] = $total_percentage.' %';
    $body_data = array($budgeted_data, $invoiced_data, $remaining_data, $percentage_data);

    return array(array('main_header' => $header, 'data' => $body_data));
} 
