<?php

function build_project_summary_report_excel($data, $report_data) {

    $excel = array();

    $excel[] = build_main_header_project_summary_report_excel($data, $report_data);
    $excel[] = build_overall_totals_project_summary_report_excel($data, $report_data);
    $project_managers = array_var($data, 'project_managers', array());
    foreach($project_managers as $pm_data) {
        $excel[] = build_project_manager_header_project_summary_report_excel($pm_data, $data);
        $excel[] = build_project_manager_projects_project_summary_report_excel($pm_data, $data, $report_data);
    }   

    return $excel;
}

function build_project_manager_header_project_summary_report_excel($pm_data, $data) {
    $columns = array_var($data, 'columns', array());
    $totals = $pm_data['totals'];
    $currency_sym = config_option('currency_code');
    $pm_name = $pm_data['project_manager_name'];

    $excel_table = array(
		'data' => array()
    );

    $header_row = array($pm_name);

    foreach($columns as $column) {
        if($column == 'name') continue;
        $money_val = format_money_amount($totals[$column], $currency_sym);
        $header_row[] = $money_val;
    }

    $excel_table['data'][] = $header_row;

    return $excel_table;
}

function build_project_manager_projects_project_summary_report_excel($pm_data, $data, $report_data) {
    $columns = array_var($data, 'columns', array());
    $currency_sym = config_option('currency_code');
    
    $excel_table = array(
		'data' => array()
    );

    $projects = array_var($pm_data, 'projects', array());
    foreach($projects as $project) {
        $new_project = array($project['name']);
        foreach($columns as $column) {
            if($column == 'name') continue;
            $money_val = format_money_amount($project[$column], $currency_sym);
            $new_project[] = $money_val;
        }
        $excel_table['data'][] = $new_project;
    }

    return $excel_table;
}

function build_main_header_project_summary_report_excel($data, $report_data) {
    $columns = array_var($data, 'columns', array());

    $excel_table = array(
		'main_header' => array('')
    );

    foreach($columns as $column) {
        if($column == 'name') continue;
        if($column == 'budget_total') {
            $column_name = $data['budget_total_cp_name'];
        } else if ($column == 'revised_budget_total') {
            $column_name = $data['revised_budget_total_cp_name'];
        } else if ($column == 'executed_cost') {
            $column_name = lang('executed cost');
        } else if ($column == 'invoiced_subtotal') {
            $column_name = lang('invoiced');
        } else if ($column == 'invoiced_paid') {
            $column_name = lang('invoiced paid');
        } else {
            $column_name = lang($column);
        }

       $excel_table['main_header'][] = $column_name;
    }

    return $excel_table;
}

function build_overall_totals_project_summary_report_excel($data, $report_data) {
    $columns = array_var($data, 'columns', array());
    $totals = array_var($data, 'totals', array());
    $currency_sym = config_option('currency_code');

    $excel_table = array(
        'totals' => array(lang('totals'))
    );

    foreach($columns as $column) {
        if($column == 'name') continue;
        $money_val = format_money_amount($totals[$column], $currency_sym);
        $excel_table['totals'][] = $money_val;
    }

    return $excel_table;
}
