<?php

function build_utulization_report_csv($data, $report_data){

    // Header columns
	$columns = $data['columns'];
	$headers = implode(',', $columns) . "\n";

	// data for the table
	$utilization_data = array_var($data, 'utilization_data');
	$utilization_totals = array_var($data, 'totals');

    $lines_csv = "";

	foreach ($utilization_data as $contact_id => $contact_data) {
		$line = array();
		foreach ($columns as $col_code => $col_name) { 
			$cell_value = $contact_data[$col_code];

			if ($cell_value != '' && ($col_code == 'billable_utilization' || $col_code == 'utilization_goal')) {
				$cell_value .= ' %';
			}

			$line[] = '"'.$cell_value.'"';
		}
		$lines_csv .= implode(',', $line) . "\n";
	}

	// totals
	$totals = array();
	foreach ($columns as $col_code => $col_name) { 
		$cell_value = array_var($utilization_totals, $col_code, '');

		$cell_value = str_replace(user_config_option('thousand_separator'), '', $cell_value);

		if ($cell_value != '' && ($col_code == 'billable_utilization' || $col_code == 'utilization_goal')) {
			$cell_value .= ' %';
		}

		$totals[] = $cell_value;
	}
	$lines_csv .= implode(',', $totals) . "\n";

    return $headers . "\n" . $lines_csv;
}
