<?php

function build_utulization_report_excel($data, $report_data){

    // Header columns
	$columns = $data['columns'];
	$headers = array_values($columns);

	// data for the table
	$utilization_data = array_var($data, 'utilization_data');
	$utilization_totals = array_var($data, 'totals');

    $lines = array();

	foreach ($utilization_data as $contact_id => $contact_data) {
		$line = array();
		foreach ($columns as $col_code => $col_name) { 
			$cell_value = $contact_data[$col_code];

			if ($cell_value != '' && ($col_code == 'billable_utilization' || $col_code == 'utilization_goal')) {
				$cell_value .= ' %';
			}

			$line[] = $cell_value;
		}
		$lines[] = $line;
	}

	$totals = array();
	foreach ($columns as $col_code => $col_name) { 
		$cell_value = array_var($utilization_totals, $col_code, '');

		$cell_value = str_replace(user_config_option('thousand_separator'), '', $cell_value);

		if ($cell_value != '' && ($col_code == 'billable_utilization' || $col_code == 'utilization_goal')) {
			$cell_value .= ' %';
		}

		$totals[] = $cell_value;
	}

    return array('headers' => $headers, 'data' => $lines, 'totals' => $totals, 'totals_after_data' => true);
}
