<?php
echo stylesheet_tag("og/reporting.css");
require_javascript("og/ReportingFunctions.js");
$genid = gen_id();
if (!isset($conditions)) $conditions = array();

$report_data = array_var($_SESSION, 'actual_vs_forecast_report_data');
$report_key = 'actual_vs_forecast_report'.Timeslots::instance()->getObjectTypeId();
$report = Reports::instance()->findOne(array("conditions" => "`code` = 'actual_vs_forecast_report'"));
$report_title = $report->getObjectName();
$report_id = $report->getId();
?>
<style>
	.coInputMainBlock label{min-width: 270px;}
</style>
<form style='height:100%;background-color:white' class="internalForm" action="<?php echo get_url('project_reports', 'actual_vs_forecast_report') ?>" method="post" enctype="multipart/form-data">
<input type="hidden" id="<?php echo $genid?>report[report_object_type_id]" name="report[report_object_type_id]" value="<?php echo Timeslots::instance()->getObjectTypeId()?>"/>
<input type="hidden" id="<?php echo $genid?>report[report_id]" name="report[report_id]" value="<?php echo $report_id ?>"/>
<input type="hidden" id="<?php echo $genid?>report[report_title]" name="report[report_title]" value="<?php echo $report_title ?>"/>


<div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo $title; ?>
	</div>
</div>
<div class="coInputSeparator"></div>
<div class="coInputMainBlock">
    
    <input type="hidden" id="report[date_type]" name="report[date_type]" value="7" />
    <div>
        <label for="report[start_value]"><?php echo lang('start month') ?>:</label>

        <input type="month" id="start_value" name="report[start_value]" min="2000-01" value="<?php echo array_var($report_data, 'start_value') ?>" />

    </div>

    <div style="margin-top: 10px;">
        <label for="report[end_value]"><?php echo lang('end month') ?>:</label>

        <input type="month" id="end_value" name="report[end_value]" min="2000-01" value="<?php echo array_var($report_data, 'end_value') ?>" />

    </div>

    <!-- Render cost or revenue selector -->
    <?php
        $financial_type = array_var($report_data, 'financial_type', 'cost');
        $fin_typ_options = array(
            array('revenue', lang('revenue')),
            array('cost',lang('cost'))
        );
    ?>
    <div style="margin-top: 10px;">
        <label for="report[financial_type]"><?php echo lang('revenue/cost') ?>:</label>
        <?php echo simple_select_box('report[financial_type]', $fin_typ_options, $financial_type)?>
    </div>

    <!-- Add group by if project type dimension is active -->
    <?php
        $enabled_dimensions = config_option('enabled_dimensions');
        $project_type_dimension = Dimensions::instance()->findByCode('project_types');
        $project_type_dim_id = $project_type_dimension instanceof Dimension ? $project_type_dimension->getId() : 0;
        $proj_proj_type_association = DimensionMemberAssociations::instance()->getAssociationByCode('project_project_type');
        if ($project_type_dimension instanceof Dimension && $proj_proj_type_association instanceof DimensionMemberAssociation && in_array($project_type_dim_id, $enabled_dimensions)) {
            $group_by_options = array(
                array('none', '-'),
                array('project_type', $project_type_dimension->getName())
            );
            $group_by_selection = array_var($report_data, 'group_by', 'none');
            ?>
            <div style="margin-top: 10px;">
                <label for="report[group_by]"><?php echo lang('group by') ?>:</label>
                <?php echo simple_select_box('report[group_by]', $group_by_options, $group_by_selection)?>
            </div>
    <?php } ?>

<br/>
<?php echo submit_button(lang('generate report'),'s',array('onclick'=>'og.setMemoryFilttersReport(this,"'.$report_key.'")','style'=>'margin-top:0px;')) ?>
</div>
</div>

</form>
<script>
	og.loadFiltersReport("<?php echo $report_key; ?>");
</script>