<?php
echo stylesheet_tag("og/reporting.css");
require_javascript("og/ReportingFunctions.js");
$genid = gen_id();
if (!isset($conditions)) $conditions = array();

$report_data = array_var($_SESSION, 'aging_invoices_report_data');
?>
<form style='height:100%;background-color:white' class="internalForm" action="<?php echo get_url('project_reports', 'aging_invoices_report') ?>" method="post" enctype="multipart/form-data">
<div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo $title ?>
	</div>
</div>
<div class="coInputSeparator"></div>
<div class="coInputMainBlock">
<?php
    $project_ot = ObjectTypes::findByName('project');   
    $project_manager_dimension = Dimensions::instance()->findByCode('project_managers');
    $pm_dim_id = $project_manager_dimension->getId();
    // Get association between project and project manager
    $proj_proj_manager_association = DimensionMemberAssociations::instance()->getAssociationByCode('project_project_manager');
    $enabled_dimensions = config_option('enabled_dimensions');
    // Get custom property 'project_manager'
    $cp_project_manager = CustomProperties::instance()->findOne(array('conditions' => 'object_type_id='.$project_ot->getId().' AND `code`="project_manager"'));
    if($project_manager_dimension instanceof Dimension && $proj_proj_manager_association instanceof DimensionMemberAssociation && in_array($pm_dim_id, $enabled_dimensions)){
        $use_active_context = false;
        $active_context_members = active_context();
        foreach($active_context_members as $mem){
            if ( $mem instanceof Member ) {
                if($mem->getDimensionId() == $pm_dim_id) $use_active_context = true;
            }
        }
        $selected_pm_ids = array(str_replace(array('[', ']'), '', array_var($report_data,'project_manager_member_id')));
        $selected_member_ids = $use_active_context ? active_context_members(false) : $selected_pm_ids;

        ?>

        <div class="dataBlock">
            <label><?php echo lang('project manager'); ?>:</label>
            <?php echo render_single_member_selector($project_manager_dimension, $genid, $selected_member_ids, array('is_multiple' => false, 'is_required' => false, 'hide_label'=>true, 'hidden_field_name' => 'report[project_manager_member_id]'));?>
        </div>
    </tr> 

    <?php } else if ($cp_project_manager instanceof CustomProperty) {
        $contact_select_array = array(array(0, ucfirst(lang('all'))));
        // Find project manager contact ids
        $pm_cp_values = CustomPropertyValues::instance()->findAll((array('conditions' => '`custom_property_id`='.$cp_project_manager->getId())));
        $pm_all_ids = array_map('get_cp_value', $pm_cp_values);
        $pm_contact_ids = array_unique($pm_all_ids);
        foreach($pm_contact_ids as $contact_id){
            $contact = Contacts::instance()->findById($contact_id);
            if($contact instanceof Contact){
                $contact_select_array[] = array($contact_id, $contact->getName());
            }
        }
        $pm_label_name = $cp_project_manager instanceof CustomProperty ? $cp_project_manager->getName() : lang('project manager');
        ?>
        <div class="dataBlock">
            <label><?php echo $pm_label_name; ?>:</label>
            <?php echo simple_select_box('report[project_manager_id]', $contact_select_array, array_var($report_data, 'project_manager_id'))?>
        </div>
   <?php } ?>

    <!-- Group by selector -->
    <?php
        $group_by_val = array_var($report_data, 'group_by', 'project');
        $group_by_options = array(
            array('project', lang('project - client')),
            array('pm',lang('pm - project - client')),
        );

        $report_date_cp = CustomProperties::instance()->findOne(array('conditions' => 'object_type_id='.$project_ot->getId().' AND `code`="report_sent" AND `is_disabled`=0'));
        if($report_date_cp instanceof CustomProperty) {
            $group_by_options[] = array('report_sent', $report_date_cp->getName());
        }
    ?>
    <div class="dataBlock">
        <label for="report[group_by]"><?php echo lang('group by') ?>:</label>
        <?php echo simple_select_box('report[group_by]', $group_by_options, $group_by_val)?>
    </div>

    <div class="dataBlock">
        <label><?php echo lang('include invoice issue date')?>:</label>
        <?php echo checkbox_field('report[show_invoice_issued_date]', array_var($report_data, 'show_invoice_issued_date'))?>
    </div>

    <div class="dataBlock">
        <label><?php echo lang('include current invoices (invoices that are not due yet)')?>:</label>
        <?php echo checkbox_field('report[include_current_invoices]', array_var($report_data, 'include_current_invoices'))?>
    </div>

    <?php
        $cp_codes = array('billing_contact', 'report_sent', 'invoice_sent', 'collection_notes');
        foreach($cp_codes as $cp_code) {
            $project_cp = CustomProperties::instance()->findOne(array('conditions' => 'object_type_id='.$project_ot->getId().' AND `code`="'.$cp_code.'"'));
            if($project_cp instanceof CustomProperty) {
            $cp_name = $project_cp->getName();
            $report_data['cp_'.$cp_code.'_name'] = $cp_name;
            ?>
            <div class="dataBlock">
                    <label><?php echo lang('show') .' "'. $cp_name . '"'; ?>:</label>
                    <?php echo checkbox_field('report[show_'.$cp_code.']', array_var($report_data, 'show_'.$cp_code))?>
            </div> 
            <?php } 
        } ?>
<?php echo submit_button(lang('generate report'),'s',array('style'=>'margin-top:0px;')) ?>
</div>

</form>
