<?php
echo stylesheet_tag("og/reporting.css");
require_javascript("og/ReportingFunctions.js");
$genid = gen_id();
if (!isset($conditions)) $conditions = array();

$report_data = array_var($_SESSION, 'budget_by_tasks_report_data');
?>
<form style='height:100%;background-color:white' class="internalForm" action="<?php echo get_url('project_reports', 'budget_by_tasks_report') ?>" method="post" id="<?php echo $genid?>_budget_by_tasks_report" enctype="multipart/form-data">
<div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo $title ?>
	</div>
</div>

<div class="coInputSeparator"></div>
<div class="coInputMainBlock">

<!-- Filter by -->
<?php 
	if(false){
		$filter_by_array = array(array(1, lang('project')), array(2, lang('project manager')));
        $listeners = array('onchange' => 'og.hide_report_form_options();', 'id' => 'filter_by_selector');
	?>
		<div class="dataBlock" id="filter_by">
			<label><?php echo lang('filter report by')?>:</label>
			<?php echo simple_select_box('report[filter_by]', $filter_by_array, array_var($report_data, 'filter_by'), $listeners)?>
		</div>
	<?php } ?>

<?php
   /* $project_ot = ObjectTypes::findByName('project');   
    $project_manager_dimension = Dimensions::instance()->findByCode('project_managers');
    $pm_dim_id = $project_manager_dimension->getId();
    // Get association between project and project manager
    $proj_proj_manager_association = DimensionMemberAssociations::instance()->getAssociationByCode('project_project_manager');
    $enabled_dimensions = config_option('enabled_dimensions');
    // Get custom property 'project_manager'
    $cp_project_manager = CustomProperties::instance()->findOne(array('conditions' => 'object_type_id='.$project_ot->getId().' AND `code`="project_manager"'));
    if($project_manager_dimension instanceof Dimension && $proj_proj_manager_association instanceof DimensionMemberAssociation && in_array($pm_dim_id, $enabled_dimensions)){
        $use_active_context = false;
        $active_context_members = active_context();
        foreach($active_context_members as $mem){
            if ( $mem instanceof Member ) {
                if($mem->getDimensionId() == $pm_dim_id) $use_active_context = true;
            }
        }
        $selected_pm_ids = json_decode(array_var($report_data,'project_member_id', '[]'));
        $selected_member_ids = $use_active_context ? active_context_members(false) : $selected_pm_ids;

        ?>

        <div class="dataBlock" id="project_manager_filter">
            <label><?php echo lang('project manager'); ?>:</label>
            <?php echo render_single_member_selector($project_manager_dimension, $genid, $selected_member_ids, array('is_multiple' => false, 'is_required' => false, 'hide_label'=>true, 'hidden_field_name' => 'report[project_manager_member_id]'));?>
        </div>

    <?php } else if ($cp_project_manager instanceof CustomProperty) {
        $contact_select_array = array(array(0, ucfirst(lang('all'))));
        // Find project manager contact ids
        $pm_cp_values = CustomPropertyValues::instance()->findAll((array('conditions' => '`custom_property_id`='.$cp_project_manager->getId())));
        $pm_all_ids = array_map('get_cp_value', $pm_cp_values);
        $pm_contact_ids = array_unique($pm_all_ids);
        foreach($pm_contact_ids as $contact_id){
            $contact = Contacts::instance()->findById($contact_id);
            if($contact instanceof Contact){
                $contact_select_array[] = array($contact_id, $contact->getName());
            }
        }
        $pm_label_name = $cp_project_manager instanceof CustomProperty ? $cp_project_manager->getName() : lang('project manager');
        ?>
        <div class="dataBlock" id="project_manager_filter">
            <label><?php echo $pm_label_name; ?>:</label>
            <?php echo simple_select_box('report[project_manager_id]', $contact_select_array, array_var($report_data, 'project_manager_id'))?>
        </div>
   <?php } */?>

   <input type="hidden" name="report[filter_by]" value="1"/>
   <?php 
        $projects_dim = Dimensions::findByCode('customer_project'); ?>
   
	<div class="dataBlock" id="project_filter">
		
    <?php
        $use_active_context = false;
        $context = active_context();
        foreach ($context as $selection) {
            if ($selection instanceof Member) { 
                if($selection->getDimensionId() == $projects_dim->getId()) {
                    $has_project_selected = true;
                    $use_active_context = true;
                }
            }
        }
        $selected_project_ids = json_decode(array_var($report_data,'project_member_id', '[]'));
        $selected_member_ids = $use_active_context ? active_context_members(false) : $selected_project_ids;
        render_single_member_selector($projects_dim, $genid, $selected_member_ids, array('is_multiple' => false, 'hidden_field_name' => 'report[project_member_id]', 'is_required' => true));
    ?>
		
	</div>

    <!-- Add Group By -->
    <?php
        $job_phases_dimension = Dimensions::instance()->findByCode('job_phases');
        $enabled_dimensions = config_option('enabled_dimensions');
        if($job_phases_dimension instanceof Dimension && in_array($job_phases_dimension->getId(), $enabled_dimensions)) {
            $group_options = array(array(0, lang('tasks')), array(1, $job_phases_dimension->getName() . ' | ' .lang('tasks')));
    ?>

    <div class="dataBlock">
        <label><?php echo lang('group by'); ?>:</label>
        <?php echo simple_select_box('report[group_by]', $group_options, array_var($report_data, 'group_by'))?>
    </div>

    <?php }?>
	
<?php echo submit_button(lang('generate report'),'s',array('style'=>'margin-top:0px;')) ?>
</div>

</form>

<script>
	///og.loadFiltersReport("<?php //echo $report_key; ?>", "<?php //echo $has_project_selected; ?>");
	
	/* og.hide_report_form_options = function () {
		var filter_by = document.getElementById('filter_by_selector');
        
		if (filter_by.value == 1){
			$('#project_filter').show();
            $('#project_manager_filter').hide();
		} else {
			$('#project_filter').hide();
            $('#project_manager_filter').show();
		}
	}
	
	og.hide_report_form_options(); */
</script>
