<?php 

Env::useHelper('view_functions', 'project_reports');

$projects_data = array_var($data, 'projects_data');
$project_member = $data['project_member'];
$totals = array_var($data, 'totals');
$project_phases = array_var($data, 'project_phases');
$report_data = array_var($_SESSION, 'budget_report_data');
$show_main_information_blocks = isset($report_data['show_main_project_info']);
$list_subprojects = array_var($report_data, 'list_supbrojects');

function render_labor_table($project_data, $project_phases) {
    $report_data = array_var($_SESSION, 'budget_report_data');
    $group_labor_by = array_var($report_data, 'group_labor_by', 'task');
    $include_hours = array_var($report_data, 'include_hours') == 'checked';
    echo '<article class="tableContainer flexContent contentColumn w-100">';
    if (!empty($project_data['labor_data'])){
        echo '<h3 class="titleTable">'.lang('project quoting').'</h3>';
        $labor_data = $project_data['labor_data'];
        $report_data = array_var($_SESSION, 'budget_report_data');
        $currency_sym = config_option('currency_code');

        $count_phases = count($project_phases);
        $header_colspan = $count_phases + 4;
       
        // Build table header
        echo '<table class="tableData radiusItem w-100">';
        echo '<thead><tr><th class="left">'.lang('details').'</th>';
        if($include_hours && count($project_phases) > 1) {
            foreach($project_phases as $phase){
                echo '<th class="left">'.$phase.'</th>';
            }
        }
        if ($include_hours) {
            echo '<th class="center">'.lang('total hours').'</th>';
        }
        if ($group_labor_by != 'task') {
            echo '<th class="right">'.lang('unit_value').'</th>';
        }
        echo '<th class="right">'.lang('total').'</th></tr></thead>';

        // Build table body
        echo '<tbody>';
        foreach($labor_data['labor_names'] as $labor_id => $labor_name){
            $name = $labor_name;
            echo '<tr><td class="left">'.$name.'</td>';
            if($include_hours && count($project_phases) > 1) {
                foreach($project_phases as $phase){     
                    $phase_hours = isset($labor_data['project_phases'][$phase][$labor_id]) &&  $labor_data['project_phases'][$phase][$labor_id] > 0 ? number_format($labor_data['project_phases'][$phase][$labor_id], 2) : '';
                    echo '<td class="left">'.$phase_hours.'</td>';
                }
            }
            if ($include_hours) {
                $total_hours = number_format($labor_data['total_per_labor_hours'][$labor_id], 2);
                echo '<td class="center">'.$total_hours.'</td>';
            }
            if ($group_labor_by != 'task') {
                $unit_value = format_money_amount($labor_data['hourly_rates'][$labor_id], $currency_sym);
                echo '<td class="right">'.$unit_value.'</td>';
            }
            echo '<td class="right">'.format_money_amount($labor_data['total_per_labor_amount'][$labor_id], $currency_sym).'</td></tr>';
        }
    }
    echo '</tbody>';
    echo '</table>';
    
    if(!empty($project_data['labor_summary'])){
        $labor_summary = $project_data['labor_summary'];
        echo '<div class="right subtotalRow otherInformation">'.lang('subtotal') .': ' . '
                 <span class="font-semiBold">'.format_money_amount($labor_summary['subtotal_amount'], $currency_sym).'</span>
             </div>';
       /*  echo '<tr class="budget-report-summary">';
        echo '<td>'.lang('labor subtotal budget report').'</td>';
        if ($include_hours && count($project_phases) > 1) {
            foreach($project_phases as $phase){
                $phase_value = isset($labor_summary['project_phases_subtotals'][$phase]) ?  number_format($labor_summary['project_phases_subtotals'][$phase], 2) : number_format(0, 2);
                echo '<td class="report-number">'.$phase_value.'</td>';
            }
        }
        if ($include_hours) {
            echo '<td class="report-number">'.number_format($labor_summary['subtotal_hours'], 2).'</td>';
        }
        if ($group_labor_by != 'task') {
            echo '<td></td>';
        }
        echo '<td class="report-number">'.format_money_amount($labor_summary['subtotal_amount'], $currency_sym).'</td></tr>'; */
        
    }
    echo '</article>';

}

function render_expenses_table($project_data, $project_phases){
    $report_data = array_var($_SESSION, 'budget_report_data');
    $group_expenses_by = isset($report_data['group_expenses_by']) ? $report_data['group_expenses_by'] : 0;
    $group_labor_by = array_var($report_data, 'group_labor_by', 'task');
    $include_hours = array_var($report_data, 'include_hours') == 'checked';
    echo '<article class="tableContainer flexContent contentColumn w-100">';
    if(!empty($project_data['expenses_data'])){
        $expenses_data = $project_data['expenses_data'];
        $currency_sym = config_option('currency_code');

        $count_phases = count($project_phases);
        $header_colspan = $count_phases + 4;
        echo '<h3 class="titleTable">'.lang('expenses project_quoting title').'</h3>';
        echo '<table class="tableData radiusItem w-100">';

        if($group_expenses_by == 0) { // Group by product type

            // Build expenses table header
            echo '<thead><tr><th class="left">'.lang('details').'</th>';
            if ($include_hours && count($project_phases) > 1) {
                foreach($project_phases as $phase){
                    echo '<th class="center">'.$phase.'</th>';
                }
            }
            if ($include_hours) {
                echo '<th class="center">'.lang('quantity total').'</th>';
            }
            if ($group_labor_by != 'task') {
                echo '<th class="right">'.lang('unit price').'</th>';
            }
            echo '<th class="right">'.lang('total').'</th></tr></thead>';

            // Build expenses table body
            echo '<tbody>';
            foreach($expenses_data['expenses_names'] as $expense_id => $expense_name){
                $name = $expense_name;
                echo '<tr><td class="left">'.$name.'</td>';
                if ($include_hours && count($project_phases) > 1) {
                    foreach($project_phases as $phase){
                        $phase_quantity = isset($expenses_data['project_phases'][$phase][$expense_id]) ? $expenses_data['project_phases'][$phase][$expense_id] : '';
                        echo '<td class="center">'.$phase_quantity.'</td>';
                    }
                }
                if ($include_hours) {
                    $total_quantity = $expenses_data['expenses_total_quantity'][$expense_id];
                    echo '<td class="center">'.$total_quantity.'</td>';
                }
                if ($group_labor_by != 'task') {
                    $unit_price = format_money_amount($expenses_data['unit_prices'][$expense_id], $currency_sym);
                    echo '<td class="right">'.$unit_price.'</td>';
                }
                echo '<td class="right">'.format_money_amount($expenses_data['amount_per_expense'][$expense_id], $currency_sym).'</td></tr>';
            }
        } else if($group_expenses_by == 1){ // Group by expense categories
            
            // Build expenses table header
            $name_colspan = 1;
            if ($include_hours) {
                $name_colspan += 1;
            }
            echo '<thead><tr><th class="left" colspan="'.$name_colspan.'">'.lang('details').'</th>';
            if ($include_hours && count($project_phases) > 1) {
                foreach($project_phases as $phase){
                    echo '<th class="right">'.$phase.'</th>';
                }
            }
            if ($group_labor_by != 'task') {
                echo '<th></th>';
            }
            echo '<th class="right">'.lang('total').'</th></tr></thead>';

            // Build expenses table body
            echo '<tbody>';
            foreach($expenses_data['expenses_names'] as $expense_name){
                echo '<tr><td class="left" colspan="'.$name_colspan.'">'.$expense_name.'</td>';
                if ($include_hours && count($project_phases) > 1) {
                    foreach($project_phases as $phase){
                        $phase_amount = isset($expenses_data['project_phases'][$phase][$expense_name]) ? format_money_amount($expenses_data['project_phases'][$phase][$expense_name],$currency_sym) : '';
                        echo '<td class="right">'.$phase_amount.'</td>';
                    }
                }
                if ($group_labor_by != 'task') {
                    echo '<td></td>';
                }
                echo '<td class="right">'.format_money_amount($expenses_data['amount_per_expense'][$expense_name], $currency_sym).'</td></tr>';
            }
        }
        echo '</table>';

        // Build expenses table summary
        $expenses_summary = $project_data['expenses_summary']['subtotal_amount'];
        echo '<div class="right subtotalRow otherInformation">'.lang('subtotal') .': ' . '
                <span class="font-semiBold">'.format_money_amount($expenses_summary, $currency_sym).'</span>
            </div>';

       /*  echo '<tr class="budget-report-summary">';
        echo '<td>'.lang('expenses subtotal').'</td>';
        if ($include_hours && count($project_phases) > 1) {
            foreach($project_phases as $phase){
                echo '<td></td>';
            }
        }
        if ($include_hours) {
            echo '<td></td>';
        }
        if ($group_labor_by != 'task') {
            echo '<td></td>';
        }
        echo '<td class="report-number">'.format_money_amount($expenses_summary, $currency_sym).'</td></tr>';
        echo '</tbody>';

        echo '<thead class="table-separator"><tr><td></td></tr></thead>'; */
        
    
       
    }
    echo '</article>';
}

function render_project_totals($totals, $project_member, $data) {

    $quoting_notes = array_var($data, 'quoting_notes');
    $currency_sym = config_option('currency_code');
    $subtotal = $totals['subtotal'];
    $grand_total = $totals['grand_total'];

    echo '<hr class="separatorQuoting" />
    <article class="flexContent w-100 borderSpacing">';
    if($quoting_notes != '') {
        echo '<div class="cell vCenter w-50 contentColumn flexChildColumn radiusItem justifyContentCenter columnContents otherInformation">
            <h3 class="titleTable">'.lang('other information').'</h3>
            <div class="aditionalInformation">'.$quoting_notes.'</div>
        </div>';
    } else {
        echo '<div></div>';
    }


    echo '<div class="cell vCenter w-50 flexChildColumn flexVerticalCenter radiusItem itemJustifyEnd columnContents">
      	<ul class="aditionalInformation">
          <li class="right p5">'.lang('subtotal').': 
          <span class="font-semiBold minWidthAmount">'.format_money_amount($subtotal, $currency_sym).'</span></li>';

    if($totals['include_taxes']) {
        $taxes = $totals['taxes'];
        foreach($taxes as $tax_info){
            if(!is_array($tax_info) || !$tax_info['is_tax']) continue;
            $tax_amount = $tax_info['amount'];
            $tax_name = $tax_info['name'] . ' (' . format_amount($tax_info['rate']) . ' %)';
            echo '<li class="right p5">'.$tax_name.': <span class="font-semiBold minWidthAmount">'.format_money_amount($tax_amount, $currency_sym).'</span></li>';
        }
    }

    echo '<li class="right p5 bold">'.strtoupper(lang('total')).': <span class="font-semiBold totalValue minWidthAmount">'.format_money_amount($grand_total, $currency_sym).'</span></li>';
    echo '</ul>
      </div>
    </article>';

}

function render_project_information_for_budget_report($data, $report_data) {

    $address = array_var($data, 'project_address');
    $client_name = array_var($data, 'client_name');
    $project_name = array_var($data, 'project_name');

   
    echo '<article class="flexContent w-100 borderSpacing">
      <div class="cell vCenter w-50 flexChildColumn flexVerticalCenter radiusItem columnContents">
        <ul class="aditionalInformation">';
    if(!$address) {
        echo '<li>'.lang('address not found').'</li>';
    } else {     
        $street = $address['street'] ? $address['street'] : '';
        $line_2 = $address['city'] ? $address['city'] : '';
        $line_2 .= $address['state'] ? ', ' . $address['state'] : '';
        $line_2 .= $address['zipcode'] ? ' ' . $address['zipcode'] : '';
        $country_name = $address['country_name'] ? $address['country_name'] : '';
        if ($street) {
            echo '<li>'.$street.'</li>';
        }
        if ($line_2) {
            echo '<li>'.$line_2.'</li>';
        }
        if ($country_name) {
            echo '<li>'.$country_name.'</li>';
        }
    }
    echo '</ul>
      </div>
      <div class="cell vCenter w-50 flexChildColumn flexVerticalCenter radiusItem columnContents">
      	<ul class="aditionalInformation">
          <li class="font-semiBold">'.$client_name.'</li>
          <li class="font-semiBold">'.$project_name.'</li>
        </ul>
      </div>
    </article>';
}

function render_organization_information_for_budget_report() {
    $company = owner_company();
    $company_info = $company->getArrayInfo();
    $date_format = user_config_option('date_format');
    $today = format_date(DateTimeValueLib::now());
    $company_picture_data = $company->getPictureFileContent('large');
    $company_picture_url = '';
    if ($company_picture_data) {
        file_put_contents(ROOT . "/tmp/company_picture.png", $company_picture_data);
        $company_picture_url = ROOT_URL . "/tmp/company_picture.png?dummy=".gen_id();
    }

    // Get Name
    $name = array_var($company_info, 'name', '');
    // Get address
    $address_arr = array_var($company_info, 'address', array());
    $address = count($address_arr) > 0 ? $address_arr[0] : array();
    $street = $address['street'] ? $address['street'] : '';
    $line_2 = $address['city'] ? $address['city'] : '';
    $line_2 .= $address['state'] ? ', ' . $address['state'] : '';
    $line_2 .= $address['zipcode'] ? ' ' . $address['zipcode'] : '';
    $country_name = $address['country_name'] ? $address['country_name'] : '';
    // Get email
    $email_arr = array_var($company_info, 'email', array());
    $email = count($email_arr) > 0 ? $email_arr[0] : array();
    $email = $email['email'] ? $email['email'] : '';
    // Get website
    $website_arr = array_var($company_info, 'website', array());
    $website = count($website_arr) > 0 ? $website_arr[0] : array();
    $website = $website['url'] ? $website['url'] : '';
    // Get phone
    $phone_arr = array_var($company_info, 'phone', array());
    $phone = count($phone_arr) > 0 ? $phone_arr[0] : array();
    $phone = $phone['number'] ? $phone['number'] : '';


    echo '<article class="flexContent w-100">
      <div class="flexContent w-50">
        <div class="reportLogo cell">
          <img src="'.$company_picture_url. '" alt="company logo" />
        </div>
        <div class="companyInformation cell">
          <ul class="companyListData">';
    
    if ($name) echo '<li>'.$name.'</li>';
    if ($street) echo '<li>'.$street.'</li>';
    if ($line_2) echo '<li>'.$line_2.'</li>';
    if ($country_name) echo '<li>'.$country_name.'</li>';
    if ($email) echo '<li>'.$email.'</li>';
    if ($website) echo '<li>'.$website.'</li>';
    if ($phone) echo '<li>'.$phone.'</li>';

    echo '</ul>
        </div>
      </div>
      <div class="cell font-semiBold date right w-50">'.$today.'</div>
    </article>';

    echo '<hr class="separatorQuoting" />';
}


function render_project_totals_og($totals, $project_phases){
    $report_data = array_var($_SESSION, 'budget_report_data');
    $group_labor_by = array_var($report_data, 'group_labor_by', 'task');
    $include_hours = array_var($report_data, 'include_hours') == 'checked';

    $count_phases = count($project_phases);
    $colspan = 1;
    if ($include_hours && count($project_phases) > 1) {
        $colspan += $count_phases;
    }
    if ($include_hours) {
        $colspan += 1;
    }
    if ($group_labor_by != 'task') {
        $colspan += 1;
    }
    $header_colspan = $colspan + 1;

    $currency_sym = config_option('currency_code');
    $subtotal = $totals['subtotal'];
    $grand_total = $totals['grand_total'];

    //echo '<thead class="table-separator"><tr><td></td></tr></thead>';
    echo '<table class="tableData radiusItem w-100">';
    echo '<thead class="table-name table-name--totals"><tr><th colspan='.$header_colspan.'>'.lang('totals').'</th></tr></thead>';
    echo '<tbody class="grand-total">';
    echo '<tr><td colspan="'.$colspan.'">'.strtoupper(lang('subtotal')).'</td><td class="report-number">'.format_money_amount($subtotal, $currency_sym).'</td></tr>';
    if($totals['include_taxes']) {
        $taxes = $totals['taxes'];
        foreach($taxes as $tax_info){
            if(!is_array($tax_info) || !$tax_info['is_tax']) continue;
            $tax_amount = $tax_info['amount'];
            $tax_name = $tax_info['name'] . ' (' . format_amount($tax_info['rate']) . '%)';
            echo '<tr><td colspan="'.$colspan.'">'.$tax_name.'</td><td class="report-number">'.format_money_amount($tax_amount, $currency_sym).'</td></tr>';
        }
    }
    echo '<tr><td colspan="'.$colspan.'">'.strtoupper(lang('total')).'</td><td class="report-number">'.format_money_amount($grand_total, $currency_sym).'</td></tr>';
    echo '</tbody>';
    echo '</table>';
    

}

echo '<link rel="stylesheet" href="' . ROOT_URL . '/plugins/project_reports/public/assets/css/project_quoting.css">';
echo '<div class="project_quoting_report">';

$count_phases = count($project_phases);
$colspan = 4 + $count_phases;

if ($show_main_information_blocks) {
    if ($project_member instanceof Member) {
        $properties_array = '';
        $params =  array(
                'member' => $project_member,
                'visible_by_default' => true,
                'return_as_array' => true,
        );
        Hook::fire('override_render_properties_for_view', $params, $properties_array);
        
        render_project_report_main_information($project_member, $properties_array, $colspan);
    }
}

render_organization_information_for_budget_report();

render_project_information_for_budget_report($data, $report_data);

foreach($projects_data as $project_data){
    if($list_subprojects && !($project_member->getObjectId() == $project_data['project_object_id'])){
        echo '<thead class="report-title"><tr><td colspan="'.$colspan.'"><span style="color: #999; margin-right: 15px;">'.lang($project_data['project_object_type_name']).'</span>'.$project_data['project_name'].'<span style="font-size: 13px; padding-left: 13px;">'.$project_data['project_id'].'</span></td></tr></thead>';
    }
    $labor_subtotal = $project_data['labor_summary']['subtotal_amount'];
    $labor_hours = $project_data['labor_summary']['subtotal_hours'];
    if($labor_subtotal > 0 || $labor_hours > 0) {
        render_labor_table($project_data, $project_phases);
    }
    $expenses_subtotal = $project_data['expenses_summary']['subtotal_amount'];
    if ($expenses_subtotal > 0) {
        render_expenses_table($project_data, $project_phases);
    }
}
render_project_totals($totals, $project_member, $data);


$today = DateTimeValueLib::now();
$tz_offset = Timezones::getTimezoneOffsetToApply(Objects::instance()->findById($project_member->getObjectId()));
$today = $today->add('s', $tz_offset)->beginningOfDay();
$date_format = user_config_option('date_format');
$dateValue = $today->format($date_format);
echo '<p style="margin-top: 20px; text-align: right; color: #999; font-size: 12px;">'.$dateValue.'</date>';

echo '</div>';

