<?php
echo stylesheet_tag("og/reporting.css");
require_javascript("og/ReportingFunctions.js");
$genid = gen_id();
if (!isset($conditions)) $conditions = array();

$report_data = array_var($_SESSION, 'gross_margin_report_data');
$report_key = 'gross_margin_report'.Timeslots::instance()->getObjectTypeId();
$report = Reports::instance()->findOne(array("conditions" => "`code` = 'gross_margin_report'"));
$report_title = $report->getObjectName();
$report_id = $report->getId();
?>
<style>
	.coInputMainBlock label{min-width: 270px;}
</style>
<form style='height:100%;background-color:white' class="internalForm" action="<?php echo get_url('project_reports', 'gross_margin_report') ?>" method="post" enctype="multipart/form-data">
<input type="hidden" id="<?php echo $genid?>report[report_object_type_id]" name="report[report_object_type_id]" value="<?php echo Timeslots::instance()->getObjectTypeId()?>"/>
<input type="hidden" id="<?php echo $genid?>report[report_id]" name="report[report_id]" value="<?php echo $report_id ?>"/>
<input type="hidden" id="<?php echo $genid?>report[report_title]" name="report[report_title]" value="<?php echo $report_title ?>"/>


<div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo $title; ?>
	</div>
</div>
<div class="coInputSeparator"></div>
<div class="coInputMainBlock">
    
    <input type="hidden" id="report[date_type]" name="report[date_type]" value="7" />
    <div class="dataBlock">
        <label for="report[start_value]"><?php echo lang('start month') ?>:</label>

        <input type="month" id="start_value" name="report[start_value]" min="2000-01" value="<?php echo array_var($report_data, 'start_value') ?>" />

    </div>

    <div class="dataBlock" style="margin-top: 10px;">
        <label for="report[end_value]"><?php echo lang('end month') ?>:</label>

        <input type="month" id="end_value" name="report[end_value]" min="2000-01" value="<?php echo array_var($report_data, 'end_value') ?>" />

    </div>

    <!-- Revenue options -->
    <?php
        $revenue_options = array(
            array('earned_value', lang('earned value')),
            array('invoiced', lang('invoiced'))
        );
    ?>

    <div class="dataBlock">
        <label><?php echo lang('for actual revenue use') ?>:</label>
        <?php echo simple_select_box('report[revenue]', $revenue_options, array_var($report_data, 'revenue'))?>
    </div>


    <!-- Report for options -->
    <?php
        $report_options = array();
        $used_dimensions = array();

        // Project dimension
        $project_dim = Dimensions::findByCode('customer_project');
        if($project_dim instanceof Dimension) {
            $report_options[] = array('project_dim', $project_dim->getName());
            $used_dimensions['project_dim'] = $project_dim;
        }

        // Client dimension
        $client_dim = Dimensions::findByCode('customers');
        if($client_dim instanceof Dimension) {
            $report_options[] = array('client_dim', $client_dim->getName());
            $used_dimensions['client_dim'] = $client_dim;
        }

        $report_options[] = array('all', lang('whole company'));
    ?>

    <div class="dataBlock">
        <label><?php echo lang('report for') ?>:</label>
        <?php echo simple_select_box('report[report_for]', $report_options, array_var($report_data, 'report_for'), array('id' => 'report_for_selector', 'onchange' => 'og.show_correct_dimension_selector()'))?>
    </div>

    <?php foreach($report_options as $option) {
        $dim_name = $option[0];
        if(strpos($dim_name, '_dim')) {
            $dim = $used_dimensions[$dim_name];
            $selected_mem_id = json_decode(array_var($report_data, $dim_name.'_id')); ?>
            <div class="dataBlock" id="<?php echo $dim_name; ?>_container">  
                <?php
                    render_single_member_selector($dim, $genid . $dim_name, $selected_mem_id, array('is_multiple' => false, 'hidden_field_name' => 'report['.$dim_name.'_id]', 'is_required' => true));
                ?>
            </div>
            <?php
        }
    }
    ?> 

<br/>
<?php echo submit_button(lang('generate report'),'s',array('onclick'=>'og.setMemoryFilttersReport(this,"'.$report_key.'")','style'=>'margin-top:0px;')) ?>
</div>
</div>

</form>
<script>
	og.loadFiltersReport("<?php echo $report_key; ?>");
   
	og.show_correct_dimension_selector = function () {
        $('*[id*=_container]').hide();
        $('#' + $('#report_for_selector').val() + '_container').show();
	}
	
	og.show_correct_dimension_selector();
</script>