<?php
echo stylesheet_tag("og/reporting.css");
require_javascript("og/ReportingFunctions.js");
$genid = gen_id();
if (!isset($conditions)) $conditions = array();

$report_data = array_var($_SESSION, 'project_management_report_data');
$enabled_dimensions = config_option('enabled_dimensions');
$report_key = 'project_billing_alt_report'.Timeslots::instance()->getObjectTypeId();
$projects_dim = Dimensions::findByCode('customer_project');
$has_project_selected = false;
$project_billing_report = Reports::instance()->findOne(array("conditions" => "`code` = 'project_billing_alt_report'"));
$report_title = $project_billing_report->getObjectName();
$report_id = $project_billing_report->getId();
?>
<style>
	.coInputMainBlock label{min-width: 270px;}
</style>
<form style='height:100%;background-color:white' class="internalForm" action="<?php echo get_url('project_reports', 'project_management_report') ?>" method="post" enctype="multipart/form-data">
<input type="hidden" id="<?php echo $genid?>report[report_object_type_id]" name="report[report_object_type_id]" value="<?php echo Timeslots::instance()->getObjectTypeId()?>"/>
<input type="hidden" id="<?php echo $genid?>report[report_id]" name="report[report_id]" value="<?php echo $report_id ?>"/>
<input type="hidden" id="<?php echo $genid?>report[report_title]" name="report[report_title]" value="<?php echo $report_title ?>"/>

<div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo $title; ?>
	</div>
</div>
<div class="coInputSeparator"></div>
<div class="coInputMainBlock">
	
	<?php if (count(active_context_members(false)) > 0) : ?>
	<div style="margin-bottom: 15px; padding-bottom: 5px; border-bottom:1px dotted #aaa;">
		<h5><?php echo lang('showing information for')?>:</h5>
		<ul>
		<?php
			$context = active_context();
			foreach ($context as $selection) {
				if ($selection instanceof Member) { 
					if($selection->getDimensionId() == $projects_dim->getId()) $has_project_selected = true;
					?>
					<li><span class="coViewAction <?php echo $selection->getIconClass()?>"><?php echo $selection->getName()?></span></li>					
		<?php 
				}
			}
		?>
		</ul>
	</div>
	<?php else: ?>
	<div style="padding:5px;"></div>
	<?php endif; 
	
	$projects_dim = Dimensions::findByCode('customer_project');
	render_single_member_selector($projects_dim, $genid, active_context_members(false), array('is_multiple' => false, 'hidden_field_name' => 'report[project_member_ids]'));
	?>



	<div class="dataBlock">		
		<table> 
			<tr>
				<td class="label" style="min-width: 270px; padding-right: 20px;"><?php echo lang("date range") ?>:&nbsp;</span></td>
				<td align='left'><?php 
					echo select_box('report[date_type]', array(
						option_tag(lang('today'), 1, array_var($report_data, "date_type") == 1 ? array('selected' => 'selected'):null),
						option_tag(lang('this week'), 2, array_var($report_data, "date_type") == 2 ? array('selected' => 'selected'):null),
						option_tag(lang('last week'), 3, array_var($report_data, "date_type") == 3 ? array('selected' => 'selected'):null),
						option_tag(lang('this month'), 4, array_var($report_data, "date_type") == 4 ? array('selected' => 'selected'):null),
						option_tag(lang('last month'), 5, array_var($report_data, "date_type") == 5 ? array('selected' => 'selected'):null),
						option_tag(lang('select dates...'), 6, array_var($report_data, "date_type") == 6 ? array('selected' => 'selected'):null)
					), array('onchange' => 'og.dateselectchange(this)'));
				?></td>
			</tr>
			<?php
				if (array_var($report_data, "date_type") == 6) {
					$style = "";
					$st = DateTimeValueLib::dateFromFormatAndString(user_config_option('date_format'), array_var($report_data, 'start_value'));
					$et = DateTimeValueLib::dateFromFormatAndString(user_config_option('date_format'), array_var($report_data, 'end_value'));
				} else {
					$style = 'display:none;';
					$st = DateTimeValueLib::now();
					$et = $st;
				} 
			?>
			<tr class="dateTr" style="<?php echo $style ?>">
				<td class="label"><?php echo lang("start date") ?>:&nbsp;</span></td>
				<td align='left'><?php echo pick_date_widget2('report[start_value]', $st, $genid);?></td>
			</tr>
			<tr class="dateTr" style="<?php echo $style ?>">
				<td class="label"><?php echo lang("end date") ?>:&nbsp;</span></td>
				<td align='left'><?php echo pick_date_widget2('report[end_value]', $et, $genid);?></td>
			</tr>
		</table>
	</div>		

	<div class="dataBlock">
		<label><?php echo lang('include main project information')?></label>
		<?php echo checkbox_field('report[show_main_project_info]', array_var($report_data, 'show_main_project_info'))?>
	</div>
	
	<div class="dataBlock">
		<label><?php echo lang('include subprojects information')?></label>
		<?php echo checkbox_field('report[include_subproject_info]', array_var($report_data, 'include_subproject_info'))?>
	</div>

	<div class="dataBlock">
		<label><?php echo lang('show billing period')?></label>
		<?php echo checkbox_field('report[show_billing_period]', array_var($report_data, 'show_billing_period'))?>
	</div>

	<div class="dataBlock">
		<label><?php echo lang('show project\'s client and start date')?></label>
		<?php echo checkbox_field('report[show_client_and_start_date]', array_var($report_data, 'show_client_start_date'))?>
	</div>
	
	<?php 
		if(Plugins::instance()->isActivePlugin('income')){
			$report_invoiced_breakdown = array(array('all_regular', lang('all')), array('all_billable_only', lang('all (billable only)')), array('invoiced', lang('invoiced')), array('pending_all', lang('unbilled')), array('pending_only', lang('unbilled (billable only)'))); 
		$attributes = array('onchange' => 'og.hide_report_form_options()', 'id' => 'billing_report_invoice_status');
	?>
	<div class="dataBlock" id="invoice_status">
		<label><?php echo lang('time and expenses invoicing status')?></label>
		<?php echo simple_select_box('report[invoice_status]', $report_invoiced_breakdown, array_var($report_data, 'invoice_status'), $attributes)?>
	</div>

	<div class="dataBlock" id='include_invoicing_details'>
		<label><?php echo lang('include invoicing details')?></label>
		<?php echo checkbox_field('report[include_invoicing_details]', array_var($report_data, 'include_invoicing_details'))?>
	</div>
	<?php } ?>


	<?php 
		$miles_cp = CustomProperties::getCustomPropertyByCode(Timeslots::instance()->getObjectTypeId(), 'miles');
		if ($miles_cp instanceof CustomProperty) { ?>
		<div class="dataBlock">
			<label><?php echo lang('include miles')?></label>
			<?php echo checkbox_field('report[include_miles]', array_var($report_data, 'include_miles'))?>
		</div>
	<?php } ?>

	<?php 
	$has_budget_total_cp = false;
	$project_object_type = ObjectTypes::instance()->findOne(array("conditions" => "`name`='project'"));
	if($project_object_type instanceof ObjectType){
		$cp_object_type_id = $project_object_type->getId();
		$budget_custom_property = CustomProperties::instance()->findOne(array('conditions' => '`object_type_id`='.$cp_object_type_id. ' AND `code`="budget_total"'));
		if($budget_custom_property instanceof CustomProperty){
			$has_budget_total_cp = true;
		}
	}
	
	if($has_budget_total_cp){
		$columns_budget_select_array = array(array('none', lang('none')), array('tasks_expenses', lang('sum of budgeted tasks + expenses')), array('budget_total_cp', $budget_custom_property->getName()));
	} else {
		$columns_budget_select_array = array(array('none', lang('none')), array('tasks_expenses', lang('sum of budgeted tasks + expenses')));
	}
	?>
	<div class="dataBlock">
		<label><?php echo lang('for budget, use')?>:</label>
		<?php echo simple_select_box('report[for_budget_use]', $columns_budget_select_array, array_var($report_data, 'for_budget_use'))?>
	</div>
	
	<div class="dataBlock">
		<label><?php echo lang('include billing rate name')?></label>
		<?php echo checkbox_field('report[include_billing_rate_name]', array_var($report_data, 'include_billing_rate_name'))?>
	</div>

	<div class="dataBlock">
		<label><?php echo lang('insert page break for each project')?></label>
		<?php echo checkbox_field('report[project_page_break]', array_var($report_data, 'project_page_break'))?>
	</div>

	<?php
	$rate_sched_dim = Dimensions::findByCode('rate_schedules');
	if($rate_sched_dim instanceof Dimension && in_array($rate_sched_dim->getId(), $enabled_dimensions)){
	?>
	<div class="dataBlock">
		<label><?php echo lang('include ') . strtolower($rate_sched_dim->getName()) ?></label>
		<?php echo checkbox_field('report[include_rate_schedule]', array_var($report_data, 'include_rate_schedule'))?>
	</div>
	<?php } ?>

	<?php
	$approval_status = Dimensions::findByCode('status_timesheet');
	if($approval_status instanceof Dimension && in_array($approval_status->getId(), $enabled_dimensions)){
	?>
	<div class="dataBlock">
		<label><?php echo lang('include ') . strtolower($approval_status->getName()) ?></label>
		<?php echo checkbox_field('report[include_approval_status]', array_var($report_data, 'include_approval_status'))?>
	</div>
	<?php } ?>

	<?php
	$modules_dim = Dimensions::findByCode('modules');
	if($modules_dim instanceof Dimension && in_array($modules_dim->getId(), $enabled_dimensions)){
	?>
	<div class="dataBlock">
		<label><?php echo lang('include ') . strtolower($modules_dim->getName()) ?></label>
		<?php echo checkbox_field('report[include_modules_dim]', array_var($report_data, 'include_modules_dim'))?>
	</div>
	<?php } ?>

	<?php 
	$sort_projects_options_array = array(array('project_name', lang('project name')), array('client_name', lang('client name')));
	?>
	<div class="dataBlock">
		<label><?php echo lang('sort projects by')?></label>
		<?php echo simple_select_box('report[sort_projects_by]', $sort_projects_options_array, array_var($report_data, 'sort_projects_by'))?>
	</div>


	
<br/>
<?php echo submit_button(lang('generate report'),'s',array('onclick'=>'og.setMemoryFilttersReport(this,"'.$report_key.'")','style'=>'margin-top:0px;')) ?>
</div>
</div>

</form>
<script>
	og.loadFiltersReport("<?php echo $report_key; ?>", "<?php echo $has_project_selected; ?>");
	
	og.hide_report_form_options = function () {
		var invoice_status = document.getElementById('billing_report_invoice_status');
		if (invoice_status.value == 'all_regular' || invoice_status.value == 'all_billable_only'){
			$('#include_invoicing_details').show();
		} else {
			$('#include_invoicing_details').hide();
		}
	}
	
	og.hide_report_form_options();
</script>