<?php
echo stylesheet_tag("og/reporting.css");
require_javascript("og/ReportingFunctions.js");
$genid = gen_id();
if (!isset($conditions)) $conditions = array();

$project_ot = ObjectTypes::findByName('project');
$projects_dim = Dimensions::findByCode('customer_project');

$report_data = array_var($_SESSION, 'project_detail_jdt_report_data');
$report_key = 'project_detail_jdt_report_'.Timeslots::instance()->getObjectTypeId();
?>
<form style='height:100%;background-color:white' class="internalForm" action="<?php echo get_url('project_reports', 'project_detail_jdt_report') ?>" method="post" enctype="multipart/form-data">

<input type="hidden" id="<?php echo $genid?>report[report_object_type_id]" name="report[report_object_type_id]" value="<?php echo Timeslots::instance()->getObjectTypeId()?>"/>

<div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo $title; ?>
	</div>
</div>
<br />
<div class="coInputSeparator"></div>

<div class="coInputMainBlock">

	<div class="dataBlock">
		
		<table class="ar-ledger-report-params">
			<tr>
				<td class="label"><span class="bold"><?php echo $project_ot->getObjectTypeName(); ?>:&nbsp;</span></td>
				<td align='left'><?php 
					render_single_member_selector($projects_dim, $genid, active_context_members(false), array('is_multiple' => false, 'is_required' => true, 'hide_label'=>true, 'hidden_field_name' => 'report[project_member_id]'));
				?></td>
			</tr>
			<tr>
				<td class="label"><span class="bold"><?php echo lang('include expenses') ?>:&nbsp;</span></td>
				<td align='left'><?php 
					$include_expenses = array_var($report_data, 'include_expenses', true);
					echo checkbox_field('report[include_expenses]', $include_expenses);
				?></td>
			</tr>
		</table>
	</div>

	<?php echo submit_button(lang('generate report'),'s',array('onclick'=>'og.setMemoryFilttersReport(this,"'.$report_key.'")','style'=>'margin-top:0px;')) ?>
</div>


</form>
<script>
	og.loadFiltersReport("<?php echo $report_key; ?>");
</script>