<?php
echo stylesheet_tag("og/reporting.css");
require_javascript("og/ReportingFunctions.js");
$genid = gen_id();
if (!isset($conditions)) $conditions = array();

$report_data = array_var($_SESSION, 'utilization_report_data');
?>
<form style='height:100%;background-color:white' class="internalForm" action="<?php echo get_url('project_reports', 'utilization_report') ?>" method="post" enctype="multipart/form-data">

<input type="hidden" id="<?php echo $genid?>report[report_object_type_id]" name="report[report_object_type_id]" value="<?php echo Timeslots::instance()->getObjectTypeId()?>"/>

<div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo $title; ?>
	</div>
</div>
<div class="coInputSeparator"></div>

<div class="coInputMainBlock">

	<div class="dataBlock">
		
		<table class="utilization-report-params">
			<tr>
				<td class="label"><?php echo lang("date range") ?>:&nbsp;</span></td>
				<td align='left'><?php 
					echo select_box('report[date_type]', array(
						option_tag(lang('today'), 1, array_var($report_data, "date_type") == 1 ? array('selected' => 'selected'):null),
						option_tag(lang('this week'), 2, array_var($report_data, "date_type") == 2 ? array('selected' => 'selected'):null),
						option_tag(lang('last week'), 3, array_var($report_data, "date_type") == 3 ? array('selected' => 'selected'):null),
						option_tag(lang('this month'), 4, array_var($report_data, "date_type") == 4 ? array('selected' => 'selected'):null),
						option_tag(lang('last month'), 5, array_var($report_data, "date_type") == 5 ? array('selected' => 'selected'):null),
						option_tag(lang('select dates...'), 6, array_var($report_data, "date_type") == 6 ? array('selected' => 'selected'):null)
					), array('onchange' => 'og.dateselectchange(this)'));
				?></td>
			</tr>
			<?php
				if (array_var($report_data, "date_type") == 6) {
					$style = "";
					$st = DateTimeValueLib::dateFromFormatAndString(user_config_option('date_format'), array_var($report_data, 'start_value'));
					$et = DateTimeValueLib::dateFromFormatAndString(user_config_option('date_format'), array_var($report_data, 'end_value'));
				} else {
					$style = 'display:none;';
					$st = DateTimeValueLib::now();
					$et = $st;
				} 
			?>
			<tr class="dateTr" style="<?php echo $style ?>">
				<td class="label"><span class="bold"><?php echo lang("start date") ?>:&nbsp;</span></td>
				<td align='left'><?php echo pick_date_widget2('report[start_value]', $st, $genid);?></td>
			</tr>
			<tr class="dateTr" style="<?php echo $style ?>">
				<td class="label"><span class="bold"><?php echo lang("end date") ?>:&nbsp;</span></td>
				<td align='left'><?php echo pick_date_widget2('report[end_value]', $et, $genid);?></td>
			</tr>
		</table>
	</div>


	<?php 
		$working_days_options = array(array('monday_to_friday', lang('monday to friday')), array('general_option', lang('set in general config option')));
	?>
	<div class="dataBlock" id="working_days_option">
		<label><?php echo lang('working days of the week')?>:</label>
		<?php echo simple_select_box('report[working_days_option]', $working_days_options, array_var($report_data, 'working_days_option'))?>
	</div>

	<div class="dataBlock">
		<label><?php echo lang('include contract hours')?>:</label>
		<?php echo checkbox_field('report[include_contract_hours]', array_var($report_data, 'include_contract_hours'))?>
	</div>

	<div class="dataBlock">
		<label><?php echo lang('exclude users without utilization goal'); ?>:</label>
		<?php echo checkbox_field('report[exclude_users_without_utilization_goal]', array_var($report_data, 'exclude_users_without_utilization_goal'))?>
	</div>

	<?php echo submit_button(lang('generate report'),'s',array('style'=>'margin-top:0px;')) ?>
</div>


</form>
