<?php

/**
 * PropertyGroupPermissions controller
 *
 * @version 1.0
 * @author Alvaro Torterola <alvaro.torterola@fengoffice.com>
 */
class PropertyGroupPermissionsController extends ApplicationController {

	var $plugin_name = "advanced_core";
	
	/**
	 * Construct the PropertyGroupPermissionsController
	 *
	 * @access public
	 * @param void
	 * @return PropertyGroupsController
	 */
	function __construct() {
		parent::__construct();
		prepare_company_website_controller($this, 'website');
		
	} // __construct
	
	
	
	
	function save_property_group_permissions($group_id, $view_permissions, $edit_permissions) {
		
		if (logged_user() instanceof Contact && SystemPermissions::userHasSystemPermission(logged_user(), 'can_manage_configuration')) {
		
			foreach ($view_permissions as $pg_id => $can_view) {
				DB::execute("
				INSERT INTO ".TABLE_PREFIX."property_group_permissions (group_id, permission_group_id, can_view) VALUES
					($group_id, $pg_id, '$can_view')
				ON DUPLICATE KEY UPDATE can_view='$can_view'
				");
			}
			
			foreach ($edit_permissions as $pg_id => $can_edit) {
				DB::execute("
				INSERT INTO ".TABLE_PREFIX."property_group_permissions (group_id, permission_group_id, can_edit) VALUES
					($group_id, $pg_id, '$can_edit')
				ON DUPLICATE KEY UPDATE can_edit='$can_edit'
				");
			}
		}
	}
	
	

} // PropertyGroupsController

