<?php 
	class PropertyGroupPermissions extends BasePropertyGroupPermissions {
		
		
		static function getByGroupAndPg($group_id, $pg_id) {
			return self::instance()->findById(array('group_id' => $group_id, 'permission_group_id' => $pg_id));
		}
		
		static function getByPermissionGroupId($pg_id) {
			return self::instance()->findAll(array('conditions' => 'permission_group_id = ' . $pg_id));
		}
		
		static function getByPropertyGroupId($group_id) {
			return self::instance()->findAll(array('conditions' => 'group_id = ' . $group_id));
		}

		static function deleteByGroup($group_id) {
			return self::instance()->delete(array("group_id = ?", $group_id));
		}
		
		
		static function getPermissionForUserAndGroupId(Contact $user, $property_group_id) {
			
			$p = self::getByGroupAndPg($property_group_id, $user->getPermissionGroupId());
			if (!$p) {
				$p = self::getByGroupAndPg($property_group_id, $user->getUserType());
			}
			
			if ($p) {
				if ($p->getCanEdit()) return 'edit';
				else if ($p->getCanView()) return 'view';
			}
			return 'none';
		}
	}
 