<?php 
	class PropertyGroupPropertiesPermissions extends BasePropertyGroupPropertiesPermissions {
		
		
		static function getByGroupPropAndPg($group_id, $property_id, $pg_id) {
			return self::instance()->findById(array('group_id' => $group_id, 'property_id' => $property_id, 'permission_group_id' => $pg_id));
		}
		
		static function getByPermissionGroupId($pg_id) {
			return self::instance()->findAll(array('conditions' => 'permission_group_id = ' . $pg_id));
		}
		
		static function getByPropertyGroupId($group_id) {
			return self::instance()->findAll(array('conditions' => 'group_id = ' . $group_id));
		}
		
		static function getByPropertyGroupIdAndProperty($group_id, $property_id) {
			return self::instance()->findAll(array('conditions' => 'group_id = ' . $group_id . ' AND property_id = '.$property_id));
		}
		
		static function deleteByGroup($group_id) {
			return self::instance()->delete(array("group_id = ?", $group_id));
		}
		
		static function deleteByGroupAndProp($group_id, $property_id) {
			return self::instance()->delete(array("group_id = ? AND property_id = ?", $group_id, $property_id));
		}
		
		
		static function getPermissionForUserGroupIdAndProperty(Contact $user, $property_group_id, $property_id) {
			
			$p = self::getByGroupPropAndPg($property_group_id, $property_id, $user->getPermissionGroupId());
			if (!$p) {
				$p = self::getByGroupPropAndPg($property_group_id, $property_id, $user->getUserType());
			}
			
			if ($p) {
				if ($p->getCanEdit()) return 'edit';
				else if ($p->getCanView()) return 'view';
				else return 'none';
			}
			
			return null; // if no permission defined for this property -> send null so the caller can decide using the group perm
		}
	}
 