
INSERT INTO `<?php echo $table_prefix ?>object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`) VALUES
 ('purchase_order', 'PurchaseOrders', 'purchase_orders', 'content_object', 'purchase-order', (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='purchase_orders'))
ON DUPLICATE KEY UPDATE id=id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
	SELECT
	 (SELECT `id` FROM `<?php echo $table_prefix ?>dimensions` WHERE `code`='customer_project'), `id`, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='purchase_order'), 0, 1
	FROM `<?php echo $table_prefix ?>object_types`
	WHERE `type` IN ('dimension_object','dimension_group') AND `plugin_id` = (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='crpm')
ON DUPLICATE KEY UPDATE dimension_id=dimension_id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
	SELECT
	 (SELECT `id` FROM `<?php echo $table_prefix ?>dimensions` WHERE `code`='workspaces'), `id`, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='purchase_order'), 0, 1
	FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='workspace'
ON DUPLICATE KEY UPDATE dimension_id=dimension_id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
	SELECT
	 (SELECT `id` FROM `<?php echo $table_prefix ?>dimensions` WHERE `code`='tags'), `id`, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='purchase_order'), 0, 1
	FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='tag'
ON DUPLICATE KEY UPDATE dimension_id=dimension_id;

DELETE FROM `<?php echo $table_prefix ?>dimension_object_type_contents` WHERE `dimension_id`=0 OR dimension_id IS NULL;

INSERT INTO `<?php echo $table_prefix ?>tab_panels` (`id`,`title`,`icon_cls`,`refresh_on_context_change`,`default_controller`,`default_action`,`initial_controller`,`initial_action`,`enabled`,`type`,`ordering`,`plugin_id`,`object_type_id`) VALUES 
 ('purchase-order-panel', 'purchase_orders', 'ico-purchase-orders', 1, 'purchase_order', 'init', '', '', 1, 'system', 11, (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='purchase_orders'), (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='purchase_order')) 
ON DUPLICATE KEY UPDATE id=id;

INSERT INTO `<?php echo $table_prefix ?>tab_panel_permissions` (`permission_group_id`, `tab_panel_id`)
 SELECT `c`.`permission_group_id`, 'purchase-order-panel'
 FROM `<?php echo $table_prefix ?>contacts` `c` WHERE `c`.`user_type` IN (
 	SELECT `id` FROM `<?php echo $table_prefix ?>permission_groups` WHERE `type`='roles' AND `name` IN ('Super Administrator','Administrator','Manager','Executive')
 )
ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;

INSERT INTO <?php echo $table_prefix ?>role_object_type_permissions (role_id, object_type_id, can_delete, can_write) 
 SELECT rtp.role_id, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='purchase_order'), can_delete, can_write
 FROM <?php echo $table_prefix ?>role_object_type_permissions rtp WHERE rtp.object_type_id=(SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>role_object_type_permissions.role_id=<?php echo $table_prefix ?>role_object_type_permissions.role_id;

INSERT INTO <?php echo $table_prefix ?>max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write) 
 SELECT rtp.role_id, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='purchase_order'), can_delete, can_write
 FROM <?php echo $table_prefix ?>max_role_object_type_permissions rtp WHERE rtp.object_type_id=(SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>max_role_object_type_permissions.role_id=<?php echo $table_prefix ?>max_role_object_type_permissions.role_id;

-- add permissions to users where the users already have permissions (copy permissions from tasks)
INSERT INTO <?php echo $table_prefix ?>contact_member_permissions (permission_group_id, member_id, object_type_id, can_delete, can_write)
 SELECT cmp.permission_group_id, cmp.member_id, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='purchase_order'), cmp.can_delete, cmp.can_write 
 FROM <?php echo $table_prefix ?>contact_member_permissions cmp
 WHERE cmp.object_type_id = (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>contact_member_permissions.member_id=<?php echo $table_prefix ?>contact_member_permissions.member_id;

INSERT INTO <?php echo $table_prefix ?>tab_panel_permissions (permission_group_id, tab_panel_id)
 SELECT pg.id, 'purchase-order-panel' FROM <?php echo $table_prefix ?>permission_groups pg WHERE pg.type='roles' AND pg.name IN ('Super Administrator','Administrator','Manager','Executive')
ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;

INSERT INTO `<?php echo $table_prefix ?>custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
	SELECT mt.id, 'Color', 'color_special','color','','','',0,0,30,1, 1, 0
	FROM <?php echo $table_prefix ?>object_types mt WHERE name IN ('supplier')
ON DUPLICATE KEY UPDATE `code`=`code`;

INSERT INTO `<?php echo $table_prefix ?>custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
	SELECT mt.id, 'Description', 'description_special', 'memo','','','',0,0,31,1, 1, 0
	FROM <?php echo $table_prefix ?>object_types mt WHERE name IN ('supplier')
ON DUPLICATE KEY UPDATE `code`=`code`;

