<?php

function render_qbo_entities_simple_table($entities_array, $sub_table = false) {

	$html = '';

	if (empty($entities_array)) {
		$html .= "No entities found";
		return $html;
	}

	$first_obj = $entities_array[0];
	$first_arr = (array) $first_obj;
	$headers = array_keys($first_arr);
	sort($headers);

	// put names and id at first
	if (in_array("DisplayName", $headers)) {
		array_unshift($headers, "DisplayName");
	}
	if (in_array("ViewInvoicesLink", $headers)) {
		array_unshift($headers, "ViewInvoicesLink");
	}
	if (in_array("DocNumber", $headers)) {
		array_unshift($headers, "DocNumber");
	}
	if (in_array("Id", $headers)) {
		array_unshift($headers, "Id");
	}
	if (in_array("FullyQualifiedName", $headers)) {
		array_unshift($headers, "FullyQualifiedName");
	}
	// --

	$table_class = "qbo-entity-table" . ($sub_table ? " sub-table" : " main" );
	$html .= '<table class="'.$table_class.'">';

	$html .= "<thead><tr>";
	foreach ($headers as $header) {
		$html .= "<th>$header</th>";
	}
	$html .= "</tr></thead>";

	
	foreach ($entities_array as $entity) {

		$entity_arr = (array)$entity;
		$html .= "<tr>";

		foreach ($headers as $header) {
			$html .= "<td>". get_qbo_entity_html(array_var($entity_arr,$header,''))."</td>";
		}

		$html .= "</tr>";

	}

	$html .= "</table>";

	return $html;
}


function get_qbo_entity_html($entity_value) {

	$value = '';

	if (is_object($entity_value) || is_array($entity_value)) {
		$value = render_qbo_entities_simple_table(array((array)$entity_value), true);
	} else {
		$value = $entity_value;
	}

	return $value;

}

function get_qbo_obj_table_entity_html($entity_value) {

	$value = '';

	if (is_object($entity_value) || is_array($entity_value)) {
		$value = render_qbo_object_table($entity_value, true);
	} else {
		$value = $entity_value;
	}

	return $value;

}


function render_qbo_object_table($entity, $sub_table = false) {
	$html = '';

	$entity_arr = (array) $entity;
	$headers = array_keys($entity_arr);
	sort($headers);

	$table_class = "qbo-entity-table" . ($sub_table ? " sub-table" : " main" );
	$html .= '<table class="'.$table_class.'">';

	foreach ($headers as $header) {
		$html .= "<tr>";
		$html .= "<th>". $header ."</th>";
		$html .= "<td>". get_qbo_obj_table_entity_html($entity_arr[$header])."</td>";
		$html .= "</tr>";
	}


	$html .= "</table>";

	return $html;
}


function render_qbo_entities_simple_table_pagination($start_pos, $page_size, $base_url, $page_object_count) {

	$end_pos = $start_pos + $page_object_count - 1;

	$html = '<div class="qbo-entity-table-pag">';

	if ($start_pos > 1) {
		$pag_prev_page_link = $base_url . "&start_pos=" . ($start_pos - $page_size);
		$html .= "<span class='pag-item'><a href='$pag_prev_page_link'>Previous page</a></span> - ";
	}

	$html .= "<span class='pag-item'>Showing objects $start_pos to $end_pos</span>";

	if ($page_object_count >= $page_size) {
		$pag_next_page_link = $base_url . "&start_pos=" . ($start_pos + $page_size);
		$html .= " - <span class='pag-item'><a href='$pag_next_page_link'>Next page</a></span>";
	}

	$html .= '</div>';

	return $html;

}