<?php
chdir(dirname(__FILE__));
define("CONSOLE_MODE", true);
define('PUBLIC_FOLDER', 'public');
include "init.php";

@set_time_limit(0);
ini_set("memory_limit", "1G");

// get request parameters
$external_token = trim(array_var($_REQUEST, 'token', ''));
$json_entities = $_REQUEST['entities'];

$valid_user = false;

if ($external_token != '') {
	
	// find token object
	$token_object = ContactExternalTokens::instance()->findByToken($external_token);
	if ($token_object instanceof ContactExternalToken) {
		
		// get the token's owner
		$user = Contacts::instance()->findById($token_object->getContactId());
		
		// check if user is a valid user
		if ($user instanceof Contact && !$user->getDisabled() && $user->getUserType() > 0) {
			$valid_user = true;
			
			try {
				
				// log user in
				CompanyWebsite::instance()->logUserIn($user);
				
				// decode entities string
				$entities = json_decode(base64_decode($json_entities), true);
				
				// call controller function to process the changes
				$qbo_controller = new QuickbooksController();
				$qbo_controller->process_qbo_data_changes($entities);
				
			} catch (Error $e) {
				Logger::log_r("QUICKBOOKS ONLINE WEBHOOK: Error processing entities:\n".$e->getMessage()."\n".$e->getTraceAsString());
			} catch (Exception $e) {
				Logger::log_r("QUICKBOOKS ONLINE WEBHOOK: Error processing entities:\n".$e->getMessage()."\n".$e->getTraceAsString());
			}
			
		}
	}
}

if (!$valid_user) {
	Logger::log_r("QUICKBOOKS ONLINE WEBHOOK: could not update entities because of invalid user.\n".print_r($_REQUEST,1));
}
