<div class="adminConfiguration" style="height:100%;background-color:white">

<form class="internalForm" action="<?php echo get_url('quickbooks','import_invoices_from_qbo') ?>" method="post">
	<input type="hidden" name="submit" value="1"/>
	<input type="hidden" name="action" value="<?php echo $action ?>"/>

	<div class="coInputHeader">
		<div>
			<div class="coInputName">
				<div class="coInputTitle">
					<?php echo lang('import invoices and payments from qbo') ?>
				</div>
			</div>
			<div class="clear"></div>
		</div>
	</div>
		
	<div class="adminMainBlock coInputMainBlock">

	<?php if ($action == 'do_query') { // show the date range form to make the query ?>

		<h1>Select the date range for the invoices that will be imported</h1>

		<div class="dataBlock">
			<label class="bold"><?php echo lang('from_date') ?></label>
			<?php echo pick_date_widget2('from_date', array_var($_SESSION, 'qbo_invoices_import_from'), $genid); ?>
		</div>

		<div class="dataBlock">
			<label class="bold"><?php echo lang('to_date') ?></label>
			<?php echo pick_date_widget2('to_date', array_var($_SESSION, 'qbo_invoices_import_to'), $genid); ?>
		</div>

		<div class="actions">
			<?php echo submit_button(lang('list invoices'), 's') ?>
		</div>
	</div>
	
	<?php } else if ($action == 'import_invoices') { // List the invoices and show the button to import ?>

		<h1>These are the invoices that will be imported (from <?php echo format_date($from_date,null,0)?> to <?php echo format_date($to_date,null,0)?>)</h1>

		<div><?php echo count($qbo_invoices) . " " . lang('invoices') ?></div>
		<div><?php echo count($qbo_payments) . " " . lang('payments') ?></div>

		<?php if (count($qbo_invoices) + count($qbo_payments) > 0) { ?>

		<?php 	if (count($qbo_invoices) > 0) { ?>
			<h1>Invoices</h1>
			<table class="bordered" style="margin:15px 0;">
				<tr>
					<th><?php echo checkbox_field('invoice_check_all', true, array('id' => 'qbo-inv-check-all')) ?></th>
					<th>Date</th><th>Number</th><th>Client/Project</th><th>Amount</th>
				</tr>
				<?php foreach ($qbo_invoices as $qbo_invoice) { 
					$qbo_client = array_var($qbo_clients, $qbo_invoice->CustomerRef);
					?>
				<tr>
					<td><?php echo checkbox_field('selected_invoices['.$qbo_invoice->Id.']', true, array('class'=>'qbo-inv-check', 'id'=>'qbo-inv-check-'.$qbo_invoice->Id)) ?></td>
					<td><?php echo $qbo_invoice->TxnDate ?></td>
					<td><?php echo $qbo_invoice->DocNumber ?></td>
					<td><?php echo $qbo_client ? $qbo_client->FullyQualifiedName : '' ?></td>
					<td><?php echo $qbo_invoice->CurrencyRef ." ". $qbo_invoice->TotalAmt ?></td>
				</tr>
				<?php } ?>
			</table>
		<?php	} ?>

		<?php 	if (count($qbo_payments) > 0) { ?>
			<h1>Payments</h1>
			<table class="bordered" style="margin:15px 0;">
				<tr>
					<th><?php echo checkbox_field('payment_check_all', true, array('id' => 'qbo-pay-check-all')) ?></th>
					<th>Date</th><th>Client/Project</th><th>Amount</th>
				</tr>
				<?php foreach ($qbo_payments as $qbo_payment) { 
					$qbo_client = array_var($qbo_clients, $qbo_payment->CustomerRef);
					?>
				<tr>
					<td><?php echo checkbox_field('selected_payments['.$qbo_payment->Id.']', true, array('class'=>'qbo-pay-check', 'id'=>'qbo-pay-check-'.$qbo_invoice->Id)) ?></td>
					<td><?php echo $qbo_payment->TxnDate ?></td>
					<td><?php echo $qbo_client ? $qbo_client->FullyQualifiedName : '' ?></td>
					<td><?php echo $qbo_payment->CurrencyRef ." ". $qbo_payment->TotalAmt ?></td>
				</tr>
				<?php } ?>
			</table>
		<?php	} ?>

		<div class="desc">This process will import a maximum of <?php echo $max_objects_to_import ?> invoices or payments per run.</div>

		<div class="actions">
			<?php 
				$btn_text = "Import selected invoices and payments";
				echo submit_button($btn_text);
			?>
		</div>
		<script>
			$("#qbo-inv-check-all").change(function() {
				var check_all = $(this).attr('checked') == 'checked';
				if (check_all) {
					$(".qbo-inv-check").attr('checked', 'checked');
				} else {
					$(".qbo-inv-check").removeAttr('checked');
				}
			});
			$("#qbo-pay-check-all").change(function() {
				var check_all = $(this).attr('checked') == 'checked';
				if (check_all) {
					$(".qbo-pay-check").attr('checked', 'checked');
				} else {
					$(".qbo-pay-check").removeAttr('checked');
				}
			});
		</script>

		<?php } ?>

	<?php } ?>

</form>
</div>