<?php

include_once dirname(__FILE__)."/../../../application/helpers/plugin_installer_functions.php";

function quickbooks_get_additional_install_queries($db_connection, $table_prefix) {
	
	$queries = array();

	if (check_is_installed_plugin($db_connection, $table_prefix, 'member_custom_properties')) {
		$queries[] = "
			INSERT INTO `".$table_prefix."member_custom_properties` (`object_type_id`, `name`, `type`, `description`, `values`, `default_value`, `code`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `show_in_lists`, `is_special`) VALUES
				((SELECT id FROM `".$table_prefix."object_types` WHERE name = 'project_type'),'QB Class', 'text', '', '', '', 'qbo_class', 0, 0, 10, 1, 1, 1)
			ON DUPLICATE KEY UPDATE name = name;
		";
		if (check_is_installed_plugin($db_connection, $table_prefix, 'expense_categories')) {
			$queries[] = "
				INSERT INTO `".$table_prefix."member_custom_properties` (`object_type_id`, `name`, `type`, `description`, `values`, `default_value`, `code`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `show_in_lists`, `is_special`) VALUES
					((SELECT id FROM `".$table_prefix."object_types` WHERE name = 'expense_category'),'QB Class', 'text', '', '', '', 'qbo_class', 0, 0, 10, 1, 1, 1)
				ON DUPLICATE KEY UPDATE name = name;
			";
		}
		if (check_is_installed_plugin($db_connection, $table_prefix, 'hour_types')) {
			$queries[] = "
				INSERT INTO `".$table_prefix."member_custom_properties` (`object_type_id`, `name`, `type`, `description`, `values`, `default_value`, `code`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `show_in_lists`, `is_special`, `is_disabled`) VALUES
					((SELECT id FROM `".$table_prefix."object_types` WHERE name = 'hour_type'),'Time Off Code', 'list', '', '', '', 'tsheets_time_off_code', 0, 0, 10, 1, 1, 1, 1)
				ON DUPLICATE KEY UPDATE name = name;
			";
		}		
	}
	if (check_is_installed_plugin($db_connection, $table_prefix, 'expenses2')) {
		$queries[] = "
			ALTER TABLE `".$table_prefix."payment_receipts` 
			ADD `quickbooks_online_id` int(10) NOT NULL DEFAULT '0';
		";
		$queries[] = "
			ALTER TABLE `".$table_prefix."payment_receipts` 
			ADD `quickbooks_online_sync_token` int(10) NOT NULL DEFAULT '0';
		";
		$queries[] = "
			ALTER TABLE `".$table_prefix."payment_receipts` 
			ADD `qbo_reimburse_charge_id` int(10) NOT NULL DEFAULT '0';
		";
		$queries[] = "
			INSERT INTO `".$table_prefix."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
			('quickbooks_online', 'qbo_dimension_for_classes_expenses', COALESCE((SELECT id FROM ". $table_prefix ."dimensions WHERE code='expense_categories'),0), 'SingleDimensionConfigHandler', 0, 0, '', '');
		";
	}
	return $queries;
}

function copy_qbo_callback_file_to_root($filename) {
	@copy(ROOT . "/plugins/quickbooks/application/helpers/$filename", ROOT . "/$filename");
}

$files = array('qbo_callback.php','qbo_webhook_callback.php');
foreach ($files as $file) {
	copy_qbo_callback_file_to_root($file);
}

