<?php
if (isset($risk) && $risk instanceof Risk) {
	if (!$risk->isTrashed()){
		if($risk->canEdit(logged_user())) {
			add_page_action(lang('edit'), "javascript:og.render_modal_form('', {c:'risk', a:'edit', params: {id:".$risk->getId()."}});", 'ico-edit', null, null, true);
			
			if (!$risk->isArchived()) {
				add_page_action(lang('archive'), "javascript:if(confirm(lang('confirm archive object'))) og.openLink('" . $risk->getArchiveUrl() ."');", 'ico-archive-obj');
			} else {
				add_page_action(lang('unarchive'), "javascript:if(confirm(lang('confirm unarchive object'))) og.openLink('" . $risk->getUnarchiveUrl() ."');", 'ico-unarchive-obj');
			}
		}
	}
	if ($risk->canDelete(logged_user())) {
		if ($risk->isTrashed()) {
			add_page_action(lang('restore from trash'), "javascript:if(confirm(lang('confirm restore objects'))) og.openLink('" . $risk->getUntrashUrl() ."');", 'ico-restore', null, null, true);
			add_page_action(lang('delete permanently'), "javascript:if(confirm(lang('confirm delete permanently'))) og.openLink('" . $risk->getDeletePermanentlyUrl() ."');", 'ico-delete', null, null, true);
		} else {
			add_page_action(lang('move to trash'), "javascript:if(confirm(lang('confirm move to trash'))) og.openLink('" . $risk->getTrashUrl() ."');", 'ico-trash', null, null, true);
		}
	}
?>

<div style="padding:7px">
<div class="risk">
<?php
	$content = '';
	
	tpl_assign("content", $content);
	tpl_assign("object", $risk);
	tpl_assign('iconclass', 'ico-large-risk');
	
	$this->includeTemplate(get_template_path('view', 'co'));
?>
</div>
</div>
<?php } ?>
