
og.RiskManager = function() {
	var actions;
	this.doNotRemove = true;
	this.needRefresh = false;
	
	/*this.actual_from_filter = null;
	this.actual_to_filter = null;
	this.actual_status_filter = -1;*/
	
	this.is_loading = false;
	
	this.fields = ['object_id', 'name', 'description', 'dateUpdated', 'memPath'];
	
  	var cps = og.custom_properties_by_type['risk'] ? og.custom_properties_by_type['risk'] : [];
  	var cp_names = [];
  	for (i=0; i<cps.length; i++) {
  		cp_names.push('cp_' + cps[i].id);
  	}
  	this.fields = this.fields.concat(cp_names);
   	
   	var dim_names = [];
   	for (did in og.dimensions_info) {
		if (isNaN(did)) continue;
		dim_names.push('dim_' + did);
	}
   	this.fields = this.fields.concat(dim_names);
  	
	
	if (!og.RiskManager.store) {
		og.RiskManager.store = new Ext.data.Store({
			proxy: new og.GooProxy({
				url: og.getUrl('risk', 'list_all')
			}),
			reader: new Ext.data.JsonReader({
				root: 'risks',
				totalProperty: 'totalCount',
				id: 'id',
				fields: this.fields
			}),
			remoteSort: true,
			listeners: {
				'load': function(store, result) {
					
					var d = this.reader.jsonData;
					this.fireEvent('after list load', "");
					if (d.totalCount == 0) {
						var sel_context_names = og.contextManager.getActiveContextNames();
						if (sel_context_names.length > 0) {
							this.fireEvent('messageToShow', lang("no objects message", lang("risks"), sel_context_names.join(', ')));
						} else {
							this.fireEvent('messageToShow', lang("no more objects message", lang("risks")));
						}
					} else {
						this.fireEvent('messageToShow', "");
					}
					
					var man = Ext.getCmp("risk-manager");
					
					/*if (d.filters.status) {
						var items = [['-1', '-- ' + lang('All') + ' --']];
						for (i=0; i<d.filters.status.length; i++) {
							items[items.length] = [d.filters.status[i].id, d.filters.status[i].name];
						}
						var status_filter = Ext.getCmp('ogObjectivesStatusFilterCombo');
						status_filter.reset();
						status_filter.store.removeAll();
						status_filter.store.loadData(items);
						
						status_filter.setValue(man.actual_status_filter);
						status_filter.collapse();
					}*/
					
					var sm = man.getSelectionModel();
					sm.clearSelections();
					
					og.eventManager.fireEvent('after grid panel load', {man:man, data:d});
					
					if (d && d.totals) {
						man.updateGridPagingToolbar({totalCount: d.totals.total_rows});
					} else {
						man.reloadGridPagingToolbar('risk','list_all','risk-manager');
					}
					man.is_loading = false;
					
					og.eventManager.fireEvent('replace all empty breadcrumb', null);
				}
			}
		});
	}
	this.store = og.RiskManager.store;
	this.store.addListener({messageToShow: {fn: this.showMessage, scope: this}});

	function renderDragHandle(value, p, r, ix) {
		if (r.data.object_id == -1) {
			return '';
		}
		return '<div class="img-grid-drag" title="' + lang('click to drag') + '" onmousedown="var sm = Ext.getCmp(\'risk-manager\').getSelectionModel();if (!sm.isSelected('+ix+')) sm.clearSelections();sm.selectRow('+ix+', true);"></div>';
	}
	
	var readClass = 'read-unread-' + Ext.id();
	function renderName(value, p, r) {
		if (isNaN(r.data.object_id)) {
			return '<span class="bold" id="'+r.data.object_id+'">'+ (value ? og.clean(value) : '') +'</span>';
		}
		
		var text = '<span class="bold">'+ og.clean(value) +'</span>';
		if (r.data.description && r.data.description.length > 0) {
			text += '<span class="desc"> - ' + r.data.description + '</span>';
		}
		
		var onclick = 'og.openLink(og.getUrl(\'risk\', \'view\', {id: '+r.data.object_id+'})); return false;';
		
		var mpath = "";
		if (r.data.memPath){
			var mpath = Ext.util.JSON.decode(r.data.memPath);
		}
		
		return String.format('<a style="font-size:120%;" href="{1}" onclick="{3}" title="{2}">{0}</a>',
				text, og.getUrl('risk', 'view', {id: r.data.object_id}), og.clean(value), onclick);
		
	}
	
	function renderDate(value, p, r) {
		return og.clean(value);
	}

	function renderIcon(value, p, r) {
		if (r.data.object_id == -1) {
			return '';
		}
		return '<div class="link-ico ico-risk"></div>';
	}
	
	function renderAmount(value, p, r) {
		return '<span class="bold">'+ value +'</span>';
	}
	
	function getSelectedIds() {
		var selections = sm.getSelections();
		if (selections.length <= 0) {
			return '';
		} else {
			var ret = '';
			for (var i=0; i < selections.length; i++) {
				ret += "," + selections[i].data.object_id;
			}
			return ret.substring(1);
		}
	}
	this.getSelectedIds = getSelectedIds;
	
	function getFirstSelectedId() {
		var selections = sm.getSelections();
		if (selections.length <= 0) {
			return '';
		} else {
			return selections[0].data.object_id;
		}
		return '';
	}

	var sm = new Ext.grid.CheckboxSelectionModel();
	sm.on('selectionchange', function() {
		if (sm.getCount() <= 0) {
			actions.edit.setDisabled(true);
			actions.del.setDisabled(true);
		} else {
			actions.edit.setDisabled(false);
			actions.del.setDisabled(false);
		}
	});
	
	var cm_info = [
		sm,{
			/*id: 'draghandle',
			header: '&nbsp;',
			dataIndex: 'draghandle',
			width: 18,
        	renderer: renderDragHandle,
        	fixed:true,
        	resizable: false,
        	hideable:false,
        	menuDisabled: true
		},{*/
			id: 'icon',
			header: '&nbsp;',
			dataIndex: 'type',
			width: 28,
        	renderer: renderIcon,
        	fixed:true,
        	resizable: false,
        	hideable:false,
        	menuDisabled: true
		},{
			id: 'name',
			header: lang("name"),
			dataIndex: 'name',
			width: 120,
			renderer: renderName,
			sortable: true
		},{
			id: 'updated_on',
			header: lang("date"),
			dataIndex: 'dateUpdated',
			width: 70,
			renderer: og.clean,
			sortable: true
        }];
	
	    
    // custom property columns
	var cps = og.custom_properties_by_type['risk'] ? og.custom_properties_by_type['risk'] : [];
	this.addCustomPropertyColumns(cps, cm_info, 'risk-manager');

	// dimension columns
	// Commented because if these columns are before the objective columns, when rendering the payments table cells are in the wrong order
	for (did in og.dimensions_info) {
		if (isNaN(did)) continue;
		var key = 'lp_dim_' + did + '_show_as_column';
		if (og.preferences['listing_preferences'][key]) {
			cm_info.push({
				id: 'dim_' + did,
				header: og.dimensions_info[did].name,
				dataIndex: 'dim_' + did,
				sortable: true,
				renderer: og.renderDimCol
			});
			og.breadcrumbs_skipped_dimensions[did] = did;
		}
	}
	
	// create column model
    var cm = new Ext.grid.ColumnModel(cm_info);
    cm.on('hiddenchange', this.afterColumnShowHide, this);
    cm.defaultSortable = false;
		
	actions = {
		newCO: new Ext.Action({
			id: 'new_button_risk',
			text: lang('new'),
            tooltip: lang('add new risk'),
            iconCls: 'ico-new new_button',
            hidden: og.replace_list_new_action && og.replace_list_new_action.risk,
            handler: function() {
				og.render_modal_form('', {c:'risk', a:'add'});
			}
		}),
		edit: new Ext.Action({
			text: lang('edit'),
            tooltip: lang('edit selected object'),
            iconCls: 'ico-edit',
			disabled: true,
			handler: function() {
				og.render_modal_form('', {c:'risk', a:'edit', params: {id:getFirstSelectedId()}});
			},
			scope: this
		}),
		del: new Ext.Action({
			text: lang('move to trash'),
            tooltip: lang('move selected objects to trash'),
            iconCls: 'ico-trash',
			disabled: true,
			handler: function() {
				var confirm_trash_config = parseInt(og.preferences['enableTrashConfirmation']);
				
				if (og.confirmNorification(lang('confirm move to trash', confirm_trash_config))) {
					this.load({
						action: 'delete',
						ids: getSelectedIds()
					});
					this.getSelectionModel().clearSelections();
				}
			},
			scope: this
		})
    };
	
	var uid = Ext.id();
	/*filters = {
		status_filter: new Ext.form.ComboBox({
	    	id: 'ogObjectivesStatusFilterCombo',
	    	store: new Ext.data.SimpleStore({
		        fields: ['value', 'text'],
		        data : []
		    }),
		    displayField:'text',
	        //typeAhead: true,
	        mode: 'local',
	        triggerAction: 'all',
	        selectOnFocus:true,
	        width:160,
	        valueField: 'value',
	        valueNotFoundText: '',
	        listeners: {
	        	'select' : function(combo, record) {
					var man = Ext.getCmp("objective-manager");
					man.actual_status_filter = combo.getValue();
					man.reloadFiltering();
	        	}
	        }
		})
	}*/
    
	var tbar = [];
	if (!og.loggedUser.isGuest) {
		if (og.replace_list_new_action && og.replace_list_new_action.risk) {
			tbar.push(og.replace_list_new_action.risk);
		}
		
		tbar.push(actions.newCO);
		tbar.push('-');
		tbar.push(actions.edit);
		tbar.push(actions.del);
		/*tbar.push('-');
		tbar.push(lang('status'));
		tbar.push(filters.status_filter);*/
		
	}
	
	og.RiskManager.superclass.constructor.call(this, {
		store: this.store,
		layout: 'fit',
		cm: cm,
		enableDrag: true,
		ddGroup: 'MemberDD',
		stateful: og.preferences['rememberGUIState'],
		id: 'risk-manager',
		stripeRows: true,
		closable: true,
		loadMask: true,
		bbar: new og.CurrentPagingToolbar({
			pageSize: og.config['files_per_page'],
			store: this.store,
			displayInfo: true,
			displayMsg: lang('displaying objects of'),
			emptyMsg: lang("no objects to display")

		}),
		viewConfig: {
			forceFit: true
		},
		sm: sm,
		tbar:tbar,
		listeners: {
			'render': {
				fn: function() {
					this.innerMessage = document.createElement('div');
					this.innerMessage.className = 'inner-message';
					var msg = this.innerMessage;
					var elem = Ext.get(this.getEl());
					var scroller = elem.select('.x-grid3-scroller');
					scroller.each(function() {
						this.dom.appendChild(msg);
					});
				},
				scope: this
			},
			'columnmove': {
				fn: function(old_index, new_index) {
					og.eventManager.fireEvent('replace all empty breadcrumb', null);
				},
				scope: this
			}
		}
	});
	
};

Ext.extend(og.RiskManager, Ext.grid.GridPanel, {
	load: function(params) {
		if (!params) params = {};
		var start;
		if (typeof params.start == 'undefined') {
			start = (this.getBottomToolbar().getPageData().activePage - 1) * og.config['files_per_page'];
		} else {
			start = 0;
		}
		
		this.store.baseParams = {
			context: og.contextManager.plainContext()
		};
		
		this.updateColumnModelHiddenColumns();
		
		this.store.removeAll();
		this.store.load({
			params: Ext.apply(params, {
				start: start,
				limit: og.config['files_per_page']				
			})
		});
	},
	
	activate: function() {
		if (this.needRefresh) {
			this.reset();
		}
	},
	
	reset: function() {
		var params = {start:0};
		
		this.load(params);
	},
	
	showMessage: function(text) {
		this.innerMessage.innerHTML = text;
	},
	
	reloadFiltering: function() {
		if (this.isLoading()) return;
		this.is_loading = true;
		
		var config = {
			start:0
		};
		
		this.load(config);
	},
	
	isLoading: function() {
		return this.is_loading;
	},
	
	trashObjects: function() {
		if (confirm(lang('confirm move to trash'))) {
			this.load({
				action: 'delete',
				ids: this.getSelectedIds()
			});
			this.getSelectionModel().clearSelections();
		}
	},
	
	archiveObjects: function() {
		if (confirm(lang('confirm archive selected objects'))) {
			this.load({
				action: 'archive',
				ids: this.getSelectedIds()
			});
			this.getSelectionModel().clearSelections();
		}
	}
});


Ext.reg("risks", og.RiskManager);

/************************************************
Container for RiskManager,
*************************************************/
og.RiskManagerPanel = function() {
	this.doNotRemove = true;
	this.needRefresh = false;
	
	this.manager = new og.RiskManager();
	
	og.RiskManagerPanel.superclass.constructor.call(this, {
		layout: 'fit',
		border: false,
		bodyBorder: false,
		items: [
			this.manager
		],
		closable: true
	});
}

Ext.extend(og.RiskManagerPanel, Ext.Panel, {
	load: function(params) {
		this.manager.load(params);
	},
	activate: function() {
		this.manager.activate();
	},	
	reset: function() {
		this.manager.reset();
	},	
	showMessage: function(text) {
		this.manager.showMessage(text);
	}
});

Ext.reg("risks-containerpanel", og.RiskManagerPanel);

