<?php 
	$genid = gen_id();
	$object = $sales_purchase_order;
	
	// on submit functions
	if (array_var($_REQUEST, 'modal')) {
		$on_submit = "og.submit_modal_form('".$genid."submit-edit-form'); return false;";
	} else {
		$on_submit = "return true;";
	}
	
	$categories = array();
	Hook::fire('object_edit_categories', $object, $categories);

	$main_cp_count = CustomProperties::countVisibleCustomPropertiesByObjectType($object->getObjectTypeId());
	$other_cp_count = CustomProperties::countHiddenCustomPropertiesByObjectType($object->getObjectTypeId());
?>
<form class="add-sales_purchase_order" id="<?php echo $genid ?>submit-edit-form" onsubmit="<?php echo $on_submit?>" action="<?php echo $sales_purchase_order->isNew() ? get_url('sales_purchase_order', 'add') : $sales_purchase_order->getEditUrl() ?>" method="post" enctype="multipart/form-data" >
<div class="sales-purchase-order">
<div class="coInputHeader">

  <div class="coInputHeaderUpperRow">
	<div class="coInputTitle">
		<?php echo $object->getAddEditFormTitle(); ?>
	</div>
  </div>

  <div>
	<div class="coInputName">
	</div>
		
	<div class="coInputButtons">
		<?php echo submit_button($sales_purchase_order->isNew() ? lang('add sales purchase order') : lang('save changes'),'s', array('style'=>'margin-top:0px;margin-left:10px')) ?>
	</div>
	<div class="clear"></div>
  </div>
</div>


<div class="coInputMainBlock">
	
	<input id="<?php echo $genid?>genid" type="hidden" name="genid" value="<?php echo $genid ?>">
	<input id="<?php echo $genid?>updated-on-hidden" type="hidden" name="updatedon" value="<?php echo !$sales_purchase_order->isNew() ? $sales_purchase_order->getUpdatedOn()->getTimestamp() : '' ?>">
	
	<div id="<?php echo $genid?>tabs" class="edit-form-tabs">
	
		<ul id="<?php echo $genid?>tab_titles">
		
			<li><a href="#<?php echo $genid?>add_sales_purchase_order_details"><?php echo lang('details') ?></a></li>
			
			<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
			<li><a href="#<?php echo $genid?>add_custom_properties_div"><?php echo lang('custom properties') ?></a></li>
			<?php } ?>
			
			<li><a href="#<?php echo $genid?>add_subscribers_div"><?php echo lang('object subscribers') ?></a></li>
			
			<?php if($object->isNew() || $object->canLinkObject(logged_user())) { ?>
			<li><a href="#<?php echo $genid?>add_linked_objects_div"><?php echo lang('linked objects') ?></a></li>
			<?php } ?>
			
			<?php foreach ($categories as $category) {
					if (array_var($category, 'hidden')) continue;
				?>
			<li><a href="#<?php echo $genid . $category['name'] ?>"><?php echo $category['name'] ?></a></li>
			<?php } ?>
		</ul>
	
		<div id="<?php echo $genid ?>add_sales_purchase_order_details" class="editor-container form-tab">
	
			<div id="<?php echo $genid ?>add_sales_purchase_order_select_context_div">
				<?php
				$listeners = array('on_selection_change' => 'og.reload_subscribers("'.$genid.'",'.$object->manager()->getObjectTypeId().')');
				if ($object->isNew()) {
					render_member_selectors($object->manager()->getObjectTypeId(), $genid, null, array('select_current_context' => true, 'listeners' => $listeners, 'object' => $object), null, null, false);
				} else {
					render_member_selectors($object->manager()->getObjectTypeId(), $genid, $object->getMemberIds(), array('listeners' => $listeners, 'object' => $object), null, null, false);
				} 
				?>
			</div>
			<div class="clear"></div>

			<div class="dataBlock"><?php
		
				echo label_tag(lang('date'), $genid . 'sales_purchase_orderDate');
				echo pick_date_widget2('sales_purchase_order[date]', $sales_purchase_order->getDate(), $genid);
			
			?></div>
			
			<div class="dataBlock"><table><tr><td><?php
				echo label_tag(lang('ordered by'), $genid . 'sales_purchase_order_ordered_by', false);
			?></td><td>
				<div id="<?php echo $genid?>ordered_by_combo_container"></div>
			  </td></tr></table>
			</div>
			<div class="clear"></div>
			
			<div class="dataBlock"><?php 
				$content_text = $sales_purchase_order->getDescription();
				echo label_tag(lang('description'), $genid . 'sales_purchase_orderFormText', false);
				echo textarea_field('sales_purchase_order[description]', $content_text, array('id' => $genid . 'sales_purchase_orderFormText', 'class' => 'long'));
				
			?></div>
			<div class="clear"></div>

			<?php $null = null; Hook::fire('before_render_main_custom_properties', array('object' => $object), $null);?>
			
			<div class="main-custom-properties-div"><?php
				if ($main_cp_count) {
					echo render_object_custom_properties($object, false, null, 'visible_by_default');
				}
			?></div>
			
		</div>
		
		<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
		<div id="<?php echo $genid ?>add_custom_properties_div" class="form-tab other-custom-properties-div">
			<?php  echo render_object_custom_properties($object, false, null, 'other') ?>
			<?php  echo render_add_custom_properties($object); ?>
		</div>
		<?php } ?>
		
		<div id="<?php echo $genid ?>add_subscribers_div" class="form-tab">
			<div id="<?php echo $genid ?>add_subscribers_content">
				<?php echo render_add_subscribers($object, $genid); ?>
			</div>
		</div>
		
		<?php if($object->isNew() || $object->canLinkObject(logged_user())) { ?>
		<div id="<?php echo $genid ?>add_linked_objects_div" class="form-tab">
			<?php echo render_object_link_form($object) ?>
		</div>
		<?php } // if ?>
	
		<?php foreach ($categories as $category) { ?>
		<div id="<?php echo $genid . $category['name'] ?>" class="form-tab">
			<?php echo $category['content'] ?>
		</div>
		<?php } ?>

	
	<div class="clear"></div>
</div>
	<?php if (!array_var($_REQUEST, 'modal')) {
		echo submit_button($sales_purchase_order->isNew() ? lang('add sales purchase order') : lang('save changes'),'s', array('tabindex' => '20000'));
	}?>
</div>
</form>

<script>
var genid = '<?php echo $genid?>';
$(function(){
	$("#<?php echo $genid?>tabs").tabs();

	var filters = {
		is_user: 1
	};

	og.renderContactSelector({
		genid: genid,
		id: genid + 'sales_purchase_order_ordered_by',
		name: 'sales_purchase_order[ordered_by]',
		render_to: "ordered_by_combo_container",
		listWidth: 300,
		filters: filters,
		selected: <?php echo ($sales_purchase_order->getOrderedBy() > 0 ? $sales_purchase_order->getOrderedBy() : '0')?>,
		selected_name: '<?php echo escape_single_quotes($sales_purchase_order->getOrderedByName())?>'
	});
});
</script>