<?php

if (isset($sales_purchase_order) && $sales_purchase_order instanceof SalesPurchaseOrder) {/* @var $sales_purchase_order SalesPurchaseOrder */
	
	if (!$sales_purchase_order->isTrashed()){
		if($sales_purchase_order->canEdit(logged_user())) {
			add_page_action(lang('edit'), "javascript:og.render_modal_form('', {c:'sales_purchase_order', a:'edit', params: {id:".$sales_purchase_order->getId()."}});", 'ico-edit', null, null, true);
		}
	}
	if ($sales_purchase_order->canDelete(logged_user())) {
		if ($sales_purchase_order->isTrashed()) {
			add_page_action(lang('restore from trash'), "javascript:if(confirm(lang('confirm restore objects'))) og.openLink('" . $sales_purchase_order->getUntrashUrl() ."');", 'ico-restore', null, null, true);
			add_page_action(lang('delete permanently'), "javascript:if(confirm(lang('confirm delete permanently'))) og.openLink('" . $sales_purchase_order->getDeletePermanentlyUrl() ."');", 'ico-delete', null, null, true);
		} else {
			add_page_action(lang('move to trash'), "javascript:if(confirm(lang('confirm move to trash'))) og.openLink('" . $sales_purchase_order->getTrashUrl() ."');", 'ico-trash', null, null, true);
		}
	}
?>

<div style="padding:7px">
<div class="sales-purchase-order">
<?php
	$title = lang('sales purchase order').': '.$sales_purchase_order->getDescription();
	$content = '<table class="sales-purchase-order-data">';
	
	$content .= '<tr><td><span class="bold">'.lang('number').': </span></td><td>'. str_pad($sales_purchase_order->getNumber(), 7, '0', STR_PAD_LEFT) .'</td></tr>';
	$content .= '<tr><td><span class="bold">'.lang('date').': </span></td><td>'. format_date($sales_purchase_order->getDate(), 0, logged_user()->getUserTimezoneHoursOffset()*-1) .'</td></tr>';
	
	$ordered_by_name = $sales_purchase_order->getOrderedByName();
	if ($ordered_by_name != "") {
		$content .= '<tr><td><span class="bold">'.lang('ordered by').': </span></td><td>'.$ordered_by_name.'</td></tr>';
	}

	$content .= '</table>';
	
	$content .= '<div><span class="bold">'.lang('event tickets').': </span></div>';
	$content .= '<div id="'.$genid.'_event_tickets_grid_container" class="event-tickets-grid-container"></div>';
	
	$content .= '<div class="clear"></div>';
	
	tpl_assign("title", $title);
	tpl_assign("content", $content);
	tpl_assign("object", $sales_purchase_order);
	tpl_assign('iconclass', $sales_purchase_order->isTrashed()? 'ico-large-sales-purchase-order-trashed' : ($sales_purchase_order->isArchived() ? 'ico-large-purchser-order-archived' : 'ico-large-purchser-order'));
	
	$this->includeTemplate(get_template_path('view', 'co'));
	
	// include payment grid columns and toolbar configuration
	tpl_assign("genid", $genid);
	$this->includeTemplate(get_template_path('event_tickets_grid/columns', 'sales_purchase_order', 'sales_purchase_orders'));
	$this->includeTemplate(get_template_path('event_tickets_grid/toolbar', 'sales_purchase_order', 'sales_purchase_orders'));
?>
</div>
</div>

<script>

var grid_id = '<?php echo $genid?>_event_tickets_grid';

var ticket_attendees_grid = new og.ObjectGrid({
	renderTo: '<?php echo $genid?>_event_tickets_grid_container',
	url: og.getUrl('event_ticket', 'list_all'),
	store_params: {
		url_controller: 'event_ticket',
		url_action: 'list_all',
		purchase_order_id: <?php echo $sales_purchase_order->getId() ?>
	},
	type_name: 'event_ticket',
	response_objects_root: 'event_tickets',
	grid_id: grid_id,
	nameRenderer: og.gridObjectNameRenderer,
	checkbox_sel_model: true,
	columns: sales_po_columns,
	add_default_actions_column: false,
	no_totals_row: true,
	skip_dimension_columns: true,
	tbar_items: tbar_items,
	stateId: 'po-event-tickets-list', // to remember the gui state independent of the panel
});

ticket_attendees_grid.load();

var active_tab = Ext.getCmp('tabs-panel').activeTab;
if (active_tab.events.resize.listeners.length < 2) {
	active_tab.on('resize', function() {
		var g = Ext.getCmp(grid_id)
		if (g) g.fireEvent('resize');
	});
}


</script>

<?php } //if isset ?>
