<?php
Hook::register("sharepoint_remote_folder");

if (!defined('SCRIPT_TO_CREATE_REMOTE_FOLDER')) {
	define('SCRIPT_TO_CREATE_REMOTE_FOLDER', ROOT . '/create_remote_folder.sh');
}
if (!defined('RMEOTE_FOLDER_CREATION_LOG')) {
	define('RMEOTE_FOLDER_CREATION_LOG', ROOT . '/cache/remote_folder_creation.log');
}

/**
 * Summary of sharepoint_remote_folder_after_member_save_and_commit
 * 
 * @param mixed $params
 * @param mixed $ret
 * @return void
 */
function sharepoint_remote_folder_after_member_save_and_commit($params, &$ret) {
	
	$is_new = array_var($params, 'is_new');
	$member = array_var($params, 'member');
	if (!$member instanceof Member) {
		return;
	}
	
	$dim_id = config_option("dimension_that_generate_folders");
	$project_ot = ObjectTypes::findByName('project');
	if ($dim_id == $member->getDimensionId() && $is_new && $member->getObjectTypeId() == $project_ot->getId()) {
		$folder_name = trim($member->getName());
		$folder_name = preg_replace("/[^a-zA-Z ]/", "", $folder_name);
		
		// remove tabs and extra spaces
		$folder_name = preg_replace('/[ ]{2,}|[\t]/', ' ', trim($folder_name));
		
		if (function_exists("get_prefix_for_object")) {
			$project = Projects::instance()->findById($member->getObjectId());
			if ($project instanceof Project) {
				$prefix_obj = get_prefix_for_object($project);
				if ($prefix_obj instanceof ObjectPrefix) {
					$prefix = $prefix_obj->getPrefix();
					if (!str_starts_with($folder_name, $prefix)) {
						$folder_name = $prefix .OBJECT_PREFIX_SEPARATOR. $folder_name;
					}
				}
			}
		}
		
		Env::useHelper('sharepoint_functions', 'sharepoint_integration');
		create_project_folder_in_sharepoint($folder_name);
	}
	
}
