<?php
/**
 *  SAML Metadata view
 */

if (!defined('ROOT')) {
	$plugin_dir = dirname($_SERVER['SCRIPT_FILENAME']);
	$installation_root = str_replace('plugins/single_sign_on', '', $plugin_dir);
	chdir($installation_root);
	define("CONSOLE_MODE", true);
	define('PUBLIC_FOLDER', 'public');
	include "init.php";
}

// load the library classes
require_once ROOT.'/plugins/single_sign_on/library/php-saml-2.13.0/_toolkit_loader.php';

// load the SSO Settings (generates the $settingsInfo var)
require_once ROOT.'/config/sso.config.php';



$auth = new OneLogin_Saml2_Auth($settingsInfo);

try {
    #$auth = new OneLogin_Saml2_Auth($settingsInfo);
    #$settings = $auth->getSettings();
    // Now we only validate SP settings
    $settings = new OneLogin_Saml2_Settings($settingsInfo, true);
    $metadata = $settings->getSPMetadata();
    $errors = $settings->validateMetadata($metadata);
    if (empty($errors)) {
        header('Content-Type: text/xml');
        echo $metadata;
    } else {
        throw new OneLogin_Saml2_Error(
            'Invalid SP metadata: '.implode(', ', $errors),
            OneLogin_Saml2_Error::METADATA_SP_INVALID
        );
    }
} catch (Exception $e) {
    echo $e->getMessage();
}
