<?php
$plugin_dir = dirname($_SERVER['SCRIPT_FILENAME']);
$installation_root = str_replace('plugins/single_sign_on', '', $plugin_dir);
chdir($installation_root);
define("CONSOLE_MODE", true);
define('PUBLIC_FOLDER', 'public');
include "init.php";

require_once ROOT.'/plugins/single_sign_on/library/php-saml-2.13.0/_toolkit_loader.php';

require_once ROOT.'/config/sso.config.php' ;

$auth = new OneLogin_Saml2_Auth($settingsInfo);


if (isset($_GET['sso'])) {
    $auth->login();
    exit;
}


if (isset($_SESSION) && isset($_SESSION['AuthNRequestID'])) {
    $requestID = $_SESSION['AuthNRequestID'];
} else {
    $requestID = null;
}

$auth->processResponse($requestID);

$errors = $auth->getErrors();

if (!empty($errors)) {
    Logger::log("SSO Errors:");
    Logger::log_r($errors);
}

if (!$auth->isAuthenticated()) {
    Logger::log("SSO Authentication failed:");
}


unset($_SESSION['AuthNRequestID']);



try {
    $username = $auth->getNameId();
    if (preg_match(EMAIL_FORMAT, $username)) {
        $user = Contacts::getByEmail($username);
        if($user instanceof Contact){
            CompanyWebsite::instance()->logUserIn($user, true);
            $ip  = get_ip_address();
            ApplicationLogs::createLog($user,ApplicationLogs::ACTION_LOGIN,false,false,true,'SSO:'.$ip);
            redirect_to(get_url('access', 'index'));
        }
    }
    Logger::log('SSO Login error:');
    Logger::log_r($auth);
    redirect_to(get_url('access', 'index'));
} catch(Exception $e) {
    Logger::log('SSO catch Login error:');
    Logger::log($e->getMessage());
} // try