<?php

include_once dirname(__FILE__)."/../../../application/helpers/plugin_installer_functions.php";


function status_dimension_timesheet_get_additional_install_queries($db_connection, $table_prefix) {
	
	$queries = array();

	if (check_is_installed_plugin($db_connection, $table_prefix, 'advanced_core')) {
	
		include_once dirname(__FILE__)."/../../advanced_core/application/helpers/installer_functions.php";
	
		$prop_groups_queries = get_default_property_groups_queries($db_connection, $table_prefix);
		$queries = array_merge($queries, $prop_groups_queries);
	
	}
	
	if (check_is_installed_plugin($db_connection, $table_prefix, 'expenses2')) {
		$queries[] = "
			INSERT INTO `".$table_prefix."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
			 SELECT
			 	(SELECT `id` FROM `".$table_prefix."dimensions` WHERE `code`='status_timesheet'),
			 	(SELECT `id` FROM `".$table_prefix."object_types` WHERE `name`='status_timesheet'),
			 	`id`, 0, 0
			 FROM `".$table_prefix."object_types`
			 WHERE  `type` IN ('content_object', 'comment', 'located') AND `name` IN ('payment_receipt')
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;";
		
		$queries[] = "
			INSERT INTO ".$table_prefix."contact_member_permissions (permission_group_id, member_id, object_type_id, can_delete, can_write)
			 SELECT cmp.permission_group_id, cmp.member_id, (SELECT `id` FROM `".$table_prefix."object_types` WHERE `name`='payment_receipt'), cmp.can_delete, cmp.can_write 
			 FROM ".$table_prefix."contact_member_permissions cmp
			 WHERE cmp.object_type_id = (SELECT `id` FROM `".$table_prefix."object_types` WHERE `name`='timeslot')
			ON DUPLICATE KEY UPDATE ".$table_prefix."contact_member_permissions.member_id=".$table_prefix."contact_member_permissions.member_id;";
		
		$queries[] = "
			INSERT INTO ".$table_prefix."max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
			SELECT p.id, o.id, 1, 1
			FROM `".$table_prefix."object_types` o JOIN `".$table_prefix."permission_groups` p
			WHERE o.`name` IN ('payment_receipt')
				AND p.`name` IN ('Super Administrator','Administrator','Manager','Executive')
			ON DUPLICATE KEY UPDATE role_id=role_id;";
		
		$queries[] = "
			INSERT INTO ".$table_prefix."role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
			SELECT p.id, o.id, 1, 1
			FROM `".$table_prefix."object_types` o JOIN `".$table_prefix."permission_groups` p
			WHERE o.`name` IN ('payment_receipt')
				AND p.`name` IN ('Super Administrator','Administrator','Manager','Executive')
			ON DUPLICATE KEY UPDATE role_id=role_id;";
	}
	
	if (check_is_installed_plugin($db_connection, $table_prefix, 'income')) {
		$queries[] = "
			INSERT INTO `".$table_prefix."income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
			('invoiced_timeslots_member_id', '', 'MemberConfigHandler', 1, CONCAT('{\"dim_id\":', (SELECT `id` FROM `".$table_prefix."dimensions` WHERE `code`='status_timesheet'), '}'));";
	}
	
	return $queries;

}
?>