<?php

class Statuses extends BaseStatuses {
    
    private $cache = null;
    private $cache_by_code = null;
    
    function getStatus($id) {
        if (is_null($this->cache)) {
            $this->cache = array();
            $statuses = self::instance()->findAll(array('conditions' => 'enabled = 1', 'order' => '`order`'));
            foreach ($statuses as $st) $this->cache[$st->getId()] = $st;
        }
        return array_var($this->cache, $id);
    }
    
    static function getFinalStatus($only_for_expenses=false) {
        $cond = $only_for_expenses ? " AND only_for_expenses=1" : "";
        return self::instance()->findOne(array('conditions' => "is_final=1 $cond"));
    }
    
    function getStatusByCode($code) {
        if (is_null($this->cache_by_code)) {
            $this->cache_by_code = array();
            $statuses = self::instance()->findAll(array('conditions' => 'enabled = 1', 'order' => '`order`'));
            foreach ($statuses as $st) $this->cache_by_code[$st->getCode()] = $st;
        }
        return array_var($this->cache_by_code, $code);
    }
    
    function getAllStatusInfo() {
        $info = array();
        if (is_null($this->cache)) {
            $this->cache = array();
            $statuses = self::instance()->findAll(array('conditions' => 'enabled = 1', 'order' => '`order`'));
            foreach ($statuses as $st) $this->cache[$st->getId()] = $st;
        }
        foreach ($this->cache as $status) {
            $text = $status->getName() == "" ? lang($status->getCode()) : $status->getName();
            $info[] = array(
                'id' => $status->getId(),
                'name' => $text,
                'code' => $status->getCode(),
                'is_final' => $status->getIsFinal(),
                'is_temporal' => $status->getIsTemporal(),
                'order' => $status->getOrder(),
                'only_for_expenses' => $status->getOnlyForExpenses()
            );
        }
        
        return $info;
    }
}
