<?php 
Env::useHelper('chart');

$suppliers_dimension_id = Dimensions::instance()->findByCode('suppliers')->getId();
$supplier_ot = ObjectTypes::instance()->findByName('supplier');
$folder_ot = ObjectTypes::instance()->findByName('folder');

$draw = true;
$parent = null;

$sdot = DimensionObjectTypes::instance()->findOne(array('conditions' => 'dimension_id='.$suppliers_dimension_id.' AND object_type_id='.$supplier_ot->getId()));
if (!$sdot instanceof DimensionObjectType || !$sdot->getEnabled()) {
	$draw = false;
}

if ($draw) {
	$context = active_context();
	foreach ($context as $selection) {
		if ($selection instanceof Member) {
			if ($selection->getDimensionId() != $suppliers_dimension_id) {
				$draw = false;
				break;
			} else {
				$parent = $selection;
				if ($selection->getObjectTypeId() == $supplier_ot->getId()) {
					$draw = false;
				}
				break;
			}
		}
	}
}


if ($draw) {
	
	$limit = 5;
	$start = 0;
	$total = 0;
	
	$suppliers_object_type_id = $supplier_ot->getId();
	$pg_array = logged_user()->getPermissionGroupIds();
	
	$ids = array();
	$current_member_cond = $parent instanceof Member ? "AND parent_member_id=".$parent->getId() : "";
	
	$members = Members::instance()->findAll(array(
		'limit' => $limit,
		'order' => "depth, name",
		'conditions' => "object_type_id=$suppliers_object_type_id $current_member_cond AND archived_by_id=0 AND EXISTS (
			SELECT cmp.member_id FROM ".TABLE_PREFIX."contact_member_cache cmp 
			WHERE cmp.member_id=".TABLE_PREFIX."members.id AND cmp.contact_id='".logged_user()->getId()."'
		)"
	));
	
	if ($parent instanceof Member && count($members) < $limit) {
		$tmp_ids = array();
		foreach ($members as $m) {
			$tmp_ids[] = $m->getId();
		}
		
		$extra_conds = "AND archived_by_id=0 AND EXISTS (
			SELECT cmp.member_id FROM ".TABLE_PREFIX."contact_member_cache cmp 
			WHERE cmp.member_id=".TABLE_PREFIX."members.id AND cmp.contact_id='".logged_user()->getId()."'
		)";

		$childs = $parent->getAllChildren(true, 'name', $extra_conds);
		foreach ($childs as $ch) {
			if (in_array($ch->getId(), $tmp_ids)) continue;
			if ($ch->getObjectTypeId() == $suppliers_object_type_id && count($members) <= $limit) {
				$members[] = $ch;
			}
			if (count($members) >= $limit) break;
		}
	}

	$total = count($members);
	
	$render_add = can_manage_dimension_members(logged_user());
	if ($total > 0 || $render_add) {
		include 'template.php';	
	}
}
