<?php /* @var supplier $supplier */
	$genid = gen_id();
	$row_cls = "";
	$no_objects_text = count($members) > 0 ? '' : lang('you have no suppliers yet');
	
	$dim_id = Dimensions::findByCode('suppliers')->getId();
	$sup_ot = ObjectTypes::findByName('supplier');
	
	$c_name = Members::getTypeNameToShowByObjectType($dim_id, $sup_ot->getId(), null, true);
	$add_button_text = count($members) > 0 ? lang('add new supplier',$c_name) : lang('add your first supplier',$c_name);
		
	$header_color_class = "color-" . (isset($subtype) ? $subtype->getColor() : "1");
?>

<div class="suppliers-widget widget">

	<div style="overflow: hidden;" class="widget-header <?php echo $header_color_class ?>" onclick="og.dashExpand('<?php echo $genid?>');">
		<div class="widget-title"><?php echo isset($widget_title) ? $widget_title : $c_name; ?>&nbsp;</div>
		<div class="view-all-container">
			<a href="#" onclick="og.suppliers.load_suppliers_list_in_new_tab('<?php echo $dim_id?>', '<?php echo $sup_ot->getId()?>', '<?php echo (isset($subtype) ? $subtype->getId() : "0") ?>');"><?php echo lang("view all") ?></a>
		</div>
	</div>
	
	<div class="widget-body" id="<?php echo $genid; ?>_widget_body" >
		
		<div class="supplier-list">
		
			<table class="supplier-list-table">
				<tr>
					<th><?php echo lang('name') ?></th>
					<th><?php echo lang('email') ?></th>
					<th><?php echo lang('address') ?></th>
					<th><?php echo lang('phone number') ?></th>
				</tr>
		
				<?php foreach ($members as $member):
						$supplier = Suppliers::instance()->findById($member->getObjectId());
						if (!$supplier instanceof Supplier) continue;
						
						$name = $member->getDisplayName();
						$phone = '';
						$email = '';
						$address = '';

						$contact = $supplier->getContact();
						if ($contact instanceof Contact) {
							$phone = $contact->getAllPhonesString();
							$emaol = $contact->getAllEmailsString();
							$address = $contact->getAllAddressesString();
						}
				?>
				<tr>
					<td><?php echo $name ?></td>
					<td><?php echo $email ?></td>
					<td><?php echo $address ?></td>
					<td><?php echo $phone ?></td>
				</tr>
				<?php endforeach;?>
			</table>
		</div>
		
		<div class="x-clear"></div>

	</div>
</div>
