og.suppliers = {

	init: function() {

		og.eventManager.addListener('after dimensions info loaded', function(data) {
			
			let suppliers_ot = og.get_object_type_by_name('supplier');
			let suppliers_ot_id = suppliers_ot ? suppliers_ot.id : 0;
			let suppliers_dim_id = 0;
			for (did in og.dimensions_info) {
				if (!isNaN(did) && og.dimensions_info[did].code == "suppliers") {
					suppliers_dim_id = did;
				}
			}

			if (suppliers_dim_id > 0 && suppliers_ot_id > 0) {

				if (!og.listing_member_type_cols) og.listing_member_type_cols = [];
				if (!og.listing_member_type_cols[suppliers_dim_id]) og.listing_member_type_cols[suppliers_dim_id] = [];
				if (!og.listing_member_type_cols[suppliers_dim_id][suppliers_ot_id]) og.listing_member_type_cols[suppliers_dim_id][suppliers_ot_id] = [];
				
				og.listing_member_type_cols[suppliers_dim_id][suppliers_ot_id].push({
					id: 'email',
					name: lang('email'),
					renderer: og.clean,
				});
				og.listing_member_type_cols[suppliers_dim_id][suppliers_ot_id].push({
					id: 'address',
					name: lang('address'),
					renderer: og.clean,
				});
				og.listing_member_type_cols[suppliers_dim_id][suppliers_ot_id].push({
					id: 'phone',
					name: lang('phone number'),
					renderer: og.clean,
				});
			}

		});
	},

	load_suppliers_list_in_new_tab: function(dim_id, type_id, subtype_id) {
		// remove previous projects list
		var p = Ext.getCmp('suppliers_list'); 
		if(p) Ext.getCmp('tabs-panel').remove(p); 
		// load the member list
		og.openLink(og.getUrl('member', 'init', {dim_id:dim_id, type_id:type_id, subtype_id:subtype_id}), {caller:'suppliers_list'});
	},

}