<?php 

function suppliers_update_1_2() {
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
		 SELECT
		 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='suppliers'),
		 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='folder'),
		 	`id`, 0, 1
		 FROM `".TABLE_PREFIX."object_types`
		 WHERE  `type` IN ('content_object', 'comment', 'located') AND `name`<>'quota'
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_types` (`dimension_id`,`object_type_id`,`is_root`,`options`) VALUES 
		(
		   (SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'suppliers'),
		   (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'folder'),
		   1,
		   '{\"defaultAjax\":{\"controller\":\"dashboard\", \"action\": \"main_dashboard\"}}'
		);
	");
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."dimension_object_type_options (`dimension_id`, `object_type_id`, `name`, `value`) VALUES 
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='suppliers'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='folder'),'select_after_creation','0')
		ON DUPLICATE KEY UPDATE `value`=`value`;
	");
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_hierarchies` (dimension_id, parent_object_type_id, child_object_type_id)
		VALUES (
		  (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='suppliers'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'folder'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'folder')
		),(
		  (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='suppliers'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'folder'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'supplier')
		);
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."member_custom_properties (object_type_id, name, code, `type`, `values`, `visible_by_default`, `is_special`) VALUES
		((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='supplier'), 'Company ID', 'company_id', 'text', '', 1, 1),
		((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='supplier'), 'Legal name', 'legal_name', 'text', '', 1, 1);
	");
}

function suppliers_update_2_3() {
	DB::execute("
		UPDATE ".TABLE_PREFIX."dimensions
		SET permission_query_method='mandatory'
		WHERE code='suppliers';

	");

	$rows =  DB::executeAll("
        SELECT o.id
        FROM ".TABLE_PREFIX."objects o
        INNER JOIN ".TABLE_PREFIX."object_members om ON o.id = om.object_id
        INNER JOIN ".TABLE_PREFIX."members m ON m.id=om.member_id
        
        WHERE m.dimension_id=(SELECT id from ".TABLE_PREFIX."dimensions WHERE code='suppliers')
        GROUP BY o.id
	");

	$object_ids = array_flat($rows);
	foreach ($object_ids as $object_id) {
		SharingTables::instance()->fill_sharing_table_by_object($object_id);
	}

}

function suppliers_update_3_4() {

	DB::execute("
		INSERT INTO `".TABLE_PREFIX."tab_panels` (`id`,`title`,`icon_cls`,`refresh_on_context_change`,`default_controller`,`default_action`,`initial_controller`,`initial_action`,`enabled`,`type`,`ordering`,`plugin_id`,`object_type_id`,`url_params`) VALUES 
			('suppliers-panel', 'suppliers', 'ico-contact', 1, 'member', 'init', '', '', 1, 'system', 20, 
			(SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='suppliers'), 
			(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='supplier'), 
			CONCAT('{\"dim_id\":',(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='suppliers'),', \"type_id\":',(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='supplier'),'}') )
		ON DUPLICATE KEY UPDATE id=id;
	");

	DB::execute("
		INSERT INTO ".TABLE_PREFIX."tab_panel_permissions (permission_group_id, tab_panel_id)
		SELECT pg.id, 'projects-panel' FROM ".TABLE_PREFIX."permission_groups pg WHERE pg.type='roles' AND pg.name IN ('Super Administrator','Administrator','Manager','Executive')
		ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;
	");

	DB::execute("
		INSERT INTO ".TABLE_PREFIX."tab_panel_permissions (permission_group_id, tab_panel_id)
		SELECT pg.id, 'projects-panel' FROM ".TABLE_PREFIX."permission_groups pg WHERE pg.type='permission_groups' AND pg.contact_id IN (
			SELECT c.object_id FROM ".TABLE_PREFIX."contacts c WHERE c.user_type IN (SELECT pg.id FROM ".TABLE_PREFIX."permission_groups pg WHERE pg.name IN ('Super Administrator','Administrator','Manager','Executive'))
		)
		ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;
	");

	DB::execute("
		INSERT INTO ".TABLE_PREFIX."widgets (name,title,plugin_id,path,default_options,default_section,default_order,icon_cls) VALUES
		('suppliers','suppliers',(SELECT id FROM ".TABLE_PREFIX."plugins WHERE name='suppliers'),'','','left',20,'ico-contact')
		ON DUPLICATE KEY UPDATE name=name;
	");

}
