<?php
if (isset($ticket) && $ticket instanceof Ticket) {
	if (!$ticket->isTrashed()){
		if($ticket->canEdit(logged_user())) {
			add_page_action(lang('edit'), "javascript:og.render_modal_form('', {c:'ticket', a:'edit', params: {id:".$ticket->getId()."}});", 'ico-edit', null, null, true);
			
			if (!$ticket->isArchived()) {
				add_page_action(lang('archive'), "javascript:if(confirm(lang('confirm archive object'))) og.openLink('" . $ticket->getArchiveUrl() ."');", 'ico-archive-obj');
			} else {
				add_page_action(lang('unarchive'), "javascript:if(confirm(lang('confirm unarchive object'))) og.openLink('" . $ticket->getUnarchiveUrl() ."');", 'ico-unarchive-obj');
			}
		}
	}
	if ($ticket->canDelete(logged_user())) {
		if ($ticket->isTrashed()) {
			add_page_action(lang('restore from trash'), "javascript:if(confirm(lang('confirm restore objects'))) og.openLink('" . $ticket->getUntrashUrl() ."');", 'ico-restore', null, null, true);
			add_page_action(lang('delete permanently'), "javascript:if(confirm(lang('confirm delete permanently'))) og.openLink('" . $ticket->getDeletePermanentlyUrl() ."');", 'ico-delete', null, null, true);
		} else {
			add_page_action(lang('move to trash'), "javascript:if(confirm(lang('confirm move to trash'))) og.openLink('" . $ticket->getTrashUrl() ."');", 'ico-trash', null, null, true);
		}
	}

	if (can_instantiate_templates(logged_user())) {
		$mail_templates = COTemplates::instance()->findAll(array('conditions' => 'can_instance_from_mail>0'));
		if (is_array($mail_templates)) {
			foreach ($mail_templates as $template) {
				$template_id = $template->getId();
				$template_name = $template->getName();

				$template_params = TemplateParameters::getParametersByTemplate($template_id);
				if ($template_params && count($template_params) > 0) {
					$action = 'instantiate_parameters';
				} else {
					$action = 'instantiate';
				}
				$linked_objects = json_encode(array($ticket->getId()));
				$members = json_encode($ticket->getMemberIds());

				$action_url = get_url('template', $action, array('id' => $template_id, 'linked_objects' => $linked_objects, 'additional_member_ids' => $members));
				add_page_action(lang('new')." $template_name", $action_url, 'ico-template', null, null, true);
			}
		}
	}
?>

<div style="padding:7px">
<div class="ticket">
<?php
	$content = '';

	if($ticket->getTypeContent() == "text"){
		$content = escape_html_whitespace(convert_to_links(clean($ticket->getText())));
	}else{
		$content = '<div class="wysiwyg-description">' . convert_to_links(purify_html(nl2br($ticket->getText()))) . '</div>';
	}
	
	tpl_assign("content", $content);
	tpl_assign("object", $ticket);
	tpl_assign('iconclass', 'ico-large-ticket');
	
	$this->includeTemplate(get_template_path('view', 'co'));
?>
</div>
</div>
<?php } ?>
