
og.TicketManager = function() {
	var actions;
	this.doNotRemove = true;
	this.needRefresh = false;
	
	/*this.actual_from_filter = null;
	this.actual_to_filter = null;
	this.actual_status_filter = -1;*/
	
	this.is_loading = false;
	
	this.fields = ['object_id', 'name', 'description', 'dateUpdated', 'updatedBy', 'createdBy', 'dateCreated', 'memPath'];
	
  	var cps = og.custom_properties_by_type['ticket'] ? og.custom_properties_by_type['ticket'] : [];
  	var cp_names = [];
  	for (i=0; i<cps.length; i++) {
  		cp_names.push('cp_' + cps[i].id);
  	}
  	this.fields = this.fields.concat(cp_names);
   	
   	var dim_names = [];
   	for (did in og.dimensions_info) {
		if (isNaN(did)) continue;
		dim_names.push('dim_' + did);
	}
   	this.fields = this.fields.concat(dim_names);
  	
	
	if (!og.TicketManager.store) {
		og.TicketManager.store = new Ext.data.Store({
			proxy: new og.GooProxy({
				url: og.getUrl('ticket', 'list_all')
			}),
			reader: new Ext.data.JsonReader({
				root: 'tickets',
				totalProperty: 'totalCount',
				id: 'id',
				fields: this.fields
			}),
			remoteSort: true,
			listeners: {
				'load': function(store, result) {
					
					var d = this.reader.jsonData;
					this.fireEvent('after list load', "");
					if (d.totalCount == 0) {
						var sel_context_names = og.contextManager.getActiveContextNames();
						if (sel_context_names.length > 0) {
							this.fireEvent('messageToShow', lang("no objects message", lang("tickets"), sel_context_names.join(', ')));
						} else {
							this.fireEvent('messageToShow', lang("no more objects message", lang("tickets")));
						}
					} else {
						this.fireEvent('messageToShow', "");
					}
					
					var man = Ext.getCmp("ticket-manager");
					
					/*if (d.filters.status) {
						var items = [['-1', '-- ' + lang('All') + ' --']];
						for (i=0; i<d.filters.status.length; i++) {
							items[items.length] = [d.filters.status[i].id, d.filters.status[i].name];
						}
						var status_filter = Ext.getCmp('ogObjectivesStatusFilterCombo');
						status_filter.reset();
						status_filter.store.removeAll();
						status_filter.store.loadData(items);
						
						status_filter.setValue(man.actual_status_filter);
						status_filter.collapse();
					}*/
					
					var sm = man.getSelectionModel();
					sm.clearSelections();
					
					og.eventManager.fireEvent('after grid panel load', {man:man, data:d});
					
					if (d && d.totals) {
						man.updateGridPagingToolbar({totalCount: d.totals.total_rows});
					} else {
						man.reloadGridPagingToolbar('ticket','list_all','ticket-manager');
					}
					man.is_loading = false;
					
					og.eventManager.fireEvent('replace all empty breadcrumb', null);
				}
			}
		});
	}
	this.store = og.TicketManager.store;
	this.store.addListener({messageToShow: {fn: this.showMessage, scope: this}});

	function renderDragHandle(value, p, r, ix) {
		if (r.data.object_id == -1) {
			return '';
		}
		return '<div class="img-grid-drag" title="' + lang('click to drag') + '" onmousedown="var sm = Ext.getCmp(\'ticket-manager\').getSelectionModel();if (!sm.isSelected('+ix+')) sm.clearSelections();sm.selectRow('+ix+', true);"></div>';
	}
	
	var readClass = 'read-unread-' + Ext.id();
	function renderName(value, p, r) {
		if (isNaN(r.data.object_id)) {
			return '<span class="bold" id="'+r.data.object_id+'">'+ (value ? og.clean(value) : '') +'</span>';
		}
		
		var text = '<span class="bold">'+ og.clean(value) +'</span>';
		if (r.data.description && r.data.description.length > 0) {
			text += '<span class="desc"> - ' + r.data.description + '</span>';
		}
		
		var onclick = 'og.openLink(og.getUrl(\'ticket\', \'view\', {id: '+r.data.object_id+'})); return false;';
		
		var mpath = "";
		if (r.data.memPath){
			var mpath = Ext.util.JSON.decode(r.data.memPath);
		}
		
		return String.format('<a style="font-size:120%;" href="{1}" onclick="{3}" title="{2}">{0}</a>',
				text, og.getUrl('ticket', 'view', {id: r.data.object_id}), og.clean(value), onclick);
		
	}
	
	/* Go to https://docs.sencha.com/extjs/2.3.0/#!/api/Ext.grid.ColumnModel 
	and search for setRenderer() function to reference renderer functions 
	behavior */

	function renderUpdatedBy(value, metadata, row) {
		if (!value) {
			return "";
		}
		var username = value;
		var linkToUser = og.getUrl('contact', 'card', {id: row.json.updatedById});

		var result = String.format('<a href="{1}" onclick="og.openLink(\'{1}\');return false;">{0}</a>',
								   username,
								   linkToUser);			

		return result;
	}

	function renderUpdatedOn(value, metadata, row) {
		return value ? value : "";
	}

	function renderCreatedBy(value, metadata, row) {
		if (!value) {
			return "";
		}
		var username = value;
		var linkToUser = og.getUrl('contact', 'card', {id: row.json.createdById});
		console.log(row);
		var result = String.format('<a href="{1}" onclick="og.openLink(\'{1}\');return false;">{0}</a>',
									username,
									linkToUser);
								  
		return result;
	}

	function renderCreatedOn(value, metadata, row) {
		return value ? value : "";
	}

	function renderIcon(value, p, r) {
		if (r.data.object_id == -1) {
			return '';
		}
		return '<div class="link-ico ico-ticket"></div>';
	}
	
	function renderAmount(value, p, r) {
		return '<span class="bold">'+ value +'</span>';
	}
	
	function getSelectedIds() {
		var selections = sm.getSelections();
		if (selections.length <= 0) {
			return '';
		} else {
			var ret = '';
			for (var i=0; i < selections.length; i++) {
				ret += "," + selections[i].data.object_id;
			}
			return ret.substring(1);
		}
	}
	this.getSelectedIds = getSelectedIds;
	
	function getFirstSelectedId() {
		var selections = sm.getSelections();
		if (selections.length <= 0) {
			return '';
		} else {
			return selections[0].data.object_id;
		}
		return '';
	}

	var sm = new Ext.grid.CheckboxSelectionModel();
	sm.on('selectionchange', function() {
		if (sm.getCount() <= 0) {
			actions.edit.setDisabled(true);
			actions.del.setDisabled(true);
		} else {
			actions.edit.setDisabled(false);
			actions.del.setDisabled(false);
		}
	});
	
	var cm_info = [
		sm,{
			/*id: 'draghandle',
			header: '&nbsp;',
			dataIndex: 'draghandle',
			width: 18,
        	renderer: renderDragHandle,
        	fixed:true,
        	resizable: false,
        	hideable:false,
        	menuDisabled: true
		},{*/
			id: 'icon',
			header: '&nbsp;',
			dataIndex: 'type',
			width: 28,
        	renderer: renderIcon,
        	fixed:true,
        	resizable: false,
        	hideable:false,
        	menuDisabled: true
		},{
			id: 'name',
			header: lang("name"),
			dataIndex: 'name',
			width: 120,
			renderer: renderName,
			sortable: true
		},{
			id: 'updated_on',
			header: lang("last updated on"),
			dataIndex: 'dateUpdated',
			width: 70,
			renderer: renderUpdatedOn,
			sortable: true
        },{
			id: 'updatedBy',
			header: lang("last updated by"),
			dataIndex: 'updatedBy',
			width: 120,
			renderer: renderUpdatedBy,
			sortable: true
        },{
			id: 'createdBy',
			header: lang("created by"),
			dataIndex: 'createdBy',
			width: 120,
			hidden: true,
			renderer: renderCreatedBy,
			sortable: true
		},{
			id: 'created_on',
			header: lang("created on"),
			dataIndex: 'dateCreated',
			width: 70,
			hidden: true,
			renderer: renderCreatedOn,
			sortable: true
		},];
	
	    
    // custom property columns
	var cps = og.custom_properties_by_type['ticket'] ? og.custom_properties_by_type['ticket'] : [];
	this.addCustomPropertyColumns(cps, cm_info, 'ticket-manager');

	// dimension columns
	// Commented because if these columns are before the objective columns, when rendering the payments table cells are in the wrong order
	for (did in og.dimensions_info) {
		if (isNaN(did)) continue;
		var key = 'lp_dim_' + did + '_show_as_column';
		if (og.preferences['listing_preferences'][key]) {
			cm_info.push({
				id: 'dim_' + did,
				header: og.dimensions_info[did].name,
				dataIndex: 'dim_' + did,
				sortable: true,
				renderer: og.renderDimCol
			});
			og.breadcrumbs_skipped_dimensions[did] = did;
		}
	}
	
	// create column model
    var cm = new Ext.grid.ColumnModel(cm_info);
    cm.on('hiddenchange', this.afterColumnShowHide, this);
    cm.defaultSortable = false;
		
	actions = {
		newCO: new Ext.Action({
			id: 'new_button_ticket',
			text: lang('new'),
            tooltip: lang('add new ticket'),
            iconCls: 'ico-new new_button',
            hidden: og.replace_list_new_action && og.replace_list_new_action.ticket,
            handler: function() {
				og.render_modal_form('', {c:'ticket', a:'add'});
			}
		}),
		edit: new Ext.Action({
			text: lang('edit'),
            tooltip: lang('edit selected object'),
            iconCls: 'ico-edit',
			disabled: true,
			handler: function() {
				og.render_modal_form('', {c:'ticket', a:'edit', params: {id:getFirstSelectedId()}});
			},
			scope: this
		}),
		del: new Ext.Action({
			text: lang('move to trash'),
            tooltip: lang('move selected objects to trash'),
            iconCls: 'ico-trash',
			disabled: true,
			handler: function() {
				var confirm_trash_config = parseInt(og.preferences['enableTrashConfirmation']);
				
				if (og.confirmNorification(lang('confirm move to trash'), confirm_trash_config)) {
					this.load({
						action: 'delete',
						ids: getSelectedIds()
					});
					this.getSelectionModel().clearSelections();
				}
			},
			scope: this
		})
    };
	
	var uid = Ext.id();
	/*filters = {
		status_filter: new Ext.form.ComboBox({
	    	id: 'ogObjectivesStatusFilterCombo',
	    	store: new Ext.data.SimpleStore({
		        fields: ['value', 'text'],
		        data : []
		    }),
		    displayField:'text',
	        //typeAhead: true,
	        mode: 'local',
	        triggerAction: 'all',
	        selectOnFocus:true,
	        width:160,
	        valueField: 'value',
	        valueNotFoundText: '',
	        listeners: {
	        	'select' : function(combo, record) {
					var man = Ext.getCmp("objective-manager");
					man.actual_status_filter = combo.getValue();
					man.reloadFiltering();
	        	}
	        }
		})
	}*/
    
	var tbar = [];
	if (!og.loggedUser.isGuest) {
		if (og.replace_list_new_action && og.replace_list_new_action.ticket) {
			tbar.push(og.replace_list_new_action.ticket);
		}
		
		tbar.push(actions.newCO);
		tbar.push('-');
		tbar.push(actions.edit);
		tbar.push(actions.del);
		/*tbar.push('-');
		tbar.push(lang('status'));
		tbar.push(filters.status_filter);*/
		
	}
	if (og.additional_list_actions && og.additional_list_actions.ticket) {
		tbar.push(' ');
		for (var i=0; i<og.additional_list_actions.ticket.length; i++) {
			tbar.push(og.additional_list_actions.ticket[i]);
		}
	}


	//This part of code need re
    og.filterCustomeProperty = {};
    if(og.custom_properties_by_type){
        var cps = og.custom_properties_by_type['ticket'] ? og.custom_properties_by_type['ticket'] : [];
        for (i=0; i<cps.length; i++) {
            if(cps[i].cp_type == 'list'){
                cp = cps[i];
                //get template for the row
                var source = $("#list-custom-propertie-filter-template").html();
                //compile the template
                var def_value = "";
                if(cp.cp_default_value == 1){
                    def_value = "checked";
                }
                var cp_values = cp.cp_values.split(',');
                displayOptions = new Array();
                for (j=0; j<cp_values.length; j++) {
                    displayOptions.push(
                        {
                            text: _lang[cp_values[j]] ? lang(cp_values[j]) : cp_values[j],
                            value: cp_values[j],
                            checked : false,

                            checkHandler: function (e) {
                                var man = Ext.getCmp("ticket-manager");
                                man.load();
                            }
                        }
                    );
                }
                var cp_filter = new Ext.Action({
                    text: cp.name,
                    id:'filter_custom_propery_'+i,
                    iconCls: 'ico-view_options',
                    disabled: false,
                    customPropertyFilter:true,
                    idCustomeProperty:cps[i].id,
                    menu: {items: displayOptions}
                });
                tbar.push(cp_filter);
            }
        }
    }


	og.TicketManager.superclass.constructor.call(this, {
		store: this.store,
		layout: 'fit',
		cm: cm,
		enableDrag: true,
		ddGroup: 'MemberDD',
		stateful: og.preferences['rememberGUIState'],
		id: 'ticket-manager',
		stripeRows: true,
		closable: true,
		loadMask: true,
		bbar: new og.CurrentPagingToolbar({
			pageSize: og.config['files_per_page'],
			store: this.store,
			displayInfo: true,
			displayMsg: lang('displaying objects of'),
			emptyMsg: lang("no objects to display")

		}),
		viewConfig: {
			forceFit: true
		},
		sm: sm,
		tbar:tbar,
		listeners: {
			'render': {
				fn: function() {
					this.innerMessage = document.createElement('div');
					this.innerMessage.className = 'inner-message';
					var msg = this.innerMessage;
					var elem = Ext.get(this.getEl());
					var scroller = elem.select('.x-grid3-scroller');
					scroller.each(function() {
						this.dom.appendChild(msg);
					});
				},
				scope: this
			},
			'columnmove': {
				fn: function(old_index, new_index) {
					og.eventManager.fireEvent('replace all empty breadcrumb', null);
				},
				scope: this
			}
		}
	});
	
};

Ext.extend(og.TicketManager, Ext.grid.GridPanel, {
	load: function(params) {
		if (!params) params = {};
		var start;
		if (typeof params.start == 'undefined') {
			start = (this.getBottomToolbar().getPageData().activePage - 1) * og.config['files_per_page'];
		} else {
			start = 0;
		}

		this.store.baseParams.context = og.contextManager.plainContext();
        this.store.baseParams.custom_properties_filters = og.custom_properties_filter_function();

		this.updateColumnModelHiddenColumns();
		
		this.store.removeAll();
		this.store.load({
			params: Ext.apply(params, {
				start: start,
				limit: og.config['files_per_page']				
			})
		});
	},
	
	activate: function() {
		if (this.needRefresh) {
			this.reset();
		}
	},
	
	reset: function() {
		var params = {start:0};
		
		this.load(params);
	},
	
	showMessage: function(text) {
		this.innerMessage.innerHTML = text;
	},
	
	reloadFiltering: function() {
		if (this.isLoading()) return;
		this.is_loading = true;
		
		var config = {
			start:0
		};
		
		this.load(config);
	},
	
	isLoading: function() {
		return this.is_loading;
	},
	
	trashObjects: function() {
		if (confirm(lang('confirm move to trash'))) {
			this.load({
				action: 'delete',
				ids: this.getSelectedIds()
			});
			this.getSelectionModel().clearSelections();
		}
	},
	
	archiveObjects: function() {
		if (confirm(lang('confirm archive selected objects'))) {
			this.load({
				action: 'archive',
				ids: this.getSelectedIds()
			});
			this.getSelectionModel().clearSelections();
		}
	}
});


Ext.reg("tickets", og.TicketManager);

/************************************************
Container for TicketManager,
*************************************************/
og.TicketManagerPanel = function() {
	this.doNotRemove = true;
	this.needRefresh = false;
	
	this.manager = new og.TicketManager();
	
	og.TicketManagerPanel.superclass.constructor.call(this, {
		layout: 'fit',
		border: false,
		bodyBorder: false,
		items: [
			this.manager
		],
		closable: true
	});
}

Ext.extend(og.TicketManagerPanel, Ext.Panel, {
	load: function(params) {
		this.manager.load(params);
	},
	activate: function() {
		this.manager.activate();
	},	
	reset: function() {
		this.manager.reset();
	},	
	showMessage: function(text) {
		this.manager.showMessage(text);
	}
});

Ext.reg("tickets-containerpanel", og.TicketManagerPanel);

/**
 * Get list checked elements for filter menu
 * @returns {Array}
 */
og.custom_properties_filter_function = function() {

    var params = {};

    var toolbar = Ext.getCmp('ticket-manager').getTopToolbar();
    if(typeof toolbar.length === "undefined"){
        toolbar = toolbar.items.items;
    }
    for (var i=0; i<toolbar.length; i++) {
        if (typeof toolbar[i].initialConfig !== "undefined") {
            if (typeof toolbar[i].initialConfig.customPropertyFilter !== "undefined") {
                if (toolbar[i].initialConfig.customPropertyFilter == true) {
                    var paramsAux = [];
                    if (typeof toolbar[i].items === "undefined"){
                        for (var index=0; index<toolbar[i].menu.items.items.length; index++) {
                            var mi = toolbar[i].menu.items.items[index];
                            if (mi.checked) {
                                paramsAux.push(mi.value);
                            }
                        }
                    }else{
                        for (var index=0; index<toolbar[i].initialConfig.menu.items.length; index++) {
                            var mi = toolbar[i].initialConfig.menu.items[index];
                            if (mi.checked) {
                                paramsAux.push(mi.value);
                            }
                        }
                    }
                    if (paramsAux.length > 0){
                        params[toolbar[i].initialConfig.idCustomeProperty] ={value: paramsAux};
                    }
                }
            }
        }
    }
   return  Ext.util.JSON.encode(params);
};