
INSERT INTO `<?php echo $table_prefix ?>objects` (`object_type_id`, `name`, `created_on`, `created_by_id`, `updated_on`, `updated_by_id`) VALUES
((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='status_timesheet'), 'Pending approval', NOW(), 2, NOW(), 2),
((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='status_timesheet'), 'Locked', NOW(), 2, NOW(), 2),
((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='status_timesheet'), 'Approved', NOW(), 2, NOW(), 2),
((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='status_timesheet'), 'Invoiced', NOW(), 2, NOW(), 2),
((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='status_timesheet'), 'Under review', NOW(), 2, NOW(), 2);


SET @old_sql_mode := @@sql_mode ;
-- derive a new value by removing NO_ZERO_DATE and NO_ZERO_IN_DATE
SET @new_sql_mode := @old_sql_mode ;
SET @new_sql_mode := TRIM(BOTH ',' FROM REPLACE(CONCAT(',',@new_sql_mode,','),',NO_ZERO_DATE,'  ,','));
SET @new_sql_mode := TRIM(BOTH ',' FROM REPLACE(CONCAT(',',@new_sql_mode,','),',NO_ZERO_IN_DATE,',','));
SET @@sql_mode := @new_sql_mode ;
UPDATE `<?php echo $table_prefix ?>objects` SET `trashed_on`=0 WHERE `trashed_on` IS NULL;
UPDATE `<?php echo $table_prefix ?>objects` SET `archived_on`=0 WHERE `archived_on` IS NULL;
UPDATE `<?php echo $table_prefix ?>objects` SET `trashed_by_id`=0 WHERE `trashed_by_id` IS NULL;
UPDATE `<?php echo $table_prefix ?>objects` SET `archived_by_id`=0 WHERE `archived_by_id` IS NULL;
SET @@sql_mode := @old_sql_mode ;


INSERT INTO `<?php echo $table_prefix ?>status` (`object_id`)
SELECT `id` FROM `<?php echo $table_prefix ?>objects` 
WHERE object_type_id=(SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='status_timesheet')
AND `name` IN ('Pending approval','Locked','Approved','Invoiced','Under review');


INSERT INTO `<?php echo $table_prefix ?>members` (`name`, `dimension_id`, `object_type_id`, `depth`, `order`, `object_id`, `archived_by_id`) VALUES
('Pending approval', (SELECT id FROM `<?php echo $table_prefix ?>dimensions` WHERE `code`='status_timesheet'), (SELECT id FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='status_timesheet'), 1, 1, (SELECT `id` FROM `<?php echo $table_prefix ?>objects` WHERE `name`='Pending approval' ORDER BY `id` DESC LIMIT 1), 0),
('Locked', (SELECT id FROM `<?php echo $table_prefix ?>dimensions` WHERE `code`='status_timesheet'), (SELECT id FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='status_timesheet'), 1, 2, (SELECT `id` FROM `<?php echo $table_prefix ?>objects` WHERE `name`='Locked' ORDER BY `id` DESC LIMIT 1), 0),
('Approved', (SELECT id FROM `<?php echo $table_prefix ?>dimensions` WHERE `code`='status_timesheet'), (SELECT id FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='status_timesheet'), 1, 3, (SELECT `id` FROM `<?php echo $table_prefix ?>objects` WHERE `name`='Approved' ORDER BY `id` DESC LIMIT 1), 0),
('Invoiced', (SELECT id FROM `<?php echo $table_prefix ?>dimensions` WHERE `code`='status_timesheet'), (SELECT id FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='status_timesheet'), 1, 4, (SELECT `id` FROM `<?php echo $table_prefix ?>objects` WHERE `name`='Invoiced' ORDER BY `id` DESC LIMIT 1), 0),
('Under review', (SELECT id FROM `<?php echo $table_prefix ?>dimensions` WHERE `code`='status_timesheet'), (SELECT id FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='status_timesheet'), 1, 5, (SELECT `id` FROM `<?php echo $table_prefix ?>objects` WHERE `name`='Under review' ORDER BY `id` DESC LIMIT 1), 0);


INSERT INTO <?php echo $table_prefix ?>contact_member_permissions (permission_group_id, member_id, object_type_id, can_delete, can_write)
SELECT c.permission_group_id, m.id, ot.id, 1, 1
FROM <?php echo $table_prefix ?>members m
JOIN <?php echo $table_prefix ?>object_types ot
JOIN <?php echo $table_prefix ?>contacts c
WHERE c.user_type=1
	AND m.dimension_id=(SELECT id FROM `<?php echo $table_prefix ?>dimensions` WHERE `code`='status_timesheet')
	AND ot.type IN ('content_object','located')
ON DUPLICATE KEY UPDATE `member_id`=`member_id`;


INSERT INTO `<?php echo $table_prefix ?>config_categories` (`name`, `is_system`, `category_order`) VALUES
 ('timesheets_config', 0, 65)
ON DUPLICATE KEY UPDATE `name`=`name`;


INSERT INTO `<?php echo $table_prefix ?>config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`,`options`) VALUES
 ('timesheets_config', 'time_bulk_action_pending_btn_text', 'Set as pending', 'StringConfigHandler', 0, 10, '',''),
 ('timesheets_config', 'time_bulk_action_lock_btn_text', 'Lock', 'StringConfigHandler', 0, 20, '',''),
 ('timesheets_config', 'time_bulk_action_approve_btn_text', 'Approve', 'StringConfigHandler', 0, 30, '',''),
 ('timesheets_config', 'time_bulk_action_invoice_btn_text', 'Invoice', 'StringConfigHandler', 0, 40, '',''),
 ('timesheets_config', 'time_bulk_action_review_btn_text', 'Put under review', 'StringConfigHandler', 0, 50, '',''),
 ('timesheets_config', 'time_bulk_action_processed_btn_text', '', 'StringConfigHandler', 0, 45, '',''),
 ('timesheets_config', 'time_bulk_action_pending_member_id', (SELECT `id` FROM `<?php echo $table_prefix ?>members` WHERE `name`='Pending approval' ORDER BY `id` DESC LIMIT 1), 'MemberConfigHandler', 0, 60, '', CONCAT('{"dim_id":',(SELECT id FROM <?php echo $table_prefix ?>dimensions WHERE code='status_timesheet'),'}')),
 ('timesheets_config', 'time_bulk_action_locked_member_id', (SELECT `id` FROM `<?php echo $table_prefix ?>members` WHERE `name`='Locked' ORDER BY `id` DESC LIMIT 1), 'MemberConfigHandler', 0, 70, '', CONCAT('{"dim_id":',(SELECT id FROM <?php echo $table_prefix ?>dimensions WHERE code='status_timesheet'),'}')),
 ('timesheets_config', 'time_bulk_action_approved_member_id', (SELECT `id` FROM `<?php echo $table_prefix ?>members` WHERE `name`='Approved' ORDER BY `id` DESC LIMIT 1), 'MemberConfigHandler', 0, 80, '', CONCAT('{"dim_id":',(SELECT id FROM <?php echo $table_prefix ?>dimensions WHERE code='status_timesheet'),'}')),
 ('timesheets_config', 'time_bulk_action_invoiced_member_id', (SELECT `id` FROM `<?php echo $table_prefix ?>members` WHERE `name`='Invoiced' ORDER BY `id` DESC LIMIT 1), 'MemberConfigHandler', 0, 90, '', CONCAT('{"dim_id":',(SELECT id FROM <?php echo $table_prefix ?>dimensions WHERE code='status_timesheet'),'}')),
 ('timesheets_config', 'time_bulk_action_processed_member_id', '', 'MemberConfigHandler', 0, 95, '', CONCAT('{"dim_id":',(SELECT id FROM <?php echo $table_prefix ?>dimensions WHERE code='status_timesheet'),'}')),
 ('timesheets_config', 'time_bulk_action_review_member_id', (SELECT `id` FROM `<?php echo $table_prefix ?>members` WHERE `name`='Under review' ORDER BY `id` DESC LIMIT 1), 'MemberConfigHandler', 0, 100, '', CONCAT('{"dim_id":',(SELECT id FROM <?php echo $table_prefix ?>dimensions WHERE code='status_timesheet'),'}'))
ON DUPLICATE KEY UPDATE `category_name`=`category_name`;


INSERT INTO `<?php echo $table_prefix ?>workflow_permissions` (`name`, `object_type_id`, `type`, `action`, `member_id`) VALUES
('can_edit_locked_timeslots', (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='timeslot'), 'permission_group_list', 'edit', (SELECT `value` FROM <?php echo $table_prefix ?>config_options WHERE name='time_bulk_action_locked_member_id')),
('can_edit_review_timeslots', (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='timeslot'), 'permission_group_list', 'edit', (SELECT `value` FROM <?php echo $table_prefix ?>config_options WHERE name='time_bulk_action_review_member_id')),
('can_approve_timeslots', (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='timeslot'), 'permission_group_list', 'approve', (SELECT `value` FROM <?php echo $table_prefix ?>config_options WHERE name='time_bulk_action_approved_member_id')),
('can_edit_approved_timeslots', (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='timeslot'), 'permission_group_list', 'edit', (SELECT `value` FROM <?php echo $table_prefix ?>config_options WHERE name='time_bulk_action_approved_member_id')),
('can_invoice_timeslots', (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='timeslot'), 'permission_group_list',	'invoice', (SELECT `value` FROM <?php echo $table_prefix ?>config_options WHERE name='time_bulk_action_invoiced_member_id')),
('can_edit_invoiced_timeslots', (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='timeslot'), 'permission_group_list', 'edit', (SELECT `value` FROM <?php echo $table_prefix ?>config_options WHERE name='time_bulk_action_invoiced_member_id'));



-- set all permissions to admins
INSERT INTO <?php echo $table_prefix ?>workflow_permission_values(workflow_permission_id, permission_group_id, bool_value) 
SELECT wp.id, u.permission_group_id, true
FROM <?php echo $table_prefix ?>contacts u
JOIN <?php echo $table_prefix ?>workflow_permissions wp
WHERE u.user_type IN (1,2)
ON DUPLICATE KEY UPDATE workflow_permission_id=workflow_permission_id;

INSERT INTO <?php echo $table_prefix ?>workflow_permission_value_pgs (workflow_permission_value_id, affected_permission_group_id)
SELECT wpv.id, au.permission_group_id
FROM <?php echo $table_prefix ?>workflow_permission_values wpv
INNER JOIN <?php echo $table_prefix ?>contacts u ON u.permission_group_id = wpv.permission_group_id
JOIN <?php echo $table_prefix ?>contacts au
WHERE u.user_type IN (1,2) AND au.user_type > 0
ON DUPLICATE KEY UPDATE workflow_permission_value_id=workflow_permission_value_id;

-- set permissions to managers
INSERT INTO <?php echo $table_prefix ?>workflow_permission_values(workflow_permission_id, permission_group_id, bool_value) 
SELECT wp.id, u.permission_group_id, true
FROM <?php echo $table_prefix ?>contacts u
JOIN <?php echo $table_prefix ?>workflow_permissions wp
WHERE u.user_type IN (3)
AND wp.name IN ('can_edit_locked_timeslots','can_edit_review_timeslots','can_approve_timeslots')
ON DUPLICATE KEY UPDATE workflow_permission_id=workflow_permission_id;

INSERT INTO <?php echo $table_prefix ?>workflow_permission_value_pgs (workflow_permission_value_id, affected_permission_group_id)
SELECT wpv.id, au.permission_group_id
FROM <?php echo $table_prefix ?>workflow_permission_values wpv
INNER JOIN <?php echo $table_prefix ?>workflow_permissions wp ON wp.id = wpv.workflow_permission_id
INNER JOIN <?php echo $table_prefix ?>contacts u ON u.permission_group_id = wpv.permission_group_id
JOIN <?php echo $table_prefix ?>contacts au
WHERE u.user_type IN (3) AND au.user_type >= 3 AND au.object_id<>u.object_id
AND wp.name IN ('can_edit_locked_timeslots','can_edit_review_timeslots','can_approve_timeslots')
ON DUPLICATE KEY UPDATE workflow_permission_value_id=workflow_permission_value_id;
