<?php
chdir(dirname(__FILE__)."/../../");
define("CONSOLE_MODE", true);
define('PUBLIC_FOLDER', 'public');
include "init.php";

Env::useHelper('page');
Env::useHelper('form');

$field_rows = DB::executeAll("SELECT `name` FROM ".TABLE_PREFIX."user_registration_fields WHERE required=1 ORDER BY `order`");
$required_fields = array_flat($field_rows);

$all_field_rows = DB::executeAll("SELECT `name` FROM ".TABLE_PREFIX."user_registration_fields ORDER BY `order`");
$all_fields = array_flat($all_field_rows);

$user_data = array_var($_SESSION, 'new_user_registration_data', array());

$genid = gen_id();
?>
<html>
<head>
	<title><?php echo clean(CompanyWebsite::instance()->getCompany()->getFirstName()) . ' - ' . product_name() ?></title>
	<link href="<?php echo ROOT_URL ?>/favicon.ico" rel="shortcut icon">
	<meta http-equiv="content-type" content="text/html; charset=utf-8">
	<link href="<?php echo ROOT_URL ?>/public/assets/themes/default/stylesheets/website.css" rel="Stylesheet" type="text/css">
	<link href="public/css/user_registration.css" rel="Stylesheet" type="text/css">
	<style>#loading { font-size: 20px; left: 45%; position: absolute; top: 45%; color: #333333; font-family: verdana,arial,helvetica,sans-serif; line-height: 150%; }</style>
	<style type="text/css">.x-accordion-hd, ul.x-tab-strip li {background-color: #9EA39D}ul.x-tab-strip li {border-color: #9EA39D}#header, #userboxWrapper h2 a {background-color: #FFFFFF}.x-accordion-hd, .x-tab-strip span.x-tab-strip-text {color: #ffffff}ul.x-tab-strip li.x-tab-strip-active {background-color: #ffffff !important}ul.x-tab-strip li.x-tab-strip-active span.x-tab-strip-text {color: #14780e !important}#logodiv h1, #userboxWrapper h2 a, div.og-loading {color: #000000}.x-accordion-hd {background-color: #14780e}.x-tree-node .x-tree-selected {background-color: #d4e8ce; border-color: #aabaa5}.cke_wrapper {background-color: #14780e !important;}</style>
	<?php
		if (file_exists(ROOT . '/user-reg.css')) {
			?><link href="<?php echo ROOT_URL ?>/user-reg.css" rel="Stylesheet" type="text/css"><?php
		}
	?>
</head>
<body>

<div class="register-user-header-container" id="register-header">
	<div class="register-user-header"></div>
</div>

<div class="register-user-form-container" id="register-content">
<form method="post" action="process_registration.php">


  <div class="register-user-title">
  	<?php echo lang('please enter your information')?>
  </div>
  
<?php
	if (isset($_SESSION['new_user_registration_error_msg'])) {
		echo '<div class="error">'.$_SESSION['new_user_registration_error_msg'].'</div>';
		unset($_SESSION['new_user_registration_error_msg']);
	}
?>

  <div class="register-user-form">
 
 <?php foreach ($all_fields as $field) { ?>
 	<?php if (str_ends_with($field, 'country')) { ?>
 	
 		<div class="label-container">
			<label for="profileForm<?php echo $field?>"><?php echo lang('field '.$field) ?>:<?php if (in_array($field, $required_fields)) echo ' <span class="label_required">*</span>'?></label>
		</div>
		<div class="input-container">
			<?php echo select_country_widget('user['.$field.']', array_var($user_data, $field), array('id' => 'profileFormW'.$field))?>
		</div>
		
 	<?php } else if (str_ends_with($field, 'address')) { ?>
 	
 		<div class="label-container">
			<label for="profileForm<?php echo $field?>"><?php echo lang('field '.$field) ?>:<?php if (in_array($field, $required_fields)) echo ' <span class="label_required">*</span>'?></label>
		</div>
		<div class="input-container">
			<textarea id="profileForm<?php echo $field?>" class="short textarea" name="user[<?php echo $field?>]" rows="10" cols="40"><?php echo array_var($user_data, $field)?></textarea>
		</div>
		
 	<?php } else { ?>
 	
 		<div class="label-container">
			<label for="profileForm<?php echo $field?>"><?php echo lang('field '.$field) ?>:<?php if (in_array($field, $required_fields)) echo ' <span class="label_required">*</span>'?></label>
		</div>
		<div class="input-container">
			<input id="profileForm<?php echo $field?>" style="width:260px;" type="text" name="user[<?php echo $field?>]" value="<?php echo array_var($user_data, $field)?>">
		</div>
		
	<?php } ?>
	
		<div class="clear"></div>
<?php } ?>

		<div class="submit-btn-container">
<?php
		  echo input_field('user[contact_id]',array_var($user_data, 'contact_id',''), array('type' => 'hidden'));
		  echo submit_button(lang('sign up')); 
?>
		</div>
  </div>

</form>
</div>

<div class="register-user-footer" id="register-footer">
	<div class="powered-by">
		<?php echo lang('footer powered', clean(PRODUCT_URL), clean(product_name())) . ' - ' . lang('version') . ' ' . product_version();?>
	</div>
</div>

<script>
function adjustFooterHeight() {
	var header = document.getElementById("register-header");
	var content = document.getElementById("register-content");
	var footer = document.getElementById("register-footer");
	var height = document.body.clientHeight - header.clientHeight - content.clientHeight - 40;
	
	footer.clientHeight = (height < 50) ? 50 : height;
	footer.style.height = ((height < 50) ? 50 : height) + 'px';
}
window.onresize = function(event) {
	adjustFooterHeight();
};
adjustFooterHeight();
</script>

</body>
</html>