<?php 

use Sabre\DAV\Auth\Backend\AbstractDigest;
use Sabre\HTTP\RequestInterface;
use Sabre\HTTP\ResponseInterface;

class FengWebDavAuth extends AbstractDigest {

	
	function getDigestHash($realm, $username) {
		
		// get user object
		if (preg_match(EMAIL_FORMAT, $username)) {
			$user = Contacts::getByEmail($username, null, true);
		} else {
			$user = Contacts::getByUsername($username);
		}
		
		// check user password
		if ($user instanceof Contact && $user->isUser()) {
			
			$pass_object = ContactPasswords::getNewestContactPassword($user->getId());
			if (!$pass_object) return null;
			
			$time = $pass_object->getPasswordDate()->getTimestamp();
			$password = cp_decrypt($pass_object->getPassword(), $time);
			
			// save user id in session to login if password is valid
			$_SESSION['check_user_id'] = $user->getId();
			
			return md5($username . ':' . $realm . ':' . "$password");
			
		} else {
			return null;
		}
	}
	
	
	function check(RequestInterface $request, ResponseInterface $response) {
		// call parent class method
		$result = parent::check($request, $response);
		$ok = $result[0];
		
		// set or unset session variables and logged user if password is valid or not
		if ($ok) {
			$user = Contacts::instance()->findById($_SESSION['check_user_id']);
			if ($user instanceof Contact) {
				
				$logged_user = logged_user();
				if (!$logged_user instanceof Contact || $logged_user->getId() != $user->getId()) {
					$_SESSION['dav_user_id'] = $_SESSION['check_user_id'];
					CompanyWebsite::instance()->setLoggedUser($user, false, false, false);
				}
				
			} else {
				CompanyWebsite::instance()->logUserOut();
				$_SESSION['dav_user_id'] = null;
			}
			
		} else {
			CompanyWebsite::instance()->logUserOut();
			$_SESSION['dav_user_id'] = null;
		}
		
		unset($_SESSION['check_user_id']);
		
		return $result;
	}
}
