<?php
	require_javascript("og/ReportingFunctions.js");
	require_javascript('og/modules/doubleListSelCtrl.js');
	$genid = gen_id();
	if (!isset($conditions)) $conditions = array();
	
	$report_data = array_var($_SESSION, 'sponsors_report_data');
	
	$payment_types_info = PaymentTypes::getAllPaymentTypesInfo();
	
	$expense_ot = ObjectTypes::findByName('expense');
	$proj_year_cp = CustomProperties::instance()->findOne(array('conditions' => "name='Project Year' AND object_type_id=".$expense_ot->getId()));
?>
<form style='height:100%;background-color:white' class="internalForm" action="<?php echo get_url('weill_cornell_reports', 'sponsors_report') ?>" method="post" enctype="multipart/form-data">

<div class="reportTotalTimeParams">
<div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo lang('project expenses by year report') ?>
	</div>
	<div style="padding:5px 0"><?php echo lang('project expenses by year report description') ?></div>
</div>
<div class="coInputSeparator"></div>
<div class="coInputMainBlock">
	
	<?php if (count(active_context_members(false)) > 0) : ?>
	<div style="margin-bottom: 15px; padding-bottom: 5px; border-bottom:1px dotted #aaa;">
		<h5><?php echo lang('showing information for')?>:</h5>
		<ul>
		<?php
			$context = active_context();
			foreach ($context as $selection) :
				if ($selection instanceof Member) : ?>
					<li><span class="coViewAction <?php echo $selection->getIconClass()?>"><?php echo $selection->getName()?></span></li>	
		<?php 	endif;
			endforeach;
		?>
		</ul>
	</div>
	<?php else: ?>
	<div style="padding:5px;"></div>
	<?php endif; ?>

	<table>
		
		
		<tr style='height:30px;'>
			<td><span class="bold"><?php echo lang("date") ?>:&nbsp;</span></td>
			<td align='left'><?php 
				echo select_box('report[date_type]', array(
					option_tag(lang('none'), -1, array_var($report_data, "date_type") == -1 ? array('selected' => 'selected'):null),
					option_tag(lang('today'), 1, array_var($report_data, "date_type") == 1 ? array('selected' => 'selected'):null),
					option_tag(lang('this week'), 2, array_var($report_data, "date_type") == 2 ? array('selected' => 'selected'):null),
					option_tag(lang('next week'), 3, array_var($report_data, "date_type") == 3 ? array('selected' => 'selected'):null),
					option_tag(lang('this month'), 4, array_var($report_data, "date_type") == 4 ? array('selected' => 'selected'):null),
					option_tag(lang('next month'), 5, array_var($report_data, "date_type") == 5 ? array('selected' => 'selected'):null),
					option_tag(lang('select dates...'), 6, array_var($report_data, "date_type") == 6 ? array('selected' => 'selected'):null)
				), array('onchange' => 'og.dateselectchange(this)'));
			?></td>
		</tr>
		<?php
			if (array_var($report_data, "date_type") == 6) {
				$style = "";
		       	$st = DateTimeValueLib::dateFromFormatAndString(DATE_MYSQL, array_var($report_data, 'date_start_value'));
		       	$et = DateTimeValueLib::dateFromFormatAndString(DATE_MYSQL, array_var($report_data, 'date_end_value'));
			} else {
				$style = 'display:none;';
				$st = DateTimeValueLib::now();
				$et = $st;
			} 
		?>
		<tr class="dateTr"  style="<?php echo $style ?>">
			<td><span class="bold"><?php echo lang("start date") ?>:&nbsp;</span></td>
			<td align='left'><?php echo pick_date_widget2('report[date_start_value]', $st, $genid);?></td>
		</tr>
		<tr class="dateTr"  style="<?php echo $style ?>">
			<td style="padding-bottom:18px"><span class="bold"><?php echo lang("end date") ?>:&nbsp;</span></td>
			<td align='left'><?php echo pick_date_widget2('report[date_end_value]', $et, $genid);?></td>
		</tr>
		
		<tr style='height:30px;' id="<?php echo $genid ?>repGroupBy">
			<td><span class="bold"><?php echo lang("group by") ?>:&nbsp;</span></td>
			<td align='left'>
				<span id="<?php echo $genid ?>gbspan">
					<?php for ($i = 1; $i <= 3; $i++){ 
						$gbVal = array_var($report_data, "group_by_$i");
						?>
					<select id="<?php echo $genid ?>group_by_<?php echo $i ?>" name="report[group_by_<?php echo $i ?>]" )">
						<option value="0"<?php if ($gbVal == null) echo ' selected="selected"' ?>><?php echo lang('none') ?></option>
						<?php 
							$gbs = array(
								array('val' => 'cp_'.$proj_year_cp->getId(), 'name' => $proj_year_cp->getName())
							);
							Hook::fire('total_task_timeslots_group_by_criterias', null, $gbs);
							foreach($gbs as $gb) { ?>
								<option value="<?php echo $gb['val']?>"<?php if ($gbVal == $gb['val']) echo ' selected="selected"' ?>><?php echo $gb['name']?></option>
						<?php } ?>
					</select>
					<?php } // for ?>
				</span>
			</td>
		</tr>
		
		<tr style="height:30px;">
			<td><span class="bold"><?php echo lang('payment type') ?>:&nbsp;</span></td>
			<td>
				<select id="<?php echo $genid?>_payment_type_combo" name="report[payment_type]">
					<option value="0"><?php echo lang('dont filter')?></option>
					<?php foreach ($payment_types_info as $pt_info) { ?>
					<option value="<?php echo $pt_info['id']?>" <?php echo (array_var($report_data, 'payment_type') == $pt_info['id'] ? 'selected="selected"' : '') ?>><?php 
						echo $pt_info['name'];
					?></option>
					<?php } ?>
				</select> 
			</td>
		</tr>
		
		<tr style="height:30px;">
			<td><span class="bold"><?php echo $proj_year_cp->getName() ?>:&nbsp;</span></td>
			<td>
				<input type="text" value="" placeholder="<?php echo lang('dont filter')?>" name="report[cp_filters][<?php echo $proj_year_cp->getId()?>]"/>
			</td>
		</tr>
		
		<tr style="height:30px;">
			<td colspan="2">
				<span class="bold" onclick="$('#<?php echo $genid?>aggregate_payment_types_of_the_same_key').click();" style="cursor:pointer;"><?php 
					echo lang('aggregate payment types of the same key') ?></span>
				<?php echo checkbox_field("report[aggregate_payment_types_of_the_same_key]", array_var($report_data, 'aggregate_payment_types_of_the_same_key', true), array('id' => $genid.'aggregate_payment_types_of_the_same_key'))?>
			</td>
		</tr>
		
		<tr id="<?php echo $genid?>_column_selector_link">
			<td style="padding-top:10px;" colspan="2">
			  <a href="#" class="underline" onclick="$('#<?php echo $genid?>_column_selector_row').show(); $(this).closest('tr').hide();"><?php 
				echo lang('select columns to show');
			?></a></td>
		</tr>
		<tr id="<?php echo $genid?>_column_selector_row" style="display:none;">
			<td style="padding-top:10px;padding-right:10px;"><span class="bold"><?php echo lang('columns') ?>:&nbsp;</span></td>
			<td><?php
				$column_list = array_var($report_data, 'column_list');
				$size = count($column_list);
				if ($size < 8) $size = 8;
				if ($size > 20) $size = 20;
				echo doubleListSelect("report[show_columns]", $column_list, array('id' => $genid."columns", 'size' => $size));
			?></td>
		</tr>
		
	</table>
	
<br/>
<?php echo submit_button(lang('generate report'),'s',array('style'=>'margin-top:0px;')) ?>
</div>
</div>

</form>

<script>
	og.loadReportingFlags();	
	og.reportTask('<?php echo $genid?>', '<?php echo array_var($report_data, 'order_by') ?>', '<?php echo array_var($report_data, 'order_by_asc') ?>', '');	

	var first = document.getElementById('<?php echo $genid ?>reportFormName');
	if (first) first.focus();
	
</script>