<?php 
$genid = gen_id();

$hierarchy_groups = array();
$hierarchy_groups_tmp = PersonHierarchyGroups::instance()->findAll();
foreach ($hierarchy_groups_tmp as $hg) {
	$hierarchy_groups[$hg->getId()] = $hg;
}

$news_type_groups = array();
$news_type_groups_tmp = NewsTypeGroups::instance()->findAll();
foreach ($news_type_groups_tmp as $nt) {
	$news_type_groups[$nt->getId()] = $nt;
}

if (!isset($totals_by_hierarchy)) $totals_by_hierarchy = array();
if (!isset($totals_by_news_type)) $totals_by_news_type = array();
?>
<div class="summary-container">
<table><tr>

<td class="left-stats">
	<div style="padding-left: 5px;" class="stats-container"><?php

		$resp_contact = Contacts::instance()->findById(config_option('summary_general_responsible'));
		if ($resp_contact instanceof Contact) {
			echo '<div style="min-height:20px;margin-top:5px;"><span class="bold">'.lang('general responsible').':</span> '. $resp_contact->getObjectName() .'</div>';
		}
		
		$aux_contact = Contacts::instance()->findById(config_option('summary_general_auxiliar'));
		if ($aux_contact instanceof Contact) {
			echo '<div style="min-height:20px;"><span class="bold">'.lang('general auxiliar').':</span> '. $aux_contact->getObjectName() .'</div>';
		}
		?>
		<table class="date-row-container"><tr><td><span class="bold"><?php echo lang('date')?>:</span>
		<td><div id="<?php echo $genid?>date_picker_summary"></div></td>
		</tr></table>
	</div>
</td>

<td class="center-stats">
	<div class="stats-container">
		<table><tr><th></th><th class="num"><?php echo lang('total persons')?></th>
				<th class="num"><?php echo lang('presents')?></th><th class="num"><?php echo lang('abscents')?></th></tr>
		</table>
		<div class="table-container" style="border-bottom:1px solid #ddd;overflow-y: auto;">
		<table>
<?php
		$total_persons = 0;
		$total_absences = 0;
		$alt = '';
		foreach ($totals_by_hierarchy as $hid => $hpersons) {?>
			<tr<?php echo $alt?>><td><?php echo $hierarchy_groups[$hid]->getName()?></td><td class="num"><?php echo $hpersons->getTotal()?></td>
				<td class="num"><?php echo $hpersons->getTotal() - $hpersons->getTotalAbsences()?></td><td class="num"><?php echo $hpersons->getTotalAbsences()?></td></tr>
	<?php	
			$total_persons += $hpersons->getTotal();
			$total_absences += $hpersons->getTotalAbsences();
			$alt = $alt == "" ? ' class="alt"' : "";
		}
		if ($total_persons > 0) {
			$abs_p = number_format($total_absences * 100 / $total_persons, 2);
		} else {
			$abs_p = 0;
		}
		?>
		</table>
		</div>
		<table style="overflow: overlay;">
			<tr><td><?php echo lang('total')?></td><td class="num"><?php echo $total_persons?></td>
				<td class="num"><?php echo $total_persons - $total_absences?></td><td class="num"><?php echo $total_absences . " ($abs_p %)"?></td>
				<?php if (count($totals_by_hierarchy) > 3) { ?>
				<td style="width:13px;">&nbsp;</td>
				<?php } ?>
			</tr>
		</table>
	</div>
</td>

<td class="right-stats">
	<div class="stats-container">
		<div class="abs-title"><?php echo lang('general statistics')?></div>
		<table><tr><th><?php //echo lang('cause')?></th></tr></table>
		<div class="table-container">
		<table>
<?php
		$alt = '';
		$with_no_cause = 0;
		foreach ($totals_by_news_type as $ntid => $nt_total) {
			if ($ntid == 0) {
				$with_no_cause = $nt_total;
				continue;
			}
		?>
			<tr<?php echo $alt?>><td><?php echo $news_type_groups[$ntid]->getName()?></td><td><?php echo $nt_total?></td>
<?php		$alt = $alt == "" ? ' class="alt"' : "";
		}
		if ($with_no_cause > 0) {?>
			<tr<?php echo $alt?>><td><?php echo lang('without cause')?></td><td><?php echo $with_no_cause?></td>
<?php 
		}
		?><tr<?php echo $alt?>><td><?php echo lang('presents')?></td><td><?php echo ($total_persons - $total_absences)?></td>
		</table>
		</div>
	</div>
</td>

</tr></table>
</div>


<script>
var date_val = '<?php echo ($summary_date instanceof DateTimeValue ? $summary_date->format(user_config_option('date_format')) : '') ?>';
var genid = '<?php echo $genid?>';
var sum_id = '<?php echo (isset($summary) && $summary instanceof NewsSummary ? $summary->getId() : 0)?>';

og.work_time_registration.status_combo_change = function(el) {
	
	var val = el.options[el.selectedIndex].value;
	
	og.openLink(og.getUrl('time_registration', 'change_summary_status', {id: sum_id, st: val}), {callback: function(success, data) {
		if (success) {
			if (val == 'approved') {
				el.parentNode.className = 'approved';
				el.parentNode.innerHTML = lang('summary status approved');
			} else {
				el.parentNode.className = is_today ? 'today-pending' : 'late-pending';
			}
		} else {
			el.selectedIndex = 0;
		} 
	}});
}

og.work_time_registration.reload_news_list = function(date) {
	var panel = Ext.getCmp('time-reg-manager-container');
	panel.setDateFilter(date.format(og.preferences['date_format']));
	panel.reset();
};

var summary_date_picker = new og.DateField({
	renderTo: genid + 'date_picker_summary',
	displayField:'text',
 	emptyText: og.preferences['date_format_tip'],
	name: 'summary_date',
	id: genid + 'summary_date',		
	allowBlank: true,
	value: date_val,	
	listeners: {
		'change':function(component, newValue, oldValue){
			this.setValue(newValue);
			og.work_time_registration.reload_news_list(newValue);
		}
	},
	menuListeners: {
		select:function(component, val) {
			this.setValue(val);
			og.work_time_registration.reload_news_list(val);
		} 
	}
});
$(function() {
<?php if ($for_widget) { ?>
	summary_date_picker.hide();
	$('<div>'+date_val+'</div>').appendTo($('#' + genid + 'date_picker_summary'));
<?php } ?>
});
</script>