<?php
	require_javascript("og/ReportingFunctions.js");
	$genid = gen_id();
	if (!isset($conditions)) $conditions = array();
	
	$report_data = array_var($_SESSION, 'absences_by_hierarchy_group');
?>
<form style='height:100%;background-color:white' class="internalForm" action="<?php echo get_url('time_registration_reports', 'absences_by_hierarchy_group') ?>" method="post" enctype="multipart/form-data">

<div class="reportTotalTimeParams">
<div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo lang('absences by hierarchy group report') ?>
		
	</div>
	<div style="padding:5px 0"><?php echo lang('absences by hierarchy group report description') ?></div>
</div>

<div class="">
	
	<?php 
	$idest = null;
	$contact_options = array(option_tag(lang('all'), 0));
	if (count(active_context_members(false)) > 0) : ?>
	<div style="margin-bottom: 15px; padding-bottom: 5px; border-bottom:1px dotted #aaa;">
		<h5><?php echo lang('showing information for')?>:</h5>
		<ul>
		<?php
			$ws_ot = ObjectTypes::findByName('workspace');
			$context = active_context();
			foreach ($context as $selection) :
				if ($selection instanceof Member) : ?>
					<li><span class="coViewAction <?php echo $selection->getIconClass()?>"><?php echo $selection->getName()?></span></li>	
		<?php 	
					if ($selection->getObjectTypeId() == $ws_ot->getId()) {
						$idest = $selection;
					}
				endif;
			endforeach;
		?>
		</ul>
	</div>
	<?php else: ?>
	<div style="padding:5px;"></div>
	<?php endif; ?>
	<?php
	
	$contact_conditions = "user_type=0";
	if ($idest instanceof Member) {
		$member_ids = array($idest->getId());
		$member_ids = array_merge($member_ids, $idest->getAllChildrenIds(true));
		$contact_conditions .= " AND internal_destiny IN (".implode(',', $member_ids).")";
	}
	$contacts = Contacts::instance()->findAll(array('conditions' => $contact_conditions, 'order' => 'surname, first_name'));
	foreach ($contacts as $c) {
		$attr = array();
		if (array_var($report_data, 'person_id') == $c->getId()) $attr['selected'] = 'selected';
		$o = option_tag($c->getSurname()." ".$c->getFirstName(), $c->getId(), $attr);
		$contact_options[] = $o;
	} 
	?>
	<table>
		
		<tr style='height:30px;'>
			<td><span class="bold"><?php echo lang("dates range") ?>:&nbsp;</span></td>
			<td align='left' style="padding-left:8px;"><?php 
				echo select_box('report[date_type]', array(
					option_tag(lang('today'), 1, array_var($report_data, "date_type") == 1 ? array('selected' => 'selected'):null),
					option_tag(lang('this week'), 2, array_var($report_data, "date_type") == 2 ? array('selected' => 'selected'):null),
					option_tag(lang('next week'), 3, array_var($report_data, "date_type") == 3 ? array('selected' => 'selected'):null),
					option_tag(lang('this month'), 4, array_var($report_data, "date_type") == 4 ? array('selected' => 'selected'):null),
					option_tag(lang('next month'), 5, array_var($report_data, "date_type") == 5 ? array('selected' => 'selected'):null),
					option_tag(lang('select dates...'), 6, array_var($report_data, "date_type") == 6 ? array('selected' => 'selected'):null)
				), array('onchange' => 'og.dateselectchange(this)'));
			?></td>
		</tr>
		<?php
			if (array_var($report_data, "date_type") == 6) {
				$style = "";
				$st = getDateValue(array_var($report_data, 'date_start_value'));
				$et = getDateValue(array_var($report_data, 'date_end_value'));
			} else {
				$style = 'display:none;';
				$st = DateTimeValueLib::now();
				$et = $st;
			} 
		?>
		<tr class="dateTr"  style="<?php echo $style ?>">
			<td><span class="bold"><?php echo lang("start date") ?>:&nbsp;</span></td>
			<td align='left' style="padding-left:10px;"><?php echo pick_date_widget2('report[date_start_value]', $st, $genid);?></td>
		</tr>
		<tr class="dateTr"  style="<?php echo $style ?>">
			<td style="padding-bottom:18px"><span class="bold"><?php echo lang("end date") ?>:&nbsp;</span></td>
			<td align='left' style="padding-left:10px;"><?php echo pick_date_widget2('report[date_end_value]', $et, $genid);?></td>
		</tr>
		
		<tr style="height:25px;">
			<td><span class="bold"><?php echo lang("news type") ?>:&nbsp;</span></td>
			<td align='left' style="padding-left:8px;"><?php echo news_type_select_box("report[news_type_id]", array_var($report_data, 'news_type_id'), null, true, null, lang('all'));?></td>
		</tr>
		
		<tr style="height:25px;">
			<td><span class="bold"><?php echo lang("person") ?>:&nbsp;</span></td>
			<td align='left' style="padding-left:8px;"><?php echo select_box("report[person_id]", $contact_options);?></td>
		</tr>
		
		
		<tr style='height:30px;'>
			<td><span class="bold"><?php echo lang('include subworkspaces') ?></span></td>
			<td align='left' style="padding-left:10px;">
				<?php echo checkbox_field('report[include_subdest]', array_var($report_data, 'include_subdest', true), array("id" => "report[include_subdest]")); ?> 
			</td>
		</tr>
		
	</table>
	
<br/>
<?php echo submit_button(lang('generate report'),'s',array('style'=>'margin-top:0px;', 'class'=>"blue")) ?>
</div>
</div>

</form>

