og.work_time_registration = {
	
	init: function() {
		og.openLink(og.getUrl('time_registration', 'load_news_types'), {
			callback: function(success, data) {
				og.work_time_registration.news_types = data.types;
				og.work_time_registration.hierarchies = data.hierarchies;
			}
		});
		
		if (!og.additional_list_columns) og.additional_list_columns = [];
		if (!og.additional_list_columns['contact-manager']) og.additional_list_columns['contact-manager'] = [];
		
		og.additional_list_columns['contact-manager'].push({
			id: 'internal_destiny',
			header: lang("internal destiny"),
			dataIndex: 'internal_destiny',
			renderer: og.work_time_registration.renderInternalDestinyCrumb,
			width: 120,
			sortable: false
		});
		og.additional_list_columns['contact-manager'].push({
			id: 'hierarchy_id',
			header: lang("person hierarchy"),
			dataIndex: 'hierarchy_id',
			renderer: og.work_time_registration.renderPersonHierarchy,
			width: 120,
			sortable: false
		});
		og.additional_list_columns['contact-manager'].push({
			id: 'nii',
			header: lang("nii"),
			dataIndex: 'nii',
			renderer: og.clean,
			width: 120,
			hidden: true,
			sortable: false
		});
		og.additional_list_columns['contact-manager'].push({
			id: 'document_type',
			header: lang("document type"),
			dataIndex: 'document_type',
			renderer: og.clean,
			width: 120,
			hidden: true,
			sortable: false
		});
		og.additional_list_columns['contact-manager'].push({
			id: 'document_number',
			header: lang("document number"),
			dataIndex: 'document_number',
			renderer: og.clean,
			width: 120,
			hidden: true,
			sortable: false
		});
		og.additional_list_columns['contact-manager'].push({
			id: 'speciality',
			header: lang("speciality"),
			dataIndex: 'speciality',
			renderer: og.clean,
			width: 120,
			hidden: true,
			sortable: false
		});
	},
	
	renderPersonHierarchy: function(value, p, r) {
		var name = '';
		if (og.work_time_registration.hierarchies[value]) {
			name = og.work_time_registration.hierarchies[value].name;
		}
		
		return name;
	},
	
	renderInternalDestinyCrumb: function(value, p, r) {
		
	}
	
}