<?php 

	function work_time_registration_update_1_2() {
		DB::executeAll("INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
			('system', 'summary_general_responsible', '0', 'IntegerConfigHandler', 1, 0, NULL),
			('system', 'summary_general_auxiliar', '0', 'IntegerConfigHandler', 1, 0, NULL);");
		
		if (!check_column_exists(TABLE_PREFIX."news_details", "observations")) {
			DB::executeAll("ALTER TABLE `".TABLE_PREFIX."news_details` ADD COLUMN `observations` TEXT NULL");
		}
	}
	
	function work_time_registration_update_2_3() {
		if (!check_column_exists(TABLE_PREFIX."system_permissions", "can_approve_summaries")) {
			DB::executeAll("ALTER TABLE `".TABLE_PREFIX."system_permissions` ADD COLUMN `can_approve_summaries` TEXT NULL");
		}
		if (!check_column_exists(TABLE_PREFIX."system_permissions", "can_edit_approved_summaries")) {
			DB::executeAll("ALTER TABLE `".TABLE_PREFIX."system_permissions` ADD COLUMN `can_edit_approved_summaries` TEXT NULL");
		}
	}
	
	function work_time_registration_update_3_4() {
		DB::executeAll("INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
			('system', 'allow_multiple_news_details_in_same_day', '0', 'BoolConfigHandler', 1, 0, NULL);");
		
		if (!checkTableExists(TABLE_PREFIX.'news_details_history')) {
			DB::executeAll("
				CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."news_details_history` (
				  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
				  `object_id` int(10) unsigned NOT NULL,
				  `date` datetime NOT NULL,
				  `hour` int(10) unsigned NOT NULL,
				  `minute` int(10) unsigned NOT NULL,
				  `comment` TEXT NULL,
				  `person_id` int(10) unsigned NOT NULL,
				  `news_type_id` int(10) unsigned NOT NULL,
				  `observations` TEXT NULL,
				  `modificated_on` datetime NOT NULL,
				  `modificated_by_id` int(10) unsigned NOT NULL,
				  `action` varchar(50) NOT NULL,
				  `modification_log` TEXT NULL,
				  PRIMARY KEY (`id`),
				  KEY `object_id` (`object_id`),
				  KEY `modificated_on` (`modificated_on`)
				) ENGINE=InnoDB DEFAULT CHARSET=latin1;
			");
		}
	}
	
	function work_time_registration_update_4_5() {
		if (!checkTableExists(TABLE_PREFIX.'news_summary_total_persons_by_hierarchy')) {
			DB::executeAll("
				CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."news_summary_total_persons_by_hierarchy` (
				  `summary_id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
				  `hierarchy_id` INTEGER UNSIGNED NOT NULL,
				  `total` INTEGER UNSIGNED NOT NULL,
				  PRIMARY KEY (`summary_id`, `hierarchy_id`)
				)
				ENGINE = InnoDB;
			");
		}
		
		if (!checkTableExists(TABLE_PREFIX.'news_summary_total_abs_by_hierarchy')) {
			DB::executeAll("
				CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."news_summary_total_abs_by_hierarchy` (
				  `summary_id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
				  `hierarchy_id` INTEGER UNSIGNED NOT NULL,
				  `total` INTEGER UNSIGNED NOT NULL,
				  PRIMARY KEY (`summary_id`, `hierarchy_id`)
				)
				ENGINE = InnoDB;
			");
		}
	}
	
	function work_time_registration_update_5_6() {
		DB::executeAll("
			INSERT INTO ".TABLE_PREFIX."widgets(`name`, `title`, `plugin_id`, `default_section`,`default_order`,`icon_cls`) VALUES
			 ('news_summary', 'news summary', (SELECT id from ".TABLE_PREFIX."plugins WHERE name = 'work_time_registration'), 'top', -110, 'ico-summary')
			ON DUPLICATE KEY update name = name;
		");
	}
	
	function work_time_registration_update_6_7() {
		if (!check_column_exists(TABLE_PREFIX."news_summary", "observations")) {
			DB::executeAll("ALTER TABLE `".TABLE_PREFIX."news_summary` ADD COLUMN `observations` TEXT NULL;");
		}
	}
	
	function work_time_registration_update_7_8() {
		
	}
	
	function work_time_registration_update_8_9() {
		if (!check_column_exists(TABLE_PREFIX."person_hierarchies", "long_name")) {
			DB::executeAll("ALTER TABLE `".TABLE_PREFIX."person_hierarchies` ADD COLUMN `long_name` VARCHAR(255) NOT NULL DEFAULT '' AFTER `name`;");
		}
	}
	
	function work_time_registration_update_9_10() {
		if (!check_column_exists(TABLE_PREFIX."news_types", "is_present_type")) {
			DB::executeAll("ALTER TABLE `".TABLE_PREFIX."news_types` ADD COLUMN `is_present_type` tinyint(1) NOT NULL DEFAULT '0';");
		}
	}
	
	function work_time_registration_update_10_11() {
		set_time_limit(0);
		ini_set('memory_limit', '512M');
		
		// add all attributes to searchable objects
		$details = NewsDetails::instance()->findAll();
		foreach ($details as $det) {
			$det->buildObjectName();
			$det->save();
			$det->addToSearchableObjects();
		}
		
		// remove summaries from searchable objects
		DB::execute("DELETE FROM ".TABLE_PREFIX."searchable_objects WHERE rel_object_id IN (SELECT object_id FROM ".TABLE_PREFIX."news_summary)");
	}
	
	function work_time_registration_update_11_12() {
		if (!check_column_exists(TABLE_PREFIX."max_system_permissions", "can_approve_summaries")) {
			DB::executeAll("
				ALTER TABLE `".TABLE_PREFIX."max_system_permissions`
				ADD COLUMN `can_approve_summaries` TINYINT(1) UNSIGNED NOT NULL DEFAULT 0,
				ADD COLUMN `can_edit_approved_summaries` TINYINT(1) UNSIGNED NOT NULL DEFAULT 0;
			");
		}
		
		DB::executeAll("
			update ".TABLE_PREFIX."max_system_permissions set can_approve_summaries=1
			where `permission_group_id` IN (SELECT id FROM `".TABLE_PREFIX."permission_groups` WHERE `type`='roles' AND `name` IN ('Super Administrator','Administrator', 'Manager', 'Executive'));
		");
		DB::executeAll("
			UPDATE `".TABLE_PREFIX."max_system_permissions` SET `can_approve_summaries`=1 WHERE `permission_group_id` IN (
				SELECT permission_group_id FROM `".TABLE_PREFIX."contacts` WHERE `user_type` IN (
					SELECT id FROM `".TABLE_PREFIX."permission_groups` WHERE `type`='roles' AND `name` IN ('Super Administrator','Administrator', 'Manager', 'Executive')
				)
			);
		");
		DB::executeAll("
			update ".TABLE_PREFIX."max_system_permissions set can_edit_approved_summaries=1
			where `permission_group_id` IN (SELECT id FROM `".TABLE_PREFIX."permission_groups` WHERE `type`='roles' AND `name` IN ('Super Administrator','Administrator', 'Manager', 'Executive'));
		");
		DB::executeAll("
			UPDATE `".TABLE_PREFIX."max_system_permissions` SET `can_edit_approved_summaries`=1 WHERE `permission_group_id` IN (
				SELECT permission_group_id FROM `".TABLE_PREFIX."contacts` WHERE `user_type` IN (
					SELECT id FROM `".TABLE_PREFIX."permission_groups` WHERE `type`='roles' AND `name` IN ('Super Administrator','Administrator', 'Manager', 'Executive')
				)
			);
		");
	}
	
	
	function work_time_registration_update_12_13() {
		DB::executeAll("INSERT INTO ".TABLE_PREFIX."max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		 SELECT rtp.role_id, (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='news_detail'), can_delete, can_write
		 FROM ".TABLE_PREFIX."max_role_object_type_permissions rtp WHERE rtp.object_type_id=(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='task')
		ON DUPLICATE KEY UPDATE ".TABLE_PREFIX."max_role_object_type_permissions.role_id=".TABLE_PREFIX."max_role_object_type_permissions.role_id;");
		
		DB::executeAll("INSERT INTO ".TABLE_PREFIX."max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		 SELECT rtp.role_id, (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='news_summary'), can_delete, can_write
		 FROM ".TABLE_PREFIX."max_role_object_type_permissions rtp WHERE rtp.object_type_id=(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='task')
		ON DUPLICATE KEY UPDATE ".TABLE_PREFIX."max_role_object_type_permissions.role_id=".TABLE_PREFIX."max_role_object_type_permissions.role_id;");
	}

	function work_time_registration_update_13_14() {

		DB::execute("
	INSERT INTO `".TABLE_PREFIX."objects` (`object_type_id`, `name`, `created_on`, `created_by_id`, `updated_on`, `updated_by_id`, `trashed_by_id`, `archived_by_id`) VALUES
	((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report_category'), 'time registration reports', NOW(), 0, NOW(), 0, 0, 0);
	");

	DB::execute("
	INSERT INTO `".TABLE_PREFIX."report_category` (`object_id`,  `description`, `is_default`) VALUES
	((SELECT max(id) FROM ".TABLE_PREFIX."objects WHERE object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report_category')), '', 1);
    ");

    DB::execute("
	INSERT INTO `".TABLE_PREFIX."objects` (`object_type_id`, `name`, `created_on`, `created_by_id`, `updated_on`, `updated_by_id`, `trashed_by_id`, `archived_by_id`) VALUES
	((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report'), 'summary report', NOW(), 0, NOW(), 0, 0, 0);
	");

	DB::execute("
	INSERT INTO `".TABLE_PREFIX."reports` (`object_id`, `description`, `report_object_type_id`, `is_order_by_asc`, `ignore_context`, `is_default`, `code`, `function_url`, `report_category_id`) VALUES
	((SELECT max(id) FROM ".TABLE_PREFIX."objects WHERE object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report')), 'summary report description', (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='billing'), 1, 1, 1, 'leave_summary_report', '?c=time_registration_reports&a=summary_report_parameters',(SELECT max(object_id) FROM ".TABLE_PREFIX."report_category));
	");
	
	DB::execute("
	INSERT INTO `".TABLE_PREFIX."objects` (`object_type_id`, `name`, `created_on`, `created_by_id`, `updated_on`, `updated_by_id`, `trashed_by_id`, `archived_by_id`) VALUES
	((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report'), 'absences by hierarchy group report', NOW(), 0, NOW(), 0, 0, 0);
	");

	DB::execute("
	INSERT INTO `".TABLE_PREFIX."reports` (`object_id`, `description`, `report_object_type_id`, `is_order_by_asc`, `ignore_context`, `is_default`, `code`, `function_url`, `report_category_id`) VALUES
	((SELECT max(id) FROM ".TABLE_PREFIX."objects WHERE object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report')), 'absences by hierarchy group report description', (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='billing'), 1, 1, 1, 'absences_by_hierarchy_report', '?c=time_registration_reports&a=absences_by_hierarchy_group_parameters',(SELECT max(object_id) FROM ".TABLE_PREFIX."report_category));
	");

	DB::execute("
	INSERT INTO `".TABLE_PREFIX."objects` (`object_type_id`, `name`, `created_on`, `created_by_id`, `updated_on`, `updated_by_id`, `trashed_by_id`, `archived_by_id`) VALUES
	((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report'), 'presents by hierarchy group report', NOW(), 0, NOW(), 0, 0, 0);
	");

	DB::execute("
	INSERT INTO `".TABLE_PREFIX."reports` (`object_id`, `description`, `report_object_type_id`, `is_order_by_asc`, `ignore_context`, `is_default`, `code`, `function_url`, `report_category_id`) VALUES
	((SELECT max(id) FROM ".TABLE_PREFIX."objects WHERE object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report')), 'presents by hierarchy group report description', (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='billing'), 1, 1, 1, 'presents_by_hierarchy_report', '?c=time_registration_reports&a=presents_by_hierarchy_group_parameters',(SELECT max(object_id) FROM ".TABLE_PREFIX."report_category));
	");
	
	}