<?php

class WorkflowPermissionsController extends ApplicationController {

	function __construct() {
		parent::__construct();
		prepare_company_website_controller($this, 'website');
	} // __construct
	


	function save_workflow_permissions_from_contact_form() {
		
		$workflow_permissions = array_var($_REQUEST, 'workflow_permissions');
		
		if ($workflow_permissions) {
			$pg_id = array_var($workflow_permissions, 'current_pg_id');
			unset($workflow_permissions['current_pg_id']);
			$permissions = $workflow_permissions;
			
			return $this->save_workflow_permissions($pg_id, $permissions);
		}
		
	}
	
	
	function save_workflow_permissions($pg_id, $permissions) {
		
		foreach ($permissions as $permission_id => $permission_values) {
			if (!is_numeric($permission_id)) continue;
			
			$workflow_permission = WorkflowPermissions::instance()->findById($permission_id);
			
			$wp_permission_value = WorkflowPermissionValues::getValueForPermissionGroup($permission_id, $pg_id);
			if (!$wp_permission_value instanceof WorkflowPermissionValue) {
				$wp_permission_value = new WorkflowPermissionValue();
				$wp_permission_value->setWorkflowPermissionId($permission_id);
				$wp_permission_value->setPermissionGroupId($pg_id);
			}
			$wp_permission_value->setBoolValue($permission_values['bool_value']);
			$wp_permission_value->save();
			
			if ($workflow_permission->getType() == "permission_group_list") {
				
				WorkflowPermissionValuePgs::instance()->delete("workflow_permission_value_id = '".$wp_permission_value->getId()."'");
				
				$sent_permission_values = array();
				foreach ($permission_values['pgs'] as $key => $val) {
					if (is_numeric($key)) {
						// own pg_id
						$sent_permission_values[$key] = $val;
					} else {
						// other user pg ids
						$other_user_pg_ids = array_filter(explode(',', $val));
						foreach ($other_user_pg_ids as $other_user_pg_id) {
							$sent_permission_values[$other_user_pg_id] = 1;
						}
					}
				}
				
				foreach ($sent_permission_values as $affected_pg_id => $enabled) {
					if ($enabled) {
						$wpv_pg = new WorkflowPermissionValuePg();
						$wpv_pg->setWorkflowPermissionValueId($wp_permission_value->getId());
						$wpv_pg->setAffectedPermissionGroupId($affected_pg_id);
						$wpv_pg->save();
					}
				}
			}
		}
		
	}
	
}
